/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var re=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/errors","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/base/common/path","vs/platform/files/common/files","vs/platform/environment/common/environment","vs/base/common/types","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/base/common/arrays","vs/base/common/resources","vs/platform/telemetry/common/telemetry","vs/base/common/cancellation","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/uuid","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagementUtil","os","vs/base/common/json","vs/base/common/process","vs/base/common/map","vs/base/common/errorMessage","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/userDataSync/common/abstractSynchronizer","vs/platform/extensions/common/extensions","vs/base/common/jsonFormatter","vs/base/common/stream","vs/platform/externalServices/common/serviceMachineId","vs/platform/configuration/common/configurationRegistry","vs/base/common/extpath","vs/base/common/ternarySearchTree","child_process","vs/platform/telemetry/common/telemetryUtils","vs/base/common/codicons","fs","vs/base/common/semver/semver","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/ipc/electron-sandbox/services","vs/platform/native/electron-sandbox/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataSync/common/content","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/date","vs/base/common/hash","vs/base/common/marshalling","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/normalization","net","vs/base/common/processes","vs/base/common/severity","vs/base/common/glob","vs/base/node/powershell","vs/base/node/processes","vs/base/parts/ipc/common/ipc.net","electron","vs/platform/environment/common/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/platform/lifecycle/electron-browser/sharedProcessLifecycleService","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/skipList","vs/base/node/macAddress","vs/base/node/ports","vs/base/parts/request/common/request","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/ipc/node/ipc.net","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/electron-browser/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policyIpc","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/electron-browser/sharedProcessRequestService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/remoteTunnel/electron-browser/remoteTunnelService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/tunnel/node/tunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/electron-browser/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/storage/electron-sandbox/storageService","vs/platform/userDataProfile/electron-sandbox/userDataProfile","vs/platform/userDataProfile/electron-sandbox/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/electron-browser/sharedProcess/contrib/extensions","util","minimist","assert","path","graceful-fs","https","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain"],ae=function(_){for(var e=[],D=0,i=_.length;D<i;D++)e[D]=re[_[D]];return e};define(re[51],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.Codicon=e.getCodiconAriaLabel=void 0;function D(A){return A?A.replace(/\$\((.*?)\)/g,(L,P)=>` ${P} `).trim():""}e.getCodiconAriaLabel=D;class i{constructor(L,P,I){this.id=L,this.definition=P,this.description=I,i.a.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return i.a}}e.Codicon=i,i.a=[],i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",i.circleFilled.definition),i.closeDirty=new i("close-dirty",i.circleFilled.definition),i.debugBreakpoint=new i("debug-breakpoint",i.circleFilled.definition),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",i.circleFilled.definition),i.debugHint=new i("debug-hint",i.circleFilled.definition),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circle=new i("circle",{fontCharacter:"\\eabc"}),i.circleOutline=new i("circle-outline",i.circle.definition),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",i.circle.definition),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolCustomColor=new i("symbol-customcolor",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.circleSmallFilled=new i("circle-small-filled",{fontCharacter:"\\eb8a"}),i.debugStackframeDot=new i("debug-stackframe-dot",i.circleSmallFilled.definition),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLarge=new i("circle-large",{fontCharacter:"\\ebb5"}),i.circleLargeOutline=new i("circle-large-outline",i.circleLarge.definition),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.layout=new i("layout",{fontCharacter:"\\ebeb"}),i.layoutActivitybarLeft=new i("layout-activitybar-left",{fontCharacter:"\\ebec"}),i.layoutActivitybarRight=new i("layout-activitybar-right",{fontCharacter:"\\ebed"}),i.layoutPanelLeft=new i("layout-panel-left",{fontCharacter:"\\ebee"}),i.layoutPanelCenter=new i("layout-panel-center",{fontCharacter:"\\ebef"}),i.layoutPanelJustify=new i("layout-panel-justify",{fontCharacter:"\\ebf0"}),i.layoutPanelRight=new i("layout-panel-right",{fontCharacter:"\\ebf1"}),i.layoutPanel=new i("layout-panel",{fontCharacter:"\\ebf2"}),i.layoutSidebarLeft=new i("layout-sidebar-left",{fontCharacter:"\\ebf3"}),i.layoutSidebarRight=new i("layout-sidebar-right",{fontCharacter:"\\ebf4"}),i.layoutStatusbar=new i("layout-statusbar",{fontCharacter:"\\ebf5"}),i.layoutMenubar=new i("layout-menubar",{fontCharacter:"\\ebf6"}),i.layoutCentered=new i("layout-centered",{fontCharacter:"\\ebf7"}),i.layoutSidebarRightOff=new i("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),i.layoutPanelOff=new i("layout-panel-off",{fontCharacter:"\\ec01"}),i.layoutSidebarLeftOff=new i("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),i.target=new i("target",{fontCharacter:"\\ebf8"}),i.indent=new i("indent",{fontCharacter:"\\ebf9"}),i.recordSmall=new i("record-small",{fontCharacter:"\\ebfa"}),i.errorSmall=new i("error-small",{fontCharacter:"\\ebfb"}),i.arrowCircleDown=new i("arrow-circle-down",{fontCharacter:"\\ebfc"}),i.arrowCircleLeft=new i("arrow-circle-left",{fontCharacter:"\\ebfd"}),i.arrowCircleRight=new i("arrow-circle-right",{fontCharacter:"\\ebfe"}),i.arrowCircleUp=new i("arrow-circle-up",{fontCharacter:"\\ebff"}),i.heartFilled=new i("heart-filled",{fontCharacter:"\\ec04"}),i.map=new i("map",{fontCharacter:"\\ec05"}),i.mapFilled=new i("map-filled",{fontCharacter:"\\ec06"}),i.circleSmall=new i("circle-small",{fontCharacter:"\\ec07"}),i.bellSlash=new i("bell-slash",{fontCharacter:"\\ec08"}),i.bellSlashDot=new i("bell-slash-dot",{fontCharacter:"\\ec09"}),i.commentUnresolved=new i("comment-unresolved",{fontCharacter:"\\ec0a"}),i.gitPullRequestGoToChanges=new i("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),i.gitPullRequestNewChanges=new i("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),i.searchFuzzy=new i("search-fuzzy",{fontCharacter:"\\ec0d"}),i.commentDraft=new i("comment-draft",{fontCharacter:"\\ec0e"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);var R;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const L=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function P(C){if(C instanceof i)return["codicon","codicon-"+C.id];const b=L.exec(C.id);if(!b)return P(i.error);const[,w,y]=b,d=["codicon","codicon-"+w];return y&&d.push("codicon-modifier-"+y.substring(1)),d}A.asClassNameArray=P;function I(C){return P(C).join(" ")}A.asClassName=I;function S(C){return"."+P(C).join(".")}A.asCSSSelector=S})(R=e.CSSIcon||(e.CSSIcon={}))}),define(re[63],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function D(L){return(P,I,S)=>{let C=null,b=null;if(typeof S.value=="function"?(C="value",b=S.value):typeof S.get=="function"&&(C="get",b=S.get),!b)throw new Error("not supported");S[C]=L(b,I)}}function i(L,P,I){let S=null,C=null;if(typeof I.value=="function"?(S="value",C=I.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof I.get=="function"&&(S="get",C=I.get),!C)throw new Error("not supported");const b=`$memoize$${P}`;I[S]=function(...w){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,w)}),this[b]}}e.memoize=i;function R(L,P,I){return D((S,C)=>{const b=`$debounce$${C}`,w=`$debounce$result$${C}`;return function(...y){this[w]||(this[w]=I?I():void 0),clearTimeout(this[b]),P&&(this[w]=P(this[w],...y),y=[this[w]]),this[b]=setTimeout(()=>{S.apply(this,y),this[w]=I?I():void 0},L)}})}e.debounce=R;function A(L,P,I){return D((S,C)=>{const b=`$throttle$timer$${C}`,w=`$throttle$result$${C}`,y=`$throttle$lastRun$${C}`,d=`$throttle$pending$${C}`;return function(...g){if(this[w]||(this[w]=I?I():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),P&&(this[w]=P(this[w],...g)),this[d])return;const v=this[y]+L;v<=Date.now()?(this[y]=Date.now(),S.apply(this,[this[w]]),this[w]=I?I():void 0):(this[d]=!0,this[b]=setTimeout(()=>{this[d]=!1,this[y]=Date.now(),S.apply(this,[this[w]]),this[w]=I?I():void 0},v-Date.now()))}})}e.throttle=A}),define(re[9],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class D{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?u.isErrorNoTelemetry(n)?new u(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(s=>{s(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}e.ErrorHandler=D,e.errorHandler=new D;function i(f){e.errorHandler.setUnexpectedErrorHandler(f)}e.setUnexpectedErrorHandler=i;function R(f){I(f)||e.errorHandler.onUnexpectedError(f)}e.onUnexpectedError=R;function A(f){I(f)||e.errorHandler.onUnexpectedExternalError(f)}e.onUnexpectedExternalError=A;function L(f){if(f instanceof Error){const{name:n,message:s}=f,t=f.stacktrace||f.stack;return{$isError:!0,name:n,message:s,stack:t,noTelemetry:u.isErrorNoTelemetry(f)}}return f}e.transformErrorForSerialization=L;const P="Canceled";function I(f){return f instanceof S?!0:f instanceof Error&&f.name===P&&f.message===P}e.isCancellationError=I;class S extends Error{constructor(){super(P),this.name=this.message}}e.CancellationError=S;function C(){const f=new Error(P);return f.name=f.message,f}e.canceled=C;function b(f){return f?new Error(`Illegal argument: ${f}`):new Error("Illegal argument")}e.illegalArgument=b;function w(f){return f?new Error(`Illegal state: ${f}`):new Error("Illegal state")}e.illegalState=w;function y(f){return f?new Error(`readonly property '${f} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=y;function d(f){const n=new Error(`${f} has been disposed`);return n.name="DISPOSED",n}e.disposed=d;function g(f){return f?f.message?f.message:f.stack?f.stack.split(`
`)[0]:String(f):"Error"}e.getErrorMessage=g;class v extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.NotImplementedError=v;class l extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.NotSupportedError=l;class m extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=m;class u extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof u)return n;const s=new u;return s.message=n.message,s.stack=n.stack,s}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.ErrorNoTelemetry=u;class h extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,h.prototype);debugger}}e.BugIndicatingError=h}),define(re[20],ae([0,1,9]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function i(x,ie=0){return x[x.length-(1+ie)]}e.tail=i;function R(x){if(x.length===0)throw new Error("Invalid tail call");return[x.slice(0,x.length-1),x[x.length-1]]}e.tail2=R;function A(x,ie,ne=(le,ue)=>le===ue){if(x===ie)return!0;if(!x||!ie||x.length!==ie.length)return!1;for(let le=0,ue=x.length;le<ue;le++)if(!ne(x[le],ie[le]))return!1;return!0}e.equals=A;function L(x,ie){const ne=x.length-1;ie<ne&&(x[ie]=x[ne]),x.pop()}e.removeFastWithoutKeepingOrder=L;function P(x,ie,ne){return I(x.length,le=>ne(x[le],ie))}e.binarySearch=P;function I(x,ie){let ne=0,le=x-1;for(;ne<=le;){const ue=(ne+le)/2|0,pe=ie(ue);if(pe<0)ne=ue+1;else if(pe>0)le=ue-1;else return ue}return-(ne+1)}e.binarySearch2=I;function S(x,ie){let ne=0,le=x.length;if(le===0)return 0;for(;ne<le;){const ue=Math.floor((ne+le)/2);ie(x[ue])?le=ue:ne=ue+1}return ne}e.findFirstInSorted=S;function C(x,ie,ne){if(x=x|0,x>=ie.length)throw new TypeError("invalid index");const le=ie[Math.floor(ie.length*Math.random())],ue=[],pe=[],Se=[];for(const be of ie){const Ee=ne(be,le);Ee<0?ue.push(be):Ee>0?pe.push(be):Se.push(be)}return x<ue.length?C(x,ue,ne):x<ue.length+Se.length?Se[0]:C(x-(ue.length+Se.length),pe,ne)}e.quickSelect=C;function b(x,ie){const ne=[];let le;for(const ue of x.slice(0).sort(ie))!le||ie(le[0],ue)!==0?(le=[ue],ne.push(le)):le.push(ue);return ne}e.groupBy=b;function w(x,ie,ne){const le=[];function ue(be,Ee,Ne){if(Ee===0&&Ne.length===0)return;const Fe=le[le.length-1];Fe&&Fe.start+Fe.deleteCount===be?(Fe.deleteCount+=Ee,Fe.toInsert.push(...Ne)):le.push({start:be,deleteCount:Ee,toInsert:Ne})}let pe=0,Se=0;for(;;){if(pe===x.length){ue(pe,0,ie.slice(Se));break}if(Se===ie.length){ue(pe,x.length-pe,[]);break}const be=x[pe],Ee=ie[Se],Ne=ne(be,Ee);Ne===0?(pe+=1,Se+=1):Ne<0?(ue(pe,1,[]),pe+=1):Ne>0&&(ue(pe,0,[Ee]),Se+=1)}return le}e.sortedDiff=w;function y(x,ie,ne){const le=w(x,ie,ne),ue=[],pe=[];for(const Se of le)ue.push(...x.slice(Se.start,Se.start+Se.deleteCount)),pe.push(...Se.toInsert);return{removed:ue,added:pe}}e.delta=y;function d(x,ie,ne){if(ne===0)return[];const le=x.slice(0,ne).sort(ie);return v(x,ie,le,ne,x.length),le}e.top=d;function g(x,ie,ne,le,ue){return ne===0?Promise.resolve([]):new Promise((pe,Se)=>{(async()=>{const be=x.length,Ee=x.slice(0,ne).sort(ie);for(let Ne=ne,Fe=Math.min(ne+le,be);Ne<be;Ne=Fe,Fe=Math.min(Fe+le,be)){if(Ne>ne&&await new Promise(Ye=>setTimeout(Ye)),ue&&ue.isCancellationRequested)throw new D.CancellationError;v(x,ie,Ee,Ne,Fe)}return Ee})().then(pe,Se)})}e.topAsync=g;function v(x,ie,ne,le,ue){for(const pe=ne.length;le<ue;le++){const Se=x[le];if(ie(Se,ne[pe-1])<0){ne.pop();const be=S(ne,Ee=>ie(Se,Ee)<0);ne.splice(be,0,Se)}}}function l(x){return x.filter(ie=>!!ie)}e.coalesce=l;function m(x){let ie=0;for(let ne=0;ne<x.length;ne++)x[ne]&&(x[ie]=x[ne],ie+=1);x.length=ie}e.coalesceInPlace=m;function u(x,ie,ne){x.splice(ne,0,x.splice(ie,1)[0])}e.move=u;function h(x){return!Array.isArray(x)||x.length===0}e.isFalsyOrEmpty=h;function f(x){return Array.isArray(x)&&x.length>0}e.isNonEmptyArray=f;function n(x,ie=ne=>ne){const ne=new Set;return x.filter(le=>{const ue=ie(le);return ne.has(ue)?!1:(ne.add(ue),!0)})}e.distinct=n;function s(x){const ie=new Set;return ne=>{const le=x(ne);return ie.has(le)?!1:(ie.add(le),!0)}}e.uniqueFilter=s;function t(x,ie){const ne=a(x,ie);if(ne!==-1)return x[ne]}e.findLast=t;function a(x,ie){for(let ne=x.length-1;ne>=0;ne--){const le=x[ne];if(ie(le))return ne}return-1}e.lastIndex=a;function r(x,ie){return x.length>0?x[0]:ie}e.firstOrDefault=r;function c(x,ie){return x.length>0?x[x.length-1]:ie}e.lastOrDefault=c;function o(x,ie,ne=(le,ue)=>le===ue){let le=0;for(let ue=0,pe=Math.min(x.length,ie.length);ue<pe&&ne(x[ue],ie[ue]);ue++)le++;return le}e.commonPrefixLength=o;function p(x){return[].concat(...x)}e.flatten=p;function E(x,ie){let ne=typeof ie=="number"?x:0;typeof ie=="number"?ne=x:(ne=0,ie=x);const le=[];if(ne<=ie)for(let ue=ne;ue<ie;ue++)le.push(ue);else for(let ue=ne;ue>ie;ue--)le.push(ue);return le}e.range=E;function k(x,ie,ne){return x.reduce((le,ue)=>(le[ie(ue)]=ne?ne(ue):ue,le),Object.create(null))}e.index=k;function F(x,ie){return x.push(ie),()=>N(x,ie)}e.insert=F;function N(x,ie){const ne=x.indexOf(ie);if(ne>-1)return x.splice(ne,1),ie}e.remove=N;function q(x,ie,ne){const le=x.slice(0,ie),ue=x.slice(ie);return le.concat(ne,ue)}e.arrayInsert=q;function j(x,ie){let ne;if(typeof ie=="number"){let le=ie;ne=()=>{const ue=Math.sin(le++)*179426549;return ue-Math.floor(ue)}}else ne=Math.random;for(let le=x.length-1;le>0;le-=1){const ue=Math.floor(ne()*(le+1)),pe=x[le];x[le]=x[ue],x[ue]=pe}}e.shuffle=j;function O(x,ie){const ne=x.indexOf(ie);ne>-1&&(x.splice(ne,1),x.unshift(ie))}e.pushToStart=O;function U(x,ie){const ne=x.indexOf(ie);ne>-1&&(x.splice(ne,1),x.push(ie))}e.pushToEnd=U;function $(x,ie){for(const ne of ie)x.push(ne)}e.pushMany=$;function G(x,ie){return Array.isArray(x)?x.map(ie):ie(x)}e.mapArrayOrNot=G;function H(x){return Array.isArray(x)?x:[x]}e.asArray=H;function Z(x){return x[Math.floor(Math.random()*x.length)]}e.getRandomElement=Z;function z(x,ie){for(const ne of x){const le=ie(ne);if(le!==void 0)return le}}e.mapFind=z;function B(x,ie,ne){const le=ee(x,ie),ue=x.length,pe=ne.length;x.length=ue+pe;for(let Se=ue-1;Se>=le;Se--)x[Se+pe]=x[Se];for(let Se=0;Se<pe;Se++)x[Se+le]=ne[Se]}e.insertInto=B;function Y(x,ie,ne,le){const ue=ee(x,ie),pe=x.splice(ue,ne);return B(x,ue,le),pe}e.splice=Y;function ee(x,ie){return ie<0?Math.max(ie+x.length,0):Math.min(ie,x.length)}var oe;(function(x){function ie(ue){return ue<0}x.isLessThan=ie;function ne(ue){return ue>0}x.isGreaterThan=ne;function le(ue){return ue===0}x.isNeitherLessOrGreaterThan=le,x.greaterThan=1,x.lessThan=-1,x.neitherLessOrGreaterThan=0})(oe=e.CompareResult||(e.CompareResult={}));function J(x,ie){return(ne,le)=>ie(x(ne),x(le))}e.compareBy=J;function Q(...x){return(ie,ne)=>{for(const le of x){const ue=le(ie,ne);if(!oe.isNeitherLessOrGreaterThan(ue))return ue}return oe.neitherLessOrGreaterThan}}e.tieBreakComparators=Q;const T=(x,ie)=>x-ie;e.numberComparator=T;function M(x,ie){if(x.length===0)return;let ne=x[0];for(let le=1;le<x.length;le++){const ue=x[le];ie(ue,ne)>0&&(ne=ue)}return ne}e.findMaxBy=M;function V(x,ie){if(x.length===0)return;let ne=x[0];for(let le=1;le<x.length;le++){const ue=x[le];ie(ue,ne)>=0&&(ne=ue)}return ne}e.findLastMaxBy=V;function W(x,ie){return M(x,(ne,le)=>-ie(ne,le))}e.findMinBy=W;class X{constructor(ie){this.f=ie,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(ie){let ne=this.c;for(;ne<this.f.length&&ie(this.f[ne]);)ne++;const le=ne===this.c?null:this.f.slice(this.c,ne);return this.c=ne,le}takeFromEndWhile(ie){let ne=this.d;for(;ne>=0&&ie(this.f[ne]);)ne--;const le=ne===this.d?null:this.f.slice(ne+1,this.d+1);return this.d=ne,le}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const ie=this.f[this.c];return this.c++,ie}removeLast(){const ie=this.f[this.d];return this.d--,ie}takeCount(ie){const ne=this.f.slice(this.c,this.c+ie);return this.c+=ie,ne}}e.ArrayQueue=X;class se{constructor(ie){this.iterate=ie}forEach(ie){this.iterate(ne=>(ie(ne),!0))}toArray(){const ie=[];return this.iterate(ne=>(ie.push(ne),!0)),ie}filter(ie){return new se(ne=>this.iterate(le=>ie(le)?ne(le):!0))}map(ie){return new se(ne=>this.iterate(le=>ne(ie(le))))}some(ie){let ne=!1;return this.iterate(le=>(ne=ie(le),!ne)),ne}findFirst(ie){let ne;return this.iterate(le=>ie(le)?(ne=le,!1):!0),ne}findLast(ie){let ne;return this.iterate(le=>(ie(le)&&(ne=le),!0)),ne}findLastMaxBy(ie){let ne,le=!0;return this.iterate(ue=>((le||oe.isGreaterThan(ie(ue,ne)))&&(le=!1,ne=ue),!0)),ne}}e.CallbackIterable=se,se.empty=new se(x=>{})}),define(re[126],ae([0,1,9]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function i(I,S){if(!I)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}e.ok=i;function R(I,S="Unreachable"){throw new Error(S)}e.assertNever=R;function A(I){if(!I)throw new D.BugIndicatingError("Assertion Failed")}e.assert=A;function L(I){if(!I()){debugger;I(),(0,D.onUnexpectedError)(new D.BugIndicatingError("Assertion Failed"))}}e.assertFn=L;function P(I,S){let C=0;for(;C<I.length-1;){const b=I[C],w=I[C+1];if(!S(b,w))return!1;C++}return!0}e.checkAdjacentItems=P}),define(re[82],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function D(i){const R=this;let A=!1,L;return function(){return A||(A=!0,L=i.apply(R,arguments)),L}}e.once=D}),define(re[64],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(i){function R(h){return h&&typeof h=="object"&&typeof h[Symbol.iterator]=="function"}i.is=R;const A=Object.freeze([]);function L(){return A}i.empty=L;function*P(h){yield h}i.single=P;function I(h){return R(h)?h:P(h)}i.wrap=I;function S(h){return h||A}i.from=S;function C(h){return!h||h[Symbol.iterator]().next().done===!0}i.isEmpty=C;function b(h){return h[Symbol.iterator]().next().value}i.first=b;function w(h,f){for(const n of h)if(f(n))return!0;return!1}i.some=w;function y(h,f){for(const n of h)if(f(n))return n}i.find=y;function*d(h,f){for(const n of h)f(n)&&(yield n)}i.filter=d;function*g(h,f){let n=0;for(const s of h)yield f(s,n++)}i.map=g;function*v(...h){for(const f of h)for(const n of f)yield n}i.concat=v;function l(h,f,n){let s=n;for(const t of h)s=f(s,t);return s}i.reduce=l;function*m(h,f,n=h.length){for(f<0&&(f+=h.length),n<0?n+=h.length:n>h.length&&(n=h.length);f<n;f++)yield h[f]}i.slice=m;function u(h,f=Number.POSITIVE_INFINITY){const n=[];if(f===0)return[n,h];const s=h[Symbol.iterator]();for(let t=0;t<f;t++){const a=s.next();if(a.done)return[n,i.empty()];n.push(a.value)}return[n,{[Symbol.iterator](){return s}}]}i.consume=u})(D=e.Iterable||(e.Iterable={}))}),define(re[35],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(D=e.ScanError||(e.ScanError={}));var i;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(i=e.SyntaxKind||(e.SyntaxKind={}));var R;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(R=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(n){n.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function L(n,s=!1){let t=0;const a=n.length;let r="",c=0,o=16,p=0;function E(U){let $=0,G=0;for(;$<U;){const H=n.charCodeAt(t);if(H>=48&&H<=57)G=G*16+H-48;else if(H>=65&&H<=70)G=G*16+H-65+10;else if(H>=97&&H<=102)G=G*16+H-97+10;else break;t++,$++}return $<U&&(G=-1),G}function k(U){t=U,r="",c=0,o=16,p=0}function F(){const U=t;if(n.charCodeAt(t)===48)t++;else for(t++;t<n.length&&S(n.charCodeAt(t));)t++;if(t<n.length&&n.charCodeAt(t)===46)if(t++,t<n.length&&S(n.charCodeAt(t)))for(t++;t<n.length&&S(n.charCodeAt(t));)t++;else return p=3,n.substring(U,t);let $=t;if(t<n.length&&(n.charCodeAt(t)===69||n.charCodeAt(t)===101))if(t++,(t<n.length&&n.charCodeAt(t)===43||n.charCodeAt(t)===45)&&t++,t<n.length&&S(n.charCodeAt(t))){for(t++;t<n.length&&S(n.charCodeAt(t));)t++;$=t}else p=3;return n.substring(U,$)}function N(){let U="",$=t;for(;;){if(t>=a){U+=n.substring($,t),p=2;break}const G=n.charCodeAt(t);if(G===34){U+=n.substring($,t),t++;break}if(G===92){if(U+=n.substring($,t),t++,t>=a){p=2;break}switch(n.charCodeAt(t++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const Z=E(4);Z>=0?U+=String.fromCharCode(Z):p=4;break}default:p=5}$=t;continue}if(G>=0&&G<=31)if(I(G)){U+=n.substring($,t),p=2;break}else p=6;t++}return U}function q(){if(r="",p=0,c=t,t>=a)return c=a,o=17;let U=n.charCodeAt(t);if(P(U)){do t++,r+=String.fromCharCode(U),U=n.charCodeAt(t);while(P(U));return o=15}if(I(U))return t++,r+=String.fromCharCode(U),U===13&&n.charCodeAt(t)===10&&(t++,r+=`
`),o=14;switch(U){case 123:return t++,o=1;case 125:return t++,o=2;case 91:return t++,o=3;case 93:return t++,o=4;case 58:return t++,o=6;case 44:return t++,o=5;case 34:return t++,r=N(),o=10;case 47:{const $=t-1;if(n.charCodeAt(t+1)===47){for(t+=2;t<a&&!I(n.charCodeAt(t));)t++;return r=n.substring($,t),o=12}if(n.charCodeAt(t+1)===42){t+=2;const G=a-1;let H=!1;for(;t<G;){if(n.charCodeAt(t)===42&&n.charCodeAt(t+1)===47){t+=2,H=!0;break}t++}return H||(t++,p=1),r=n.substring($,t),o=13}return r+=String.fromCharCode(U),t++,o=16}case 45:if(r+=String.fromCharCode(U),t++,t===a||!S(n.charCodeAt(t)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=F(),o=11;default:for(;t<a&&j(U);)t++,U=n.charCodeAt(t);if(c!==t){switch(r=n.substring(c,t),r){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return r+=String.fromCharCode(U),t++,o=16}}function j(U){if(P(U)||I(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function O(){let U;do U=q();while(U>=12&&U<=15);return U}return{setPosition:k,getPosition:()=>t,scan:s?O:q,getToken:()=>o,getTokenValue:()=>r,getTokenOffset:()=>c,getTokenLength:()=>t-c,getTokenError:()=>p}}e.createScanner=L;function P(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function I(n){return n===10||n===13||n===8232||n===8233}function S(n){return n>=48&&n<=57}var C;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(C||(C={}));function b(n,s){const t=[],a=new Object;let r;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function p(E,k,F,N){c.value=E,c.offset=k,c.length=F,c.type=N,c.colonOffset=void 0,r=c}try{u(n,{onObjectBegin:(E,k)=>{if(s<=E)throw a;r=void 0,o=s>E,t.push("")},onObjectProperty:(E,k,F)=>{if(s<k||(p(E,k,F,"property"),t[t.length-1]=E,s<=k+F))throw a},onObjectEnd:(E,k)=>{if(s<=E)throw a;r=void 0,t.pop()},onArrayBegin:(E,k)=>{if(s<=E)throw a;r=void 0,t.push(0)},onArrayEnd:(E,k)=>{if(s<=E)throw a;r=void 0,t.pop()},onLiteralValue:(E,k,F)=>{if(s<k||(p(E,k,F,f(E)),s<=k+F))throw a},onSeparator:(E,k,F)=>{if(s<=k)throw a;if(E===":"&&r&&r.type==="property")r.colonOffset=k,o=!1,r=void 0;else if(E===","){const N=t[t.length-1];typeof N=="number"?t[t.length-1]=N+1:(o=!0,t[t.length-1]=""),r=void 0}}})}catch(E){if(E!==a)throw E}return{path:t,previousNode:r,isAtPropertyKey:o,matches:E=>{let k=0;for(let F=0;k<E.length&&F<t.length;F++)if(E[k]===t[F]||E[k]==="*")k++;else if(E[k]!=="**")return!1;return k===E.length}}}e.getLocation=b;function w(n,s=[],t=A.DEFAULT){let a=null,r=[];const c=[];function o(E){Array.isArray(r)?r.push(E):a!==null&&(r[a]=E)}return u(n,{onObjectBegin:()=>{const E={};o(E),c.push(r),r=E,a=null},onObjectProperty:E=>{a=E},onObjectEnd:()=>{r=c.pop()},onArrayBegin:()=>{const E=[];o(E),c.push(r),r=E,a=null},onArrayEnd:()=>{r=c.pop()},onLiteralValue:o,onError:(E,k,F)=>{s.push({error:E,offset:k,length:F})}},t),r[0]}e.parse=w;function y(n,s=[],t=A.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(E){a.type==="property"&&(a.length=E-a.offset,a=a.parent)}function c(E){return a.children.push(E),E}u(n,{onObjectBegin:E=>{a=c({type:"object",offset:E,length:-1,parent:a,children:[]})},onObjectProperty:(E,k,F)=>{a=c({type:"property",offset:k,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:E,offset:k,length:F,parent:a})},onObjectEnd:(E,k)=>{a.length=E+k-a.offset,a=a.parent,r(E+k)},onArrayBegin:(E,k)=>{a=c({type:"array",offset:E,length:-1,parent:a,children:[]})},onArrayEnd:(E,k)=>{a.length=E+k-a.offset,a=a.parent,r(E+k)},onLiteralValue:(E,k,F)=>{c({type:f(E),offset:k,length:F,parent:a,value:E}),r(k+F)},onSeparator:(E,k,F)=>{a.type==="property"&&(E===":"?a.colonOffset=k:E===","&&r(k))},onError:(E,k,F)=>{s.push({error:E,offset:k,length:F})}},t);const p=a.children[0];return p&&delete p.parent,p}e.parseTree=y;function d(n,s){if(!n)return;let t=n;for(const a of s)if(typeof a=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let r=!1;for(const c of t.children)if(Array.isArray(c.children)&&c.children[0].value===a){t=c.children[1],r=!0;break}if(!r)return}else{const r=a;if(t.type!=="array"||r<0||!Array.isArray(t.children)||r>=t.children.length)return;t=t.children[r]}return t}e.findNodeAtLocation=d;function g(n){if(!n.parent||!n.parent.children)return[];const s=g(n.parent);if(n.parent.type==="property"){const t=n.parent.children[0].value;s.push(t)}else if(n.parent.type==="array"){const t=n.parent.children.indexOf(n);t!==-1&&s.push(t)}return s}e.getNodePath=g;function v(n){switch(n.type){case"array":return n.children.map(v);case"object":{const s=Object.create(null);for(const t of n.children){const a=t.children[1];a&&(s[t.children[0].value]=v(a))}return s}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=v;function l(n,s,t=!1){return s>=n.offset&&s<n.offset+n.length||t&&s===n.offset+n.length}e.contains=l;function m(n,s,t=!1){if(l(n,s,t)){const a=n.children;if(Array.isArray(a))for(let r=0;r<a.length&&a[r].offset<=s;r++){const c=m(a[r],s,t);if(c)return c}return n}}e.findNodeAtOffset=m;function u(n,s,t=A.DEFAULT){const a=L(n,!1);function r(J){return J?()=>J(a.getTokenOffset(),a.getTokenLength()):()=>!0}function c(J){return J?Q=>J(Q,a.getTokenOffset(),a.getTokenLength()):()=>!0}const o=r(s.onObjectBegin),p=c(s.onObjectProperty),E=r(s.onObjectEnd),k=r(s.onArrayBegin),F=r(s.onArrayEnd),N=c(s.onLiteralValue),q=c(s.onSeparator),j=r(s.onComment),O=c(s.onError),U=t&&t.disallowComments,$=t&&t.allowTrailingComma;function G(){for(;;){const J=a.scan();switch(a.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:U||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(J){case 12:case 13:U?H(10):j();break;case 16:H(1);break;case 15:case 14:break;default:return J}}}function H(J,Q=[],T=[]){if(O(J),Q.length+T.length>0){let M=a.getToken();for(;M!==17;){if(Q.indexOf(M)!==-1){G();break}else if(T.indexOf(M)!==-1)break;M=G()}}}function Z(J){const Q=a.getTokenValue();return J?N(Q):p(Q),G(),!0}function z(){switch(a.getToken()){case 11:{let J=0;try{J=JSON.parse(a.getTokenValue()),typeof J!="number"&&(H(2),J=0)}catch{H(2)}N(J);break}case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return G(),!0}function B(){return a.getToken()!==10?(H(3,[],[2,5]),!1):(Z(!1),a.getToken()===6?(q(":"),G(),oe()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function Y(){o(),G();let J=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(J||H(4,[],[]),q(","),G(),a.getToken()===2&&$)break}else J&&H(6,[],[]);B()||H(4,[],[2,5]),J=!0}return E(),a.getToken()!==2?H(7,[2],[]):G(),!0}function ee(){k(),G();let J=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(J||H(4,[],[]),q(","),G(),a.getToken()===4&&$)break}else J&&H(6,[],[]);oe()||H(4,[],[4,5]),J=!0}return F(),a.getToken()!==4?H(8,[4],[]):G(),!0}function oe(){switch(a.getToken()){case 3:return ee();case 1:return Y();case 10:return Z(!0);default:return z()}}return G(),a.getToken()===17?t.allowEmptyContent?!0:(H(4,[],[]),!1):oe()?(a.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.visit=u;function h(n,s){const t=L(n),a=[];let r,c=0,o;do switch(o=t.getPosition(),r=t.scan(),r){case 12:case 13:case 17:c!==o&&a.push(n.substring(c,o)),s!==void 0&&a.push(t.getTokenValue().replace(/[^\r\n]/g,s)),c=t.getPosition();break}while(r!==17);return a.join("")}e.stripComments=h;function f(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=f}),define(re[43],ae([0,1,35]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function i(S,C,b){let w,y,d,g,v;if(C){for(g=C.offset,v=g+C.length,d=g;d>0&&!I(S,d-1);)d--;let o=v;for(;o<S.length&&!I(S,o);)o++;y=S.substring(d,o),w=L(y,b)}else y=S,w=0,d=0,g=0,v=S.length;const l=P(b,S);let m=!1,u=0,h;b.insertSpaces?h=A(" ",b.tabSize||4):h="	";const f=(0,D.createScanner)(y,!1);let n=!1;function s(){return l+A(h,w+u)}function t(){let o=f.scan();for(m=!1;o===15||o===14;)m=m||o===14,o=f.scan();return n=o===16||f.getTokenError()!==0,o}const a=[];function r(o,p,E){!n&&p<v&&E>g&&S.substring(p,E)!==o&&a.push({offset:p,length:E-p,content:o})}let c=t();if(c!==17){const o=f.getTokenOffset()+d,p=A(h,w);r(p,d,o)}for(;c!==17;){let o=f.getTokenOffset()+f.getTokenLength()+d,p=t(),E="";for(;!m&&(p===12||p===13);){const F=f.getTokenOffset()+d;r(" ",o,F),o=f.getTokenOffset()+f.getTokenLength()+d,E=p===12?s():"",p=t()}if(p===2)c!==1&&(u--,E=s());else if(p===4)c!==3&&(u--,E=s());else{switch(c){case 3:case 1:u++,E=s();break;case 5:case 12:E=s();break;case 13:m?E=s():E=" ";break;case 6:E=" ";break;case 10:if(p===6){E="";break}case 7:case 8:case 9:case 11:case 2:case 4:p===12||p===13?E=" ":p!==5&&p!==17&&(n=!0);break;case 16:n=!0;break}m&&(p===12||p===13)&&(E=s())}const k=f.getTokenOffset()+d;r(E,o,k),c=p}return a}e.format=i;function R(S,C){const b=JSON.stringify(S,void 0,C.insertSpaces?C.tabSize||4:"	");return C.eol!==void 0?b.replace(/\r\n|\r|\n/g,C.eol):b}e.toFormattedString=R;function A(S,C){let b="";for(let w=0;w<C;w++)b+=S;return b}function L(S,C){let b=0,w=0;const y=C.tabSize||4;for(;b<S.length;){const d=S.charAt(b);if(d===" ")w++;else if(d==="	")w+=y;else break;b++}return Math.floor(w/y)}function P(S,C){for(let b=0;b<C.length;b++){const w=C.charAt(b);if(w==="\r")return b+1<C.length&&C.charAt(b+1)===`
`?`\r
`:"\r";if(w===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=P;function I(S,C){return`\r
`.indexOf(S.charAt(C))!==-1}e.isEOL=I}),define(re[83],ae([0,1,35,43]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function R(S,C,b){return A(S,C,void 0,b)}e.removeProperty=R;function A(S,C,b,w,y){const d=C.slice(),g=[],v=(0,D.parseTree)(S,g);let l,m;for(;d.length>0&&(m=d.pop(),l=(0,D.findNodeAtLocation)(v,d),l===void 0&&b!==void 0);)typeof m=="string"?b={[m]:b}:b=[b];if(l)if(l.type==="object"&&typeof m=="string"&&Array.isArray(l.children)){const u=(0,D.findNodeAtLocation)(l,[m]);if(u!==void 0)if(b===void 0){if(!u.parent)throw new Error("Malformed AST");const h=l.children.indexOf(u.parent);let f,n=u.parent.offset+u.parent.length;if(h>0){const s=l.children[h-1];f=s.offset+s.length}else f=l.offset+1,l.children.length>1&&(n=l.children[1].offset);return L(S,{offset:f,length:n-f,content:""},w)}else return L(S,{offset:u.offset,length:u.length,content:JSON.stringify(b)},w);else{if(b===void 0)return[];const h=`${JSON.stringify(m)}: ${JSON.stringify(b)}`,f=y?y(l.children.map(s=>s.children[0].value)):l.children.length;let n;if(f>0){const s=l.children[f-1];n={offset:s.offset+s.length,length:0,content:","+h}}else l.children.length===0?n={offset:l.offset+1,length:0,content:h}:n={offset:l.offset+1,length:0,content:h+","};return L(S,n,w)}}else if(l.type==="array"&&typeof m=="number"&&Array.isArray(l.children))if(b!==void 0){const u=`${JSON.stringify(b)}`;let h;if(l.children.length===0||m===0)h={offset:l.offset+1,length:0,content:l.children.length===0?u:u+","};else{const f=m===-1||m>l.children.length?l.children.length:m,n=l.children[f-1];h={offset:n.offset+n.length,length:0,content:","+u}}return L(S,h,w)}else{const u=m,h=l.children[u];let f;if(l.children.length===1)f={offset:l.offset+1,length:l.length-2,content:""};else if(l.children.length-1===u){const n=l.children[u-1],s=n.offset+n.length,t=l.offset+l.length;f={offset:s,length:t-2-s,content:""}}else f={offset:h.offset,length:l.children[u+1].offset-h.offset,content:""};return L(S,f,w)}else throw new Error(`Can not add ${typeof m!="number"?"index":"property"} to parent of type ${l.type}`);else{if(b===void 0)throw new Error("Can not delete in empty document");return L(S,{offset:v?v.offset:0,length:v?v.length:0,content:JSON.stringify(b)},w)}}e.setProperty=A;function L(S,C,b){let w=P(S,C),y=C.offset,d=C.offset+C.content.length;if(C.length===0||C.content.length===0){for(;y>0&&!(0,i.isEOL)(w,y-1);)y--;for(;d<w.length&&!(0,i.isEOL)(w,d);)d++}const g=(0,i.format)(w,{offset:y,length:d-y},b);for(let l=g.length-1;l>=0;l--){const m=g[l];w=P(w,m),y=Math.min(y,m.offset),d=Math.max(d,m.offset+m.length),d+=m.content.length-m.length}const v=S.length-(w.length-d)-y;return[{offset:y,length:v,content:w.substring(y,d)}]}e.withFormatting=L;function P(S,C){return S.substring(0,C.offset)+C.content+S.substring(C.offset+C.length)}e.applyEdit=P;function I(S,C){const b=C.slice(0).sort((y,d)=>{const g=y.offset-d.offset;return g===0?y.length-d.length:g});let w=S.length;for(let y=b.length-1;y>=0;y--){const d=b[y];if(d.offset+d.length<=w)S=P(S,d);else throw new Error("Overlapping edit");w=d.offset}return S}e.applyEdits=I}),define(re[127],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class D{constructor(R){this.d=R,this.a=!1}hasValue(){return this.a}getValue(){if(!this.a)try{this.b=this.d()}catch(R){this.c=R}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}map(R){return new D(()=>R(this.getValue()))}}e.Lazy=D}),define(re[2],ae([0,1,82,64]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const R=!1;let A=null;function L(c){A=c}if(e.setDisposableTracker=L,R){const c="__is_disposable_tracked__";L(new class{trackDisposable(o){const p=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[c]||console.log(p)},3e3)}setParent(o,p){if(o&&o!==m.None)try{o[c]=!0}catch{}}markAsDisposed(o){if(o&&o!==m.None)try{o[c]=!0}catch{}}markAsSingleton(o){}})}function P(c){return A?.trackDisposable(c),c}function I(c){A?.markAsDisposed(c)}function S(c,o){A?.setParent(c,o)}function C(c,o){if(!!A)for(const p of c)A.setParent(p,o)}function b(c){return A?.markAsSingleton(c),c}e.markAsSingleton=b;function w(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=w;function y(c){if(i.Iterable.is(c)){const o=[];for(const p of c)if(p)try{p.dispose()}catch(E){o.push(E)}if(o.length===1)throw o[0];if(o.length>1)throw new AggregateError(o,"Encountered errors while disposing of store");return Array.isArray(c)?[]:c}else if(c)return c.dispose(),c}e.dispose=y;function d(c){for(const o of c)w(o)&&o.dispose();return[]}e.disposeIfDisposable=d;function g(...c){const o=v(()=>y(c));return C(c,o),o}e.combinedDisposable=g;function v(c){const o=P({dispose:(0,D.once)(()=>{I(o),c()})});return o}e.toDisposable=v;class l{constructor(){this.c=new Set,this.f=!1,P(this)}dispose(){this.f||(I(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{y(this.c)}finally{this.c.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return S(o,this),this.f?l.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(o),o}}e.DisposableStore=l,l.DISABLE_DISPOSED_WARNING=!1;class m{constructor(){this.q=new l,P(this),S(this.q,this)}dispose(){I(this),this.q.dispose()}B(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(o)}}e.Disposable=m,m.None=Object.freeze({dispose(){}});class u{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(o){this.b||o===this.a||(this.a?.dispose(),o&&S(o,this),this.a=o)}clear(){this.value=void 0}dispose(){this.b=!0,I(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const o=this.a;return this.a=void 0,o&&S(o,null),o}}e.MutableDisposable=u;class h{constructor(o){this.b=o,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=h;class f{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(o){let p=o;return this.unset=()=>p=void 0,this.isset=()=>p!==void 0,this.dispose=()=>{p&&(p(),p=void 0,I(this))},this}}e.SafeDisposable=f;class n{constructor(){this.a=new Map}acquire(o,...p){let E=this.a.get(o);E||(E={counter:0,object:this.b(o,...p)},this.a.set(o,E));const{object:k}=E,F=(0,D.once)(()=>{--E.counter===0&&(this.c(o,E.object),this.a.delete(o))});return E.counter++,{object:k,dispose:F}}}e.ReferenceCollection=n;class s{constructor(o){this.a=o}async acquire(o,...p){const E=this.a.acquire(o,...p);try{return{object:await E.object,dispose:()=>E.dispose()}}catch(k){throw E.dispose(),k}}}e.AsyncReferenceCollection=s;class t{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=t;function a(c){const o=new l;try{c(o)}finally{o.dispose()}}e.disposeOnReturn=a;class r{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){I(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{y(this.a.values())}finally{this.a.clear()}}has(o){return this.a.has(o)}get(o){return this.a.get(o)}set(o,p,E=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),E||this.a.get(o)?.dispose(),this.a.set(o,p)}deleteAndDispose(o){this.a.get(o)?.dispose(),this.a.delete(o)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=r}),define(re[84],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class D{constructor(A){this.element=A,this.next=D.Undefined,this.prev=D.Undefined}}D.Undefined=new D(void 0);class i{constructor(){this.a=D.Undefined,this.b=D.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===D.Undefined}clear(){let A=this.a;for(;A!==D.Undefined;){const L=A.next;A.prev=D.Undefined,A.next=D.Undefined,A=L}this.a=D.Undefined,this.b=D.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,L){const P=new D(A);if(this.a===D.Undefined)this.a=P,this.b=P;else if(L){const S=this.b;this.b=P,P.prev=S,S.next=P}else{const S=this.a;this.a=P,P.next=S,S.prev=P}this.c+=1;let I=!1;return()=>{I||(I=!0,this.e(P))}}shift(){if(this.a!==D.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==D.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==D.Undefined&&A.next!==D.Undefined){const L=A.prev;L.next=A.next,A.next.prev=L}else A.prev===D.Undefined&&A.next===D.Undefined?(this.a=D.Undefined,this.b=D.Undefined):A.next===D.Undefined?(this.b=this.b.prev,this.b.next=D.Undefined):A.prev===D.Undefined&&(this.a=this.a.next,this.a.prev=D.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==D.Undefined;)yield A.element,A=A.next}}e.LinkedList=i}),define(re[37],ae([0,1]),function(_,e){"use strict";var D,i,R;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function A(d,g,v){let l=d.get(g);return l===void 0&&(l=v,d.set(g,l)),l}e.getOrSet=A;function L(d){const g=[];return d.forEach((v,l)=>{g.push(`${l} => ${v}`)}),`Map(${d.size}) {${g.join(", ")}}`}e.mapToString=L;function P(d){const g=[];return d.forEach(v=>{g.push(v)}),`Set(${d.size}) {${g.join(", ")}}`}e.setToString=P;class I{constructor(g,v){this.uri=g,this.value=v}}class S{constructor(g,v){this[D]="ResourceMap",g instanceof S?(this.b=new Map(g.b),this.c=v??S.a):(this.b=new Map,this.c=g??S.a)}set(g,v){return this.b.set(this.c(g),new I(g,v)),this}get(g){return this.b.get(this.c(g))?.value}has(g){return this.b.has(this.c(g))}get size(){return this.b.size}clear(){this.b.clear()}delete(g){return this.b.delete(this.c(g))}forEach(g,v){typeof v<"u"&&(g=g.bind(v));for(const[l,m]of this.b)g(m.value,m.uri,this)}*values(){for(const g of this.b.values())yield g.value}*keys(){for(const g of this.b.values())yield g.uri}*entries(){for(const g of this.b.values())yield[g.uri,g.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,g]of this.b)yield[g.uri,g.value]}}e.ResourceMap=S,S.a=d=>d.toString();class C{constructor(g,v){this[i]="ResourceSet",!g||typeof g=="function"?this.a=new S(g):(this.a=new S(v),g.forEach(this.add,this))}get size(){return this.a.size}add(g){return this.a.set(g,g),this}clear(){this.a.clear()}delete(g){return this.a.delete(g)}forEach(g,v){this.a.forEach((l,m)=>g.call(v,m,m,this))}has(g){return this.a.has(g)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=C;var b;(function(d){d[d.None=0]="None",d[d.AsOld=1]="AsOld",d[d.AsNew=2]="AsNew"})(b=e.Touch||(e.Touch={}));class w{constructor(){this[R]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(g){return this.a.has(g)}get(g,v=0){const l=this.a.get(g);if(!!l)return v!==0&&this.j(l,v),l.value}set(g,v,l=0){let m=this.a.get(g);if(m)m.value=v,l!==0&&this.j(m,l);else{switch(m={key:g,value:v,next:void 0,previous:void 0},l){case 0:this.h(m);break;case 1:this.g(m);break;case 2:this.h(m);break;default:this.h(m);break}this.a.set(g,m),this.d++}return this}delete(g){return!!this.remove(g)}remove(g){const v=this.a.get(g);if(!!v)return this.a.delete(g),this.i(v),this.d--,v.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const g=this.b;return this.a.delete(g.key),this.i(g),this.d--,g.value}forEach(g,v){const l=this.e;let m=this.b;for(;m;){if(v?g.bind(v)(m.value,m.key,this):g(m.value,m.key,this),this.e!==l)throw new Error("LinkedMap got modified during iteration.");m=m.next}}keys(){const g=this,v=this.e;let l=this.b;const m={[Symbol.iterator](){return m},next(){if(g.e!==v)throw new Error("LinkedMap got modified during iteration.");if(l){const u={value:l.key,done:!1};return l=l.next,u}else return{value:void 0,done:!0}}};return m}values(){const g=this,v=this.e;let l=this.b;const m={[Symbol.iterator](){return m},next(){if(g.e!==v)throw new Error("LinkedMap got modified during iteration.");if(l){const u={value:l.value,done:!1};return l=l.next,u}else return{value:void 0,done:!0}}};return m}entries(){const g=this,v=this.e;let l=this.b;const m={[Symbol.iterator](){return m},next(){if(g.e!==v)throw new Error("LinkedMap got modified during iteration.");if(l){const u={value:[l.key,l.value],done:!1};return l=l.next,u}else return{value:void 0,done:!0}}};return m}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(g){if(g>=this.size)return;if(g===0){this.clear();return}let v=this.b,l=this.size;for(;v&&l>g;)this.a.delete(v.key),v=v.next,l--;this.b=v,this.d=l,v&&(v.previous=void 0),this.e++}g(g){if(!this.b&&!this.c)this.c=g;else if(this.b)g.next=this.b,this.b.previous=g;else throw new Error("Invalid list");this.b=g,this.e++}h(g){if(!this.b&&!this.c)this.b=g;else if(this.c)g.previous=this.c,this.c.next=g;else throw new Error("Invalid list");this.c=g,this.e++}i(g){if(g===this.b&&g===this.c)this.b=void 0,this.c=void 0;else if(g===this.b){if(!g.next)throw new Error("Invalid list");g.next.previous=void 0,this.b=g.next}else if(g===this.c){if(!g.previous)throw new Error("Invalid list");g.previous.next=void 0,this.c=g.previous}else{const v=g.next,l=g.previous;if(!v||!l)throw new Error("Invalid list");v.previous=l,l.next=v}g.next=void 0,g.previous=void 0,this.e++}j(g,v){if(!this.b||!this.c)throw new Error("Invalid list");if(!(v!==1&&v!==2)){if(v===1){if(g===this.b)return;const l=g.next,m=g.previous;g===this.c?(m.next=void 0,this.c=m):(l.previous=m,m.next=l),g.previous=void 0,g.next=this.b,this.b.previous=g,this.b=g,this.e++}else if(v===2){if(g===this.c)return;const l=g.next,m=g.previous;g===this.b?(l.previous=void 0,this.b=l):(l.previous=m,m.next=l),g.next=void 0,g.previous=this.c,this.c.next=g,this.c=g,this.e++}}}toJSON(){const g=[];return this.forEach((v,l)=>{g.push([l,v])}),g}fromJSON(g){this.clear();for(const[v,l]of g)this.set(v,l)}}e.LinkedMap=w;class y extends w{constructor(g,v=1){super(),this.k=g,this.l=Math.min(Math.max(0,v),1)}get limit(){return this.k}set limit(g){this.k=g,this.m()}get ratio(){return this.l}set ratio(g){this.l=Math.min(Math.max(0,g),1),this.m()}get(g,v=2){return super.get(g,v)}peek(g){return super.get(g,0)}set(g,v){return super.set(g,v,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=y}),define(re[85],ae([0,1,37]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const i=new D.LRUCache(1e4);function R(S){return I(S,"NFC",i)}e.normalizeNFC=R;const A=new D.LRUCache(1e4);function L(S){return I(S,"NFD",A)}e.normalizeNFD=L;const P=/[^\u0000-\u0080]/;function I(S,C,b){if(!S)return S;const w=b.get(S);if(w)return w;let y;return P.test(S)?y=S.normalize(C):y=S,b.set(S,y),y}e.removeAccents=function(){const S=/[\u0300-\u036f]/g;return function(C){return L(C).replace(S,"")}}()}),function(){function _(R){const A=[];typeof R=="number"&&A.push("code/timeOrigin",R);function L(I){A.push(I,Date.now())}function P(){const I=[];for(let S=0;S<A.length;S+=2)I.push({name:A[S],startTime:A[S+1]});return I}return{mark:L,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?_():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const L of performance.getEntriesByType("mark"))A.push({name:L.name,startTime:Math.round(R+L.startTime)});return A}};if(typeof process=="object"){const R=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return _(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),_()}function D(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var i;typeof global=="object"?i=global:typeof self=="object"?i=self:i={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(i)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(i):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),i.perf=D(i))}(),function(_,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var i in D)(typeof exports=="object"?exports:_)[i]=D[i]}}(typeof self<"u"?self:this,function(){return function(_){var e={};function D(i){if(e[i])return e[i].exports;var R=e[i]={i,l:!1,exports:{}};return _[i].call(R.exports,R,R.exports,D),R.l=!0,R.exports}return D.m=_,D.c=e,D.d=function(i,R,A){D.o(i,R)||Object.defineProperty(i,R,{enumerable:!0,get:A})},D.r=function(i){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(i,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(i,"__esModule",{value:!0})},D.t=function(i,R){if(1&R&&(i=D(i)),8&R||4&R&&typeof i=="object"&&i&&i.__esModule)return i;var A=Object.create(null);if(D.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:i}),2&R&&typeof i!="string")for(var L in i)D.d(A,L,function(P){return i[P]}.bind(null,L));return A},D.n=function(i){var R=i&&i.__esModule?function(){return i.default}:function(){return i};return D.d(R,"a",R),R},D.o=function(i,R){return Object.prototype.hasOwnProperty.call(i,R)},D.p="",D(D.s=0)}([function(_,e,D){(function(i){var R;e=_.exports=T,R=typeof i=="object"&&i.env&&i.env.NODE_DEBUG&&/\bsemver\b/i.test(i.env.NODE_DEBUG)?function(){var ce=Array.prototype.slice.call(arguments,0);ce.unshift("SEMVER"),console.log.apply(console,ce)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],I=e.src=[],S=0,C=S++;I[C]="0|[1-9]\\d*";var b=S++;I[b]="[0-9]+";var w=S++;I[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=S++;I[y]="("+I[C]+")\\.("+I[C]+")\\.("+I[C]+")";var d=S++;I[d]="("+I[b]+")\\.("+I[b]+")\\.("+I[b]+")";var g=S++;I[g]="(?:"+I[C]+"|"+I[w]+")";var v=S++;I[v]="(?:"+I[b]+"|"+I[w]+")";var l=S++;I[l]="(?:-("+I[g]+"(?:\\."+I[g]+")*))";var m=S++;I[m]="(?:-?("+I[v]+"(?:\\."+I[v]+")*))";var u=S++;I[u]="[0-9A-Za-z-]+";var h=S++;I[h]="(?:\\+("+I[u]+"(?:\\."+I[u]+")*))";var f=S++,n="v?"+I[y]+I[l]+"?"+I[h]+"?";I[f]="^"+n+"$";var s="[v=\\s]*"+I[d]+I[m]+"?"+I[h]+"?",t=S++;I[t]="^"+s+"$";var a=S++;I[a]="((?:<|>)?=?)";var r=S++;I[r]=I[b]+"|x|X|\\*";var c=S++;I[c]=I[C]+"|x|X|\\*";var o=S++;I[o]="[v=\\s]*("+I[c]+")(?:\\.("+I[c]+")(?:\\.("+I[c]+")(?:"+I[l]+")?"+I[h]+"?)?)?";var p=S++;I[p]="[v=\\s]*("+I[r]+")(?:\\.("+I[r]+")(?:\\.("+I[r]+")(?:"+I[m]+")?"+I[h]+"?)?)?";var E=S++;I[E]="^"+I[a]+"\\s*"+I[o]+"$";var k=S++;I[k]="^"+I[a]+"\\s*"+I[p]+"$";var F=S++;I[F]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var N=S++;I[N]="(?:~>?)";var q=S++;I[q]="(\\s*)"+I[N]+"\\s+",P[q]=new RegExp(I[q],"g");var j=S++;I[j]="^"+I[N]+I[o]+"$";var O=S++;I[O]="^"+I[N]+I[p]+"$";var U=S++;I[U]="(?:\\^)";var $=S++;I[$]="(\\s*)"+I[U]+"\\s+",P[$]=new RegExp(I[$],"g");var G=S++;I[G]="^"+I[U]+I[o]+"$";var H=S++;I[H]="^"+I[U]+I[p]+"$";var Z=S++;I[Z]="^"+I[a]+"\\s*("+s+")$|^$";var z=S++;I[z]="^"+I[a]+"\\s*("+n+")$|^$";var B=S++;I[B]="(\\s*)"+I[a]+"\\s*("+s+"|"+I[o]+")",P[B]=new RegExp(I[B],"g");var Y=S++;I[Y]="^\\s*("+I[o]+")\\s+-\\s+("+I[o]+")\\s*$";var ee=S++;I[ee]="^\\s*("+I[p]+")\\s+-\\s+("+I[p]+")\\s*$";var oe=S++;I[oe]="(<|>)?=?\\s*\\*";for(var J=0;J<35;J++)R(J,I[J]),P[J]||(P[J]=new RegExp(I[J]));function Q(ce,de){if(ce instanceof T)return ce;if(typeof ce!="string"||ce.length>A||!(de?P[t]:P[f]).test(ce))return null;try{return new T(ce,de)}catch{return null}}function T(ce,de){if(ce instanceof T){if(ce.loose===de)return ce;ce=ce.version}else if(typeof ce!="string")throw new TypeError("Invalid Version: "+ce);if(ce.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof T))return new T(ce,de);R("SemVer",ce,de),this.loose=de;var ge=ce.trim().match(de?P[t]:P[f]);if(!ge)throw new TypeError("Invalid Version: "+ce);if(this.raw=ce,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Ce){if(/^[0-9]+$/.test(Ce)){var Pe=+Ce;if(Pe>=0&&Pe<L)return Pe}return Ce}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=Q,e.valid=function(ce,de){var ge=Q(ce,de);return ge?ge.version:null},e.clean=function(ce,de){var ge=Q(ce.trim().replace(/^[=v]+/,""),de);return ge?ge.version:null},e.SemVer=T,T.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},T.prototype.toString=function(){return this.version},T.prototype.compare=function(ce){return R("SemVer.compare",this.version,this.loose,ce),ce instanceof T||(ce=new T(ce,this.loose)),this.compareMain(ce)||this.comparePre(ce)},T.prototype.compareMain=function(ce){return ce instanceof T||(ce=new T(ce,this.loose)),V(this.major,ce.major)||V(this.minor,ce.minor)||V(this.patch,ce.patch)},T.prototype.comparePre=function(ce){if(ce instanceof T||(ce=new T(ce,this.loose)),this.prerelease.length&&!ce.prerelease.length)return-1;if(!this.prerelease.length&&ce.prerelease.length)return 1;if(!this.prerelease.length&&!ce.prerelease.length)return 0;var de=0;do{var ge=this.prerelease[de],Ce=ce.prerelease[de];if(R("prerelease compare",de,ge,Ce),ge===void 0&&Ce===void 0)return 0;if(Ce===void 0)return 1;if(ge===void 0)return-1;if(ge!==Ce)return V(ge,Ce)}while(++de)},T.prototype.inc=function(ce,de){switch(ce){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+ce)}return this.format(),this.raw=this.version,this},e.inc=function(ce,de,ge,Ce){typeof ge=="string"&&(Ce=ge,ge=void 0);try{return new T(ce,ge).inc(de,Ce).version}catch{return null}},e.diff=function(ce,de){if(x(ce,de))return null;var ge=Q(ce),Ce=Q(de);if(ge.prerelease.length||Ce.prerelease.length){for(var Pe in ge)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ge[Pe]!==Ce[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in ge)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ge[Pe]!==Ce[Pe])return Pe},e.compareIdentifiers=V;var M=/^[0-9]+$/;function V(ce,de){var ge=M.test(ce),Ce=M.test(de);return ge&&Ce&&(ce=+ce,de=+de),ge&&!Ce?-1:Ce&&!ge?1:ce<de?-1:ce>de?1:0}function W(ce,de,ge){return new T(ce,ge).compare(new T(de,ge))}function X(ce,de,ge){return W(ce,de,ge)>0}function se(ce,de,ge){return W(ce,de,ge)<0}function x(ce,de,ge){return W(ce,de,ge)===0}function ie(ce,de,ge){return W(ce,de,ge)!==0}function ne(ce,de,ge){return W(ce,de,ge)>=0}function le(ce,de,ge){return W(ce,de,ge)<=0}function ue(ce,de,ge,Ce){var Pe;switch(de){case"===":typeof ce=="object"&&(ce=ce.version),typeof ge=="object"&&(ge=ge.version),Pe=ce===ge;break;case"!==":typeof ce=="object"&&(ce=ce.version),typeof ge=="object"&&(ge=ge.version),Pe=ce!==ge;break;case"":case"=":case"==":Pe=x(ce,ge,Ce);break;case"!=":Pe=ie(ce,ge,Ce);break;case">":Pe=X(ce,ge,Ce);break;case">=":Pe=ne(ce,ge,Ce);break;case"<":Pe=se(ce,ge,Ce);break;case"<=":Pe=le(ce,ge,Ce);break;default:throw new TypeError("Invalid operator: "+de)}return Pe}function pe(ce,de){if(ce instanceof pe){if(ce.loose===de)return ce;ce=ce.value}if(!(this instanceof pe))return new pe(ce,de);R("comparator",ce,de),this.loose=de,this.parse(ce),this.semver===Se?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(ce,de){return V(de,ce)},e.major=function(ce,de){return new T(ce,de).major},e.minor=function(ce,de){return new T(ce,de).minor},e.patch=function(ce,de){return new T(ce,de).patch},e.compare=W,e.compareLoose=function(ce,de){return W(ce,de,!0)},e.rcompare=function(ce,de,ge){return W(de,ce,ge)},e.sort=function(ce,de){return ce.sort(function(ge,Ce){return e.compare(ge,Ce,de)})},e.rsort=function(ce,de){return ce.sort(function(ge,Ce){return e.rcompare(ge,Ce,de)})},e.gt=X,e.lt=se,e.eq=x,e.neq=ie,e.gte=ne,e.lte=le,e.cmp=ue,e.Comparator=pe;var Se={};function be(ce,de){if(ce instanceof be)return ce.loose===de?ce:new be(ce.raw,de);if(ce instanceof pe)return new be(ce.value,de);if(!(this instanceof be))return new be(ce,de);if(this.loose=de,this.raw=ce,this.set=ce.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ce);this.format()}function Ee(ce){return!ce||ce.toLowerCase()==="x"||ce==="*"}function Ne(ce,de,ge,Ce,Pe,Ae,De,je,Oe,Ue,Be,ke,Te){return((de=Ee(ge)?"":Ee(Ce)?">="+ge+".0.0":Ee(Pe)?">="+ge+"."+Ce+".0":">="+de)+" "+(je=Ee(Oe)?"":Ee(Ue)?"<"+(+Oe+1)+".0.0":Ee(Be)?"<"+Oe+"."+(+Ue+1)+".0":ke?"<="+Oe+"."+Ue+"."+Be+"-"+ke:"<="+je)).trim()}function Fe(ce,de){for(var ge=0;ge<ce.length;ge++)if(!ce[ge].test(de))return!1;if(de.prerelease.length){for(ge=0;ge<ce.length;ge++)if(R(ce[ge].semver),ce[ge].semver!==Se&&ce[ge].semver.prerelease.length>0){var Ce=ce[ge].semver;if(Ce.major===de.major&&Ce.minor===de.minor&&Ce.patch===de.patch)return!0}return!1}return!0}function Ye(ce,de,ge){try{de=new be(de,ge)}catch{return!1}return de.test(ce)}function ze(ce,de,ge,Ce){var Pe,Ae,De,je,Oe;switch(ce=new T(ce,Ce),de=new be(de,Ce),ge){case">":Pe=X,Ae=le,De=se,je=">",Oe=">=";break;case"<":Pe=se,Ae=ne,De=X,je="<",Oe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ye(ce,de,Ce))return!1;for(var Ue=0;Ue<de.set.length;++Ue){var Be=de.set[Ue],ke=null,Te=null;if(Be.forEach(function(te){te.semver===Se&&(te=new pe(">=0.0.0")),ke=ke||te,Te=Te||te,Pe(te.semver,ke.semver,Ce)?ke=te:De(te.semver,Te.semver,Ce)&&(Te=te)}),ke.operator===je||ke.operator===Oe||(!Te.operator||Te.operator===je)&&Ae(ce,Te.semver)||Te.operator===Oe&&De(ce,Te.semver))return!1}return!0}pe.prototype.parse=function(ce){var de=this.loose?P[Z]:P[z],ge=ce.match(de);if(!ge)throw new TypeError("Invalid comparator: "+ce);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new T(ge[2],this.loose):this.semver=Se},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(ce){return R("Comparator.test",ce,this.loose),this.semver===Se||(typeof ce=="string"&&(ce=new T(ce,this.loose)),ue(ce,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(ce,de){if(!(ce instanceof pe))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new be(ce.value,de),Ye(this.value,ge,de);if(ce.operator==="")return ge=new be(this.value,de),Ye(ce.semver,ge,de);var Ce=!(this.operator!==">="&&this.operator!==">"||ce.operator!==">="&&ce.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||ce.operator!=="<="&&ce.operator!=="<"),Ae=this.semver.version===ce.semver.version,De=!(this.operator!==">="&&this.operator!=="<="||ce.operator!==">="&&ce.operator!=="<="),je=ue(this.semver,"<",ce.semver,de)&&(this.operator===">="||this.operator===">")&&(ce.operator==="<="||ce.operator==="<"),Oe=ue(this.semver,">",ce.semver,de)&&(this.operator==="<="||this.operator==="<")&&(ce.operator===">="||ce.operator===">");return Ce||Pe||Ae&&De||je||Oe},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(ce){return ce.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(ce){var de=this.loose;ce=ce.trim(),R("range",ce,de);var ge=de?P[ee]:P[Y];ce=ce.replace(ge,Ne),R("hyphen replace",ce),ce=ce.replace(P[B],"$1$2$3"),R("comparator trim",ce,P[B]),ce=(ce=(ce=ce.replace(P[q],"$1~")).replace(P[$],"$1^")).split(/\s+/).join(" ");var Ce=de?P[Z]:P[z],Pe=ce.split(" ").map(function(Ae){return function(De,je){return R("comp",De),De=function(Oe,Ue){return Oe.trim().split(/\s+/).map(function(Be){return function(ke,Te){R("caret",ke,Te);var te=Te?P[H]:P[G];return ke.replace(te,function(he,fe,me,we,Ie){var Re;return R("caret",ke,he,fe,me,we,Ie),Ee(fe)?Re="":Ee(me)?Re=">="+fe+".0.0 <"+(+fe+1)+".0.0":Ee(we)?Re=fe==="0"?">="+fe+"."+me+".0 <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+".0 <"+(+fe+1)+".0.0":Ie?(R("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Re=fe==="0"?me==="0"?">="+fe+"."+me+"."+we+Ie+" <"+fe+"."+me+"."+(+we+1):">="+fe+"."+me+"."+we+Ie+" <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+"."+we+Ie+" <"+(+fe+1)+".0.0"):(R("no pr"),Re=fe==="0"?me==="0"?">="+fe+"."+me+"."+we+" <"+fe+"."+me+"."+(+we+1):">="+fe+"."+me+"."+we+" <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+"."+we+" <"+(+fe+1)+".0.0"),R("caret return",Re),Re})}(Be,Ue)}).join(" ")}(De,je),R("caret",De),De=function(Oe,Ue){return Oe.trim().split(/\s+/).map(function(Be){return function(ke,Te){var te=Te?P[O]:P[j];return ke.replace(te,function(he,fe,me,we,Ie){var Re;return R("tilde",ke,he,fe,me,we,Ie),Ee(fe)?Re="":Ee(me)?Re=">="+fe+".0.0 <"+(+fe+1)+".0.0":Ee(we)?Re=">="+fe+"."+me+".0 <"+fe+"."+(+me+1)+".0":Ie?(R("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Re=">="+fe+"."+me+"."+we+Ie+" <"+fe+"."+(+me+1)+".0"):Re=">="+fe+"."+me+"."+we+" <"+fe+"."+(+me+1)+".0",R("tilde return",Re),Re})}(Be,Ue)}).join(" ")}(De,je),R("tildes",De),De=function(Oe,Ue){return R("replaceXRanges",Oe,Ue),Oe.split(/\s+/).map(function(Be){return function(ke,Te){ke=ke.trim();var te=Te?P[k]:P[E];return ke.replace(te,function(he,fe,me,we,Ie,Re){R("xRange",ke,he,fe,me,we,Ie,Re);var He=Ee(me),$e=He||Ee(we),Le=$e||Ee(Ie);return fe==="="&&Le&&(fe=""),He?he=fe===">"||fe==="<"?"<0.0.0":"*":fe&&Le?($e&&(we=0),Le&&(Ie=0),fe===">"?(fe=">=",$e?(me=+me+1,we=0,Ie=0):Le&&(we=+we+1,Ie=0)):fe==="<="&&(fe="<",$e?me=+me+1:we=+we+1),he=fe+me+"."+we+"."+Ie):$e?he=">="+me+".0.0 <"+(+me+1)+".0.0":Le&&(he=">="+me+"."+we+".0 <"+me+"."+(+we+1)+".0"),R("xRange return",he),he})}(Be,Ue)}).join(" ")}(De,je),R("xrange",De),De=function(Oe,Ue){return R("replaceStars",Oe,Ue),Oe.trim().replace(P[oe],"")}(De,je),R("stars",De),De}(Ae,de)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(Ae){return!!Ae.match(Ce)})),Pe=Pe.map(function(Ae){return new pe(Ae,de)})},be.prototype.intersects=function(ce,de){if(!(ce instanceof be))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Ce){return ce.set.some(function(Pe){return Pe.every(function(Ae){return Ce.intersects(Ae,de)})})})})},e.toComparators=function(ce,de){return new be(ce,de).set.map(function(ge){return ge.map(function(Ce){return Ce.value}).join(" ").trim().split(" ")})},be.prototype.test=function(ce){if(!ce)return!1;typeof ce=="string"&&(ce=new T(ce,this.loose));for(var de=0;de<this.set.length;de++)if(Fe(this.set[de],ce))return!0;return!1},e.satisfies=Ye,e.maxSatisfying=function(ce,de,ge){var Ce=null,Pe=null;try{var Ae=new be(de,ge)}catch{return null}return ce.forEach(function(De){Ae.test(De)&&(Ce&&Pe.compare(De)!==-1||(Pe=new T(Ce=De,ge)))}),Ce},e.minSatisfying=function(ce,de,ge){var Ce=null,Pe=null;try{var Ae=new be(de,ge)}catch{return null}return ce.forEach(function(De){Ae.test(De)&&(Ce&&Pe.compare(De)!==1||(Pe=new T(Ce=De,ge)))}),Ce},e.validRange=function(ce,de){try{return new be(ce,de).range||"*"}catch{return null}},e.ltr=function(ce,de,ge){return ze(ce,de,"<",ge)},e.gtr=function(ce,de,ge){return ze(ce,de,">",ge)},e.outside=ze,e.prerelease=function(ce,de){var ge=Q(ce,de);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(ce,de,ge){return ce=new be(ce,ge),de=new be(de,ge),ce.intersects(de)},e.coerce=function(ce){if(ce instanceof T)return ce;if(typeof ce!="string")return null;var de=ce.match(P[F]);return de==null?null:Q((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,D(1))},function(_,e){var D,i,R=_.exports={};function A(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function P(v){if(D===setTimeout)return setTimeout(v,0);if((D===A||!D)&&setTimeout)return D=setTimeout,setTimeout(v,0);try{return D(v,0)}catch{try{return D.call(null,v,0)}catch{return D.call(this,v,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:A}catch{D=A}try{i=typeof clearTimeout=="function"?clearTimeout:L}catch{i=L}})();var I,S=[],C=!1,b=-1;function w(){C&&I&&(C=!1,I.length?S=I.concat(S):b=-1,S.length&&y())}function y(){if(!C){var v=P(w);C=!0;for(var l=S.length;l;){for(I=S,S=[];++b<l;)I&&I[b].run();b=-1,l=S.length}I=null,C=!1,function(m){if(i===clearTimeout)return clearTimeout(m);if((i===L||!i)&&clearTimeout)return i=clearTimeout,clearTimeout(m);try{i(m)}catch{try{return i.call(null,m)}catch{return i.call(this,m)}}}(v)}}function d(v,l){this.fun=v,this.array=l}function g(){}R.nextTick=function(v){var l=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)l[m-1]=arguments[m];S.push(new d(v,l)),S.length!==1||C||P(y)},d.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=g,R.addListener=g,R.once=g,R.off=g,R.removeListener=g,R.removeAllListeners=g,R.emit=g,R.prependListener=g,R.prependOnceListener=g,R.listeners=function(v){return[]},R.binding=function(v){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(v){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(re[128],ae([0,1]),function(_,e){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class i{constructor(P,I,S){this.level=P,this.key=I,this.value=S,this.forward=[]}}const R=void 0;class A{constructor(P,I=2**16){this.comparator=P,this[D]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(I)|0),this.e=new i(this.c,R,R)}get size(){return this.f}clear(){this.e=new i(this.c,R,R)}has(P){return Boolean(A.g(this,P,this.comparator))}get(P){return A.g(this,P,this.comparator)?.value}set(P,I){return A.h(this,P,I,this.comparator)&&(this.f+=1),this}delete(P){const I=A.k(this,P,this.comparator);return I&&(this.f-=1),I}forEach(P,I){let S=this.e.forward[0];for(;S;)P.call(I,S.value,S.key,this),S=S.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",I=this.e.forward[0];for(;I;)P+=`node(${I.key}, ${I.value}, lvl:${I.level})`,I=I.forward[0];return P}static g(P,I,S){let C=P.e;for(let b=P.d-1;b>=0;b--)for(;C.forward[b]&&S(C.forward[b].key,I)<0;)C=C.forward[b];if(C=C.forward[0],C&&S(C.key,I)===0)return C}static h(P,I,S,C){const b=[];let w=P.e;for(let y=P.d-1;y>=0;y--){for(;w.forward[y]&&C(w.forward[y].key,I)<0;)w=w.forward[y];b[y]=w}if(w=w.forward[0],w&&C(w.key,I)===0)return w.value=S,!1;{const y=A.j(P);if(y>P.d){for(let d=P.d;d<y;d++)b[d]=P.e;P.d=y}w=new i(y,I,S);for(let d=0;d<y;d++)w.forward[d]=b[d].forward[d],b[d].forward[d]=w;return!0}}static j(P,I=.5){let S=1;for(;Math.random()<I&&S<P.c;)S+=1;return S}static k(P,I,S){const C=[];let b=P.e;for(let w=P.d-1;w>=0;w--){for(;b.forward[w]&&S(b.forward[w].key,I)<0;)b=b.forward[w];C[w]=b}if(b=b.forward[0],!b||S(b.key,I)!==0)return!1;for(let w=0;w<P.d&&C[w].forward[w]===b;w++)C[w].forward[w]=b.forward[w];for(;P.d>0&&P.e.forward[P.d-1]===R;)P.d-=1;return!0}}e.SkipList=A}),define(re[44],ae([0,1,9,2]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function R(h){const f=h;return f?typeof f.read=="function":!1}e.isReadable=R;function A(h){const f=h;return f?[f.on,f.pause,f.resume,f.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=A;function L(h){const f=h;return f?A(f.stream)&&Array.isArray(f.buffer)&&typeof f.ended=="boolean":!1}e.isReadableBufferedStream=L;function P(h,f){return new I(h,f)}e.newWriteableStream=P;class I{constructor(f,n){this.e=f,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(f){if(!this.a.destroyed){if(this.a.flowing)this.g(f);else if(this.b.data.push(f),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(f){this.a.destroyed||(this.a.flowing?this.h(f):this.b.error.push(f))}end(f){this.a.destroyed||(typeof f<"u"&&this.write(f),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(f){this.c.data.slice(0).forEach(n=>n(f))}h(f){this.c.error.length===0?(0,D.onUnexpectedError)(f):this.c.error.slice(0).forEach(n=>n(f))}i(){this.c.end.slice(0).forEach(f=>f())}on(f,n){if(!this.a.destroyed)switch(f){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(f,n){if(this.a.destroyed)return;let s;switch(f){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const t=s.indexOf(n);t>=0&&s.splice(t,1)}}j(){if(this.b.data.length>0){const f=this.e(this.b.data);this.g(f),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const f of this.b.error)this.h(f);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function S(h,f){const n=[];let s;for(;(s=h.read())!==null;)n.push(s);return f(n)}e.consumeReadable=S;function C(h,f,n){const s=[];let t;for(;(t=h.read())!==null&&s.length<n;)s.push(t);return t===null&&s.length>0?f(s):{read:()=>{if(s.length>0)return s.shift();if(typeof t<"u"){const a=t;return t=void 0,a}return h.read()}}}e.peekReadable=C;function b(h,f){return new Promise((n,s)=>{const t=[];w(h,{onData:a=>{f&&t.push(a)},onError:a=>{f?s(a):n(void 0)},onEnd:()=>{n(f?f(t):void 0)}})})}e.consumeStream=b;function w(h,f){let n=!1;return h.on("error",s=>{n||f.onError(s)}),h.on("end",()=>{n||f.onEnd()}),h.on("data",s=>{n||f.onData(s)}),(0,i.toDisposable)(()=>n=!0)}e.listenStream=w;function y(h,f){return new Promise((n,s)=>{const t=new i.DisposableStore,a=[],r=p=>{if(a.push(p),a.length>f)return t.dispose(),h.pause(),n({stream:h,buffer:a,ended:!1})},c=p=>s(p),o=()=>n({stream:h,buffer:a,ended:!0});t.add((0,i.toDisposable)(()=>h.removeListener("error",c))),h.on("error",c),t.add((0,i.toDisposable)(()=>h.removeListener("end",o))),h.on("end",o),t.add((0,i.toDisposable)(()=>h.removeListener("data",r))),h.on("data",r)})}e.peekStream=y;function d(h,f){const n=P(f);return n.end(h),n}e.toStream=d;function g(){const h=P(()=>{throw new Error("not supported")});return h.end(),h}e.emptyStream=g;function v(h){let f=!1;return{read:()=>f?null:(f=!0,h)}}e.toReadable=v;function l(h,f,n){const s=P(n);return w(h,{onData:t=>s.write(f.data(t)),onError:t=>s.error(f.error?f.error(t):t),onEnd:()=>s.end()}),s}e.transform=l;function m(h,f,n){let s=!1;return{read:()=>{const t=f.read();return s?t:(s=!0,t!==null?n([h,t]):h)}}}e.prefixedReadable=m;function u(h,f,n){let s=!1;const t=P(n);return w(f,{onData:a=>s?t.write(a):(s=!0,t.write(n([h,a]))),onError:a=>t.error(a),onEnd:()=>{s||(s=!0,t.write(h)),t.end()}}),t}e.prefixedStream=u}),define(re[17],ae([0,1,44]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const i=typeof Buffer<"u";let R,A;class L{static alloc(p){return i?new L(Buffer.allocUnsafe(p)):new L(new Uint8Array(p))}static wrap(p){return i&&!Buffer.isBuffer(p)&&(p=Buffer.from(p.buffer,p.byteOffset,p.byteLength)),new L(p)}static fromString(p,E){return!(E?.dontUseNodeBuffer||!1)&&i?new L(Buffer.from(p)):(R||(R=new TextEncoder),new L(R.encode(p)))}static fromByteArray(p){const E=L.alloc(p.length);for(let k=0,F=p.length;k<F;k++)E.buffer[k]=p[k];return E}static concat(p,E){if(typeof E>"u"){E=0;for(let N=0,q=p.length;N<q;N++)E+=p[N].byteLength}const k=L.alloc(E);let F=0;for(let N=0,q=p.length;N<q;N++){const j=p[N];k.set(j,F),F+=j.byteLength}return k}constructor(p){this.buffer=p,this.byteLength=this.buffer.byteLength}clone(){const p=L.alloc(this.byteLength);return p.set(this),p}toString(){return i?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(p,E){return new L(this.buffer.subarray(p,E))}set(p,E){if(p instanceof L)this.buffer.set(p.buffer,E);else if(p instanceof Uint8Array)this.buffer.set(p,E);else if(p instanceof ArrayBuffer)this.buffer.set(new Uint8Array(p),E);else if(ArrayBuffer.isView(p))this.buffer.set(new Uint8Array(p.buffer,p.byteOffset,p.byteLength),E);else throw new Error("Unknown argument 'array'")}readUInt32BE(p){return S(this.buffer,p)}writeUInt32BE(p,E){C(this.buffer,p,E)}readUInt32LE(p){return b(this.buffer,p)}writeUInt32LE(p,E){w(this.buffer,p,E)}readUInt8(p){return y(this.buffer,p)}writeUInt8(p,E){d(this.buffer,p,E)}}e.VSBuffer=L;function P(o,p){return o[p+0]<<0>>>0|o[p+1]<<8>>>0}e.readUInt16LE=P;function I(o,p,E){o[E+0]=p&255,p=p>>>8,o[E+1]=p&255}e.writeUInt16LE=I;function S(o,p){return o[p]*2**24+o[p+1]*2**16+o[p+2]*2**8+o[p+3]}e.readUInt32BE=S;function C(o,p,E){o[E+3]=p,p=p>>>8,o[E+2]=p,p=p>>>8,o[E+1]=p,p=p>>>8,o[E]=p}e.writeUInt32BE=C;function b(o,p){return o[p+0]<<0>>>0|o[p+1]<<8>>>0|o[p+2]<<16>>>0|o[p+3]<<24>>>0}e.readUInt32LE=b;function w(o,p,E){o[E+0]=p&255,p=p>>>8,o[E+1]=p&255,p=p>>>8,o[E+2]=p&255,p=p>>>8,o[E+3]=p&255}e.writeUInt32LE=w;function y(o,p){return o[p]}e.readUInt8=y;function d(o,p,E){o[E]=p}e.writeUInt8=d;function g(o){return D.consumeReadable(o,p=>L.concat(p))}e.readableToBuffer=g;function v(o){return D.toReadable(o)}e.bufferToReadable=v;function l(o){return D.consumeStream(o,p=>L.concat(p))}e.streamToBuffer=l;async function m(o){return o.ended?L.concat(o.buffer):L.concat([...o.buffer,await l(o.stream)])}e.bufferedStreamToBuffer=m;function u(o){return D.toStream(o,p=>L.concat(p))}e.bufferToStream=u;function h(o){return D.transform(o,{data:p=>typeof p=="string"?L.fromString(p):L.wrap(p)},p=>L.concat(p))}e.streamToBufferReadableStream=h;function f(o){return D.newWriteableStream(p=>L.concat(p),o)}e.newWriteableBufferStream=f;function n(o,p){return D.prefixedReadable(o,p,E=>L.concat(E))}e.prefixedBufferReadable=n;function s(o,p){return D.prefixedStream(o,p,E=>L.concat(E))}e.prefixedBufferStream=s;function t(o){let p=0,E=0,k=0;const F=new Uint8Array(Math.floor(o.length/4*3)),N=j=>{switch(E){case 3:F[k++]=p|j,E=0;break;case 2:F[k++]=p|j>>>2,p=j<<6,E=3;break;case 1:F[k++]=p|j>>>4,p=j<<4,E=2;break;default:p=j<<2,E=1}};for(let j=0;j<o.length;j++){const O=o.charCodeAt(j);if(O>=65&&O<=90)N(O-65);else if(O>=97&&O<=122)N(O-97+26);else if(O>=48&&O<=57)N(O-48+52);else if(O===43||O===45)N(62);else if(O===47||O===95)N(63);else{if(O===61)break;throw new SyntaxError(`Unexpected base64 character ${o[j]}`)}}const q=k;for(;E>0;)N(0);return L.wrap(F).slice(0,q)}e.decodeBase64=t;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:o},p=!0,E=!1){const k=E?r:a;let F="";const N=o.byteLength%3;let q=0;for(;q<o.byteLength-N;q+=3){const j=o[q+0],O=o[q+1],U=o[q+2];F+=k[j>>>2],F+=k[(j<<4|O>>>4)&63],F+=k[(O<<2|U>>>6)&63],F+=k[U&63]}if(N===1){const j=o[q+0];F+=k[j>>>2],F+=k[j<<4&63],p&&(F+="==")}else if(N===2){const j=o[q+0],O=o[q+1];F+=k[j>>>2],F+=k[(j<<4|O>>>4)&63],F+=k[O<<2&63],p&&(F+="=")}return F}e.encodeBase64=c}),define(re[15],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function D(s){return typeof s=="string"}e.isString=D;function i(s){return Array.isArray(s)&&s.every(t=>D(t))}e.isStringArray=i;function R(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}e.isObject=R;function A(s){const t=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof t}e.isTypedArray=A;function L(s){return typeof s=="number"&&!isNaN(s)}e.isNumber=L;function P(s){return!!s&&typeof s[Symbol.iterator]=="function"}e.isIterable=P;function I(s){return s===!0||s===!1}e.isBoolean=I;function S(s){return typeof s>"u"}e.isUndefined=S;function C(s){return!b(s)}e.isDefined=C;function b(s){return S(s)||s===null}e.isUndefinedOrNull=b;function w(s,t){if(!s)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.assertType=w;function y(s){if(b(s))throw new Error("Assertion Failed: argument is undefined or null");return s}e.assertIsDefined=y;function d(...s){const t=[];for(let a=0;a<s.length;a++){const r=s[a];if(b(r))throw new Error(`Assertion Failed: argument at index ${a} is undefined or null`);t.push(r)}return t}e.assertAllDefined=d;const g=Object.prototype.hasOwnProperty;function v(s){if(!R(s))return!1;for(const t in s)if(g.call(s,t))return!1;return!0}e.isEmptyObject=v;function l(s){return typeof s=="function"}e.isFunction=l;function m(...s){return s.length>0&&s.every(l)}e.areFunctions=m;function u(s,t){const a=Math.min(s.length,t.length);for(let r=0;r<a;r++)h(s[r],t[r])}e.validateConstraints=u;function h(s,t){if(D(t)){if(typeof s!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(l(t)){try{if(s instanceof t)return}catch{}if(!b(s)&&s.constructor===t||t.length===1&&t.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=h;function f(s){return s===null?void 0:s}e.withNullAsUndefined=f;function n(s){return typeof s>"u"?null:s}e.withUndefinedAsNull=n}),define(re[32],ae([0,1,15]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function i(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const m=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([u,h])=>{m[u]=h&&typeof h=="object"?i(h):h}),m}e.deepClone=i;function R(l){if(!l||typeof l!="object")return l;const m=[l];for(;m.length>0;){const u=m.shift();Object.freeze(u);for(const h in u)if(A.call(u,h)){const f=u[h];typeof f=="object"&&!Object.isFrozen(f)&&!(0,D.isTypedArray)(f)&&m.push(f)}}return l}e.deepFreeze=R;const A=Object.prototype.hasOwnProperty;function L(l,m){return P(l,m,new Set)}e.cloneAndChange=L;function P(l,m,u){if((0,D.isUndefinedOrNull)(l))return l;const h=m(l);if(typeof h<"u")return h;if(Array.isArray(l)){const f=[];for(const n of l)f.push(P(n,m,u));return f}if((0,D.isObject)(l)){if(u.has(l))throw new Error("Cannot clone recursive data-structure");u.add(l);const f={};for(const n in l)A.call(l,n)&&(f[n]=P(l[n],m,u));return u.delete(l),f}return l}function I(l,m,u=!0){return(0,D.isObject)(l)?((0,D.isObject)(m)&&Object.keys(m).forEach(h=>{h in l?u&&((0,D.isObject)(l[h])&&(0,D.isObject)(m[h])?I(l[h],m[h],u):l[h]=m[h]):l[h]=m[h]}),l):m}e.mixin=I;function S(l,m){if(l===m)return!0;if(l==null||m===null||m===void 0||typeof l!=typeof m||typeof l!="object"||Array.isArray(l)!==Array.isArray(m))return!1;let u,h;if(Array.isArray(l)){if(l.length!==m.length)return!1;for(u=0;u<l.length;u++)if(!S(l[u],m[u]))return!1}else{const f=[];for(h in l)f.push(h);f.sort();const n=[];for(h in m)n.push(h);if(n.sort(),!S(f,n))return!1;for(u=0;u<f.length;u++)if(!S(l[f[u]],m[f[u]]))return!1}return!0}e.equals=S;function C(l){const m=new Set;return JSON.stringify(l,(u,h)=>{if((0,D.isObject)(h)||Array.isArray(h)){if(m.has(h))return"[Circular]";m.add(h)}return h})}e.safeStringify=C;function b(l,m){const u=Object.create(null);return!l||!m||Object.keys(m).forEach(f=>{const n=l[f],s=m[f];S(n,s)||(u[f]=s)}),u}e.distinct=b;function w(l,m){const u=m.toLowerCase(),h=Object.keys(l).find(f=>f.toLowerCase()===u);return h?l[h]:l[m]}e.getCaseInsensitive=w;function y(l,m){const u=Object.create(null);for(const[h,f]of Object.entries(l))m(h,f)&&(u[h]=f);return u}e.filter=y;function d(l){let m=[],u=Object.getPrototypeOf(l);for(;Object.prototype!==u;)m=m.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return m}e.getAllPropertyNames=d;function g(l){const m=[];for(const u of d(l))typeof l[u]=="function"&&m.push(u);return m}e.getAllMethodNames=g;function v(l,m){const u=f=>function(){const n=Array.prototype.slice.call(arguments,0);return m(f,n)},h={};for(const f of l)h[f]=u(f);return h}e.createProxyObject=v}),define(re[31],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function i(R){return D.test(R)}e.isUUID=i,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(P){for(let I=0;I<P.length;I++)P[I]=Math.floor(Math.random()*256);return P};const A=new Uint8Array(16),L=[];for(let P=0;P<256;P++)L.push(P.toString(16).padStart(2,"0"));return function(){R(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let I=0,S="";return S+=L[A[I++]],S+=L[A[I++]],S+=L[A[I++]],S+=L[A[I++]],S+="-",S+=L[A[I++]],S+=L[A[I++]],S+="-",S+=L[A[I++]],S+=L[A[I++]],S+="-",S+=L[A[I++]],S+=L[A[I++]],S+="-",S+=L[A[I++]],S+=L[A[I++]],S+=L[A[I++]],S+=L[A[I++]],S+=L[A[I++]],S+=L[A[I++]],S}}()}),define(re[129],ae([0,1,34]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const i=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(L){const P=L.replace(/\-/g,":").toLowerCase();return!i.has(P)}function A(){const L=(0,D.networkInterfaces)();for(const P in L){const I=L[P];if(I){for(const{mac:S}of I)if(R(S))return S}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=A}),define(re[130],ae([0,1,86]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function i(P,I,S,C=1){let b=!1;return new Promise(w=>{const y=setTimeout(()=>{if(!b)return b=!0,w(0)},S);R(P,I,C,d=>{if(!b)return b=!0,clearTimeout(y),w(d)})})}e.findFreePort=i;function R(P,I,S,C){if(I===0)return C(0);const b=new D.Socket;b.once("connect",()=>(L(b),R(P+S,I-1,S,C))),b.once("data",()=>{}),b.once("error",w=>(L(b),w.code!=="ECONNREFUSED"?R(P+S,I-1,S,C):C(P))),b.connect(P,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(P,I,S,C="127.0.0.1"){let b=!1,w,y=1;const d=D.createServer({pauseOnConnect:!0});function g(v,l){b||(b=!0,d.removeAllListeners(),d.close(),w&&clearTimeout(w),l(v))}return new Promise(v=>{w=setTimeout(()=>{g(0,v)},S),d.on("listening",()=>{g(P,v)}),d.on("error",l=>{l&&(l.code==="EADDRINUSE"||l.code==="EACCES")&&y<I?(P++,y++,d.listen(P,C)):g(0,v)}),d.on("close",()=>{g(0,v)}),d.listen(P,C)})}e.findFreePortFaster=A;function L(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(I){console.error(I)}}}),define(re[131],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OfflineError=e.isOfflineError=void 0;const D="Offline";function i(A){return A instanceof R?!0:A instanceof Error&&A.name===D&&A.message===D}e.isOfflineError=i;class R extends Error{constructor(){super(D),this.name=this.message}}e.OfflineError=R}),define(re[132],ae([0,1,17,9,131]),function(_,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function A(I,S){if(!navigator.onLine)throw new R.OfflineError;I.proxyAuthorization&&(I.headers={...I.headers||{},"Proxy-Authorization":I.proxyAuthorization});const C=new XMLHttpRequest;return new Promise((b,w)=>{C.open(I.type||"GET",I.url||"",!0,I.user,I.password),L(C,I),C.responseType="arraybuffer",C.onerror=y=>w(new Error(C.statusText&&"XHR failed: "+C.statusText||"XHR failed")),C.onload=y=>{b({res:{statusCode:C.status,headers:P(C)},stream:(0,D.bufferToStream)(D.VSBuffer.wrap(new Uint8Array(C.response)))})},C.ontimeout=y=>w(new Error(`XHR timeout: ${I.timeout}ms`)),I.timeout&&(C.timeout=I.timeout),C.send(I.data),S.onCancellationRequested(()=>{C.abort(),w((0,i.canceled)())})})}e.request=A;function L(I,S){if(S.headers){e:for(const C in S.headers){switch(C){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}I.setRequestHeader(C,S.headers[C])}}}function P(I){const S=Object.create(null);for(const C of I.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(C){const b=C.indexOf(":");S[C.substr(0,b).trim().toLowerCase()]=C.substr(b+1).trim()}return S}}),define(re[133],ae([10,11]),function(_,e){return _.create("vs/base/common/date",e)}),define(re[65],ae([0,1,133]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const i=60,R=i*60,A=R*24,L=A*7,P=A*30,I=A*365;function S(b,w,y){typeof b!="number"&&(b=b.getTime());const d=Math.round((new Date().getTime()-b)/1e3);if(d<-30)return(0,D.localize)(0,null,S(new Date().getTime()+d*1e3,!1));if(d<30)return(0,D.localize)(1,null);let g;return d<i?(g=d,w?g===1?y?(0,D.localize)(2,null,g):(0,D.localize)(3,null,g):y?(0,D.localize)(4,null,g):(0,D.localize)(5,null,g):g===1?y?(0,D.localize)(6,null,g):(0,D.localize)(7,null,g):y?(0,D.localize)(8,null,g):(0,D.localize)(9,null,g)):d<R?(g=Math.floor(d/i),w?g===1?y?(0,D.localize)(10,null,g):(0,D.localize)(11,null,g):y?(0,D.localize)(12,null,g):(0,D.localize)(13,null,g):g===1?y?(0,D.localize)(14,null,g):(0,D.localize)(15,null,g):y?(0,D.localize)(16,null,g):(0,D.localize)(17,null,g)):d<A?(g=Math.floor(d/R),w?g===1?y?(0,D.localize)(18,null,g):(0,D.localize)(19,null,g):y?(0,D.localize)(20,null,g):(0,D.localize)(21,null,g):g===1?y?(0,D.localize)(22,null,g):(0,D.localize)(23,null,g):y?(0,D.localize)(24,null,g):(0,D.localize)(25,null,g)):d<L?(g=Math.floor(d/A),w?g===1?(0,D.localize)(26,null,g):(0,D.localize)(27,null,g):g===1?(0,D.localize)(28,null,g):(0,D.localize)(29,null,g)):d<P?(g=Math.floor(d/L),w?g===1?y?(0,D.localize)(30,null,g):(0,D.localize)(31,null,g):y?(0,D.localize)(32,null,g):(0,D.localize)(33,null,g):g===1?y?(0,D.localize)(34,null,g):(0,D.localize)(35,null,g):y?(0,D.localize)(36,null,g):(0,D.localize)(37,null,g)):d<I?(g=Math.floor(d/P),w?g===1?y?(0,D.localize)(38,null,g):(0,D.localize)(39,null,g):y?(0,D.localize)(40,null,g):(0,D.localize)(41,null,g):g===1?y?(0,D.localize)(42,null,g):(0,D.localize)(43,null,g):y?(0,D.localize)(44,null,g):(0,D.localize)(45,null,g)):(g=Math.floor(d/I),w?g===1?y?(0,D.localize)(46,null,g):(0,D.localize)(47,null,g):y?(0,D.localize)(48,null,g):(0,D.localize)(49,null,g):g===1?y?(0,D.localize)(50,null,g):(0,D.localize)(51,null,g):y?(0,D.localize)(52,null,g):(0,D.localize)(53,null,g))}e.fromNow=S;function C(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=C}),define(re[134],ae([10,11]),function(_,e){return _.create("vs/base/common/errorMessage",e)}),define(re[38],ae([0,1,20,15,134]),function(_,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(b,w){return w&&(b.stack||b.stacktrace)?R.localize(0,null,P(b),L(b.stack)||L(b.stacktrace)):P(b)}function L(b){return Array.isArray(b)?b.join(`
`):b}function P(b){return typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?R.localize(1,null,b.message):b.message||R.localize(2,null)}function I(b=null,w=!1){if(!b)return R.localize(3,null);if(Array.isArray(b)){const y=D.coalesce(b),d=I(y[0],w);return y.length>1?R.localize(4,null,d,y.length):d}if(i.isString(b))return b;if(b.detail){const y=b.detail;if(y.error)return A(y.error,w);if(y.exception)return A(y.exception,w)}return b.stack?A(b,w):b.message?b.message:R.localize(5,null)}e.toErrorMessage=I;function S(b){const w=b;return w instanceof Error&&Array.isArray(w.actions)}e.isErrorWithActions=S;function C(b,w){let y;return typeof b=="string"?y=new Error(b):y=b,y.actions=w,y}e.createErrorWithActions=C}),define(re[135],ae([10,11]),function(_,e){return _.create("vs/base/common/jsonErrorMessages",e)}),define(re[136],ae([0,1,135]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function i(R){switch(R){case 1:return(0,D.localize)(0,null);case 2:return(0,D.localize)(1,null);case 3:return(0,D.localize)(2,null);case 4:return(0,D.localize)(3,null);case 5:return(0,D.localize)(4,null);case 6:return(0,D.localize)(5,null);case 7:return(0,D.localize)(6,null);case 8:return(0,D.localize)(7,null);case 9:return(0,D.localize)(8,null);default:return""}}e.getParseErrorMessage=i}),define(re[137],ae([10,11]),function(_,e){return _.create("vs/base/common/platform",e)}),define(re[5],ae([0,1,137]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let i=!1,R=!1,A=!1,L=!1,P=!1,I=!1,S=!1,C=!1,b=!1,w=!1,y,d=e.LANGUAGE_DEFAULT,g,v;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let l;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?l=e.globals.vscode.process:typeof process<"u"&&(l=process);const m=typeof l?.versions?.electron=="string",u=m&&l?.type==="renderer";if(typeof navigator=="object"&&!u)v=navigator.userAgent,i=v.indexOf("Windows")>=0,R=v.indexOf("Macintosh")>=0,C=(v.indexOf("Macintosh")>=0||v.indexOf("iPad")>=0||v.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=v.indexOf("Linux")>=0,w=v?.indexOf("Mobi")>=0,I=!0,y=D.getConfiguredDefaultLocale(D.localize(0,null))||e.LANGUAGE_DEFAULT,d=y;else if(typeof l=="object"){i=l.platform==="win32",R=l.platform==="darwin",A=l.platform==="linux",L=A&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,S=m,b=!!l.env.CI||!!l.env.BUILD_ARTIFACTSTAGINGDIRECTORY,y=e.LANGUAGE_DEFAULT,d=e.LANGUAGE_DEFAULT;const o=l.env.VSCODE_NLS_CONFIG;if(o)try{const p=JSON.parse(o),E=p.availableLanguages["*"];y=p.locale,d=E||e.LANGUAGE_DEFAULT,g=p._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var h;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(h=e.Platform||(e.Platform={}));function f(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=f;let n=0;R?n=1:i?n=3:A&&(n=2),e.isWindows=i,e.isMacintosh=R,e.isLinux=A,e.isLinuxSnap=L,e.isNative=P,e.isElectron=S,e.isWeb=I,e.isWebWorker=I&&typeof e.globals.importScripts=="function",e.isIOS=C,e.isMobile=w,e.isCI=b,e.platform=n,e.userAgent=v,e.language=d;var s;(function(o){function p(){return e.language}o.value=p;function E(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=E;function k(){return e.language==="en"}o.isDefault=k})(s=e.Language||(e.Language={})),e.locale=y,e.translationsConfigFile=g,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const o=[];e.globals.addEventListener("message",E=>{if(E.data&&E.data.vscodeScheduleAsyncWork)for(let k=0,F=o.length;k<F;k++){const N=o[k];if(N.id===E.data.vscodeScheduleAsyncWork){o.splice(k,1),N.callback();return}}});let p=0;return E=>{const k=++p;o.push({id:k,callback:E}),e.globals.postMessage({vscodeScheduleAsyncWork:k},"*")}}return o=>setTimeout(o)})();var t;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(t=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||C?2:i?1:3;let a=!0,r=!1;function c(){if(!r){r=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,a=new Uint16Array(o.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=c,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(re[36],ae([0,1,5]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let i;if(typeof D.globals.vscode<"u"&&typeof D.globals.vscode.process<"u"){const R=D.globals.vscode.process;i={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"?i={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:i={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=i.cwd,e.env=i.env,e.platform=i.platform,e.arch=i.arch}),define(re[12],ae([0,1,36]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const i=65,R=97,A=90,L=122,P=46,I=47,S=92,C=58,b=63;class w extends Error{constructor(h,f,n){let s;typeof f=="string"&&f.indexOf("not ")===0?(s="must not be",f=f.replace(/^not /,"")):s="must be";const t=h.indexOf(".")!==-1?"property":"argument";let a=`The "${h}" ${t} ${s} of type ${f}`;a+=`. Received type ${typeof n}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function y(u,h){if(typeof u!="string")throw new w(h,"string",u)}function d(u){return u===I||u===S}function g(u){return u===I}function v(u){return u>=i&&u<=A||u>=R&&u<=L}function l(u,h,f,n){let s="",t=0,a=-1,r=0,c=0;for(let o=0;o<=u.length;++o){if(o<u.length)c=u.charCodeAt(o);else{if(n(c))break;c=I}if(n(c)){if(!(a===o-1||r===1))if(r===2){if(s.length<2||t!==2||s.charCodeAt(s.length-1)!==P||s.charCodeAt(s.length-2)!==P){if(s.length>2){const p=s.lastIndexOf(f);p===-1?(s="",t=0):(s=s.slice(0,p),t=s.length-1-s.lastIndexOf(f)),a=o,r=0;continue}else if(s.length!==0){s="",t=0,a=o,r=0;continue}}h&&(s+=s.length>0?`${f}..`:"..",t=2)}else s.length>0?s+=`${f}${u.slice(a+1,o)}`:s=u.slice(a+1,o),t=o-a-1;a=o,r=0}else c===P&&r!==-1?++r:r=-1}return s}function m(u,h){if(h===null||typeof h!="object")throw new w("pathObject","Object",h);const f=h.dir||h.root,n=h.base||`${h.name||""}${h.ext||""}`;return f?f===h.root?`${f}${n}`:`${f}${u}${n}`:n}e.win32={resolve(...u){let h="",f="",n=!1;for(let s=u.length-1;s>=-1;s--){let t;if(s>=0){if(t=u[s],y(t,"path"),t.length===0)continue}else h.length===0?t=D.cwd():(t=D.env[`=${h}`]||D.cwd(),(t===void 0||t.slice(0,2).toLowerCase()!==h.toLowerCase()&&t.charCodeAt(2)===S)&&(t=`${h}\\`));const a=t.length;let r=0,c="",o=!1;const p=t.charCodeAt(0);if(a===1)d(p)&&(r=1,o=!0);else if(d(p))if(o=!0,d(t.charCodeAt(1))){let E=2,k=E;for(;E<a&&!d(t.charCodeAt(E));)E++;if(E<a&&E!==k){const F=t.slice(k,E);for(k=E;E<a&&d(t.charCodeAt(E));)E++;if(E<a&&E!==k){for(k=E;E<a&&!d(t.charCodeAt(E));)E++;(E===a||E!==k)&&(c=`\\\\${F}\\${t.slice(k,E)}`,r=E)}}}else r=1;else v(p)&&t.charCodeAt(1)===C&&(c=t.slice(0,2),r=2,a>2&&d(t.charCodeAt(2))&&(o=!0,r=3));if(c.length>0)if(h.length>0){if(c.toLowerCase()!==h.toLowerCase())continue}else h=c;if(n){if(h.length>0)break}else if(f=`${t.slice(r)}\\${f}`,n=o,o&&h.length>0)break}return f=l(f,!n,"\\",d),n?`${h}\\${f}`:`${h}${f}`||"."},normalize(u){y(u,"path");const h=u.length;if(h===0)return".";let f=0,n,s=!1;const t=u.charCodeAt(0);if(h===1)return g(t)?"\\":u;if(d(t))if(s=!0,d(u.charCodeAt(1))){let r=2,c=r;for(;r<h&&!d(u.charCodeAt(r));)r++;if(r<h&&r!==c){const o=u.slice(c,r);for(c=r;r<h&&d(u.charCodeAt(r));)r++;if(r<h&&r!==c){for(c=r;r<h&&!d(u.charCodeAt(r));)r++;if(r===h)return`\\\\${o}\\${u.slice(c)}\\`;r!==c&&(n=`\\\\${o}\\${u.slice(c,r)}`,f=r)}}}else f=1;else v(t)&&u.charCodeAt(1)===C&&(n=u.slice(0,2),f=2,h>2&&d(u.charCodeAt(2))&&(s=!0,f=3));let a=f<h?l(u.slice(f),!s,"\\",d):"";return a.length===0&&!s&&(a="."),a.length>0&&d(u.charCodeAt(h-1))&&(a+="\\"),n===void 0?s?`\\${a}`:a:s?`${n}\\${a}`:`${n}${a}`},isAbsolute(u){y(u,"path");const h=u.length;if(h===0)return!1;const f=u.charCodeAt(0);return d(f)||h>2&&v(f)&&u.charCodeAt(1)===C&&d(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let h,f;for(let t=0;t<u.length;++t){const a=u[t];y(a,"path"),a.length>0&&(h===void 0?h=f=a:h+=`\\${a}`)}if(h===void 0)return".";let n=!0,s=0;if(typeof f=="string"&&d(f.charCodeAt(0))){++s;const t=f.length;t>1&&d(f.charCodeAt(1))&&(++s,t>2&&(d(f.charCodeAt(2))?++s:n=!1))}if(n){for(;s<h.length&&d(h.charCodeAt(s));)s++;s>=2&&(h=`\\${h.slice(s)}`)}return e.win32.normalize(h)},relative(u,h){if(y(u,"from"),y(h,"to"),u===h)return"";const f=e.win32.resolve(u),n=e.win32.resolve(h);if(f===n||(u=f.toLowerCase(),h=n.toLowerCase(),u===h))return"";let s=0;for(;s<u.length&&u.charCodeAt(s)===S;)s++;let t=u.length;for(;t-1>s&&u.charCodeAt(t-1)===S;)t--;const a=t-s;let r=0;for(;r<h.length&&h.charCodeAt(r)===S;)r++;let c=h.length;for(;c-1>r&&h.charCodeAt(c-1)===S;)c--;const o=c-r,p=a<o?a:o;let E=-1,k=0;for(;k<p;k++){const N=u.charCodeAt(s+k);if(N!==h.charCodeAt(r+k))break;N===S&&(E=k)}if(k!==p){if(E===-1)return n}else{if(o>p){if(h.charCodeAt(r+k)===S)return n.slice(r+k+1);if(k===2)return n.slice(r+k)}a>p&&(u.charCodeAt(s+k)===S?E=k:k===2&&(E=3)),E===-1&&(E=0)}let F="";for(k=s+E+1;k<=t;++k)(k===t||u.charCodeAt(k)===S)&&(F+=F.length===0?"..":"\\..");return r+=E,F.length>0?`${F}${n.slice(r,c)}`:(n.charCodeAt(r)===S&&++r,n.slice(r,c))},toNamespacedPath(u){if(typeof u!="string")return u;if(u.length===0)return"";const h=e.win32.resolve(u);if(h.length<=2)return u;if(h.charCodeAt(0)===S){if(h.charCodeAt(1)===S){const f=h.charCodeAt(2);if(f!==b&&f!==P)return`\\\\?\\UNC\\${h.slice(2)}`}}else if(v(h.charCodeAt(0))&&h.charCodeAt(1)===C&&h.charCodeAt(2)===S)return`\\\\?\\${h}`;return u},dirname(u){y(u,"path");const h=u.length;if(h===0)return".";let f=-1,n=0;const s=u.charCodeAt(0);if(h===1)return d(s)?u:".";if(d(s)){if(f=n=1,d(u.charCodeAt(1))){let r=2,c=r;for(;r<h&&!d(u.charCodeAt(r));)r++;if(r<h&&r!==c){for(c=r;r<h&&d(u.charCodeAt(r));)r++;if(r<h&&r!==c){for(c=r;r<h&&!d(u.charCodeAt(r));)r++;if(r===h)return u;r!==c&&(f=n=r+1)}}}}else v(s)&&u.charCodeAt(1)===C&&(f=h>2&&d(u.charCodeAt(2))?3:2,n=f);let t=-1,a=!0;for(let r=h-1;r>=n;--r)if(d(u.charCodeAt(r))){if(!a){t=r;break}}else a=!1;if(t===-1){if(f===-1)return".";t=f}return u.slice(0,t)},basename(u,h){h!==void 0&&y(h,"ext"),y(u,"path");let f=0,n=-1,s=!0,t;if(u.length>=2&&v(u.charCodeAt(0))&&u.charCodeAt(1)===C&&(f=2),h!==void 0&&h.length>0&&h.length<=u.length){if(h===u)return"";let a=h.length-1,r=-1;for(t=u.length-1;t>=f;--t){const c=u.charCodeAt(t);if(d(c)){if(!s){f=t+1;break}}else r===-1&&(s=!1,r=t+1),a>=0&&(c===h.charCodeAt(a)?--a===-1&&(n=t):(a=-1,n=r))}return f===n?n=r:n===-1&&(n=u.length),u.slice(f,n)}for(t=u.length-1;t>=f;--t)if(d(u.charCodeAt(t))){if(!s){f=t+1;break}}else n===-1&&(s=!1,n=t+1);return n===-1?"":u.slice(f,n)},extname(u){y(u,"path");let h=0,f=-1,n=0,s=-1,t=!0,a=0;u.length>=2&&u.charCodeAt(1)===C&&v(u.charCodeAt(0))&&(h=n=2);for(let r=u.length-1;r>=h;--r){const c=u.charCodeAt(r);if(d(c)){if(!t){n=r+1;break}continue}s===-1&&(t=!1,s=r+1),c===P?f===-1?f=r:a!==1&&(a=1):f!==-1&&(a=-1)}return f===-1||s===-1||a===0||a===1&&f===s-1&&f===n+1?"":u.slice(f,s)},format:m.bind(null,"\\"),parse(u){y(u,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return h;const f=u.length;let n=0,s=u.charCodeAt(0);if(f===1)return d(s)?(h.root=h.dir=u,h):(h.base=h.name=u,h);if(d(s)){if(n=1,d(u.charCodeAt(1))){let E=2,k=E;for(;E<f&&!d(u.charCodeAt(E));)E++;if(E<f&&E!==k){for(k=E;E<f&&d(u.charCodeAt(E));)E++;if(E<f&&E!==k){for(k=E;E<f&&!d(u.charCodeAt(E));)E++;E===f?n=E:E!==k&&(n=E+1)}}}}else if(v(s)&&u.charCodeAt(1)===C){if(f<=2)return h.root=h.dir=u,h;if(n=2,d(u.charCodeAt(2))){if(f===3)return h.root=h.dir=u,h;n=3}}n>0&&(h.root=u.slice(0,n));let t=-1,a=n,r=-1,c=!0,o=u.length-1,p=0;for(;o>=n;--o){if(s=u.charCodeAt(o),d(s)){if(!c){a=o+1;break}continue}r===-1&&(c=!1,r=o+1),s===P?t===-1?t=o:p!==1&&(p=1):t!==-1&&(p=-1)}return r!==-1&&(t===-1||p===0||p===1&&t===r-1&&t===a+1?h.base=h.name=u.slice(a,r):(h.name=u.slice(a,t),h.base=u.slice(a,r),h.ext=u.slice(t,r))),a>0&&a!==n?h.dir=u.slice(0,a-1):h.dir=h.root,h},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...u){let h="",f=!1;for(let n=u.length-1;n>=-1&&!f;n--){const s=n>=0?u[n]:D.cwd();y(s,"path"),s.length!==0&&(h=`${s}/${h}`,f=s.charCodeAt(0)===I)}return h=l(h,!f,"/",g),f?`/${h}`:h.length>0?h:"."},normalize(u){if(y(u,"path"),u.length===0)return".";const h=u.charCodeAt(0)===I,f=u.charCodeAt(u.length-1)===I;return u=l(u,!h,"/",g),u.length===0?h?"/":f?"./":".":(f&&(u+="/"),h?`/${u}`:u)},isAbsolute(u){return y(u,"path"),u.length>0&&u.charCodeAt(0)===I},join(...u){if(u.length===0)return".";let h;for(let f=0;f<u.length;++f){const n=u[f];y(n,"path"),n.length>0&&(h===void 0?h=n:h+=`/${n}`)}return h===void 0?".":e.posix.normalize(h)},relative(u,h){if(y(u,"from"),y(h,"to"),u===h||(u=e.posix.resolve(u),h=e.posix.resolve(h),u===h))return"";const f=1,n=u.length,s=n-f,t=1,a=h.length-t,r=s<a?s:a;let c=-1,o=0;for(;o<r;o++){const E=u.charCodeAt(f+o);if(E!==h.charCodeAt(t+o))break;E===I&&(c=o)}if(o===r)if(a>r){if(h.charCodeAt(t+o)===I)return h.slice(t+o+1);if(o===0)return h.slice(t+o)}else s>r&&(u.charCodeAt(f+o)===I?c=o:o===0&&(c=0));let p="";for(o=f+c+1;o<=n;++o)(o===n||u.charCodeAt(o)===I)&&(p+=p.length===0?"..":"/..");return`${p}${h.slice(t+c)}`},toNamespacedPath(u){return u},dirname(u){if(y(u,"path"),u.length===0)return".";const h=u.charCodeAt(0)===I;let f=-1,n=!0;for(let s=u.length-1;s>=1;--s)if(u.charCodeAt(s)===I){if(!n){f=s;break}}else n=!1;return f===-1?h?"/":".":h&&f===1?"//":u.slice(0,f)},basename(u,h){h!==void 0&&y(h,"ext"),y(u,"path");let f=0,n=-1,s=!0,t;if(h!==void 0&&h.length>0&&h.length<=u.length){if(h===u)return"";let a=h.length-1,r=-1;for(t=u.length-1;t>=0;--t){const c=u.charCodeAt(t);if(c===I){if(!s){f=t+1;break}}else r===-1&&(s=!1,r=t+1),a>=0&&(c===h.charCodeAt(a)?--a===-1&&(n=t):(a=-1,n=r))}return f===n?n=r:n===-1&&(n=u.length),u.slice(f,n)}for(t=u.length-1;t>=0;--t)if(u.charCodeAt(t)===I){if(!s){f=t+1;break}}else n===-1&&(s=!1,n=t+1);return n===-1?"":u.slice(f,n)},extname(u){y(u,"path");let h=-1,f=0,n=-1,s=!0,t=0;for(let a=u.length-1;a>=0;--a){const r=u.charCodeAt(a);if(r===I){if(!s){f=a+1;break}continue}n===-1&&(s=!1,n=a+1),r===P?h===-1?h=a:t!==1&&(t=1):h!==-1&&(t=-1)}return h===-1||n===-1||t===0||t===1&&h===n-1&&h===f+1?"":u.slice(h,n)},format:m.bind(null,"/"),parse(u){y(u,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return h;const f=u.charCodeAt(0)===I;let n;f?(h.root="/",n=1):n=0;let s=-1,t=0,a=-1,r=!0,c=u.length-1,o=0;for(;c>=n;--c){const p=u.charCodeAt(c);if(p===I){if(!r){t=c+1;break}continue}a===-1&&(r=!1,a=c+1),p===P?s===-1?s=c:o!==1&&(o=1):s!==-1&&(o=-1)}if(a!==-1){const p=t===0&&f?1:t;s===-1||o===0||o===1&&s===a-1&&s===t+1?h.base=h.name=u.slice(p,a):(h.name=u.slice(p,s),h.base=u.slice(p,a),h.ext=u.slice(s,a))}return t>0?h.dir=u.slice(0,t-1):f&&(h.dir="/"),h},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=D.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=D.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=D.platform==="win32"?e.win32.join:e.posix.join,e.resolve=D.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=D.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=D.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=D.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=D.platform==="win32"?e.win32.extname:e.posix.extname,e.format=D.platform==="win32"?e.win32.format:e.posix.format,e.parse=D.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=D.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=D.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=D.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(re[138],ae([0,1,12]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const i={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},R={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(C){const b=(0,D.extname)(C),w=i[b.toLowerCase()];return w!==void 0?w:L(C)}e.getMediaOrTextMime=A;function L(C){const b=(0,D.extname)(C);return R[b.toLowerCase()]}e.getMediaMime=L;function P(C){for(const b in R)if(R[b]===C)return b}e.getExtensionForMimeType=P;const I=/^(.+)\/(.+?)(;.+)?$/;function S(C,b){const w=I.exec(C);return w?`${w[1].toLowerCase()}/${w[2].toLowerCase()}${w[3]??""}`:b?void 0:C}e.normalizeMimeType=S}),define(re[87],ae([0,1,5]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var i;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(i=e.Source||(e.Source={}));var R;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(R=e.TerminateResponseCode||(e.TerminateResponseCode={}));function A(P,...I){const S=I.reduce((w,y)=>(w[y]=!0,w),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(w=>!S[w]).forEach(w=>{for(let y=0;y<C.length;y++)if(w.search(C[y])!==-1){delete P[w];break}})}e.sanitizeProcessEnvironment=A;function L(P){!P||(delete P.DEBUG,D.isMacintosh&&delete P.DYLD_LIBRARY_PATH,D.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=L}),define(re[139],ae([0,1,5]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const i=D.globals.performance&&typeof D.globals.performance.now=="function";class R{static create(L=!0){return new R(L)}constructor(L){this.a=i&&L,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?D.globals.performance.now():Date.now()}}e.StopWatch=R}),define(re[3],ae([0,1,9,82,2,84,139]),function(_,e,D,i,R,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const P=!1,I=!1;var S;(function(c){c.None=()=>R.Disposable.None;function o(W){if(I){const{onDidAddListener:X}=W,se=d.create();let x=0;W.onDidAddListener=()=>{++x===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),se.print()),X?.()}}}function p(W,X){return $(W,()=>{},0,void 0,void 0,X)}c.defer=p;function E(W){return(X,se=null,x)=>{let ie=!1,ne;return ne=W(le=>{if(!ie)return ne?ne.dispose():ie=!0,X.call(se,le)},null,x),ie&&ne.dispose(),ne}}c.once=E;function k(W,X,se){return U((x,ie=null,ne)=>W(le=>x.call(ie,X(le)),null,ne),se)}c.map=k;function F(W,X,se){return U((x,ie=null,ne)=>W(le=>{X(le),x.call(ie,le)},null,ne),se)}c.forEach=F;function N(W,X,se){return U((x,ie=null,ne)=>W(le=>X(le)&&x.call(ie,le),null,ne),se)}c.filter=N;function q(W){return W}c.signal=q;function j(...W){return(X,se=null,x)=>(0,R.combinedDisposable)(...W.map(ie=>ie(ne=>X.call(se,ne),null,x)))}c.any=j;function O(W,X,se,x){let ie=se;return k(W,ne=>(ie=X(ie,ne),ie),x)}c.reduce=O;function U(W,X){let se;const x={onWillAddFirstListener(){se=W(ie.fire,ie)},onDidRemoveLastListener(){se?.dispose()}};X||o(x);const ie=new v(x);return X?.add(ie),ie.event}function $(W,X,se=100,x=!1,ie,ne){let le,ue,pe,Se=0;const be={leakWarningThreshold:ie,onWillAddFirstListener(){le=W(Ne=>{Se++,ue=X(ue,Ne),x&&!pe&&(Ee.fire(ue),ue=void 0),clearTimeout(pe),pe=setTimeout(()=>{const Fe=ue;ue=void 0,pe=void 0,(!x||Se>1)&&Ee.fire(Fe),Se=0},se)})},onDidRemoveLastListener(){le.dispose()}};ne||o(be);const Ee=new v(be);return ne?.add(Ee),Ee.event}c.debounce=$;function G(W,X=0,se){return c.debounce(W,(x,ie)=>x?(x.push(ie),x):[ie],X,void 0,void 0,se)}c.accumulate=G;function H(W,X=(x,ie)=>x===ie,se){let x=!0,ie;return N(W,ne=>{const le=x||!X(ne,ie);return x=!1,ie=ne,le},se)}c.latch=H;function Z(W,X,se){return[c.filter(W,X,se),c.filter(W,x=>!X(x),se)]}c.split=Z;function z(W,X=!1,se=[]){let x=se.slice(),ie=W(ue=>{x?x.push(ue):le.fire(ue)});const ne=()=>{x?.forEach(ue=>le.fire(ue)),x=null},le=new v({onWillAddFirstListener(){ie||(ie=W(ue=>le.fire(ue)))},onDidAddFirstListener(){x&&(X?setTimeout(ne):ne())},onDidRemoveLastListener(){ie&&ie.dispose(),ie=null}});return le.event}c.buffer=z;class B{constructor(X){this.event=X,this.c=new R.DisposableStore}map(X){return new B(k(this.event,X,this.c))}forEach(X){return new B(F(this.event,X,this.c))}filter(X){return new B(N(this.event,X,this.c))}reduce(X,se){return new B(O(this.event,X,se,this.c))}latch(){return new B(H(this.event,void 0,this.c))}debounce(X,se=100,x=!1,ie){return new B($(this.event,X,se,x,ie,this.c))}on(X,se,x){return this.event(X,se,x)}once(X,se,x){return E(this.event)(X,se,x)}dispose(){this.c.dispose()}}function Y(W){return new B(W)}c.chain=Y;function ee(W,X,se=x=>x){const x=(...ue)=>le.fire(se(...ue)),ie=()=>W.on(X,x),ne=()=>W.removeListener(X,x),le=new v({onWillAddFirstListener:ie,onDidRemoveLastListener:ne});return le.event}c.fromNodeEventEmitter=ee;function oe(W,X,se=x=>x){const x=(...ue)=>le.fire(se(...ue)),ie=()=>W.addEventListener(X,x),ne=()=>W.removeEventListener(X,x),le=new v({onWillAddFirstListener:ie,onDidRemoveLastListener:ne});return le.event}c.fromDOMEventEmitter=oe;function J(W){return new Promise(X=>E(W)(X))}c.toPromise=J;function Q(W,X){return X(void 0),W(se=>X(se))}c.runAndSubscribe=Q;function T(W,X){let se=null;function x(ne){se?.dispose(),se=new R.DisposableStore,X(ne,se)}x(void 0);const ie=W(ne=>x(ne));return(0,R.toDisposable)(()=>{ie.dispose(),se?.dispose()})}c.runAndSubscribeWithStore=T;class M{constructor(X,se){this.obs=X,this.c=0,this.d=!1;const x={onWillAddFirstListener:()=>{X.addObserver(this)},onDidRemoveLastListener:()=>{X.removeObserver(this)}};se||o(x),this.emitter=new v(x),se&&se.add(this.emitter)}beginUpdate(X){this.c++}handleChange(X,se){this.d=!0}endUpdate(X){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function V(W,X){return new M(W,X).emitter.event}c.fromObservable=V})(S=e.Event||(e.Event={}));class C{constructor(o){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${o}_${C.c++}`,C.all.add(this)}start(o){this.d=new L.StopWatch(!0),this.listenerCount=o}stop(){if(this.d){const o=this.d.elapsed();this.durations.push(o),this.elapsedOverall+=o,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=C,C.all=new Set,C.c=0;let b=-1;function w(c){const o=b;return b=c,{dispose(){b=o}}}e.setGlobalLeakWarningThreshold=w;class y{constructor(o,p=Math.random().toString(18).slice(2,5)){this.threshold=o,this.name=p,this.d=0}dispose(){this.c?.clear()}check(o,p){const E=this.threshold;if(E<=0||p<E)return;this.c||(this.c=new Map);const k=this.c.get(o.value)||0;if(this.c.set(o.value,k+1),this.d-=1,this.d<=0){this.d=E*.5;let F,N=0;for(const[q,j]of this.c)(!F||N<j)&&(F=q,N=j);console.warn(`[${this.name}] potential listener LEAK detected, having ${p} listeners already. MOST frequent listener (${N}):`),console.warn(F)}return()=>{const F=this.c.get(o.value)||0;this.c.set(o.value,F-1)}}}class d{static create(){return new d(new Error().stack??"")}constructor(o){this.value=o}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class g{constructor(o,p,E){this.callback=o,this.callbackThis=p,this.stack=E,this.subscription=new R.SafeDisposable}invoke(o){this.callback.call(this.callbackThis,o)}}class v{constructor(o){this.j=!1,this.d=o,this.f=b>0||this.d?.leakWarningThreshold?new y(this.d?.leakWarningThreshold??b):void 0,this.g=this.d?._profName?new C(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(P){const o=Array.from(this.q);queueMicrotask(()=>{for(const p of o)p.subscription.isset()&&(p.subscription.unset(),p.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(o,p,E)=>{if(this.q||(this.q=new A.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),R.Disposable.None;const k=this.q.isEmpty();k&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let F,N;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(N=d.create(),F=this.f.check(N,this.q.size+1)),P&&(N=N??d.create());const q=new g(o,p,N),j=this.q.push(q);k&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,o,p);const O=q.subscription.set(()=>{F?.(),this.j||(j(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return E instanceof R.DisposableStore?E.add(O):Array.isArray(E)&&E.push(O),O}),this.l}fire(o){if(this.q){this.m||(this.m=new m);for(const p of this.q)this.m.push(this,p,o);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=v;class l{constructor(){this.c=new A.LinkedList}get size(){return this.c.size}push(o,p,E){this.c.push(new u(o,p,E))}clear(o){const p=new A.LinkedList;for(const E of this.c)E.emitter!==o&&p.push(E);this.c=p}deliver(){for(;this.c.size>0;){const o=this.c.shift();try{o.listener.invoke(o.event)}catch(p){(0,D.onUnexpectedError)(p)}}}}e.EventDeliveryQueue=l;class m extends l{clear(o){this.c.clear()}}class u{constructor(o,p,E){this.emitter=o,this.listener=p,this.event=E}}class h extends v{async fireAsync(o,p,E){if(!!this.q){this.c||(this.c=new A.LinkedList);for(const k of this.q)this.c.push([k,o]);for(;this.c.size>0&&!p.isCancellationRequested;){const[k,F]=this.c.shift(),N=[],q={...F,token:p,waitUntil:j=>{if(Object.isFrozen(N))throw new Error("waitUntil can NOT be called asynchronous");E&&(j=E(j,k.callback)),N.push(j)}};try{k.invoke(q)}catch(j){(0,D.onUnexpectedError)(j);continue}Object.freeze(N),await Promise.allSettled(N).then(j=>{for(const O of j)O.status==="rejected"&&(0,D.onUnexpectedError)(O.reason)})}}}}e.AsyncEmitter=h;class f extends v{constructor(o){super(o),this.h=0,this.s=new A.LinkedList,this.t=o?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const o=Array.from(this.s);this.s.clear(),super.fire(this.t(o))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(o){this.q&&(this.h!==0?this.s.push(o):super.fire(o))}}e.PauseableEmitter=f;class n extends f{constructor(o){super(o),this.c=o.delay??100}fire(o){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(o)}}e.DebounceEmitter=n;class s extends v{constructor(o){super(o),this.c=[],this.h=o?.merge}fire(o){!this.hasListeners()||(this.c.push(o),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(p=>super.fire(p)),this.c=[]}))}}e.MicrotaskEmitter=s;class t{constructor(){this.d=!1,this.f=[],this.c=new v({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(o){const p={event:o,listener:null};this.f.push(p),this.d&&this.j(p);const E=()=>{this.d&&this.k(p);const k=this.f.indexOf(p);this.f.splice(k,1)};return(0,R.toDisposable)((0,i.once)(E))}g(){this.d=!0,this.f.forEach(o=>this.j(o))}h(){this.d=!1,this.f.forEach(o=>this.k(o))}j(o){o.listener=o.event(p=>this.c.fire(p))}k(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=t;class a{constructor(){this.c=[]}wrapEvent(o){return(p,E,k)=>o(F=>{const N=this.c[this.c.length-1];N?N.push(()=>p.call(E,F)):p.call(E,F)},void 0,k)}bufferEvents(o){const p=[];this.c.push(p);const E=o();return this.c.pop(),p.forEach(k=>k()),E}}e.EventBufferer=a;class r{constructor(){this.c=!1,this.d=S.None,this.f=R.Disposable.None,this.g=new v({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(o){this.d=o,this.c&&(this.f.dispose(),this.f=o(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=r}),define(re[23],ae([0,1,3]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const i=Object.freeze(function(P,I){const S=setTimeout(P.bind(I),0);return{dispose(){clearTimeout(S)}}});var R;(function(P){function I(S){return S===P.None||S===P.Cancelled||S instanceof A?!0:!S||typeof S!="object"?!1:typeof S.isCancellationRequested=="boolean"&&typeof S.onCancellationRequested=="function"}P.isCancellationToken=I,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})})(R=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?i:(this.b||(this.b=new D.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class L{constructor(I){this.a=void 0,this.b=void 0,this.b=I&&I.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new A),this.a}cancel(){this.a?this.a instanceof A&&this.a.cancel():this.a=R.Cancelled}dispose(I=!1){I&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof A&&this.a.dispose():this.a=R.None}}e.CancellationTokenSource=L}),define(re[140],ae([0,1,23]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class i{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new D.CancellationTokenSource,I=this.b(P.token);return this.a={promise:I,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.Cache=i;class R{constructor(P){this.c=P,this.a=void 0,this.b=void 0}get(P){const I=JSON.stringify(P);return this.b!==I&&(this.b=I,this.a=this.c(P)),this.a}}e.LRUCachedFunction=R;class A{get cachedValues(){return this.a}constructor(P){this.b=P,this.a=new Map}get(P){if(this.a.has(P))return this.a.get(P);const I=this.b(P);return this.a.set(P,I),I}}e.CachedFunction=A}),define(re[27],ae([0,1,140,127]),function(_,e,D,i){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function A(te){return!te||typeof te!="string"?!0:te.trim().length===0}e.isFalsyOrWhitespace=A;const L=/{(\d+)}/g;function P(te,...he){return he.length===0?te:te.replace(L,function(fe,me){const we=parseInt(me,10);return isNaN(we)||we<0||we>=he.length?fe:he[we]})}e.format=P;const I=/{([^}]+)}/g;function S(te,he){return te.replace(I,(fe,me)=>he[me]??fe)}e.format2=S;function C(te){return te.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}e.escape=C;function b(te){return te.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=b;function w(te,he){let fe=0;const me=he.charCodeAt(0);for(let we=te.length-1;we>=0;we--)te.charCodeAt(we)===me&&fe++;return fe}e.count=w;function y(te,he,fe="\u2026"){return te.length<=he?te:`${te.substr(0,he)}${fe}`}e.truncate=y;function d(te,he=" "){const fe=g(te,he);return v(fe,he)}e.trim=d;function g(te,he){if(!te||!he)return te;const fe=he.length;if(fe===0||te.length===0)return te;let me=0;for(;te.indexOf(he,me)===me;)me=me+fe;return te.substring(me)}e.ltrim=g;function v(te,he){if(!te||!he)return te;const fe=he.length,me=te.length;if(fe===0||me===0)return te;let we=me,Ie=-1;for(;Ie=te.lastIndexOf(he,we-1),!(Ie===-1||Ie+fe!==we);){if(Ie===0)return"";we=Ie}return te.substring(0,we)}e.rtrim=v;function l(te){return te.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=l;function m(te){return te.replace(/\*/g,"")}e.stripWildcards=m;function u(te,he,fe={}){if(!te)throw new Error("Cannot create regex from empty string");he||(te=b(te)),fe.wholeWord&&(/\B/.test(te.charAt(0))||(te="\\b"+te),/\B/.test(te.charAt(te.length-1))||(te=te+"\\b"));let me="";return fe.global&&(me+="g"),fe.matchCase||(me+="i"),fe.multiline&&(me+="m"),fe.unicode&&(me+="u"),new RegExp(te,me)}e.createRegExp=u;function h(te){return te.source==="^"||te.source==="^$"||te.source==="$"||te.source==="^\\s*$"?!1:!!(te.exec("")&&te.lastIndex===0)}e.regExpLeadsToEndlessLoop=h;function f(te){return!!te.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=f;function n(te){return(te.global?"g":"")+(te.ignoreCase?"i":"")+(te.multiline?"m":"")+(te.unicode?"u":"")}e.regExpFlags=n;function s(te){return te.split(/\r\n|\r|\n/)}e.splitLines=s;function t(te){for(let he=0,fe=te.length;he<fe;he++){const me=te.charCodeAt(he);if(me!==32&&me!==9)return he}return-1}e.firstNonWhitespaceIndex=t;function a(te,he=0,fe=te.length){for(let me=he;me<fe;me++){const we=te.charCodeAt(me);if(we!==32&&we!==9)return te.substring(he,me)}return te.substring(he,fe)}e.getLeadingWhitespace=a;function r(te,he=te.length-1){for(let fe=he;fe>=0;fe--){const me=te.charCodeAt(fe);if(me!==32&&me!==9)return fe}return-1}e.lastNonWhitespaceIndex=r;function c(te,he,fe){const me=[];let we=0;for(const Ie of te.matchAll(he)){if(me.push(te.slice(we,Ie.index)),Ie.index===void 0)throw new Error("match.index should be defined");we=Ie.index+Ie[0].length,me.push(fe(Ie[0],...Ie.slice(1),Ie.index,te,Ie.groups))}return me.push(te.slice(we)),Promise.all(me).then(Ie=>Ie.join(""))}e.replaceAsync=c;function o(te,he){return te<he?-1:te>he?1:0}e.compare=o;function p(te,he,fe=0,me=te.length,we=0,Ie=he.length){for(;fe<me&&we<Ie;fe++,we++){const $e=te.charCodeAt(fe),Le=he.charCodeAt(we);if($e<Le)return-1;if($e>Le)return 1}const Re=me-fe,He=Ie-we;return Re<He?-1:Re>He?1:0}e.compareSubstring=p;function E(te,he){return k(te,he,0,te.length,0,he.length)}e.compareIgnoreCase=E;function k(te,he,fe=0,me=te.length,we=0,Ie=he.length){for(;fe<me&&we<Ie;fe++,we++){let $e=te.charCodeAt(fe),Le=he.charCodeAt(we);if($e===Le)continue;if($e>=128||Le>=128)return p(te.toLowerCase(),he.toLowerCase(),fe,me,we,Ie);N($e)&&($e-=32),N(Le)&&(Le-=32);const qe=$e-Le;if(qe!==0)return qe}const Re=me-fe,He=Ie-we;return Re<He?-1:Re>He?1:0}e.compareSubstringIgnoreCase=k;function F(te){return te>=48&&te<=57}e.isAsciiDigit=F;function N(te){return te>=97&&te<=122}e.isLowerAsciiLetter=N;function q(te){return te>=65&&te<=90}e.isUpperAsciiLetter=q;function j(te,he){return te.length===he.length&&k(te,he)===0}e.equalsIgnoreCase=j;function O(te,he){const fe=he.length;return he.length>te.length?!1:k(te,he,0,fe)===0}e.startsWithIgnoreCase=O;function U(te,he){const fe=Math.min(te.length,he.length);let me;for(me=0;me<fe;me++)if(te.charCodeAt(me)!==he.charCodeAt(me))return me;return fe}e.commonPrefixLength=U;function $(te,he){const fe=Math.min(te.length,he.length);let me;const we=te.length-1,Ie=he.length-1;for(me=0;me<fe;me++)if(te.charCodeAt(we-me)!==he.charCodeAt(Ie-me))return me;return fe}e.commonSuffixLength=$;function G(te){return 55296<=te&&te<=56319}e.isHighSurrogate=G;function H(te){return 56320<=te&&te<=57343}e.isLowSurrogate=H;function Z(te,he){return(te-55296<<10)+(he-56320)+65536}e.computeCodePoint=Z;function z(te,he,fe){const me=te.charCodeAt(fe);if(G(me)&&fe+1<he){const we=te.charCodeAt(fe+1);if(H(we))return Z(me,we)}return me}e.getNextCodePoint=z;function B(te,he){const fe=te.charCodeAt(he-1);if(H(fe)&&he>1){const me=te.charCodeAt(he-2);if(G(me))return Z(me,fe)}return fe}class Y{get offset(){return this.e}constructor(he,fe=0){this.c=he,this.d=he.length,this.e=fe}setOffset(he){this.e=he}prevCodePoint(){const he=B(this.c,this.e);return this.e-=he>=65536?2:1,he}nextCodePoint(){const he=z(this.c,this.d,this.e);return this.e+=he>=65536?2:1,he}eol(){return this.e>=this.d}}e.CodePointIterator=Y;class ee{get offset(){return this.c.offset}constructor(he,fe=0){this.c=new Y(he,fe)}nextGraphemeLength(){const he=Ae.getInstance(),fe=this.c,me=fe.offset;let we=he.getGraphemeBreakType(fe.nextCodePoint());for(;!fe.eol();){const Ie=fe.offset,Re=he.getGraphemeBreakType(fe.nextCodePoint());if(Ce(we,Re)){fe.setOffset(Ie);break}we=Re}return fe.offset-me}prevGraphemeLength(){const he=Ae.getInstance(),fe=this.c,me=fe.offset;let we=he.getGraphemeBreakType(fe.prevCodePoint());for(;fe.offset>0;){const Ie=fe.offset,Re=he.getGraphemeBreakType(fe.prevCodePoint());if(Ce(Re,we)){fe.setOffset(Ie);break}we=Re}return me-fe.offset}eol(){return this.c.eol()}}e.GraphemeIterator=ee;function oe(te,he){return new ee(te,he).nextGraphemeLength()}e.nextCharLength=oe;function J(te,he){return new ee(te,he).prevGraphemeLength()}e.prevCharLength=J;function Q(te,he){he>0&&H(te.charCodeAt(he))&&he--;const fe=he+oe(te,he);return[fe-J(te,fe),fe]}e.getCharContainingOffset=Q;function T(te){const he=new ee(te);let fe=0;for(;!he.eol();)fe++,he.nextGraphemeLength();return fe}e.charCount=T;let M;function V(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function W(te){return M||(M=V()),M.test(te)}e.containsRTL=W;const X=/^[\t\n\r\x20-\x7E]*$/;function se(te){return X.test(te)}e.isBasicASCII=se,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function x(te){return e.UNUSUAL_LINE_TERMINATORS.test(te)}e.containsUnusualLineTerminators=x;function ie(te){return te>=11904&&te<=55215||te>=63744&&te<=64255||te>=65281&&te<=65374}e.isFullWidthCharacter=ie;function ne(te){return te>=127462&&te<=127487||te===8986||te===8987||te===9200||te===9203||te>=9728&&te<=10175||te===11088||te===11093||te>=127744&&te<=128591||te>=128640&&te<=128764||te>=128992&&te<=129008||te>=129280&&te<=129535||te>=129648&&te<=129782}e.isEmojiImprecise=ne;function le(te,he){if(te.length<he)return te;const fe=/\b/g;let me=0;for(;fe.test(te)&&!(te.length-fe.lastIndex<he);)me=fe.lastIndex,fe.lastIndex+=1;return te.substring(me).replace(/^\s/,"")}e.lcut=le;const ue=/\x1B\x5B[12]?K/g,pe=/\x1b\[\d+m/g,Se=/\x1b\[0?m/g;function be(te){return te&&(te=te.replace(ue,""),te=te.replace(pe,""),te=te.replace(Se,"")),te}e.removeAnsiEscapeCodes=be,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ee(te){return!!(te&&te.length>0&&te.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ee;function Ne(te){return Ee(te)?te.substr(1):te}e.stripUTF8BOM=Ne;function Fe(te,he){if(!te||!he||te.length<he.length)return!1;const fe=he.length,me=te.toLowerCase();let we=0,Ie=-1;for(;we<fe;){const Re=me.indexOf(he[we],Ie+1);if(Re<0)return!1;Ie=Re,we++}return!0}e.fuzzyContains=Fe;function Ye(te,he=!1){return te?(he&&(te=te.replace(/\\./g,"")),te.toLowerCase()!==te):!1}e.containsUppercaseCharacter=Ye;function ze(te){return te.charAt(0).toUpperCase()+te.slice(1)}e.uppercaseFirstLetter=ze;function ce(te,he=1){if(he===0)return"";let fe=-1;do fe=te.indexOf(`
`,fe+1),he--;while(he>0&&fe>=0);return fe===-1?te:(te[fe-1]==="\r"&&fe--,te.substr(0,fe))}e.getNLines=ce;function de(te){return te=te%(2*26),te<26?String.fromCharCode(97+te):String.fromCharCode(65+te-26)}e.singleLetterHash=de;function ge(te){return Ae.getInstance().getGraphemeBreakType(te)}e.getGraphemeBreakType=ge;function Ce(te,he){return te===0?he!==5&&he!==7:te===2&&he===3?!1:te===4||te===2||te===3||he===4||he===2||he===3?!0:!(te===8&&(he===8||he===9||he===11||he===12)||(te===11||te===9)&&(he===9||he===10)||(te===12||te===10)&&he===10||he===5||he===13||he===7||te===1||te===13&&he===14||te===6&&he===6)}var Pe;(function(te){te[te.Other=0]="Other",te[te.Prepend=1]="Prepend",te[te.CR=2]="CR",te[te.LF=3]="LF",te[te.Control=4]="Control",te[te.Extend=5]="Extend",te[te.Regional_Indicator=6]="Regional_Indicator",te[te.SpacingMark=7]="SpacingMark",te[te.L=8]="L",te[te.V=9]="V",te[te.T=10]="T",te[te.LV=11]="LV",te[te.LVT=12]="LVT",te[te.ZWJ=13]="ZWJ",te[te.Extended_Pictographic=14]="Extended_Pictographic"})(Pe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ae{static getInstance(){return Ae.c||(Ae.c=new Ae),Ae.c}constructor(){this.d=De()}getGraphemeBreakType(he){if(he<32)return he===10?3:he===13?2:4;if(he<127)return 0;const fe=this.d,me=fe.length/3;let we=1;for(;we<=me;)if(he<fe[3*we])we=2*we;else if(he>fe[3*we+1])we=2*we+1;else return fe[3*we+2];return 0}}Ae.c=null;function De(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function je(te,he){if(te===0)return 0;const fe=Oe(te,he);if(fe!==void 0)return fe;const me=new Y(he,te);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=je;function Oe(te,he){const fe=new Y(he,te);let me=fe.prevCodePoint();for(;Ue(me)||me===65039||me===8419;){if(fe.offset===0)return;me=fe.prevCodePoint()}if(!ne(me))return;let we=fe.offset;return we>0&&fe.prevCodePoint()===8205&&(we=fe.offset),we}function Ue(te){return 127995<=te&&te<=127999}var Be;(function(te){te[te.zwj=8205]="zwj",te[te.emojiVariantSelector=65039]="emojiVariantSelector",te[te.enclosingKeyCap=8419]="enclosingKeyCap"})(Be||(Be={})),e.noBreakWhitespace="\xA0";class ke{static getInstance(he){return ke.d.get(Array.from(he))}static getLocales(){return ke.e.getValue()}constructor(he){this.f=he}isAmbiguous(he){return this.f.has(he)}getPrimaryConfusable(he){return this.f.get(he)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=ke,R=ke,ke.c=new i.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ke.d=new D.LRUCachedFunction(te=>{function he(Le){const qe=new Map;for(let Ge=0;Ge<Le.length;Ge+=2)qe.set(Le[Ge],Le[Ge+1]);return qe}function fe(Le,qe){const Ge=new Map(Le);for(const[et,at]of qe)Ge.set(et,at);return Ge}function me(Le,qe){if(!Le)return qe;const Ge=new Map;for(const[et,at]of Le)qe.has(et)&&Ge.set(et,at);return Ge}const we=R.c.getValue();let Ie=te.filter(Le=>!Le.startsWith("_")&&Le in we);Ie.length===0&&(Ie=["_default"]);let Re;for(const Le of Ie){const qe=he(we[Le]);Re=me(Re,qe)}const He=he(we._common),$e=fe(He,Re);return new ke($e)}),ke.e=new i.Lazy(()=>Object.keys(ke.c.getValue()).filter(te=>!te.startsWith("_")));class Te{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Te.c())),this.d}static isInvisibleCharacter(he){return Te.e().has(he)}static get codePoints(){return Te.e()}}e.InvisibleCharacters=Te,Te.d=void 0}),define(re[47],ae([0,1,12,5,27,15]),function(_,e,D,i,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function L(r){return r===47||r===92}e.isPathSeparator=L;function P(r){return r.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=P;function I(r){return r.indexOf("/")===-1&&(r=P(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=I;function S(r,c=D.posix.sep){if(!r)return"";const o=r.length,p=r.charCodeAt(0);if(L(p)){if(L(r.charCodeAt(1))&&!L(r.charCodeAt(2))){let k=3;const F=k;for(;k<o&&!L(r.charCodeAt(k));k++);if(F!==k&&!L(r.charCodeAt(k+1))){for(k+=1;k<o;k++)if(L(r.charCodeAt(k)))return r.slice(0,k+1).replace(/[\\/]/g,c)}}return c}else if(l(p)&&r.charCodeAt(1)===58)return L(r.charCodeAt(2))?r.slice(0,2)+c:r.slice(0,2);let E=r.indexOf("://");if(E!==-1){for(E+=3;E<o;E++)if(L(r.charCodeAt(E)))return r.slice(0,E+1)}return""}e.getRoot=S;function C(r){if(!i.isWindows||!r||r.length<5)return!1;let c=r.charCodeAt(0);if(c!==92||(c=r.charCodeAt(1),c!==92))return!1;let o=2;const p=o;for(;o<r.length&&(c=r.charCodeAt(o),c!==92);o++);return!(p===o||(c=r.charCodeAt(o+1),isNaN(c)||c===92))}e.isUNC=C;const b=/[\\/:\*\?"<>\|]/g,w=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(r,c=i.isWindows){const o=c?b:w;return!(!r||r.length===0||/^\s+$/.test(r)||(o.lastIndex=0,o.test(r))||c&&y.test(r)||r==="."||r===".."||c&&r[r.length-1]==="."||c&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=d;function g(r,c,o){const p=r===c;return!o||p?p:!r||!c?!1:(0,R.equalsIgnoreCase)(r,c)}e.isEqual=g;function v(r,c,o,p=D.sep){if(r===c)return!0;if(!r||!c||c.length>r.length)return!1;if(o){if(!(0,R.startsWithIgnoreCase)(r,c))return!1;if(c.length===r.length)return!0;let k=c.length;return c.charAt(c.length-1)===p&&k--,r.charAt(k)===p}return c.charAt(c.length-1)!==p&&(c+=p),r.indexOf(c)===0}e.isEqualOrParent=v;function l(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=l;function m(r,c){return i.isWindows&&r.endsWith(":")&&(r+=D.sep),(0,D.isAbsolute)(r)||(r=(0,D.join)(c,r)),r=(0,D.normalize)(r),i.isWindows?(r=(0,R.rtrim)(r,D.sep),r.endsWith(":")&&(r+=D.sep)):(r=(0,R.rtrim)(r,D.sep),r||(r=D.sep)),r}e.sanitizeFilePath=m;function u(r){const c=(0,D.normalize)(r);return i.isWindows?r.length>3?!1:h(c)&&(r.length===2||c.charCodeAt(2)===92):c===D.posix.sep}e.isRootOrDriveLetter=u;function h(r,c=i.isWindows){return c?l(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=h;function f(r){return h(r)?r[0]:void 0}e.getDriveLetter=f;function n(r,c,o){return c.length>r.length?-1:r===c?0:(o&&(r=r.toLowerCase(),c=c.toLowerCase()),r.indexOf(c))}e.indexOfPath=n;function s(r){const c=r.split(":");let o,p,E;for(const k of c){const F=Number(k);(0,A.isNumber)(F)?p===void 0?p=F:E===void 0&&(E=F):o=o?[o,k].join(":"):k}if(!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:p!==void 0?p:void 0,column:E!==void 0?E:p!==void 0?1:void 0}}e.parseLineAndColumnAware=s;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function a(r,c,o=8){let p="";for(let k=0;k<o;k++)p+=t.charAt(Math.floor(Math.random()*t.length));let E;return c?E=`${c}-${p}`:E=p,r?(0,D.join)(r,E):E}e.randomPath=a}),define(re[66],ae([0,1,27]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function i(l){return R(l,0)}e.hash=i;function R(l,m){switch(typeof l){case"object":return l===null?A(349,m):Array.isArray(l)?I(l,m):S(l,m);case"string":return P(l,m);case"boolean":return L(l,m);case"number":return A(l,m);case"undefined":return A(937,m);default:return A(617,m)}}e.doHash=R;function A(l,m){return(m<<5)-m+l|0}e.numberHash=A;function L(l,m){return A(l?433:863,m)}function P(l,m){m=A(149417,m);for(let u=0,h=l.length;u<h;u++)m=A(l.charCodeAt(u),m);return m}e.stringHash=P;function I(l,m){return m=A(104579,m),l.reduce((u,h)=>R(h,u),m)}function S(l,m){return m=A(181387,m),Object.keys(l).sort().reduce((u,h)=>(u=P(h,u),R(l[h],u)),m)}class C{constructor(){this.g=0}get value(){return this.g}hash(m){return this.g=R(m,this.g),this.g}}e.Hasher=C;var b;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function w(l,m,u=32){const h=u-m,f=~((1<<h)-1);return(l<<m|(f&l)>>>h)>>>0}function y(l,m=0,u=l.byteLength,h=0){for(let f=0;f<u;f++)l[m+f]=h}function d(l,m,u="0"){for(;l.length<m;)l=u+l;return l}function g(l,m=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(u=>u.toString(16).padStart(2,"0")).join(""):d((l>>>0).toString(16),m/4)}e.toHexString=g;class v{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(m){const u=m.length;if(u===0)return;const h=this.p;let f=this.r,n=this.u,s,t;for(n!==0?(s=n,t=-1,n=0):(s=m.charCodeAt(0),t=0);;){let a=s;if(D.isHighSurrogate(s))if(t+1<u){const r=m.charCodeAt(t+1);D.isLowSurrogate(r)?(t++,a=D.computeCodePoint(s,r)):a=65533}else{n=s;break}else D.isLowSurrogate(s)&&(a=65533);if(f=this.w(h,f,a),t++,t<u)s=m.charCodeAt(t);else break}this.r=f,this.u=n}w(m,u,h){return h<128?m[u++]=h:h<2048?(m[u++]=192|(h&1984)>>>6,m[u++]=128|(h&63)>>>0):h<65536?(m[u++]=224|(h&61440)>>>12,m[u++]=128|(h&4032)>>>6,m[u++]=128|(h&63)>>>0):(m[u++]=240|(h&1835008)>>>18,m[u++]=128|(h&258048)>>>12,m[u++]=128|(h&4032)>>>6,m[u++]=128|(h&63)>>>0),u>=64&&(this.y(),u-=64,this.t+=64,m[0]=m[64+0],m[1]=m[64+1],m[2]=m[64+2]),u}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),g(this.h)+g(this.l)+g(this.m)+g(this.n)+g(this.o)}x(){this.p[this.r++]=128,y(this.p,this.r),this.r>56&&(this.y(),y(this.p));const m=8*this.t;this.q.setUint32(56,Math.floor(m/4294967296),!1),this.q.setUint32(60,m%4294967296,!1),this.y()}y(){const m=v.g,u=this.q;for(let o=0;o<64;o+=4)m.setUint32(o,u.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)m.setUint32(o,w(m.getUint32(o-12,!1)^m.getUint32(o-32,!1)^m.getUint32(o-56,!1)^m.getUint32(o-64,!1),1),!1);let h=this.h,f=this.l,n=this.m,s=this.n,t=this.o,a,r,c;for(let o=0;o<80;o++)o<20?(a=f&n|~f&s,r=1518500249):o<40?(a=f^n^s,r=1859775393):o<60?(a=f&n|f&s|n&s,r=2400959708):(a=f^n^s,r=3395469782),c=w(h,5)+a+t+r+m.getUint32(o*4,!1)&4294967295,t=s,s=n,n=w(f,30),f=h,h=c;this.h=this.h+h&4294967295,this.l=this.l+f&4294967295,this.m=this.m+n&4294967295,this.n=this.n+s&4294967295,this.o=this.o+t&4294967295}}e.StringSHA1=v,v.g=new DataView(new ArrayBuffer(320))}),define(re[88],ae([0,1,27]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var i;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(i||(i={})),function(R){const A="error",L="warning",P="warn",I="info",S="ignore";function C(w){return w?D.equalsIgnoreCase(A,w)?R.Error:D.equalsIgnoreCase(L,w)||D.equalsIgnoreCase(P,w)?R.Warning:D.equalsIgnoreCase(I,w)?R.Info:R.Ignore:R.Ignore}R.fromValue=C;function b(w){switch(w){case R.Error:return A;case R.Warning:return L;case R.Info:return I;default:return S}}R.toString=b}(i||(i={})),e.default=i}),define(re[48],ae([0,1,20,27]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class R{constructor(){this.b="",this.c=0}reset(y){return this.b=y,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(y){const d=y.charCodeAt(0),g=this.b.charCodeAt(this.c);return d-g}value(){return this.b[this.c]}}e.StringIterator=R;class A{constructor(y=!0){this.e=y}reset(y){return this.b=y,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let y=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(y)this.c++;else break;else y=!1;return this}cmp(y){return this.e?(0,i.compareSubstring)(y,this.b,0,y.length,this.c,this.d):(0,i.compareSubstringIgnoreCase)(y,this.b,0,y.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=A;class L{constructor(y=!0,d=!0){this.f=y,this.g=d}reset(y){this.d=0,this.e=0,this.b=y,this.c=y.length;for(let d=y.length-1;d>=0;d--,this.c--){const g=this.b.charCodeAt(d);if(!(g===47||this.f&&g===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let y=!0;for(;this.e<this.c;this.e++){const d=this.b.charCodeAt(this.e);if(d===47||this.f&&d===92)if(y)this.d++;else break;else y=!1}return this}cmp(y){return this.g?(0,i.compareSubstring)(y,this.b,0,y.length,this.d,this.e):(0,i.compareSubstringIgnoreCase)(y,this.b,0,y.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=L;var P;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})(P||(P={}));class I{constructor(y,d){this.f=y,this.g=d,this.d=[],this.e=0}reset(y){return this.c=y,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new L(!1,!this.f(y)),this.b.reset(y.path),this.b.value()&&this.d.push(3)),this.g(y)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(y){if(this.d[this.e]===1)return(0,i.compareIgnoreCase)(y,this.c.scheme);if(this.d[this.e]===2)return(0,i.compareIgnoreCase)(y,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(y);if(this.d[this.e]===4)return(0,i.compare)(y,this.c.query);if(this.d[this.e]===5)return(0,i.compare)(y,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=I;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const y=this.right;return this.right=y.left,y.left=this,this.updateHeight(),y.updateHeight(),y}rotateRight(){const y=this.left;return this.left=y.right,y.right=this,this.updateHeight(),y.updateHeight(),y}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var C;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(C||(C={}));class b{static forUris(y=()=>!1,d=()=>!1){return new b(new I(y,d))}static forPaths(y=!1){return new b(new L(void 0,!y))}static forStrings(){return new b(new R)}static forConfigKeys(){return new b(new A)}constructor(y){this.b=y}clear(){this.c=void 0}fill(y,d){if(d){const g=d.slice(0);(0,D.shuffle)(g);for(const v of g)this.set(v,y)}else{const g=y.slice(0);(0,D.shuffle)(g);for(const v of g)this.set(v[0],v[1])}}set(y,d){const g=this.b.reset(y);let v;this.c||(this.c=new S,this.c.segment=g.value());const l=[];for(v=this.c;;){const u=g.cmp(v.segment);if(u>0)v.left||(v.left=new S,v.left.segment=g.value()),l.push([-1,v]),v=v.left;else if(u<0)v.right||(v.right=new S,v.right.segment=g.value()),l.push([1,v]),v=v.right;else if(g.hasNext())g.next(),v.mid||(v.mid=new S,v.mid.segment=g.value()),l.push([0,v]),v=v.mid;else break}const m=v.value;v.value=d,v.key=y;for(let u=l.length-1;u>=0;u--){const h=l[u][1];h.updateHeight();const f=h.balanceFactor();if(f<-1||f>1){const n=l[u][0],s=l[u+1][0];if(n===1&&s===1)l[u][1]=h.rotateLeft();else if(n===-1&&s===-1)l[u][1]=h.rotateRight();else if(n===1&&s===-1)h.right=l[u+1][1]=l[u+1][1].rotateRight(),l[u][1]=h.rotateLeft();else if(n===-1&&s===1)h.left=l[u+1][1]=l[u+1][1].rotateLeft(),l[u][1]=h.rotateRight();else throw new Error;if(u>0)switch(l[u-1][0]){case-1:l[u-1][1].left=l[u][1];break;case 1:l[u-1][1].right=l[u][1];break;case 0:l[u-1][1].mid=l[u][1];break}else this.c=l[0][1]}}return m}get(y){return this.d(y)?.value}d(y){const d=this.b.reset(y);let g=this.c;for(;g;){const v=d.cmp(g.segment);if(v>0)g=g.left;else if(v<0)g=g.right;else if(d.hasNext())d.next(),g=g.mid;else break}return g}has(y){const d=this.d(y);return!(d?.value===void 0&&d?.mid===void 0)}delete(y){return this.e(y,!1)}deleteSuperstr(y){return this.e(y,!0)}e(y,d){const g=this.b.reset(y),v=[];let l=this.c;for(;l;){const m=g.cmp(l.segment);if(m>0)v.push([-1,l]),l=l.left;else if(m<0)v.push([1,l]),l=l.right;else if(g.hasNext())g.next(),v.push([0,l]),l=l.mid;else break}if(!!l){if(d?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const m=this.f(l.right);if(m.key){const{key:u,value:h,segment:f}=m;this.e(m.key,!1),l.key=u,l.value=h,l.segment=f}}else{const m=l.left??l.right;if(v.length>0){const[u,h]=v[v.length-1];switch(u){case-1:h.left=m;break;case 0:h.mid=m;break;case 1:h.right=m;break}}else this.c=m}for(let m=v.length-1;m>=0;m--){const u=v[m][1];u.updateHeight();const h=u.balanceFactor();if(h>1?(u.right.balanceFactor()>=0||(u.right=u.right.rotateRight()),v[m][1]=u.rotateLeft()):h<-1&&(u.left.balanceFactor()<=0||(u.left=u.left.rotateLeft()),v[m][1]=u.rotateRight()),m>0)switch(v[m-1][0]){case-1:v[m-1][1].left=v[m][1];break;case 1:v[m-1][1].right=v[m][1];break;case 0:v[m-1][1].mid=v[m][1];break}else this.c=v[0][1]}}}f(y){for(;y.left;)y=y.left;return y}findSubstr(y){const d=this.b.reset(y);let g=this.c,v;for(;g;){const l=d.cmp(g.segment);if(l>0)g=g.left;else if(l<0)g=g.right;else if(d.hasNext())d.next(),v=g.value||v,g=g.mid;else break}return g&&g.value||v}findSuperstr(y){const d=this.b.reset(y);let g=this.c;for(;g;){const v=d.cmp(g.segment);if(v>0)g=g.left;else if(v<0)g=g.right;else if(d.hasNext())d.next(),g=g.mid;else return g.mid?this.g(g.mid):void 0}}forEach(y){for(const[d,g]of this)y(g,d)}*[Symbol.iterator](){yield*this.g(this.c)}g(y){const d=[];return this.h(y,d),d[Symbol.iterator]()}h(y,d){!y||(y.left&&this.h(y.left,d),y.value&&d.push([y.key,y.value]),y.mid&&this.h(y.mid,d),y.right&&this.h(y.right,d))}_isBalanced(){const y=d=>{if(!d)return!0;const g=d.balanceFactor();return g<-1||g>1?!1:y(d.left)&&y(d.right)};return y(this.c)}}e.TernarySearchTree=b}),define(re[7],ae([0,1,12,5]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const R=/^\w[\w\d+.-]*$/,A=/^\//,L=/^\/\//;function P(t,a){if(!t.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!R.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!A.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(L.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function I(t,a){return!t&&!a?"file":t}function S(t,a){switch(t){case"https":case"http":case"file":a?a[0]!==b&&(a=b+a):a=b;break}return a}const C="",b="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{static isUri(a){return a instanceof y?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}constructor(a,r,c,o,p,E=!1){typeof a=="object"?(this.scheme=a.scheme||C,this.authority=a.authority||C,this.path=a.path||C,this.query=a.query||C,this.fragment=a.fragment||C):(this.scheme=I(a,E),this.authority=r||C,this.path=S(this.scheme,c||C),this.query=o||C,this.fragment=p||C,P(this,E))}get fsPath(){return u(this,!1)}with(a){if(!a)return this;let{scheme:r,authority:c,path:o,query:p,fragment:E}=a;return r===void 0?r=this.scheme:r===null&&(r=C),c===void 0?c=this.authority:c===null&&(c=C),o===void 0?o=this.path:o===null&&(o=C),p===void 0?p=this.query:p===null&&(p=C),E===void 0?E=this.fragment:E===null&&(E=C),r===this.scheme&&c===this.authority&&o===this.path&&p===this.query&&E===this.fragment?this:new g(r,c,o,p,E)}static parse(a,r=!1){const c=w.exec(a);return c?new g(c[2]||C,s(c[4]||C),s(c[5]||C),s(c[7]||C),s(c[9]||C),r):new g(C,C,C,C,C)}static file(a){let r=C;if(i.isWindows&&(a=a.replace(/\\/g,b)),a[0]===b&&a[1]===b){const c=a.indexOf(b,2);c===-1?(r=a.substring(2),a=b):(r=a.substring(2,c),a=a.substring(c)||b)}return new g("file",r,a,C,C)}static from(a){const r=new g(a.scheme,a.authority,a.path,a.query,a.fragment);return P(r,!0),r}static joinPath(a,...r){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return i.isWindows&&a.scheme==="file"?c=y.file(D.win32.join(u(a,!0),...r)).path:c=D.posix.join(a.path,...r),a.with({path:c})}toString(a=!1){return h(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof y)return a;{const r=new g(a);return r._formatted=a.external,r._fsPath=a._sep===d?a.fsPath:null,r}}else return a}}e.URI=y;const d=i.isWindows?1:void 0;class g extends y{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(a=!1){return a?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=d),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const v={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function l(t,a){let r,c=-1;for(let o=0;o<t.length;o++){const p=t.charCodeAt(o);if(p>=97&&p<=122||p>=65&&p<=90||p>=48&&p<=57||p===45||p===46||p===95||p===126||a&&p===47)c!==-1&&(r+=encodeURIComponent(t.substring(c,o)),c=-1),r!==void 0&&(r+=t.charAt(o));else{r===void 0&&(r=t.substr(0,o));const E=v[p];E!==void 0?(c!==-1&&(r+=encodeURIComponent(t.substring(c,o)),c=-1),r+=E):c===-1&&(c=o)}}return c!==-1&&(r+=encodeURIComponent(t.substring(c))),r!==void 0?r:t}function m(t){let a;for(let r=0;r<t.length;r++){const c=t.charCodeAt(r);c===35||c===63?(a===void 0&&(a=t.substr(0,r)),a+=v[c]):a!==void 0&&(a+=t[r])}return a!==void 0?a:t}function u(t,a){let r;return t.authority&&t.path.length>1&&t.scheme==="file"?r=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?a?r=t.path.substr(1):r=t.path[1].toLowerCase()+t.path.substr(2):r=t.path,i.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=u;function h(t,a){const r=a?m:l;let c="",{scheme:o,authority:p,path:E,query:k,fragment:F}=t;if(o&&(c+=o,c+=":"),(p||o==="file")&&(c+=b,c+=b),p){let N=p.indexOf("@");if(N!==-1){const q=p.substr(0,N);p=p.substr(N+1),N=q.indexOf(":"),N===-1?c+=r(q,!1):(c+=r(q.substr(0,N),!1),c+=":",c+=r(q.substr(N+1),!1)),c+="@"}p=p.toLowerCase(),N=p.indexOf(":"),N===-1?c+=r(p,!1):(c+=r(p.substr(0,N),!1),c+=p.substr(N))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const N=E.charCodeAt(1);N>=65&&N<=90&&(E=`/${String.fromCharCode(N+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const N=E.charCodeAt(0);N>=65&&N<=90&&(E=`${String.fromCharCode(N+32)}:${E.substr(2)}`)}c+=r(E,!0)}return k&&(c+="?",c+=r(k,!1)),F&&(c+="#",c+=a?F:l(F,!1)),c}function f(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+f(t.substr(3)):t}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(t){return t.match(n)?t.replace(n,a=>f(a)):t}}),define(re[141],ae([0,1,7]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function i(S){const C=S;return C&&typeof C.type=="string"&&typeof C.severity=="string"}e.isRemoteConsoleLog=i;function R(S){const C=[];let b;try{const w=JSON.parse(S.arguments),y=w[w.length-1];y&&y.__$stack&&(w.pop(),b=y.__$stack),C.push(...w)}catch{C.push("Unable to log remote console arguments",S.arguments)}return{args:C,stack:b}}e.parse=R;function A(S){if(typeof S!="string")return A(R(S).stack);const C=S;if(C){const b=L(C),w=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(w&&w.length===4)return{uri:D.URI.file(w[1]),line:Number(w[2]),column:Number(w[3])}}}e.getFirstFrame=A;function L(S){if(!S)return S;const C=S.indexOf(`
`);return C===-1?S:S.substring(0,C)}function P(S,C){const{args:b,stack:w}=R(S),y=typeof b[0]=="string"&&b.length===1;let d=L(w);d&&(d=`(${d.trim()})`);let g=[];if(typeof b[0]=="string"?d&&y?g=[`%c[${C}] %c${b[0]} %c${d}`,I("blue"),I(""),I("grey")]:g=[`%c[${C}] %c${b[0]}`,I("blue"),I(""),...b.slice(1)]:g=[`%c[${C}]%`,I("blue"),...b],d&&!y&&g.push(d),typeof console[S.severity]!="function")throw new Error("Unknown console method");console[S.severity].apply(console,g)}e.log=P;function I(S){return`color: ${S}`}}),define(re[67],ae([0,1,17,27,7]),function(_,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(S){return JSON.stringify(S,P)}e.stringify=A;function L(S){let C=JSON.parse(S);return C=I(C),C}e.parse=L;function P(S,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,i.regExpFlags)(C)}:C}function I(S,C=0){if(!S||C>200)return S;if(typeof S=="object"){switch(S.$mid){case 1:return R.URI.revive(S);case 2:return new RegExp(S.source,S.flags);case 16:return new Date(S.source)}if(S instanceof D.VSBuffer||S instanceof Uint8Array)return S;if(Array.isArray(S))for(let b=0;b<S.length;++b)S[b]=I(S[b],C+1);else for(const b in S)Object.hasOwnProperty.call(S,b)&&(S[b]=I(S[b],C+1))}return S}e.revive=I}),define(re[24],ae([0,1,5,7]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var R;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.vscodeUserData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebook="vscode-notebook",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp",I.vsls="vsls",I.vscodeSourceControl="vscode-scm"})(R=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(S){this.d=S}setDelegate(S){this.e=S}setServerRootPath(S){this.f=`${S}/${R.vscodeRemoteResource}`}set(S,C,b){this.a[S]=C,this.b[S]=b}setConnectionToken(S,C){this.c[S]=C}getPreferredWebSchema(){return this.d}rewrite(S){if(this.e)return this.e(S);const C=S.authority;let b=this.a[C];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const w=this.b[C],y=this.c[C];let d=`path=${encodeURIComponent(S.path)}`;return typeof y=="string"&&(d+=`&${e.connectionTokenQueryName}=${encodeURIComponent(y)}`),i.URI.from({scheme:D.isWeb?this.d:R.vscodeRemoteResource,authority:`${b}:${w}`,path:this.f,query:d})}}e.RemoteAuthorities=new A,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class L{asBrowserUri(S){const C=this.b(S,_);return this.uriToBrowserUri(C)}uriToBrowserUri(S){return S.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(S):S.scheme===R.file&&(D.isNative||D.isWebWorker&&D.globals.origin===`${R.vscodeFileResource}://${L.a}`)?S.with({scheme:R.vscodeFileResource,authority:S.authority||L.a,query:null,fragment:null}):S}asFileUri(S){const C=this.b(S,_);return this.uriToFileUri(C)}uriToFileUri(S){return S.scheme===R.vscodeFileResource?S.with({scheme:R.file,authority:S.authority!==L.a?S.authority:null,query:null,fragment:null}):S}b(S,C){return i.URI.isUri(S)?S:i.URI.parse(C.toUrl(S))}}L.a="vscode-app",e.FileAccess=new L;var P;(function(I){const S=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);I.CoopAndCoep=Object.freeze(S.get("3"));const C="vscode-coi";function b(y){let d;typeof y=="string"?d=new URL(y).searchParams:y instanceof URL?d=y.searchParams:i.URI.isUri(y)&&(d=new URL(y.toString(!0)).searchParams);const g=d?.get(C);if(!!g)return S.get(g)}I.getHeadersFromQuery=b;function w(y,d,g){if(!globalThis.crossOriginIsolated)return;const v=d&&g?"3":g?"2":"1";y instanceof URLSearchParams?y.set(C,v):y[C]=v}I.addSearchParam=w})(P=e.COI||(e.COI={}))}),define(re[21],ae([0,1,47,24,12,5,27,7]),function(_,e,D,i,R,A,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function I(y){return(0,P.uriToFsPath)(y,!0)}e.originalFSPath=I;class S{constructor(d){this.a=d}compare(d,g,v=!1){return d===g?0:(0,L.compare)(this.getComparisonKey(d,v),this.getComparisonKey(g,v))}isEqual(d,g,v=!1){return d===g?!0:!d||!g?!1:this.getComparisonKey(d,v)===this.getComparisonKey(g,v)}getComparisonKey(d,g=!1){return d.with({path:this.a(d)?d.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(d){return this.a(d)}isEqualOrParent(d,g,v=!1){if(d.scheme===g.scheme){if(d.scheme===i.Schemas.file)return D.isEqualOrParent(I(d),I(g),this.a(d))&&d.query===g.query&&(v||d.fragment===g.fragment);if((0,e.isEqualAuthority)(d.authority,g.authority))return D.isEqualOrParent(d.path,g.path,this.a(d),"/")&&d.query===g.query&&(v||d.fragment===g.fragment)}return!1}joinPath(d,...g){return P.URI.joinPath(d,...g)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return R.posix.basename(d.path)}extname(d){return R.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let g;return d.scheme===i.Schemas.file?g=P.URI.file(R.dirname(I(d))).path:(g=R.posix.dirname(d.path),d.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),g="/")),d.with({path:g})}normalizePath(d){if(!d.path.length)return d;let g;return d.scheme===i.Schemas.file?g=P.URI.file(R.normalize(I(d))).path:g=R.posix.normalize(d.path),d.with({path:g})}relativePath(d,g){if(d.scheme!==g.scheme||!(0,e.isEqualAuthority)(d.authority,g.authority))return;if(d.scheme===i.Schemas.file){const m=R.relative(I(d),I(g));return A.isWindows?D.toSlashes(m):m}let v=d.path||"/";const l=g.path||"/";if(this.a(d)){let m=0;for(const u=Math.min(v.length,l.length);m<u&&!(v.charCodeAt(m)!==l.charCodeAt(m)&&v.charAt(m).toLowerCase()!==l.charAt(m).toLowerCase());m++);v=l.substr(0,m)+v.substr(m)}return R.posix.relative(v,l)}resolvePath(d,g){if(d.scheme===i.Schemas.file){const v=P.URI.file(R.resolve(I(d),g));return d.with({authority:v.authority,path:v.path})}return g=D.toPosixPath(g),d.with({path:R.posix.resolve(d.path,g)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,g){return d===g||d!==void 0&&g!==void 0&&(0,L.equalsIgnoreCase)(d,g)}hasTrailingPathSeparator(d,g=R.sep){if(d.scheme===i.Schemas.file){const v=I(d);return v.length>D.getRoot(v).length&&v[v.length-1]===g}else{const v=d.path;return v.length>1&&v.charCodeAt(v.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,g=R.sep){return(0,e.hasTrailingPathSeparator)(d,g)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,g=R.sep){let v=!1;if(d.scheme===i.Schemas.file){const l=I(d);v=l!==void 0&&l.length===D.getRoot(l).length&&l[l.length-1]===g}else{g="/";const l=d.path;v=l.length===1&&l.charCodeAt(l.length-1)===47}return!v&&!(0,e.hasTrailingPathSeparator)(d,g)?d.with({path:d.path+"/"}):d}}e.ExtUri=S,e.extUri=new S(()=>!1),e.extUriBiasedIgnorePathCase=new S(y=>y.scheme===i.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new S(y=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function C(y,d){const g=[];for(let v=0;v<y.length;v++){const l=d(y[v]);y.some((m,u)=>u===v?!1:(0,e.isEqualOrParent)(l,d(m)))||g.push(y[v])}return g}e.distinctParents=C;var b;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function d(g){const v=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(u=>{const[h,f]=u.split(":");h&&f&&v.set(h,f)});const m=g.path.substring(0,g.path.indexOf(";"));return m&&v.set(y.META_DATA_MIME,m),v}y.parseMetaData=d})(b=e.DataUri||(e.DataUri={}));function w(y,d,g){if(d){let v=y.path;return v&&v[0]!==R.posix.sep&&(v=R.posix.sep+v),y.with({scheme:g,authority:d,path:v})}return y.with({scheme:g})}e.toLocalResource=w}),define(re[6],ae([0,1,23,9,3,2,21,5]),function(_,e,D,i,R,A,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function I(Q){return!!Q&&typeof Q.then=="function"}e.isThenable=I;function S(Q){const T=new D.CancellationTokenSource,M=Q(T.token),V=new Promise((W,X)=>{const se=T.token.onCancellationRequested(()=>{se.dispose(),T.dispose(),X(new i.CancellationError)});Promise.resolve(M).then(x=>{se.dispose(),T.dispose(),W(x)},x=>{se.dispose(),T.dispose(),X(x)})});return new class{cancel(){T.cancel()}then(W,X){return V.then(W,X)}catch(W){return this.then(void 0,W)}finally(W){return V.finally(W)}}}e.createCancelablePromise=S;function C(Q,T,M){return new Promise((V,W)=>{const X=T.onCancellationRequested(()=>{X.dispose(),V(M)});Q.then(V,W).finally(()=>X.dispose())})}e.raceCancellation=C;function b(Q,T){return new Promise((M,V)=>{const W=T.onCancellationRequested(()=>{W.dispose(),V(new i.CancellationError)});Q.then(M,V).finally(()=>W.dispose())})}e.raceCancellationError=b;async function w(Q){let T=-1;const M=Q.map((W,X)=>W.then(se=>(T=X,se))),V=await Promise.race(M);return Q.forEach((W,X)=>{X!==T&&W.cancel()}),V}e.raceCancellablePromises=w;function y(Q,T,M){let V;const W=setTimeout(()=>{V?.(void 0),M?.()},T);return Promise.race([Q.finally(()=>clearTimeout(W)),new Promise(X=>V=X)])}e.raceTimeout=y;function d(Q){return new Promise((T,M)=>{const V=Q();I(V)?V.then(T,M):T(V)})}e.asPromise=d;class g{constructor(){this.a=null,this.b=null,this.d=null}queue(T){if(this.a){if(this.d=T,!this.b){const M=()=>{this.b=null;const V=this.queue(this.d);return this.d=null,V};this.b=new Promise(V=>{this.a.then(M,M).then(V)})}return new Promise((M,V)=>{this.b.then(M,V)})}return this.a=T(),new Promise((M,V)=>{this.a.then(W=>{this.a=null,M(W)},W=>{this.a=null,V(W)})})}}e.Throttler=g;class v{constructor(){this.a=Promise.resolve(null)}queue(T){return this.a=this.a.then(()=>T(),()=>T())}}e.Sequencer=v;class l{constructor(){this.a=new Map}queue(T,M){const W=(this.a.get(T)??Promise.resolve()).catch(()=>{}).then(M).finally(()=>{this.a.get(T)===W&&this.a.delete(T)});return this.a.set(T,W),W}}e.SequencerByKey=l;const m=(Q,T)=>{let M=!0;const V=setTimeout(()=>{M=!1,T()},Q);return{isTriggered:()=>M,dispose:()=>{clearTimeout(V),M=!1}}},u=Q=>{let T=!0;return queueMicrotask(()=>{T&&(T=!1,Q())}),{isTriggered:()=>T,dispose:()=>{T=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class h{constructor(T){this.defaultDelay=T,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(T,M=this.defaultDelay){this.g=T,this.h(),this.b||(this.b=new Promise((W,X)=>{this.d=W,this.f=X}).then(()=>{if(this.b=null,this.d=null,this.g){const W=this.g;return this.g=null,W()}}));const V=()=>{this.a=null,this.d?.(null)};return this.a=M===e.MicrotaskDelay?u(V):m(M,V),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new i.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=h;class f{constructor(T){this.a=new h(T),this.b=new g}trigger(T,M){return this.a.trigger(()=>this.b.queue(T),M)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=f;class n{constructor(){this.a=!1,this.b=new Promise((T,M)=>{this.d=T})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=n;class s extends n{constructor(T){super(),this.f=setTimeout(()=>this.open(),T)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=s;function t(Q,T){return T?new Promise((M,V)=>{const W=setTimeout(()=>{X.dispose(),M()},Q),X=T.onCancellationRequested(()=>{clearTimeout(W),X.dispose(),V(new i.CancellationError)})}):S(M=>t(Q,M))}e.timeout=t;function a(Q,T=0){const M=setTimeout(Q,T);return(0,A.toDisposable)(()=>clearTimeout(M))}e.disposableTimeout=a;function r(Q){const T=[];let M=0;const V=Q.length;function W(){return M<V?Q[M++]():null}function X(se){se!=null&&T.push(se);const x=W();return x?x.then(X):Promise.resolve(T)}return Promise.resolve(null).then(X)}e.sequence=r;function c(Q,T=V=>!!V,M=null){let V=0;const W=Q.length,X=()=>{if(V>=W)return Promise.resolve(M);const se=Q[V++];return Promise.resolve(se()).then(ie=>T(ie)?Promise.resolve(ie):X())};return X()}e.first=c;function o(Q,T=V=>!!V,M=null){if(Q.length===0)return Promise.resolve(M);let V=Q.length;const W=()=>{V=-1;for(const X of Q)X.cancel?.()};return new Promise((X,se)=>{for(const x of Q)x.then(ie=>{--V>=0&&T(ie)?(W(),X(ie)):V===0&&X(M)}).catch(ie=>{--V>=0&&(W(),se(ie))})})}e.firstParallel=o;class p{constructor(T){this.a=0,this.d=T,this.f=[],this.b=0,this.g=new R.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(T){return this.a++,new Promise((M,V)=>{this.f.push({factory:T,c:M,e:V}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const T=this.f.shift();this.b++;const M=T.factory();M.then(T.c,T.e),M.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=p;class E extends p{constructor(){super(1)}}e.Queue=E;class k{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const T=new z;return this.b.add(T),T.p}d(){for(const[,T]of this.a)if(T.size>0)return!1;return!0}queueFor(T,M=L.extUri){const V=M.getComparisonKey(T);let W=this.a.get(V);return W||(W=new E,R.Event.once(W.onDrained)(()=>{W?.dispose(),this.a.delete(V),this.f()}),this.a.set(V,W)),W}f(){!this.d()||this.g()}g(){for(const T of this.b)T.complete();this.b.clear()}dispose(){for(const[,T]of this.a)T.dispose();this.a.clear(),this.g()}}e.ResourceQueue=k;class F{constructor(T,M){this.a=-1,typeof T=="function"&&typeof M=="number"&&this.setIfNotSet(T,M)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(T,M){this.cancel(),this.a=setTimeout(()=>{this.a=-1,T()},M)}setIfNotSet(T,M){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,T()},M))}}e.TimeoutTimer=F;class N{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(T,M){this.cancel(),this.a=setInterval(()=>{T()},M)}}e.IntervalTimer=N;class q{constructor(T,M){this.b=-1,this.a=T,this.d=M,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(T=this.d){this.cancel(),this.b=setTimeout(this.f,T)}get delay(){return this.d}set delay(T){this.d=T}isScheduled(){return this.b!==-1}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=q;class j{constructor(T,M){M%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${M}ms is not a multiple of 1000ms.`),this.a=T,this.b=M,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(T=this.b){T%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${T}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(T/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=j;class O extends q{constructor(T,M){super(T,M),this.j=[]}work(T){this.j.push(T),this.isScheduled()||this.schedule()}h(){const T=this.j;this.j=[],this.a?.(T)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=O;class U extends A.Disposable{constructor(T,M){super(),this.g=T,this.h=M,this.a=[],this.b=this.B(new A.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(T){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+T.length>this.g.maxBufferedWork)return!1}else if(this.pending+T.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}return this.a.push(...T),this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new q(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=U,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=Q=>{(0,P.setTimeout0)(()=>{if(T)return;const M=Date.now()+15;Q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,M-Date.now())}}))});let T=!1;return{dispose(){T||(T=!0)}}}:e.runWhenIdle=(Q,T)=>{const M=requestIdleCallback(Q,typeof T=="number"?{timeout:T}:void 0);let V=!1;return{dispose(){V||(V=!0,cancelIdleCallback(M))}}}}();class ${constructor(T){this.d=!1,this.a=()=>{try{this.f=T()}catch(M){this.g=M}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=$;async function G(Q,T,M){let V;for(let W=0;W<M;W++)try{return await Q()}catch(X){V=X,await t(T)}throw V}e.retry=G;class H{hasPending(T){return this.a?typeof T=="number"?this.a.taskId===T:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(T,M,V){return this.a={taskId:T,cancel:()=>V?.(),promise:M},M.then(()=>this.d(T),()=>this.d(T)),M}d(T){this.a&&T===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const T=this.b;this.b=void 0,T.run().then(T.promiseResolve,T.promiseReject)}}setNext(T){if(this.b)this.b.run=T;else{let M,V;const W=new Promise((X,se)=>{M=X,V=se});this.b={run:T,promise:W,promiseResolve:M,promiseReject:V}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=H;class Z{constructor(T,M=()=>Date.now()){this.d=T,this.f=M,this.a=0,this.b=0}increment(){const T=this.f();return T-this.a>this.d&&(this.a=T,this.b=0),this.b++,this.b}}e.IntervalCounter=Z;class z{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((T,M)=>{this.a=T,this.b=M})}complete(T){return new Promise(M=>{this.a(T),this.f=!0,M()})}error(T){return new Promise(M=>{this.b(T),this.d=!0,M()})}cancel(){new Promise(T=>{this.b(new i.CancellationError),this.d=!0,T()})}}e.DeferredPromise=z;var B;(function(Q){async function T(V){let W;const X=await Promise.all(V.map(se=>se.then(x=>x,x=>{W||(W=x)})));if(typeof W<"u")throw W;return X}Q.settled=T;function M(V){return new Promise(async(W,X)=>{try{await V(W,X)}catch(se){X(se)}})}Q.withAsyncBody=M})(B=e.Promises||(e.Promises={}));var Y;(function(Q){Q[Q.Initial=0]="Initial",Q[Q.DoneOK=1]="DoneOK",Q[Q.DoneError=2]="DoneError"})(Y||(Y={}));class ee{static fromArray(T){return new ee(M=>{M.emitMany(T)})}static fromPromise(T){return new ee(async M=>{M.emitMany(await T)})}static fromPromises(T){return new ee(async M=>{await Promise.all(T.map(async V=>M.emitOne(await V)))})}static merge(T){return new ee(async M=>{await Promise.all(T.map(async V=>{for await(const W of V)M.emitOne(W)}))})}constructor(T){this.a=0,this.b=[],this.d=null,this.f=new R.Emitter,queueMicrotask(async()=>{const M={emitOne:V=>this.g(V),emitMany:V=>this.h(V),reject:V=>this.k(V)};try{await Promise.resolve(T(M)),this.j()}catch(V){this.k(V)}finally{M.emitOne=void 0,M.emitMany=void 0,M.reject=void 0}})}[Symbol.asyncIterator](){let T=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(T<this.b.length)return{done:!1,value:this.b[T++]};if(this.a===1)return{done:!0,value:void 0};await R.Event.toPromise(this.f.event)}while(!0)}}}static map(T,M){return new ee(async V=>{for await(const W of T)V.emitOne(M(W))})}map(T){return ee.map(this,T)}static filter(T,M){return new ee(async V=>{for await(const W of T)M(W)&&V.emitOne(W)})}filter(T){return ee.filter(this,T)}static coalesce(T){return ee.filter(T,M=>!!M)}coalesce(){return ee.coalesce(this)}static async toPromise(T){const M=[];for await(const V of T)M.push(V);return M}toPromise(){return ee.toPromise(this)}g(T){this.a===0&&(this.b.push(T),this.f.fire())}h(T){this.a===0&&(this.b=this.b.concat(T),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(T){this.a===0&&(this.a=2,this.d=T,this.f.fire())}}e.AsyncIterableObject=ee,ee.EMPTY=ee.fromArray([]);class oe extends ee{constructor(T,M){super(M),this.l=T}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=oe;function J(Q){const T=new D.CancellationTokenSource,M=Q(T.token);return new oe(T,async V=>{const W=T.token.onCancellationRequested(()=>{W.dispose(),T.dispose(),V.reject(new i.CancellationError)});try{for await(const X of M){if(T.token.isCancellationRequested)return;V.emitOne(X)}W.dispose(),T.dispose()}catch(X){W.dispose(),T.dispose(),V.reject(X)}})}e.createCancelableAsyncIterable=J}),define(re[89],ae([0,1,20,6,47,37,12,5,27]),function(_,e,D,i,R,A,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function S(){return Object.create(null)}e.getEmptyExpression=S,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const C="[/\\\\]",b="[^/\\\\]",w=/\//g;function y(z,B){switch(z){case 0:return"";case 1:return`${b}*?`;default:return`(?:${C}|${b}+${C}${B?`|${C}${b}+`:""})*?`}}function d(z,B){if(!z)return[];const Y=[];let ee=!1,oe=!1,J="";for(const Q of z){switch(Q){case B:if(!ee&&!oe){Y.push(J),J="";continue}break;case"{":ee=!0;break;case"}":ee=!1;break;case"[":oe=!0;break;case"]":oe=!1;break}J+=Q}return J&&Y.push(J),Y}e.splitGlobAware=d;function g(z){if(!z)return"";let B="";const Y=d(z,e.GLOB_SPLIT);if(Y.every(ee=>ee===e.GLOBSTAR))B=".*";else{let ee=!1;Y.forEach((oe,J)=>{if(oe===e.GLOBSTAR){if(ee)return;B+=y(2,J===Y.length-1)}else{let Q=!1,T="",M=!1,V="";for(const W of oe){if(W!=="}"&&Q){T+=W;continue}if(M&&(W!=="]"||!V)){let X;W==="-"?X=W:(W==="^"||W==="!")&&!V?X="^":W===e.GLOB_SPLIT?X="":X=(0,I.escapeRegExpCharacters)(W),V+=X;continue}switch(W){case"{":Q=!0;continue;case"[":M=!0;continue;case"}":{B+=`(?:${d(T,",").map(x=>g(x)).join("|")})`,Q=!1,T="";break}case"]":{B+="["+V+"]",M=!1,V="";break}case"?":B+=b;continue;case"*":B+=y(1);continue;default:B+=(0,I.escapeRegExpCharacters)(W)}}J<Y.length-1&&(Y[J+1]!==e.GLOBSTAR||J+2<Y.length)&&(B+=C)}ee=oe===e.GLOBSTAR})}return B}const v=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,m=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,u=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,h=/^\*\*((\/[\w\.-]+)+)\/?$/,f=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new A.LRUCache(1e4),s=function(){return!1},t=function(){return null};function a(z,B){if(!z)return t;let Y;typeof z!="string"?Y=z.pattern:Y=z,Y=Y.trim();const ee=`${Y}_${!!B.trimForExclusions}`;let oe=n.get(ee);if(oe)return r(oe,z);let J;return v.test(Y)?oe=o(Y.substr(4),Y):(J=l.exec(c(Y,B)))?oe=p(J[1],Y):(B.trimForExclusions?u:m).test(Y)?oe=E(Y,B):(J=h.exec(c(Y,B)))?oe=k(J[1].substr(1),Y,!0):(J=f.exec(c(Y,B)))?oe=k(J[1],Y,!1):oe=F(Y),n.set(ee,oe),r(oe,z)}function r(z,B){if(typeof B=="string")return z;const Y=function(ee,oe){return(0,R.isEqualOrParent)(ee,B.base,!P.isLinux)?z((0,I.ltrim)(ee.substr(B.base.length),L.sep),oe):null};return Y.allBasenames=z.allBasenames,Y.allPaths=z.allPaths,Y.basenames=z.basenames,Y.patterns=z.patterns,Y}function c(z,B){return B.trimForExclusions&&z.endsWith("/**")?z.substr(0,z.length-2):z}function o(z,B){return function(Y,ee){return typeof Y=="string"&&Y.endsWith(z)?B:null}}function p(z,B){const Y=`/${z}`,ee=`\\${z}`,oe=function(Q,T){return typeof Q!="string"?null:T?T===z?B:null:Q===z||Q.endsWith(Y)||Q.endsWith(ee)?B:null},J=[z];return oe.basenames=J,oe.patterns=[B],oe.allBasenames=J,oe}function E(z,B){const Y=H(z.slice(1,-1).split(",").map(T=>a(T,B)).filter(T=>T!==t),z),ee=Y.length;if(!ee)return t;if(ee===1)return Y[0];const oe=function(T,M){for(let V=0,W=Y.length;V<W;V++)if(Y[V](T,M))return z;return null},J=Y.find(T=>!!T.allBasenames);J&&(oe.allBasenames=J.allBasenames);const Q=Y.reduce((T,M)=>M.allPaths?T.concat(M.allPaths):T,[]);return Q.length&&(oe.allPaths=Q),oe}function k(z,B,Y){const ee=L.sep===L.posix.sep,oe=ee?z:z.replace(w,L.sep),J=L.sep+oe,Q=L.posix.sep+z;let T;return Y?T=function(M,V){return typeof M=="string"&&(M===oe||M.endsWith(J)||!ee&&(M===z||M.endsWith(Q)))?B:null}:T=function(M,V){return typeof M=="string"&&(M===oe||!ee&&M===z)?B:null},T.allPaths=[(Y?"*/":"./")+z],T}function F(z){try{const B=new RegExp(`^${g(z)}$`);return function(Y){return B.lastIndex=0,typeof Y=="string"&&B.test(Y)?z:null}}catch{return t}}function N(z,B,Y){return!z||typeof B!="string"?!1:q(z)(B,void 0,Y)}e.match=N;function q(z,B={}){if(!z)return s;if(typeof z=="string"||j(z)){const Y=a(z,B);if(Y===t)return s;const ee=function(oe,J){return!!Y(oe,J)};return Y.allBasenames&&(ee.allBasenames=Y.allBasenames),Y.allPaths&&(ee.allPaths=Y.allPaths),ee}return $(z,B)}e.parse=q;function j(z){const B=z;return B?typeof B.base=="string"&&typeof B.pattern=="string":!1}e.isRelativePattern=j;function O(z){return z.allBasenames||[]}e.getBasenameTerms=O;function U(z){return z.allPaths||[]}e.getPathTerms=U;function $(z,B){const Y=H(Object.getOwnPropertyNames(z).map(T=>G(T,z[T],B)).filter(T=>T!==t)),ee=Y.length;if(!ee)return t;if(!Y.some(T=>!!T.requiresSiblings)){if(ee===1)return Y[0];const T=function(W,X){let se;for(let x=0,ie=Y.length;x<ie;x++){const ne=Y[x](W,X);if(typeof ne=="string")return ne;(0,i.isThenable)(ne)&&(se||(se=[]),se.push(ne))}return se?(async()=>{for(const x of se){const ie=await x;if(typeof ie=="string")return ie}return null})():null},M=Y.find(W=>!!W.allBasenames);M&&(T.allBasenames=M.allBasenames);const V=Y.reduce((W,X)=>X.allPaths?W.concat(X.allPaths):W,[]);return V.length&&(T.allPaths=V),T}const oe=function(T,M,V){let W,X;for(let se=0,x=Y.length;se<x;se++){const ie=Y[se];ie.requiresSiblings&&V&&(M||(M=(0,L.basename)(T)),W||(W=M.substr(0,M.length-(0,L.extname)(T).length)));const ne=ie(T,M,W,V);if(typeof ne=="string")return ne;(0,i.isThenable)(ne)&&(X||(X=[]),X.push(ne))}return X?(async()=>{for(const se of X){const x=await se;if(typeof x=="string")return x}return null})():null},J=Y.find(T=>!!T.allBasenames);J&&(oe.allBasenames=J.allBasenames);const Q=Y.reduce((T,M)=>M.allPaths?T.concat(M.allPaths):T,[]);return Q.length&&(oe.allPaths=Q),oe}function G(z,B,Y){if(B===!1)return t;const ee=a(z,Y);if(ee===t)return t;if(typeof B=="boolean")return ee;if(B){const oe=B.when;if(typeof oe=="string"){const J=(Q,T,M,V)=>{if(!V||!ee(Q,T))return null;const W=oe.replace("$(basename)",M),X=V(W);return(0,i.isThenable)(X)?X.then(se=>se?z:null):X?z:null};return J.requiresSiblings=!0,J}}return ee}function H(z,B){const Y=z.filter(T=>!!T.basenames);if(Y.length<2)return z;const ee=Y.reduce((T,M)=>{const V=M.basenames;return V?T.concat(V):T},[]);let oe;if(B){oe=[];for(let T=0,M=ee.length;T<M;T++)oe.push(B)}else oe=Y.reduce((T,M)=>{const V=M.patterns;return V?T.concat(V):T},[]);const J=function(T,M){if(typeof T!="string")return null;if(!M){let W;for(W=T.length;W>0;W--){const X=T.charCodeAt(W-1);if(X===47||X===92)break}M=T.substr(W)}const V=ee.indexOf(M);return V!==-1?oe[V]:null};J.basenames=ee,J.patterns=oe,J.allBasenames=ee;const Q=z.filter(T=>!T.basenames);return Q.push(J),Q}function Z(z,B){return(0,D.equals)(z,B,(Y,ee)=>typeof Y=="string"&&typeof ee=="string"?Y===ee:typeof Y!="string"&&typeof ee!="string"?Y.base===ee.base&&Y.pattern===ee.pattern:!1)}e.patternsEquals=Z}),define(re[142],ae([0,1,7]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function i(C){return C.toJSON()}class R{constructor(b){this.a=b}transformIncoming(b){const w=this.a.transformIncoming(b);return w===b?b:i(D.URI.from(w))}transformOutgoing(b){const w=this.a.transformOutgoing(b);return w===b?b:i(D.URI.from(w))}transformOutgoingURI(b){const w=this.a.transformOutgoing(b);return w===b?b:D.URI.from(w)}transformOutgoingScheme(b){return this.a.transformOutgoingScheme(b)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function A(C,b,w){if(!C||w>200)return null;if(typeof C=="object"){if(C instanceof D.URI)return b.transformOutgoing(C);for(const y in C)if(Object.hasOwnProperty.call(C,y)){const d=A(C[y],b,w+1);d!==null&&(C[y]=d)}}return null}function L(C,b){const w=A(C,b,0);return w===null?C:w}e.transformOutgoingURIs=L;function P(C,b,w,y){if(!C||y>200)return null;if(typeof C=="object"){if(C.$mid===1)return w?D.URI.revive(b.transformIncoming(C)):b.transformIncoming(C);for(const d in C)if(Object.hasOwnProperty.call(C,d)){const g=P(C[d],b,w,y+1);g!==null&&(C[d]=g)}}return null}function I(C,b){const w=P(C,b,!1,0);return w===null?C:w}e.transformIncomingURIs=I;function S(C,b){const w=P(C,b,!0,0);return w===null?C:w}e.transformAndReviveIncomingURIs=S}),define(re[143],ae([0,1,34,9,48,31,129]),function(_,e,D,i,R,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(C){return this.a||(this.a=R.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(C)}value(){if(this.b===void 0){let C=0,b=0;const w=(0,D.networkInterfaces)();for(const y in w){const d=w[y];if(d)for(const{mac:g,internal:v}of d)v||(b+=1,this.c(g.toUpperCase())&&(C+=1))}this.b=b>0?C/b:0}return this.b}};let P;async function I(){return P||(P=(async()=>await S()||A.generateUuid())()),P}e.getMachineId=I;async function S(){try{const C=await new Promise((w,y)=>{_(["crypto"],w,y)}),b=(0,L.getMac)();return C.createHash("sha256").update(b,"utf8").digest("hex")}catch(C){i.onUnexpectedError(C);return}}}),define(re[28],ae([0,1,52,34,282,6,47,85,12,5,21,7]),function(_,e,D,i,R,A,L,P,I,S,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var w;(function($){$[$.UNLINK=0]="UNLINK",$[$.MOVE=1]="MOVE"})(w=e.RimRafMode||(e.RimRafMode={}));async function y($,G=w.UNLINK){if((0,L.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");return G===w.UNLINK?g($):d($)}async function d($){try{const G=(0,L.randomPath)((0,i.tmpdir)());try{await D.promises.rename($,G)}catch(H){return H.code==="ENOENT"?void 0:g($)}g(G).catch(H=>{})}catch(G){if(G.code!=="ENOENT")throw G}}async function g($){return(0,R.promisify)(D.rm)($,{recursive:!0,force:!0,maxRetries:3})}function v($){if((0,L.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync($,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=v;async function l($,G){return h(await(G?m($):(0,R.promisify)(D.readdir)($)))}async function m($){try{return await(0,R.promisify)(D.readdir)($,{withFileTypes:!0})}catch(Z){console.warn("[node.js fs] readdir with filetypes failed with error: ",Z)}const G=[],H=await l($);for(const Z of H){let z=!1,B=!1,Y=!1;try{const ee=await e.Promises.lstat((0,I.join)($,Z));z=ee.isFile(),B=ee.isDirectory(),Y=ee.isSymbolicLink()}catch(ee){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ee)}G.push({name:Z,isFile:()=>z,isDirectory:()=>B,isSymbolicLink:()=>Y})}return G}function u($){return h(D.readdirSync($))}e.readdirSync=u;function h($){return $.map(G=>typeof G=="string"?S.isMacintosh?(0,P.normalizeNFC)(G):G:(G.name=S.isMacintosh?(0,P.normalizeNFC)(G.name):G.name,G))}async function f($){const G=await l($),H=[];for(const Z of G)await s.existsDirectory((0,I.join)($,Z))&&H.push(Z);return H}function n($,G=1e3){return new Promise(H=>{let Z=!1;const z=setInterval(()=>{Z||(Z=!0,D.access($,B=>{Z=!1,B&&(clearInterval(z),H(void 0))}))},G)})}e.whenDeleted=n;var s;(function($){async function G(z){let B;try{if(B=await e.Promises.lstat(z),!B.isSymbolicLink())return{stat:B}}catch{}try{return{stat:await e.Promises.stat(z),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Y){if(Y.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(S.isWindows&&Y.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(z)),symbolicLink:{dangling:!1}}}catch(ee){if(ee.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw ee}throw Y}}$.stat=G;async function H(z){try{const{stat:B,symbolicLink:Y}=await $.stat(z);return B.isFile()&&Y?.dangling!==!0}catch{}return!1}$.existsFile=H;async function Z(z){try{const{stat:B,symbolicLink:Y}=await $.stat(z);return B.isDirectory()&&Y?.dangling!==!0}catch{}return!1}$.existsDirectory=Z})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new A.ResourceQueue;function a($,G,H){return t.queueFor(b.URI.file($),C.extUriBiasedIgnorePathCase).queue(()=>{const Z=E(H);return new Promise((z,B)=>o($,G,Z,Y=>Y?B(Y):z()))})}let r=!0;function c($){r=$}e.configureFlushOnWrite=c;function o($,G,H,Z){if(!r)return D.writeFile($,G,{mode:H.mode,flag:H.flag},Z);D.open($,H.flag,H.mode,(z,B)=>{if(z)return Z(z);D.writeFile(B,G,Y=>{if(Y)return D.close(B,()=>Z(Y));D.fdatasync(B,ee=>(ee&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ee),c(!1)),D.close(B,oe=>Z(oe))))})})}function p($,G,H){const Z=E(H);if(!r)return D.writeFileSync($,G,{mode:Z.mode,flag:Z.flag});const z=D.openSync($,Z.flag,Z.mode);try{D.writeFileSync(z,G);try{D.fdatasyncSync(z)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),c(!1)}}finally{D.closeSync(z)}}e.writeFileSync=p;function E($){return $?{mode:typeof $.mode=="number"?$.mode:438,flag:typeof $.flag=="string"?$.flag:"w"}:{mode:438,flag:"w"}}async function k($,G){if($!==G)try{await e.Promises.rename($,G)}catch(H){if($.toLowerCase()!==G.toLowerCase()&&H.code==="EXDEV"||$.endsWith("."))await F($,G,{preserveSymlinks:!1}),await y($,w.MOVE);else throw H}}async function F($,G,H){return q($,G,{root:{source:$,target:G},options:H,handledSourcePaths:new Set})}const N=511;async function q($,G,H){if(H.handledSourcePaths.has($))return;H.handledSourcePaths.add($);const{stat:Z,symbolicLink:z}=await s.stat($);if(z){if(H.options.preserveSymlinks)try{return await U($,G,H)}catch(B){console.warn("[node.js fs] copy of symlink failed: ",B)}if(z.dangling)return}return Z.isDirectory()?j($,G,Z.mode&N,H):O($,G,Z.mode&N)}async function j($,G,H,Z){await e.Promises.mkdir(G,{recursive:!0,mode:H});const z=await l($);for(const B of z)await q((0,I.join)($,B),(0,I.join)(G,B),Z)}async function O($,G,H){await e.Promises.copyFile($,G),await e.Promises.chmod(G,H)}async function U($,G,H){let Z=await e.Promises.readlink($);(0,L.isEqualOrParent)(Z,H.root.source,!S.isLinux)&&(Z=(0,I.join)(H.root.target,Z.substr(H.root.source.length+1))),await e.Promises.symlink(Z,G)}e.Promises=new class{get access(){return(0,R.promisify)(D.access)}get stat(){return(0,R.promisify)(D.stat)}get lstat(){return(0,R.promisify)(D.lstat)}get utimes(){return(0,R.promisify)(D.utimes)}get read(){return($,G,H,Z,z)=>new Promise((B,Y)=>{D.read($,G,H,Z,z,(ee,oe,J)=>ee?Y(ee):B({bytesRead:oe,buffer:J}))})}get readFile(){return(0,R.promisify)(D.readFile)}get write(){return($,G,H,Z,z)=>new Promise((B,Y)=>{D.write($,G,H,Z,z,(ee,oe,J)=>ee?Y(ee):B({bytesWritten:oe,buffer:J}))})}get appendFile(){return(0,R.promisify)(D.appendFile)}get fdatasync(){return(0,R.promisify)(D.fdatasync)}get truncate(){return(0,R.promisify)(D.truncate)}get rename(){return(0,R.promisify)(D.rename)}get copyFile(){return(0,R.promisify)(D.copyFile)}get open(){return(0,R.promisify)(D.open)}get close(){return(0,R.promisify)(D.close)}get symlink(){return(0,R.promisify)(D.symlink)}get readlink(){return(0,R.promisify)(D.readlink)}get chmod(){return(0,R.promisify)(D.chmod)}get mkdir(){return(0,R.promisify)(D.mkdir)}get unlink(){return(0,R.promisify)(D.unlink)}get rmdir(){return(0,R.promisify)(D.rmdir)}get realpath(){return(0,R.promisify)(D.realpath)}async exists($){try{return await e.Promises.access($),!0}catch{return!1}}get readdir(){return l}get readDirsInDir(){return f}get writeFile(){return a}get rm(){return y}get move(){return k}get copy(){return F}}}),define(re[144],ae([0,1,52,12,5,27,28]),function(_,e,D,i,R,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(w){if(R.isLinux)return w;const y=(0,i.dirname)(w);if(w===y)return w;const d=((0,i.basename)(w)||w).toLowerCase();try{const v=(0,L.readdirSync)(y).filter(l=>l.toLowerCase()===d);if(v.length===1){const l=P(y);if(l)return(0,i.join)(l,v[0])}else if(v.length>1){const l=v.indexOf(d);if(l>=0){const m=P(y);if(m)return(0,i.join)(m,v[l])}}}catch{}return null}e.realcaseSync=P;async function I(w){if(R.isLinux)return w;const y=(0,i.dirname)(w);if(w===y)return w;const d=((0,i.basename)(w)||w).toLowerCase();try{const v=(await L.Promises.readdir(y)).filter(l=>l.toLowerCase()===d);if(v.length===1){const l=await I(y);if(l)return(0,i.join)(l,v[0])}else if(v.length>1){const l=v.indexOf(d);if(l>=0){const m=await I(y);if(m)return(0,i.join)(m,v[l])}}}catch{}return null}e.realcase=I;async function S(w){try{return await L.Promises.realpath(w)}catch{const d=b(w);return await L.Promises.access(d,D.constants.R_OK),d}}e.realpath=S;function C(w){try{return D.realpathSync(w)}catch{const d=b(w);return D.accessSync(d,D.constants.R_OK),d}}e.realpathSync=C;function b(w){return(0,A.rtrim)((0,i.normalize)(w),i.sep)}}),define(re[90],ae([0,1,34,12,28]),function(_,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const A=/^\d+$/,L=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var I;(function(h){h[h.x64=0]="x64",h[h.x86=1]="x86",h[h.ARM=2]="ARM"})(I||(I={}));let S;switch(process.arch){case"ia32":case"x32":S=1;break;case"arm":case"arm64":S=2;break;default:S=0;break}let C;process.env.PROCESSOR_ARCHITEW6432?C=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?C=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?C=1:C=0;class b{constructor(f,n,s){this.exePath=f,this.displayName=n,this.a=s}async exists(){return this.a===void 0&&(this.a=await R.SymlinkSupport.existsFile(this.exePath)),this.a}}function w({useAlternateBitness:h=!1}={}){return h?S===0?process.env["ProgramFiles(x86)"]||null:C===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function y({useAlternateBitness:h=!1,findPreview:f=!1}={}){const n=w({useAlternateBitness:h});if(!n)return null;const s=i.join(n,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(s))return null;let t=-1,a=null;for(const o of await R.Promises.readdir(s)){let p=-1;if(f){const k=o.indexOf("-");if(k<0)continue;const F=o.substring(0,k);if(!A.test(F)||o.substring(k+1)!=="preview")continue;p=parseInt(F,10)}else{if(!A.test(o))continue;p=parseInt(o,10)}if(p<=t)continue;const E=i.join(s,o,"pwsh.exe");!await R.SymlinkSupport.existsFile(E)||(a=E,t=p)}if(!a)return null;const r=n.includes("x86")?" (x86)":"",c=f?" Preview":"";return new b(a,`PowerShell${c}${r}`,!0)}async function d({findPreview:h}={}){if(!process.env.LOCALAPPDATA)return null;const f=i.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(f))return null;const{pwshMsixDirRegex:n,pwshMsixName:s}=h?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:L,pwshMsixName:"PowerShell (Store)"};for(const t of await R.Promises.readdir(f))if(n.test(t)){const a=i.join(f,t,"pwsh.exe");return new b(a,s)}return null}function g(){const h=i.join(D.homedir(),".dotnet","tools","pwsh.exe");return new b(h,".NET Core PowerShell Global Tool")}function v(){const h=i.join(process.env.windir,S===1&&C!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(h,"Windows PowerShell",!0)}async function*l(){let h=await y();h&&(yield h),h=await y({useAlternateBitness:!0}),h&&(yield h),h=await d(),h&&(yield h),h=g(),h&&(yield h),h=await y({findPreview:!0}),h&&(yield h),h=await d({findPreview:!0}),h&&(yield h),h=await y({useAlternateBitness:!0,findPreview:!0}),h&&(yield h),h=v(),h&&(yield h)}async function*m(){for await(const h of l())await h.exists()&&(yield h)}e.enumeratePowerShellInstallations=m;async function u(){for await(const h of m())return h;return null}e.getFirstAvailablePowerShellInstallation=u}),define(re[91],ae([0,1,12,5,36,87,15,28]),function(_,e,D,i,R,A,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function I(b=R.env){return b.comspec||"cmd.exe"}e.getWindowsShell=I;function S(b){let w=[],y=!1;const d=function(g){if(y){w.push(g);return}(!b.send(g,l=>{if(l&&console.error(l),y=!1,w.length>0){const m=w.slice(0);w=[],m.forEach(u=>d(u))}})||i.isWindows)&&(y=!0)};return{send:d}}e.createQueuedSender=S;var C;(function(b){async function w(y,d,g){if(D.isAbsolute(y))return y;if(d===void 0&&(d=R.cwd()),D.dirname(y)!=="."||(g===void 0&&L.isString(R.env.PATH)&&(g=R.env.PATH.split(D.delimiter)),g===void 0||g.length===0))return D.join(d,y);async function l(m){if(await P.Promises.exists(m)){let u;try{u=await P.Promises.stat(m)}catch(h){h.message.startsWith("EACCES")&&(u=await P.Promises.lstat(m))}return u?!u.isDirectory():!1}return!1}for(const m of g){let u;if(D.isAbsolute(m)?u=D.join(m,y):u=D.join(d,m,y),await l(u))return u;let h=u+".com";if(await l(h)||(h=u+".exe",await l(h)))return h}return D.join(d,y)}b.findExecutable=w})(C=e.win32||(e.win32={}))}),define(re[145],ae([0,1,49,24]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function R(L){return new Promise((P,I)=>{let S;const C=new Map;function b(y,d,g,v,l){const m=C.get(d);if(y===L||m){const u={name:w(g),cmd:g,pid:y,ppid:d,load:v,mem:l};C.set(y,u),y===L&&(S=u),m&&(m.children||(m.children=[]),m.children.push(u),m.children.length>1&&(m.children=m.children.sort((h,f)=>h.pid-f.pid)))}}function w(y){const d=/--vscode-window-kind=shared-process/,g=/--vscode-window-kind=issue-reporter/,v=/--vscode-window-kind=process-explorer/,l=/--utility-sub-type=network/,m=/--utility-sub-type=node.mojom.NodeService/,u=/--crashes-directory/,h=/\\pipe\\winpty-control/,f=/conhost\.exe/,n=/--type=([a-zA-Z-]+)/;if(u.exec(y))return"electron-crash-reporter";if(h.exec(y))return"winpty-process";if(f.exec(y))return"console-window-host (Windows internal process)";let s=n.exec(y);if(s&&s.length===2){if(s[1]==="renderer")return d.exec(y)?"shared-process":g.exec(y)?"issue-reporter":v.exec(y)?"process-explorer":"window";if(s[1]==="utility"){if(l.exec(y))return"utility-network-service";if(m.exec(y))return"extension-host"}return s[1]}const t=/[a-zA-Z-]+\.js/g;let a="";do s=t.exec(y),s&&(a+=s+" ");while(s);return a&&y.indexOf("node ")<0&&y.indexOf("node.exe")<0?`electron_node ${a}`:y}if(process.platform==="win32"){const y=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,g)=>{_(["windows-process-tree"],d,g)}).then(d=>{d.getProcessList(L,g=>{if(!g){I(new Error(`Root process ${L} not found`));return}d.getProcessCpuUsage(g,v=>{const l=new Map;v.forEach(m=>{const u=y(m.commandLine||"");l.set(m.pid,{name:w(u),cmd:u,pid:m.pid,ppid:m.ppid,load:m.cpu||0,mem:m.memory||0})}),S=l.get(L),S?(l.forEach(m=>{const u=l.get(m.ppid);u&&(u.children||(u.children=[]),u.children.push(m))}),l.forEach(m=>{m.children&&(m.children=m.children.sort((u,h)=>u.pid-h.pid))}),P(S)):I(new Error(`Root process ${L} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let y=function(){let d=[S];const g=[];for(;d.length;){const l=d.shift();l&&(g.push(l.pid),l.children&&(d=d.concat(l.children)))}let v=JSON.stringify(i.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);v+=" "+g.join(" "),(0,D.exec)(v,{},(l,m,u)=>{if(l||u)I(l||new Error(u.toString()));else{const h=m.toString().split(`
`);for(let f=0;f<g.length;f++){const n=C.get(g[f]);n.load=parseFloat(h[f])}if(!S){I(new Error(`Root process ${L} not found`));return}P(S)}})};(0,D.exec)("which ps",{},(d,g,v)=>{if(d||v)if(process.platform!=="linux")I(d||new Error(v.toString()));else{const l=JSON.stringify(i.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,D.exec)(l,{},(m,u,h)=>{m||h?I(m||new Error(h.toString())):(A(u,b),y())})}else{const l=g.toString().trim(),m="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${l} ${m}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(u,h,f)=>{u||f&&!f.includes("screen size is bogus")?I(u||new Error(f.toString())):(A(h,b),process.platform==="linux"?y():S?P(S):I(new Error(`Root process ${L} not found`)))})}})}})}e.listProcesses=R;function A(L,P){const I=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,S=L.toString().split(`
`);for(const C of S){const b=I.exec(C.trim());b&&b.length===6&&P(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}}),define(re[146],ae([0,1,34,5,90,91]),function(_,e,D,i,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function L(y,d){return y===1?i.isWindows?b():A.getWindowsShell(d):S(y,d)}e.getSystemShell=L;function P(y,d){return y===1?i.isWindows?w(d):A.getWindowsShell(d):S(y,d)}e.getSystemShellSync=P;let I=null;function S(y,d){if(i.isLinux&&y===2||i.isMacintosh&&y===3)return"/bin/bash";if(!I){let g;if(i.isWindows)g="/bin/bash";else{if(g=d.SHELL,!g)try{g=(0,D.userInfo)().shell}catch{}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}I=g}return I}let C=null;async function b(){return C||(C=(await(0,R.getFirstAvailablePowerShellInstallation)()).exePath),C}function w(y){if(C)return C;const d=i.isWindows&&parseFloat((0,D.release)())>=10,g=y.hasOwnProperty("PROCESSOR_ARCHITEW6432"),v=`${y.windir}\\${g?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?v:A.getWindowsShell(y)}});var ye=this&&this.__decorate||function(_,e,D,i){var R=arguments.length,A=R<3?e:i===null?i=Object.getOwnPropertyDescriptor(e,D):i,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(_,e,D,i);else for(var P=_.length-1;P>=0;P--)(L=_[P])&&(A=(R<3?L(A):R>3?L(e,D,A):L(e,D))||A);return R>3&&A&&Object.defineProperty(e,D,A),A};define(re[39],ae([0,1,20,6,17,23,63,9,3,2,67,27,15]),function(_,e,D,i,R,A,L,P,I,S,C,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=void 0;var y;(function(z){z[z.Promise=100]="Promise",z[z.PromiseCancel=101]="PromiseCancel",z[z.EventListen=102]="EventListen",z[z.EventDispose=103]="EventDispose"})(y||(y={}));function d(z){switch(z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(z){z[z.Initialize=200]="Initialize",z[z.PromiseSuccess=201]="PromiseSuccess",z[z.PromiseError=202]="PromiseError",z[z.PromiseErrorObj=203]="PromiseErrorObj",z[z.EventFire=204]="EventFire"})(g||(g={}));function v(z){switch(z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(z){z[z.Uninitialized=0]="Uninitialized",z[z.Idle=1]="Idle"})(l||(l={}));class m{constructor(B){this.b=B,this.a=0}read(B){const Y=this.b.slice(this.a,this.a+B);return this.a+=Y.byteLength,Y}}class u{constructor(){this.a=[]}get buffer(){return R.VSBuffer.concat(this.a)}write(B){this.a.push(B)}}var h;(function(z){z[z.Undefined=0]="Undefined",z[z.String=1]="String",z[z.Buffer=2]="Buffer",z[z.VSBuffer=3]="VSBuffer",z[z.Array=4]="Array",z[z.Object=5]="Object"})(h||(h={}));function f(z){const B=R.VSBuffer.alloc(4);return B.writeUInt32BE(z,0),B}function n(z){return z.read(4).readUInt32BE(0)}function s(z){const B=R.VSBuffer.alloc(1);return B.writeUInt8(z,0),B}const t={Undefined:s(h.Undefined),String:s(h.String),Buffer:s(h.Buffer),VSBuffer:s(h.VSBuffer),Array:s(h.Array),Object:s(h.Object)},a=typeof Buffer<"u";function r(z,B){if(typeof B>"u")z.write(t.Undefined);else if(typeof B=="string"){const Y=R.VSBuffer.fromString(B);z.write(t.String),z.write(f(Y.byteLength)),z.write(Y)}else if(a&&Buffer.isBuffer(B)){const Y=R.VSBuffer.wrap(B);z.write(t.Buffer),z.write(f(Y.byteLength)),z.write(Y)}else if(B instanceof R.VSBuffer)z.write(t.VSBuffer),z.write(f(B.byteLength)),z.write(B);else if(Array.isArray(B)){z.write(t.Array),z.write(f(B.length));for(const Y of B)r(z,Y)}else{const Y=R.VSBuffer.fromString(JSON.stringify(B));z.write(t.Object),z.write(f(Y.byteLength)),z.write(Y)}}function c(z){switch(z.read(1).readUInt8(0)){case h.Undefined:return;case h.String:return z.read(n(z)).toString();case h.Buffer:return z.read(n(z)).buffer;case h.VSBuffer:return z.read(n(z));case h.Array:{const Y=n(z),ee=[];for(let oe=0;oe<Y;oe++)ee.push(c(z));return ee}case h.Object:return JSON.parse(z.read(n(z)).toString())}}class o{constructor(B,Y,ee=null,oe=1e3){this.h=B,this.j=Y,this.k=ee,this.l=oe,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(J=>this.p(J)),this.m({type:200})}registerChannel(B,Y){this.b.set(B,Y),setTimeout(()=>this.v(B),0)}m(B){switch(B.type){case 200:{const Y=this.n([B.type]);this.k?.logOutgoing(Y,0,1,v(B.type));return}case 201:case 202:case 204:case 203:{const Y=this.n([B.type,B.id],B.data);this.k?.logOutgoing(Y,B.id,1,v(B.type),B.data);return}}}n(B,Y=void 0){const ee=new u;return r(ee,B),r(ee,Y),this.o(ee.buffer)}o(B){try{return this.h.send(B),B.byteLength}catch{return 0}}p(B){const Y=new m(B),ee=c(Y),oe=c(Y),J=ee[0];switch(J){case 100:return this.k?.logIncoming(B.byteLength,ee[1],1,`${d(J)}: ${ee[2]}.${ee[3]}`,oe),this.q({type:J,id:ee[1],channelName:ee[2],name:ee[3],arg:oe});case 102:return this.k?.logIncoming(B.byteLength,ee[1],1,`${d(J)}: ${ee[2]}.${ee[3]}`,oe),this.s({type:J,id:ee[1],channelName:ee[2],name:ee[3],arg:oe});case 101:return this.k?.logIncoming(B.byteLength,ee[1],1,`${d(J)}`),this.t({type:J,id:ee[1]});case 103:return this.k?.logIncoming(B.byteLength,ee[1],1,`${d(J)}`),this.t({type:J,id:ee[1]})}}q(B){const Y=this.b.get(B.channelName);if(!Y){this.u(B);return}const ee=new A.CancellationTokenSource;let oe;try{oe=Y.call(this.j,B.name,B.arg,ee.token)}catch(T){oe=Promise.reject(T)}const J=B.id;oe.then(T=>{this.m({id:J,data:T,type:201}),this.d.delete(B.id)},T=>{T instanceof Error?this.m({id:J,data:{message:T.message,name:T.name,stack:T.stack?T.stack.split?T.stack.split(`
`):T.stack:void 0},type:202}):this.m({id:J,data:T,type:203}),this.d.delete(B.id)});const Q=(0,S.toDisposable)(()=>ee.cancel());this.d.set(B.id,Q)}s(B){const Y=this.b.get(B.channelName);if(!Y){this.u(B);return}const ee=B.id,J=Y.listen(this.j,B.name,B.arg)(Q=>this.m({id:ee,data:Q,type:204}));this.d.set(B.id,J)}t(B){const Y=this.d.get(B.id);Y&&(Y.dispose(),this.d.delete(B.id))}u(B){let Y=this.g.get(B.channelName);Y||(Y=[],this.g.set(B.channelName,Y));const ee=setTimeout(()=>{console.error(`Unknown channel: ${B.channelName}`),B.type===100&&this.m({id:B.id,data:{name:"Unknown channel",message:`Channel name '${B.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Y.push({request:B,timeoutTimer:ee})}v(B){const Y=this.g.get(B);if(Y){for(const ee of Y)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case 100:this.q(ee.request);break;case 102:this.s(ee.request);break}this.g.delete(B)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,S.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=o;var p;(function(z){z[z.LocalSide=0]="LocalSide",z[z.OtherSide=1]="OtherSide"})(p=e.RequestInitiator||(e.RequestInitiator={}));class E{constructor(B,Y=null){this.l=B,this.a=!1,this.b=l.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new I.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ee=>this.r(ee)),this.j=Y}getChannel(B){const Y=this;return{call(ee,oe,J){return Y.a?Promise.reject(new P.CancellationError):Y.m(B,ee,oe,J)},listen(ee,oe){return Y.a?I.Event.None:Y.n(B,ee,oe)}}}m(B,Y,ee,oe=A.CancellationToken.None){const J=this.g++,T={id:J,type:100,channelName:B,name:Y,arg:ee};if(oe.isCancellationRequested)return Promise.reject(new P.CancellationError);let M;return new Promise((W,X)=>{if(oe.isCancellationRequested)return X(new P.CancellationError);const se=()=>{const le=ue=>{switch(ue.type){case 201:this.f.delete(J),W(ue.data);break;case 202:{this.f.delete(J);const pe=new Error(ue.data.message);pe.stack=Array.isArray(ue.data.stack)?ue.data.stack.join(`
`):ue.data.stack,pe.name=ue.data.name,X(pe);break}case 203:this.f.delete(J),X(ue.data);break}};this.f.set(J,le),this.o(T)};let x=null;this.b===l.Idle?se():(x=(0,i.createCancelablePromise)(le=>this.t()),x.then(()=>{x=null,se()}));const ie=()=>{x?(x.cancel(),x=null):this.o({id:J,type:101}),X(new P.CancellationError)},ne=oe.onCancellationRequested(ie);M=(0,S.combinedDisposable)((0,S.toDisposable)(ie),ne),this.d.add(M)}).finally(()=>{this.d.delete(M)})}n(B,Y,ee){const oe=this.g++,Q={id:oe,type:102,channelName:B,name:Y,arg:ee};let T=null;const M=new I.Emitter({onWillAddFirstListener:()=>{T=(0,i.createCancelablePromise)(W=>this.t()),T.then(()=>{T=null,this.d.add(M),this.o(Q)})},onDidRemoveLastListener:()=>{T?(T.cancel(),T=null):(this.d.delete(M),this.o({id:oe,type:103}))}}),V=W=>M.fire(W.data);return this.f.set(oe,V),M.event}o(B){switch(B.type){case 100:case 102:{const Y=this.p([B.type,B.id,B.channelName,B.name],B.arg);this.j?.logOutgoing(Y,B.id,0,`${d(B.type)}: ${B.channelName}.${B.name}`,B.arg);return}case 101:case 103:{const Y=this.p([B.type,B.id]);this.j?.logOutgoing(Y,B.id,0,d(B.type));return}}}p(B,Y=void 0){const ee=new u;return r(ee,B),r(ee,Y),this.q(ee.buffer)}q(B){try{return this.l.send(B),B.byteLength}catch{return 0}}r(B){const Y=new m(B),ee=c(Y),oe=c(Y),J=ee[0];switch(J){case 200:return this.j?.logIncoming(B.byteLength,0,0,v(J)),this.s({type:ee[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(B.byteLength,ee[1],0,v(J),oe),this.s({type:ee[0],id:ee[1],data:oe})}}s(B){if(B.type===200){this.b=l.Idle,this.k.fire();return}this.f.get(B.id)?.(B)}get onDidInitializePromise(){return I.Event.toPromise(this.onDidInitialize)}t(){return this.b===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,S.dispose)(this.d.values()),this.d.clear()}}ye([L.memoize],E.prototype,"onDidInitializePromise",null),e.ChannelClient=E;class k{get connections(){const B=[];return this.f.forEach(Y=>B.push(Y)),B}constructor(B){this.a=new Map,this.f=new Set,this.g=new I.Emitter,this.onDidAddConnection=this.g.event,this.h=new I.Emitter,this.onDidRemoveConnection=this.h.event,B(({protocol:Y,onDidClientDisconnect:ee})=>{I.Event.once(Y.onMessage)(J=>{const Q=new m(J),T=c(Q),M=new o(Y,T),V=new E(Y);this.a.forEach((X,se)=>M.registerChannel(se,X));const W={channelServer:M,channelClient:V,ctx:T};this.f.add(W),this.g.fire(W),ee(()=>{M.dispose(),V.dispose(),this.f.delete(W),this.h.fire(W)})})})}getChannel(B,Y){const ee=this;return{call(oe,J,Q){let T;if((0,w.isFunction)(Y)){const V=(0,D.getRandomElement)(ee.connections.filter(Y));T=V?Promise.resolve(V):I.Event.toPromise(I.Event.filter(ee.onDidAddConnection,Y))}else T=Y.routeCall(ee,oe,J);const M=T.then(V=>V.channelClient.getChannel(B));return N(M).call(oe,J,Q)},listen(oe,J){if((0,w.isFunction)(Y))return ee.j(B,Y,oe,J);const Q=Y.routeEvent(ee,oe,J).then(T=>T.channelClient.getChannel(B));return N(Q).listen(oe,J)}}}j(B,Y,ee,oe){const J=this;let Q=new S.DisposableStore;const T=new I.Emitter({onWillAddFirstListener:()=>{Q=new S.DisposableStore;const M=new I.EventMultiplexer,V=new Map,W=se=>{const ie=se.channelClient.getChannel(B).listen(ee,oe),ne=M.add(ie);V.set(se,ne)},X=se=>{const x=V.get(se);!x||(x.dispose(),V.delete(se))};J.connections.filter(Y).forEach(W),I.Event.filter(J.onDidAddConnection,Y)(W,void 0,Q),J.onDidRemoveConnection(X,void 0,Q),M.event(T.fire,T,Q),Q.add(M)},onDidRemoveLastListener:()=>{Q.dispose()}});return T.event}registerChannel(B,Y){this.a.set(B,Y),this.f.forEach(ee=>{ee.channelServer.registerChannel(B,Y)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=k;class F{constructor(B,Y,ee=null){const oe=new u;r(oe,Y),B.send(oe.buffer),this.a=new E(B,ee),this.d=new o(B,Y,ee)}getChannel(B){return this.a.getChannel(B)}registerChannel(B,Y){this.d.registerChannel(B,Y)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=F;function N(z){return{call(B,Y,ee){return z.then(oe=>oe.call(B,Y,ee))},listen(B,Y){const ee=new I.Relay;return z.then(oe=>ee.input=oe.listen(B,Y)),ee.event}}}e.getDelayedChannel=N;function q(z){let B=!1;return{call(Y,ee,oe){return B?z.call(Y,ee,oe):(0,i.timeout)(0).then(()=>B=!0).then(()=>z.call(Y,ee,oe))},listen(Y,ee){if(B)return z.listen(Y,ee);const oe=new I.Relay;return(0,i.timeout)(0).then(()=>B=!0).then(()=>oe.input=z.listen(Y,ee)),oe.event}}}e.getNextTickChannel=q;class j{constructor(B){this.a=B}routeCall(B){return this.b(B)}routeEvent(B){return this.b(B)}async b(B){for(const Y of B.connections)if(await Promise.resolve(this.a(Y.ctx)))return Promise.resolve(Y);return await I.Event.toPromise(B.onDidAddConnection),await this.b(B)}}e.StaticRouter=j;var O;(function(z){function B(J,Q){const T=J,M=Q&&Q.disableMarshalling,V=new Map;for(const W in T)ee(W)&&V.set(W,I.Event.buffer(T[W],!0));return new class{listen(W,X,se){const x=V.get(X);if(x)return x;if(oe(X)){const ie=T[X];if(typeof ie=="function")return ie.call(T,se)}throw new Error(`Event not found: ${X}`)}call(W,X,se){const x=T[X];if(typeof x=="function"){if(!M&&Array.isArray(se))for(let ie=0;ie<se.length;ie++)se[ie]=(0,C.revive)(se[ie]);return x.apply(T,se)}throw new Error(`Method not found: ${X}`)}}}z.fromService=B;function Y(J,Q){const T=Q&&Q.disableMarshalling;return new Proxy({},{get(M,V){if(typeof V=="string")return Q?.properties?.has(V)?Q.properties.get(V):oe(V)?function(W){return J.listen(V,W)}:ee(V)?J.listen(V):async function(...W){let X;Q&&!(0,w.isUndefinedOrNull)(Q.context)?X=[Q.context,...W]:X=W;const se=await J.call(V,X);return T?se:(0,C.revive)(se)};throw new Error(`Property not found: ${String(V)}`)}})}z.toService=Y;function ee(J){return J[0]==="o"&&J[1]==="n"&&b.isUpperAsciiLetter(J.charCodeAt(2))}function oe(J){return/^onDynamic/.test(J)&&b.isUpperAsciiLetter(J.charCodeAt(9))}})(O=e.ProxyChannel||(e.ProxyChannel={}));const U=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function $(z){if(Array.isArray(z))return z;if(z&&typeof z=="object"&&typeof z.toString=="function"){const B=z.toString();if(B!=="[object Object]")return B}return z}function G(z){return Array.isArray(z)?z.map($):$(z)}function H(z,B,Y,ee,oe,J,Q){Q=G(Q);const T=U[oe],M=T[ee%T.length];let V=[`%c[${z}]%c[${String(B).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${J}`,"color: darkgreen","color: grey","color: grey",`color: ${M}`];/\($/.test(J)?(V=V.concat(Q),V.push(")")):V.push(Q),console.log.apply(console,V)}class Z{constructor(B,Y){this.d=B,this.f=Y,this.a=0,this.b=0}logOutgoing(B,Y,ee,oe,J){this.b+=B,H(this.d,this.b,B,Y,ee,oe,J)}logIncoming(B,Y,ee,oe,J){this.a+=B,H(this.f,this.a,B,Y,ee,oe,J)}}e.IPCLogger=Z}),define(re[147],ae([0,1,17,3,39]),function(_,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class A{constructor(I){this.a=I,this.onMessage=i.Event.fromDOMEventEmitter(this.a,"message",S=>D.VSBuffer.wrap(S.data)),I.start()}send(I){this.a.postMessage(I.buffer)}disconnect(){this.a.close()}}e.Protocol=A;class L extends R.IPCClient{constructor(I,S){const C=new A(I);super(C,S),this.b=C}dispose(){this.b.disconnect()}}e.Client=L}),define(re[92],ae([0,1,17,3,2,39]),function(_,e,D,i,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var L;(function(a){a.Created="created",a.Read="read",a.Write="write",a.Open="open",a.Error="error",a.Close="close",a.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",a.NodeEndReceived="nodeEndReceived",a.NodeEndSent="nodeEndSent",a.NodeDrainBegin="nodeDrainBegin",a.NodeDrainEnd="nodeDrainEnd",a.zlibInflateError="zlibInflateError",a.zlibInflateData="zlibInflateData",a.zlibInflateInitialWrite="zlibInflateInitialWrite",a.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",a.zlibInflateWrite="zlibInflateWrite",a.zlibInflateFlushFired="zlibInflateFlushFired",a.zlibDeflateError="zlibDeflateError",a.zlibDeflateData="zlibDeflateData",a.zlibDeflateWrite="zlibDeflateWrite",a.zlibDeflateFlushFired="zlibDeflateFlushFired",a.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",a.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",a.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",a.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",a.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",a.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",a.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",a.ProtocolHeaderRead="protocolHeaderRead",a.ProtocolMessageRead="protocolMessageRead",a.ProtocolHeaderWrite="protocolHeaderWrite",a.ProtocolMessageWrite="protocolMessageWrite",a.ProtocolWrite="protocolWrite"})(L=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var P;(function(a){a.enableDiagnostics=!1,a.records=[];const r=new WeakMap;let c=0;function o(E,k){if(!r.has(E)){const F=String(++c);r.set(E,F)}return r.get(E)}function p(E,k,F,N){if(!a.enableDiagnostics)return;const q=o(E,k);if(N instanceof D.VSBuffer||N instanceof Uint8Array||N instanceof ArrayBuffer||ArrayBuffer.isView(N)){const j=D.VSBuffer.alloc(N.byteLength);j.set(N),a.records.push({timestamp:Date.now(),id:q,label:k,type:F,buff:j})}else a.records.push({timestamp:Date.now(),id:q,label:k,type:F,data:N})}a.traceSocketEvent=p})(P=e.SocketDiagnostics||(e.SocketDiagnostics={}));var I;(function(a){a[a.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",a[a.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(I=e.SocketCloseEventType||(e.SocketCloseEventType={}));let S=null;function C(){return S||(S=D.VSBuffer.alloc(0)),S}class b{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(r){this.a.push(r),this.b+=r.byteLength}read(r){return this.c(r,!0)}peek(r){return this.c(r,!1)}c(r,c){if(r===0)return C();if(r>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===r){const k=this.a[0];return c&&(this.a.shift(),this.b-=r),k}if(this.a[0].byteLength>r){const k=this.a[0].slice(0,r);return c&&(this.a[0]=this.a[0].slice(r),this.b-=r),k}const o=D.VSBuffer.alloc(r);let p=0,E=0;for(;r>0;){const k=this.a[E];if(k.byteLength>r){const F=k.slice(0,r);o.set(F,p),p+=r,c&&(this.a[E]=k.slice(r),this.b-=r),r-=r}else o.set(k,p),p+=k.byteLength,c?(this.a.shift(),this.b-=k.byteLength):E++,r-=k.byteLength}return o}}e.ChunkStream=b;var w;(function(a){a[a.None=0]="None",a[a.Regular=1]="Regular",a[a.Control=2]="Control",a[a.Ack=3]="Ack",a[a.Disconnect=5]="Disconnect",a[a.ReplayRequest=6]="ReplayRequest",a[a.Pause=7]="Pause",a[a.Resume=8]="Resume",a[a.KeepAlive=9]="KeepAlive"})(w||(w={}));function y(a){switch(a){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var d;(function(a){a[a.HeaderLength=13]="HeaderLength",a[a.AcknowledgeTime=2e3]="AcknowledgeTime",a[a.TimeoutTime=2e4]="TimeoutTime",a[a.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",a[a.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(d=e.ProtocolConstants||(e.ProtocolConstants={}));class g{constructor(r,c,o,p){this.type=r,this.id=c,this.ack=o,this.data=p,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends R.Disposable{constructor(r){super(),this.f=this.B(new i.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=r,this.b=!1,this.c=new b,this.B(this.a.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(r);this.c.byteLength>=this.g.readLen;){const c=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=c.readUInt32BE(9),this.g.messageType=c.readUInt8(0),this.g.id=c.readUInt32BE(1),this.g.ack=c.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:y(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const o=this.g.messageType,p=this.g.id,E=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",c),this.f.fire(new g(o,p,E,c)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class l{constructor(r){this.k=null,this.a=!1,this.b=!1,this.c=r,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(r){if(this.a)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=D.VSBuffer.alloc(13);c.writeUInt8(r.type,0),c.writeUInt32BE(r.id,1),c.writeUInt32BE(r.ack,5),c.writeUInt32BE(r.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:y(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",r.data),this.j(c,r.data)}g(r,c){const o=this.f===0;return this.d.push(r,c),this.f+=r.byteLength+c.byteLength,o}h(){const r=D.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,r}j(r,c){this.g(r,c)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const r=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this.c.write(r)}}class m extends R.Disposable{constructor(r){super(),this.f=new i.Emitter,this.onMessage=this.f.event,this.g=new i.Emitter,this.onDidDispose=this.g.event,this.a=r,this.b=this.B(new l(this.a)),this.c=this.B(new v(this.a)),this.B(this.c.onMessage(c=>{c.type===1&&this.f.fire(c.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(r){this.b.write(new g(1,0,0,r))}}e.Protocol=m;class u extends A.IPCClient{static fromSocket(r,c){return new u(new m(r),c)}get onDidDispose(){return this.b.onDidDispose}constructor(r,c,o=null){super(r,c,o),this.b=r}dispose(){super.dispose();const r=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),r.end()}}e.Client=u;class h{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new i.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(r){this.b?this.d.length>0?this.d.push(r):this.a.fire(r):this.d.push(r)}flushBuffer(){this.d=[]}}e.BufferedEmitter=h;class f{constructor(r){this.data=r,this.next=null}}class n{constructor(){this.a=null,this.b=null}length(){let r=0,c=this.a;for(;c;)c=c.next,r++;return r}peek(){return this.a?this.a.data:null}toArray(){const r=[];let c=0,o=this.a;for(;o;)r[c++]=o.data,o=o.next;return r}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(r){const c=new f(r);if(!this.a){this.a=c,this.b=c;return}this.b.next=c,this.b=c}}class s{static getInstance(){return s.b||(s.b=new s),s.b}constructor(){this.c=[];const r=Date.now();for(let c=0;c<s.a;c++)this.c[c]=r-1e3*c;setInterval(()=>{for(let c=s.a;c>=1;c--)this.c[c]=this.c[c-1];this.c[0]=Date.now()},1e3)}d(){const r=Date.now(),c=(1+s.a)*1e3;let o=0;for(let p=0;p<s.a;p++)r-this.c[p]<=c&&o++;return 1-o/s.a}hasHighLoad(){return this.d()>=.5}}s.a=10,s.b=null;class t{get unacknowledgedCount(){return this.c-this.d}constructor(r,c=null,o=s.getInstance()){this.t=new h,this.onControlMessage=this.t.event,this.u=new h,this.onMessage=this.u.event,this.v=new h,this.onDidDispose=this.v.event,this.w=new h,this.onSocketClose=this.w.event,this.x=new h,this.onSocketTimeout=this.x.event,this.s=o,this.a=!1,this.b=new n,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=[],this.o=r,this.p=new l(this.o),this.r.push(this.p),this.q=new v(this.o),this.r.push(this.q),this.r.push(this.q.onMessage(p=>this.y(p))),this.r.push(this.o.onClose(p=>this.w.fire(p))),c&&this.q.acceptChunk(c),this.l=setInterval(()=>{this.C()},5e3)}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r=(0,R.dispose)(this.r)}drain(){return this.p.drain()}sendDisconnect(){const r=new g(5,0,0,C());this.p.write(r),this.p.flush()}sendPause(){const r=new g(7,0,0,C());this.p.write(r)}sendResume(){const r=new g(8,0,0,C());this.p.write(r)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(r,c){this.a=!0,this.r=(0,R.dispose)(this.r),this.t.flushBuffer(),this.w.flushBuffer(),this.x.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=r,this.p=new l(this.o),this.r.push(this.p),this.q=new v(this.o),this.r.push(this.q),this.r.push(this.q.onMessage(o=>this.y(o))),this.r.push(this.o.onClose(o=>this.w.fire(o))),this.q.acceptChunk(c)}endAcceptReconnection(){this.a=!1,this.h=this.g;const r=new g(3,0,this.h,C());this.p.write(r);const c=this.b.toArray();for(let o=0,p=c.length;o<p;o++)this.p.write(c[o]);this.A()}acceptDisconnect(){this.v.fire()}y(r){if(r.ack>this.d){this.d=r.ack;do{const c=this.b.peek();if(c&&c.id<=r.ack)this.b.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this.g)if(r.id!==this.g+1){const c=Date.now();c-this.m>1e4&&(this.m=c,this.p.write(new g(6,0,0,C())))}else this.g=r.id,this.j=Date.now(),this.z(),this.u.fire(r.data);break}case 2:{this.t.fire(r.data);break}case 3:break;case 5:{this.v.fire();break}case 6:{const c=this.b.toArray();for(let o=0,p=c.length;o<p;o++)this.p.write(c[o]);this.A();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(r){const c=++this.c;this.h=this.g;const o=new g(1,c,this.h,r);this.b.push(o),this.a||(this.p.write(o),this.A())}sendControl(r){const c=new g(2,0,0,r);this.p.write(c)}z(){if(this.g<=this.h||this.k)return;const r=Date.now()-this.j;if(r>=2e3){this.B();return}this.k=setTimeout(()=>{this.k=null,this.z()},2e3-r+5)}A(){if(this.c<=this.d||this.f||this.a)return;const r=this.b.peek(),c=Date.now()-r.writtenTime,o=Date.now()-this.q.lastReadTime,p=Date.now()-this.n;if(c>=2e4&&o>=2e4&&p>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.x.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:c,timeSinceLastReceivedSomeData:o});return}const E=Math.max(2e4-c,2e4-o,2e4-p,500);this.f=setTimeout(()=>{this.f=null,this.A()},E)}B(){if(this.g<=this.h)return;this.h=this.g;const r=new g(3,0,this.h,C());this.p.write(r)}C(){const r=new g(9,0,0,C());this.p.write(r)}}e.PersistentProtocol=t}),define(re[148],ae([0,1,93,3,39,147]),function(_,e,D,i,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class L extends R.IPCServer{static b(){const I=i.Event.fromNodeEventEmitter(D.ipcRenderer,"vscode:createMessageChannel",(S,C)=>C);return i.Event.map(I,S=>{const{port1:C,port2:b}=new MessageChannel,y={protocol:new A.Protocol(C),onDidClientDisconnect:i.Event.fromDOMEventEmitter(C,"close")};return D.ipcRenderer.postMessage("vscode:createMessageChannelResult",S,[b]),y})}constructor(){super(L.b())}}e.Server=L}),define(re[68],ae([0,1,49,6,17,23,141,9,3,2,32,91,87,39]),function(_,e,D,i,R,A,L,P,I,S,C,b,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends y.ChannelServer{constructor(l){super({send:m=>{try{process.send?.(m.buffer.toString("base64"))}catch{}},onMessage:I.Event.fromNodeEventEmitter(process,"message",m=>R.VSBuffer.wrap(Buffer.from(m,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.Server=d;class g{constructor(l,m){this.i=l,this.j=m,this.c=new Set,this.g=new Map,this.h=new I.Emitter,this.onDidProcessExit=this.h.event;const u=m&&m.timeout?m.timeout:6e4;this.b=new i.Delayer(u),this.d=null,this.f=null}getChannel(l){const m=this;return{call(u,h,f){return m.k(l,u,h,f)},listen(u,h){return m.l(l,u,h)}}}k(l,m,u,h=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(h.isCancellationRequested)return Promise.reject(P.canceled());this.b.cancel();const f=this.n(l),n=(0,i.createCancelablePromise)(a=>f.call(m,u,a)),s=h.onCancellationRequested(()=>n.cancel()),t=(0,S.toDisposable)(()=>n.cancel());return this.c.add(t),n.finally(()=>{s.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),n}l(l,m,u){if(!this.b)return I.Event.None;this.b.cancel();let h;const f=new I.Emitter({onWillAddFirstListener:()=>{h=this.n(l).listen(m,u)(f.fire,f),this.c.add(h)},onDidRemoveLastListener:()=>{this.c.delete(h),h.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return f.event}get m(){if(!this.f){const l=this.j&&this.j.args?this.j.args:[],m=Object.create(null);m.env={...(0,C.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(m.env={...m.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(m.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r))),(0,w.removeDangerousEnvVariables)(m.env),this.d=(0,D.fork)(this.i,l,m);const u=new I.Emitter;I.Event.fromNodeEventEmitter(this.d,"message",r=>r)(r=>{if((0,L.isRemoteConsoleLog)(r)){(0,L.log)(r,`IPC Library: ${this.j.serverName}`);return}u.fire(R.VSBuffer.wrap(Buffer.from(r,"base64")))});const f=this.j.useQueue?(0,b.createQueuedSender)(this.d):this.d,n=r=>this.d&&this.d.connected&&f.send(r.buffer.toString("base64")),s=u.event,t={send:n,onMessage:s};this.f=new y.ChannelClient(t);const a=()=>this.o();process.once("exit",a),this.d.on("error",r=>console.warn('IPC "'+this.j.serverName+'" errored with '+r)),this.d.on("exit",(r,c)=>{process.removeListener("exit",a),this.c.forEach(o=>(0,S.dispose)(o)),this.c.clear(),r!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+r+" and signal "+c),this.b?.cancel(),this.o(),this.h.fire({code:r,signal:c})})}return this.f}n(l){let m=this.g.get(l);return m||(m=this.m.getChannel(l),this.g.set(l,m)),m}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=g}),define(re[149],ae([0,1,17,9,3,2,12,5,31,39,92]),function(_,e,D,i,R,A,L,P,I,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function b(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class w{traceSocketEvent(o,p){C.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,o,p)}constructor(o,p=""){this.f=!0,this.debugLabel=p,this.socket=o,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=E=>{if(this.traceSocketEvent("error",{code:E?.code,message:E?.message}),E){if(E.code==="EPIPE")return;(0,i.onUnexpectedError)(E)}},this.socket.on("error",this.a),this.b=E=>{this.traceSocketEvent("close",{hadError:E}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(o){const p=E=>{this.traceSocketEvent("read",E),o(D.VSBuffer.wrap(E))};return this.socket.on("data",p),{dispose:()=>this.socket.off("data",p)}}onClose(o){const p=E=>{o({type:0,hadError:E,error:void 0})};return this.socket.on("close",p),{dispose:()=>this.socket.off("close",p)}}onEnd(o){const p=()=>{o()};return this.socket.on("end",p),{dispose:()=>this.socket.off("end",p)}}write(o){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",o),this.socket.write(o.buffer,p=>{if(p){if(p.code==="EPIPE")return;(0,i.onUnexpectedError)(p)}})}catch(p){if(p.code==="EPIPE")return;(0,i.onUnexpectedError)(p)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((o,p)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),o();return}const E=()=>{this.socket.off("close",E),this.socket.off("end",E),this.socket.off("error",E),this.socket.off("timeout",E),this.socket.off("drain",E),this.traceSocketEvent("nodeDrainEnd"),o()};this.socket.on("close",E),this.socket.on("end",E),this.socket.on("error",E),this.socket.on("timeout",E),this.socket.on("drain",E)})}}e.NodeSocket=w;var y;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(y||(y={}));var d;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(d||(d={}));class g extends A.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(o,p){this.socket.traceSocketEvent(o,p)}constructor(o,p,E,k){super(),this.f=this.B(new R.Emitter),this.g=this.B(new R.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=o,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:p,inflateBytesLength:E?.byteLength||0,recordInflateBytes:k}),this.a=this.B(new v(this,p,E,k,this.f,(F,N)=>this.k(F,N))),this.B(this.a.onError(F=>{console.error(F),(0,i.onUnexpectedError)(F),this.g.fire({type:0,hadError:!0,error:F})})),this.b=new C.ChunkStream,this.B(this.socket.onData(F=>this.l(F))),this.B(this.socket.onClose(F=>this.g.fire(F)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(o){return this.f.event(o)}onClose(o){return this.g.event(o)}onEnd(o){return this.socket.onEnd(o)}write(o){this.a.writeMessage(o)}k(o,p){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",o);let E=2;o.byteLength<126?E+=0:o.byteLength<2**16?E+=2:E+=8;const k=D.VSBuffer.alloc(E);if(p?k.writeUInt8(194,0):k.writeUInt8(130,0),o.byteLength<126)k.writeUInt8(o.byteLength,1);else if(o.byteLength<2**16){k.writeUInt8(126,1);let F=1;k.writeUInt8(o.byteLength>>>8&255,++F),k.writeUInt8(o.byteLength>>>0&255,++F)}else{k.writeUInt8(127,1);let F=1;k.writeUInt8(0,++F),k.writeUInt8(0,++F),k.writeUInt8(0,++F),k.writeUInt8(0,++F),k.writeUInt8(o.byteLength>>>24&255,++F),k.writeUInt8(o.byteLength>>>16&255,++F),k.writeUInt8(o.byteLength>>>8&255,++F),k.writeUInt8(o.byteLength>>>0&255,++F)}this.socket.write(D.VSBuffer.concat([k,o]))}end(){this.h=!0,this.socket.end()}l(o){if(o.byteLength!==0){for(this.b.acceptChunk(o);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const p=this.b.peek(this.j.readLen),E=p.readUInt8(0),k=(E&128)>>>7,F=(E&64)>>>6,N=p.readUInt8(1),q=(N&128)>>>7,j=N&127;this.j.state=2,this.j.readLen=2+(q?4:0)+(j===126?2:0)+(j===127?8:0),this.j.fin=k,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(F)),this.j.firstFrameOfMessage=Boolean(k),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const p=this.b.read(this.j.readLen),E=p.readUInt8(1),k=(E&128)>>>7;let F=E&127,N=1;F===126?F=p.readUInt8(++N)*2**8+p.readUInt8(++N):F===127&&(F=p.readUInt8(++N)*0+p.readUInt8(++N)*0+p.readUInt8(++N)*0+p.readUInt8(++N)*0+p.readUInt8(++N)*2**24+p.readUInt8(++N)*2**16+p.readUInt8(++N)*2**8+p.readUInt8(++N));let q=0;k&&(q=p.readUInt8(++N)*2**24+p.readUInt8(++N)*2**16+p.readUInt8(++N)*2**8+p.readUInt8(++N)),this.j.state=3,this.j.readLen=F,this.j.mask=q,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const p=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",p),u(p,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",p),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(p,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await R.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=g;class v extends A.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:D.VSBuffer.alloc(0)}constructor(o,p,E,k,F,N){super(),this.k=o,this.l=F,this.m=N,this.a=this.B(new R.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new R.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,p?(this.b=this.B(new l(this.k,k,E,{windowBits:15})),this.f=this.B(new m(this.k,{windowBits:15})),this.B(this.b.onError(q=>this.a.fire(q))),this.B(this.f.onError(q=>this.a.fire(q)))):(this.b=null,this.f=null)}writeMessage(o){this.g.push(o),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const o=this.g.shift();if(this.f){const p=await this.r(this.f,o);this.m(p,!0)}else this.m(o,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(o,p){return new Promise((E,k)=>{o.write(p),o.flush(F=>E(F))})}acceptFrame(o,p,E){this.h.push({data:o,isCompressed:p,isLastFrameOfMessage:E}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const o=this.h.shift();if(this.b&&o.isCompressed){const p=await this.u(this.b,o.data,o.isLastFrameOfMessage);this.l.fire(p)}else this.l.fire(o.data)}this.s=!1}}u(o,p,E){return new Promise((k,F)=>{o.write(p),E&&o.write(D.VSBuffer.fromByteArray([0,0,255,255])),o.flush(N=>k(N))})}}class l extends A.Disposable{get recordedInflateBytes(){return this.j?D.VSBuffer.concat(this.f):D.VSBuffer.alloc(0)}constructor(o,p,E,k){super(),this.h=o,this.j=p,this.a=this.B(new R.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=b().zlib.createInflateRaw(k),this.b.on("error",F=>{this.h.traceSocketEvent("zlibInflateError",{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.h.traceSocketEvent("zlibInflateData",F),this.g.push(D.VSBuffer.wrap(F))}),E&&(this.h.traceSocketEvent("zlibInflateInitialWrite",E.buffer),this.b.write(E.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(o){this.j&&this.f.push(o.clone()),this.h.traceSocketEvent("zlibInflateWrite",o),this.b.write(o.buffer)}flush(o){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const p=D.VSBuffer.concat(this.g);this.g.length=0,o(p)})}}class m extends A.Disposable{constructor(o,p){super(),this.g=o,this.a=this.B(new R.Emitter),this.onError=this.a.event,this.f=[],this.b=b().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",E=>{this.g.traceSocketEvent("zlibDeflateError",{message:E?.message,code:E?.code}),this.a.fire(E)}),this.b.on("data",E=>{this.g.traceSocketEvent("zlibDeflateData",E),this.f.push(D.VSBuffer.wrap(E))})}write(o){this.g.traceSocketEvent("zlibDeflateWrite",o.buffer),this.b.write(o.buffer)}flush(o){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let p=D.VSBuffer.concat(this.f);this.f.length=0,p=p.slice(0,p.byteLength-4),o(p)})}}function u(c,o){if(o===0)return;const p=c.byteLength>>>2;for(let j=0;j<p;j++){const O=c.readUInt32BE(j*4);c.writeUInt32BE(O^o,j*4)}const E=p*4,k=c.byteLength-E,F=o>>>24&255,N=o>>>16&255,q=o>>>8&255;k>=1&&c.writeUInt8(c.readUInt8(E)^F,E),k>=2&&c.writeUInt8(c.readUInt8(E+1)^N,E+1),k>=3&&c.writeUInt8(c.readUInt8(E+2)^q,E+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const h={[2]:107,[1]:103};function f(){const c=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let o;return e.XDG_RUNTIME_DIR?o=(0,L.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):o=(0,L.join)(b().os.tmpdir(),`vscode-ipc-${c}.sock`),s(o),o}e.createRandomIPCHandle=f;function n(c,o,p){const E=b().crypto.createHash("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${E}-${p}-${o}-sock`;let k;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?k=(0,L.join)(e.XDG_RUNTIME_DIR,`vscode-${E.substr(0,8)}-${p}-${o}.sock`):k=(0,L.join)(c,`${p}-${o}.sock`),s(k),k}e.createStaticIPCHandle=n;function s(c){const o=h[P.platform];typeof o=="number"&&c.length>=o&&console.warn(`WARNING: IPC handle "${c}" is longer than ${o} chars, try a shorter --user-data-dir`)}class t extends S.IPCServer{static b(o){const p=R.Event.fromNodeEventEmitter(o,"connection");return R.Event.map(p,E=>({protocol:new C.Protocol(new w(E,"ipc-server-connection")),onDidClientDisconnect:R.Event.once(R.Event.fromNodeEventEmitter(E,"close"))}))}constructor(o){super(t.b(o)),this.d=o}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=t;function a(c){return new Promise((o,p)=>{const E=b().net.createServer();E.on("error",p),E.listen(c,()=>{E.removeListener("error",p),o(new t(E))})})}e.serve=a;function r(c,o){return new Promise((p,E)=>{const k=b().net.createConnection(c,()=>{k.removeListener("error",E),p(C.Client.fromSocket(new w(k,`ipc-client${o}`),o))});k.once("error",E)})}e.connect=r}),define(re[69],ae([0,1,6,3,2,15]),function(_,e,D,i,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var L;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",b[b.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(L=e.StorageHint||(e.StorageHint={}));function P(b){const w=b;return w?.changed instanceof Map||w?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var I;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(I=e.StorageState||(e.StorageState={}));class S extends R.Disposable{constructor(w,y=Object.create(null)){super(),this.m=w,this.n=y,this.b=this.B(new i.Emitter),this.onDidChangeStorage=this.b.event,this.c=I.None,this.f=new Map,this.g=new D.ThrottledDelayer(S.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(w=>this.r(w)))}r(w){w.changed?.forEach((y,d)=>this.s(d,y)),w.deleted?.forEach(y=>this.s(y,void 0))}s(w,y){if(this.c===I.Closed)return;let d=!1;(0,A.isUndefinedOrNull)(y)?d=this.f.delete(w):this.f.get(w)!==y&&(this.f.set(w,y),d=!0),d&&this.b.fire(w)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===I.None&&(this.c=I.Initialized,this.n.hint!==L.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(w,y){const d=this.f.get(w);return(0,A.isUndefinedOrNull)(d)?y:d}getBoolean(w,y){const d=this.get(w);return(0,A.isUndefinedOrNull)(d)?y:d==="true"}getNumber(w,y){const d=this.get(w);return(0,A.isUndefinedOrNull)(d)?y:parseInt(d,10)}async set(w,y){if(this.c===I.Closed)return;if((0,A.isUndefinedOrNull)(y))return this.delete(w);const d=String(y);if(this.f.get(w)!==d)return this.f.set(w,d),this.j.set(w,d),this.h.delete(w),this.b.fire(w),this.w()}async delete(w){if(!(this.c===I.Closed||!this.f.delete(w)))return this.h.has(w)||this.h.add(w),this.j.delete(w),this.b.fire(w),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=I.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const w={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(w).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(w){if(!!this.u)return this.w(w)}async w(w){return this.g.trigger(()=>this.v(),w)}async whenFlushed(){if(!!this.u)return new Promise(w=>this.l.push(w))}isInMemory(){return this.n.hint===L.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.Storage=S,S.a=100;class C{constructor(){this.onDidChangeItemsExternal=i.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(w){w.insert?.forEach((y,d)=>this.a.set(d,y)),w.delete?.forEach(y=>this.a.delete(y))}async close(){}}e.InMemoryStorageDatabase=C}),define(re[150],ae([10,11]),function(_,e){return _.create("vs/base/node/zip",e)}),define(re[151],ae([10,11]),function(_,e){return _.create("vs/platform/configuration/common/configurationRegistry",e)}),define(re[152],ae([10,11]),function(_,e){return _.create("vs/platform/environment/node/argv",e)}),define(re[153],ae([10,11]),function(_,e){return _.create("vs/platform/environment/node/argvHelper",e)}),define(re[154],ae([10,11]),function(_,e){return _.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(re[155],ae([10,11]),function(_,e){return _.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(re[156],ae([10,11]),function(_,e){return _.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(re[157],ae([10,11]),function(_,e){return _.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(re[158],ae([10,11]),function(_,e){return _.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(re[159],ae([10,11]),function(_,e){return _.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(re[160],ae([10,11]),function(_,e){return _.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(re[161],ae([10,11]),function(_,e){return _.create("vs/platform/extensions/common/extensionValidator",e)}),define(re[162],ae([10,11]),function(_,e){return _.create("vs/platform/files/common/fileService",e)}),define(re[163],ae([10,11]),function(_,e){return _.create("vs/platform/files/common/files",e)}),define(re[164],ae([10,11]),function(_,e){return _.create("vs/platform/files/common/io",e)}),define(re[165],ae([10,11]),function(_,e){return _.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(re[166],ae([10,11]),function(_,e){return _.create("vs/platform/languagePacks/common/languagePacks",e)}),define(re[167],ae([10,11]),function(_,e){return _.create("vs/platform/remoteTunnel/electron-browser/remoteTunnelService",e)}),define(re[168],ae([10,11]),function(_,e){return _.create("vs/platform/request/common/request",e)}),define(re[169],ae([10,11]),function(_,e){return _.create("vs/platform/shell/node/shellEnv",e)}),define(re[170],ae([10,11]),function(_,e){return _.create("vs/platform/telemetry/common/telemetryService",e)}),define(re[171],ae([10,11]),function(_,e){return _.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(re[172],ae([10,11]),function(_,e){return _.create("vs/platform/terminal/common/terminalProfiles",e)}),define(re[173],ae([10,11]),function(_,e){return _.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(re[174],ae([10,11]),function(_,e){return _.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(re[175],ae([10,11]),function(_,e){return _.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(re[176],ae([10,11]),function(_,e){return _.create("vs/platform/userDataSync/common/settingsSync",e)}),define(re[177],ae([10,11]),function(_,e){return _.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(re[178],ae([10,11]),function(_,e){return _.create("vs/platform/userDataSync/common/userDataSync",e)}),define(re[179],ae([10,11]),function(_,e){return _.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(re[180],ae([10,11]),function(_,e){return _.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(re[181],ae([10,11]),function(_,e){return _.create("vs/platform/workspace/common/workspace",e)}),define(re[94],ae([0,1,65,63,24,12,36,21,7]),function(_,e,D,i,R,A,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class S{get appRoot(){return(0,A.dirname)(R.FileAccess.asFileUri("").fsPath)}get userHome(){return I.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return I.URI.file((0,A.join)(this.userDataPath,"User"))}get tmpDir(){return I.URI.file(this.b.tmpDir)}get cacheHome(){return I.URI.file(this.userDataPath)}get stateResource(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const g=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.join)(this.userDataPath,"logs",g)}return this.args.logsPath}get userDataSyncLogResource(){return I.URI.file((0,A.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return I.URI.file((0,A.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(I.URI.file((0,A.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=L.env.VSCODE_PORTABLE;return g?I.URI.file((0,A.join)(g,"argv.json")):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return I.URI.file((0,A.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,A.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,A.resolve)(g):(0,A.normalize)((0,A.join)(R.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const g=this.args["extensions-download-dir"];return g?I.URI.file((0,A.resolve)(g)):I.URI.file((0,A.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,A.resolve)(g);const v=L.env.VSCODE_EXTENSIONS;if(v)return v;const l=L.env.VSCODE_PORTABLE;return l?(0,A.join)(l,"extensions"):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(v=>/^[^:/?#]+?:\/\//.test(v)?I.URI.parse(v):I.URI.file((0,A.normalize)(v)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?I.URI.parse(g):I.URI.file((0,A.normalize)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!L.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(g=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(g))}get extensionLogLevel(){const g=[];for(const v of this.args.log||[]){const l=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(v);l&&l[1]&&l[2]&&g.push([l[1],l[2]])}return g.length?g:void 0}get serviceMachineIdResource(){return(0,P.joinPath)(I.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return I.URI.file((0,A.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const g=L.env.VSCODE_PORTABLE;return g?I.URI.file((0,A.join)(g,"policy.json")):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(g){this.args.continueOn=g}get args(){return this.a}constructor(g,v,l){this.a=g,this.b=v,this.c=l,this.editSessionId=this.args.editSessionId}}ye([i.memoize],S.prototype,"appRoot",null),ye([i.memoize],S.prototype,"userHome",null),ye([i.memoize],S.prototype,"userDataPath",null),ye([i.memoize],S.prototype,"appSettingsHome",null),ye([i.memoize],S.prototype,"tmpDir",null),ye([i.memoize],S.prototype,"cacheHome",null),ye([i.memoize],S.prototype,"stateResource",null),ye([i.memoize],S.prototype,"userRoamingDataHome",null),ye([i.memoize],S.prototype,"userDataSyncHome",null),ye([i.memoize],S.prototype,"userDataSyncLogResource",null),ye([i.memoize],S.prototype,"editSessionsLogResource",null),ye([i.memoize],S.prototype,"sync",null),ye([i.memoize],S.prototype,"machineSettingsResource",null),ye([i.memoize],S.prototype,"workspaceStorageHome",null),ye([i.memoize],S.prototype,"localHistoryHome",null),ye([i.memoize],S.prototype,"keyboardLayoutResource",null),ye([i.memoize],S.prototype,"argvResource",null),ye([i.memoize],S.prototype,"isExtensionDevelopment",null),ye([i.memoize],S.prototype,"untitledWorkspacesHome",null),ye([i.memoize],S.prototype,"installSourcePath",null),ye([i.memoize],S.prototype,"builtinExtensionsPath",null),ye([i.memoize],S.prototype,"extensionsPath",null),ye([i.memoize],S.prototype,"extensionDevelopmentLocationURI",null),ye([i.memoize],S.prototype,"extensionDevelopmentKind",null),ye([i.memoize],S.prototype,"extensionTestsLocationURI",null),ye([i.memoize],S.prototype,"debugExtensionHost",null),ye([i.memoize],S.prototype,"logLevel",null),ye([i.memoize],S.prototype,"extensionLogLevel",null),ye([i.memoize],S.prototype,"serviceMachineIdResource",null),ye([i.memoize],S.prototype,"telemetryLogResource",null),ye([i.memoize],S.prototype,"disableWorkspaceTrust",null),ye([i.memoize],S.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=S;function C(d,g){return y(d["inspect-extensions"],d["inspect-brk-extensions"],5870,g,d.debugId,d.extensionEnvironment)}e.parseExtensionHostPort=C;function b(d,g){return y(d["inspect-search"],d["inspect-brk-search"],5876,g,d.extensionEnvironment)}e.parseSearchPort=b;function w(d,g){return y(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,g,d.extensionEnvironment)}e.parsePtyHostPort=w;function y(d,g,v,l,m,u){const f=Number(g||d)||(l?null:v),n=f?Boolean(!!g):!1;let s;if(u)try{s=JSON.parse(u)}catch{}return{port:f,break:n,debugId:m,env:s}}}),define(re[182],ae([0,1,283,5,152]),function(_,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const A={o:(0,R.localize)(0,null),e:(0,R.localize)(1,null),t:(0,R.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,R.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,R.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,R.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,R.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,R.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,R.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,R.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,R.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,R.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,R.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,R.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,R.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,R.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,R.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,R.localize)(17,null)},category:{type:"string",cat:"e",description:(0,R.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,R.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,R.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,R.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,R.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,R.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,R.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,R.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,R.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,R.localize)(27,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,R.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,R.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,R.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,R.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,R.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,R.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,R.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,R.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const L={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(g,v,l=L){const m=g.find(c=>c.length>0&&c[0]!=="-"),u={},h=["_"],f=[],n={};let s;for(const c in v){const o=v[c];o.type==="subcommand"?c===m&&(s=o):(o.alias&&(u[c]=o.alias),o.type==="string"||o.type==="string[]"?(h.push(c),o.deprecates&&h.push(...o.deprecates)):o.type==="boolean"&&(f.push(c),o.deprecates&&f.push(...o.deprecates)),o.global&&(n[c]=o))}if(s&&m){const c=n;for(const k in s.options)c[k]=s.options[k];const o=g.filter(k=>k!==m),p=l.getSubcommandReporter?l.getSubcommandReporter(m):void 0,E=P(o,c,p);return{[m]:E,_:[]}}const t=D(g,{string:h,boolean:f,alias:u}),a={},r=t;a._=t._.map(c=>String(c)).filter(c=>c.length>0),delete r._;for(const c in v){const o=v[c];if(o.type==="subcommand")continue;o.alias&&delete r[o.alias];let p=r[c];if(o.deprecates)for(const E of o.deprecates)r.hasOwnProperty(E)&&(p||(p=r[E],p&&l.onDeprecatedOption(E,o.deprecationMessage||(0,R.localize)(36,null,c))),delete r[E]);if(typeof p<"u"){if(o.type==="string[]"){if(Array.isArray(p)||(p=[p]),!o.allowEmptyValue){const E=p.filter(k=>k.length>0);E.length!==p.length&&(l.onEmptyValue(c),p=E.length>0?E:void 0)}}else o.type==="string"&&(Array.isArray(p)?(p=p.pop(),l.onMultipleValues(c,p)):!p&&!o.allowEmptyValue&&(l.onEmptyValue(c),p=void 0));a[c]=p,o.deprecationMessage&&l.onDeprecatedOption(c,o.deprecationMessage)}delete r[c]}for(const c in r)l.onUnknownOption(c);return a}e.parseArgs=P;function I(g,v){let l="";return v.args&&(Array.isArray(v.args)?l=` <${v.args.join("> <")}>`:l=` <${v.args}>`),v.alias?`-${v.alias} --${g}${l}`:`--${g}${l}`}function S(g,v){const l=[];for(const m in g){const u=g[m],h=I(m,u);l.push([h,u.description])}return C(l,v)}e.formatOptions=S;function C(g,v){const m=g.reduce((f,n)=>Math.max(f,n[0].length),12)+2+1;if(v-m<25)return g.reduce((f,n)=>f.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);const u=v-m-1,h=[];for(const f of g){const n=f[0],s=w(f[1],u),t=b(m-n.length-2);h.push("  "+n+t+s[0]);for(let a=1;a<s.length;a++)h.push(b(m)+s[a])}return h}function b(g){return" ".repeat(g)}function w(g,v){const l=[];for(;g.length;){const m=g.length<v?g.length:g.lastIndexOf(" ",v),u=g.slice(0,m).trim();g=g.slice(m),l.push(u)}return l}function y(g,v,l,m,u){const h=process.stdout.isTTY&&process.stdout.columns||80,f=u?.noInputFiles!==!0?`[${(0,R.localize)(37,null)}...]`:"",n=[`${g} ${l}`];n.push(""),n.push(`${(0,R.localize)(38,null)}: ${v} [${(0,R.localize)(39,null)}]${f}`),n.push(""),u?.noPipe!==!0&&(i.isWindows?n.push((0,R.localize)(40,null,v)):n.push((0,R.localize)(41,null,v)),n.push(""));const s={},t=[];for(const a in m){const r=m[a];if(r.type==="subcommand")r.description&&t.push({command:a,description:r.description});else if(r.description&&r.cat){let c=s[r.cat];c||(s[r.cat]=c={}),c[a]=r}}for(const a in s){const r=a,c=s[r];c&&(n.push(A[r]),n.push(...S(c,h)),n.push(""))}return t.length&&(n.push((0,R.localize)(42,null)),n.push(...C(t.map(a=>[a.command,a.description]),h)),n.push("")),n.join(`
`)}e.buildHelpMessage=y;function d(g,v){return`${g||(0,R.localize)(43,null)}
${v||(0,R.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=d}),define(re[183],ae([0,1,284,153,182]),function(_,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const A=2048;function L(w,y){const d=(h,f)=>{console.warn((0,i.localize)(0,null,h,f))},g=h=>{console.warn((0,i.localize)(1,null,h))},v=(h,f)=>{console.warn((0,i.localize)(2,null,h,f))},l=h=>({onUnknownOption:f=>{h!=="tunnel"&&console.warn((0,i.localize)(3,null,f,h))},onMultipleValues:d,onEmptyValue:g,onDeprecatedOption:v,getSubcommandReporter:h!=="tunnel"?l:void 0}),m={onUnknownOption:h=>{console.warn((0,i.localize)(4,null,h))},onMultipleValues:d,onEmptyValue:g,onDeprecatedOption:v,getSubcommandReporter:l},u=(0,R.parseArgs)(w,R.OPTIONS,y?m:void 0);return u.goto&&u._.forEach(h=>D(/^(\w:)?[^:]+(:\d*){0,2}$/.test(h),(0,i.localize)(5,null))),u["max-memory"]&&D(parseInt(u["max-memory"])>=A,`The max-memory argument cannot be specified lower than ${A} MB.`),u}function P(w){const y=w.findIndex(d=>!/^-/.test(d));if(y>-1)return[...w.slice(0,y),...w.slice(y+1)]}function I(w){let[,...y]=w;process.env.VSCODE_DEV&&(y=P(y)||[]);const d=!b(process.env);return L(y,d)}e.parseMainProcessArgv=I;function S(w){let[,,...y]=w;return process.env.VSCODE_DEV&&(y=P(y)||[]),L(y,!0)}e.parseCLIProcessArgv=S;function C(w,...y){const d=w.indexOf("--");return d===-1?w.push(...y):w.splice(d,0,...y),w}e.addArg=C;function b(w){return w.VSCODE_CLI==="1"}e.isLaunchedFromCli=b}),function(){"use strict";function _(e,D,i){function R(L,P){const I=A(L,P),S=[I];return e.isAbsolute(I)||S.unshift(i),e.resolve(...S)}function A(L,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const I=process.env.VSCODE_PORTABLE;if(I)return e.join(I,"user-data");let S=process.env.VSCODE_APPDATA;if(S)return e.join(S,P);const C=L["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if(S=process.env.APPDATA,!S){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");S=e.join(b,"AppData","Roaming")}break;case"darwin":S=e.join(D.homedir(),"Library","Application Support");break;case"linux":S=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(S,P)}return{getUserDataPath:R}}if(typeof define=="function")define(re[184],ae([285,34,36]),function(e,D,i){return _(e,D,i.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),D=require("os");module.exports=_(e,D,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(re[185],ae([0,1,34,94,184]),function(_,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class A extends i.AbstractNativeEnvironmentService{constructor(P,I){super(P,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,R.getUserDataPath)(P,I.nameShort)},I)}}e.NativeEnvironmentService=A}),define(re[186],ae([0,1,7]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const i=/^([^@:]+@)?([^:]+):/,R=/^([^@:]+@)?([^:]+):(.+)$/,A=/^([^@]+@)?([^:]+)(:\d+)?$/,L=/([^@:.]+\.[^@:.]+)(:\d+)?$/,P=/^\s*url\s*=\s*(.+\S)\s*$/mg,I=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function S(v){const l=v.match(L);return l?l[1]:null}function C(v){if(v.indexOf("://")===-1){const l=v.match(i);return l?S(l[2]):null}try{const l=D.URI.parse(v);if(l.authority)return S(l.authority)}catch{}return null}function b(v,l){const m=new Set;let u;for(;u=P.exec(v);){const f=C(u[1]);f&&m.add(f)}const h=new Set(l);return Array.from(m).map(f=>h.has(f)?f:f.replace(I,"a"))}e.getDomainsOfRemotes=b;function w(v){const l=v.match(A);return l?l[2]:null}function y(v,l,m){return v&&l?(m&&l.endsWith(".git")&&(l=l.substr(0,l.length-4)),l.indexOf("/")===0?`${v}${l}`:`${v}/${l}`):null}function d(v,l){if(v.indexOf("://")===-1){const m=v.match(R);if(m)return y(m[2],m[3],l)}try{const m=D.URI.parse(v);if(m.authority)return y(w(m.authority),m.path,l)}catch{}return null}function g(v,l=!1){const m=[];let u;for(;u=P.exec(v);){const h=d(u[1],l);h&&m.push(h)}return m}e.getRemotes=g}),define(re[187],ae([0,1,15,156]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function R(L,P,I){try{A(L,P,I)}catch(S){console.error(S?.message??S)}return L}e.localizeManifest=R;function A(L,P,I){const S=(C,b,w)=>{const y=C[b];if((0,D.isString)(y)){const d=y,g=d.length;if(g>1&&d[0]==="%"&&d[g-1]==="%"){const v=d.substr(1,g-2);let l=P[v];l===void 0&&I&&(l=I[v]);const m=typeof l=="string"?l:l?.message,u=I?.[v],h=typeof u=="string"?u:u?.message;if(!m){h||console.warn(`[${L.name}]: ${(0,i.localize)(0,null,v)}`);return}if(w&&(b==="title"||b==="category")&&h&&h!==m){const f={value:m,original:h};C[b]=f}else C[b]=m}}else if((0,D.isObject)(y))for(const d in y)y.hasOwnProperty(d)&&(d==="commands"?S(y,d,!0):S(y,d,w));else if(Array.isArray(y))for(let d=0;d<y.length;d++)S(y,d,w)};for(const C in L)L.hasOwnProperty(C)&&S(L,C)}}),define(re[188],ae([0,1,9]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class i{constructor(){this.a=new Map}register(A,L){this.a.set(A,L)}updateManifest(A){if(!(!Array.isArray(A.activationEvents)||!A.contributes)&&!(typeof A.main>"u"&&typeof A.browser>"u"))for(const L in A.contributes){const P=this.a.get(L);if(!P)continue;const I=A.contributes[L],S=Array.isArray(I)?I:[I];try{P(S,A.activationEvents)}catch(C){(0,D.onUnexpectedError)(C)}}}}e.ImplicitActivationEventsImpl=i,e.ImplicitActivationEvents=new i}),define(re[189],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class D{constructor(A){this.a=A}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(A,L,P,I){return this.a.call("promptImportantExtensionsInstallNotification",[A,L,P,I])}promptWorkspaceRecommendations(A){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=D;class i{constructor(A){this.a=A}listen(A,L){throw new Error(`Event not found: ${L}`)}call(A,L,P){switch(L){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(P[0],P[1],P[2],P[3])}throw new Error(`Call not found: ${L}`)}}e.ExtensionRecommendationNotificationServiceChannel=i}),define(re[70],ae([0,1,21,88,161,53]),function(_,e,D,i,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function I(l){return l=l.trim(),l==="*"||L.test(l)}e.isValidVersionStr=I;function S(l){if(!I(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const m=l.match(L);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=S;function C(l){if(!l)return null;const m=l.majorBase,u=l.majorMustEqual,h=l.minorBase;let f=l.minorMustEqual;const n=l.patchBase;let s=l.patchMustEqual;l.hasCaret&&(m===0||(f=!1),s=!1);let t=0;if(l.preRelease){const a=P.exec(l.preRelease);if(a){const[,r,c,o]=a;t=Date.UTC(Number(r),Number(c)-1,Number(o))}}return{majorBase:m,majorMustEqual:u,minorBase:h,minorMustEqual:f,patchBase:n,patchMustEqual:s,isMinimum:l.hasGreaterEquals,notBefore:t}}e.normalizeVersion=C;function b(l,m,u){let h;typeof l=="string"?h=C(S(l)):h=l;let f;m instanceof Date?f=m.getTime():typeof m=="string"&&(f=new Date(m).getTime());let n;if(typeof u=="string"?n=C(S(u)):n=u,!h||!n)return!1;const s=h.majorBase,t=h.minorBase,a=h.patchBase;let r=n.majorBase,c=n.minorBase,o=n.patchBase;const p=n.notBefore;let E=n.majorMustEqual,k=n.minorMustEqual,F=n.patchMustEqual;return n.isMinimum?s>r?!0:s<r?!1:t>c?!0:t<c||f&&f<p?!1:a>=o:(s===1&&r===0&&(!E||!k||!F)&&(r=1,c=0,o=0,E=!0,k=!1,F=!1),s<r?!1:s>r?!E:t<c?!1:t>c?!k:a<o?!1:a>o?!F:!(f&&f<p))}e.isValidVersion=b;function w(l,m,u,h,f){const n=[];if(typeof h.publisher<"u"&&typeof h.publisher!="string")return n.push([i.default.Error,R.localize(0,null)]),n;if(typeof h.name!="string")return n.push([i.default.Error,R.localize(1,null,"name")]),n;if(typeof h.version!="string")return n.push([i.default.Error,R.localize(2,null,"version")]),n;if(!h.engines)return n.push([i.default.Error,R.localize(3,null,"engines")]),n;if(typeof h.engines.vscode!="string")return n.push([i.default.Error,R.localize(4,null,"engines.vscode")]),n;if(typeof h.extensionDependencies<"u"&&!v(h.extensionDependencies))return n.push([i.default.Error,R.localize(5,null,"extensionDependencies")]),n;if(typeof h.activationEvents<"u"){if(!v(h.activationEvents))return n.push([i.default.Error,R.localize(6,null,"activationEvents")]),n;if(typeof h.main>"u"&&typeof h.browser>"u")return n.push([i.default.Error,R.localize(7,null,"activationEvents","main")]),n}if(typeof h.extensionKind<"u"&&typeof h.main>"u"&&n.push([i.default.Warning,R.localize(8,null,"extensionKind")]),typeof h.main<"u"){if(typeof h.main!="string")return n.push([i.default.Error,R.localize(9,null,"main")]),n;{const a=(0,D.joinPath)(u,h.main);(0,D.isEqualOrParent)(a,u)||n.push([i.default.Warning,R.localize(10,null,a.path,u.path)])}if(typeof h.activationEvents>"u")return n.push([i.default.Error,R.localize(11,null,"activationEvents","main")]),n}if(typeof h.browser<"u"){if(typeof h.browser!="string")return n.push([i.default.Error,R.localize(12,null,"browser")]),n;{const a=(0,D.joinPath)(u,h.browser);(0,D.isEqualOrParent)(a,u)||n.push([i.default.Warning,R.localize(13,null,a.path,u.path)])}if(typeof h.activationEvents>"u")return n.push([i.default.Error,R.localize(14,null,"activationEvents","browser")]),n}if(!A.valid(h.version))return n.push([i.default.Error,R.localize(15,null)]),n;const s=[];if(!y(l,m,h,f,s))for(const a of s)n.push([i.default.Error,a]);return n}e.validateExtensionManifest=w;function y(l,m,u,h,f){return h||typeof u.main>"u"&&typeof u.browser>"u"?!0:g(l,m,u.engines.vscode,f)}e.isValidExtensionVersion=y;function d(l,m,u){return l==="*"||g(m,u,l)}e.isEngineValid=d;function g(l,m,u,h=[]){const f=C(S(u));if(!f)return h.push(R.localize(16,null,u)),!1;if(f.majorBase===0){if(!f.majorMustEqual||!f.minorMustEqual)return h.push(R.localize(17,null,u)),!1}else if(!f.majorMustEqual)return h.push(R.localize(18,null,u)),!1;return b(l,m,f)?!0:(h.push(R.localize(19,null,l,u)),!1)}function v(l){if(!Array.isArray(l))return!1;for(let m=0,u=l.length;m<u;m++)if(typeof l[m]!="string")return!1;return!0}}),define(re[45],ae([0,1,17,31]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function R(A,L,P){let I=P&&P.get("storage.serviceMachineId",-1)||null;if(I)return I;try{const C=(await L.readFile(A.serviceMachineIdResource)).value.toString();I=(0,i.isUUID)(C)?C:null}catch{I=null}if(!I){I=(0,i.generateUuid)();try{await L.writeFile(A.serviceMachineIdResource,D.VSBuffer.fromString(I))}catch{}}return P?.store("storage.serviceMachineId",I,-1,1),I}e.getServiceMachineId=R}),define(re[54],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class D{constructor(R,A=[],L=!1){this.ctor=R,this.staticArguments=A,this.supportsDelayedInstantiation=L}}e.SyncDescriptor=D}),define(re[71],ae([0,1,54]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const i=[];var R;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(R=e.InstantiationType||(e.InstantiationType={}));function A(P,I,S){I instanceof D.SyncDescriptor||(I=new D.SyncDescriptor(I,[],Boolean(S))),i.push([P,I])}e.registerSingleton=A;function L(){return i}e.getSingletonServiceDescriptors=L}),define(re[190],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class D{constructor(A,L){this.key=A,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.Node=D;class i{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const L of this.a.values())L.outgoing.size===0&&A.push(L);return A}insertEdge(A,L){const P=this.lookupOrInsertNode(A),I=this.lookupOrInsertNode(L);P.outgoing.set(I.key,I),I.incoming.set(P.key,P)}removeNode(A){const L=this.b(A);this.a.delete(L);for(const P of this.a.values())P.outgoing.delete(L),P.incoming.delete(L)}lookupOrInsertNode(A){const L=this.b(A);let P=this.a.get(L);return P||(P=new D(L,A),this.a.set(L,P)),P}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[L,P]of this.a)A.push(`${L}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,L]of this.a){const P=new Set([A]),I=this.c(L,P);if(I)return I}}c(A,L){for(const[P,I]of A.outgoing){if(L.has(P))return[...L,P].join(" -> ");L.add(P);const S=this.c(I,L);if(S)return S;L.delete(P)}}}e.Graph=i}),define(re[4],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var D;(function(L){L.serviceIds=new Map,L.DI_TARGET="$di$target",L.DI_DEPENDENCIES="$di$dependencies";function P(I){return I[L.DI_DEPENDENCIES]||[]}L.getServiceDependencies=P})(D=e._util||(e._util={})),e.IInstantiationService=R("instantiationService");function i(L,P,I){P[D.DI_TARGET]===P?P[D.DI_DEPENDENCIES].push({id:L,index:I}):(P[D.DI_DEPENDENCIES]=[{id:L,index:I}],P[D.DI_TARGET]=P)}function R(L){if(D.serviceIds.has(L))return D.serviceIds.get(L);const P=function(I,S,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");i(P,I,C)};return P.toString=()=>L,D.serviceIds.set(L,P),P}e.createDecorator=R;function A(L){return L}e.refineServiceDecorator=A}),define(re[191],ae([0,1,4]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,D.createDecorator)("checksumService")}),define(re[16],ae([0,1,15,7,4]),function(_,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,R.createDecorator)("configurationService");function A(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof i.URI)}e.isConfigurationOverrides=A;function L(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof i.URI)}e.isConfigurationUpdateOverrides=L;var P;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function I(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=I;function S(l,m){const u=Object.create(null);for(const h in l)C(u,h,l[h],m);return u}e.toValuesTree=S;function C(l,m,u,h){const f=m.split("."),n=f.pop();let s=l;for(let t=0;t<f.length;t++){const a=f[t];let r=s[a];switch(typeof r){case"undefined":r=s[a]=Object.create(null);break;case"object":break;default:h(`Ignoring ${m} as ${f.slice(0,t+1).join(".")} is ${JSON.stringify(r)}`);return}s=r}if(typeof s=="object"&&s!==null)try{s[n]=u}catch{h(`Ignoring ${m} as ${f.join(".")} is ${JSON.stringify(s)}`)}else h(`Ignoring ${m} as ${f.join(".")} is ${JSON.stringify(s)}`)}e.addToValueTree=C;function b(l,m){const u=m.split(".");w(l,u)}e.removeFromValueTree=b;function w(l,m){const u=m.shift();if(m.length===0){delete l[u];return}if(Object.keys(l).indexOf(u)!==-1){const h=l[u];typeof h=="object"&&!Array.isArray(h)&&(w(h,m),Object.keys(h).length===0&&delete l[u])}}function y(l,m,u){function h(s,t){let a=s;for(const r of t){if(typeof a!="object"||a===null)return;a=a[r]}return a}const f=m.split("."),n=h(l,f);return typeof n>"u"?u:n}e.getConfigurationValue=y;function d(l,m,u){Object.keys(m).forEach(h=>{h!=="__proto__"&&(h in l?D.isObject(l[h])&&D.isObject(m[h])?d(l[h],m[h],u):u&&(l[h]=m[h]):l[h]=m[h])})}e.merge=d;function g(l,m,u){const h=l.inspect(m),f=l.inspect(u);return typeof h.userValue<"u"||typeof h.workspaceValue<"u"||typeof h.workspaceFolderValue<"u"?h.value:typeof f.userValue<"u"||typeof f.workspaceValue<"u"||typeof f.workspaceFolderValue<"u"?f.value:h.defaultValue}e.getMigratedSettingValue=g;function v(l){return l.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=v}),define(re[192],ae([0,1,5,27,4]),function(_,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",D.isMacintosh),A.set("isLinux",D.isLinux),A.set("isWindows",D.isWindows),A.set("isWeb",D.isWeb),A.set("isMacNative",D.isMacintosh&&!D.isWeb),A.set("isEdge",D.isEdge),A.set("isFirefox",D.isFirefox),A.set("isChrome",D.isChrome),A.set("isSafari",D.isSafari);const L=Object.prototype.hasOwnProperty;var P;(function(j){j[j.False=0]="False",j[j.True=1]="True",j[j.Defined=2]="Defined",j[j.Not=3]="Not",j[j.Equals=4]="Equals",j[j.NotEquals=5]="NotEquals",j[j.And=6]="And",j[j.Regex=7]="Regex",j[j.NotRegex=8]="NotRegex",j[j.Or=9]="Or",j[j.In=10]="In",j[j.NotIn=11]="NotIn",j[j.Greater=12]="Greater",j[j.GreaterEquals=13]="GreaterEquals",j[j.Smaller=14]="Smaller",j[j.SmallerEquals=15]="SmallerEquals"})(P=e.ContextKeyExprType||(e.ContextKeyExprType={}));class I{static false(){return b.INSTANCE}static true(){return w.INSTANCE}static has(O){return y.create(O)}static equals(O,U){return d.create(O,U)}static notEquals(O,U){return l.create(O,U)}static regex(O,U){return t.create(O,U)}static in(O,U){return g.create(O,U)}static notIn(O,U){return v.create(O,U)}static not(O){return m.create(O)}static and(...O){return c.create(O,null,!0)}static or(...O){return o.create(O,null,!0)}static greater(O,U){return h.create(O,U)}static greaterEquals(O,U){return f.create(O,U)}static smaller(O,U){return n.create(O,U)}static smallerEquals(O,U){return s.create(O,U)}static deserialize(O,U=!1){if(!!O)return this.c(O,U)}static c(O,U){const $=O.split("||");return o.create($.map(G=>this.d(G,U)),null,!0)}static d(O,U){const $=O.split("&&");return c.create($.map(G=>this.f(G,U)),null,!0)}static f(O,U){if(O=O.trim(),O.indexOf("!=")>=0){const $=O.split("!=");return l.create($[0].trim(),this.g($[1],U))}if(O.indexOf("==")>=0){const $=O.split("==");return d.create($[0].trim(),this.g($[1],U))}if(O.indexOf("=~")>=0){const $=O.split("=~");return t.create($[0].trim(),this.h($[1],U))}if(O.indexOf(" not in ")>=0){const $=O.split(" not in ");return v.create($[0].trim(),this.g($[1],U))}if(O.indexOf(" in ")>=0){const $=O.split(" in ");return g.create($[0].trim(),this.g($[1],U))}if(/^[^<=>]+>=[^<=>]+$/.test(O)){const $=O.split(">=");return f.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(O)){const $=O.split(">");return h.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(O)){const $=O.split("<=");return s.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(O)){const $=O.split("<");return n.create($[0].trim(),$[1].trim())}return/^\!\s*/.test(O)?m.create(O.substr(1).trim()):y.create(O)}static g(O,U){if(O=O.trim(),O==="true")return!0;if(O==="false")return!1;const $=/^'([^']*)'$/.exec(O);return $?$[1].trim():O}static h(O,U){if((0,i.isFalsyOrWhitespace)(O)){if(U)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const $=O.indexOf("/"),G=O.lastIndexOf("/");if($===G||$<0){if(U)throw new Error(`bad regexp-value '${O}', missing /-enclosure`);return console.warn(`bad regexp-value '${O}', missing /-enclosure`),null}const H=O.slice($+1,G),Z=O[G+1]==="i"?"i":"";try{return new RegExp(H,Z)}catch(z){if(U)throw new Error(`bad regexp-value '${O}', parse error: ${z}`);return console.warn(`bad regexp-value '${O}', parse error: ${z}`),null}}}e.ContextKeyExpr=I;function S(j,O){const U=j?j.substituteConstants():void 0,$=O?O.substituteConstants():void 0;return!U&&!$?!0:!U||!$?!1:U.equals($)}e.expressionsAreEqualWithConstantSubstitution=S;function C(j,O){return j.cmp(O)}class b{constructor(){this.type=0}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!1}serialize(){return"false"}keys(){return[]}map(O){return this}negate(){return w.INSTANCE}}e.ContextKeyFalseExpr=b,b.INSTANCE=new b;class w{constructor(){this.type=1}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!0}serialize(){return"true"}keys(){return[]}map(O){return this}negate(){return b.INSTANCE}}e.ContextKeyTrueExpr=w,w.INSTANCE=new w;class y{static create(O,U=null){const $=A.get(O);return typeof $=="boolean"?$?w.INSTANCE:b.INSTANCE:new y(O,U)}constructor(O,U){this.key=O,this.c=U,this.type=2}cmp(O){return O.type!==this.type?this.type-O.type:E(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=A.get(this.key);return typeof O=="boolean"?O?w.INSTANCE:b.INSTANCE:this}evaluate(O){return!!O.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(O){return O.mapDefined(this.key)}negate(){return this.c||(this.c=m.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=y;class d{static create(O,U,$=null){if(typeof U=="boolean")return U?y.create(O,$):m.create(O,$);const G=A.get(O);return typeof G=="boolean"?U===(G?"true":"false")?w.INSTANCE:b.INSTANCE:new d(O,U,$)}constructor(O,U,$){this.c=O,this.d=U,this.f=$,this.type=4}cmp(O){return O.type!==this.type?this.type-O.type:k(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=A.get(this.c);if(typeof O=="boolean"){const U=O?"true":"false";return this.d===U?w.INSTANCE:b.INSTANCE}return this}evaluate(O){return O.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(O){return O.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=l.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=d;class g{static create(O,U){return new g(O,U)}constructor(O,U){this.d=O,this.f=U,this.type=10,this.c=null}cmp(O){return O.type!==this.type?this.type-O.type:k(this.d,this.f,O.d,O.f)}equals(O){return O.type===this.type?this.d===O.d&&this.f===O.f:!1}substituteConstants(){return this}evaluate(O){const U=O.getValue(this.f),$=O.getValue(this.d);return Array.isArray(U)?U.includes($):typeof $=="string"&&typeof U=="object"&&U!==null?L.call(U,$):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(O){return O.mapIn(this.d,this.f)}negate(){return this.c||(this.c=v.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=g;class v{static create(O,U){return new v(O,U)}constructor(O,U){this.d=O,this.f=U,this.type=11,this.c=g.create(O,U)}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(O){return O.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=v;class l{static create(O,U,$=null){if(typeof U=="boolean")return U?m.create(O,$):y.create(O,$);const G=A.get(O);return typeof G=="boolean"?U===(G?"true":"false")?b.INSTANCE:w.INSTANCE:new l(O,U,$)}constructor(O,U,$){this.c=O,this.d=U,this.f=$,this.type=5}cmp(O){return O.type!==this.type?this.type-O.type:k(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=A.get(this.c);if(typeof O=="boolean"){const U=O?"true":"false";return this.d===U?b.INSTANCE:w.INSTANCE}return this}evaluate(O){return O.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(O){return O.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=d.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=l;class m{static create(O,U=null){const $=A.get(O);return typeof $=="boolean"?$?b.INSTANCE:w.INSTANCE:new m(O,U)}constructor(O,U){this.c=O,this.d=U,this.type=3}cmp(O){return O.type!==this.type?this.type-O.type:E(this.c,O.c)}equals(O){return O.type===this.type?this.c===O.c:!1}substituteConstants(){const O=A.get(this.c);return typeof O=="boolean"?O?b.INSTANCE:w.INSTANCE:this}evaluate(O){return!O.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(O){return O.mapNot(this.c)}negate(){return this.d||(this.d=y.create(this.c,this)),this.d}}e.ContextKeyNotExpr=m;function u(j,O){if(typeof j=="string"){const U=parseFloat(j);isNaN(U)||(j=U)}return typeof j=="string"||typeof j=="number"?O(j):b.INSTANCE}class h{static create(O,U,$=null){return u(U,G=>new h(O,G,$))}constructor(O,U,$){this.c=O,this.d=U,this.f=$,this.type=12}cmp(O){return O.type!==this.type?this.type-O.type:k(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=s.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=h;class f{static create(O,U,$=null){return u(U,G=>new f(O,G,$))}constructor(O,U,$){this.c=O,this.d=U,this.f=$,this.type=13}cmp(O){return O.type!==this.type?this.type-O.type:k(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=n.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=f;class n{static create(O,U,$=null){return u(U,G=>new n(O,G,$))}constructor(O,U,$){this.c=O,this.d=U,this.f=$,this.type=14}cmp(O){return O.type!==this.type?this.type-O.type:k(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=f.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=n;class s{static create(O,U,$=null){return u(U,G=>new s(O,G,$))}constructor(O,U,$){this.c=O,this.d=U,this.f=$,this.type=15}cmp(O){return O.type!==this.type?this.type-O.type:k(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=h.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=s;class t{static create(O,U){return new t(O,U)}constructor(O,U){this.d=O,this.f=U,this.type=7,this.c=null}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.d<O.d)return-1;if(this.d>O.d)return 1;const U=this.f?this.f.source:"",$=O.f?O.f.source:"";return U<$?-1:U>$?1:0}equals(O){if(O.type===this.type){const U=this.f?this.f.source:"",$=O.f?O.f.source:"";return this.d===O.d&&U===$}return!1}substituteConstants(){return this}evaluate(O){const U=O.getValue(this.d);return this.f?this.f.test(U):!1}serialize(){const O=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${O}`}keys(){return[this.d]}map(O){return O.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=a.create(this)),this.c}}e.ContextKeyRegexExpr=t;class a{static create(O){return new a(O)}constructor(O){this.c=O,this.type=8}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(O){return new a(this.c.map(O))}negate(){return this.c}}e.ContextKeyNotRegexExpr=a;function r(j){let O=null;for(let U=0,$=j.length;U<$;U++){const G=j[U].substituteConstants();if(j[U]!==G&&O===null){O=[];for(let H=0;H<U;H++)O[H]=j[H]}O!==null&&(O[U]=G)}return O===null?j:O}class c{static create(O,U,$){return c.d(O,U,$)}constructor(O,U){this.expr=O,this.c=U,this.type=6}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let U=0,$=this.expr.length;U<$;U++){const G=C(this.expr[U],O.expr[U]);if(G!==0)return G}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let U=0,$=this.expr.length;U<$;U++)if(!this.expr[U].equals(O.expr[U]))return!1;return!0}return!1}substituteConstants(){const O=r(this.expr);return O===this.expr?this:c.create(O,this.c,!1)}evaluate(O){for(let U=0,$=this.expr.length;U<$;U++)if(!this.expr[U].evaluate(O))return!1;return!0}static d(O,U,$){const G=[];let H=!1;for(const Z of O)if(!!Z){if(Z.type===1){H=!0;continue}if(Z.type===0)return b.INSTANCE;if(Z.type===6){G.push(...Z.expr);continue}G.push(Z)}if(G.length===0&&H)return w.INSTANCE;if(G.length!==0){if(G.length===1)return G[0];G.sort(C);for(let Z=1;Z<G.length;Z++)G[Z-1].equals(G[Z])&&(G.splice(Z,1),Z--);if(G.length===1)return G[0];for(;G.length>1;){const Z=G[G.length-1];if(Z.type!==9)break;G.pop();const z=G.pop(),B=G.length===0,Y=o.create(Z.expr.map(ee=>c.create([ee,z],null,$)),null,B);Y&&(G.push(Y),G.sort(C))}if(G.length===1)return G[0];if($){for(let Z=0;Z<G.length;Z++)for(let z=Z+1;z<G.length;z++)if(G[Z].negate().equals(G[z]))return b.INSTANCE;if(G.length===1)return G[0]}return new c(G,U)}}serialize(){return this.expr.map(O=>O.serialize()).join(" && ")}keys(){const O=[];for(const U of this.expr)O.push(...U.keys());return O}map(O){return new c(this.expr.map(U=>U.map(O)),null)}negate(){if(!this.c){const O=[];for(const U of this.expr)O.push(U.negate());this.c=o.create(O,this,!0)}return this.c}}class o{static create(O,U,$){return o.d(O,U,$)}constructor(O,U){this.expr=O,this.c=U,this.type=9}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let U=0,$=this.expr.length;U<$;U++){const G=C(this.expr[U],O.expr[U]);if(G!==0)return G}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let U=0,$=this.expr.length;U<$;U++)if(!this.expr[U].equals(O.expr[U]))return!1;return!0}return!1}substituteConstants(){const O=r(this.expr);return O===this.expr?this:o.create(O,this.c,!1)}evaluate(O){for(let U=0,$=this.expr.length;U<$;U++)if(this.expr[U].evaluate(O))return!0;return!1}static d(O,U,$){let G=[],H=!1;if(O){for(let Z=0,z=O.length;Z<z;Z++){const B=O[Z];if(!!B){if(B.type===0){H=!0;continue}if(B.type===1)return w.INSTANCE;if(B.type===9){G=G.concat(B.expr);continue}G.push(B)}}if(G.length===0&&H)return b.INSTANCE;G.sort(C)}if(G.length!==0){if(G.length===1)return G[0];for(let Z=1;Z<G.length;Z++)G[Z-1].equals(G[Z])&&(G.splice(Z,1),Z--);if(G.length===1)return G[0];if($){for(let Z=0;Z<G.length;Z++)for(let z=Z+1;z<G.length;z++)if(G[Z].negate().equals(G[z]))return w.INSTANCE;if(G.length===1)return G[0]}return new o(G,U)}}serialize(){return this.expr.map(O=>O.serialize()).join(" || ")}keys(){const O=[];for(const U of this.expr)O.push(...U.keys());return O}map(O){return new o(this.expr.map(U=>U.map(O)),null)}negate(){if(!this.c){const O=[];for(const U of this.expr)O.push(U.negate());for(;O.length>1;){const U=O.shift(),$=O.shift(),G=[];for(const H of q(U))for(const Z of q($))G.push(c.create([H,Z],null,!1));O.unshift(o.create(G,null,!1))}this.c=o.create(O,this,!0)}return this.c}}class p extends y{static all(){return p.d.values()}constructor(O,U,$){super(O,null),this.f=U,typeof $=="object"?p.d.push({...$,key:O}):$!==!0&&p.d.push({key:O,description:$,type:U!=null?typeof U:void 0})}bindTo(O){return O.createKey(this.key,this.f)}getValue(O){return O.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(O){return d.create(this.key,O)}notEqualsTo(O){return l.create(this.key,O)}}e.RawContextKey=p,p.d=[],e.IContextKeyService=(0,R.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function E(j,O){return j<O?-1:j>O?1:0}function k(j,O,U,$){return j<U?-1:j>U?1:O<$?-1:O>$?1:0}function F(j,O){if(j.type===0||O.type===1)return!0;if(j.type===9)return O.type===9?N(j.expr,O.expr):!1;if(O.type===9){for(const U of O.expr)if(F(j,U))return!0;return!1}if(j.type===6){if(O.type===6)return N(O.expr,j.expr);for(const U of j.expr)if(F(U,O))return!0;return!1}return j.equals(O)}e.implies=F;function N(j,O){let U=0,$=0;for(;U<j.length&&$<O.length;){const G=j[U].cmp(O[$]);if(G<0)return!1;G===0&&U++,$++}return U===j.length}function q(j){return j.type===9?j.expr:[j]}}),define(re[95],ae([0,1,4]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,D.createDecorator)(e.ID);function i(A){return!!A.hostName&&!!A.errorMessage}e.isRemoteDiagnosticError=i;class R{async getPerformanceInfo(L,P){return{}}async getSystemInfo(L,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(L,P){return""}async getWorkspaceFileExtensions(L){return{extensions:[]}}async reportWorkspaceStats(L){}}e.NullDiagnosticsService=R}),define(re[96],ae([0,1,4]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,D.createDecorator)("downloadService")}),define(re[14],ae([0,1,4]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,D.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,D.refineServiceDecorator)(e.IEnvironmentService)}),define(re[29],ae([0,1,155,4]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function R(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=R;function A(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function L(l,m){switch(l){case 3:return m==="x64"?"win32-x64":m==="ia32"?"win32-ia32":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":"unknown";case"alpine":return m==="x64"?"alpine-x64":m==="arm64"?"alpine-arm64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=L;function P(l,m){return m==="web"&&!l.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function I(l,m,u){return P(m,u)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===u?!0:S(u).includes(l)}e.isTargetPlatformCompatible=I;function S(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=S;function C(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=C;var b;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(b=e.SortBy||(e.SortBy={}));var w;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(w=e.SortOrder||(e.SortOrder={}));var y;(function(l){l.Install="install",l.Uninstall="uninstall"})(y=e.StatisticType||(e.StatisticType={}));var d;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(d=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,i.createDecorator)("extensionGalleryService");var g;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatiblePreRelease="IncompatiblePreRelease",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Internal="Internal",l.Signature="Signature"})(g=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class v extends Error{constructor(m,u){super(m),this.code=u,this.name=u}}e.ExtensionManagementError=v,e.IExtensionManagementService=(0,i.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,i.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,i.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,D.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,D.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(re[193],ae([0,1,3,2,67,32,7,142,29]),function(_,e,D,i,R,A,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function S(v,l){return L.URI.revive(l?l.transformIncoming(v):v)}function C(v,l){return l?l.transformOutgoingURI(v):v}function b(v,l){l=l||P.DefaultURITransformer;const m=v.manifest;return{...(0,P.transformAndReviveIncomingURIs)({...v,manifest:void 0},l),manifest:m}}function w(v,l){return l?(0,A.cloneAndChange)(v,m=>m instanceof L.URI?l.transformOutgoingURI(m):void 0):v}class y{constructor(l,m){this.a=l,this.b=m,this.onInstallExtension=D.Event.buffer(l.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(l.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(l.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(l.onDidUninstallExtension,!0)}listen(l,m){const u=this.b(l);switch(m){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,h=>h.map(f=>({...f,local:f.local?w(f.local,u):f.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(l,m,u){const h=this.b(l);switch(m){case"zip":return this.a.zip(b(u[0],h)).then(f=>C(f,h));case"unzip":return this.a.unzip(S(u[0],h));case"install":return this.a.install(S(u[0],h),(0,R.revive)(u[1]));case"installFromLocation":return this.a.installFromLocation(S(u[0],h),L.URI.revive(u[1]));case"getManifest":return this.a.getManifest(S(u[0],h));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(u[0]);case"installFromGallery":return this.a.installFromGallery(u[0],(0,R.revive)(u[1]));case"uninstall":return this.a.uninstall(b(u[0],h),(0,R.revive)(u[1]));case"reinstallFromGallery":return this.a.reinstallFromGallery(b(u[0],h));case"getInstalled":return this.a.getInstalled(u[0],L.URI.revive(u[1])).then(f=>f.map(n=>w(n,h)));case"getMetadata":return this.a.getMetadata(b(u[0],h));case"updateMetadata":return this.a.updateMetadata(b(u[0],h),u[1]).then(f=>w(f,h));case"updateExtensionScope":return this.a.updateExtensionScope(b(u[0],h),u[1]).then(f=>w(f,h));case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(u[0],u[1])}throw new Error("Invalid call")}}e.ExtensionManagementChannel=y;class d extends i.Disposable{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}constructor(l){super(),this.j=l,this.c=this.B(new D.Emitter),this.f=this.B(new D.Emitter),this.g=this.B(new D.Emitter),this.h=this.B(new D.Emitter),this.B(this.j.listen("onInstallExtension")(m=>this.c.fire({identifier:m.identifier,source:this.k(m.source)?L.URI.revive(m.source):m.source,profileLocation:L.URI.revive(m.profileLocation)}))),this.B(this.j.listen("onDidInstallExtensions")(m=>this.f.fire(m.map(u=>({...u,local:u.local?b(u.local,null):u.local,source:this.k(u.source)?L.URI.revive(u.source):u.source,profileLocation:L.URI.revive(u.profileLocation)}))))),this.B(this.j.listen("onUninstallExtension")(m=>this.g.fire({identifier:m.identifier,profileLocation:L.URI.revive(m.profileLocation)}))),this.B(this.j.listen("onDidUninstallExtension")(m=>this.h.fire({...m,profileLocation:L.URI.revive(m.profileLocation)})))}k(l){return l?typeof l.path=="string"&&typeof l.scheme=="string":!1}getTargetPlatform(){return this.l||(this.l=this.j.call("getTargetPlatform")),this.l}async canInstall(l){const m=await this.getTargetPlatform();return l.allTargetPlatforms.some(u=>(0,I.isTargetPlatformCompatible)(u,l.allTargetPlatforms,m))}zip(l){return Promise.resolve(this.j.call("zip",[l]).then(m=>L.URI.revive(m)))}unzip(l){return Promise.resolve(this.j.call("unzip",[l]))}install(l,m){return Promise.resolve(this.j.call("install",[l,m])).then(u=>b(u,null))}installFromLocation(l,m){return Promise.resolve(this.j.call("installFromLocation",[l,m])).then(u=>b(u,null))}getManifest(l){return Promise.resolve(this.j.call("getManifest",[l]))}installFromGallery(l,m){return Promise.resolve(this.j.call("installFromGallery",[l,m])).then(u=>b(u,null))}uninstall(l,m){return Promise.resolve(this.j.call("uninstall",[l,m]))}reinstallFromGallery(l){return Promise.resolve(this.j.call("reinstallFromGallery",[l]))}getInstalled(l=null,m){return Promise.resolve(this.j.call("getInstalled",[l,m])).then(u=>u.map(h=>b(h,null)))}getMetadata(l){return Promise.resolve(this.j.call("getMetadata",[l]))}updateMetadata(l,m){return Promise.resolve(this.j.call("updateMetadata",[l,m])).then(u=>b(u,null))}updateExtensionScope(l,m){return Promise.resolve(this.j.call("updateExtensionScope",[l,m])).then(u=>b(u,null))}getExtensionsControlManifest(){return Promise.resolve(this.j.call("getExtensionsControlManifest"))}async download(l,m){const u=await this.j.call("download",[l,m]);return L.URI.revive(u)}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=d;class g{constructor(l){this.a=l}listen(l,m){throw new Error("Invalid listen")}call(l,m,u){switch(m){case"getConfigBasedTips":return this.a.getConfigBasedTips(L.URI.revive(u[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=g}),define(re[97],ae([0,1,4]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,D.createDecorator)("IExtensionSignatureVerificationService");class i{b(){return this.a||(this.a=new Promise((A,L)=>_(["node-vsce-sign"],async P=>A(P),L))),this.a}async verify(A,L){let P;try{P=await this.b()}catch{return!1}return P.verify(A,L)}}e.ExtensionSignatureVerificationService=i}),define(re[98],ae([0,1,4]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var i;(function(L){L[L.FILE=1]="FILE",L[L.WORKSPACE=2]="WORKSPACE",L[L.EXE=3]="EXE"})(i=e.RecommendationSource||(e.RecommendationSource={}));function R(L){switch(L){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=R;var A;(function(L){L.Ignored="ignored",L.Cancelled="cancelled",L.TooMany="toomany",L.IncompatibleWindow="incompatibleWindow",L.Accepted="reacted"})(A=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,D.createDecorator)("IExtensionRecommendationNotificationService")}),define(re[13],ae([0,1,48,12,27,15,7,163,4]),function(_,e,D,i,R,A,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,I.createDecorator)("fileService");function S(H){return H.create===!0}e.isFileOpenForWriteOptions=S;var C;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(C=e.FileType||(e.FileType={}));var b;(function(H){H[H.Readonly=1]="Readonly"})(b=e.FilePermission||(e.FilePermission={}));var w;(function(H){H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead",H[H.FileClone=32768]="FileClone"})(w=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function y(H){return!!(H.capabilities&2)}e.hasReadWriteCapability=y;function d(H){return!!(H.capabilities&8)}e.hasFileFolderCopyCapability=d;function g(H){return!!(H.capabilities&32768)}e.hasFileCloneCapability=g;function v(H){return!!(H.capabilities&4)}e.hasOpenReadWriteCloseCapability=v;function l(H){return!!(H.capabilities&16)}e.hasFileReadStreamCapability=l;function m(H){return y(H)?!!(H.capabilities&16384):!1}e.hasFileAtomicReadCapability=m;var u;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(u=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class h extends Error{constructor(Z,z){super(Z),this.code=z}}e.FileSystemProviderError=h;function f(H,Z){const z=new h(H.toString(),Z);return s(z,Z),z}e.createFileSystemProviderError=f;function n(H){return H||f((0,P.localize)(0,null),u.Unknown)}e.ensureFileSystemProviderError=n;function s(H,Z){return H.name=Z?`${Z} (FileSystemError)`:"FileSystemError",H}e.markAsFileSystemProviderError=s;function t(H){if(!H)return u.Unknown;if(H instanceof h)return H.code;const Z=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!Z)return u.Unknown;switch(Z[1]){case u.FileExists:return u.FileExists;case u.FileIsADirectory:return u.FileIsADirectory;case u.FileNotADirectory:return u.FileNotADirectory;case u.FileNotFound:return u.FileNotFound;case u.FileExceedsMemoryLimit:return u.FileExceedsMemoryLimit;case u.FileTooLarge:return u.FileTooLarge;case u.FileWriteLocked:return u.FileWriteLocked;case u.NoPermissions:return u.NoPermissions;case u.Unavailable:return u.Unavailable}return u.Unknown}e.toFileSystemProviderErrorCode=t;function a(H){if(H instanceof k)return H.fileOperationResult;switch(t(H)){case u.FileNotFound:return 1;case u.FileIsADirectory:return 0;case u.FileNotADirectory:return 10;case u.FileWriteLocked:return 5;case u.NoPermissions:return 6;case u.FileExists:return 4;case u.FileExceedsMemoryLimit:return 9;case u.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=a;var r;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY",H[H.WRITE=4]="WRITE"})(r=e.FileOperation||(e.FileOperation={}));class c{constructor(Z,z,B){this.resource=Z,this.operation=z,this.target=B}isOperation(Z){return this.operation===Z}}e.FileOperationEvent=c;var o;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class p{constructor(Z,z){this.a=void 0,this.b=void 0,this.c=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=Z;const B=new Map;for(const Y of Z){const ee=B.get(Y.type);switch(ee?ee.push([Y.resource,Y]):B.set(Y.type,[[Y.resource,Y]]),Y.type){case 1:this.rawAdded.push(Y.resource);break;case 0:this.rawUpdated.push(Y.resource);break;case 2:this.rawDeleted.push(Y.resource);break}}for(const[Y,ee]of B)switch(Y){case 1:this.a=D.TernarySearchTree.forUris(()=>z),this.a.fill(ee);break;case 0:this.b=D.TernarySearchTree.forUris(()=>z),this.b.fill(ee);break;case 2:this.c=D.TernarySearchTree.forUris(()=>z),this.c.fill(ee);break}}contains(Z,...z){return this.d(Z,{includeChildren:!1},...z)}affects(Z,...z){return this.d(Z,{includeChildren:!0},...z)}d(Z,z,...B){if(!Z)return!1;const Y=B.length>0;return!!((!Y||B.includes(1))&&(this.a?.get(Z)||z.includeChildren&&this.a?.findSuperstr(Z))||(!Y||B.includes(0))&&(this.b?.get(Z)||z.includeChildren&&this.b?.findSuperstr(Z))||(!Y||B.includes(2))&&(this.c?.findSubstr(Z)||z.includeChildren&&this.c?.findSuperstr(Z)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=p;function E(H,Z,z){return!H||!Z||H===Z||Z.length>H.length?!1:(Z.charAt(Z.length-1)!==i.sep&&(Z+=i.sep),z?(0,R.startsWithIgnoreCase)(H,Z):H.indexOf(Z)===0)}e.isParent=E;class k extends Error{constructor(Z,z,B){super(Z),this.fileOperationResult=z,this.options=B}}e.FileOperationError=k;class F extends k{constructor(Z,z,B){super(Z,2,B),this.stat=z}}e.NotModifiedSinceFileOperationError=F;var N;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",H[H.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(N=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var q;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(q=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function j(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.etag=j;async function O(H,Z){if(!Z.hasProvider(L.URI.from({scheme:H.scheme})))return new Promise(z=>{const B=Z.onDidChangeFileSystemProviderRegistrations(Y=>{Y.scheme===H.scheme&&Y.added&&(B.dispose(),z())})})}e.whenProviderRegistered=O,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class U{static formatSize(Z){return(0,A.isNumber)(Z)||(Z=0),Z<U.KB?(0,P.localize)(1,null,Z.toFixed(0)):Z<U.MB?(0,P.localize)(2,null,(Z/U.KB).toFixed(2)):Z<U.GB?(0,P.localize)(3,null,(Z/U.MB).toFixed(2)):Z<U.TB?(0,P.localize)(4,null,(Z/U.GB).toFixed(2)):(0,P.localize)(5,null,(Z/U.TB).toFixed(2))}}e.ByteSize=U,U.KB=1024,U.MB=U.KB*U.KB,U.GB=U.MB*U.KB,U.TB=U.GB*U.KB;var $;(function(H){H[H.IA32=0]="IA32",H[H.OTHER=1]="OTHER"})($=e.Arch||(e.Arch={}));function G(H){return{maxFileSize:H===0?300*U.MB:16*U.GB,maxHeapSize:H===0?700*U.MB:2*700*U.MB}}e.getPlatformLimits=G});var K=this&&this.__param||function(_,e){return function(D,i){e(D,i,_)}};define(re[194],ae([0,1,99,44,13]),function(_,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let A=class{constructor(P){this.a=P}async checksum(P){const I=(await this.a.readFileStream(P)).value;return new Promise((S,C)=>{const b=(0,D.createHash)("md5");(0,i.listenStream)(I,{onData:w=>b.update(w.buffer),onError:w=>C(w),onEnd:()=>S(b.digest("base64").replace(/=+$/,""))})})}};A=ye([K(0,R.IFileService)],A),e.ChecksumService=A}),define(re[195],ae([0,1,17,38,9,3,2,44,7,31,13]),function(_,e,D,i,R,A,L,P,I,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class b extends L.Disposable{constructor(y,d){super(),this.a=y,this.b=d,this.onDidChangeCapabilities=A.Event.None,this.f=this.B(new A.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new A.Emitter),this.onDidWatchError=this.g.event,this.h=(0,S.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(y){return this.a.call("stat",[y])}readdir(y){return this.a.call("readdir",[y])}async readFile(y,d){const{buffer:g}=await this.a.call("readFile",[y,d]);return g}readFileStream(y,d,g){const v=(0,P.newWriteableStream)(m=>D.VSBuffer.concat(m.map(u=>D.VSBuffer.wrap(u))).buffer),l=this.a.listen("readFileStream",[y,d])(m=>{if(m instanceof D.VSBuffer)v.write(m.buffer);else{if(m==="end")v.end();else{let u=m;u instanceof Error||(u=(0,C.createFileSystemProviderError)((0,i.toErrorMessage)(u),C.FileSystemProviderErrorCode.Unknown)),v.error(u),v.end()}l.dispose()}});return g.onCancellationRequested(()=>{v.error((0,R.canceled)()),v.end(),l.dispose()}),v}writeFile(y,d,g){return this.a.call("writeFile",[y,D.VSBuffer.wrap(d),g])}open(y,d){return this.a.call("open",[y,d])}close(y){return this.a.call("close",[y])}async read(y,d,g,v,l){const[m,u]=await this.a.call("read",[y,d,l]);return g.set(m.buffer.slice(0,u),v),u}write(y,d,g,v,l){return this.a.call("write",[y,d,D.VSBuffer.wrap(g),v,l])}mkdir(y){return this.a.call("mkdir",[y])}delete(y,d){return this.a.call("delete",[y,d])}rename(y,d,g){return this.a.call("rename",[y,d,g])}copy(y,d,g){return this.a.call("copy",[y,d,g])}cloneFile(y,d){return this.a.call("cloneFile",[y,d])}i(){this.B(this.a.listen("fileChange",[this.h])(y=>{if(Array.isArray(y)){const d=y;this.f.fire(d.map(g=>({resource:I.URI.revive(g.resource),type:g.type})))}else{const d=y;this.g.fire(d)}}))}watch(y,d){const g=(0,S.generateUuid)();return this.a.call("watch",[this.h,g,y,d]),(0,L.toDisposable)(()=>this.a.call("unwatch",[this.h,g]))}}e.DiskFileSystemProviderClient=b}),define(re[100],ae([0,1,17,9,164,13]),function(_,e,D,i,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function L(C,b,w,y,d,g){let v;try{await P(C,b,w,y,d,g)}catch(l){v=l}finally{v&&d.errorTransformer&&(v=d.errorTransformer(v)),typeof v<"u"&&w.error(v),w.end()}}e.readFileIntoStream=L;async function P(C,b,w,y,d,g){I(g);const v=await C.open(b,{create:!1});try{I(g);let l=0,m=0,u=d&&typeof d.length=="number"?d.length:void 0,h=D.VSBuffer.alloc(Math.min(d.bufferSize,typeof u=="number"?u:d.bufferSize)),f=d&&typeof d.position=="number"?d.position:0,n=0;do m=await C.read(v,f,h.buffer,n,h.byteLength-n),f+=m,n+=m,l+=m,typeof u=="number"&&(u-=m),n===h.byteLength&&(await w.write(y(h)),h=D.VSBuffer.alloc(Math.min(d.bufferSize,typeof u=="number"?u:d.bufferSize)),n=0);while(m>0&&(typeof u!="number"||u>0)&&I(g)&&S(l,d));if(n>0){let s=n;typeof u=="number"&&(s=Math.min(n,u)),w.write(y(h.slice(0,s)))}}catch(l){throw(0,A.ensureFileSystemProviderError)(l)}finally{await C.close(v)}}function I(C){if(C.isCancellationRequested)throw(0,i.canceled)();return!0}function S(C,b){if(b?.limits){if(typeof b.limits.memory=="number"&&C>b.limits.memory)throw(0,A.createFileSystemProviderError)((0,R.localize)(0,null),A.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof b.limits.size=="number"&&C>b.limits.size)throw(0,A.createFileSystemProviderError)((0,R.localize)(1,null),A.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(re[55],ae([0,1,89,2,12,5,7,13]),function(_,e,D,i,R,A,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function I(l){return l.recursive===!0}e.isRecursiveWatchRequest=I;class S extends i.Disposable{constructor(m,u,h,f){super(),this.h=m,this.i=u,this.j=h,this.k=f,this.c=this.B(new i.MutableDisposable),this.f=void 0,this.g=0}m(){const m=new i.DisposableStore;this.c.value=m,this.b=this.l(m),this.b.setVerboseLogging(this.j),m.add(this.b.onDidChangeFile(u=>this.h(u))),m.add(this.b.onDidLogMessage(u=>this.i(u))),m.add(this.b.onDidError(u=>this.n(u)))}n(m){this.k.restartOnError?this.g<S.a&&this.f?(this.r(`restarting watcher after error: ${m}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${m}`):this.r(m)}p(m){this.g++,this.m(),this.watch(m)}async watch(m){this.f=m,await this.b?.watch(m)}async setVerboseLogging(m){this.j=m,await this.b?.setVerboseLogging(m)}r(m){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${m}`})}dispose(){return this.b=void 0,super.dispose()}}e.AbstractWatcherClient=S,S.a=5;class C extends S{constructor(m,u,h){super(m,u,h,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=C;class b extends S{constructor(m,u,h){super(m,u,h,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=b;function w(l){return l.map(m=>({type:m.type,resource:L.URI.file(m.path)}))}e.toFileChanges=w;function y(l){const m=new v;for(const u of l)m.processEvent(u);return m.coalesce()}e.coalesceEvents=y;function d(l,m){return typeof m=="string"&&!m.startsWith(D.GLOBSTAR)&&!(0,R.isAbsolute)(m)?{base:l,pattern:m}:m}e.normalizeWatcherPattern=d;function g(l,m){const u=[];for(const h of m)u.push((0,D.parse)(d(l,h)));return u}e.parseWatcherPatterns=g;class v{constructor(){this.a=new Set,this.b=new Map}c(m){return A.isLinux?m.path:m.path.toLowerCase()}processEvent(m){const u=this.b.get(this.c(m));let h=!1;if(u){const f=u.type,n=m.type;u.path!==m.path&&(m.type===2||m.type===1)?h=!0:f===1&&n===2?(this.b.delete(this.c(m)),this.a.delete(u)):f===2&&n===1?u.type=0:f===1&&n===0||(u.type=n)}else h=!0;h&&(this.a.add(m),this.b.set(this.c(m),m))}coalesce(){const m=[],u=[];return Array.from(this.a).filter(h=>h.type!==2?(m.push(h),!1):!0).sort((h,f)=>h.path.length-f.path.length).filter(h=>u.some(f=>(0,P.isParent)(h.path,f,!A.isLinux))?!1:(u.push(h.path),!0)).concat(m)}}}),define(re[196],ae([0,1,52,6,23,47,2,85,12,5,144,28,55]),function(_,e,D,i,R,A,L,P,I,S,C,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class y extends L.Disposable{constructor(v,l,m,u){super(),this.k=v,this.l=l,this.m=m,this.n=u,this.c=new i.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},h=>this.l(h)),this.f=this.B(new i.ThrottledDelayer(y.b)),this.g=[],this.h=(0,w.parseWatcherPatterns)(this.k.path,this.k.excludes),this.i=this.k.includes?(0,w.parseWatcherPatterns)(this.k.path,this.k.includes):void 0,this.j=new R.CancellationTokenSource,this.ready=this.r()}async r(){try{const v=await this.s(this.k);if(this.j.token.isCancellationRequested)return;const l=await b.Promises.stat(v);this.B(await this.t(v,l.isDirectory()))}catch(v){v.code!=="ENOENT"?this.w(v):this.z(v)}}async s(v){let l=v.path;try{l=await b.Promises.realpath(v.path),v.path===l&&(l=await(0,C.realcase)(v.path)??v.path),v.path!==l&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${v.path}, real: ${l})`)}catch{}return l}async t(v,l){if(S.isMacintosh&&(0,A.isEqualOrParent)(v,"/Volumes/",!0))return this.w(`Refusing to watch ${v} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),L.Disposable.None;const m=new R.CancellationTokenSource(this.j.token),u=new L.DisposableStore;try{const h=(0,I.basename)(v),f=(0,D.watch)(v);u.add((0,L.toDisposable)(()=>{f.removeAllListeners(),f.close()})),this.z(`Started watching: '${v}'`);const n=new Set;if(l)try{for(const t of await b.Promises.readdir(v))n.add(t)}catch(t){this.w(t)}const s=new Map;u.add((0,L.toDisposable)(()=>{for(const[,t]of s)t.dispose();s.clear()})),f.on("error",(t,a)=>{this.w(`Failed to watch ${v} for changes using fs.watch() (${t}, ${a})`),this.dispose()}),f.on("change",(t,a)=>{if(m.token.isCancellationRequested)return;this.z(`[raw] ["${t}"] ${a}`);let r="";if(a&&(r=a.toString(),S.isMacintosh&&(r=(0,P.normalizeNFC)(r))),!(!r||t!=="change"&&t!=="rename"))if(l)if(t==="rename"){s.get(r)?.dispose();const c=setTimeout(async()=>{if(s.delete(r),r===h&&!await b.Promises.exists(v)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const o=await this.v((0,I.join)(v,r));if(m.token.isCancellationRequested)return;let p;o?n.has(r)?p=0:(p=1,n.add(r)):(n.delete(r),p=2),this.u({path:(0,I.join)(this.k.path,r),type:p})},y.a);s.set(r,(0,L.toDisposable)(()=>clearTimeout(c)))}else{let c;n.has(r)?c=0:(c=1,n.add(r)),this.u({path:(0,I.join)(this.k.path,r),type:c})}else if(t==="rename"||r!==h){const c=setTimeout(async()=>{const o=await b.Promises.exists(v);m.token.isCancellationRequested||(o?(this.u({path:this.k.path,type:0},!0),u.add(await this.t(v,!1))):(await this.u({path:this.k.path,type:2},!0),this.dispose()))},y.a);u.clear(),u.add((0,L.toDisposable)(()=>clearTimeout(c)))}else this.u({path:this.k.path,type:0},!0)})}catch(h){await b.Promises.exists(v)&&!m.token.isCancellationRequested&&this.w(`Failed to watch ${v} for changes using fs.watch() (${h.toString()})`)}return(0,L.toDisposable)(()=>{m.dispose(!0),u.dispose()})}async u(v,l=!1){if(!this.j.token.isCancellationRequested){this.n&&this.z(`${v.type===1?"[ADDED]":v.type===2?"[DELETED]":"[CHANGED]"} ${v.path}`),!l&&this.h.some(m=>m(v.path))?this.n&&this.z(` >> ignored (excluded) ${v.path}`):!l&&this.i&&this.i.length>0&&!this.i.some(m=>m(v.path))?this.n&&this.z(` >> ignored (not included) ${v.path}`):this.g.push(v);try{await this.f.trigger(async()=>{const m=this.g;this.g=[];const u=(0,w.coalesceEvents)(m);if(u.length>0){if(this.n)for(const f of u)this.z(`>> normalized ${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`);this.c.work(u)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async v(v){if(S.isLinux)return b.Promises.exists(v);try{const l=(0,I.basename)(v);return(await b.Promises.readdir((0,I.dirname)(v))).some(u=>u===l)}catch(l){return this.z(l),!1}}setVerboseLogging(v){this.n=v}w(v){this.j.token.isCancellationRequested||this.m?.({type:"error",message:`[File Watcher (node.js)] ${v}`})}y(v){this.j.token.isCancellationRequested||this.m?.({type:"warn",message:`[File Watcher (node.js)] ${v}`})}z(v){!this.j.token.isCancellationRequested&&this.n&&this.m?.({type:"trace",message:`[File Watcher (node.js)] ${v}`})}dispose(){this.z(`stopping file watcher on ${this.k.path}`),this.j.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=y,y.a=100,y.b=50;async function d(g,v,l,m,u=512){const h=await b.Promises.open(g,"r"),f=Buffer.allocUnsafe(u),n=new R.CancellationTokenSource(m);let s,t=!1;const a={path:g,excludes:[],recursive:!1},r=new y(a,c=>{(async()=>{for(const{type:o}of c)if(o===0){if(t)return;t=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:p}=await b.Promises.read(h,f,0,u,null);if(!p||n.token.isCancellationRequested)break;v(f.slice(0,p))}}catch(p){s=new Error(p),n.dispose(!0)}finally{t=!1}}})()});return await r.ready,l(),new Promise((c,o)=>{n.token.onCancellationRequested(async()=>{r.dispose();try{await b.Promises.close(h)}catch(p){s=new Error(p)}s?o(s):c()})})}e.watchFileContents=d}),define(re[197],ae([0,1,3,89,2,5,196]),function(_,e,D,i,R,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class P extends R.Disposable{constructor(){super(...arguments),this.a=this.B(new D.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new D.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=D.Event.None,this.c=new Map,this.f=!1}async watch(S){const C=this.i(S),b=C.filter(y=>{const d=this.c.get(y.path);return d?!(0,i.patternsEquals)(d.request.excludes,y.excludes)||!(0,i.patternsEquals)(d.request.includes,y.includes):!0}),w=Array.from(this.c.values()).filter(({request:y})=>!C.find(d=>d.path===y.path&&(0,i.patternsEquals)(d.excludes,y.excludes)&&(0,i.patternsEquals)(d.includes,y.includes))).map(({request:y})=>y.path);b.length&&this.j(`Request to start watching: ${b.map(y=>`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"}, includes: ${y.includes&&y.includes.length>0?JSON.stringify(y.includes):"<all>"})`).join(",")}`),w.length&&this.j(`Request to stop watching: ${w.join(",")}`);for(const y of w)this.h(y);for(const y of b)this.g(y)}g(S){const C=new L.NodeJSFileWatcherLibrary(S,w=>this.a.fire(w),w=>this.b.fire(w),this.f),b={request:S,instance:C};this.c.set(S.path,b)}async stop(){for(const[S]of this.c)this.h(S);this.c.clear()}h(S){const C=this.c.get(S);C&&(this.c.delete(S),C.instance.dispose())}i(S){const C=new Map;for(const b of S){const w=A.isLinux?b.path:b.path.toLowerCase();C.set(w,b)}return Array.from(C.values())}async setVerboseLogging(S){this.f=S;for(const[,C]of this.c)C.instance.setVerboseLogging(S)}j(S){this.f&&this.b.fire({type:"trace",message:this.k(S)})}k(S,C){return C?`[File Watcher (node.js)] ${S} (path: ${C.request.path})`:`[File Watcher (node.js)] ${S}`}}e.NodeJSWatcher=P}),define(re[198],ae([0,1,55,197]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class R extends D.AbstractNonRecursiveWatcherClient{constructor(L,P,I){super(L,P,I),this.m()}l(){return new i.NodeJSWatcher}}e.NodeJSWatcherClient=R}),define(re[199],ae([0,1,24,39,68,55]),function(_,e,D,i,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class L extends A.AbstractUniversalWatcherClient{constructor(I,S,C){super(I,S,C),this.m()}l(I){const S=I.add(new R.Client(D.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return I.add(S.onDidProcessExit(({code:C,signal:b})=>this.n(`terminated by itself with code ${C}, signal: ${b}`))),i.ProxyChannel.toService((0,i.getNextTickChannel)(S.getChannel("watcher")))}}e.UniversalWatcherClient=L}),define(re[72],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class D{constructor(...R){this.a=new Map;for(const[A,L]of R)this.set(A,L)}set(R,A){const L=this.a.get(R);return this.a.set(R,A),L}has(R){return this.a.has(R)}get(R){return this.a.get(R)}}e.ServiceCollection=D}),define(re[200],ae([0,1,6,9,2,54,190,4,72,84]),function(_,e,D,i,R,A,L,P,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const C=!1;class b extends Error{constructor(v){super("cyclic dependency between services"),this.message=v.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${v.toString()}`}}class w{constructor(v=new I.ServiceCollection,l=!1,m,u=C){this.f=v,this.g=l,this.h=m,this.i=u,this.o=new Set,this.f.set(P.IInstantiationService,this),this._globalGraph=u?m?._globalGraph??new L.Graph(h=>h):void 0}createChild(v){return new w(v,this.g,this,this.i)}invokeFunction(v,...l){const m=d.traceInvocation(this.i,v);let u=!1;try{return v({get:f=>{if(u)throw(0,i.illegalState)("service accessor is only valid during the invocation of its target method");const n=this.m(f,m);if(!n)throw new Error(`[invokeFunction] unknown service '${f}'`);return n}},...l)}finally{u=!0,m.stop()}}createInstance(v,...l){let m,u;return v instanceof A.SyncDescriptor?(m=d.traceCreation(this.i,v.ctor),u=this.j(v.ctor,v.staticArguments.concat(l),m)):(m=d.traceCreation(this.i,v),u=this.j(v,l,m)),m.stop(),u}j(v,l=[],m){const u=P._util.getServiceDependencies(v).sort((n,s)=>n.index-s.index),h=[];for(const n of u){const s=this.m(n.id,m);s||this.u(`[createInstance] ${v.name} depends on UNKNOWN service ${n.id}.`,!1),h.push(s)}const f=u.length>0?u[0].index:l.length;if(l.length!==f){console.trace(`[createInstance] First service dependency of ${v.name} at position ${f+1} conflicts with ${l.length} static arguments`);const n=f-l.length;n>0?l=l.concat(new Array(n)):l=l.slice(0,f)}return Reflect.construct(v,l.concat(h))}k(v,l){if(this.f.get(v)instanceof A.SyncDescriptor)this.f.set(v,l);else if(this.h)this.h.k(v,l);else throw new Error("illegalState - setting UNKNOWN service instance")}l(v){const l=this.f.get(v);return!l&&this.h?this.h.l(v):l}m(v,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(v));const m=this.l(v);return m instanceof A.SyncDescriptor?this.q(v,m,l.branch(v,!0)):(l.branch(v,!1),m)}q(v,l,m){if(this.o.has(v))throw new Error(`illegal state - RECURSIVELY instantiating service '${v}'`);this.o.add(v);try{return this.r(v,l,m)}finally{this.o.delete(v)}}r(v,l,m){const u=new L.Graph(n=>n.id.toString());let h=0;const f=[{id:v,desc:l,_trace:m}];for(;f.length;){const n=f.pop();if(u.lookupOrInsertNode(n),h++>1e3)throw new b(u);for(const s of P._util.getServiceDependencies(n.desc.ctor)){const t=this.l(s.id);if(t||this.u(`[createInstance] ${v} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(s.id)),t instanceof A.SyncDescriptor){const a={id:s.id,desc:t,_trace:n._trace.branch(s.id,!0)};u.insertEdge(n,a),f.push(a)}}}for(;;){const n=u.roots();if(n.length===0){if(!u.isEmpty())throw new b(u);break}for(const{data:s}of n){if(this.l(s.id)instanceof A.SyncDescriptor){const a=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,a)}u.removeNode(s)}}return this.l(v)}s(v,l,m=[],u,h){if(this.f.get(v)instanceof A.SyncDescriptor)return this.t(v,l,m,u,h);if(this.h)return this.h.s(v,l,m,u,h);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}t(v,l,m=[],u,h){if(u){const f=new w(void 0,this.g,this,this.i);f.c=String(v);const n=new Map,s=new D.IdleValue(()=>{const t=f.j(l,m,h);for(const[a,r]of n){const c=t[a];if(typeof c=="function")for(const o of r)c.apply(t,o)}return n.clear(),t});return new Proxy(Object.create(null),{get(t,a){if(!s.isInitialized&&typeof a=="string"&&(a.startsWith("onDid")||a.startsWith("onWill"))){let o=n.get(a);return o||(o=new S.LinkedList,n.set(a,o)),(E,k,F)=>{const N=o.push([E,k,F]);return(0,R.toDisposable)(N)}}if(a in t)return t[a];const r=s.value;let c=r[a];return typeof c!="function"||(c=c.bind(r),t[a]=c),c},set(t,a,r){return s.value[a]=r,!0},getPrototypeOf(t){return l.prototype}})}else return this.j(l,m,h)}u(v,l){if(l&&console.warn(v),this.g)throw new Error(v)}}e.InstantiationService=w;var y;(function(g){g[g.Creation=0]="Creation",g[g.Invocation=1]="Invocation",g[g.Branch=2]="Branch"})(y||(y={}));class d{static traceInvocation(v,l){return v?new d(1,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d.c}static traceCreation(v,l){return v?new d(0,l.name):d.c}constructor(v,l){this.type=v,this.name=l,this.g=Date.now(),this.h=[]}branch(v,l){const m=new d(2,v.toString());return this.h.push([v,l,m]),m}stop(){const v=Date.now()-this.g;d.f+=v;let l=!1;function m(h,f){const n=[],s=new Array(h+1).join("	");for(const[t,a,r]of f.h)if(a&&r){l=!0,n.push(`${s}CREATES -> ${t}`);const c=m(h+1,r);c&&n.push(c)}else n.push(`${s}uses -> ${t}`);return n.join(`
`)}const u=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${v.toFixed(2)}ms (grand total ${d.f.toFixed(2)}ms)`];(v>2||l)&&d.all.add(u.join(`
`))}}e.Trace=d,d.all=new Set,d.c=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d.f=0}),define(re[201],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class D{constructor(R,A){this.a=R,this.b=A}getChannel(R){return this.a.getChannel(R,this.b)}registerChannel(R,A){this.a.registerChannel(R,A)}}e.MessagePortMainProcessService=D}),define(re[56],ae([0,1,39,54,71,4]),function(_,e,D,i,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class L{constructor(y,d,g,v){const l=g.getChannel(y);return P(d)?v.createInstance(new i.SyncDescriptor(d.channelClientCtor,[l])):D.ProxyChannel.toService(l,d?.proxyOptions)}}function P(w){return!!w?.channelClientCtor}e.IMainProcessService=(0,A.createDecorator)("mainProcessService");let I=class extends L{constructor(y,d,g,v){super(y,d,g,v)}};I=ye([K(2,e.IMainProcessService),K(3,A.IInstantiationService)],I);function S(w,y,d){(0,R.registerSingleton)(w,new i.SyncDescriptor(I,[y,d],!0))}e.registerMainProcessRemoteService=S,e.ISharedProcessService=(0,A.createDecorator)("sharedProcessService");let C=class extends L{constructor(y,d,g,v){super(y,d,g,v)}};C=ye([K(2,e.ISharedProcessService),K(3,A.IInstantiationService)],C);function b(w,y,d){(0,R.registerSingleton)(w,new i.SyncDescriptor(C,[y,d],!0))}e.registerSharedProcessRemoteService=b}),define(re[73],ae([0,1,23,2,5,166,29,4]),function(_,e,D,i,R,A,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function I(C){return C.tags.find(b=>b.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=I,e.ILanguagePackService=(0,P.createDecorator)("languagePackService");let S=class extends i.Disposable{constructor(b){super(),this.c=b}async getAvailableLanguages(){const b=new D.CancellationTokenSource;setTimeout(()=>b.cancel(),1e3);let w;try{w=await this.c.query({text:'category:"language packs"',pageSize:20},b.token)}catch{return[]}const d=w.firstPage.filter(g=>g.properties.localizedLanguages?.length&&g.tags.some(v=>v.startsWith("lp-"))).map(g=>{const v=g.properties.localizedLanguages?.[0],l=I(g);return{...this.f(l,v,g),extensionId:g.identifier.id,galleryExtension:g}});return d.push({...this.f("en","English"),extensionId:"default"}),d}f(b,w,y){const d=w??b;let g;if(d!==b&&(g=`(${b})`),b.toLowerCase()===R.language.toLowerCase()&&(g??="",g+=(0,A.localize)(0,null)),y?.installCount){g??="";const v=y.installCount;let l;v>1e6?l=`${Math.floor(v/1e5)/10}M`:v>1e3?l=`${Math.floor(v/1e3)}K`:l=String(v),g+=` $(cloud-download) ${l}`}return{id:b,label:d,description:g}}};S=ye([K(0,L.IExtensionGalleryService)],S),e.LanguagePackBaseService=S}),define(re[202],ae([0,1,2,73]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let R=class extends D.Disposable{constructor(L){super(),this.a=L,this.b()}b(){this.a.update()}};R=ye([K(0,i.ILanguagePackService)],R),e.LocalizationsUpdater=R}),define(re[8],ae([0,1,38,3,2,37,5,7,4]),function(_,e,D,i,R,A,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,I.createDecorator)("logService"),e.ILoggerService=(0,I.createDecorator)("loggerService");function S(){return new Date().toISOString()}var C;(function(c){c[c.Off=0]="Off",c[c.Trace=1]="Trace",c[c.Debug=2]="Debug",c[c.Info=3]="Info",c[c.Warning=4]="Warning",c[c.Error=5]="Error"})(C=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=C.Info;function b(c,o,p){switch(o){case C.Trace:c.trace(p);break;case C.Debug:c.debug(p);break;case C.Info:c.info(p);break;case C.Warning:c.warn(p);break;case C.Error:c.error(p);break;case C.Off:break;default:throw new Error(`Invalid log level ${o}`)}}e.log=b;function w(c){let o="";for(let p=0;p<c.length;p++){let E=c[p];if(typeof E=="object")try{E=JSON.stringify(E)}catch{}o+=(p>0?" ":"")+E}return o}e.format=w;class y extends R.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new i.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(o){this.b!==o&&(this.b=o,this.c.fire(this.b))}getLevel(){return this.b}f(o){return this.b!==C.Off&&this.b<=o}}e.AbstractLogger=y;class d extends y{constructor(o){super(),this.h=o}f(o){return this.h||super.f(o)}trace(o,...p){this.f(C.Trace)&&this.g(C.Trace,w([o,...p]))}debug(o,...p){this.f(C.Debug)&&this.g(C.Debug,w([o,...p]))}info(o,...p){this.f(C.Info)&&this.g(C.Info,w([o,...p]))}warn(o,...p){this.f(C.Warning)&&this.g(C.Warning,w([o,...p]))}error(o,...p){if(this.f(C.Error))if(o instanceof Error){const E=Array.prototype.slice.call(arguments);E[0]=o.stack,this.g(C.Error,w(E))}else this.g(C.Error,w([o,...p]))}flush(){}}e.AbstractMessageLogger=d;class g extends y{constructor(o=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(o),this.g=!L.isWindows}trace(o,...p){this.f(C.Trace)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,o,...p):console.log(`[main ${S()}]`,o,...p))}debug(o,...p){this.f(C.Debug)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,o,...p):console.log(`[main ${S()}]`,o,...p))}info(o,...p){this.f(C.Info)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,o,...p):console.log(`[main ${S()}]`,o,...p))}warn(o,...p){this.f(C.Warning)&&(this.g?console.warn(`\x1B[93m[main ${S()}]\x1B[0m`,o,...p):console.warn(`[main ${S()}]`,o,...p))}error(o,...p){this.f(C.Error)&&(this.g?console.error(`\x1B[91m[main ${S()}]\x1B[0m`,o,...p):console.error(`[main ${S()}]`,o,...p))}dispose(){}flush(){}}e.ConsoleMainLogger=g;class v extends y{constructor(o=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(o)}trace(o,...p){this.f(C.Trace)&&console.log("%cTRACE","color: #888",o,...p)}debug(o,...p){this.f(C.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",o,...p)}info(o,...p){this.f(C.Info)&&console.log("%c INFO","color: #33f",o,...p)}warn(o,...p){this.f(C.Warning)&&console.log("%c WARN","color: #993",o,...p)}error(o,...p){this.f(C.Error)&&console.log("%c  ERR","color: #f33",o,...p)}dispose(){}flush(){}}e.ConsoleLogger=v;class l extends y{constructor(o,p=e.DEFAULT_LOG_LEVEL){super(),this.g=o,this.setLevel(p)}trace(o,...p){this.f(C.Trace)&&this.g.log(C.Trace,[this.h(o),...p])}debug(o,...p){this.f(C.Debug)&&this.g.log(C.Debug,[this.h(o),...p])}info(o,...p){this.f(C.Info)&&this.g.log(C.Info,[this.h(o),...p])}warn(o,...p){this.f(C.Warning)&&this.g.log(C.Warning,[this.h(o),...p])}error(o,...p){this.f(C.Error)&&this.g.log(C.Error,[this.h(o),...p])}h(o){return typeof o=="string"?o:(0,D.toErrorMessage)(o,this.f(C.Trace))}dispose(){}flush(){}}e.AdapterLogger=l;class m extends y{constructor(o){super(),this.g=o,o.length&&this.setLevel(o[0].getLevel())}setLevel(o){for(const p of this.g)p.setLevel(o);super.setLevel(o)}trace(o,...p){for(const E of this.g)E.trace(o,...p)}debug(o,...p){for(const E of this.g)E.debug(o,...p)}info(o,...p){for(const E of this.g)E.info(o,...p)}warn(o,...p){for(const E of this.g)E.warn(o,...p)}error(o,...p){for(const E of this.g)E.error(o,...p)}flush(){for(const o of this.g)o.flush()}dispose(){for(const o of this.g)o.dispose()}}e.MultiplexLogService=m;class u extends R.Disposable{constructor(o){super(),this.b=o,this.B(o)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(o){this.b.setLevel(o)}getLevel(){return this.b.getLevel()}trace(o,...p){this.b.trace(o,...p)}debug(o,...p){this.b.debug(o,...p)}info(o,...p){this.b.info(o,...p)}warn(o,...p){this.b.warn(o,...p)}error(o,...p){this.b.error(o,...p)}flush(){this.b.flush()}}e.LogService=u;class h extends R.Disposable{constructor(o,p){super(),this.c=o,this.b=new A.ResourceMap,this.B(p(E=>this.setLevel(E)))}getLoggers(){return[...this.b.values()].map(({logger:o})=>o)}getLogger(o){return this.b.get(o)?.logger}createLogger(o,p,E){let k=this.b.get(o)?.logger;return k||(E=p?.always?C.Trace:E,k=this.f(o,E??this.c,p),this.b.set(o,{logger:k,logLevel:E})),k}setLevel(o,p){const E=P.URI.isUri(o)?o:void 0,k=E?p:o;if(E){const F=this.b.get(E);F&&F.logLevel!==k&&(F.logLevel=k,F.logger.setLevel(k))}else this.c=k,this.b.forEach(({logLevel:F,logger:N})=>{F===void 0&&N.setLevel(this.c)})}getLogLevel(o){return this.b.get(o)?.logLevel}dispose(){this.b.forEach(({logger:o})=>o.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=h;class f{constructor(){this.onDidChangeLogLevel=new i.Emitter().event}setLevel(o){}getLevel(){return C.Info}trace(o,...p){}debug(o,...p){}info(o,...p){}warn(o,...p){}error(o,...p){}critical(o,...p){}dispose(){}flush(){}}e.NullLogger=f;class n extends f{}e.NullLogService=n;class s extends h{constructor(){super(C.Info,i.Event.None)}f(o,p,E){return new f}}e.NullLoggerService=s;function t(c){if(c.verbose)return C.Trace;if(typeof c.logLevel=="string"){const o=r(c.logLevel.toLowerCase());if(o!==void 0)return o}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=t;function a(c){switch(c){case C.Trace:return"trace";case C.Debug:return"debug";case C.Info:return"info";case C.Warning:return"warn";case C.Error:return"error";case C.Off:return"off"}}e.LogLevelToString=a;function r(c){switch(c){case"trace":return C.Trace;case"debug":return C.Debug;case"info":return C.Info;case"warn":return C.Warning;case"error":return C.Error;case"critical":return C.Error;case"off":return C.Off}}e.parseLogLevel=r}),define(re[203],ae([0,1,6,9,2,12,28,14,8]),function(_,e,D,i,R,A,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let S=class extends R.Disposable{constructor(b,w){super(),this.a=b,this.b=w,this.B(new D.RunOnceScheduler(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const b=(0,A.basename)(this.a.logsPath),w=(0,A.dirname)(this.a.logsPath),g=(await L.Promises.readdir(w)).filter(l=>/^\d{8}T\d{6}$/.test(l)).sort().filter(l=>l!==b),v=g.slice(0,Math.max(0,g.length-9));v.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${v.join(", ")}'`),await Promise.all(v.map(l=>L.Promises.rm((0,A.join)(w,l)))))}catch(b){(0,i.onUnexpectedError)(b)}}};S=ye([K(0,P.IEnvironmentService),K(1,I.ILogService)],S),e.LogsDataCleaner=S}),define(re[204],ae([0,1,20,6,9,3,2,12,55,8]),function(_,e,D,i,R,A,L,P,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class C extends L.Disposable{constructor(w,y){super(),this.a=w,this.b=y,this.c=this.B(new A.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new A.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new i.ThrottledDelayer(0)),this.s=[],this.t=this.B(new i.ThrottledDelayer(0))}watch(w,y){return y.recursive||this.b?.watcher?.forceUniversal?this.l(w,y):this.u(w,y)}l(w,y){const d={path:this.C(w),excludes:y.excludes,includes:y.includes,recursive:y.recursive},g=(0,D.insert)(this.j,d);return this.m(),(0,L.toDisposable)(()=>{g(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(w=>(0,R.onUnexpectedError)(w))}n(){this.h||(this.h=this.B(this.p(y=>this.c.fire((0,I.toFileChanges)(y)),y=>this.z(y),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)})));const w=this.b?.watcher?.recursive?.usePolling;if(w===!0)for(const y of this.j)(0,I.isRecursiveWatchRequest)(y)&&(y.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const y of this.j)(0,I.isRecursiveWatchRequest)(y)&&w.includes(y.path)&&(y.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(w,y){const d={path:this.C(w),excludes:y.excludes,includes:y.includes,recursive:!1},g=(0,D.insert)(this.s,d);return this.v(),(0,L.toDisposable)(()=>{g(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(w=>(0,R.onUnexpectedError)(w))}w(){return this.r||(this.r=this.B(this.y(w=>this.c.fire((0,I.toFileChanges)(w)),w=>this.z(w),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)}))),this.r.watch(this.s)}z(w){w.type==="error"&&this.g.fire(w.message),this.a[w.type](w.message)}C(w){return(0,P.normalize)(w.fsPath)}}e.AbstractDiskFileSystemProvider=C}),define(re[205],ae([0,1,20,6,17,23,3,66,64,2,48,24,206,21,44,162,13,100,8]),function(_,e,D,i,R,A,L,P,I,S,C,b,w,y,d,g,v,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let u=class extends S.Disposable{constructor(f){super(),this.b=f,this.a=256*1024,this.c=this.B(new L.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new L.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new L.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new L.Emitter),this.onDidRunOperation=this.m.event,this.Q=this.B(new L.Emitter),this.onDidFilesChange=this.Q.event,this.R=this.B(new L.Emitter),this.onDidWatchError=this.R.event,this.S=new Map,this.W=this.B(new i.ResourceQueue)}registerProvider(f,n){if(this.h.has(f))throw new Error(`A filesystem provider for the scheme '${f}' is already registered.`);(0,w.mark)(`code/registerFilesystem/${f}`);const s=new S.DisposableStore;return this.h.set(f,n),this.c.fire({added:!0,scheme:f,provider:n}),s.add(n.onDidChangeFile(t=>this.Q.fire(new v.FileChangesEvent(t,!this.N(n))))),typeof n.onDidWatchError=="function"&&s.add(n.onDidWatchError(t=>this.R.fire(new Error(t)))),s.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:f}))),(0,S.toDisposable)(()=>{this.c.fire({added:!1,scheme:f,provider:n}),this.h.delete(f),(0,S.dispose)(s)})}getProvider(f){return this.h.get(f)}async activateProvider(f){const n=[];this.f.fire({scheme:f,join(s){n.push(s)}}),!this.h.has(f)&&await i.Promises.settled(n)}async canHandleResource(f){return await this.activateProvider(f.scheme),this.hasProvider(f)}hasProvider(f){return this.h.has(f.scheme)}hasCapability(f,n){const s=this.h.get(f.scheme);return!!(s&&s.capabilities&n)}listCapabilities(){return I.Iterable.map(this.h,([f,n])=>({scheme:f,capabilities:n.capabilities}))}async j(f){if(!(0,y.isAbsolutePath)(f))throw new v.FileOperationError((0,g.localize)(0,null,this.mb(f)),8);await this.activateProvider(f.scheme);const n=this.h.get(f.scheme);if(!n){const s=new Error;throw s.name="ENOPRO",s.message=(0,g.localize)(1,null,f.toString()),s}return n}async k(f){const n=await this.j(f);if((0,v.hasOpenReadWriteCloseCapability)(n)||(0,v.hasReadWriteCapability)(n)||(0,v.hasFileReadStreamCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${f.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(f){const n=await this.j(f);if((0,v.hasOpenReadWriteCloseCapability)(n)||(0,v.hasReadWriteCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${f.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(f,n){try{return await this.n(f,n)}catch(s){throw(0,v.toFileSystemProviderErrorCode)(s)===v.FileSystemProviderErrorCode.FileNotFound?new v.FileOperationError((0,g.localize)(2,null,this.mb(f)),1):(0,v.ensureFileSystemProviderError)(s)}}async n(f,n){const s=await this.j(f),t=this.N(s),a=n?.resolveTo,r=n?.resolveSingleChildDescendants,c=n?.resolveMetadata,o=await s.stat(f);let p;return this.p(s,f,o,void 0,!!c,(E,k)=>(p||(p=C.TernarySearchTree.forUris(()=>!t),p.set(f,!0),a&&p.fill(!0,a)),p.get(E.resource)||p.findSuperstr(E.resource.with({query:null,fragment:null}))?!0:E.isDirectory&&r?k===1:!1))}async p(f,n,s,t,a,r){const{providerExtUri:c}=this.M(f),o={resource:n,name:c.basename(n),isFile:(s.type&v.FileType.File)!==0,isDirectory:(s.type&v.FileType.Directory)!==0,isSymbolicLink:(s.type&v.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:Boolean((s.permissions??0)&v.FilePermission.Readonly)||Boolean(f.capabilities&2048),etag:(0,v.etag)({mtime:s.mtime,size:s.size}),children:void 0};if(o.isDirectory&&r(o,t)){try{const p=await f.readdir(n),E=await i.Promises.settled(p.map(async([k,F])=>{try{const N=c.joinPath(n,k),q=a?await f.stat(N):{type:F};return await this.p(f,N,q,p.length,a,r)}catch(N){return this.b.trace(N),null}}));o.children=(0,D.coalesce)(E)}catch(p){this.b.trace(p),o.children=[]}return o}return o}async resolveAll(f){return i.Promises.settled(f.map(async n=>{try{return{stat:await this.n(n.resource,n.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(f){const n=await this.j(f),s=await n.stat(f);return this.p(n,f,s,void 0,!0,()=>!1)}async exists(f){const n=await this.j(f);try{return!!await n.stat(f)}catch{return!1}}async canCreateFile(f,n){try{await this.r(f,n)}catch(s){return s}return!0}async r(f,n){if(!n?.overwrite&&await this.exists(f))throw new v.FileOperationError((0,g.localize)(3,null,this.mb(f)),3,n)}async createFile(f,n=R.VSBuffer.fromString(""),s){await this.r(f,s);const t=await this.writeFile(f,n);return this.m.fire(new v.FileOperationEvent(f,0,t)),t}async writeFile(f,n,s){const t=this.kb(await this.l(f),f),{providerExtUri:a}=this.M(t);try{await this.s(t,f,s)||await this.O(t,a.dirname(f));let c;if((0,v.hasReadWriteCapability)(t)&&!(n instanceof R.VSBuffer))if((0,d.isReadableStream)(n)){const o=await(0,d.peekStream)(n,3);o.ended?c=R.VSBuffer.concat(o.buffer):c=o}else c=(0,d.peekReadable)(n,o=>R.VSBuffer.concat(o),3);else c=n;!(0,v.hasOpenReadWriteCloseCapability)(t)||(0,v.hasReadWriteCapability)(t)&&c instanceof R.VSBuffer?await this.bb(t,f,s,c):await this.X(t,f,s,c instanceof R.VSBuffer?(0,R.bufferToReadable)(c):c),this.m.fire(new v.FileOperationEvent(f,4))}catch(r){throw new v.FileOperationError((0,g.localize)(4,null,this.mb(f),(0,v.ensureFileSystemProviderError)(r).toString()),(0,v.toFileOperationResult)(r),s)}return this.resolve(f,{resolveMetadata:!0})}async s(f,n,s){if(!!s?.unlock&&!(f.capabilities&8192))throw new Error((0,g.localize)(5,null,this.mb(n)));let a;try{a=await f.stat(n)}catch{return}if((a.type&v.FileType.Directory)!==0)throw new v.FileOperationError((0,g.localize)(6,null,this.mb(n)),0,s);if(this.lb(n,a),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==v.ETAG_DISABLED&&typeof a.mtime=="number"&&typeof a.size=="number"&&s.mtime<a.mtime&&s.etag!==(0,v.etag)({mtime:s.mtime,size:a.size}))throw new v.FileOperationError((0,g.localize)(7,null),3,s);return a}async readFile(f,n,s){const t=await this.k(f);return n?.atomic?this.t(t,f,n,s):this.u(t,f,n,s)}async t(f,n,s,t){return new Promise((a,r)=>{this.W.queueFor(n,this.M(f).providerExtUri).queue(async()=>{try{const c=await this.u(f,n,s,t);a(c)}catch(c){r(c)}})})}async u(f,n,s,t){const a=await this.v(f,n,{...s,preferUnbuffered:!0},t);return{...a,value:await(0,R.streamToBuffer)(a.value)}}async readFileStream(f,n,s){const t=await this.k(f);return this.v(t,f,n,s)}async v(f,n,s,t){const a=new A.CancellationTokenSource(t),r=this.D(n,s).then(o=>o,o=>{throw a.cancel(),o});let c;try{return typeof s?.etag=="string"&&s.etag!==v.ETAG_DISABLED&&await r,s?.atomic&&(0,v.hasFileAtomicReadCapability)(f)||!((0,v.hasOpenReadWriteCloseCapability)(f)||(0,v.hasFileReadStreamCapability)(f))||(0,v.hasReadWriteCapability)(f)&&s?.preferUnbuffered?c=this.C(f,n,s):(0,v.hasFileReadStreamCapability)(f)?c=this.w(f,n,a.token,s):c=this.z(f,n,a.token,s),{...await r,value:c}}catch(o){c&&await(0,d.consumeStream)(c);const p=(0,g.localize)(8,null,this.mb(n),(0,v.ensureFileSystemProviderError)(o).toString());throw o instanceof v.NotModifiedSinceFileOperationError?new v.NotModifiedSinceFileOperationError(p,o.stat,s):new v.FileOperationError(p,(0,v.toFileOperationResult)(o),s)}}w(f,n,s,t=Object.create(null)){const a=f.readFileStream(n,t,s);return(0,d.transform)(a,{data:r=>r instanceof R.VSBuffer?r:R.VSBuffer.wrap(r),error:r=>new v.FileOperationError((0,g.localize)(9,null,this.mb(n),(0,v.ensureFileSystemProviderError)(r).toString()),(0,v.toFileOperationResult)(r),t)},r=>R.VSBuffer.concat(r))}z(f,n,s,t=Object.create(null)){const a=(0,R.newWriteableBufferStream)();return(0,l.readFileIntoStream)(f,n,a,r=>r,{...t,bufferSize:this.a,errorTransformer:r=>new v.FileOperationError((0,g.localize)(10,null,this.mb(n),(0,v.ensureFileSystemProviderError)(r).toString()),(0,v.toFileOperationResult)(r),t)},s),a}C(f,n,s){const t=(0,d.newWriteableStream)(a=>R.VSBuffer.concat(a));return(async()=>{try{let a;s?.atomic&&(0,v.hasFileAtomicReadCapability)(f)?a=await f.readFile(n,{atomic:!0}):a=await f.readFile(n),typeof s?.position=="number"&&(a=a.slice(s.position)),typeof s?.length=="number"&&(a=a.slice(0,s.length)),this.F(n,a.byteLength,s),t.end(R.VSBuffer.wrap(a))}catch(a){t.error(a),t.end()}})(),t}async D(f,n){const s=await this.resolve(f,{resolveMetadata:!0});if(s.isDirectory)throw new v.FileOperationError((0,g.localize)(11,null,this.mb(f)),0,n);if(typeof n?.etag=="string"&&n.etag!==v.ETAG_DISABLED&&n.etag===s.etag)throw new v.NotModifiedSinceFileOperationError((0,g.localize)(12,null),s,n);return this.F(f,s.size,n),s}F(f,n,s){if(s?.limits){let t;if(typeof s.limits.memory=="number"&&n>s.limits.memory&&(t=9),typeof s.limits.size=="number"&&n>s.limits.size&&(t=7),typeof t=="number")throw new v.FileOperationError((0,g.localize)(13,null,this.mb(f)),t)}}async canMove(f,n,s){return this.G(f,n,"move",s)}async canCopy(f,n,s){return this.G(f,n,"copy",s)}async G(f,n,s,t){if(f.toString()!==n.toString())try{const a=s==="move"?this.kb(await this.l(f),f):await this.k(f),r=this.kb(await this.l(n),n);await this.L(a,f,r,n,s,t)}catch(a){return a}return!0}async move(f,n,s){const t=this.kb(await this.l(f),f),a=this.kb(await this.l(n),n),r=await this.H(t,f,a,n,"move",!!s),c=await this.resolve(n,{resolveMetadata:!0});return this.m.fire(new v.FileOperationEvent(f,r==="move"?2:3,c)),c}async copy(f,n,s){const t=await this.k(f),a=this.kb(await this.l(n),n),r=await this.H(t,f,a,n,"copy",!!s),c=await this.resolve(n,{resolveMetadata:!0});return this.m.fire(new v.FileOperationEvent(f,r==="copy"?3:2,c)),c}async H(f,n,s,t,a,r){if(n.toString()===t.toString())return a;const{exists:c,isSameResourceWithDifferentPathCase:o}=await this.L(f,n,s,t,a,r);if(c&&!o&&r&&await this.del(t,{recursive:!0}),await this.O(s,this.M(s).providerExtUri.dirname(t)),a==="copy"){if(f===s&&(0,v.hasFileFolderCopyCapability)(f))await f.copy(n,t,{overwrite:r});else{const p=await this.resolve(n);p.isDirectory?await this.J(f,p,s,t):await this.I(f,n,s,t)}return a}else return f===s?(await f.rename(n,t,{overwrite:r}),a):(await this.H(f,n,s,t,"copy",r),await this.del(n,{recursive:!0}),"copy")}async I(f,n,s,t){if((0,v.hasOpenReadWriteCloseCapability)(f)&&(0,v.hasOpenReadWriteCloseCapability)(s))return this.db(f,n,s,t);if((0,v.hasOpenReadWriteCloseCapability)(f)&&(0,v.hasReadWriteCapability)(s))return this.jb(f,n,s,t);if((0,v.hasReadWriteCapability)(f)&&(0,v.hasOpenReadWriteCloseCapability)(s))return this.hb(f,n,s,t);if((0,v.hasReadWriteCapability)(f)&&(0,v.hasReadWriteCapability)(s))return this.fb(f,n,s,t)}async J(f,n,s,t){await s.mkdir(t),Array.isArray(n.children)&&await i.Promises.settled(n.children.map(async a=>{const r=this.M(s).providerExtUri.joinPath(t,a.name);return a.isDirectory?this.J(f,await this.resolve(a.resource),s,r):this.I(f,a.resource,s,r)}))}async L(f,n,s,t,a,r){let c=!1;if(f===s){const{providerExtUri:p,isPathCaseSensitive:E}=this.M(f);if(E||(c=p.isEqual(n,t)),c&&a==="copy")throw new Error((0,g.localize)(14,null,this.mb(n),this.mb(t)));if(!c&&p.isEqualOrParent(t,n))throw new Error((0,g.localize)(15,null,this.mb(n),this.mb(t)))}const o=await this.exists(t);if(o&&!c){if(!r)throw new v.FileOperationError((0,g.localize)(16,null,this.mb(n),this.mb(t)),4);if(f===s){const{providerExtUri:p}=this.M(f);if(p.isEqualOrParent(n,t))throw new Error((0,g.localize)(17,null,this.mb(n),this.mb(t)))}}return{exists:o,isSameResourceWithDifferentPathCase:c}}M(f){const n=this.N(f);return{providerExtUri:n?y.extUri:y.extUriIgnorePathCase,isPathCaseSensitive:n}}N(f){return!!(f.capabilities&1024)}async createFolder(f){const n=this.kb(await this.j(f),f);await this.O(n,f);const s=await this.resolve(f,{resolveMetadata:!0});return this.m.fire(new v.FileOperationEvent(f,0,s)),s}async O(f,n){const s=[],{providerExtUri:t}=this.M(f);for(;!t.isEqual(n,t.dirname(n));)try{if(((await f.stat(n)).type&v.FileType.Directory)===0)throw new Error((0,g.localize)(18,null,this.mb(n)));break}catch(a){if((0,v.toFileSystemProviderErrorCode)(a)!==v.FileSystemProviderErrorCode.FileNotFound)throw a;s.push(t.basename(n)),n=t.dirname(n)}for(let a=s.length-1;a>=0;a--){n=t.joinPath(n,s[a]);try{await f.mkdir(n)}catch(r){if((0,v.toFileSystemProviderErrorCode)(r)!==v.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(f,n){try{await this.P(f,n)}catch(s){return s}return!0}async P(f,n){const s=this.kb(await this.j(f),f);if(!!n?.useTrash&&!(s.capabilities&4096))throw new Error((0,g.localize)(19,null,this.mb(f)));let a;try{a=await s.stat(f)}catch{}if(a)this.lb(f,a);else throw new v.FileOperationError((0,g.localize)(20,null,this.mb(f)),1);if(!!!n?.recursive){const c=await this.resolve(f);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,g.localize)(21,null,this.mb(f)))}return s}async del(f,n){const s=await this.P(f,n),t=!!n?.useTrash,a=!!n?.recursive;await s.delete(f,{recursive:a,useTrash:t}),this.m.fire(new v.FileOperationEvent(f,1))}async cloneFile(f,n){const s=await this.j(f),t=this.kb(await this.l(n),n);if(s===t&&this.M(s).providerExtUri.isEqual(f,n))return;if(s===t&&(0,v.hasFileCloneCapability)(s))return s.cloneFile(f,n);await this.O(t,this.M(t).providerExtUri.dirname(n));const a=this.W.queueFor(f,this.M(s).providerExtUri);return s===t&&(0,v.hasFileFolderCopyCapability)(s)?a.queue(()=>s.copy(f,n,{overwrite:!0})):a.queue(()=>this.I(s,f,t,n))}watch(f,n={recursive:!1,excludes:[]}){const s=new S.DisposableStore;let t=!1,a=()=>{t=!0};return s.add((0,S.toDisposable)(()=>a())),(async()=>{try{const r=await this.U(f,n);t?(0,S.dispose)(r):a=()=>(0,S.dispose)(r)}catch(r){this.b.error(r)}})(),s}async U(f,n){const s=await this.j(f),t=(0,P.hash)([this.M(s).providerExtUri.getComparisonKey(f),n]);let a=this.S.get(t);return a||(a={count:0,disposable:s.watch(f,n)},this.S.set(t,a)),a.count+=1,(0,S.toDisposable)(()=>{a&&(a.count--,a.count===0&&((0,S.dispose)(a.disposable),this.S.delete(t)))})}dispose(){super.dispose();for(const[,f]of this.S)(0,S.dispose)(f.disposable);this.S.clear()}async X(f,n,s,t){return this.W.queueFor(n,this.M(f).providerExtUri).queue(async()=>{const a=await f.open(n,{create:!0,unlock:s?.unlock??!1});try{(0,d.isReadableStream)(t)||(0,d.isReadableBufferedStream)(t)?await this.Y(f,a,t):await this.Z(f,a,t)}catch(r){throw(0,v.ensureFileSystemProviderError)(r)}finally{await f.close(a)}})}async Y(f,n,s){let t=0,a;if((0,d.isReadableBufferedStream)(s)){if(s.buffer.length>0){const r=R.VSBuffer.concat(s.buffer);await this.ab(f,n,r,r.byteLength,t,0),t+=r.byteLength}if(s.ended)return;a=s.stream}else a=s;return new Promise((r,c)=>{(0,d.listenStream)(a,{onData:async o=>{a.pause();try{await this.ab(f,n,o,o.byteLength,t,0)}catch(p){return c(p)}t+=o.byteLength,setTimeout(()=>a.resume())},onError:o=>c(o),onEnd:()=>r()})})}async Z(f,n,s){let t=0,a;for(;(a=s.read())!==null;)await this.ab(f,n,a,a.byteLength,t,0),t+=a.byteLength}async ab(f,n,s,t,a,r){let c=0;for(;c<t;)c+=await f.write(n,a+c,s.buffer,r+c,t-c)}async bb(f,n,s,t){return this.W.queueFor(n,this.M(f).providerExtUri).queue(()=>this.cb(f,n,s,t))}async cb(f,n,s,t){let a;t instanceof R.VSBuffer?a=t:(0,d.isReadableStream)(t)?a=await(0,R.streamToBuffer)(t):(0,d.isReadableBufferedStream)(t)?a=await(0,R.bufferedStreamToBuffer)(t):a=(0,R.readableToBuffer)(t),await f.writeFile(n,a.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1})}async db(f,n,s,t){return this.W.queueFor(t,this.M(s).providerExtUri).queue(()=>this.eb(f,n,s,t))}async eb(f,n,s,t){let a,r;try{a=await f.open(n,{create:!1}),r=await s.open(t,{create:!0,unlock:!1});const c=R.VSBuffer.alloc(this.a);let o=0,p=0,E=0;do E=await f.read(a,o,c.buffer,p,c.byteLength-p),await this.ab(s,r,c,E,o,p),o+=E,p+=E,p===c.byteLength&&(p=0);while(E>0)}catch(c){throw(0,v.ensureFileSystemProviderError)(c)}finally{await i.Promises.settled([typeof a=="number"?f.close(a):Promise.resolve(),typeof r=="number"?s.close(r):Promise.resolve()])}}async fb(f,n,s,t){return this.W.queueFor(t,this.M(s).providerExtUri).queue(()=>this.gb(f,n,s,t))}async gb(f,n,s,t){return s.writeFile(t,await f.readFile(n),{create:!0,overwrite:!0,unlock:!1})}async hb(f,n,s,t){return this.W.queueFor(t,this.M(s).providerExtUri).queue(()=>this.ib(f,n,s,t))}async ib(f,n,s,t){const a=await s.open(t,{create:!0,unlock:!1});try{const r=await f.readFile(n);await this.ab(s,a,R.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,v.ensureFileSystemProviderError)(r)}finally{await s.close(a)}}async jb(f,n,s,t){const a=await(0,R.streamToBuffer)(this.z(f,n,A.CancellationToken.None));await this.bb(s,t,void 0,a)}kb(f,n){if(f.capabilities&2048)throw new v.FileOperationError((0,g.localize)(22,null,this.mb(n)),6);return f}lb(f,n){if((n.permissions??0)&v.FilePermission.Readonly)throw new v.FileOperationError((0,g.localize)(23,null,this.mb(f)),6)}mb(f){return f.scheme===b.Schemas.file?f.fsPath:f.toString(!0)}};u=ye([K(0,m.ILogService)],u),e.FileService=u}),define(re[207],ae([0,1,52,286,6,37,17,3,47,2,12,5,21,44,28,165,13,100,204,38,199,198]),function(_,e,D,i,R,A,L,P,I,S,C,b,w,y,d,g,v,l,m,u,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,i.gracefulify)(D)}catch(s){console.error(`Error enabling graceful-fs: ${(0,u.toErrorMessage)(s)}`)}})();class n extends m.AbstractDiskFileSystemProvider{constructor(t,a){super(t,a),this.onDidChangeCapabilities=P.Event.None,this.H=new A.ResourceMap(r=>w.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,b.isLinux&&(this.F|=1024)),this.F}async stat(t){try{const{stat:a,symbolicLink:r}=await d.SymlinkSupport.stat(this.C(t));return{type:this.G(a,r),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.Y(a)}}async readdir(t){try{const a=await d.Promises.readdir(this.C(t),{withFileTypes:!0}),r=[];return await Promise.all(a.map(async c=>{try{let o;c.isSymbolicLink()?o=(await this.stat((0,w.joinPath)(t,c.name))).type:o=this.G(c),r.push([c.name,o])}catch(o){this.a.trace(o)}})),r}catch(a){throw this.Y(a)}}G(t,a){let r;return a?.dangling?r=v.FileType.Unknown:t.isFile()?r=v.FileType.File:t.isDirectory()?r=v.FileType.Directory:r=v.FileType.Unknown,a&&(r|=v.FileType.SymbolicLink),r}async I(t){const a=this.C(t);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${a})`);let r;for(;r=this.H.get(t);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${a})`),await r.wait();const c=new R.Barrier;return this.H.set(t,c),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${a})`),(0,S.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${a})`),this.H.get(t)===c&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${a})`),this.H.delete(t)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${a})`),c.open()})}async readFile(t,a){let r;try{a?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(t)})`),r=await this.I(t));const c=this.C(t);return await d.Promises.readFile(c)}catch(c){throw this.Y(c)}finally{r?.dispose()}}J(t){n.D&&this.a.trace(t)}readFileStream(t,a,r){const c=(0,y.newWriteableStream)(o=>L.VSBuffer.concat(o.map(p=>L.VSBuffer.wrap(p))).buffer);return(0,l.readFileIntoStream)(this,t,c,o=>o.buffer,{...a,bufferSize:256*1024},r),c}async writeFile(t,a,r){let c;try{const o=this.C(t);if(!r.create||!r.overwrite){if(await d.Promises.exists(o)){if(!r.overwrite)throw(0,v.createFileSystemProviderError)((0,g.localize)(0,null),v.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,v.createFileSystemProviderError)((0,g.localize)(1,null),v.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(t,{create:!0,unlock:r.unlock}),await this.write(c,0,a,0,a.byteLength)}catch(o){throw await this.Z(t,o)}finally{typeof c=="number"&&await this.close(c)}}static configureFlushOnWrite(t){n.O=t}async open(t,a){const r=this.C(t);let c;(0,v.isFileOpenForWriteOptions)(a)&&(c=await this.I(t));let o;try{if((0,v.isFileOpenForWriteOptions)(a)&&a.unlock)try{const{stat:E}=await d.SymlinkSupport.stat(r);E.mode&128||await d.Promises.chmod(r,E.mode|128)}catch(E){this.a.trace(E)}let p;if((0,v.isFileOpenForWriteOptions)(a)){if(b.isWindows)try{await d.Promises.truncate(r,0),p="r+"}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}p||(p="w")}else p="r";o=await d.Promises.open(r,p)}catch(p){throw c?.dispose(),(0,v.isFileOpenForWriteOptions)(a)?await this.Z(t,p):this.Y(p)}if(this.L.set(o,0),(0,v.isFileOpenForWriteOptions)(a)&&this.N.set(o,t),c){const p=this.M.get(o);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${o} (${r})`),this.M.set(o,c),p&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${o} (${r})`),p.dispose())}return o}async close(t){const a=this.M.get(t);try{if(this.L.delete(t),this.N.delete(t)&&n.O)try{await d.Promises.fdatasync(t)}catch(r){n.configureFlushOnWrite(!1),this.a.error(r)}return await d.Promises.close(t)}catch(r){throw this.Y(r)}finally{a&&(this.M.get(t)===a&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.M.delete(t)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),a.dispose())}}async read(t,a,r,c,o){const p=this.P(t,a);let E=null;try{E=(await d.Promises.read(t,r,c,o,p)).bytesRead}catch(k){throw this.Y(k)}finally{this.Q(t,p,E)}return E}P(t,a){return a===this.L.get(t)?null:a}Q(t,a,r){const c=this.L.get(t);typeof c=="number"&&(typeof a=="number"||(typeof r=="number"?this.L.set(t,c+r):this.L.delete(t)))}async write(t,a,r,c,o){return(0,R.retry)(()=>this.R(t,a,r,c,o),100,3)}async R(t,a,r,c,o){const p=this.P(t,a);let E=null;try{E=(await d.Promises.write(t,r,c,o,p)).bytesWritten}catch(k){throw await this.Z(this.N.get(t),k)}finally{this.Q(t,p,E)}return E}async mkdir(t){try{await d.Promises.mkdir(this.C(t))}catch(a){throw this.Y(a)}}async delete(t,a){try{const r=this.C(t);a.recursive?await d.Promises.rm(r,d.RimRafMode.MOVE):await d.Promises.unlink(r)}catch(r){throw this.Y(r)}}async rename(t,a,r){const c=this.C(t),o=this.C(a);if(c!==o)try{await this.S(t,a,"move",r.overwrite),await d.Promises.move(c,o)}catch(p){throw(p.code==="EINVAL"||p.code==="EBUSY"||p.code==="ENAMETOOLONG")&&(p=new Error((0,g.localize)(2,null,(0,C.basename)(c),(0,C.basename)((0,C.dirname)(o)),p.toString()))),this.Y(p)}}async copy(t,a,r){const c=this.C(t),o=this.C(a);if(c!==o)try{await this.S(t,a,"copy",r.overwrite),await d.Promises.copy(c,o,{preserveSymlinks:!0})}catch(p){throw(p.code==="EINVAL"||p.code==="EBUSY"||p.code==="ENAMETOOLONG")&&(p=new Error((0,g.localize)(3,null,(0,C.basename)(c),(0,C.basename)((0,C.dirname)(o)),p.toString()))),this.Y(p)}}async S(t,a,r,c){const o=this.C(t),p=this.C(a);let E=!1;if(!!(this.capabilities&1024)||(E=(0,I.isEqual)(o,p,!0)),E&&r==="copy")throw(0,v.createFileSystemProviderError)((0,g.localize)(4,null),v.FileSystemProviderErrorCode.FileExists);if(!E&&await d.Promises.exists(p)){if(!c)throw(0,v.createFileSystemProviderError)((0,g.localize)(5,null),v.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}async cloneFile(t,a){return this.U(t,a,!1)}async U(t,a,r){const c=this.C(t),o=this.C(a),p=!!(this.capabilities&1024);if((0,I.isEqual)(c,o,!p))return;const E=new S.DisposableStore;try{const[k,F]=await Promise.all([this.I(t),this.I(a)]);E.add(k),E.add(F),r&&await d.Promises.mkdir((0,C.dirname)(o),{recursive:!0}),await d.Promises.copyFile(c,o)}catch(k){if(k.code==="ENOENT"&&!r)return this.U(t,a,!0);throw this.Y(k)}finally{E.dispose()}}p(t,a,r){return new h.UniversalWatcherClient(c=>t(c),c=>a(c),r)}y(t,a,r){return new f.NodeJSWatcherClient(c=>t(c),c=>a(c),r)}Y(t){if(t instanceof v.FileSystemProviderError)return t;let a;switch(t.code){case"ENOENT":a=v.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=v.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=v.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=v.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=v.FileSystemProviderErrorCode.NoPermissions;break;default:a=v.FileSystemProviderErrorCode.Unknown}return(0,v.createFileSystemProviderError)(t,a)}async Z(t,a){let r=this.Y(a);if(t&&r.code===v.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await d.SymlinkSupport.stat(this.C(t));c.mode&128||(r=(0,v.createFileSystemProviderError)(a,v.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.a.trace(c)}return r}}e.DiskFileSystemProvider=n,n.D=!1,n.O=!0}),define(re[101],ae([0,1,6,3,2,4,8]),function(_,e,D,i,R,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessLifecycleService=e.ISharedProcessLifecycleService=void 0,e.ISharedProcessLifecycleService=(0,A.createDecorator)("lifecycleSharedProcessService");let P=class extends R.Disposable{constructor(S){super(),this.c=S,this.a=void 0,this.b=this.B(new i.Emitter),this.onWillShutdown=this.b.event}fireOnWillShutdown(){if(this.a)return this.a;this.c.trace("Lifecycle#onWillShutdown.fire()");const S=[];return this.b.fire({join(C){S.push(C)}}),this.a=(async()=>{try{await D.Promises.settled(S)}catch(C){this.c.error(C)}})(),this.a}};P=ye([K(0,L.ILogService)],P),e.SharedProcessLifecycleService=P}),define(re[102],ae([0,1,3,7,8]),function(_,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class A{constructor(w,y){this.a=w,this.b=y,this.onDidChangeLogLevel=D.Event.buffer(w.onDidChangeLogLevel,!0)}listen(w,y){switch(y){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${y}`)}async call(w,y,d){switch(y){case"setLevel":return d[1]?this.b.setLevel(i.URI.revive(d[1]),d[0]):this.a.setLevel(d[0])}throw new Error(`Call not found: ${y}`)}}e.LogLevelChannel=A;class L{constructor(w){this.a=w}get onDidChangeLogLevel(){return this.a.listen("onDidChangeLogLevel")}setLevel(w,y){L.setLevel(this.a,w,y)}static setLevel(w,y,d){return w.call("setLevel",[y,d])}}e.LogLevelChannelClient=L;class P{constructor(w){this.b=w,this.a=new Map}listen(w,y){throw new Error(`Event not found: ${y}`)}async call(w,y,d){switch(y){case"createLogger":this.c(i.URI.revive(d[0]),d[1]);return;case"log":return this.e(i.URI.revive(d[0]),d[1]);case"consoleLog":return this.d(d[0],d[1])}throw new Error(`Call not found: ${y}`)}c(w,y){this.a.set(w.toString(),this.b.createLogger(w,y))}d(w,y){let d=console.log;switch(w){case R.LogLevel.Error:d=console.error;break;case R.LogLevel.Warning:d=console.warn;break;case R.LogLevel.Info:d=console.info;break}d.call(console,...y)}e(w,y){const d=this.a.get(w.toString());if(!d)throw new Error("Create the logger before logging");for(const[g,v]of y)(0,R.log)(d,g,v)}}e.LoggerChannel=P;class I extends R.AbstractLoggerService{constructor(w,y,d){super(w,y),this.g=d}createConsoleMainLogger(){return new R.AdapterLogger({log:(w,y)=>{this.g.call("consoleLog",[w,y])}})}f(w,y,d){return new S(this.g,w,y,d)}}e.LoggerChannelClient=I;class S extends R.AbstractMessageLogger{constructor(w,y,d,g){super(g?.always),this.m=w,this.n=y,this.k=!1,this.l=[],this.setLevel(d),this.m.call("createLogger",[y,g]).then(()=>{this.r(this.l),this.k=!0})}g(w,y){const d=[[w,y]];this.k?this.r(d):this.l.push(...d)}r(w){this.m.call("log",[this.n,w])}}class C extends R.LogService{constructor(w,y){super(y),this.c=w,this.B(w.onDidChangeLogLevel(d=>y.setLevel(d)))}setLevel(w){super.setLevel(w),this.c.setLevel(w)}}e.FollowerLogService=C}),define(re[57],ae([0,1,4]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,D.createDecorator)("nativeHostService")}),define(re[58],ae([0,1,3,64,2,4]),function(_,e,D,i,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,A.createDecorator)("policy");class L extends R.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new D.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(S){const C=Object.keys(this.f).length;return this.f={...S,...this.f},C!==Object.keys(this.f).length&&await this.i(S),i.Iterable.reduce(this.g.entries(),(b,[w,y])=>({...b,[w]:y}),{})}getPolicyValue(S){return this.g.get(S)}serialize(){return i.Iterable.reduce(Object.entries(this.f),(S,[C,b])=>({...S,[C]:{definition:b,value:this.g.get(C)}}),{})}}e.AbstractPolicyService=L;class P{constructor(){this.onDidChange=D.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=P}),define(re[208],ae([0,1,3,2,58]),function(_,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class A{constructor(I){this.b=I,this.a=new i.DisposableStore}listen(I,S){switch(S){case"onDidChange":return D.Event.map(this.b.onDidChange,C=>C.reduce((b,w)=>({...b,[w]:this.b.getPolicyValue(w)??null}),{}),this.a)}throw new Error(`Event not found: ${S}`)}call(I,S,C){switch(S){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(C)}throw new Error(`Call not found: ${S}`)}dispose(){this.a.dispose()}}e.PolicyChannel=A;class L extends R.AbstractPolicyService{constructor(I,S){super(),this.a=S;for(const C in I){const{definition:b,value:w}=I[C];this.f[C]=b,w!==void 0&&this.g.set(C,w)}this.a.listen("onDidChange")(C=>{for(const b in C){const w=C[b];w===null?this.g.delete(b):this.g.set(b,w)}this.h.fire(Object.keys(C))})}async i(I){const S=await this.a.call("updatePolicyDefinitions",I);for(const C in S)this.g.set(C,S[C])}}e.PolicyChannelClient=L}),define(re[103],ae([0,1,5,36]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let R;if(typeof D.globals.vscode<"u"&&typeof D.globals.vscode.context<"u"){const A=D.globals.vscode.context.configuration();if(A)R=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(R=globalThis._VSCODE_PRODUCT_JSON,i.env.VSCODE_DEV&&Object.assign(R,{nameShort:`${R.nameShort} Dev`,nameLong:`${R.nameLong} Dev`,dataFolderName:`${R.dataFolderName}-dev`,serverDataFolderName:R.serverDataFolderName?`${R.serverDataFolderName}-dev`:void 0}),!R.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(R,{version:A.version})}}else R={},Object.keys(R).length===0&&Object.assign(R,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=R}),define(re[25],ae([0,1,4]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,D.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(re[209],ae([0,1,6,9,2,12,28,8,25]),function(_,e,D,i,R,A,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let S=class extends R.Disposable{constructor(b,w,y){super(),this.b=w,this.c=y,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,b&&this.B(new D.RunOnceScheduler(()=>{this.f(b)},3e4)).schedule()}async f(b){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const w=Date.now(),y=(0,A.dirname)(b),d=(0,A.basename)(b),g=await L.Promises.readdir(y);await Promise.all(g.map(async v=>{if(v===d)return;const l=(0,A.join)(y,v),m=await L.Promises.stat(l);if(m.isDirectory()&&w-m.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${v}.`),L.Promises.rm(l)}))}catch(w){(0,i.onUnexpectedError)(w)}}};S=ye([K(1,I.IProductService),K(2,P.ILogService)],S),e.CodeCacheCleaner=S}),define(re[210],ae([0,1,6,9,2,12,28,14,8,25]),function(_,e,D,i,R,A,L,P,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let C=class extends R.Disposable{constructor(w,y,d){super(),this.b=w,this.c=y,this.f=d,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new D.RunOnceScheduler(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const w=Object.create(null),y=JSON.parse(await L.Promises.readFile((0,A.join)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const m of Object.keys(y)){const u=y[m];w[`${u.hash}.${m}`]=!0}const d=(0,A.join)(this.b.userDataPath,"clp");if(!await L.Promises.exists(d))return;const v=await L.Promises.readdir(d);for(const m of v){if(w[m]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${m}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${m}`),await L.Promises.rm((0,A.join)(d,m))}const l=Date.now();for(const m of Object.keys(w)){const u=(0,A.join)(d,m),h=await L.Promises.readdir(u);for(const f of h){if(f==="tcf.json")continue;const n=(0,A.join)(u,f),s=await L.Promises.stat(n);s.isDirectory()&&l-s.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,A.join)(m,f)}`),await L.Promises.rm(n))}}}catch(w){(0,i.onUnexpectedError)(w)}}};C=ye([K(0,P.INativeEnvironmentService),K(1,I.ILogService),K(2,S.IProductService)],C),e.LanguagePackCachedDataCleaner=C}),define(re[211],ae([0,1,20,2,21,186,13,25]),function(_,e,D,i,R,A,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let I=class extends i.Disposable{constructor(C,b){super(),this.b=C,this.c=b,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,w])=>this.a.set(w.configPath,w))}getConfigBasedTips(C){return this.f(C)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(C){const b=[];for(const[w,y]of this.a)if(!(y.configScheme&&y.configScheme!==C.scheme))try{const d=await this.b.readFile((0,R.joinPath)(C,w)),g=new Map;Object.entries(y.recommendations).forEach(([l,m])=>{if((0,D.isNonEmptyArray)(m.remotes))for(const u of m.remotes)g.set(u,{extensionId:l,extensionName:m.name,configName:y.configName,important:!!m.important,isExtensionPack:!!m.isExtensionPack,whenNotInstalled:m.whenNotInstalled});else b.push({extensionId:l,extensionName:m.name,configName:y.configName,important:!!m.important,isExtensionPack:!!m.isExtensionPack,whenNotInstalled:m.whenNotInstalled})});const v=(0,A.getDomainsOfRemotes)(d.value.toString(),[...g.keys()]);for(const l of v){const m=g.get(l);m&&b.push(m)}}catch{}return b}};I=ye([K(0,L.IFileService),K(1,P.IProductService)],I),e.ExtensionTipsService=I}),define(re[212],ae([0,1,12,4]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,i.createDecorator)("IV8InspectProfilingService");var R;(function(A){function L(I){return Boolean(I.samples&&I.timeDeltas)}A.isValidProfile=L;function P(I,S="noAbsolutePaths"){for(const C of I.nodes)C.callFrame&&C.callFrame.url&&((0,D.isAbsolute)(C.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(C.callFrame.url))&&(C.callFrame.url=(0,D.join)(S,(0,D.basename)(C.callFrame.url)));return I}A.rewriteAbsolutePaths=P})(R=e.Utils||(e.Utils={}))}),define(re[213],ae([0,1,31]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class i{constructor(){this.a=new Map}async startProfiling(A){const P=await(await new Promise((S,C)=>{_(["v8-inspect-profiler"],S,C)})).startProfiling({port:A.port,checkForPaused:!0}),I=(0,D.generateUuid)();return this.a.set(I,P),I}async stopProfiling(A){const L=this.a.get(A);if(!L)throw new Error(`UNKNOWN session '${A}'`);const P=await L.stop();return this.a.delete(A),P.profile}}e.InspectProfilingService=i}),define(re[40],ae([0,1,126,15]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class R{constructor(){this.a=new Map}add(L,P){D.ok(i.isString(L)),D.ok(i.isObject(P)),D.ok(!this.a.has(L),"There is already an extension with this id"),this.a.set(L,P)}knows(L){return this.a.has(L)}as(L){return this.a.get(L)||null}}e.Registry=new R}),define(re[104],ae([0,1,3,40]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function R(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class A{constructor(){this.b=new D.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(I,S){this.a[R(I)]=S,this.b.fire(I)}notifySchemaChanged(I){this.b.fire(I)}getSchemaContributions(){return{schemas:this.a}}}const L=new A;i.Registry.add(e.Extensions.JSONContribution,L)}),define(re[46],ae([0,1,20,3,15,151,16,104,40]),function(_,e,D,i,R,A,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(f){f.Multiline="multilineText",f.Singleline="singlelineText"})(S=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var C;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.MACHINE=2]="MACHINE",f[f.WINDOW=3]="WINDOW",f[f.RESOURCE=4]="RESOURCE",f[f.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",f[f.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const b=I.Registry.as(P.Extensions.JSONContribution);class w{constructor(){this.h=new Set,this.i=new i.Emitter,this.onDidSchemaChange=this.i.event,this.j=new i.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},b.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.r()}registerConfiguration(n,s=!0){this.registerConfigurations([n],s)}registerConfigurations(n,s=!0){const t=this.k(n,s);b.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(n){const s=this.l(n);b.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:n,remove:s}){const t=[];t.push(...this.l(s)),t.push(...this.k(n,!1)),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:(0,D.distinct)(t)})}registerDefaultConfigurations(n){const s=[],t=[];for(const{overrides:a,source:r}of n)for(const c in a)if(s.push(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const o=this.a.get(c),p=o?.valuesSources??new Map;if(r)for(const N of Object.keys(a[c]))p.set(N,r);const E={...o?.value||{},...a[c]};this.a.set(c,{source:r,value:E,valuesSources:p});const k=(0,L.getLanguageTagSettingPlainKey)(c),F={type:"object",default:E,description:A.localize(1,null,k),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:E,source:R.isString(r)?void 0:r,defaultValueSource:r};t.push(...g(c)),this.d[c]=F,this.b.properties[c]=F}else{this.a.set(c,{value:a[c],source:r});const o=this.d[c];o&&(this.s(c,o),this.o(c,o))}this.registerOverrideIdentifiers(t),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}deregisterDefaultConfigurations(n){const s=[];for(const{overrides:t,source:a}of n)for(const r in t){const c=this.a.get(r),o=R.isString(a)?a:a?.id,p=R.isString(c?.source)?c?.source:c?.source?.id;if(o===p)if(s.push(r),this.a.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.d[r],delete this.b.properties[r];else{const E=this.d[r];E&&(this.s(r,E),this.o(r,E))}}this.q(),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){for(const s of n)this.h.add(s);this.q()}k(n,s){const t=[];return n.forEach(a=>{t.push(...this.m(a,s,a.extensionInfo,a.restrictedProperties)),this.c.push(a),this.n(a)}),t}l(n){const s=[],t=a=>{if(a.properties)for(const r in a.properties){s.push(r);const c=this.d[r];c?.policy?.name&&this.e.delete(c.policy.name),delete this.d[r],this.p(r,a.properties[r])}a.allOf?.forEach(r=>t(r))};for(const a of n){t(a);const r=this.c.indexOf(a);r!==-1&&this.c.splice(r,1)}return s}m(n,s=!0,t,a,r=3){r=R.isUndefinedOrNull(n.scope)?r:n.scope;const c=[],o=n.properties;if(o)for(const E in o){const k=o[E];if(s&&u(E,k)){delete o[E];continue}if(k.source=t,k.defaultDefaultValue=o[E].default,this.s(E,k),e.OVERRIDE_PROPERTY_REGEX.test(E)?k.scope=void 0:(k.scope=R.isUndefinedOrNull(k.scope)?r:k.scope,k.restricted=R.isUndefinedOrNull(k.restricted)?!!a?.includes(E):k.restricted),o[E].hasOwnProperty("included")&&!o[E].included){this.f[E]=o[E],delete o[E];continue}else this.d[E]=o[E],o[E].policy?.name&&this.e.set(o[E].policy.name,E);!o[E].deprecationMessage&&o[E].markdownDeprecationMessage&&(o[E].deprecationMessage=o[E].markdownDeprecationMessage),c.push(E)}const p=n.allOf;if(p)for(const E of p)c.push(...this.m(E,s,t,a,r));return c}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}n(n){const s=t=>{const a=t.properties;if(a)for(const c in a)this.o(c,a[c]);t.allOf?.forEach(s)};s(n)}o(n,s){switch(e.allSettings.properties[n]=s,s.scope){case 1:e.applicationSettings.properties[n]=s;break;case 2:e.machineSettings.properties[n]=s;break;case 6:e.machineOverridableSettings.properties[n]=s;break;case 3:e.windowSettings.properties[n]=s;break;case 4:e.resourceSettings.properties[n]=s;break;case 5:e.resourceSettings.properties[n]=s,this.g.properties[n]=s;break}}p(n,s){switch(delete e.allSettings.properties[n],s.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.g.properties[n];break}}q(){for(const n of this.h.values()){const s=`[${n}]`,t={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.s(s,t),e.allSettings.properties[s]=t,e.applicationSettings.properties[s]=t,e.machineSettings.properties[s]=t,e.machineOverridableSettings.properties[s]=t,e.windowSettings.properties[s]=t,e.resourceSettings.properties[s]=t}this.i.fire()}r(){const n={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this.i.fire()}s(n,s){const t=this.a.get(n);let a=t?.value,r=t?.source;R.isUndefined(a)&&(a=s.defaultDefaultValue,r=void 0),R.isUndefined(a)&&(a=l(s.type)),s.default=a,s.defaultValueSource=r}}const y="\\[([^\\]]+)\\]",d=new RegExp(y,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${y})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function g(f){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(f)){let s=d.exec(f);for(;s?.length;){const t=s[1].trim();t&&n.push(t),s=d.exec(f)}}return(0,D.distinct)(n)}e.overrideIdentifiersFromKey=g;function v(f){return f.reduce((n,s)=>`${n}[${s}]`,"")}e.keyFromOverrideIdentifiers=v;function l(f){switch(Array.isArray(f)?f[0]:f){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const m=new w;I.Registry.add(e.Extensions.Configuration,m);function u(f,n){return f.trim()?e.OVERRIDE_PROPERTY_REGEX.test(f)?A.localize(7,null,f):m.getConfigurationProperties()[f]!==void 0?A.localize(8,null,f):n.policy?.name&&m.getPolicyConfigurations().get(n.policy?.name)!==void 0?A.localize(9,null,f,n.policy?.name,m.getPolicyConfigurations().get(n.policy?.name)):null:A.localize(6,null)}e.validateProperty=u;function h(){const f=[],n=m.getConfigurationProperties();for(const s of Object.keys(n))f.push([s,n[s].scope]);return f.push(["launch",4]),f.push(["task",4]),f}e.getScopes=h}),define(re[74],ae([0,1,20,3,35,2,37,32,15,7,16,46,40]),function(_,e,D,i,R,A,L,P,I,S,C,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class y{constructor(s={},t=[],a=[],r){this.c=s,this.d=t,this.f=a,this.raw=r,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const s=this.raw.map(t=>{if(t instanceof y)return t;const a=new d("");return a.parseRaw(t),a.configurationModel});this.g=s.reduce((t,a)=>a===t?a:t.merge(a),s[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(s){return s?(0,C.getConfigurationValue)(this.contents,s):this.contents}inspect(s,t){const a=this.rawConfiguration.getValue(s),r=t?this.rawConfiguration.getOverrideValue(s,t):void 0,c=t?this.rawConfiguration.override(t).getValue(s):a;return{value:a,override:r,merged:c}}getOverrideValue(s,t){const a=this.l(t);return a?s?(0,C.getConfigurationValue)(a,s):a:void 0}getKeysForOverrideIdentifier(s){const t=[];for(const a of this.overrides)a.identifiers.includes(s)&&t.push(...a.keys);return D.distinct(t)}getAllOverrideIdentifiers(){const s=[];for(const t of this.overrides)s.push(...t.identifiers);return D.distinct(s)}override(s){let t=this.b.get(s);return t||(t=this.h(s),this.b.set(s,t)),t}merge(...s){const t=P.deepClone(this.contents),a=P.deepClone(this.overrides),r=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const o of s)if(c.push(...o.raw?.length?o.raw:[o]),!o.isEmpty()){this.j(t,o.contents);for(const p of o.overrides){const[E]=a.filter(k=>D.equals(k.identifiers,p.identifiers));E?(this.j(E.contents,p.contents),E.keys.push(...p.keys),E.keys=D.distinct(E.keys)):a.push(P.deepClone(p))}for(const p of o.keys)r.indexOf(p)===-1&&r.push(p)}return new y(t,r,a,c.every(o=>o instanceof y)?void 0:c)}freeze(){return this.a=!0,this}clone(){return new y(P.deepClone(this.contents),[...this.keys],P.deepClone(this.overrides))}h(s){const t=this.l(s);if(!t||typeof t!="object"||!Object.keys(t).length)return this;const a={};for(const r of D.distinct([...Object.keys(this.contents),...Object.keys(t)])){let c=this.contents[r];const o=t[r];o&&(typeof c=="object"&&typeof o=="object"?(c=P.deepClone(c),this.j(c,o)):c=o),a[r]=c}return new y(a,this.keys,this.overrides)}j(s,t){for(const a of Object.keys(t)){if(a in s&&I.isObject(s[a])&&I.isObject(t[a])){this.j(s[a],t[a]);continue}s[a]=P.deepClone(t[a])}}k(s){return this.a&&!Object.isFrozen(s)?P.deepFreeze(s):s}l(s){let t=null,a=null;const r=c=>{c&&(a?this.j(a,c):a=P.deepClone(c))};for(const c of this.overrides)D.equals(c.identifiers,[s])?t=c.contents:c.identifiers.includes(s)&&r(c.contents);return r(t),a}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(s,t){this.m(s),(0,C.addToValueTree)(this.contents,s,t,a=>{throw new Error(a)})}removeValue(s){this.n(s)&&(0,C.removeFromValueTree)(this.contents,s)}m(s){let t=this.keys.length;for(let a=0;a<t;a++)s.indexOf(this.keys[a])===0&&(t=a);this.keys.splice(t,1,s)}n(s){const t=this.keys.indexOf(s);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=y;class d{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new y}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,t){if(!I.isUndefinedOrNull(s)){const a=this.g(s);this.parseRaw(a,t)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,t){this.a=s;const{contents:a,keys:r,overrides:c,restricted:o,hasExcludedProperties:p}=this.h(s,t);this.b=new y(a,r,c,p?[s]:void 0),this.c=o||[]}g(s){let t={},a=null,r=[];const c=[],o=[];function p(k){Array.isArray(r)?r.push(k):a!==null&&(r[a]=k)}const E={onObjectBegin:()=>{const k={};p(k),c.push(r),r=k,a=null},onObjectProperty:k=>{a=k},onObjectEnd:()=>{r=c.pop()},onArrayBegin:()=>{const k=[];p(k),c.push(r),r=k,a=null},onArrayEnd:()=>{r=c.pop()},onLiteralValue:p,onError:(k,F,N)=>{o.push({error:k,offset:F,length:N})}};if(s)try{R.visit(s,E),t=r[0]||{}}catch(k){console.error(`Error while parsing settings file ${this.f}: ${k}`),this.d=[k]}return t}h(s,t){const a=w.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),r=this.j(s,a,!0,t);s=r.raw;const c=(0,C.toValuesTree)(s,E=>console.error(`Conflict in settings file ${this.f}: ${E}`)),o=Object.keys(s),p=this.l(s,E=>console.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:c,keys:o,overrides:p,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}j(s,t,a,r){let c=!1;if(!r?.scopes&&!r?.skipRestricted)return{raw:s,restricted:[],hasExcludedProperties:c};const o={},p=[];for(const E in s)if(b.OVERRIDE_PROPERTY_REGEX.test(E)&&a){const k=this.j(s[E],t,!1,r);o[E]=k.raw,c=c||k.hasExcludedProperties,p.push(...k.restricted)}else{const k=t[E],F=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&p.push(E),(F===void 0||r.scopes===void 0||r.scopes.includes(F))&&!(r.skipRestricted&&k?.restricted)?o[E]=s[E]:c=!0}return{raw:o,restricted:p,hasExcludedProperties:c}}l(s,t){const a=[];for(const r of Object.keys(s))if(b.OVERRIDE_PROPERTY_REGEX.test(r)){const c={};for(const o in s[r])c[o]=s[r][o];a.push({identifiers:(0,b.overrideIdentifiersFromKey)(r),keys:Object.keys(c),contents:(0,C.toValuesTree)(c,t)})}return a}}e.ConfigurationModelParser=d;class g extends A.Disposable{constructor(s,t,a,r){super(),this.f=s,this.g=t,this.h=r,this.c=this.B(new i.Emitter),this.onDidChange=this.c.event,this.a=new d(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(a.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(i.Event.any(i.Event.filter(this.h.onDidFilesChange,c=>c.contains(this.f)),i.Event.filter(this.h.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&a.isEqual(c.resource,s)))(()=>this.c.fire()))}async loadConfiguration(){try{const s=await this.h.readFile(this.f);return this.a.parse(s.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new y}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=g;class v{constructor(s,t,a,r,c,o,p,E,k,F,N,q,j){this.a=s,this.b=t,this.value=a,this.overrideIdentifiers=r,this.c=c,this.d=o,this.f=p,this.g=E,this.h=k,this.j=F,this.k=N,this.l=q,this.m=j}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get z(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.z.merged}get userRemote(){return this.z.value!==void 0||this.z.override!==void 0?{value:this.z.value,override:this.z.override}:void 0}get B(){return this.A===void 0&&(this.A=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.A}get workspaceValue(){return this.B?.merged}get workspace(){return this.B?.value!==void 0||this.B?.override!==void 0?{value:this.B.value,override:this.B.override}:void 0}get E(){return this.D===void 0&&(this.D=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.D}get workspaceFolderValue(){return this.E?.merged}get workspaceFolder(){return this.E?.value!==void 0||this.E?.override!==void 0?{value:this.E.value,override:this.E.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class l{constructor(s,t,a,r,c=new y,o=new y,p=new L.ResourceMap,E=new y,k=new L.ResourceMap,F=!0){this.c=s,this.d=t,this.f=a,this.g=r,this.h=c,this.j=o,this.l=p,this.m=E,this.n=k,this.p=F,this.a=null,this.b=new L.ResourceMap,this.q=null}getValue(s,t,a){return this.s(s,t,a).getValue(s)}updateValue(s,t,a={}){let r;a.resource?(r=this.n.get(a.resource),r||(r=new y,this.n.set(a.resource,r))):r=this.m,t===void 0?r.removeValue(s):r.setValue(s,t),a.resource||(this.a=null)}inspect(s,t,a){const r=this.s(s,t,a),c=D.distinct(r.overrides.map(E=>E.identifiers).flat()).filter(E=>r.getOverrideValue(s,E)!==void 0),o=this.w(t.resource,a),p=t.resource?this.n.get(t.resource)||this.m:this.m;return new v(s,t,r.getValue(s),c.length?c:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),a?this.j.freeze():void 0,o?o.freeze():void 0,p.inspect(s,t.overrideIdentifier))}keys(s){const t=this.w(void 0,s);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.j=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,t){this.l.set(s,t),this.b.delete(s)}deleteFolderConfiguration(s){this.r.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,t){const a=[];if(!t){const{added:r,updated:c,removed:o}=h(this.c,s);t=[...r,...c,...o]}for(const r of t)for(const c of(0,b.overrideIdentifiersFromKey)(r)){const o=this.c.getKeysForOverrideIdentifier(c),p=s.getKeysForOverrideIdentifier(c),E=[...p.filter(k=>o.indexOf(k)===-1),...o.filter(k=>p.indexOf(k)===-1),...o.filter(k=>!P.equals(this.c.override(c).getValue(k),s.override(c).getValue(k)))];a.push([c,E])}return this.updateDefaultConfiguration(s),{keys:t,overrides:a}}compareAndUpdatePolicyConfiguration(s){const{added:t,updated:a,removed:r}=h(this.d,s),c=[...t,...a,...r];return c.length&&this.updatePolicyConfiguration(s),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:t,updated:a,removed:r,overrides:c}=h(this.applicationConfiguration,s),o=[...t,...a,...r];return o.length&&this.updateApplicationConfiguration(s),{keys:o,overrides:c}}compareAndUpdateLocalUserConfiguration(s){const{added:t,updated:a,removed:r,overrides:c}=h(this.localUserConfiguration,s),o=[...t,...a,...r];return o.length&&this.updateLocalUserConfiguration(s),{keys:o,overrides:c}}compareAndUpdateRemoteUserConfiguration(s){const{added:t,updated:a,removed:r,overrides:c}=h(this.remoteUserConfiguration,s),o=[...t,...a,...r];return o.length&&this.updateRemoteUserConfiguration(s),{keys:o,overrides:c}}compareAndUpdateWorkspaceConfiguration(s){const{added:t,updated:a,removed:r,overrides:c}=h(this.workspaceConfiguration,s),o=[...t,...a,...r];return o.length&&this.updateWorkspaceConfiguration(s),{keys:o,overrides:c}}compareAndUpdateFolderConfiguration(s,t){const a=this.r.get(s),{added:r,updated:c,removed:o,overrides:p}=h(a,t),E=[...r,...c,...o];return(E.length||!a)&&this.updateFolderConfiguration(s,t),{keys:E,overrides:p}}compareAndDeleteFolderConfiguration(s){const t=this.r.get(s);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:a,updated:r,removed:c,overrides:o}=h(t,void 0);return{keys:[...a,...r,...c],overrides:o}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(s,t,a){let r=this.t(t,a);return t.overrideIdentifier&&(r=r.override(t.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(r=r.merge(this.d)),r}t({resource:s},t){let a=this.u();if(t&&s){const r=t.getFolder(s);r&&(a=this.v(r.uri)||a);const c=this.n.get(s);c&&(a=a.merge(c))}return a}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(s){let t=this.b.get(s);if(!t){const a=this.u(),r=this.l.get(s);r?(t=a.merge(r),this.p&&(t=t.freeze()),this.b.set(s,t)):t=a}return t}w(s,t){if(t&&s){const a=t.getFolder(s);if(a)return this.l.get(a.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((s,t)=>{const{contents:a,overrides:r,keys:c}=this.l.get(t);return s.push([t,{contents:a,overrides:r,keys:c}]),s},[])}}allKeys(){const s=new Set;return this.c.freeze().keys.forEach(t=>s.add(t)),this.userConfiguration.freeze().keys.forEach(t=>s.add(t)),this.j.freeze().keys.forEach(t=>s.add(t)),this.l.forEach(t=>t.freeze().keys.forEach(a=>s.add(a))),[...s.values()]}x(){const s=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(t=>s.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>s.add(t)),this.j.freeze().getAllOverrideIdentifiers().forEach(t=>s.add(t)),this.l.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(a=>s.add(a))),[...s.values()]}y(s){const t=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(a=>t.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(a=>t.add(a)),this.j.getKeysForOverrideIdentifier(s).forEach(a=>t.add(a)),this.l.forEach(a=>a.getKeysForOverrideIdentifier(s).forEach(r=>t.add(r))),[...t.values()]}static parse(s){const t=this.z(s.defaults),a=this.z(s.policy),r=this.z(s.application),c=this.z(s.user),o=this.z(s.workspace),p=s.folders.reduce((E,k)=>(E.set(S.URI.revive(k[0]),this.z(k[1])),E),new L.ResourceMap);return new l(t,a,r,c,new y,o,p,new y,new L.ResourceMap,!1)}static z(s){return new y(s.contents,s.keys,s.overrides).freeze()}}e.Configuration=l;function m(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const s=new Set,t=new Map;for(const r of n)r.keys.forEach(c=>s.add(c)),r.overrides.forEach(([c,o])=>{const p=(0,L.getOrSet)(t,c,new Set);o.forEach(E=>p.add(E))});const a=[];return t.forEach((r,c)=>a.push([c,[...r.values()]])),{keys:[...s.values()],overrides:a}}e.mergeChanges=m;class u{constructor(s,t,a,r){this.change=s,this.b=t,this.c=a,this.d=r,this.f=void 0;const c=new Set;s.keys.forEach(p=>c.add(p)),s.overrides.forEach(([,p])=>p.forEach(E=>c.add(E))),this.affectedKeys=[...c.values()];const o=new y;this.affectedKeys.forEach(p=>o.setValue(p,{})),this.a=o.contents}get previousConfiguration(){return!this.f&&this.b&&(this.f=l.parse(this.b.data)),this.f}affectsConfiguration(s,t){if(this.g(this.a,s)){if(t){const a=this.previousConfiguration?this.previousConfiguration.getValue(s,t,this.b?.workspace):void 0,r=this.c.getValue(s,t,this.d);return!P.equals(a,r)}return!0}return!1}g(s,t){let a=(0,C.toValuesTree)({[t]:!0},()=>{}),r;for(;typeof a=="object"&&(r=Object.keys(a)[0]);){if(s=s[r],!s)return!1;a=a[r]}return!0}}e.ConfigurationChangeEvent=u;function h(n,s){const{added:t,removed:a,updated:r}=f(s?.rawConfiguration,n?.rawConfiguration),c=[],o=n?.getAllOverrideIdentifiers()||[],p=s?.getAllOverrideIdentifiers()||[];if(s){const E=p.filter(k=>!o.includes(k));for(const k of E)c.push([k,s.getKeysForOverrideIdentifier(k)])}if(n){const E=o.filter(k=>!p.includes(k));for(const k of E)c.push([k,n.getKeysForOverrideIdentifier(k)])}if(s&&n){for(const E of o)if(p.includes(E)){const k=f({contents:n.getOverrideValue(void 0,E)||{},keys:n.getKeysForOverrideIdentifier(E)},{contents:s.getOverrideValue(void 0,E)||{},keys:s.getKeysForOverrideIdentifier(E)});c.push([E,[...k.added,...k.removed,...k.updated]])}}return{added:t,removed:a,updated:r,overrides:c}}function f(n,s){const t=n?s?n.keys.filter(c=>s.keys.indexOf(c)===-1):[...n.keys]:[],a=s?n?s.keys.filter(c=>n.keys.indexOf(c)===-1):[...s.keys]:[],r=[];if(n&&s){for(const c of s.keys)if(n.keys.indexOf(c)!==-1){const o=(0,C.getConfigurationValue)(s.contents,c),p=(0,C.getConfigurationValue)(n.contents,c);P.equals(o,p)||r.push(c)}}return{added:t,removed:a,updated:r}}}),define(re[214],ae([0,1,20,3,2,32,15,16,74,46,8,58,40]),function(_,e,D,i,R,A,L,P,I,S,C,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class y extends R.Disposable{constructor(){super(...arguments),this.a=this.B(new i.Emitter),this.onDidChangeConfiguration=this.a.event}get configurationModel(){return this.b||(this.b=new d(this.f())),this.b}async initialize(){return this.b=void 0,this.B(w.Registry.as(S.Extensions.Configuration).onDidUpdateConfiguration(({properties:m,defaultsOverrides:u})=>this.c(m,u))),this.configurationModel}reload(){return this.b=void 0,this.configurationModel}c(m,u){this.b=void 0,this.a.fire({defaults:this.configurationModel,properties:m})}f(){return{}}}e.DefaultConfiguration=y;class d extends I.ConfigurationModel{constructor(m={}){const u=w.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),h=Object.keys(u),f=Object.create(null),n=[];for(const s in u){const t=m[s],a=t!==void 0?t:u[s].default;(0,P.addToValueTree)(f,s,a,r=>console.error(`Conflict in default settings: ${r}`))}for(const s of Object.keys(f))S.OVERRIDE_PROPERTY_REGEX.test(s)&&n.push({identifiers:(0,S.overrideIdentifiersFromKey)(s),keys:Object.keys(f[s]),contents:(0,P.toValuesTree)(f[s],t=>console.error(`Conflict in default settings file: ${t}`))});super(f,h,n)}}e.DefaultConfigurationModel=d;class g{constructor(){this.onDidChangeConfiguration=i.Event.None,this.configurationModel=new I.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=g;let v=class extends R.Disposable{get configurationModel(){return this.b}constructor(m,u,h){super(),this.c=m,this.f=u,this.g=h,this.a=this.B(new i.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new I.ConfigurationModel}async initialize(){return this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(m=>this.i(m))),this.B(this.c.onDidChangeConfiguration(async({properties:m})=>this.j(await this.h(m),!0))),this.b}async h(m){const u={},h=[],f=w.Registry.as(S.Extensions.Configuration).getConfigurationProperties();for(const n of m){const s=f[n];if(!s){h.push(n);continue}if(s.policy){if(s.type!=="string"&&s.type!=="number"){this.g.warn(`Policy ${s.policy.name} has unsupported type ${s.type}`);continue}h.push(n),u[s.policy.name]={type:s.type}}}return(0,L.isEmptyObject)(u)||await this.f.updatePolicyDefinitions(u),h}i(m){const u=w.Registry.as(S.Extensions.Configuration).getPolicyConfigurations(),h=(0,D.coalesce)(m.map(f=>u.get(f)));this.j(h,!0)}j(m,u){const h=w.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),f=[],n=this.b.isEmpty();for(const s of m){const t=h[s]?.policy?.name;if(t){const a=this.f.getPolicyValue(t);(n?a!==void 0:!(0,A.equals)(this.b.getValue(s),a))&&f.push([s,a])}else this.b.getValue(s)!==void 0&&f.push([s,void 0])}if(f.length){const s=this.b;this.b=new I.ConfigurationModel;for(const t of s.keys)this.b.setValue(t,s.getValue(t));for(const[t,a]of f)a===void 0?this.b.removeValue(t):this.b.setValue(t,a);u&&this.a.fire(this.b)}}};v=ye([K(1,b.IPolicyService),K(2,C.ILogService)],v),e.PolicyConfiguration=v}),define(re[215],ae([0,1,6,3,2,21,16,74,214,58]),function(_,e,D,i,R,A,L,P,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class C extends R.Disposable{constructor(w,y,d,g){super(),this.i=w,this.h=this.B(new i.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new I.DefaultConfiguration),this.c=d instanceof S.NullPolicyService?new I.NullPolicyConfiguration:this.B(new I.PolicyConfiguration(this.b,d,g)),this.f=this.B(new P.UserSettings(this.i,void 0,A.extUriBiasedIgnorePathCase,y)),this.a=new P.Configuration(this.b.configurationModel,this.c.configurationModel,new P.ConfigurationModel,new P.ConfigurationModel),this.g=this.B(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:v,properties:l})=>this.k(v,l))),this.B(this.c.onDidChangeConfiguration(v=>this.l(v))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[w,y,d]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new P.Configuration(w,y,new P.ConfigurationModel,d)}getConfigurationData(){return this.a.toData()}getValue(w,y){const d=typeof w=="string"?w:void 0,g=(0,L.isConfigurationOverrides)(w)?w:(0,L.isConfigurationOverrides)(y)?y:{};return this.a.getValue(d,g,void 0)}updateValue(w,y,d,g){return Promise.reject(new Error("not supported"))}inspect(w){return this.a.inspect(w,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const w=await this.f.loadConfiguration();this.j(w)}j(w){const y=this.a.toData(),d=this.a.compareAndUpdateLocalUserConfiguration(w);this.m(d,y,2)}k(w,y){const d=this.a.toData(),g=this.a.compareAndUpdateDefaultConfiguration(w,y);this.m(g,d,7)}l(w){const y=this.a.toData(),d=this.a.compareAndUpdatePolicyConfiguration(w);this.m(d,y,7)}m(w,y,d){const g=new P.ConfigurationChangeEvent(w,{data:y},this.a);g.source=d,g.sourceConfig=this.n(d),this.h.fire(g)}n(w){switch(w){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=C}),define(re[216],ae([0,1,9,4]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,i.createDecorator)("remoteAuthorityResolverService");var R;(function(L){L.Unknown="Unknown",L.NotAvailable="NotAvailable",L.TemporarilyNotAvailable="TemporarilyNotAvailable",L.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class A extends D.ErrorNoTelemetry{static isNotAvailable(P){return P instanceof A&&P._code===R.NotAvailable}static isTemporarilyNotAvailable(P){return P instanceof A&&P._code===R.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof A&&P._code===R.NoResolverFound}static isHandled(P){return P instanceof A&&P.isHandled}constructor(P,I=R.Unknown,S){super(P),this._message=P,this._code=I,this._detail=S,this.isHandled=I===R.NotAvailable&&S===!0,Object.setPrototypeOf(this,A.prototype)}}e.RemoteAuthorityResolverError=A}),define(re[75],ae([0,1,24]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function i(S){return S.scheme===D.Schemas.vscodeRemote?S.authority:void 0}e.getRemoteAuthority=i;function R(S){if(!S)return;const C=S.indexOf("+");return C<0?S:S.substr(0,C)}e.getRemoteName=R;function A(S){return`/${S.quality??"oss"}-${S.commit??"dev"}`}e.getRemoteServerRootPath=A;function L(S){const{host:C,port:b}=I(S);if(typeof b>"u")throw new Error("Remote authority doesn't contain a port!");return{host:C,port:b}}e.parseAuthorityWithPort=L;function P(S,C){let{host:b,port:w}=I(S);return typeof w>"u"&&(w=C),{host:b,port:w}}e.parseAuthorityWithOptionalPort=P;function I(S){const C=S.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(C)return{host:C[1],port:parseInt(C[2],10)};const b=S.match(/^(\[[0-9a-z:]+\])$/);if(b)return{host:b[1],port:void 0};const w=S.match(/(.*):(\d+)$/);return w?{host:w[1],port:parseInt(w[2],10)}:{host:S,port:void 0}}}),define(re[42],ae([0,1,27,4,75]),function(_,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.getWorkspaceSupportTypeMessage=A;function L(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=L,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));var I;(function(d){d.WIN32_X64="win32-x64",d.WIN32_IA32="win32-ia32",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(I=e.TargetPlatform||(e.TargetPlatform={}));class S{constructor(g){this.value=g,this.c=g.toLowerCase()}static equals(g,v){if(typeof g>"u"||g===null)return typeof v>"u"||v===null;if(typeof v>"u"||v===null)return!1;if(typeof g=="string"||typeof v=="string"){const l=typeof g=="string"?g:g.value,m=typeof v=="string"?v:v.value;return D.equalsIgnoreCase(l,m)}return g.c===v.c}static toKey(g){return typeof g=="string"?g.toLowerCase():g.c}}e.ExtensionIdentifier=S;function C(d){return b(d)}e.isApplicationScopedExtension=C;function b(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.isLanguagePackExtension=b;function w(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=w;function y(d,g){if(g){const v=`onResolveRemoteAuthority:${(0,R.getRemoteName)(g)}`;return d.activationEvents?.indexOf(v)!==-1}return!1}e.isResolverExtension=y,e.IBuiltinExtensionsScannerService=(0,i.createDecorator)("IBuiltinExtensionsScannerService")}),define(re[33],ae([0,1,27,29,42,5,7,9,36]),function(_,e,D,i,R,A,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function S(s,t){return s.uuid&&t.uuid?s.uuid===t.uuid:s.id===t.id?!0:(0,D.compareIgnoreCase)(s.id,t.id)===0}e.areSameExtensions=S;const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{static create(t){const a=t.manifest?t.manifest.version:t.version,r=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new b(t.identifier,a,r)}static parse(t){const a=C.exec(t);return a&&a[1]&&a[2]?new b({id:a[1]},a[2],a[4]||void 0):null}constructor(t,a,r="undefined"){this.version=a,this.targetPlatform=r,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof b?S(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.ExtensionKey=b;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(s){const t=w.exec(s);return t&&t[1]?[g(t[1]),t[2]]:[g(s),void 0]}e.getIdAndVersion=y;function d(s,t){return`${s}.${t}`}e.getExtensionId=d;function g(s){return s.toLocaleLowerCase()}e.adoptToGalleryExtensionId=g;function v(s,t){return g(d(s,t))}e.getGalleryExtensionId=v;function l(s,t){const a=[],r=c=>{for(const o of a)if(o.some(p=>S(t(p),t(c))))return o;return null};for(const c of s){const o=r(c);o?o.push(c):a.push([c])}return a}e.groupByExtension=l;function m(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=m;function u(s){return{id:s.identifier.id,name:s.name,galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.getGalleryExtensionTelemetryData=u,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function h(s,t){const a=[],r=t.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const c=r.shift();if(c&&a.every(o=>!S(o.identifier,{id:c}))){const o=s.filter(p=>S(p.identifier,{id:c}));o.length===1&&(a.push(o[0]),r.push(...o[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}e.getExtensionDependencies=h;async function f(s,t){if(!A.isLinux)return!1;let a;try{a=(await s.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{a=(await s.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){t.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(c))}}return!!a&&(a.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=f;async function n(s,t){const a=await f(s,t),r=(0,i.getTargetPlatform)(a?"alpine":A.platform,I.arch);return t.debug("ComputeTargetPlatform:",r),r}e.computeTargetPlatform=n}),define(re[217],ae([0,1,23,33]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function R(A,L,P,I,S){try{const C=await A.getExtensionsControlManifest();if(!C.deprecated)return;const b=await A.getInstalled(1);for(const[w,y]of Object.entries(C.deprecated)){if(!y?.extension)continue;const{id:d,autoMigrate:g,preRelease:v}=y.extension;if(!g)continue;const l=b.find(u=>(0,i.areSameExtensions)(u.identifier,{id:w}));if(!l)continue;const m=(await L.getExtensions([{id:d,preRelease:v}],{targetPlatform:await A.getTargetPlatform(),compatible:!0},D.CancellationToken.None))[0];if(!m){S.info(`Skipping migrating '${l.identifier.id}' extension because, the comaptible target '${d}' extension is not found`);continue}try{S.info(`Migrating '${l.identifier.id}' extension to '${d}' extension...`);const u=!I.getDisabledExtensions().some(f=>(0,i.areSameExtensions)(f,l.identifier));await A.uninstall(l),S.info(`Uninstalled the unsupported extension '${l.identifier.id}'`);let h=b.find(f=>(0,i.areSameExtensions)(f.identifier,{id:d}));(!h||!h.isPreReleaseVersion&&u)&&(h=await A.installFromGallery(m,{installPreReleaseVersion:!0,isMachineScoped:l.isMachineScoped,operation:4}),S.info(`Installed the pre-release extension '${h.identifier.id}'`),u||(await I.disableExtension(h.identifier),S.info(`Disabled the pre-release extension '${h.identifier.id}' because the unsupported extension '${l.identifier.id}' is disabled`)),g.storage&&(P.addToMigrationList((0,i.getExtensionId)(l.manifest.publisher,l.manifest.name),(0,i.getExtensionId)(h.manifest.publisher,h.manifest.name)),S.info("Added pre-release extension to the storage migration list"))),S.info(`Migrated '${l.identifier.id}' extension to '${d}' extension.`)}catch(u){S.error(u)}}}catch(C){S.error(C)}}e.migrateUnsupportedExtensions=R}),define(re[218],ae([0,1,6,9,2,24,5,21,53,15,31,28,16,14,29,33,97,13,8,25]),function(_,e,D,i,R,A,L,P,I,S,C,b,w,y,d,g,v,l,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let h=class pt extends R.Disposable{constructor(n,s,t,a,r,c,o,p){super(),this.h=n,this.i=t,this.j=a,this.k=r,this.l=c,this.m=o,this.n=p,this.extensionsDownloadDir=s.extensionsDownloadLocation,this.f=20,this.g=this.w()}async download(n,s){await this.g;const t=(0,P.joinPath)(this.extensionsDownloadDir,this.y(n));try{await this.u(n,t,r=>this.j.download(n,r,s))}catch(r){throw new d.ExtensionManagementError(r.message,d.ExtensionManagementErrorCode.Download)}let a=!1;if(await this.r(n)){const r=await this.t(n);try{a=await this.m.verify(t.fsPath,r.fsPath),this.n.info(`Verified extension: ${n.identifier.id}`,a)}catch(c){throw await this.delete(r),await this.delete(t),new d.ExtensionManagementError(c.code,d.ExtensionManagementErrorCode.Signature)}}return{location:t,verified:a}}async r(n){if(!n.isSigned||await this.h==="linux-armhf")return!1;const t=this.k.getValue("extensions.verifySignature");return(0,S.isBoolean)(t)?t:this.l.quality!=="stable"}async t(n){await this.g;const s=(0,P.joinPath)(this.extensionsDownloadDir,`${this.y(n)}${pt.c}`);return await this.u(n,s,t=>this.j.downloadSignatureArchive(n,t)),s}async u(n,s,t){if(await this.i.exists(s))return;if(s.scheme!==A.Schemas.file){await t(s);return}const a=(0,P.joinPath)(this.extensionsDownloadDir,`.${(0,C.generateUuid)()}`);await this.i.exists(a)||await t(a);try{await this.v(a,s,Date.now()+2*60*1e3)}catch(r){try{await this.i.del(a)}catch{}if(r.code==="ENOTEMPTY")this.n.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",n.identifier.id,s.path);else throw this.n.info(`Rename failed because of ${(0,i.getErrorMessage)(r)}. Deleted the file from downloaded location`,a.path),r}}async delete(n){await this.g,await this.i.del(n)}async v(n,s,t){try{await b.Promises.rename(n.fsPath,s.fsPath)}catch(a){if(L.isWindows&&a&&a.code==="EPERM"&&Date.now()<t)return this.n.info(`Failed renaming ${n} to ${s} with 'EPERM' error. Trying again...`),this.v(n,s,t);throw a}}async w(){try{if(!await this.i.exists(this.extensionsDownloadDir)){this.n.trace("Extension VSIX downloads cache dir does not exist");return}const n=await this.i.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(n.children){const s=[],t=[],a=[];for(const o of n.children)if(o.name.endsWith(pt.c))a.push(o.resource);else{const p=g.ExtensionKey.parse(o.name);p&&t.push([p,o])}const r=(0,g.groupByExtension)(t,([o])=>o),c=[];for(const o of r)o.sort((p,E)=>I.rcompare(p[0].version,E[0].version)),s.push(...o.slice(1).map(p=>p[1].resource)),c.push(o[0][1]);c.sort((o,p)=>o.mtime-p.mtime),s.push(...c.slice(0,Math.max(0,c.length-this.f)).map(o=>o.resource)),s.push(...a),await D.Promises.settled(s.map(o=>(this.n.trace("Deleting from cache",o.path),this.i.del(o))))}}catch(n){this.n.error(n)}}y(n){return this.f?g.ExtensionKey.create(n).toString().toLowerCase():(0,C.generateUuid)()}};h.c=".sigzip",h=ye([K(1,y.INativeEnvironmentService),K(2,l.IFileService),K(3,d.IExtensionGalleryService),K(4,w.IConfigurationService),K(5,u.IProductService),K(6,v.IExtensionSignatureVerificationService),K(7,m.ILogService)],h),e.ExtensionsDownloader=h}),define(re[219],ae([0,1,2,12,28,42]),function(_,e,D,i,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class L extends D.Disposable{constructor(I,S){super(),this.b=I,this.a=(0,i.join)(this.b.userDataPath,A.MANIFEST_CACHE_FOLDER,A.USER_MANIFEST_CACHE_FILE),this.B(S.onDidInstallExtensions(C=>this.c(C))),this.B(S.onDidUninstallExtension(C=>this.f(C)))}c(I){I.some(S=>!!S.local)&&this.invalidate()}f(I){I.error||this.invalidate()}invalidate(){R.Promises.rm(this.a,R.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=L}),define(re[220],ae([0,1,3,2,37,33,42]),function(_,e,D,i,R,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class P extends i.Disposable{constructor(S,C,b,w,y,d,g){super(),this.f=S,this.g=C,this.h=b,this.i=w,this.j=y,this.k=d,this.l=g,this.a=this.B(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new i.DisposableMap),this.m().then(null,v=>g.error(v))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.C()}n(){this.B(this.h.onDidChangeProfiles(S=>this.p(S.added,S.removed))),this.B(this.i.onAddExtensions(S=>this.r(S))),this.B(this.i.onDidAddExtensions(S=>this.s(S))),this.B(this.i.onRemoveExtensions(S=>this.t(S))),this.B(this.i.onDidRemoveExtensions(S=>this.u(S))),this.B(this.k.onDidFilesChange(S=>this.v(S)))}async p(S,C){try{await Promise.all(C.map(b=>(this.c.deleteAndDispose(b.id),this.z(b.extensionsResource))))}catch(b){this.l.error(b)}try{S.length&&await Promise.all(S.map(b=>(this.c.set(b.id,(0,i.combinedDisposable)(this.k.watch(this.j.extUri.dirname(b.extensionsResource)),this.k.watch(b.extensionsResource))),this.y(b.extensionsResource))))}catch(b){this.l.error(b)}}async r(S){for(const C of S.extensions)this.D(this.G(C.identifier,C.version),S.profileLocation)}async s(S){for(const C of S.extensions){const b=this.G(C.identifier,C.version);S.error?this.F(b,S.profileLocation):this.D(b,S.profileLocation)}}async t(S){for(const C of S.extensions)this.F(this.G(C.identifier,C.version),S.profileLocation)}async u(S){let C=!1;for(const b of S.extensions){const w=this.G(b.identifier,b.version);S.error?this.D(w,S.profileLocation):(this.F(w,S.profileLocation),C=C||!this.b.has(w))}C&&await this.C()}v(S){for(const C of this.h.profiles)S.contains(C.extensionsResource,0,1)&&this.w(C.extensionsResource)}async w(S){const C=[],b=[],w=await this.i.scanProfileExtensions(S),y=new Set,d=new Set;for(const[g,v]of this.b)v.has(S)&&d.add(g);for(const g of w){const v=this.G(g.identifier,g.version);y.add(v),d.has(v)||(C.push(g.identifier),this.D(v,S))}for(const g of d)if(!y.has(g)){const v=this.H(g);v&&(b.push(v.identifier),this.F(g,S))}(C.length||b.length)&&this.a.fire({added:C.length?{extensions:C,profileLocation:S}:void 0,removed:b.length?{extensions:b,profileLocation:S}:void 0})}async y(S){const C=await this.i.scanProfileExtensions(S);for(const b of C)this.D(this.G(b.identifier,b.version),S)}async z(S){for(const C of[...this.b.keys()])this.F(C,S);await this.C()}async C(){const C=(await this.f.getAllUserInstalled()).filter(b=>b.installedTimestamp&&!this.b.has(this.G(b.identifier,b.manifest.version)));C.length&&await this.f.markAsUninstalled(...C)}D(S,C){let b=this.b.get(S);b||this.b.set(S,b=new R.ResourceSet(w=>this.j.extUri.getComparisonKey(w))),b.add(C)}F(S,C){const b=this.b.get(S);b&&b.delete(C),b?.size||this.b.delete(S)}G(S,C){return`${L.ExtensionIdentifier.toKey(S.id)}@${C}`}H(S){const[C,b]=(0,A.getIdAndVersion)(S);return b?{identifier:{id:C},version:b}:void 0}}e.ExtensionsWatcher=P}),define(re[221],ae([0,1,99,20,6,2,24,12,28,14,29,33,8,73,5,7]),function(_,e,D,i,R,A,L,P,I,S,C,b,w,y,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let v=class extends y.LanguagePackBaseService{constructor(h,f,n,s){super(n),this.h=h,this.i=s,this.g=this.B(new l(f,s)),this.h.registerParticipant({postInstall:async t=>this.j(t),postUninstall:async t=>this.k(t)})}async getBuiltInExtensionTranslationsUri(h){const n=(await this.g.getLanguagePacks())[d.Language.value()];if(!n){this.i.warn(`No language pack found for ${d.Language.value()}`);return}const s=n.translations[h];return s?g.URI.file(s):void 0}async getInstalledLanguages(){const h=await this.g.getLanguagePacks(),f=Object.keys(h).map(n=>{const s=h[n];return{...this.f(n,s.label),extensionId:s.extensions[0].extensionIdentifier.id}});return f.push({...this.f("en","English"),extensionId:"default"}),f.sort((n,s)=>n.label.localeCompare(s.label)),f}async j(h){h&&h.manifest&&h.manifest.contributes&&h.manifest.contributes.localizations&&h.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",h.identifier.id),await this.update())}async k(h){const f=await this.g.getLanguagePacks();Object.keys(f).some(n=>f[n]&&f[n].extensions.some(s=>(0,b.areSameExtensions)(s.extensionIdentifier,h.identifier)))&&(this.i.info("Removing language packs from the extension",h.identifier.id),await this.update())}async update(){const[h,f]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),n=await this.g.update(f);return!(0,i.equals)(Object.keys(h),Object.keys(n))}};v=ye([K(0,C.IExtensionManagementService),K(1,S.INativeEnvironmentService),K(2,C.IExtensionGalleryService),K(3,w.ILogService)],v),e.NativeLanguagePackService=v;let l=class extends A.Disposable{constructor(h,f){super(),this.i=f,this.c={},this.f=(0,P.join)(h.userDataPath,"languagepacks.json"),this.g=new R.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(h){return this.m(f=>{Object.keys(f).forEach(n=>delete f[n]),this.j(f,...h)}).then(()=>this.c)}j(h,...f){for(const n of f)n&&n.manifest&&n.manifest.contributes&&n.manifest.contributes.localizations&&n.manifest.contributes.localizations.length&&this.k(h,n);Object.keys(h).forEach(n=>this.l(h[n]))}k(h,f){const n=f.identifier,s=f.manifest.contributes&&f.manifest.contributes.localizations?f.manifest.contributes.localizations:[];for(const t of s)if(f.location.scheme===L.Schemas.file&&m(t)){let a=h[t.languageId];a||(a={hash:"",extensions:[],translations:{},label:t.localizedLanguageName??t.languageName},h[t.languageId]=a);const r=a.extensions.filter(c=>(0,b.areSameExtensions)(c.extensionIdentifier,n))[0];r?r.version=f.manifest.version:a.extensions.push({extensionIdentifier:n,version:f.manifest.version});for(const c of t.translations)a.translations[c.id]=(0,P.join)(f.location.fsPath,c.path)}}l(h){if(h){const f=(0,D.createHash)("md5");for(const n of h.extensions)f.update(n.extensionIdentifier.uuid||n.extensionIdentifier.id).update(n.version);h.hash=f.digest("hex")}}m(h=()=>null){return this.g.queue(()=>{let f=null;return I.Promises.readFile(this.f,"utf8").then(void 0,n=>n.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(n)).then(n=>{try{return JSON.parse(n)}catch{return{}}}).then(n=>(f=h(n),n)).then(n=>{for(const t of Object.keys(n))n[t]||delete n[t];this.c=n,this.h=!0;const s=JSON.stringify(this.c);return this.i.debug("Writing language packs",s),I.Promises.writeFile(this.f,s)}).then(()=>f,n=>this.i.error(n))})}};l=ye([K(0,S.INativeEnvironmentService),K(1,w.ILogService)],l);function m(u){if(typeof u.languageId!="string"||!Array.isArray(u.translations)||u.translations.length===0)return!1;for(const h of u.translations)if(typeof h.id!="string"||typeof h.path!="string")return!1;return!(u.languageName&&typeof u.languageName!="string"||u.localizedLanguageName&&typeof u.localizedLanguageName!="string")}}),define(re[222],ae([0,1,6,17,23,9,3,2,31,92,216,75]),function(_,e,D,i,R,A,L,P,I,S,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const w=30*1e3;var y;(function(J){J[J.Management=1]="Management",J[J.ExtensionHost=2]="ExtensionHost",J[J.Tunnel=3]="Tunnel"})(y=e.ConnectionType||(e.ConnectionType={}));function d(J){switch(J){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function g(J){const Q=new R.CancellationTokenSource;return setTimeout(()=>Q.cancel(),J),Q.token}function v(J,Q){if(J.isCancellationRequested||Q.isCancellationRequested)return R.CancellationToken.Cancelled;const T=new R.CancellationTokenSource;return J.onCancellationRequested(()=>T.cancel()),Q.onCancellationRequested(()=>T.cancel()),T.token}class l{get didTimeout(){return this.c==="timedout"}constructor(Q){this.c="pending",this.d=new P.DisposableStore,this.promise=new Promise((T,M)=>{this.f=T,this.g=M}),Q.isCancellationRequested?this.h():this.d.add(Q.onCancellationRequested(()=>this.h()))}registerDisposable(Q){this.c==="pending"?this.d.add(Q):Q.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const Q=new Error("Time limit reached");return Q.code="ETIMEDOUT",Q.syscall="connect",Q}resolve(Q){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(Q))}reject(Q){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(Q))}}function m(J,Q){const T=new l(Q);return T.registerDisposable(J.onControlMessage(M=>{const V=JSON.parse(M.toString()),W=z(V);W?T.reject(W):T.resolve(V)})),T.promise}function u(J,Q,T,M,V,W,X,se){const x=new l(se);return Q.connect(T,M,V,W,X,(ie,ne)=>{x.didTimeout?(ie&&J.error(ie),ne?.dispose()):ie||!ne?x.reject(ie):x.resolve(ne)}),x.promise}function h(J,Q){const T=new l(Q);return J.then(M=>{T.didTimeout||T.resolve(M)},M=>{T.didTimeout||T.reject(M)}),T.promise}async function f(J,Q,T,M){const V=ee(J,Q);J.logService.trace(`${V} 1/6. invoking socketFactory.connect().`);let W;try{W=await u(J.logService,J.socketFactory,J.host,J.port,(0,b.getRemoteServerRootPath)(J),`reconnectionToken=${J.reconnectionToken}&reconnection=${J.reconnectionProtocol?"true":"false"}`,`renderer-${d(Q)}-${J.reconnectionToken}`,M)}catch(ne){throw J.logService.error(`${V} socketFactory.connect() failed or timed out. Error:`),J.logService.error(ne),ne}J.logService.trace(`${V} 2/6. socketFactory.connect() was successful.`);let X,se;J.reconnectionProtocol?(J.reconnectionProtocol.beginAcceptReconnection(W,null),X=J.reconnectionProtocol,se=!1):(X=new S.PersistentProtocol(W,null),se=!0),J.logService.trace(`${V} 3/6. sending AuthRequest control message.`);const x=await h(J.signService.createNewMessage((0,I.generateUuid)()),M),ie={type:"auth",auth:J.connectionToken||"00000000000000000000",data:x.data};X.sendControl(i.VSBuffer.fromString(JSON.stringify(ie)));try{const ne=await m(X,v(M,g(1e4)));if(ne.type!=="sign"||typeof ne.data!="string"){const Se=new Error("Unexpected handshake message");throw Se.code="VSCODE_CONNECTION_ERROR",Se}if(J.logService.trace(`${V} 4/6. received SignRequest control message.`),!await h(J.signService.validate(x,ne.signedData),M)){const Se=new Error("Refused to connect to unsupported server");throw Se.code="VSCODE_CONNECTION_ERROR",Se}const ue=await h(J.signService.sign(ne.data),M),pe={type:"connectionType",commit:J.commit,signedData:ue,desiredConnectionType:Q};return T&&(pe.args=T),J.logService.trace(`${V} 5/6. sending ConnectionTypeRequest control message.`),X.sendControl(i.VSBuffer.fromString(JSON.stringify(pe))),{protocol:X,ownsProtocol:se}}catch(ne){throw ne&&ne.code==="ETIMEDOUT"&&(J.logService.error(`${V} the handshake timed out. Error:`),J.logService.error(ne)),ne&&ne.code==="VSCODE_CONNECTION_ERROR"&&(J.logService.error(`${V} received error control message when negotiating connection. Error:`),J.logService.error(ne)),se&&Z(X),ne}}async function n(J,Q,T,M){const V=Date.now(),W=ee(J,Q),{protocol:X,ownsProtocol:se}=await f(J,Q,T,M),x=new l(M);return x.registerDisposable(X.onControlMessage(ie=>{const ne=JSON.parse(ie.toString()),le=z(ne);le?(J.logService.error(`${W} received error control message when negotiating connection. Error:`),J.logService.error(le),se&&Z(X),x.reject(le)):(J.reconnectionProtocol?.endAcceptReconnection(),J.logService.trace(`${W} 6/6. handshake finished, connection is up and running after ${oe(V)}!`),x.resolve({protocol:X,firstMessage:ne}))})),x.promise}async function s(J,Q){const{protocol:T}=await n(J,1,void 0,Q);return{protocol:T}}async function t(J,Q,T){const{protocol:M,firstMessage:V}=await n(J,2,Q,T),W=V&&V.debugPort;return{protocol:M,debugPort:W}}async function a(J,Q,T){const M=Date.now(),V=ee(J,3),{protocol:W}=await f(J,3,Q,T);return J.logService.trace(`${V} 6/6. handshake finished, connection is up and running after ${oe(M)}!`),W}async function r(J,Q,T){const{host:M,port:V,connectionToken:W}=await J.addressProvider.getAddress();return{commit:J.commit,quality:J.quality,host:M,port:V,connectionToken:W,reconnectionToken:Q,reconnectionProtocol:T,socketFactory:J.socketFactory,signService:J.signService,logService:J.logService}}async function c(J,Q,T){return p(J,async M=>{const{protocol:V}=await s(M,R.CancellationToken.None);return new G(J,Q,T,M.reconnectionToken,V)})}e.connectRemoteAgentManagement=c;async function o(J,Q){return p(J,async T=>{const{protocol:M,debugPort:V}=await t(T,Q,R.CancellationToken.None);return new H(J,Q,T.reconnectionToken,M,V)})}e.connectRemoteAgentExtensionHost=o;async function p(J,Q){for(let M=1;;M++)try{const V=(0,I.generateUuid)(),W=await r(J,V,null);return await Q(W)}catch(V){if(M<5)J.logService.error(`[remote-connection][attempt ${M}] An error occurred in initial connection! Will retry... Error:`),J.logService.error(V);else throw J.logService.error(`[remote-connection][attempt ${M}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),J.logService.error(V),$.triggerPermanentFailure(0,0,C.RemoteAuthorityResolverError.isHandled(V)),V}}async function E(J,Q,T){const M=await r(J,(0,I.generateUuid)(),null);return await a(M,{host:Q,port:T},R.CancellationToken.None)}e.connectRemoteAgentTunnel=E;function k(J){return(0,D.createCancelablePromise)(Q=>new Promise((T,M)=>{const V=setTimeout(T,J*1e3);Q.onCancellationRequested(()=>{clearTimeout(V),T()})}))}var F;(function(J){J[J.ConnectionLost=0]="ConnectionLost",J[J.ReconnectionWait=1]="ReconnectionWait",J[J.ReconnectionRunning=2]="ReconnectionRunning",J[J.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",J[J.ConnectionGain=4]="ConnectionGain"})(F=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class N{constructor(Q,T){this.reconnectionToken=Q,this.millisSinceLastIncomingData=T,this.type=0}}e.ConnectionLostEvent=N;class q{constructor(Q,T,M,V){this.reconnectionToken=Q,this.millisSinceLastIncomingData=T,this.durationSeconds=M,this.c=V,this.type=1}skipWait(){this.c.cancel()}}e.ReconnectionWaitEvent=q;class j{constructor(Q,T,M){this.reconnectionToken=Q,this.millisSinceLastIncomingData=T,this.attempt=M,this.type=2}}e.ReconnectionRunningEvent=j;class O{constructor(Q,T,M){this.reconnectionToken=Q,this.millisSinceLastIncomingData=T,this.attempt=M,this.type=4}}e.ConnectionGainEvent=O;class U{constructor(Q,T,M,V){this.reconnectionToken=Q,this.millisSinceLastIncomingData=T,this.attempt=M,this.handled=V,this.type=3}}e.ReconnectionPermanentFailureEvent=U;class $ extends P.Disposable{static triggerPermanentFailure(Q,T,M){this._permanentFailure=!0,this.f=Q,this.g=T,this.h=M,this.i.forEach(V=>V.u(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(Q=>Q.r())}static debugPauseSocketWriting(){this.i.forEach(Q=>Q.v())}get k(){return this.c||$._permanentFailure}constructor(Q,T,M,V,W){super(),this.m=Q,this.n=T,this.reconnectionToken=M,this.protocol=V,this.p=W,this.j=this.B(new L.Emitter),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.j.fire(new O(this.reconnectionToken,0,0)),this.B(V.onSocketClose(X=>{const se=Y(this.m,this.reconnectionToken,!0);X?X.type===0?(this.n.logService.info(`${se} received socket close event (hadError: ${X.hadError}).`),X.error&&this.n.logService.error(X.error)):(this.n.logService.info(`${se} received socket close event (wasClean: ${X.wasClean}, code: ${X.code}, reason: ${X.reason}).`),X.event&&this.n.logService.error(X.event)):this.n.logService.info(`${se} received socket close event.`),this.r()})),this.B(V.onSocketTimeout(X=>{const se=Y(this.m,this.reconnectionToken,!0);this.n.logService.info(`${se} received socket timeout event (unacknowledgedMsgCount: ${X.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${X.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${X.timeSinceLastReceivedSomeData}).`),this.r()})),$.i.push(this),this.B((0,P.toDisposable)(()=>{const X=$.i.indexOf(this);X>=0&&$.i.splice(X,1)})),this.k&&this.u($.f,$.g,$.h)}async r(){if(!this.l)try{this.l=!0,await this.s()}finally{this.l=!1}}async s(){if(this.k)return;const Q=Y(this.m,this.reconnectionToken,!0);this.n.logService.info(`${Q} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const T=[0,5,5,10,10,10,10,10,30];let M=-1;do{M++;const V=M<T.length?T[M]:T[T.length-1];try{if(V>0){const X=k(V);this.j.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),V,X)),this.n.logService.info(`${Q} waiting for ${V} seconds before reconnecting...`);try{await X}catch{}}if(this.k){this.n.logService.error(`${Q} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),M+1)),this.n.logService.info(`${Q} resolving connection...`);const W=await r(this.n,this.reconnectionToken,this.protocol);this.n.logService.info(`${Q} connecting to ${W.host}:${W.port}...`),await this.w(W,g(w)),this.n.logService.info(`${Q} reconnected!`),this.j.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),M+1));break}catch(W){if(W.code==="VSCODE_CONNECTION_ERROR"){this.n.logService.error(`${Q} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.n.logService.error(W),this.t(this.protocol.getMillisSinceLastIncomingData(),M+1,!1);break}if(M>360){this.n.logService.error(`${Q} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.n.logService.error(W),this.t(this.protocol.getMillisSinceLastIncomingData(),M+1,!1);break}if(C.RemoteAuthorityResolverError.isTemporarilyNotAvailable(W)){this.n.logService.info(`${Q} A temporarily not available error occurred while trying to reconnect, will try again...`),this.n.logService.trace(W);continue}if((W.code==="ETIMEDOUT"||W.code==="ENETUNREACH"||W.code==="ECONNREFUSED"||W.code==="ECONNRESET")&&W.syscall==="connect"){this.n.logService.info(`${Q} A network error occurred while trying to reconnect, will try again...`),this.n.logService.trace(W);continue}if((0,A.isCancellationError)(W)){this.n.logService.info(`${Q} A promise cancelation error occurred while trying to reconnect, will try again...`),this.n.logService.trace(W);continue}if(W instanceof C.RemoteAuthorityResolverError){this.n.logService.error(`${Q} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.n.logService.error(W),this.t(this.protocol.getMillisSinceLastIncomingData(),M+1,C.RemoteAuthorityResolverError.isHandled(W));break}this.n.logService.error(`${Q} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.n.logService.error(W),this.t(this.protocol.getMillisSinceLastIncomingData(),M+1,!1);break}}while(!this.k)}t(Q,T,M){this.p?$.triggerPermanentFailure(Q,T,M):this.u(Q,T,M)}u(Q,T,M){this.j.fire(new U(this.reconnectionToken,Q,T,M)),Z(this.protocol)}v(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=$,$._permanentFailure=!1,$.f=0,$.g=0,$.h=!1,$.i=[];class G extends ${constructor(Q,T,M,V,W){super(1,Q,V,W,!0),this.client=this.B(new S.Client(W,{remoteAuthority:T,clientId:M},Q.ipcLogger))}async w(Q,T){await s(Q,T)}}e.ManagementPersistentConnection=G;class H extends ${constructor(Q,T,M,V,W){super(2,Q,M,V,!1),this.y=T,this.debugPort=W}async w(Q,T){await t(Q,this.y,T)}}e.ExtensionHostPersistentConnection=H;function Z(J){try{J.acceptDisconnect();const Q=J.getSocket();J.dispose(),Q.dispose()}catch(Q){(0,A.onUnexpectedError)(Q)}}function z(J){if(J&&J.type==="error"){const Q=new Error(`Connection error: ${J.reason}`);return Q.code="VSCODE_CONNECTION_ERROR",Q}return null}function B(J,Q){for(;J.length<Q;)J+=" ";return J}function Y(J,Q,T){return`[remote-connection][${B(d(J),13)}][${Q.substr(0,5)}\u2026][${T?"reconnect":"initial"}]`}function ee(J,Q){return`${Y(Q,J.reconnectionToken,!!J.reconnectionProtocol)}[${J.host}:${J.port}]`}function oe(J){return`${Date.now()-J} ms`}}),define(re[223],ae([0,1,4]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,D.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(re[224],ae([0,1,86,149]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(R,A,L,P,I,S){const C=w=>S(w,void 0),b=D.createConnection({host:R,port:A},()=>{b.removeListener("error",C);const w=Buffer.alloc(16);for(let v=0;v<16;v++)w[v]=Math.round(Math.random()*256);const y=w.toString("base64"),d=[`GET ws://${/:/.test(R)?`[${R}]`:R}:${A}${L}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${y}`];b.write(d.join(`\r
`)+`\r
\r
`);const g=v=>{v.toString().indexOf(`\r
\r
`)>=0&&(b.off("data",g),S(void 0,new i.NodeSocket(b,I)))};b.on("data",g)});b.setNoDelay(!0),b.once("error",C)}}}),define(re[105],ae([0,1,4]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LOG_CHANNEL_ID=e.LOGGER_NAME=e.LOG_FILE_NAME=e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX=e.TunnelStates=e.IRemoteTunnelService=void 0,e.IRemoteTunnelService=(0,D.createDecorator)("IRemoteTunnelService");var i;(function(R){R.disconnected={type:"disconnected"},R.uninitialized={type:"uninitialized"},R.connected=A=>({type:"connected",info:A}),R.connecting=A=>({type:"connecting",progress:A})})(i=e.TunnelStates||(e.TunnelStates={})),e.CONFIGURATION_KEY_PREFIX="remote.tunnels.access",e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX+".hostNameOverride",e.LOG_FILE_NAME="remoteTunnelService.log",e.LOGGER_NAME="remoteTunnelService",e.LOG_CHANNEL_ID="remoteTunnelServiceLog"}),define(re[225],ae([0,1,132,16,8]),function(_,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let A=class{constructor(P,I){this.a=P,this.b=I}async request(P,I){this.b.trace("RequestService#request (browser) - begin",P.url),P.proxyAuthorization||(P.proxyAuthorization=this.a.getValue("http.proxyAuthorization"));try{const S=await(0,D.request)(P,I);return this.b.trace("RequestService#request (browser) - success",P.url),S}catch(S){throw this.b.error("RequestService#request (browser) - error",P.url,S),S}}async resolveProxy(P){}};A=ye([K(0,i.IConfigurationService),K(1,R.ILogService)],A),e.RequestService=A}),define(re[59],ae([0,1,17,168,46,4,40]),function(_,e,D,i,R,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,A.createDecorator)("requestService");function P(g){return g.res.statusCode&&g.res.statusCode>=200&&g.res.statusCode<300||g.res.statusCode===1223}e.isSuccess=P;function I(g){return g.res.statusCode===204}async function S(g){return I(g)?null:(await(0,D.streamToBuffer)(g.stream)).toString()}e.asText=S;async function C(g){if(!P(g))throw new Error("Server returned "+g.res.statusCode);return S(g)}e.asTextOrError=C;async function b(g){if(!P(g))throw new Error("Server returned "+g.res.statusCode);if(I(g))return null;const l=(await(0,D.streamToBuffer)(g.stream)).toString();try{return JSON.parse(l)}catch(m){throw m.message+=`:
`+l,m}}e.asJson=b;function w(g){d(g)}e.updateProxyConfigurationsScope=w;let y;function d(g){const v=L.Registry.as(R.Extensions.Configuration),l=y;y={id:"http",order:15,title:(0,i.localize)(0,null),type:"object",scope:g,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,i.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,i.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,i.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,i.localize)(4,null),(0,i.localize)(5,null),(0,i.localize)(6,null),(0,i.localize)(7,null)],default:"override",description:(0,i.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,i.localize)(9,null),restricted:!0}}},v.updateConfigurations({add:[y],remove:l?[l]:[]})}d(2)}),define(re[226],ae([0,1,23,24,13,59]),function(_,e,D,i,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let L=class{constructor(I,S){this.a=I,this.b=S}async download(I,S,C=D.CancellationToken.None){if(I.scheme===i.Schemas.file||I.scheme===i.Schemas.vscodeRemote){await this.b.copy(I,S);return}const b={type:"GET",url:I.toString(!0)},w=await this.a.request(b,C);if(w.res.statusCode===200)await this.b.writeFile(S,w.stream);else{const y=await(0,A.asTextOrError)(w);throw new Error(`Expected 200, got back ${w.res.statusCode} instead.

${y}`)}}};L=ye([K(0,A.IRequestService),K(1,R.IFileService)],L),e.DownloadService=L}),define(re[227],ae([0,1,17,23]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class R{constructor(P){this.a=P}listen(P,I){throw new Error("Invalid listen")}call(P,I,S,C=i.CancellationToken.None){switch(I){case"request":return this.a.request(S[0],C).then(async({res:b,stream:w})=>{const y=await(0,D.streamToBuffer)(w);return[{statusCode:b.statusCode,headers:b.headers},y]});case"resolveProxy":return this.a.resolveProxy(S[0])}throw new Error("Invalid call")}}e.RequestChannel=R;class A{constructor(P){this.a=P}async request(P,I){const[S,C]=await this.a.call("request",[P],I);return{res:S,stream:(0,D.bufferToStream)(C)}}async resolveProxy(P){return this.a.call("resolveProxy",[P])}}e.RequestChannelClient=A}),define(re[228],ae([0,1,15,225,227]),function(_,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRequestService=void 0;class A{constructor(P,I,S,C){this.c=I,this.d=S,this.e=C,this.a=new i.RequestService(I,C),this.b=new R.RequestChannelClient(P.getChannel("request"))}request(P,I){return this.f().request(P,I)}async resolveProxy(P){return this.f().resolveProxy(P)}f(){return this.g()?(this.e.trace("Using main request service"),this.b):(this.e.trace("Using browser request service"),this.a)}g(){const P=this.c.getValue("developer.sharedProcess.redirectRequestsToMain");return(0,D.isBoolean)(P)?P:this.d.quality!=="stable"}}e.SharedProcessRequestService=A}),define(re[106],ae([0,1,66,4]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function R(A){return(0,D.hash)({moduleId:A.process.moduleId,windowId:A.reply.windowId})}e.hash=R,e.ISharedProcessWorkerService=(0,i.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(re[229],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var D;(function(i){i.Spawn="vscode:shared-process->shared-process-worker=spawn",i.Terminate="vscode:shared-process->shared-process-worker=terminate",i.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",i.Ready="vscode:shared-process-worker->shared-process=ready",i.Ack="vscode:shared-process-worker->shared-process=ack",i.Trace="vscode:shared-process-worker->shared-process=trace",i.Info="vscode:shared-process-worker->shared-process=info",i.Warn="vscode:shared-process-worker->shared-process=warn",i.Error="vscode:shared-process-worker->shared-process=error"})(D=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(re[230],ae([0,1,93,6,23,3,2,24,31,8,106,229]),function(_,e,D,i,R,A,L,P,I,S,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let w=class{constructor(g){this.d=g,this.a=new Map,this.b=new Map,this.c=new Map}async createWorker(g){const v=`window: ${g.reply.windowId}, moduleId: ${g.process.moduleId}`;this.d.trace(`SharedProcess: createWorker (${v})`);const l=(0,C.hash)(g);this.b.has(l)&&(this.d.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${v})`),this.f(g));const m=new R.CancellationTokenSource;let u,h,f;this.b.set(l,a=>{m.dispose(!0),u?.terminate(g,R.CancellationToken.None),h?.close(),f?.close(),this.b.delete(l);const r=this.c.get(l);r&&(this.c.delete(l),r({reason:a}))}),u=await this.e(g);const n=new Promise(a=>{this.c.set(l,a)});if(m.token.isCancellationRequested)return n;const{port1:s,port2:t}=new MessageChannel;return h=s,f=t,await u.spawn(g,f,m.token),m.token.isCancellationRequested||(this.d.trace(`SharedProcess: createWorker sending message port back to window (${v})`),D.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",g,[h])),n}e(g){let v=this.a.get(g.process.moduleId);if(!v){this.d.trace(`SharedProcess: creating new web worker (${g.process.moduleId})`);const l=new y(g.process.type,this.d);v=l.init(),l.onDidProcessSelfTerminate(({configuration:m,reason:u})=>{this.f(m,u)}),this.a.set(g.process.moduleId,v)}return v}async disposeWorker(g){return this.f(g)}f(g,v){const l=this.b.get((0,C.hash)(g));l&&(this.d.trace(`SharedProcess: disposeWorker (window: ${g.reply.windowId}, moduleId: ${g.process.moduleId})`),l(v))}};w=ye([K(0,S.ILogService)],w),e.SharedProcessWorkerService=w;class y extends L.Disposable{constructor(g,v){super(),this.f=g,this.g=v,this.a=this.B(new A.Emitter),this.onDidProcessSelfTerminate=this.a.event,this.b=this.h(),this.c=new Map}async init(){return await this.b,this}h(){const g=new i.DeferredPromise,v=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.f})`});return v.onerror=l=>{this.g.error(`SharedProcess: worker error (${this.f})`,l.message)},v.onmessageerror=l=>{this.g.error(`SharedProcess: worker message error (${this.f})`,l)},v.onmessage=l=>{const{id:m,message:u,configuration:h,nonce:f}=l.data;switch(m){case b.SharedProcessWorkerMessages.Ready:g.complete(v);break;case b.SharedProcessWorkerMessages.Ack:if(f){const n=this.c.get(f);n&&(this.c.delete(f),n())}break;case b.SharedProcessWorkerMessages.SelfTerminated:h&&u&&this.a.fire({configuration:h,reason:JSON.parse(u)});break;case b.SharedProcessWorkerMessages.Trace:this.g.trace(`SharedProcess (worker, ${this.f}):`,u);break;case b.SharedProcessWorkerMessages.Info:u&&this.g.info(u);break;case b.SharedProcessWorkerMessages.Warn:this.g.warn(`SharedProcess (worker, ${this.f}):`,u);break;case b.SharedProcessWorkerMessages.Error:this.g.error(`SharedProcess (worker, ${this.f}):`,u);break;default:this.g.warn(`SharedProcess: unexpected worker message (${this.f})`,l)}},v.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),g.p}async i(g,v,l){const m=await this.b;if(!v.isCancellationRequested)return new Promise(u=>{const h=(0,I.generateUuid)();this.c.set(h,u);const f={...g,nonce:h};l?m.postMessage(f,[l]):m.postMessage(f),v.onCancellationRequested(()=>{this.c.delete(h)&&u()})})}spawn(g,v,l){const m={id:b.SharedProcessWorkerMessages.Spawn,configuration:g,environment:{bootstrapPath:P.FileAccess.asFileUri("bootstrap-fork").fsPath}};return this.i(m,l,v)}terminate(g,v){const l={id:b.SharedProcessWorkerMessages.Terminate,configuration:g};return this.i(l,v)}}}),define(re[231],ae([0,1,63,24,185]),function(_,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class A extends R.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:i.Schemas.vscodeUserData})}}ye([D.memoize],A.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=A}),define(re[232],ae([0,1,49,12,169,23,38,9,5,31,146,183,6]),function(_,e,D,i,R,A,L,P,I,S,C,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const y=1e4;let d;async function g(l,m,u){return m["force-disable-user-env"]?(l.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):I.isWindows?(l.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,b.isLaunchedFromCli)(u)&&!m["force-user-env"]?(l.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,b.isLaunchedFromCli)(u)?l.trace("resolveShellEnv(): running (--force-user-env)"):l.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=w.Promises.withAsyncBody(async(h,f)=>{const n=new A.CancellationTokenSource,s=setTimeout(()=>{n.dispose(!0),f(new Error((0,R.localize)(0,null)))},y);try{h(await v(l,n.token))}catch(t){!(0,P.isCancellationError)(t)&&!n.token.isCancellationRequested?f(new Error((0,R.localize)(1,null,(0,L.toErrorMessage)(t)))):h({})}finally{clearTimeout(s),n.dispose()}})),d)}e.getResolvedShellEnv=g;async function v(l,m){const u=process.env.ELECTRON_RUN_AS_NODE;l.trace("getUnixShellEnvironment#runAsNode",u);const h=process.env.ELECTRON_NO_ATTACH_CONSOLE;l.trace("getUnixShellEnvironment#noAttach",h);const f=(0,S.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(f+"(.*)"+f),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};l.trace("getUnixShellEnvironment#env",s);const t=await(0,C.getSystemShell)(I.OS,s);return l.trace("getUnixShellEnvironment#shell",t),new Promise((a,r)=>{if(m.isCancellationRequested)return r((0,P.canceled)());const c=(0,i.basename)(t);let o,p;const E=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(o=`& '${process.execPath}' ${E} -p '''${f}'' + JSON.stringify(process.env) + ''${f}'''`,p=["-Login","-Command"]):(o=`'${process.execPath}' ${E} -p '"${f}" + JSON.stringify(process.env) + "${f}"'`,c==="tcsh"?p=["-ic"]:p=["-ilc"]),l.trace("getUnixShellEnvironment#spawn",JSON.stringify(p),o);const k=(0,D.spawn)(t,[...p,o],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});m.onCancellationRequested(()=>(k.kill(),r((0,P.canceled)()))),k.on("error",q=>{l.error("getUnixShellEnvironment#errorChildProcess",(0,L.toErrorMessage)(q)),r(q)});const F=[];k.stdout.on("data",q=>F.push(q));const N=[];k.stderr.on("data",q=>N.push(q)),k.on("close",(q,j)=>{const O=Buffer.concat(F).toString("utf8");l.trace("getUnixShellEnvironment#raw",O);const U=Buffer.concat(N).toString("utf8");if(U.trim()&&l.trace("getUnixShellEnvironment#stderr",U),q||j)return r(new Error((0,R.localize)(2,null,q,j)));const $=n.exec(O),G=$?$[1]:"{}";try{const H=JSON.parse(G);u?H.ELECTRON_RUN_AS_NODE=u:delete H.ELECTRON_RUN_AS_NODE,h?H.ELECTRON_NO_ATTACH_CONSOLE=h:delete H.ELECTRON_NO_ATTACH_CONSOLE,delete H.XDG_RUNTIME_DIR,l.trace("getUnixShellEnvironment#result",H),a(H)}catch(H){l.error("getUnixShellEnvironment#errorCaught",(0,L.toErrorMessage)(H)),r(H)}})})}}),define(re[107],ae([0,1,4]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,D.createDecorator)(e.SIGN_SERVICE_ID)}),define(re[233],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class D{constructor(){this.b=new Map}c(){return new Promise((R,A)=>_(["vsda"],R,A))}async createNewMessage(R){try{const A=await this.c(),L=new A.validator;if(L){const P=String(D.a++);return this.b.set(P,L),{id:P,data:L.createNewMessage(R)}}}catch{}return{id:"",data:R}}async validate(R,A){if(!R.id)return!0;const L=this.b.get(R.id);if(!L)return!1;this.b.delete(R.id);try{return L.validate(A)==="ok"}catch{return!1}}async sign(R){try{const A=await this.c(),L=new A.signer;if(L)return L.sign(R)}catch{}return R}}e.SignService=D,D.a=1}),define(re[76],ae([0,1,3,2]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class R extends i.Disposable{constructor(b,w,y){super(),this.a=b,this.b=w,this.c=y}async getItems(){const b={profile:this.b,workspace:this.c},w=await this.a.call("getItems",b);return new Map(w)}updateItems(b){const w={profile:this.b,workspace:this.c};return b.insert&&(w.insert=Array.from(b.insert.entries())),b.delete&&(w.delete=Array.from(b.delete.values())),this.a.call("updateItems",w)}}class A extends R{constructor(b,w){super(b,w,void 0),this.f=this.B(new D.Emitter),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(b=>this.h(b)))}h(b){(Array.isArray(b.changed)||Array.isArray(b.deleted))&&this.f.fire({changed:b.changed?new Map(b.changed):void 0,deleted:b.deleted?new Set(b.deleted):void 0})}}class L extends A{constructor(b){super(b,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=L;class P extends A{constructor(b,w){super(b,w)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=P;class I extends R{constructor(b,w){super(b,void 0,w),this.onDidChangeItemsExternal=D.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=I;class S{constructor(b){this.a=b}isUsed(b){const w={payload:b,profile:void 0,workspace:void 0};return this.a.call("isUsed",w)}}e.StorageClient=S}),define(re[108],ae([0,1,5,36,7,31]),function(_,e,D,i,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function L(S){if(D.platform===2&&/^penguin(\.|$)/i.test(S))return"chromebook"}async function P(S,C,b,w,y,d,g,v,l,m){const u=Object.create(null);u["common.machineId"]=g,u.sessionID=(0,A.generateUuid)()+Date.now(),u.commitHash=y,u.version=d,u["common.platformVersion"]=(C||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,D.PlatformToString)(D.platform),u["common.nodePlatform"]=i.platform,u["common.nodeArch"]=w,u["common.product"]=m||"desktop",v&&(u["common.msftInternal"]=v);let h=0;const f=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-f,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),D.isLinuxSnap&&(u["common.snap"]="true");const n=L(b);n&&(u["common.platformDetail"]=n);try{const s=await S.readFile(R.URI.file(l));u["common.source"]=s.value.toString().slice(0,30)}catch{}return u}e.resolveCommonProperties=P;function I(S){const C=i.env.USERDNSDOMAIN;if(!C)return!1;const b=C.toLowerCase();return S.some(w=>b===w)}e.verifyMicrosoftInternalDomain=I}),define(re[22],ae([0,1,4]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,D.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var i;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(i=e.TelemetryLevel||(e.TelemetryLevel={}));var R;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(R=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(re[234],ae([0,1,34,6,35,24,12,5,7,143,28,145,95,13,25,22]),function(_,e,D,i,R,A,L,P,I,S,C,b,w,y,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const v=new Map;async function l(n,s){const t=`${n}::${s.join(":")}`,a=v.get(t);if(a)return a;const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],c=new Map,o=new Map,p=2e4;function E(F,N,q,j){const O=N.substring(F.length+1);return i.Promises.withAsyncBody(async U=>{let $;try{$=await C.Promises.readdir(N,{withFileTypes:!0})}catch{U();return}if(j.count>=p){j.count+=$.length,j.maxReached=!0,U();return}let G=$.length;if(G===0){U();return}let H=$;j.count+$.length>p&&(j.maxReached=!0,G=p-j.count,H=$.slice(0,G)),j.count+=$.length;for(const Z of H)if(Z.isDirectory()){if(q.includes(Z.name)||await E(F,(0,L.join)(N,Z.name),q,j),--G===0){U();return}}else{const z=Z.name.lastIndexOf(".");if(z>=0){const B=Z.name.substring(z+1);B&&c.set(B,(c.get(B)??0)+1)}for(const B of r)B.relativePathPattern?.test(O)!==!1&&B.filePattern.test(Z.name)&&o.set(B.tag,(o.get(B.tag)??0)+1);if(--G===0){U();return}}})}const k=i.Promises.withAsyncBody(async F=>{const N={count:0,maxReached:!1};await E(n,n,s,N);const q=await h(n);F({configFiles:m(o),fileTypes:m(c),fileCount:N.count,maxFilesReached:N.maxReached,launchConfigFiles:q})});return v.set(t,k),k}e.collectWorkspaceStats=l;function m(n){return Array.from(n.entries(),([s,t])=>({name:s,count:t})).sort((s,t)=>t.count-s.count)}function u(){const n={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/y.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/y.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(S.virtualMachineHint.value()*100)}%`},s=D.cpus();return s&&s.length>0&&(n.cpus=`${s[0].model} (${s.length} x ${s[0].speed})`),n}e.getMachineInfo=u;async function h(n){try{const s=new Map,t=(0,L.join)(n,".vscode","launch.json"),a=await C.Promises.readFile(t),r=[],c=(0,R.parse)(a.toString(),r);if(r.length)return console.log(`Unable to parse ${t}`),[];if((0,R.getNodeType)(c)==="object"&&c.configurations)for(const o of c.configurations){const p=o.type;p&&(s.has(p)?s.set(p,s.get(p)+1):s.set(p,1))}return m(s)}catch{return[]}}e.collectLaunchConfigs=h;let f=class{constructor(s,t){this.c=s,this.d=t}f(s){const t=[];return t.push(`OS Version:       ${s.os}`),t.push(`CPUs:             ${s.cpus}`),t.push(`Memory (System):  ${s.memory}`),t.push(`VM:               ${s.vmHint}`),t.join(`
`)}g(s){const t=[];t.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),t.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const a=D.cpus();return a&&a.length>0&&t.push(`CPUs:             ${a[0].model} (${a.length} x ${a[0].speed})`),t.push(`Memory (System):  ${(D.totalmem()/y.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/y.ByteSize.GB).toFixed(2)}GB free)`),P.isWindows||t.push(`Load (avg):       ${D.loadavg().map(r=>Math.round(r)).join(", ")}`),t.push(`VM:               ${Math.round(S.virtualMachineHint.value()*100)}%`),t.push(`Screen Reader:    ${s.screenReader?"yes":"no"}`),t.push(`Process Argv:     ${s.mainArguments.join(" ")}`),t.push(`GPU Status:       ${this.j(s.gpuFeatureStatus)}`),t.join(`
`)}async getPerformanceInfo(s,t){return Promise.all([(0,b.listProcesses)(s.mainPID),this.k(s)]).then(async a=>{let[r,c]=a,o=this.m(s,r);return t.forEach(p=>{if((0,w.isRemoteDiagnosticError)(p))o+=`
${p.errorMessage}`,c+=`
${p.errorMessage}`;else if(o+=`

Remote: ${p.hostName}`,p.processes&&(o+=`
${this.m(s,p.processes)}`),p.workspaceMetadata){c+=`
|  Remote: ${p.hostName}`;for(const E of Object.keys(p.workspaceMetadata)){const k=p.workspaceMetadata[E];let F=`${k.fileCount} files`;k.maxFilesReached&&(F=`more than ${F}`),c+=`|    Folder (${E}): ${F}`,c+=this.h(k)}}}),{processInfo:o,workspaceInfo:c}})}async getSystemInfo(s,t){const{memory:a,vmHint:r,os:c,cpus:o}=u(),p={os:c,memory:a,cpus:o,vmHint:r,processArgs:`${s.mainArguments.join(" ")}`,gpuStatus:s.gpuFeatureStatus,screenReader:`${s.screenReader?"yes":"no"}`,remoteData:t};return P.isWindows||(p.load=`${D.loadavg().map(E=>Math.round(E)).join(", ")}`),P.isLinux&&(p.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(p)}async getDiagnostics(s,t){const a=[];return(0,b.listProcesses)(s.mainPID).then(async r=>(a.push(""),a.push(this.g(s)),a.push(""),a.push(this.m(s,r)),s.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(a.push(""),a.push("Workspace Stats: "),a.push(await this.k(s))),t.forEach(c=>{if((0,w.isRemoteDiagnosticError)(c))a.push(`
${c.errorMessage}`);else if(a.push(`

`),a.push(`Remote:           ${c.hostName}`),a.push(this.f(c.machineInfo)),c.processes&&a.push(this.m(s,c.processes)),c.workspaceMetadata)for(const o of Object.keys(c.workspaceMetadata)){const p=c.workspaceMetadata[o];let E=`${p.fileCount} files`;p.maxFilesReached&&(E=`more than ${E}`),a.push(`Folder (${o}): ${E}`),a.push(this.h(p))}}),a.push(""),a.push(""),a.join(`
`)))}h(s){const t=[];let r=0;const c=(k,F)=>{const N=` ${k}(${F})`;r+N.length>60?(t.push(o),o="|                 ",r=o.length):r+=N.length,o+=N};let o="|      File types:";const p=10,E=s.fileTypes.length>p?p:s.fileTypes.length;for(let k=0;k<E;k++){const F=s.fileTypes[k];c(F.name,F.count)}if(t.push(o),s.configFiles.length>=0&&(o="|      Conf files:",r=0,s.configFiles.forEach(k=>{c(k.name,k.count)}),t.push(o)),s.launchConfigFiles.length>0){let k="|      Launch Configs:";s.launchConfigFiles.forEach(F=>{k+=F.count>1?` ${F.name}(${F.count})`:` ${F.name}`}),t.push(k)}return t.join(`
`)}j(s){const t=Math.max(...Object.keys(s).map(a=>a.length));return Object.keys(s).map(a=>`${a}:  ${" ".repeat(t-a.length)}  ${s[a]}`).join(`
                  `)}k(s){const t=[],a=[];return s.windows.forEach(r=>{r.folderURIs.length===0||!!r.remoteAuthority||(t.push(`|  Window (${r.title})`),r.folderURIs.forEach(c=>{const o=I.URI.revive(c);if(o.scheme===A.Schemas.file){const p=o.fsPath;a.push(l(p,["node_modules",".git"]).then(E=>{let k=`${E.fileCount} files`;E.maxFilesReached&&(k=`more than ${k}`),t.push(`|    Folder (${(0,L.basename)(p)}): ${k}`),t.push(this.h(E))}).catch(E=>{t.push(`|      Error: Unable to collect workspace stats for folder ${p} (${E.toString()})`)}))}else t.push(`|    Folder (${o.toString()}): Workspace stats not available.`)}))}),Promise.all(a).then(r=>t.join(`
`)).catch(r=>`Unable to collect workspace stats: ${r}`)}m(s,t){const a=new Map;s.windows.forEach(c=>a.set(c.pid,c.title));const r=[];return r.push("CPU %	Mem MB	   PID	Process"),t&&this.n(s.mainPID,a,r,t,0),r.join(`
`)}n(s,t,a,r,c){const o=c===0;let p;o?p=r.pid===s?`${this.d.applicationName} main`:"remote agent":(p=`${"  ".repeat(c)} ${r.name}`,r.name==="window"&&(p=`${p} (${t.get(r.pid)})`));const E=process.platform==="win32"?r.mem:D.totalmem()*(r.mem/100);a.push(`${r.load.toFixed(0).padStart(5," ")}	${(E/y.ByteSize.MB).toFixed(0).padStart(6," ")}	${r.pid.toFixed(0).padStart(6," ")}	${p}`),Array.isArray(r.children)&&r.children.forEach(k=>this.n(s,t,a,k,c+1))}async getWorkspaceFileExtensions(s){const t=new Set;for(const{uri:a}of s.folders){const r=I.URI.revive(a);if(r.scheme!==A.Schemas.file)continue;const c=r.fsPath;try{(await l(c,["node_modules",".git"])).fileTypes.forEach(p=>t.add(p.name))}catch{}}return{extensions:[...t]}}async reportWorkspaceStats(s){for(const{uri:t}of s.folders){const a=I.URI.revive(t);if(a.scheme!==A.Schemas.file)continue;const r=a.fsPath;try{const c=await l(r,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":s.telemetryId,rendererSessionId:s.rendererSessionId}),c.fileTypes.forEach(o=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:s.rendererSessionId,type:o.name,count:o.count})}),c.launchConfigFiles.forEach(o=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:s.rendererSessionId,type:o.name,count:o.count})}),c.configFiles.forEach(o=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:s.rendererSessionId,type:o.name,count:o.count})})}catch{}}}};f=ye([K(0,g.ITelemetryService),K(1,d.IProductService)],f),e.DiagnosticsService=f}),define(re[235],ae([0,1,105,3,22,14,2,8,12,49,25,5,6,101,16,167,34,7]),function(_,e,D,i,R,A,L,P,I,S,C,b,w,y,d,g,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTunnelService=void 0;let m=class extends L.Disposable{constructor(h,f,n,s,t,a){super(),this.p=h,this.r=f,this.s=n,this.t=a,this.b=new i.Emitter,this.onDidTokenFailed=this.b.event,this.c=new i.Emitter,this.onDidChangeTunnelStatus=this.c.event,this.f=new i.Emitter,this.onDidChangeAccount=this.f.event,this.j=D.TunnelStates.disconnected;const r=l.URI.file((0,I.join)(n.logsPath,D.LOG_FILE_NAME));this.g=this.B(s.createLogger(r,{name:D.LOGGER_NAME})),this.k=new w.Delayer(100),this.B(this.g.onDidChangeLogLevel(c=>this.g.info("Log level changed to "+(0,P.LogLevelToString)(c)))),this.B(t.onWillShutdown(c=>{this.i&&(this.i.cancel(),this.i=void 0),this.dispose()})),this.B(a.onDidChangeConfiguration(c=>{c.affectsConfiguration(D.CONFIGURATION_KEY_HOST_NAME)&&this.k.trigger(()=>this.v())}))}async getAccount(){return this.h}async updateAccount(h){if(h&&this.h?h.token!==this.h.token||h.providerId!==this.h.providerId:h!==this.h){this.h=h,this.f.fire(h),h?this.g.info(`Account updated: ${h.accountLabel} (${h.providerId})`):this.g.info("Account reset"),this.p.publicLog2("remoteTunnel.enablement",{enabled:!!h});try{await this.k.trigger(()=>this.v())}catch(f){this.g.error(f)}}return this.j}u(){if(!this.n){let h;b.isMacintosh?h=this.s.appRoot:h=(0,I.dirname)((0,I.dirname)(this.s.appRoot)),this.n=(0,I.join)(h,"bin",`${this.r.tunnelApplicationName}${b.isWindows?".exe":""}`)}return this.n}async v(){if(this.i&&(this.i.cancel(),this.i=void 0),!this.h){this.w(D.TunnelStates.disconnected);return}const{token:h,providerId:f,accountLabel:n}=this.h;this.w(D.TunnelStates.connecting((0,g.localize)(0,null,n,f)));const s=(o,p)=>{o=o.replaceAll(h,"*".repeat(4)),p?this.g.error(o):this.g.info(o),!this.s.isBuilt&&o.startsWith("   Compiling")&&this.w(D.TunnelStates.connecting((0,g.localize)(1,null)))},t=this.y("login",["user","login","--provider",f,"--access-token",h,"--log",(0,P.LogLevelToString)(this.g.getLevel())],s);this.i=t;try{if(await t,this.i!==t)return}catch(o){this.g.error(o),this.i=void 0,this.b.fire(!0),this.w(D.TunnelStates.disconnected);return}const a=this.z();a?this.w(D.TunnelStates.connecting((0,g.localize)(2,null,a))):this.w(D.TunnelStates.connecting((0,g.localize)(3,null)));const r=["--parent-process-id",String(process.pid),"--accept-server-license-terms","--log",(0,P.LogLevelToString)(this.g.getLevel())];a?r.push("--name",a):r.push("--random-name");const c=this.y("tunnel",r,(o,p)=>{p?this.g.error(o):this.g.info(o);const E=o.match(/^\s*Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(E){const k={link:E[1],domain:E[2],hostName:E[4]};this.w(D.TunnelStates.connected(k))}else o.match(/error refreshing token/)&&(c.cancel(),this.b.fire(!0),this.w(D.TunnelStates.disconnected))});this.i=c,c.finally(()=>{c===this.i&&(this.g.info("tunnel process terminated"),this.i=void 0,this.h=void 0,this.w(D.TunnelStates.disconnected))})}async getTunnelStatus(){return this.j}w(h){this.j=h,this.c.fire(h)}y(h,f,n=()=>{}){return(0,w.createCancelablePromise)(s=>new Promise((t,a)=>{s.isCancellationRequested&&t();let r;if(s.onCancellationRequested(()=>{r&&(this.g.info(`${h} terminating(${r.pid})`),r.kill())}),!this.s.isBuilt)n("Building tunnel CLI from sources and run",!1),n(`${h} Spawning: cargo run -- tunnel ${f.join(" ")}`,!1),r=(0,S.spawn)("cargo",["run","--","tunnel",...f],{cwd:(0,I.join)(this.s.appRoot,"cli")});else{n("Running tunnel CLI",!1);const c=this.u();n(`${h} Spawning: ${c} tunnel ${f.join(" ")}`,!1),r=(0,S.spawn)(c,["tunnel",...f],{cwd:(0,v.homedir)()})}r.stdout.on("data",c=>{if(r){const o=c.toString();n(o,!1)}}),r.stderr.on("data",c=>{if(r){const o=c.toString();n(o,!0)}}),r.on("exit",c=>{r&&(n(`${h} exit(${r.pid}): + ${c} `,!1),r=void 0,c===0?t():a())}),r.on("error",c=>{r&&(n(`${h} error(${r.pid}): + ${c} `,!0),r=void 0,a())})}))}async getHostName(){return this.z()}z(){let h=this.t.getValue(D.CONFIGURATION_KEY_HOST_NAME)||(0,v.hostname)();return h=h.replace(/[^\w-]/g,"").substring(0,20),h||void 0}};m=ye([K(0,R.ITelemetryService),K(1,C.IProductService),K(2,A.INativeEnvironmentService),K(3,P.ILoggerService),K(4,y.ISharedProcessLifecycleService),K(5,d.IConfigurationService)],m),e.RemoteTunnelService=m}),define(re[109],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class D{constructor(A){this.b=A}listen(A,L){throw new Error(`Event not found: ${L}`)}call(A,L,{eventName:P,data:I}){return this.b.forEach(S=>S.log(P,I)),Promise.resolve(null)}}e.TelemetryAppenderChannel=D;class i{constructor(A){this.b=A}log(A,L){return this.b.call("log",{eventName:A,data:L}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=i}),define(re[50],ae([0,1,32,15,16,75,108,22]),function(_,e,D,i,R,A,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TrustedTelemetryValue=void 0;class I{constructor(c){this.value=c}}e.TrustedTelemetryValue=I;class S{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(c,o){return Promise.resolve(void 0)}publicLog2(c,o){return this.publicLog(c,o)}publicLogError(c,o){return Promise.resolve(void 0)}publicLogError2(c,o){return this.publicLogError(c,o)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=S,e.NullTelemetryService=new S;class C{async publicLog(c,o,p){}async publicLogError(c,o,p){}}e.NullEndpointTelemetryService=C,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function b(r,c){return c.onDidChangeConfiguration(o=>{o.source!==7&&r.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(o.source),configurationKeys:u(o.sourceConfig)})})}e.configurationTelemetry=b;function w(r,c){return!c.isBuilt&&!c.disableTelemetry?!0:!(c.disableTelemetry||!r.enableTelemetry||c.extensionTestsLocationURI)}e.supportsTelemetry=w;function y(r,c){return!(c.isBuilt||c.disableTelemetry||r.enableTelemetry&&r.aiConfig?.ariaKey)}e.isLoggingOnly=y;function d(r){const c=r.getValue(P.TELEMETRY_SETTING_ID),o=r.getValue("telemetry.enableCrashReporter");if(r.getValue(P.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(c??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=d;function g(r){const c={},o={},p={};m(r,p);for(let E in p){E=E.length>150?E.substr(E.length-149):E;const k=p[E];typeof k=="number"?o[E]=k:typeof k=="boolean"?o[E]=k?1:0:typeof k=="string"?(k.length>8192&&console.warn(`Telemetry property: ${E} has been trimmed to 8192, the original length is ${k.length}`),c[E]=k.substring(0,8191)):typeof k<"u"&&k!==null&&(c[E]=k)}return{properties:c,measurements:o}}e.validateTelemetryData=g;const v=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function l(r){if(!r)return"none";const c=(0,A.getRemoteName)(r);return v.has(c)?c:"other"}e.cleanRemoteAuthority=l;function m(r,c,o=0,p){if(!!r)for(const E of Object.getOwnPropertyNames(r)){const k=r[E],F=p?p+E:E;Array.isArray(k)?c[F]=(0,D.safeStringify)(k):k instanceof Date?c[F]=k.toISOString():(0,i.isObject)(k)?o<2?m(k,c,o+1,F+"."):c[F]=(0,D.safeStringify)(k):c[F]=k}}function u(r){if(!r)return[];const c=[];return h(c,"",r),c}function h(r,c,o){o&&typeof o=="object"&&!Array.isArray(o)?Object.keys(o).forEach(p=>h(r,c?`${c}.${p}`:p,o[p])):r.push(c)}function f(r,c){const o=r.msftInternalDomains||[],p=c.getValue("telemetry.internalTesting");return(0,L.verifyMicrosoftInternalDomain)(o)||p}e.isInternalTelemetry=f;function n(r){return[r.appRoot,r.extensionsPath,r.userHome.fsPath,r.tmpDir.fsPath,r.userDataPath]}e.getPiiPathsFromEnvironment=n;function s(r,c){if(!r||!r.includes("/")&&!r.includes("\\"))return r;let o=r;const p=[];for(const N of c)for(;;){const q=N.exec(r);if(!q)break;p.push([q.index,N.lastIndex])}const E=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,k=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let F=0;for(o="";;){const N=k.exec(r);if(!N)break;const q=p.some(([j,O])=>N.index<O&&j<k.lastIndex);!E.test(N[0])&&!q&&(o+=r.substring(F,N.index)+"<REDACTED: user-file-path>",F=k.lastIndex)}return F<r.length&&(o+=r.substr(F)),o}function t(r){if(!r)return r;const c=r.toLowerCase(),o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const p of o)if(p.regex.test(c))return`<REDACTED: ${p.label}>`;return r}function a(r,c){return(0,D.cloneAndChange)(r,o=>{if(o instanceof I)return o.value;if(typeof o=="string"){let p=o.replaceAll("%20"," ");p=s(p,c);for(const E of c)p=p.replace(E,"");return p=t(p),p}})}e.cleanData=a}),define(re[236],ae([0,1,45,50]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function R(A,L,P,I,S,C,b){const w={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${L.nameShort})`};if((0,i.supportsTelemetry)(L,P)&&(0,i.getTelemetryLevel)(I)===3){const y=await(0,D.getServiceMachineId)(P,S,C),{machineId:d}=await b.getTelemetryInfo();w["X-Market-User-Id"]=y,w["VSCode-SessionId"]=d||y}return w}e.resolveMarketplaceHeaders=R}),define(re[237],ae([0,1,9,32,50]),function(_,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const A="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function L(I,S,C){const b=await new Promise((v,l)=>{_(["@microsoft/1ds-core-js"],v,l)}),w=await new Promise((v,l)=>{_(["@microsoft/1ds-post-js"],v,l)}),y=new b.AppInsightsCore,d=new w.PostChannel,g={instrumentationKey:I,endpointUrl:A,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[d]]};if(C){g.extensionConfig={};const v={alwaysUseXhrOverride:!0,httpXHROverride:C};g.extensionConfig[d.identifier]=v}return y.initialize(g,[]),y.addTelemetryInitializer(v=>{S&&(v.ext=v.ext??{},v.ext.utc=v.ext.utc??{},v.ext.utc.flags=8462029)}),y}class P{constructor(S,C,b,w,y){this.d=S,this.e=C,this.f=b,this.g=y,this.c=A,this.f||(this.f={}),typeof w=="function"?this.a=w():this.a=w,this.b=null}h(S){if(!!this.a){if(typeof this.a!="string"){S(this.a);return}this.b||(this.b=L(this.a,this.d,this.g)),this.b.then(C=>{S(C)},C=>{(0,D.onUnexpectedError)(C),console.error(C)})}}log(S,C){if(!this.a)return;C=(0,i.mixin)(C,this.f),C=(0,R.validateTelemetryData)(C);const b=this.e+"/"+S;try{this.h(w=>{w.pluginVersionString=C?.properties.version??"Unknown",w.track({name:b,baseData:{name:b,properties:C?.properties,measurements:C?.measurements}})})}catch{}}flush(){return this.a?new Promise(S=>{this.h(C=>{C.unload(!0,()=>{this.a=void 0,S(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=P}),define(re[110],ae([0,1,2,14,8,50]),function(_,e,D,i,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let L=class extends D.Disposable{constructor(I,S,C=""){super(),this.b=C;const b=I.getLogger(S.telemetryLogResource);b?this.a=this.B(b):(this.a=this.B(I.createLogger(S.telemetryLogResource)),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(I,S){this.a.trace(`${this.b}telemetry/${I}`,(0,A.validateTelemetryData)(S))}};L=ye([K(0,R.ILoggerService),K(1,i.IEnvironmentService)],L),e.TelemetryLogAppender=L}),define(re[111],ae([0,1,2,32,5,27,170,16,46,103,25,40,22,50]),function(_,e,D,i,R,A,L,P,I,S,C,b,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let d=class{constructor(l,m,u){this.k=m,this.l=u,this.d={},this.i=new D.DisposableStore,this.j=[],this.b=l.appenders,this.c=l.commonProperties||Promise.resolve({}),this.f=l.piiPaths||[],this.g=3,this.h=!!l.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const h of this.f)this.j.push(new RegExp((0,A.escapeRegExpCharacters)(h),"gi")),h.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.escapeRegExpCharacters)(h.replace(/\\/g,"/")),"gi"));this.m(),this.k.onDidChangeConfiguration(this.m,this,this.i)}setExperimentProperty(l,m){this.d[l]=m}m(){let l=(0,y.getTelemetryLevel)(this.k);const m=this.l.enabledTelemetryLevels;if(m){this.h=this.sendErrorTelemetry?m.error:!1;const u=m.usage?3:m.error?2:0;l=Math.min(l,u)}this.g=l}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const l=await this.c,m=l.sessionID,u=l["common.machineId"],h=l["common.firstSessionDate"],f=l["common.msftInternal"];return{sessionId:m,machineId:u,firstSessionDate:h,msftInternal:f}}dispose(){this.i.dispose()}n(l,m,u){return this.g<m?Promise.resolve(void 0):this.c.then(h=>{u=(0,i.mixin)(u,this.d),u=(0,y.cleanData)(u,this.j),u=(0,i.mixin)(u,h),this.b.forEach(f=>f.log(l,u))},h=>{console.error(h)})}publicLog(l,m){return this.n(l,3,m)}publicLog2(l,m){return this.publicLog(l,m)}publicLogError(l,m){return this.h?this.n(l,2,m):Promise.resolve(void 0)}publicLogError2(l,m){return this.publicLogError(l,m)}};d.IDLE_START_EVENT_NAME="UserIdleStart",d.IDLE_STOP_EVENT_NAME="UserIdleStop",d=ye([K(1,P.IConfigurationService),K(2,C.IProductService)],d),e.TelemetryService=d;function g(){const v=(0,L.localize)(0,null,S.default.nameLong),l=S.default.privacyStatementUrl?(0,L.localize)(2,null,"https://aka.ms/vscode-telemetry",S.default.privacyStatementUrl):(0,L.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=R.isWeb?"":(0,L.localize)(3,null),u=(0,L.localize)(4,null),h=(0,L.localize)(5,null),f=(0,L.localize)(6,null),n=(0,L.localize)(7,null),s=`
|       | ${u} | ${h} | ${f} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,L.localize)(8,null);return`
${v} ${l} ${m}

&nbsp;

${n}
${s}

&nbsp;

${t}
`}b.Registry.as(I.Extensions.Configuration).registerConfiguration({id:w.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,L.localize)(9,null),properties:{[w.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,L.localize)(10,null),(0,L.localize)(11,null),(0,L.localize)(12,null),(0,L.localize)(13,null)],markdownDescription:g(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),b.Registry.as(I.Extensions.Configuration).registerConfiguration({id:w.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,L.localize)(14,null),properties:{[w.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:S.default.privacyStatementUrl?(0,L.localize)(16,null,S.default.nameLong,S.default.privacyStatementUrl):(0,L.localize)(15,null,S.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,L.localize)(17,null,`\`#${w.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(re[238],ae([0,1,287,237]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class R extends i.AbstractOneDataSystemAppender{constructor(L,P,I,S){const C={sendPOST:(b,w)=>{const y={method:"POST",headers:{...b.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(b.data)}};try{const d=D.request(b.urlString,y,g=>{g.on("data",function(v){w(g.statusCode??200,g.headers,v.toString())}),g.on("error",function(v){w(0,{})})});d.write(b.data),d.end()}catch{w(0,{})}}};super(L,P,I,S,C)}}e.OneDataSystemAppender=R}),define(re[239],ae([0,1,24,68,16,14,8,25,22,109,110,111]),function(_,e,D,i,R,A,L,P,I,S,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let w=class{constructor(d,g,v,l,m){this.b=d,this.c=g,this.d=v,this.e=l,this.f=m,this.a=new Map}async g(d){if(!this.a.has(d.id)){const{machineId:g,sessionId:v}=await this.c.getTelemetryInfo(),l=Object.create(null);l["common.vscodemachineid"]=g,l["common.vscodesessionid"]=v;const m=[d.id,JSON.stringify(l),d.aiKey],h=new i.Client(D.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:m,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),f=[new S.TelemetryAppenderClient(h),new C.TelemetryLogAppender(this.d,this.e,`[${d.id}] `)];this.a.set(d.id,new b.TelemetryService({appenders:f,sendErrorTelemetry:d.sendErrorTelemetry},this.b,this.f))}return this.a.get(d.id)}async publicLog(d,g,v){await(await this.g(d)).publicLog(g,v)}async publicLogError(d,g,v){await(await this.g(d)).publicLogError(g,v)}};w=ye([K(0,R.IConfigurationService),K(1,I.ITelemetryService),K(2,L.ILoggerService),K(3,A.IEnvironmentService),K(4,P.IProductService)],w),e.CustomEndpointTelemetryService=w}),define(re[240],ae([0,1,6,23,3,2,8]),function(_,e,D,i,R,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends A.Disposable{constructor(S,C){super(),this.h=C,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new R.Emitter),this.onCreateRequest=this.g.event,this.b=S===void 0?15e3:S}createRequest(S){return new Promise((C,b)=>{const w=++this.a;this.c.set(w,C),this.g.fire({requestId:w,...S});const y=new i.CancellationTokenSource;(0,D.timeout)(this.b,y.token).then(()=>b(`Request ${w} timed out (${this.b}ms)`)),this.f.set(w,[(0,A.toDisposable)(()=>y.cancel())])})}acceptReply(S,C){const b=this.c.get(S);b?(this.c.delete(S),(0,A.dispose)(this.f.get(S)||[]),this.f.delete(S),b(C)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${S}`)}};P=ye([K(1,L.ILogService)],P),e.RequestStore=P}),define(re[112],ae([0,1,4]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var i;(function(u){u.Shell="terminal.integrated.shell.",u.ShellArgs="terminal.integrated.shellArgs.",u.DefaultProfile="terminal.integrated.defaultProfile.",u.Profiles="terminal.integrated.profiles."})(i=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var R;(function(u){u.ShellLinux="terminal.integrated.shell.linux",u.ShellMacOs="terminal.integrated.shell.osx",u.ShellWindows="terminal.integrated.shell.windows",u.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",u.AutomationShellLinux="terminal.integrated.automationShell.linux",u.AutomationShellMacOs="terminal.integrated.automationShell.osx",u.AutomationShellWindows="terminal.integrated.automationShell.windows",u.AutomationProfileLinux="terminal.integrated.automationProfile.linux",u.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",u.AutomationProfileWindows="terminal.integrated.automationProfile.windows",u.ShellArgsLinux="terminal.integrated.shellArgs.linux",u.ShellArgsMacOs="terminal.integrated.shellArgs.osx",u.ShellArgsWindows="terminal.integrated.shellArgs.windows",u.ProfilesWindows="terminal.integrated.profiles.windows",u.ProfilesMacOs="terminal.integrated.profiles.osx",u.ProfilesLinux="terminal.integrated.profiles.linux",u.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",u.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",u.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",u.UseWslProfiles="terminal.integrated.useWslProfiles",u.TabsDefaultColor="terminal.integrated.tabs.defaultColor",u.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",u.TabsEnabled="terminal.integrated.tabs.enabled",u.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",u.TabsHideCondition="terminal.integrated.tabs.hideCondition",u.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",u.TabsShowActions="terminal.integrated.tabs.showActions",u.TabsLocation="terminal.integrated.tabs.location",u.TabsFocusMode="terminal.integrated.tabs.focusMode",u.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",u.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",u.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",u.CopyOnSelection="terminal.integrated.copyOnSelection",u.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",u.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",u.FontFamily="terminal.integrated.fontFamily",u.FontSize="terminal.integrated.fontSize",u.LetterSpacing="terminal.integrated.letterSpacing",u.LineHeight="terminal.integrated.lineHeight",u.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",u.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",u.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",u.BellDuration="terminal.integrated.bellDuration",u.FontWeight="terminal.integrated.fontWeight",u.FontWeightBold="terminal.integrated.fontWeightBold",u.CursorBlinking="terminal.integrated.cursorBlinking",u.CursorStyle="terminal.integrated.cursorStyle",u.CursorWidth="terminal.integrated.cursorWidth",u.Scrollback="terminal.integrated.scrollback",u.DetectLocale="terminal.integrated.detectLocale",u.DefaultLocation="terminal.integrated.defaultLocation",u.GpuAcceleration="terminal.integrated.gpuAcceleration",u.TerminalTitleSeparator="terminal.integrated.tabs.separator",u.TerminalTitle="terminal.integrated.tabs.title",u.TerminalDescription="terminal.integrated.tabs.description",u.RightClickBehavior="terminal.integrated.rightClickBehavior",u.Cwd="terminal.integrated.cwd",u.ConfirmOnExit="terminal.integrated.confirmOnExit",u.ConfirmOnKill="terminal.integrated.confirmOnKill",u.EnableBell="terminal.integrated.enableBell",u.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",u.AllowChords="terminal.integrated.allowChords",u.AllowMnemonics="terminal.integrated.allowMnemonics",u.EnvMacOs="terminal.integrated.env.osx",u.EnvLinux="terminal.integrated.env.linux",u.EnvWindows="terminal.integrated.env.windows",u.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",u.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",u.ShowExitAlert="terminal.integrated.showExitAlert",u.SplitCwd="terminal.integrated.splitCwd",u.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",u.WordSeparators="terminal.integrated.wordSeparators",u.EnableFileLinks="terminal.integrated.enableFileLinks",u.UnicodeVersion="terminal.integrated.unicodeVersion",u.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",u.LocalEchoEnabled="terminal.integrated.localEchoEnabled",u.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",u.LocalEchoStyle="terminal.integrated.localEchoStyle",u.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",u.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",u.CustomGlyphs="terminal.integrated.customGlyphs",u.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",u.InheritEnv="terminal.integrated.inheritEnv",u.ShowLinkHover="terminal.integrated.showLinkHover",u.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",u.AutoReplies="terminal.integrated.autoReplies",u.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",u.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",u.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",u.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",u.SmoothScrolling="terminal.integrated.smoothScrolling"})(R=e.TerminalSettingId||(e.TerminalSettingId={}));var A;(function(u){u.FileName="ptyhost"})(A=e.TerminalLogConstants||(e.TerminalLogConstants={}));var L;(function(u){u.PowerShell="pwsh",u.Bash="bash",u.Fish="fish",u.Sh="sh",u.Csh="csh",u.Ksh="ksh",u.Zsh="zsh"})(L=e.PosixShellType||(e.PosixShellType={}));var P;(function(u){u.CommandPrompt="cmd",u.PowerShell="pwsh",u.Wsl="wsl",u.GitBash="gitbash"})(P=e.WindowsShellType||(e.WindowsShellType={}));var I;(function(u){u[u.Api=0]="Api",u[u.Process=1]="Process",u[u.Sequence=2]="Sequence",u[u.Config=3]="Config"})(I=e.TitleEventSource||(e.TitleEventSource={}));var S;(function(u){u.LocalPty="localPty",u.PtyHost="ptyHost",u.Log="log",u.Heartbeat="heartbeat"})(S=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,D.createDecorator)("ptyService");var C;(function(u){u.Cwd="cwd",u.InitialCwd="initialCwd",u.FixedDimensions="fixedDimensions",u.Title="title",u.ShellType="shellType",u.HasChildProcesses="hasChildProcesses",u.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",u.OverrideDimensions="overrideDimensions",u.FailedShellIntegrationActivation="failedShellIntegrationActivation",u.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(C=e.ProcessPropertyType||(e.ProcessPropertyType={}));var b;(function(u){u[u.BeatInterval=5e3]="BeatInterval",u[u.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",u[u.SecondWaitMultiplier=1]="SecondWaitMultiplier",u[u.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(b=e.HeartbeatConstants||(e.HeartbeatConstants={}));var w;(function(u){u[u.Panel=1]="Panel",u[u.Editor=2]="Editor"})(w=e.TerminalLocation||(e.TerminalLocation={}));var y;(function(u){u.TerminalView="view",u.Editor="editor"})(y=e.TerminalLocationString||(e.TerminalLocationString={}));var d;(function(u){u[u.GraceTime=6e4]="GraceTime",u[u.ShortGraceTime=6e3]="ShortGraceTime"})(d=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var g;(function(u){u[u.HighWatermarkChars=1e5]="HighWatermarkChars",u[u.LowWatermarkChars=5e3]="LowWatermarkChars",u[u.CharCountAckSize=5e3]="CharCountAckSize"})(g=e.FlowControlConstants||(e.FlowControlConstants={}));var v;(function(u){u.GitBash="Git Bash",u.Pwsh="PowerShell"})(v=e.ProfileSource||(e.ProfileSource={}));var l;(function(u){u[u.Off=0]="Off",u[u.FinalTerm=1]="FinalTerm",u[u.VSCode=2]="VSCode"})(l=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var m;(function(u){u[u.Unknown=0]="Unknown",u[u.Shutdown=1]="Shutdown",u[u.Process=2]="Process",u[u.User=3]="User",u[u.Extension=4]="Extension"})(m=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(re[241],ae([0,1,4]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,D.createDecorator)("localPtyService")}),define(re[242],ae([0,1,34,24,32,12,5,36,27,15,28]),function(_,e,D,i,R,A,L,P,I,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shellIntegrationArgs=e.ShellIntegrationExecutable=e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function b(){const h=/(\d+)\.(\d+)\.(\d+)/g.exec(D.release());let f=0;return h&&h.length===4&&(f=parseInt(h[3])),f}e.getWindowsBuildNumber=b;async function w(h,f,n,s=P.env,t=C.Promises.exists){if(A.isAbsolute(h))return await t(h)?h:void 0;if(f===void 0&&(f=P.cwd()),A.dirname(h)!=="."){const o=A.join(f,h);return await t(o)?o:void 0}const r=(0,R.getCaseInsensitive)(s,"PATH");if(n===void 0&&(0,S.isString)(r)&&(n=r.split(A.delimiter)),n===void 0||n.length===0){const o=A.join(f,h);return await t(o)?o:void 0}for(const o of n){let p;if(A.isAbsolute(o)?p=A.join(o,h):p=A.join(f,o,h),await t(p))return p;if(L.isWindows){let E=p+".com";if(await t(E)||(E=p+".exe",await t(E)))return E}}const c=A.join(f,h);return await t(c)?c:void 0}e.findExecutable=w;function y(h,f,n,s,t){if(!f.shellIntegration.enabled||!h.executable||h.isFeatureTerminal||h.hideFromUser||h.ignoreShellIntegration||L.isWindows&&!f.windowsEnableConpty)return;const a=h.args,r=P.platform==="win32"?A.basename(h.executable).toLowerCase():A.basename(h.executable),c=A.dirname(i.FileAccess.asFileUri("").fsPath);let o;const p={VSCODE_INJECTION:"1"};if(L.isWindows){if(r==="pwsh.exe"||r==="powershell.exe")return!a||m(a)?o=e.shellIntegrationArgs.get(d.WindowsPwsh):l(a)&&(o=e.shellIntegrationArgs.get(d.WindowsPwshLogin)),o?(o=[...o],o[o.length-1]=(0,I.format)(o[o.length-1],c,""),{newArgs:o,envMixin:p}):void 0;s.warn(`Shell integration cannot be enabled for executable "${h.executable}" and args`,h.args);return}switch(r){case"bash":return!a||a.length===0?o=e.shellIntegrationArgs.get(d.Bash):u(a)&&(p.VSCODE_SHELL_LOGIN="1",o=e.shellIntegrationArgs.get(d.Bash)),o?(o=[...o],o[o.length-1]=(0,I.format)(o[o.length-1],c),{newArgs:o,envMixin:p}):void 0;case"pwsh":return!a||m(a)?o=e.shellIntegrationArgs.get(d.Pwsh):l(a)&&(o=e.shellIntegrationArgs.get(d.PwshLogin)),o?(o=[...o],o[o.length-1]=(0,I.format)(o[o.length-1],c,""),{newArgs:o,envMixin:p}):void 0;case"zsh":{if(!a||a.length===0?o=e.shellIntegrationArgs.get(d.Zsh):u(a)?o=e.shellIntegrationArgs.get(d.ZshLogin):(a===e.shellIntegrationArgs.get(d.Zsh)||a===e.shellIntegrationArgs.get(d.ZshLogin))&&(o=a),!o)return;o=[...o],o[o.length-1]=(0,I.format)(o[o.length-1],c);const E=A.join(D.tmpdir(),`${D.userInfo().username}-${t.applicationName}-zsh`);p.ZDOTDIR=E;const k=n?.ZDOTDIR??D.homedir()??"~";p.USER_ZDOTDIR=k;const F=[];return F.push({source:A.join(c,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:A.join(E,".zshrc")}),F.push({source:A.join(c,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:A.join(E,".zprofile")}),F.push({source:A.join(c,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:A.join(E,".zshenv")}),F.push({source:A.join(c,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:A.join(E,".zlogin")}),{newArgs:o,envMixin:p,filesToCopy:F}}}s.warn(`Shell integration cannot be enabled for executable "${h.executable}" and args`,h.args)}e.getShellIntegrationInjection=y;var d;(function(h){h.WindowsPwsh="windows-pwsh",h.WindowsPwshLogin="windows-pwsh-login",h.Pwsh="pwsh",h.PwshLogin="pwsh-login",h.Zsh="zsh",h.ZshLogin="zsh-login",h.Bash="bash"})(d=e.ShellIntegrationExecutable||(e.ShellIntegrationExecutable={})),e.shellIntegrationArgs=new Map,e.shellIntegrationArgs.set(d.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(d.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(d.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(d.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),e.shellIntegrationArgs.set(d.Zsh,["-i"]),e.shellIntegrationArgs.set(d.ZshLogin,["-il"]),e.shellIntegrationArgs.set(d.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const g=["-login","-l"],v=["-nol","-nologo"];function l(h){return typeof h=="string"?g.includes(h.toLowerCase()):h.length===1&&g.includes(h[0].toLowerCase())||h.length===2&&(g.includes(h[0].toLowerCase())||g.includes(h[1].toLowerCase()))&&(v.includes(h[0].toLowerCase())||v.includes(h[1].toLowerCase()))}function m(h){return typeof h=="string"?v.includes(h.toLowerCase()):h.length===0||h?.length===1&&v.includes(h[0].toLowerCase())}function u(h){return h==="string"&&g.includes(h.toLowerCase())||typeof h!="string"&&h.length===1&&g.includes(h[0].toLowerCase())}}),define(re[243],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var D;(function(A){A.DARK="dark",A.LIGHT="light",A.HIGH_CONTRAST_DARK="hcDark",A.HIGH_CONTRAST_LIGHT="hcLight"})(D=e.ColorScheme||(e.ColorScheme={}));function i(A){return A===D.HIGH_CONTRAST_DARK||A===D.HIGH_CONTRAST_LIGHT}e.isHighContrast=i;function R(A){return A===D.DARK||A===D.HIGH_CONTRAST_DARK}e.isDark=R}),define(re[113],ae([0,1,51,3,2,4,40,243]),function(_,e,D,i,R,A,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,A.createDecorator)("themeService");var I;(function(v){function l(m){return m&&typeof m=="object"&&typeof m.id=="string"}v.isThemeColor=l})(I=e.ThemeColor||(e.ThemeColor={}));function S(v){return{id:v}}e.themeColorFromId=S;var C;(function(v){function l(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color>"u"||I.isThemeColor(a.color))}v.isThemeIcon=l;const m=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function u(a){const r=m.exec(a);if(!r)return;const[,c]=r;return{id:c}}v.fromString=u;function h(a){return{id:a}}v.fromId=h;function f(a,r){let c=a.id;const o=c.lastIndexOf("~");return o!==-1&&(c=c.substring(0,o)),r&&(c=`${c}~${r}`),{id:c}}v.modify=f;function n(a){const r=a.id.lastIndexOf("~");if(r!==-1)return a.id.substring(r+1)}v.getModifier=n;function s(a,r){return a.id===r.id&&a.color?.id===r.color?.id}v.isEqual=s;function t(a,r){return{id:a.id,color:r?S(r):void 0}}v.asThemeIcon=t,v.asClassNameArray=D.CSSIcon.asClassNameArray,v.asClassName=D.CSSIcon.asClassName,v.asCSSSelector=D.CSSIcon.asCSSSelector})(C=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function b(v){switch(v){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case P.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=b,e.Extensions={ThemingContribution:"base.contributions.theming"};class w{constructor(){this.a=[],this.a=[],this.b=new i.Emitter}onColorThemeChange(l){return this.a.push(l),this.b.fire(l),(0,R.toDisposable)(()=>{const m=this.a.indexOf(l);this.a.splice(m,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const y=new w;L.Registry.add(e.Extensions.ThemingContribution,y);function d(v){return y.onColorThemeChange(v)}e.registerThemingParticipant=d;class g extends R.Disposable{constructor(l){super(),this.k=l,this.h=l.getColorTheme(),this.B(this.k.onDidColorThemeChange(m=>this.n(m)))}n(l){this.h=l,this.updateStyles()}updateStyles(){}w(l,m){let u=this.h.getColor(l);return u&&m&&(u=m(u,this.h)),u?u.toString():null}}e.Themable=g}),define(re[244],ae([0,1,51,7,172,113]),function(_,e,D,i,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function L(w,y){const d=[{name:null,description:(0,R.localize)(0,null)}];return d.push(...w.map(g=>({name:g.profileName,description:P(g)}))),y&&d.push(...y.map(g=>({name:g.title,description:I(g)}))),{values:d.map(g=>g.name),markdownDescriptions:d.map(g=>g.description)}}e.createProfileSchemaEnums=L;function P(w){let y=`$(${A.ThemeIcon.isThemeIcon(w.icon)?w.icon.id:w.icon?w.icon:D.Codicon.terminal.id}) ${w.profileName}
- path: ${w.path}`;return w.args&&(typeof w.args=="string"?y+=`
- args: "${w.args}"`:y+=`
- args: [${w.args.length===0?"":`'${w.args.join("','")}'`}]`),w.overrideName!==void 0&&(y+=`
- overrideName: ${w.overrideName}`),w.color&&(y+=`
- color: ${w.color}`),w.env&&(y+=`
- env: ${JSON.stringify(w.env)}`),y}function I(w){return`$(${A.ThemeIcon.isThemeIcon(w.icon)?w.icon.id:w.icon?w.icon:D.Codicon.terminal.id}) ${w.title}
- extensionIdentifier: ${w.extensionIdentifier}`}function S(w,y){if(!w&&!y)return!0;if(typeof w=="string"&&typeof y=="string")return w===y;if(Array.isArray(w)&&Array.isArray(y)){if(w.length!==y.length)return!1;for(let d=0;d<w.length;d++)if(w[d]!==y[d])return!1;return!0}return!1}e.terminalProfileArgsMatch=S;function C(w,y){if(!w&&!y)return!0;if(!w||!y)return!1;if(A.ThemeIcon.isThemeIcon(w)&&A.ThemeIcon.isThemeIcon(y))return w.id===y.id&&w.color===y.color;if(typeof w=="object"&&"light"in w&&"dark"in w&&typeof y=="object"&&"light"in y&&"dark"in y){const d=w,g=y;if((i.URI.isUri(d.light)||b(d.light))&&(i.URI.isUri(d.dark)||b(d.dark))&&(i.URI.isUri(g.light)||b(g.light))&&(i.URI.isUri(g.dark)||b(g.dark)))return d.light.path===g.light.path&&d.dark.path===g.dark.path}if(i.URI.isUri(w)&&i.URI.isUri(y)||b(w)||b(y)){const d=w,g=y;return d.path===g.path&&d.scheme===g.scheme}return!1}e.terminalIconsEqual=C;function b(w){return w?typeof w.path=="string"&&typeof w.scheme=="string":!1}e.isUriComponents=b}),define(re[245],ae([0,1,51,171,46,40,244]),function(_,e,D,i,R,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from(D.Codicon.getAll(),h=>h.id),markdownEnumDescriptions:Array.from(D.Codicon.getAll(),h=>`$(${h.id})`)};const P={args:{description:(0,i.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,i.localize)(1,null),type:"boolean"},icon:{description:(0,i.localize)(2,null),...e.terminalIconSchema},color:{description:(0,i.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,i.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},I={type:"object",required:["path"],properties:{path:{description:(0,i.localize)(5,null),type:["string","array"],items:{type:"string"}},...P}},S={type:"object",required:["path"],properties:{path:{description:(0,i.localize)(6,null),type:["string"],items:{type:"string"}},...P}},C=(0,i.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),b=(0,i.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),w=(0,i.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),y=(0,i.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),d=(0,i.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),g=(0,i.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),v={id:"terminal",order:100,title:(0,i.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:d},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:g},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},S],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},S],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},S],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:C},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:b},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:w},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:C},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:b},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,i.localize)(26,null)}},{type:"string",markdownDescription:(0,i.localize)(27,null)}],default:[],markdownDeprecationMessage:w},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,i.localize)(29,null),enum:["PowerShell","Git Bash"]},...P}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,i.localize)(30,null),type:"string"},id:{description:(0,i.localize)(31,null),type:"string"},title:{description:(0,i.localize)(32,null),type:"string"},...P}},{type:"null"},I]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,i.localize)(34,null),type:"string"},id:{description:(0,i.localize)(35,null),type:"string"},title:{description:(0,i.localize)(36,null),type:"string"},...P}},{type:"null"},I]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,i.localize)(38,null),type:"string"},id:{description:(0,i.localize)(39,null),type:"string"},title:{description:(0,i.localize)(40,null),type:"string"},...P}},{type:"null"},I]}},["terminal.integrated.useWslProfiles"]:{description:(0,i.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,i.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,i.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,i.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,i.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function l(){A.Registry.as(R.Extensions.Configuration).registerConfiguration(v),u()}e.registerTerminalPlatformConfiguration=l;let m;function u(h,f){const n=A.Registry.as(R.Extensions.Configuration);let s;h&&(s=(0,L.createProfileSchemaEnums)(h?.profiles,f));const t=m;m={id:"terminal",order:100,title:(0,i.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:h?.os===3?s?.values:void 0,markdownEnumDescriptions:h?.os===3?s?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:h?.os===2?s?.values:void 0,markdownEnumDescriptions:h?.os===2?s?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:h?.os===1?s?.values:void 0,markdownEnumDescriptions:h?.os===1?s?.markdownDescriptions:void 0}}},n.updateConfigurations({add:[m],remove:t?[t]:[]})}e.registerTerminalDefaultProfileConfiguration=u}),define(re[246],ae([0,1,49,51,12,5,28,90,242,113]),function(_,e,D,i,R,A,L,P,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let C,b=!0;function w(s,t,a,r,c=process.env,o,p,E,k){return o=o||{existsFile:L.SymlinkSupport.existsFile,readFile:L.Promises.readFile},A.isWindows?y(a,o,c,p,r.getValue("terminal.integrated.useWslProfiles")!==!1,s&&typeof s=="object"?{...s}:r.getValue("terminal.integrated.profiles.windows"),typeof t=="string"?t:r.getValue("terminal.integrated.defaultProfile.windows"),k,E):h(o,p,a,s&&typeof s=="object"?{...s}:r.getValue(A.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof t=="string"?t:r.getValue(A.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),k,E,c)}e.detectAvailableProfiles=w;async function y(s,t,a,r,c,o,p,E,k){const F=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),N=`${process.env.windir}\\${F?"Sysnative":"System32"}`;let q=!1;(0,I.getWindowsBuildNumber)()>=16299&&(q=!0),await v(E);const j=new Map;s&&(j.set("PowerShell",{source:"PowerShell",icon:i.Codicon.terminalPowershell,isAutoDetected:!0}),j.set("Windows PowerShell",{path:`${N}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:i.Codicon.terminalPowershell,isAutoDetected:!0}),j.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),j.set("Command Prompt",{path:`${N}\\cmd.exe`,icon:i.Codicon.terminalCmd,isAutoDetected:!0})),f(o,j);const O=await d(j.entries(),p,t,a,r,k);if(s||c)try{const U=await m(`${N}\\${q?"wsl":"bash"}.exe`,p);for(const $ of U)(!o||!($.profileName in o))&&O.push($)}catch{b&&(r?.info("WSL is not installed, so could not detect WSL profiles"),b=!1)}return O}async function d(s,t,a,r=process.env,c,o){const p=[];for(const[E,k]of s){if(k===null)continue;let F,N,q;if("source"in k){const U=C?.get(k.source);if(!U)continue;F=U.paths,N=k.args||U.args,k.icon?q=g(k.icon):U.icon&&(q=U.icon)}else F=Array.isArray(k.path)?k.path:[k.path],N=A.isWindows||Array.isArray(k.args)?k.args:void 0,q=g(k.icon);const j=await o?.(F)||F.slice(),O=await n(E,t,j,a,r,N,k.env,k.overrideName,k.isAutoDetected,c);O?(O.isAutoDetected=k.isAutoDetected,O.icon=q,O.color=k.color,p.push(O)):c?.debug("Terminal profile not validated",E,F)}return c?.debug("Validated terminal profiles",p),p}function g(s){return typeof s=="string"?{id:s}:s}async function v(s){C&&!s||(C=new Map,C.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login","-i"]}),C.set("PowerShell",{profileName:"PowerShell",paths:s||await l(),icon:S.ThemeIcon.asThemeIcon(i.Codicon.terminalPowershell)}))}async function l(){const s=[];for await(const t of(0,P.enumeratePowerShellInstallations)())s.push(t.exePath);return s}async function m(s,t){const a=[],r=await new Promise((p,E)=>{D.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(k,F)=>{if(k)return E("Problem occurred when getting wsl distros");p(F)})});if(!r)return[];const c=new RegExp(/[\r?\n]/),o=r.split(c).filter(p=>p.trim().length>0&&p!=="");for(const p of o){if(p===""||p.startsWith("docker-desktop"))continue;const E=`${p} (WSL)`,k={profileName:E,path:s,args:["-d",`${p}`],isDefault:E===t,icon:u(p),isAutoDetected:!1};a.push(k)}return a}function u(s){return s.includes("Ubuntu")?S.ThemeIcon.asThemeIcon(i.Codicon.terminalUbuntu):s.includes("Debian")?S.ThemeIcon.asThemeIcon(i.Codicon.terminalDebian):S.ThemeIcon.asThemeIcon(i.Codicon.terminalLinux)}async function h(s,t,a,r,c,o,p,E){const k=new Map;if(a){const F=(await s.readFile("/etc/shells")).toString(),N=o||F.split(`
`).filter(j=>j.trim().indexOf("#")!==0&&j.trim().length>0),q=new Map;for(const j of N){let O=(0,R.basename)(j),U=q.get(O)||0;U++,U>1&&(O=`${O} (${U})`),q.set(O,U),k.set(O,{path:j,isAutoDetected:!0})}}return f(r,k),await d(k.entries(),c,s,E,t,p)}function f(s,t){if(!!s)for(const[a,r]of Object.entries(s))r===null||!("path"in r)&&!("source"in r)?t.delete(a):(r.icon=r.icon||t.get(a)?.icon,t.set(a,r))}async function n(s,t,a,r,c,o,p,E,k,F){if(a.length===0)return Promise.resolve(void 0);const N=a.shift();if(N==="")return n(s,t,a,r,c,o,p,E,k);const q={profileName:s,path:N,args:o,env:p,overrideName:E,isAutoDetected:k,isDefault:s===t};if((0,R.basename)(N)===N){const O=c.PATH?c.PATH.split(R.delimiter):void 0,U=await(0,I.findExecutable)(N,void 0,O,void 0,r.existsFile);return U?(q.path=U,q.isFromPath=!0,q):n(s,t,a,r,c,o)}return await r.existsFile((0,R.normalize)(N))?q:n(s,t,a,r,c,o,p,E,k)}}),define(re[247],ae([0,1,3,2,24,5,39,68,16,14,94,232,8,102,240,112,245,246]),function(_,e,D,i,R,A,L,P,I,S,C,b,w,y,d,g,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var m;(function(f){f[f.MaxRestarts=5]="MaxRestarts"})(m||(m={}));let u=0,h=class extends i.Disposable{constructor(n,s,t,a){super(),this.C=n,this.D=s,this.F=t,this.G=a,this.g=0,this.h=!0,this.i=!1,this.l=this.B(new D.Emitter),this.onPtyHostExit=this.l.event,this.m=this.B(new D.Emitter),this.onPtyHostStart=this.m.event,this.n=this.B(new D.Emitter),this.onPtyHostUnresponsive=this.n.event,this.p=this.B(new D.Emitter),this.onPtyHostResponsive=this.p.event,this.r=this.B(new D.Emitter),this.onPtyHostRequestResolveVariables=this.r.event,this.s=this.B(new D.Emitter),this.onProcessData=this.s.event,this.t=this.B(new D.Emitter),this.onProcessReady=this.t.event,this.u=this.B(new D.Emitter),this.onProcessReplay=this.u.event,this.v=this.B(new D.Emitter),this.onProcessOrphanQuestion=this.v.event,this.w=this.B(new D.Emitter),this.onDidRequestDetach=this.w.event,this.y=this.B(new D.Emitter),this.onDidChangeProperty=this.y.event,this.z=this.B(new D.Emitter),this.onProcessExit=this.z.event,(0,v.registerTerminalPlatformConfiguration)(),this.c=this.J(),this.B((0,i.toDisposable)(()=>this.M())),this.f=this.B(new d.RequestStore(void 0,this.G)),this.f.onCreateRequest(this.r.fire,this.r),[this.a,this.b]=this.L(),this.B(this.D.onDidChangeConfiguration(async r=>{r.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.I()}))}initialize(){this.I()}get H(){return this.D.getValue("terminal.integrated.ignoreProcessNames")}async I(){return this.b.refreshIgnoreProcessNames?.(this.H)}async J(){if(A.isWindows)return process.env;try{return await(0,b.getResolvedShellEnv)(this.G,{_:[]},process.env)}catch(n){return this.G.error("ptyHost was unable to resolve shell environment",n),{}}}L(){const n={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.F.logsPath],env:{VSCODE_LAST_PTY_ID:u,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.C.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.C.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.C.scrollback}},s=(0,C.parsePtyHostPort)(this.F.args,this.F.isBuilt);s&&(s.break&&s.port?n.debugBrk=s.port:!s.break&&s.port&&(n.debug=s.port));const t=new P.Client(R.FileAccess.asFileUri("bootstrap-fork").fsPath,n);this.m.fire(),L.ProxyChannel.toService(t.getChannel(g.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.N()),this.N(),this.B(t.onDidProcessExit(o=>{this.l.fire(o.code),this.i||(this.g<=m.MaxRestarts?(this.G.error(`ptyHost terminated unexpectedly with code ${o.code}`),this.g++,this.restartPtyHost()):this.G.error(`ptyHost terminated unexpectedly with code ${o.code}, giving up`))}));const r=t.getChannel(g.TerminalIpcChannels.Log);y.LogLevelChannelClient.setLevel(r,this.G.getLevel()),this.B(this.G.onDidChangeLogLevel(()=>{y.LogLevelChannelClient.setLevel(r,this.G.getLevel())}));const c=L.ProxyChannel.toService(t.getChannel(g.TerminalIpcChannels.PtyHost));return this.B(c.onProcessData(o=>this.s.fire(o))),this.B(c.onProcessReady(o=>this.t.fire(o))),this.B(c.onProcessExit(o=>this.z.fire(o))),this.B(c.onDidChangeProperty(o=>this.y.fire(o))),this.B(c.onProcessReplay(o=>this.u.fire(o))),this.B(c.onProcessOrphanQuestion(o=>this.v.fire(o))),this.B(c.onDidRequestDetach(o=>this.w.fire(o))),[t,c]}dispose(){this.i=!0,super.dispose()}async createProcess(n,s,t,a,r,c,o,p,E,k,F){const N=setTimeout(()=>this.Q(),g.HeartbeatConstants.CreateProcessTimeout),q=await this.b.createProcess(n,s,t,a,r,c,o,p,E,k,F);return clearTimeout(N),u=Math.max(u,q),q}updateTitle(n,s,t){return this.b.updateTitle(n,s,t)}updateIcon(n,s,t,a){return this.b.updateIcon(n,s,t,a)}attachToProcess(n){return this.b.attachToProcess(n)}detachFromProcess(n,s){return this.b.detachFromProcess(n,s)}listProcesses(){return this.b.listProcesses()}reduceConnectionGraceTime(){return this.b.reduceConnectionGraceTime()}start(n){return this.b.start(n)}shutdown(n,s){return this.b.shutdown(n,s)}input(n,s){return this.b.input(n,s)}processBinary(n,s){return this.b.processBinary(n,s)}resize(n,s,t){return this.b.resize(n,s,t)}acknowledgeDataEvent(n,s){return this.b.acknowledgeDataEvent(n,s)}setUnicodeVersion(n,s){return this.b.setUnicodeVersion(n,s)}getInitialCwd(n){return this.b.getInitialCwd(n)}getCwd(n){return this.b.getCwd(n)}getLatency(n){return this.b.getLatency(n)}orphanQuestionReply(n){return this.b.orphanQuestionReply(n)}installAutoReply(n,s){return this.b.installAutoReply(n,s)}uninstallAllAutoReplies(){return this.b.uninstallAllAutoReplies()}uninstallAutoReply(n){return this.b.uninstallAutoReply(n)}getDefaultSystemShell(n){return this.b.getDefaultSystemShell(n)}async getProfiles(n,s,t,a=!1){const r=await this.c;return(0,l.detectAvailableProfiles)(s,t,a,this.D,r,void 0,this.G,this.S.bind(this,n))}getEnvironment(){return this.b.getEnvironment()}getWslPath(n){return this.b.getWslPath(n)}getRevivedPtyNewId(n){return this.b.getRevivedPtyNewId(n)}setTerminalLayoutInfo(n){return this.b.setTerminalLayoutInfo(n)}async getTerminalLayoutInfo(n){return await this.b.getTerminalLayoutInfo(n)}async requestDetachInstance(n,s){return this.b.requestDetachInstance(n,s)}async acceptDetachInstanceReply(n,s){return this.b.acceptDetachInstanceReply(n,s)}async freePortKillProcess(n){if(!this.b.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.b.freePortKillProcess(n)}async serializeTerminalState(n){return this.b.serializeTerminalState(n)}async reviveTerminalProcesses(n,s){return this.b.reviveTerminalProcesses(n,s)}async refreshProperty(n,s){return this.b.refreshProperty(n,s)}async updateProperty(n,s,t){return this.b.updateProperty(n,s,t)}async restartPtyHost(){this.h=!0,this.M(),[this.a,this.b]=this.L()}M(){this.b.shutdownAll?.(),this.a.dispose()}N(){this.R(),this.j=setTimeout(()=>this.O(),g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier),this.h||(this.h=!0,this.p.fire())}O(){this.G.warn(`No ptyHost heartbeat after ${g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.j=void 0,this.k=setTimeout(()=>this.P(),g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.SecondWaitMultiplier)}P(){this.G.error(`No ptyHost heartbeat after ${(g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier+g.HeartbeatConstants.BeatInterval*g.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.k=void 0,this.h&&(this.h=!1,this.n.fire())}Q(){this.R(),this.G.error(`No ptyHost response to createProcess after ${g.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.h&&(this.h=!1,this.n.fire())}R(){this.j&&(clearTimeout(this.j),this.j=void 0),this.k&&(clearTimeout(this.k),this.k=void 0)}S(n,s){return this.f.createRequest({workspaceId:n,originalText:s})}async acceptPtyHostResolvedVariables(n,s){this.f.acceptReply(n,s)}};h=ye([K(1,I.IConfigurationService),K(2,S.IEnvironmentService),K(3,w.ILogService)],h),e.PtyHostService=h}),define(re[77],ae([0,1,3,16,4,8]),function(_,e,D,i,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,R.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,R.createDecorator)("sharedTunnelsService");var L;(function(g){g.Http="http",g.Https="https"})(L=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(g){g.ConstantPrivate="constantPrivate",g.Private="private",g.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var I;(function(g){g[g.Notify=1]="Notify",g[g.OpenBrowser=2]="OpenBrowser",g[g.OpenPreview=3]="OpenPreview",g[g.Silent=4]="Silent",g[g.Ignore=5]="Ignore",g[g.OpenBrowserOnce=6]="OpenBrowserOnce"})(I=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function S(g){if(g.scheme!=="http"&&g.scheme!=="https")return;const v=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(g.authority);if(!!v)return{address:v[1],port:+v[2]}}e.extractLocalHostUriMetaDataForPortMapping=S,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function C(g){return e.LOCALHOST_ADDRESSES.indexOf(g)>=0}e.isLocalhost=C,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(g){return e.ALL_INTERFACES_ADDRESSES.indexOf(g)>=0}e.isAllInterfaces=b;function w(g,v,l,m){if(l===1)return!1;if(l===2&&b(v)){const u=/(\d+)\.(\d+)\.(\d+)/g.exec(m);if(u?.length===4&&parseInt(u[1])>=18)return!1}return g<1024}e.isPortPrivileged=w;class y{constructor(v,l,m){this.remoteAddress=v,this.localAddress=l,this.b=m,this.a=new D.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=y;let d=class{constructor(v,l){this.i=v,this.j=l,this.a=new D.Emitter,this.onTunnelOpened=this.a.event,this.b=new D.Emitter,this.onTunnelClosed=this.b.event,this.c=new D.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const v=this.j.getValue("remote.localPortHost");return!v||v==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(v){return this.e=v,v?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(v){this.f=v.elevation,this.g=v.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const v=[],l=Array.from(this.d.values());for(const m of l){const u=Array.from(m.values());for(const h of u){const f=await h.value;f&&v.push(f)}}return v}async dispose(){for(const v of this.d.values()){for(const{value:l}of v.values())await l.then(m=>m?.dispose());v.clear()}this.d.clear()}setEnvironmentTunnel(v,l,m,u,h){this.o(v,l,Promise.resolve({tunnelRemoteHost:v,tunnelRemotePort:l,localAddress:m,privacy:u,protocol:h,dispose:()=>Promise.resolve()}))}async getExistingTunnel(v,l){(b(v)||C(v))&&(v=e.LOCALHOST_ADDRESSES[0]);const m=this.q(v,l);if(m)return++m.refcount,m.value}openTunnel(v,l,m,u,h=!1,f,n){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${l}:${m} on local port ${u}.`),!v)return;if(l||(l="localhost"),this.e&&this.h.has(m)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const s=this.r(v,l,m,u,h,f,n);return s?s.then(t=>{if(!t){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(l,m);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.m(t);return(t.tunnelRemoteHost!==l||t.tunnelRemotePort!==m)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(a),a}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}m(v){return{tunnelRemotePort:v.tunnelRemotePort,tunnelRemoteHost:v.tunnelRemoteHost,tunnelLocalPort:v.tunnelLocalPort,localAddress:v.localAddress,privacy:v.privacy,protocol:v.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${v.tunnelRemoteHost}:${v.tunnelRemotePort} `);const l=this.d.get(v.tunnelRemoteHost);if(l){const m=l.get(v.tunnelRemotePort);m&&(m.refcount--,await this.n(v.tunnelRemoteHost,v.tunnelRemotePort,m))}}}}async n(v,l,m){if(m.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${v}:${l}.`);const u=m.value.then(async h=>{h&&(await h.dispose(!0),this.b.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this.d.has(v)&&this.d.get(v).delete(l),u}}async closeTunnel(v,l){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${v}:${l} `);const m=this.d.get(v);if(m&&m.has(l)){const u=m.get(l);u.refcount=0,await this.n(v,l,u)}}o(v,l,m){this.d.has(v)||this.d.set(v,new Map),this.d.get(v).set(l,{refcount:1,value:m})}async p(v,l){const m=this.d.get(v);m&&(await m.get(l)||m.delete(l),m.size===0&&this.d.delete(v))}q(v,l){const m=[v];C(v)?(m.push(...e.LOCALHOST_ADDRESSES),m.push(...e.ALL_INTERFACES_ADDRESSES)):b(v)&&m.push(...e.ALL_INTERFACES_ADDRESSES);const u=m.map(h=>this.d.get(h));for(const h of u){const f=h?.get(l);if(f)return f}}canTunnel(v){return!!S(v)}s(v,l,m,u,h,f,n){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${l}:${m} on local port ${u}.`);const s=m;this.h.add(s);const t=u===void 0?m:u,a={elevationRequired:h?this.isPortPrivileged(t):!1},r={remoteAddress:{host:l,port:m},localAddressPort:u,privacy:f,public:f?f!==P.Private:void 0,protocol:n},c=v.forwardPort(r,a);return c?(this.o(l,m,c),c.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(s)})):this.h.delete(s),c}};d=ye([K(0,A.ILogService),K(1,i.IConfigurationService)],d),e.AbstractTunnelService=d}),define(re[248],ae([0,1,8,77,2,9,6]),function(_,e,D,i,R,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class P extends R.Disposable{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new L.DeferredPromise),this.b.p)}setAddress(C){this.a=C,this.b&&(this.b.complete(C),this.b=null)}setTunnel(C){this.B(C)}}let I=class kt extends R.Disposable{constructor(C,b){super(),this.f=C,this.g=b,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(C=>C.dispose())}async createTunnel(){return{id:String(++kt.a)}}async startTunnel(C,b,w,y,d,g){const v=new P,l=await Promise.resolve(this.f.openTunnel(C,v,w,y,d,g));if(!l)throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${w}:${y} (remote).`),v.dispose(),new Error("Could not create tunnel");if(this.c.has(b))throw this.c.delete(b),v.dispose(),await l.dispose(),(0,A.canceled)();return v.setTunnel(l),this.b.set(b,v),this.g.info(`[SharedProcessTunnelService] Created tunnel ${b}: ${l.localAddress} (local) to ${w}:${y} (remote).`),{tunnelLocalPort:l.tunnelLocalPort,localAddress:l.localAddress}}async setAddress(C,b){const w=this.b.get(C);!w||w.setAddress(b)}async destroyTunnel(C){const b=this.b.get(C);if(b){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${C}.`),this.b.delete(C),await b.dispose();return}this.c.add(C)}};I.a=0,I=ye([K(0,i.ISharedTunnelsService),K(1,D.ILogService)],I),e.SharedProcessTunnelService=I}),define(re[249],ae([0,1,86,34,130,224,6,2,16,8,25,222,77,107,5]),function(_,e,D,i,R,A,L,P,I,S,C,b,w,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function g(h,f,n,s,t){let a;for(let r=3;r&&(a?.dispose(),a=await new v(h,f,n,s,t).waitForReady(),!(t&&R.BROWSER_RESTRICTED_PORTS[t]||!R.BROWSER_RESTRICTED_PORTS[a.tunnelLocalPort]));r--);return a}class v extends P.Disposable{constructor(f,n,s,t,a){super(),this.j=n,this.k=a,this.privacy=w.TunnelPrivacyId.Private,this.i=new Map,this.a=f,this.b=D.createServer(),this.c=new L.Barrier,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=r=>this.l(r),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=t,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(n=>{n()})}async waitForReady(){const f=this.k??this.tunnelRemotePort,n=(0,w.isAllInterfaces)(this.j)?"0.0.0.0":"127.0.0.1";let s=await(0,R.findFreePortFaster)(f,2,1e3,n),t=null;return this.b.listen(s,this.j),await this.c.wait(),t=this.b.address(),t||(s=0,this.b.listen(s,this.j),await this.c.wait(),t=this.b.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async l(f){f.pause();const n=(0,w.isLocalhost)(this.tunnelRemoteHost)||(0,w.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,b.connectRemoteAgentTunnel)(this.a,n,this.tunnelRemotePort),t=s.getSocket().socket,a=s.readEntireBuffer();s.dispose(),a.byteLength>0&&f.write(a.buffer),f.on("end",()=>{f.localAddress&&this.i.delete(f.localAddress),t.end()}),f.on("close",()=>t.end()),f.on("error",()=>{f.localAddress&&this.i.delete(f.localAddress),t.destroy()}),t.on("end",()=>f.end()),t.on("close",()=>f.end()),t.on("error",()=>{f.destroy()}),f.pipe(t),t.pipe(f),f.localAddress&&this.i.set(f.localAddress,()=>{f.end(),t.end()})}}let l=class extends w.AbstractTunnelService{constructor(f,n,s,t,a){super(n,a),this.t=f,this.u=s,this.v=t}isPortPrivileged(f){return(0,w.isPortPrivileged)(f,this.k,d.OS,i.release())}r(f,n,s,t,a,r,c){const o=this.q(n,s);if(o)return++o.refcount,o.value;if(this.e)return this.s(this.e,n,s,t,a,r,c);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${s} on local port ${t}.`);const p={commit:this.v.commit,quality:this.v.quality,socketFactory:this.t,addressProvider:f,signService:this.u,logService:this.i,ipcLogger:null},E=g(p,this.k,n,s,t);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(n,s,E),E}}};l=ye([K(1,S.ILogService),K(2,y.ISignService),K(3,C.IProductService),K(4,I.IConfigurationService)],l),e.BaseTunnelService=l;let m=class extends l{constructor(f,n,s,t){super(A.nodeSocketFactory,f,n,s,t)}};m=ye([K(0,S.ILogService),K(1,y.ISignService),K(2,C.IProductService),K(3,I.IConfigurationService)],m),e.TunnelService=m;let u=class extends P.Disposable{constructor(f,n,s,t){super(),this.b=f,this.c=n,this.f=s,this.g=t,this.a=new Map}async openTunnel(f,n,s,t,a,r,c,o){if(this.b.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${t} on local port ${a}.`),!this.a.has(f)){const p=new m(this.b,this.f,this.c,this.g);this.B(p),this.a.set(f,p),p.onTunnelClosed(async()=>{(await p.tunnels).length===0&&(p.dispose(),this.a.delete(f))})}return this.a.get(f).openTunnel(n,s,t,a,r,c,o)}};u=ye([K(0,S.ILogService),K(1,C.IProductService),K(2,y.ISignService),K(3,I.IConfigurationService)],u),e.SharedTunnelsService=u}),define(re[30],ae([0,1,4]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,D.createDecorator)("IUriIdentityService")}),define(re[250],ae([0,1,30,71,13,21,128,3,2]),function(_,e,D,i,R,A,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class S{constructor(w){this.uri=w,this.time=S._clock++}touch(){return this.time=S._clock++,this}}S._clock=0;let C=class{constructor(w){this.g=w,this.c=new I.DisposableStore,this.f=2**16;const y=new Map,d=g=>{let v=y.get(g.scheme);return v===void 0&&(v=w.hasProvider(g)&&!this.g.hasCapability(g,1024),y.set(g.scheme,v)),v};this.c.add(P.Event.any(w.onDidChangeFileSystemProviderRegistrations,w.onDidChangeFileSystemProviderCapabilities)(g=>{y.delete(g.scheme)})),this.extUri=new A.ExtUri(d),this.d=new L.SkipList((g,v)=>this.extUri.compare(g,v,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(w){this.g.hasProvider(w)&&(w=(0,A.normalizePath)(w));const y=this.d.get(w);return y?y.touch().uri.with({fragment:w.fragment}):(this.d.set(w,new S(w)),this.h(),w)}h(){if(this.d.size<this.f)return;const w=[...this.d.entries()].sort((d,g)=>d[1].touch<g[1].touch?1:d[1].touch>g[1].touch?-1:0);S._clock=0,this.d.clear();const y=this.f*.5;for(let d=0;d<y;d++)this.d.set(w[d][0],w[d][1].touch())}};C=ye([K(0,R.IFileService)],C),e.UriIdentityService=C,(0,i.registerSingleton)(D.IUriIdentityService,C,1)}),define(re[251],ae([0,1,3,2,13,44,48,17]),function(_,e,D,i,R,A,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class I extends i.Disposable{get capabilities(){return this.f.capabilities&-5}constructor(C,b,w,y){super(),this.c=C,this.f=b,this.g=w,this.h=y,this.onDidChangeCapabilities=this.f.onDidChangeCapabilities,this.a=this.B(new D.Emitter),this.onDidChangeFile=this.a.event,this.b=L.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this.B(this.f.onDidChangeFile(d=>this.i(d)))}watch(C,b){this.b.set(C,C);const w=this.f.watch(this.j(C),b);return(0,i.toDisposable)(()=>{this.b.delete(C),w.dispose()})}stat(C){return this.f.stat(this.j(C))}mkdir(C){return this.f.mkdir(this.j(C))}rename(C,b,w){return this.f.rename(this.j(C),this.j(b),w)}readFile(C){return this.f.readFile(this.j(C),{atomic:!0})}readFileStream(C,b,w){const y=(0,A.newWriteableStream)(d=>P.VSBuffer.concat(d.map(g=>P.VSBuffer.wrap(g))).buffer);return(async()=>{try{const d=await this.readFile(C);y.end(d)}catch(d){y.error(d),y.end()}})(),y}readdir(C){return this.f.readdir(this.j(C))}writeFile(C,b,w){return this.f.writeFile(this.j(C),b,w)}delete(C,b){return this.f.delete(this.j(C),b)}copy(C,b,w){if((0,R.hasFileFolderCopyCapability)(this.f))return this.f.copy(this.j(C),this.j(b),w);throw new Error("copy not supported")}i(C){const b=[];for(const w of C){if(w.resource.scheme!==this.c)continue;const y=this.k(w.resource);this.b.findSubstr(y)&&b.push({resource:y,type:w.type})}b.length&&(this.h.debug("User data changed"),this.a.fire(b))}j(C){return C.with({scheme:this.c})}k(C){return C.with({scheme:this.g})}}e.FileUserDataProvider=I}),define(re[60],ae([0,1,83]),function(_,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function i(L,P,I,S){const C=(0,D.setProperty)(L,P,I,S)[0];return C&&(L=L.substring(0,C.offset)+C.content+L.substring(C.offset+C.length)),L}e.edit=i;function R(L,P,I){let S=I;for(;S>=0;){if(L.charAt(S)===P.charAt(P.length-1)&&P.length===1)return S+1;if(S--,P.length===2&&S>=0&&L.charAt(S)===P.charAt(0))return S+2}return 0}e.getLineStartOffset=R;function A(L,P,I){let S=I;for(;S>=0;)if(L.charAt(S)===P.charAt(P.length-1)&&P.length===1||(S++,P.length===2&&S>=0&&L.charAt(S)===P.charAt(1)))return S;return L.length-1}e.getLineEndOffset=A}),define(re[252],ae([0,1,32,53,15]),function(_,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function A(y,d,g,v,l,m){const u=[],h=[],f=[];if(!d){const U=y.filter(({identifier:$})=>l.every(G=>G.toLowerCase()!==$.id.toLowerCase()));return{local:{added:u,removed:h,updated:f},remote:U.length>0?{added:U,updated:[],removed:[],all:U}:null}}y=y.map(b),d=d.map(b),g=g?g.map(b):null;const n=new Map,s=U=>{U.uuid&&n.set(U.id.toLowerCase(),U.uuid)};y.forEach(({identifier:U})=>s(U)),d.forEach(({identifier:U})=>s(U)),g?.forEach(({identifier:U})=>s(U));const t=U=>{const $=U.identifier.uuid||n.get(U.identifier.id.toLowerCase());return $?`uuid:${$}`:`id:${U.identifier.id.toLowerCase()}`},a=(U,$)=>(U.set(t($),$),U),r=y.reduce(a,new Map),c=d.reduce(a,new Map),o=d.reduce((U,$)=>a(U,(0,D.deepClone)($)),new Map),p=g?g.reduce(a,new Map):null,E=v.reduce(a,new Map),k=l.reduce((U,$)=>{const G=n.get($.toLowerCase());return U.add(G?`uuid:${G}`:`id:${$.toLowerCase()}`)},new Set),F=m.reduce((U,{id:$,uuid:G})=>(G=G??n.get($.toLowerCase()),U.add(G?`uuid:${G}`:`id:${$.toLowerCase()}`)),new Set),N=L(r,c,k,!1);if(N.added.size>0||N.removed.size>0||N.updated.size>0){const U=L(p,r,k,!1),$=L(p,c,k,!0),G=(H,Z,z,B)=>({...B,installed:Z.installed||z.installed,version:z.version&&(!Z.installed||i.gt(z.version,Z.version))?z.version:Z.version,state:I(Z,z,p?.get(H)),preRelease:(Z.installed?B.preRelease:z.preRelease)??Z.preRelease});for(const H of $.removed.values()){const Z=r.get(H);if(!Z)continue;const z=(0,R.assertIsDefined)(p?.get(H)),B=!F.has(H)&&z.installed;Z.installed&&B?h.push(Z.identifier):o.set(H,Z)}for(const H of $.added.values()){const Z=(0,R.assertIsDefined)(c.get(H)),z=r.get(H);if(z){if(N.updated.has(H)){const B=G(H,z,Z,Z);P(z,Z,!1,!1)||f.push(w(B,H)),o.set(H,B)}}else Z.installed&&u.push(w(Z,H))}for(const H of $.updated.values()){const Z=(0,R.assertIsDefined)(c.get(H)),z=(0,R.assertIsDefined)(p?.get(H)),B=r.get(H);if(B)if(!F.has(H)&&z.installed&&B.installed&&!Z.installed)h.push(B.identifier);else{const ee=G(H,B,Z,Z);f.push(w(ee,H)),o.set(H,ee)}else Z.installed&&u.push(w(Z,H))}for(const H of U.added.values())$.added.has(H)||o.set(H,(0,R.assertIsDefined)(r.get(H)));for(const H of U.updated.values()){if($.removed.has(H)||$.updated.has(H))continue;const Z=(0,R.assertIsDefined)(r.get(H)),z=(0,R.assertIsDefined)(c.get(H));o.set(H,G(H,Z,z,Z))}for(const H of U.removed.values())$.updated.has(H)||$.removed.has(H)||E.has(H)||!(0,R.assertIsDefined)(c.get(H)).installed||F.has(H)||!(0,R.assertIsDefined)(p?.get(H)).installed||o.delete(H)}const q=[],j=L(c,o,new Set,!0),O=j.added.size>0||j.updated.size>0||j.removed.size>0;return O&&o.forEach((U,$)=>q.push(w(U,$))),{local:{added:u,removed:h,updated:f},remote:O?{added:[...j.added].map(U=>o.get(U)),updated:[...j.updated].map(U=>o.get(U)),removed:[...j.removed].map(U=>c.get(U)),all:q}:null}}e.merge=A;function L(y,d,g,v){const l=y?[...y.keys()].filter(n=>!g.has(n)):[],m=[...d.keys()].filter(n=>!g.has(n)),u=m.filter(n=>l.indexOf(n)===-1).reduce((n,s)=>(n.add(s),n),new Set),h=l.filter(n=>m.indexOf(n)===-1).reduce((n,s)=>(n.add(s),n),new Set),f=new Set;for(const n of l){if(h.has(n))continue;const s=y.get(n),t=d.get(n);(!t||!P(s,t,v,!0))&&f.add(n)}return{added:u,removed:h,updated:f}}function P(y,d,g,v){return!(y.disabled!==d.disabled||v&&y.installed!==d.installed||y.installed&&d.installed&&y.preRelease!==d.preRelease||!C(y.state,d.state)||g&&y.version!==d.version)}function I(y,d,g){const v=y.state,l=d.state,m=g?.state;if(!d.version||v&&i.gt(y.version,d.version))return v;if(l&&i.gt(d.version,y.version)||!v)return l;if(!l)return v;const u=(0,D.deepClone)(v),h=m?S(m,l):{added:Object.keys(l).reduce((n,s)=>(n.add(s),n),new Set),removed:new Set,updated:new Set},f=m?S(m,v):{added:Object.keys(v).reduce((n,s)=>(n.add(s),n),new Set),removed:new Set,updated:new Set};for(const n of[...h.added.values(),...h.updated.values()])u[n]=l[n];for(const n of h.removed.values())f.updated.has(n)||delete u[n];return u}function S(y,d){const g=Object.keys(y),v=Object.keys(d),l=v.filter(h=>g.indexOf(h)===-1).reduce((h,f)=>(h.add(f),h),new Set),m=g.filter(h=>v.indexOf(h)===-1).reduce((h,f)=>(h.add(f),h),new Set),u=new Set;for(const h of g){if(m.has(h))continue;const f=y[h],n=d[h];(0,D.equals)(f,n)||u.add(h)}return{added:l,removed:m,updated:u}}function C(y={},d={}){const{added:g,removed:v,updated:l}=S(y,d);return g.size===0&&v.size===0&&l.size===0}function b(y){return{...y,disabled:!!y.disabled,installed:!!y.installed}}function w(y,d){const g={identifier:{id:y.identifier.id,uuid:d.startsWith("uuid:")?d.substring(5):void 0},preRelease:!!y.preRelease};return y.version&&(g.version=y.version),y.disabled&&(g.disabled=!0),y.installed&&(g.installed=!0),y.state&&(g.state=y.state),g}}),define(re[114],ae([0,1,20,16,4]),function(_,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,R.createDecorator)("IIgnoredExtensionsManagementService");let A=class{constructor(P){this.a=P}hasToNeverSyncExtension(P){return this.b().includes(P.toLowerCase())}hasToAlwaysSyncExtension(P){return this.b().includes(`-${P.toLowerCase()}`)}updateIgnoredExtensions(P,I){let S=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return S=S.filter(C=>C!==P&&C!==`-${P}`),I&&S.push(P.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",S.length?S:void 0,2)}updateSynchronizedExtensions(P,I){let S=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return S=S.filter(C=>C!==P&&C!==`-${P}`),I&&S.push(`-${P.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",S.length?S:void 0,2)}getIgnoredExtensions(P){const I=P.filter(w=>w.isMachineScoped).map(w=>w.identifier.id.toLowerCase()),S=this.b().map(w=>w.toLowerCase()),C=[],b=[];if(Array.isArray(S))for(const w of S)w.startsWith("-")?b.push(w.substring(1)):C.push(w);return(0,D.distinct)([...I,...C].filter(w=>b.indexOf(w)===-1))}b(){let P=this.a.inspect("settingsSync.ignoredExtensions").userValue;return P!==void 0||(P=this.a.inspect("sync.ignoredExtensions").userValue,P!==void 0)?P:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(I=>I.toLowerCase())}};A=ye([K(0,i.IConfigurationService)],A),e.IgnoredExtensionsManagementService=A}),define(re[253],ae([0,1,20,35,32,192,60]),function(_,e,D,i,R,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function P(h){return(0,i.parse)(h)||[]}e.parseKeybindings=P;async function I(h,f,n,s,t){const a=P(h),r=P(f),c=n?P(n):null,o=[...a,...r,...c||[]].map(G=>G.key),p=await t.resolveUserBindings(o),E=C(a,r,c,p);if(!E.hasLocalForwarded&&!E.hasRemoteForwarded)return{mergeContent:h,hasChanges:!1,hasConflicts:!1};if(!E.hasLocalForwarded&&E.hasRemoteForwarded)return{mergeContent:f,hasChanges:!0,hasConflicts:!1};if(E.hasLocalForwarded&&!E.hasRemoteForwarded)return{mergeContent:h,hasChanges:!0,hasConflicts:!1};const k=w(a),F=w(r),N=c?w(c):null,q=d(k,F,p),j=N?d(N,k,p):{added:[...k.keys()].reduce((G,H)=>(G.add(H),G),new Set),removed:new Set,updated:new Set},O=N?d(N,F,p):{added:[...F.keys()].reduce((G,H)=>(G.add(H),G),new Set),removed:new Set,updated:new Set},U=S(q,j,O);let $=h;for(const G of U.removed.values())U.conflicts.has(G)||($=m($,G,s));for(const G of U.added.values()){if(U.conflicts.has(G))continue;const H=F.get(G);if(H.some(Z=>Z.command!==`-${G}`&&E.conflicts.has(p[Z.key]))){U.conflicts.add(G);continue}$=l($,H,s)}for(const G of U.updated.values()){if(U.conflicts.has(G))continue;const H=F.get(G);if(H.some(Z=>Z.command!==`-${G}`&&E.conflicts.has(p[Z.key]))){U.conflicts.add(G);continue}$=u($,G,H,s)}return{mergeContent:$,hasChanges:!0,hasConflicts:U.conflicts.size>0}}e.merge=I;function S(h,f,n){const s=new Set,t=new Set,a=new Set,r=new Set;for(const c of f.removed.values())n.updated.has(c)&&r.add(c);for(const c of n.removed.values())r.has(c)||(f.updated.has(c)?r.add(c):t.add(c));for(const c of f.added.values())r.has(c)||n.added.has(c)&&h.updated.has(c)&&r.add(c);for(const c of n.added.values())r.has(c)||(f.added.has(c)?h.updated.has(c)&&r.add(c):s.add(c));for(const c of f.updated.values())r.has(c)||n.updated.has(c)&&h.updated.has(c)&&r.add(c);for(const c of n.updated.values())r.has(c)||(f.updated.has(c)?h.updated.has(c)&&r.add(c):a.add(c));return{added:s,removed:t,updated:a,conflicts:r}}function C(h,f,n,s){const t=new Set,a=b(h,s),r=b(f,s),c=n?b(n,s):null,o=y(a,r);if(o.added.size===0&&o.removed.size===0&&o.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const p=c?y(c,a):{added:[...a.keys()].reduce((j,O)=>(j.add(O),j),new Set),removed:new Set,updated:new Set};if(p.added.size===0&&p.removed.size===0&&p.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:t,removed:t,updated:t,conflicts:t};const E=c?y(c,r):{added:[...r.keys()].reduce((j,O)=>(j.add(O),j),new Set),removed:new Set,updated:new Set};if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const{added:k,removed:F,updated:N,conflicts:q}=S(o,p,E);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:k,removed:F,updated:N,conflicts:q}}function b(h,f){const n=new Map;for(const s of h){const t=f[s.key];let a=n.get(t);a||(a=[],n.set(t,a)),a.push(s)}return n}function w(h){const f=new Map;for(const n of h){const s=n.command[0]==="-"?n.command.substring(1):n.command;let t=f.get(s);t||(t=[],f.set(s,t)),t.push(n)}return f}function y(h,f){const n=[...h.keys()],s=[...f.keys()],t=s.filter(c=>n.indexOf(c)===-1).reduce((c,o)=>(c.add(o),c),new Set),a=n.filter(c=>s.indexOf(c)===-1).reduce((c,o)=>(c.add(o),c),new Set),r=new Set;for(const c of n){if(a.has(c))continue;const o=h.get(c).map(E=>({...E,key:c})),p=f.get(c).map(E=>({...E,key:c}));(0,D.equals)(o,p,(E,k)=>v(E,k))||r.add(c)}return{added:t,removed:a,updated:r}}function d(h,f,n){const s=[...h.keys()],t=[...f.keys()],a=t.filter(o=>s.indexOf(o)===-1).reduce((o,p)=>(o.add(p),o),new Set),r=s.filter(o=>t.indexOf(o)===-1).reduce((o,p)=>(o.add(p),o),new Set),c=new Set;for(const o of s){if(r.has(o))continue;const p=h.get(o).map(k=>({...k,key:n[k.key]})),E=f.get(o).map(k=>({...k,key:n[k.key]}));g(p,E)||c.add(o)}return{added:a,removed:r,updated:c}}function g(h,f){return!(!(0,D.equals)(h.filter(({command:n})=>n[0]!=="-"),f.filter(({command:n})=>n[0]!=="-"),(n,s)=>v(n,s))||!(0,D.equals)(h.filter(({command:n})=>n[0]==="-"),f.filter(({command:n})=>n[0]==="-"),(n,s)=>v(n,s)))}function v(h,f){if(h.command!==f.command||h.key!==f.key)return!1;const n=A.ContextKeyExpr.deserialize(h.when),s=A.ContextKeyExpr.deserialize(f.when);return!(n&&!s||!n&&s||n&&s&&!n.equals(s)||!R.equals(h.args,f.args))}function l(h,f,n){for(const s of f)h=L.edit(h,[-1],s,n);return h}function m(h,f,n){const s=P(h);for(let t=s.length-1;t>=0;t--)(s[t].command===f||s[t].command===`-${f}`)&&(h=L.edit(h,[t],void 0,n));return h}function u(h,f,n,s){const t=P(h),a=t.findIndex(r=>r.command===f||r.command===`-${f}`);for(let r=t.length-1;r>=0;r--)(t[r].command===f||t[r].command===`-${f}`)&&(h=L.edit(h,[r],void 0,s));for(let r=n.length-1;r>=0;r--)h=L.edit(h,[a],n[r],s);return h}}),define(re[254],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function D(A,L,P){const I={},S={},C=new Set;if(!L)return{local:{added:I,updated:S,removed:[...C.values()]},remote:{added:A,updated:{},removed:[]},conflicts:[]};const b=i(A,L);if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{local:{added:I,updated:S,removed:[...C.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const w=i(P,A),y=i(P,L),d={},g={},v=new Set,l=new Set;for(const m of w.removed.values())y.updated.has(m)?I[m]=L[m]:v.add(m);for(const m of y.removed.values())l.has(m)||(w.updated.has(m)?l.add(m):C.add(m));for(const m of w.updated.values())l.has(m)||(y.updated.has(m)?b.updated.has(m)&&l.add(m):g[m]=A[m]);for(const m of y.updated.values())l.has(m)||(w.updated.has(m)?b.updated.has(m)&&l.add(m):A[m]!==void 0&&(S[m]=L[m]));for(const m of w.added.values())l.has(m)||(y.added.has(m)?b.updated.has(m)&&l.add(m):d[m]=A[m]);for(const m of y.added.values())l.has(m)||(w.added.has(m)?b.updated.has(m)&&l.add(m):I[m]=L[m]);return{local:{added:I,removed:[...C.values()],updated:S},remote:{added:d,removed:[...v.values()],updated:g},conflicts:[...l.values()]}}e.merge=D;function i(A,L){const P=A?Object.keys(A):[],I=L?Object.keys(L):[],S=I.filter(w=>P.indexOf(w)===-1).reduce((w,y)=>(w.add(y),w),new Set),C=P.filter(w=>I.indexOf(w)===-1).reduce((w,y)=>(w.add(y),w),new Set),b=new Set;for(const w of P){if(C.has(w))continue;const y=A[w],d=L[w];y!==d&&b.add(w)}return{added:S,removed:C,updated:b}}function R(A,L){const{added:P,removed:I,updated:S}=i(A,L);return P.size===0&&I.size===0&&S.size===0}e.areSame=R}),define(re[255],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(R,A,L,P){const I={local:{added:[],removed:[],updated:[]},remote:{added:[],removed:[],updated:[]}};if(!A){const C=R.filter(({id:b})=>!P.includes(b));return C.length?I.remote.added=C:I.remote=null,I}const S=i(R,A,P);if(S.added.length>0||S.removed.length>0||S.updated.length>0){const C=i(L,R,P),b=i(L,A,P);for(const w of b.removed){const y=R.find(d=>d.id===w);y&&I.local.removed.push(y)}for(const w of b.added){const y=A.find(d=>d.id===w);C.added.includes(w)?S.updated.includes(w)&&I.local.updated.push(y):I.local.added.push(y)}for(const w of b.updated)I.local.updated.push(A.find(y=>y.id===w));for(const w of C.added)b.added.includes(w)||I.remote.added.push(R.find(y=>y.id===w));for(const w of C.updated)b.removed.includes(w)||b.updated.includes(w)||I.remote.updated.push(R.find(y=>y.id===w));for(const w of C.removed)I.remote.removed.push(A.find(y=>y.id===w))}return I.remote.added.length===0&&I.remote.removed.length===0&&I.remote.updated.length===0&&(I.remote=null),I}e.merge=D;function i(R,A,L){R=R?R.filter(({id:w})=>!L.includes(w)):[],A=A.filter(({id:w})=>!L.includes(w));const P=R.map(({id:w})=>w),I=A.map(({id:w})=>w),S=I.filter(w=>P.indexOf(w)===-1),C=P.filter(w=>I.indexOf(w)===-1),b=[];for(const{id:w,name:y,shortName:d}of R){if(C.includes(w))continue;const g=A.find(v=>v.id===w);(!g||g.name!==y||g.shortName!==d)&&b.push(w)}return{added:S,removed:C,updated:b}}}),define(re[26],ae([0,1,20,15,178,46,29,4,104,40]),function(_,e,D,i,R,A,L,P,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncResourceProviderService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.getPathSegments=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function C(){const r=S.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(r).filter(c=>!!r[c].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=C;function b(){const r=S.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),c=Object.keys(r).filter(E=>!!r[E].ignoreSync),o=Object.keys(r).filter(E=>r[E].scope===2||r[E].scope===6),p=C();return(0,D.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...c,...o,...p])}e.getDefaultIgnoredSettings=b,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync",e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM="settingsSync.keybindingsPerPlatform";function w(){const r="vscode://schemas/ignoredSettings",c=S.Registry.as(A.Extensions.Configuration);c.registerConfiguration({id:"settingsSync",order:30,title:(0,R.localize)(0,null),type:"object",properties:{[e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM]:{type:"boolean",description:(0,R.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,R.localize)(2,null),items:[{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,R.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,R.localize)(4,null),default:[],scope:1,$ref:r,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const o=S.Registry.as(I.Extensions.JSONContribution),p=()=>{const E=C(),k=b().filter(j=>j!==e.CONFIGURATION_SYNC_STORE_KEY),F=Object.keys(A.allSettings.properties).filter(j=>k.indexOf(j)===-1),N=k.filter(j=>E.indexOf(j)===-1),q={items:{type:"string",enum:[...F,...N.map(j=>`-${j}`)]}};o.registerSchema(r,q)};return c.onDidUpdateConfiguration(()=>p())}e.registerConfiguration=w;function y(r){return r&&(0,i.isObject)(r)&&(0,i.isString)(r.id)&&Array.isArray(r.scopes)}e.isAuthenticationProvider=y;var d;(function(r){r.Settings="settings",r.Keybindings="keybindings",r.Snippets="snippets",r.Tasks="tasks",r.Extensions="extensions",r.GlobalState="globalState",r.Profiles="profiles"})(d=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function g(r,...c){return r?[r,...c]:c}e.getPathSegments=g;function v(r,c,o,p){return p.joinPath(o.userDataSyncHome,...g(r,c,`lastSync${c}.json`))}e.getLastSyncResourceUri=v,e.IUserDataSyncStoreManagementService=(0,P.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,P.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,P.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function l(r){const c={};return c[e.HEADER_EXECUTION_ID]=r,c}e.createSyncHeaders=l;var m;(function(r){r.Unauthorized="Unauthorized",r.NotFound="NotFound",r.Conflict="Conflict",r.Gone="Gone",r.PreconditionFailed="PreconditionFailed",r.TooLarge="TooLarge",r.UpgradeRequired="UpgradeRequired",r.PreconditionRequired="PreconditionRequired",r.TooManyRequests="RemoteTooManyRequests",r.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",r.RequestFailed="RequestFailed",r.RequestCanceled="RequestCanceled",r.RequestTimeout="RequestTimeout",r.RequestProtocolNotSupported="RequestProtocolNotSupported",r.RequestPathNotEscaped="RequestPathNotEscaped",r.RequestHeadersNotObject="RequestHeadersNotObject",r.NoCollection="NoCollection",r.NoRef="NoRef",r.EmptyResponse="EmptyResponse",r.TurnedOff="TurnedOff",r.SessionExpired="SessionExpired",r.ServiceChanged="ServiceChanged",r.DefaultServiceChanged="DefaultServiceChanged",r.LocalTooManyRequests="LocalTooManyRequests",r.LocalPreconditionFailed="LocalPreconditionFailed",r.LocalInvalidContent="LocalInvalidContent",r.LocalError="LocalError",r.IncompatibleLocalContent="IncompatibleLocalContent",r.IncompatibleRemoteContent="IncompatibleRemoteContent",r.Unknown="Unknown"})(m=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class u extends Error{constructor(c,o,p,E){super(c),this.code=o,this.resource=p,this.operationId=E,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=u;class h extends u{constructor(c,o,p,E,k){super(c,p,void 0,k),this.url=o,this.serverCode=E}}e.UserDataSyncStoreError=h;class f extends u{constructor(c,o){super(c,o)}}e.UserDataAutoSyncError=f,function(r){function c(o){if(o instanceof r)return o;const p=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(o.name);if(p&&p[1]){const E=p[2]==="unknown"?void 0:p[2],k=p[3]==="unknown"?void 0:p[3];return new r(o.message,p[1],E,k)}return new r(o.message,"Unknown")}r.toUserDataSyncError=c}(u=e.UserDataSyncError||(e.UserDataSyncError={}));var n;(function(r){r.Uninitialized="uninitialized",r.Idle="idle",r.Syncing="syncing",r.HasConflicts="hasConflicts"})(n=e.SyncStatus||(e.SyncStatus={}));var s;(function(r){r[r.None=0]="None",r[r.Added=1]="Added",r[r.Modified=2]="Modified",r[r.Deleted=3]="Deleted"})(s=e.Change||(e.Change={}));var t;(function(r){r.Preview="preview",r.Conflict="conflict",r.Accepted="accepted"})(t=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function a(r){return`sync.enable.${r}`}e.getEnablementKey=a,e.IUserDataSyncEnablementService=(0,P.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,P.createDecorator)("IUserDataSyncService"),e.IUserDataSyncResourceProviderService=(0,P.createDecorator)("IUserDataSyncResourceProviderService"),e.IUserDataAutoSyncService=(0,P.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,P.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,P.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview"}),define(re[256],ae([0,1,32,26]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(L,P,I,S,C){if(!P)return{remote:{added:Object.keys(L),removed:[],updated:[],all:Object.keys(L).length>0?L:null},local:{added:{},removed:[],updated:{}}};const b=A(L,P);if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const w=I?A(I,P):{added:Object.keys(P).reduce((m,u)=>(m.add(u),m),new Set),removed:new Set,updated:new Set},y=I?A(I,L):{added:Object.keys(L).reduce((m,u)=>(m.add(u),m),new Set),removed:new Set,updated:new Set},d={added:{},removed:[],updated:{}},g=D.deepClone(P),v=!I;for(const m of y.added.values())m!==i.SYNC_SERVICE_URL_TYPE&&v&&w.added.has(m)||(g[m]=L[m]);for(const m of y.updated.values())g[m]=L[m];for(const m of y.removed.values())S.unregistered.includes(m)||delete g[m];for(const m of w.added.values()){const u=P[m];if(S.machine.includes(m)){C.info(`GlobalState: Skipped adding ${m} in local storage because it is declared as machine scoped.`);continue}if(I&&y.added.has(m))continue;const h=L[m];h&&h.value===u.value||m===i.SYNC_SERVICE_URL_TYPE&&v&&y.added.has(m)||(h?d.updated[m]=u:d.added[m]=u)}for(const m of w.updated.values()){const u=P[m];if(S.machine.includes(m)){C.info(`GlobalState: Skipped updating ${m} in local storage because it is declared as machine scoped.`);continue}if(y.updated.has(m)||y.removed.has(m))continue;const h=L[m];h&&h.value===u.value||(d.updated[m]=u)}for(const m of w.removed.values()){if(S.machine.includes(m)){C.trace(`GlobalState: Skipped removing ${m} in local storage because it is declared as machine scoped.`);continue}y.updated.has(m)||y.removed.has(m)||d.removed.push(m)}const l=A(P,g);return{local:d,remote:{added:[...l.added],updated:[...l.updated],removed:[...l.removed],all:l.added.size===0&&l.removed.size===0&&l.updated.size===0?null:g}}}e.merge=R;function A(L,P){const I=Object.keys(L),S=Object.keys(P),C=S.filter(y=>I.indexOf(y)===-1).reduce((y,d)=>(y.add(d),y),new Set),b=I.filter(y=>S.indexOf(y)===-1).reduce((y,d)=>(y.add(d),y),new Set),w=new Set;for(const y of I){if(b.has(y))continue;const d=L[y],g=P[y];D.equals(d,g)||w.add(y)}return{added:C,removed:b,updated:w}}}),define(re[257],ae([0,1,20,35,83,43,32,60,26]),function(_,e,D,i,R,A,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function S(o,p,E){let k=[];E?k=b(E):k=C(p);const F=[],N=[...(0,I.getDisallowedIgnoredSettings)()];if(Array.isArray(k))for(const q of k)q.startsWith("-")?N.push(q.substring(1)):F.push(q);return(0,D.distinct)([...o,...F].filter(q=>N.indexOf(q)===-1))}e.getIgnoredSettings=S;function C(o){let p=o.inspect("settingsSync.ignoredSettings").userValue;return p!==void 0||(p=o.inspect("sync.ignoredSettings").userValue,p!==void 0)?p:o.getValue("settingsSync.ignoredSettings")||[]}function b(o){const p=(0,i.parse)(o);return p?p["settingsSync.ignoredSettings"]||p["sync.ignoredSettings"]||[]:[]}function w(o,p){const E=(0,i.parse)(o)||{};let k="{}";for(const F of Object.keys(E)){const N=(0,R.setProperty)(k,[F],E[F],p);k=(0,R.applyEdits)(k,N)}return k}e.removeComments=w;function y(o,p,E,k){if(E.length){const F=c(p),N=(0,i.parse)(p)||{},q=(0,i.parse)(o);if(!q)return o;const j=[];for(const O of E){const U=N[O],$=q[O];U===void 0?o=P.edit(o,[O],void 0,k):$!==void 0?o=P.edit(o,[O],U,k):j.push(n(O,F))}j.sort((O,U)=>O.startOffset-U.startOffset),j.forEach(O=>o=m(O.setting.key,p,o,k))}return o}e.updateIgnoredSettings=y;function d(o,p,E,k,F,N){const q=y(o,p,k,N),j=E!==q,O=E!==p;if(!j&&!O)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(j&&!O)return{conflictsSettings:[],localContent:null,remoteContent:q,hasConflicts:!1};if(O&&!j)return{conflictsSettings:[],localContent:y(p,o,k,N),remoteContent:null,hasConflicts:!1};if(E===null&&v(o)){const W=g(o,p,k)?null:y(p,o,k,N);return{conflictsSettings:[],localContent:W,remoteContent:null,hasConflicts:!1}}let U=o,$=p;const G=(0,i.parse)(o),H=(0,i.parse)(p),Z=E?(0,i.parse)(E):null,z=k.reduce((W,X)=>(W.add(X),W),new Set),B=l(G,H,z),Y=l(Z,G,z),ee=l(Z,H,z),oe=new Map,J=new Set,Q=W=>{J.add(W);const X=F.filter(({key:se})=>se===W)[0];X?(U=P.edit(U,[W],X.value,N),$=P.edit($,[W],X.value,N)):oe.set(W,{key:W,localValue:G[W],remoteValue:H[W]})};for(const W of Y.removed.values())ee.updated.has(W)?Q(W):$=P.edit($,[W],void 0,N);for(const W of ee.removed.values())J.has(W)||(Y.updated.has(W)?Q(W):U=P.edit(U,[W],void 0,N));for(const W of Y.updated.values())J.has(W)||(ee.updated.has(W)?B.updated.has(W)&&Q(W):$=P.edit($,[W],G[W],N));for(const W of ee.updated.values())J.has(W)||(Y.updated.has(W)?B.updated.has(W)&&Q(W):U=P.edit(U,[W],H[W],N));for(const W of Y.added.values())J.has(W)||(ee.added.has(W)?B.updated.has(W)&&Q(W):$=m(W,U,$,N));for(const W of ee.added.values())J.has(W)||(Y.added.has(W)?B.updated.has(W)&&Q(W):U=m(W,$,U,N));const T=oe.size>0||!g(U,$,k),M=T||!g(U,o,[]),V=T||!g($,p,[]);return{localContent:M?U:null,remoteContent:V?$:null,conflictsSettings:[...oe.values()],hasConflicts:T}}e.merge=d;function g(o,p,E){if(o===p)return!0;const k=(0,i.parse)(o),F=(0,i.parse)(p),N=E.reduce((O,U)=>(O.add(U),O),new Set),q=c(o).filter(O=>!(O.setting&&N.has(O.setting.key))),j=c(p).filter(O=>!(O.setting&&N.has(O.setting.key)));if(q.length!==j.length)return!1;for(let O=0;O<q.length;O++){const U=q[O],$=j[O];if(U.setting&&$.setting){if(U.setting.key!==$.setting.key||!L.equals(k[U.setting.key],F[U.setting.key]))return!1}else if(!U.setting&&!$.setting){if(U.value!==$.value)return!1}else return!1}return!0}e.areSame=g;function v(o){return o?c(o).length===0:!0}e.isEmpty=v;function l(o,p,E){const k=o?Object.keys(o).filter(O=>!E.has(O)):[],F=Object.keys(p).filter(O=>!E.has(O)),N=F.filter(O=>k.indexOf(O)===-1).reduce((O,U)=>(O.add(U),O),new Set),q=k.filter(O=>F.indexOf(O)===-1).reduce((O,U)=>(O.add(U),O),new Set),j=new Set;if(o)for(const O of k){if(q.has(O))continue;const U=o[O],$=p[O];L.equals(U,$)||j.add(O)}return{added:N,removed:q,updated:j}}function m(o,p,E,k){const F=(0,i.parse)(p),N=c(p),q=c(E),j=u(o,N,q);return h(E,o,F[o],j,q,k)}e.addSetting=m;function u(o,p,E){const k=p.findIndex(N=>N.setting?.key===o),F=p[k-1];if(F){if(F.setting){const q=n(F.setting.key,E);if(q)return{index:E.indexOf(q),insertAfter:!0}}else{const q=s(k,p);if(q){const j=n(q.setting.key,E);if(j){const O=t(E.indexOf(j),E),U=a(p,q,p[k]);if(O){const $=a(E,j,O),G=r(U,$);return G?{index:E.indexOf(G),insertAfter:!0}:{index:E.indexOf(O),insertAfter:!1}}else{const $=a(E,j,E[E.length-1]),G=r(U,$);return G?{index:E.indexOf(G),insertAfter:!0}:{index:E.length-1,insertAfter:!0}}}}}const N=p[k+1];if(N)if(N.setting){const q=n(N.setting.key,E);if(q)return{index:E.indexOf(q),insertAfter:!1}}else{const q=t(k,p);if(q){const j=n(q.setting.key,E);if(j){const O=s(E.indexOf(j),E),U=a(p,p[k],q);if(O){const $=a(E,O,j),G=r(U.reverse(),$.reverse());return G?{index:E.indexOf(G),insertAfter:!1}:{index:E.indexOf(O),insertAfter:!0}}else{const $=a(E,E[0],j),G=r(U.reverse(),$.reverse());return G?{index:E.indexOf(G),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:E.length-1,insertAfter:!0}}function h(o,p,E,k,F,N){let q;return k.index===-1?q=(0,R.setProperty)(o,[p],E,N):q=f(o,p,E,k,F,N).map(j=>(0,R.withFormatting)(o,j,N)[0]),(0,R.applyEdits)(o,q)}function f(o,p,E,k,F,N){const q=`${JSON.stringify(p)}: ${JSON.stringify(E)}`,j=(0,A.getEOL)(N,o),O=F[k.index];if(k.insertAfter){const U=[];if(O.setting)U.push({offset:O.endOffset,length:0,content:","+q});else{const $=t(k.index,F),G=s(k.index,F),H=G?.setting?.commaOffset;G&&H===void 0&&U.push({offset:G.endOffset,length:0,content:","});const Z=H!==void 0&&H>O.endOffset;U.push({offset:Z?H+1:O.endOffset,length:0,content:$?j+q+",":j+q})}return U}else{if(O.setting)return[{offset:O.startOffset,length:0,content:q+","}];const U=(F[k.index-1]&&!F[k.index-1].setting?j:"")+q+(t(k.index,F)?",":"")+j;return[{offset:O.startOffset,length:0,content:U}]}}function n(o,p){return p.filter(E=>E.setting?.key===o)[0]}function s(o,p){for(let E=o-1;E>=0;E--)if(p[E].setting)return p[E]}function t(o,p){for(let E=o+1;E<p.length;E++)if(p[E].setting)return p[E]}function a(o,p,E){const k=o.indexOf(p),F=o.indexOf(E);return o.filter((N,q)=>k<q&&q<F)}function r(o,p){if(o.length&&p.length){let E=0;for(;E<p.length&&E<o.length;E++)if(o[E].value!==p[E].value)return p[E-1];return p[E-1]}}function c(o){const p=[];let E=-1,k,F;const N={onObjectBegin:q=>{E++},onObjectProperty:(q,j,O)=>{E===0&&(k=j,F=q)},onObjectEnd:(q,j)=>{E--,E===0&&p.push({startOffset:k,endOffset:q+j,value:o.substring(k,q+j),setting:{key:F,commaOffset:void 0}})},onArrayBegin:(q,j)=>{E++},onArrayEnd:(q,j)=>{E--,E===0&&p.push({startOffset:k,endOffset:q+j,value:o.substring(k,q+j),setting:{key:F,commaOffset:void 0}})},onLiteralValue:(q,j,O)=>{E===0&&p.push({startOffset:k,endOffset:j+O,value:o.substring(k,j+O),setting:{key:F,commaOffset:void 0}})},onSeparator:(q,j,O)=>{if(E===0&&q===","){let U=p.length-1;for(;U>=0&&!p[U].setting;U--);const $=p[U];$&&p.splice(U,1,{startOffset:$.startOffset,endOffset:$.endOffset,value:$.value,setting:{key:$.setting.key,commaOffset:j}})}},onComment:(q,j)=>{E===0&&p.push({startOffset:q,endOffset:q+j,value:o.substring(q,q+j)})}};return(0,i.visit)(o,N),p}}),define(re[78],ae([0,1,3,2,4,26]),function(_,e,D,i,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,R.createDecorator)("IUserDataSyncAccountService");let L=class extends i.Disposable{get account(){return this.a}constructor(I,S){super(),this.g=I,this.h=S,this.b=this.B(new D.Emitter),this.onDidChangeAccount=this.b.event,this.c=this.B(new D.Emitter),this.onTokenFailed=this.c.event,this.f=!1,this.B(I.onTokenFailed(()=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f),this.updateAccount(void 0),this.c.fire(this.f),this.f=!0})),this.B(I.onTokenSucceed(()=>this.f=!1))}async updateAccount(I){(I&&this.a?I.token!==this.a.token||I.authenticationProviderId!==this.a.authenticationProviderId:I!==this.a)&&(this.a=I,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(I))}};L=ye([K(0,A.IUserDataSyncStoreService),K(1,A.IUserDataSyncLogService)],L),e.UserDataSyncAccountService=L}),define(re[258],ae([0,1,2,7]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class R{constructor(w){this.a=w}listen(w,y){switch(y){case"onError":return this.a.onError}throw new Error(`Event not found: ${y}`)}call(w,y,d){switch(y){case"triggerSync":return this.a.triggerSync(d[0],d[1],d[2]);case"turnOn":return this.a.turnOn();case"turnOff":return this.a.turnOff(d[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=R;class A{constructor(w){this.a=w}listen(w,y){throw new Error(`Event not found: ${y}`)}call(w,y,d){switch(y){case"resolveDefaultIgnoredSettings":return this.a.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.a.resolveUserBindings(d[0]);case"resolveFormattingOptions":return this.a.resolveFormattingOptions(i.URI.revive(d[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=A;class L{constructor(w){this.a=w}async resolveDefaultIgnoredSettings(){return this.a.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(w){return this.a.call("resolveUserKeybindings",[w])}async resolveFormattingOptions(w){return this.a.call("resolveFormattingOptions",[w])}}e.UserDataSyncUtilServiceClient=L;class P{constructor(w){this.a=w}listen(w,y){switch(y){case"onDidChange":return this.a.onDidChange}throw new Error(`Event not found: ${y}`)}async call(w,y,d){switch(y){case"getMachines":return this.a.getMachines();case"addCurrentMachine":return this.a.addCurrentMachine();case"removeCurrentMachine":return this.a.removeCurrentMachine();case"renameMachine":return this.a.renameMachine(d[0],d[1]);case"setEnablements":return this.a.setEnablements(d)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=P;class I{constructor(w){this.a=w}listen(w,y){switch(y){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${y}`)}call(w,y,d){switch(y){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(d)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=I;class S{constructor(w){this.a=w}listen(w,y){switch(y){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${y}`)}call(w,y,d){switch(y){case"switch":return this.a.switch(d[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=S;class C extends D.Disposable{constructor(w){super(),this.a=w,this.onDidChangeUserDataSyncStore=this.a.listen("onDidChangeUserDataSyncStore")}async switch(w){return this.a.call("switch",[w])}async getPreviousUserDataSyncStore(){const w=await this.a.call("getPreviousUserDataSyncStore");return this.b(w)}b(w){return{url:i.URI.revive(w.url),type:w.type,defaultUrl:i.URI.revive(w.defaultUrl),insidersUrl:i.URI.revive(w.insidersUrl),stableUrl:i.URI.revive(w.stableUrl),canSwitch:w.canSwitch,authenticationProviders:w.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=C}),define(re[259],ae([0,1,14,8]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let R=class extends i.AbstractLogger{constructor(L,P){super(),this.g=this.B(L.createLogger(P.userDataSyncLogResource,{name:"settingssync"}))}trace(L,...P){this.g.trace(L,...P)}debug(L,...P){this.g.debug(L,...P)}info(L,...P){this.g.info(L,...P)}warn(L,...P){this.g.warn(L,...P)}error(L,...P){this.g.error(L,...P)}flush(){this.g.flush()}};R=ye([K(0,i.ILoggerService),K(1,D.IEnvironmentService)],R),e.UserDataSyncLogService=R}),define(re[260],ae([0,1,6,3,2]),function(_,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class A extends R.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:I,getActiveWindowId:S}){super(),this.a=this.B(new R.DisposableStore),i.Event.latch(i.Event.any(P,I))(this.f,this,this.a),this.b=(0,D.createCancelablePromise)(()=>S()),(async()=>{try{const b=await this.b;this.c=typeof this.c=="number"?this.c:b}catch{}finally{this.b=void 0}})()}f(P){this.b&&(this.b.cancel(),this.b=void 0),this.c=P}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.ActiveWindowManager=A}),define(re[115],ae([0,1,181,12,48,21,7,4,24]),function(_,e,D,i,R,A,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function S(s){const t=s;return typeof t?.id=="string"&&L.URI.isUri(t.uri)}e.isSingleFolderWorkspaceIdentifier=S,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function C(s,t){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,i.basename)(s)}:t?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const a=s;if(a.configuration)return{id:a.id,configPath:a.configuration};if(a.folders.length===1)return{id:a.id,uri:a.folders[0].uri}}e.toWorkspaceIdentifier=C;function b(s){const t=s;return typeof t?.id=="string"&&L.URI.isUri(t.configPath)}e.isWorkspaceIdentifier=b;function w(s){const t=s;if(t?.uri)return{id:t.id,uri:L.URI.revive(t.uri)};const a=s;if(a?.configPath)return{id:a.id,configPath:L.URI.revive(a.configPath)};if(s?.id)return{id:s.id}}e.reviveIdentifier=w;var y;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(y=e.WorkbenchState||(e.WorkbenchState={}));function d(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.isWorkspace=d;function g(s){const t=s;return!!(t&&typeof t=="object"&&L.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.isWorkspaceFolder=g;class v{constructor(t,a,r,c,o){this.h=t,this.j=r,this.k=c,this.l=o,this.c=R.TernarySearchTree.forUris(this.l,()=>!0),this.folders=a}update(t){this.h=t.id,this.k=t.configuration,this.j=t.transient,this.l=t.l,this.folders=t.folders}get folders(){return this.g}set folders(t){this.g=t,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(t){this.k=t}getFolder(t){return t&&this.c.findSubstr(t)||null}n(){this.c=R.TernarySearchTree.forUris(this.l,()=>!0);for(const t of this.folders)this.c.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=v;class l{constructor(t,a){this.raw=a,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,A.joinPath)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=l;function m(s){return new l({uri:s,index:0,name:(0,A.basenameOrAuthority)(s)},{uri:s.toString()})}e.toWorkspaceFolder=m,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,D.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function u(s,t){return A.extUriBiasedIgnorePathCase.isEqualOrParent(s,t.untitledWorkspacesHome)}e.isUntitledWorkspace=u;function h(s){let t;return L.URI.isUri(s)?t=s:t=s.configuration,t?.scheme===I.Schemas.tmp}e.isTemporaryWorkspace=h;function f(s,t){return!u(s,t)&&!h(s)}e.isSavedWorkspace=f;function n(s){return(typeof s=="string"?(0,i.extname)(s):(0,A.extname)(s))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=n}),define(re[18],ae([0,1,66,3,2,21,7,173,14,13,4,8,115,37,30,6,31,27]),function(_,e,D,i,R,A,L,P,I,S,C,b,w,y,d,g,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function m(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&L.URI.isUri(t.location)&&L.URI.isUri(t.globalStorageHome)&&L.URI.isUri(t.settingsResource)&&L.URI.isUri(t.keybindingsResource)&&L.URI.isUri(t.tasksResource)&&L.URI.isUri(t.snippetsHome)&&L.URI.isUri(t.extensionsResource))}e.isUserDataProfile=m,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,C.createDecorator)("IUserDataProfilesService");function u(s,t){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,location:L.URI.revive(s.location).with({scheme:t}),globalStorageHome:L.URI.revive(s.globalStorageHome).with({scheme:t}),settingsResource:L.URI.revive(s.settingsResource).with({scheme:t}),keybindingsResource:L.URI.revive(s.keybindingsResource).with({scheme:t}),tasksResource:L.URI.revive(s.tasksResource).with({scheme:t}),snippetsHome:L.URI.revive(s.snippetsHome).with({scheme:t}),extensionsResource:L.URI.revive(s.extensionsResource)?.with({scheme:t}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}e.reviveProfile=u;function h(s,t,a,r){return{id:s,name:t,location:a,isDefault:!1,shortName:r?.shortName,globalStorageHome:(0,A.joinPath)(a,"globalStorage"),settingsResource:(0,A.joinPath)(a,"settings.json"),keybindingsResource:(0,A.joinPath)(a,"keybindings.json"),tasksResource:(0,A.joinPath)(a,"tasks.json"),snippetsHome:(0,A.joinPath)(a,"snippets"),extensionsResource:(0,A.joinPath)(a,"extensions.json"),useDefaultFlags:r?.useDefaultFlags,isTransient:r?.transient}}e.toUserDataProfile=h;let f=class extends R.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(t,a,r,c){super(),this.m=t,this.n=a,this.r=r,this.s=c,this.f=!1,this.g=this.B(new i.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new i.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new i.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new i.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new y.ResourceMap},this.profilesHome=(0,A.joinPath)(this.m.userRoamingDataHome,"profiles")}setEnablement(t){this.f!==t&&(this.t=void 0,this.f=t)}isEnabled(){return this.f}get u(){if(!this.t){const t=this.f?this.H().map(o=>h((0,A.basename)(o.location),o.name,o.location,{shortName:o.shortName,useDefaultFlags:o.useDefaultFlags})):[];let a;const r=new y.ResourceMap,c=h((0,D.hash)(this.m.userRoamingDataHome.path).toString(16),(0,P.localize)(0,null),this.m.userRoamingDataHome);if(t.unshift({...c,extensionsResource:this.M()??c.extensionsResource,isDefault:!0}),t.length){const o=this.J();if(o.workspaces)for(const[p,E]of Object.entries(o.workspaces)){const k=L.URI.parse(p),F=L.URI.parse(E),N=t.find(q=>this.r.extUri.isEqual(q.location,F));N&&r.set(k,N)}if(o.emptyWindow){const p=L.URI.parse(o.emptyWindow);a=t.find(E=>this.r.extUri.isEqual(E.location,p))}}this.t={profiles:t,workspaces:r,emptyWindow:a}}return this.t}async createTransientProfile(t){const a="Temp",r=new RegExp(`${(0,l.escapeRegExpCharacters)(a)}\\s(\\d+)`);let c=0;for(const p of this.profiles){const E=r.exec(p.name),k=E?parseInt(E[1]):0;c=k>c?k:c}const o=`${a} ${c+1}`;return this.createProfile((0,D.hash)((0,v.generateUuid)()).toString(16),o,{transient:!0},t)}async createNamedProfile(t,a,r){return this.createProfile((0,D.hash)((0,v.generateUuid)()).toString(16),t,a,r)}async createProfile(t,a,r,c){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const o=await this.v(t,a,r);return c&&await this.setProfileForWorkspace(c,o),o}async v(t,a,r){let c=this.k.get(a);return c||(c=(async()=>{try{const o=this.profiles.find(k=>k.name===a||k.id===t);if(o)return o;const p=h(t,a,(0,A.joinPath)(this.profilesHome,t),r);await this.n.createFolder(p.location);const E=[];return this.h.fire({profile:p,join(k){E.push(k)}}),await g.Promises.settled(E),this.C([p],[],[]),p}finally{this.k.delete(a)}})(),this.k.set(a,c)),c}async updateProfile(t,a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let r=this.profiles.find(c=>c.id===t.id);if(!r)throw new Error(`Profile '${t.name}' does not exist`);return r=h(r.id,a.name??r.name,r.location,{shortName:a.shortName??r.shortName,transient:a.transient??r.isTransient,useDefaultFlags:a.useDefaultFlags??r.useDefaultFlags}),this.C([],[],[r]),r}async removeProfile(t){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(t.isDefault)throw new Error("Cannot remove default profile");const a=this.profiles.find(c=>c.id===t.id);if(!a)throw new Error(`Profile '${t.name}' does not exist`);const r=[];this.i.fire({profile:a,join(c){r.push(c)}});try{await Promise.allSettled(r)}catch(c){this.s.error(c)}a.id===this.u.emptyWindow?.id&&(this.u.emptyWindow=void 0);for(const c of[...this.u.workspaces.keys()])a.id===this.u.workspaces.get(c)?.id&&this.u.workspaces.delete(c);this.G(),this.C([],[a],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(a.location,{recursive:!0})}catch(c){this.s.error(c)}}getOrSetProfileForWorkspace(t,a=this.defaultProfile){if(!this.f)return this.defaultProfile;let r=this.w(t);return r||(r=a,this.profiles.length>1&&this.setProfileForWorkspaceSync(t,r)),r}async setProfileForWorkspace(t,a){this.setProfileForWorkspaceSync(t,a)}setProfileForWorkspaceSync(t,a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const r=this.profiles.find(c=>c.id===a.id);if(!r)throw new Error(`Profile '${a.name}' does not exist`);this.F(t,r)}unsetWorkspace(t,a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.F(t,void 0,a)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindow=void 0,this.u.workspaces.clear(),this.u.emptyWindow=void 0,this.G(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const t=await this.n.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(a=>a.isDirectory&&this.profiles.every(r=>!this.r.extUri.isEqual(r.location,a.resource))).map(a=>this.n.del(a.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const t=this.l.profiles.filter(a=>!this.z(a));await Promise.allSettled(t.map(a=>this.removeProfile(a)))}w(t){const a=this.y(t);return L.URI.isUri(a)?this.l.workspaces.get(a)??this.u.workspaces.get(a):this.l.emptyWindow??this.u.emptyWindow}y(t){return(0,w.isSingleFolderWorkspaceIdentifier)(t)?t.uri:(0,w.isWorkspaceIdentifier)(t)?t.configPath:"empty-window"}z(t){return!!(this.r.extUri.isEqual(this.l.emptyWindow?.location,t.location)||[...this.l.workspaces.values()].some(a=>this.r.extUri.isEqual(a.location,t.location))||this.r.extUri.isEqual(this.u.emptyWindow?.location,t.location)||[...this.u.workspaces.values()].some(a=>this.r.extUri.isEqual(a.location,t.location)))}C(t,a,r){const c=[...this.profiles,...t],o=[];this.l.profiles=[];for(let p of c)p.isDefault||a.some(E=>p.id===E.id)||(p=r.find(E=>p.id===E.id)??p,p.isTransient?this.l.profiles.push(p):o.push({location:p.location,name:p.name,shortName:p.shortName,useDefaultFlags:p.useDefaultFlags}));this.I(o),this.t=void 0,this.D(t,a,r)}D(t,a,r){this.g.fire({added:t,removed:a,updated:r,all:this.profiles})}F(t,a,r){r=a?.isTransient?!0:r,r||this.F(t,void 0,!0);const c=this.y(t),o=r?this.l:this.u;L.URI.isUri(c)?(o.workspaces.delete(c),a&&o.workspaces.set(c,a)):o.emptyWindow=a,r||this.G()}G(){const t={};for(const[r,c]of this.u.workspaces.entries())t[r.toString()]=c.location.toString();const a=this.u.emptyWindow?.location.toString();this.L({workspaces:t,emptyWindow:a}),this.t=void 0}H(){return[]}I(t){throw new Error("not implemented")}J(){return{}}L(t){throw new Error("not implemented")}M(){}};f.b="userDataProfiles",f.c="profileAssociations",f=ye([K(0,I.IEnvironmentService),K(1,S.IFileService),K(2,d.IUriIdentityService),K(3,b.ILogService)],f),e.UserDataProfilesService=f;class n extends f{constructor(){super(...arguments),this.a=[],this.P={}}H(){return this.a}I(t){this.a=t}J(){return this.P}L(t){this.P=t}}e.InMemoryUserDataProfilesService=n}),define(re[261],ae([0,1,6,2,18]),function(_,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let A=class extends i.Disposable{constructor(P){super(),this.B(new D.RunOnceScheduler(()=>{P.cleanUp()},10*1e3)).schedule()}};A=ye([K(0,R.IUserDataProfilesService)],A),e.UserDataProfilesCleaner=A}),define(re[262],ae([0,1,20,6,23,9,3,2,5,7,154,29,33,42,8,25,22,18]),function(_,e,D,i,R,A,L,P,I,S,C,b,w,y,d,g,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let m=class extends P.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(t,a,r,c,o){super(),this.t=t,this.u=a,this.v=r,this.w=c,this.y=o,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new L.Emitter),this.m=this.B(new L.Emitter),this.n=this.B(new L.Emitter),this.p=this.B(new L.Emitter),this.s=[],this.B((0,P.toDisposable)(()=>{this.j.forEach(({task:p})=>p.cancel()),this.k.forEach(p=>p.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(t){const a=await this.getTargetPlatform();return t.allTargetPlatforms.some(r=>(0,b.isTargetPlatformCompatible)(r,t.allTargetPlatforms,a))}async installFromGallery(t,a={}){try{if(!this.t.isEnabled())throw new b.ExtensionManagementError(C.localize(0,null),b.ExtensionManagementErrorCode.Internal);const r=await this.G(t,!!a.installGivenVersion,!!a.installPreReleaseVersion);return await this.z(r.manifest,r.extension,a)}catch(r){throw f(this.u,"extensionGallery:install",{extensionData:(0,w.getGalleryExtensionTelemetryData)(t),error:r}),this.v.error("Failed to install extension.",t.identifier.id),this.v.error(r),h(r)}}async uninstall(t,a={}){return this.v.trace("ExtensionManagementService#uninstall",t.identifier.id),this.I(t,a)}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.g||t-this.h>1e3*60*5)&&(this.g=this.O(),this.h=t),this.g}registerParticipant(t){this.s.push(t)}async z(t,a,r){const c={...r,installOnlyNewlyAddedFromExtensionPack:S.URI.isUri(a)?r.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,y.isApplicationScopedExtension)(t)?this.y.defaultProfile.extensionsResource:r.profileLocation??this.P()},o=q=>`${w.ExtensionKey.create(q).toString()}${c.profileLocation?`-${c.profileLocation.toString()}`:""}`;if(!S.URI.isUri(a)){const q=this.j.get(o(a));if(q){this.v.info("Extensions is already requested to install",a.identifier.id);const{local:j}=await q.task.waitUntilTaskIsFinished();return j}}const p=[],E=[],k=[],F=this.Q(t,a,c);S.URI.isUri(a)||this.j.set(o(a),{task:F,waitingTasks:[]}),this.l.fire({identifier:F.identifier,source:a,profileLocation:c.profileLocation}),this.v.info("Installing extension:",F.identifier.id),p.push({task:F,manifest:t});let N=!1;try{if(c.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",F.identifier.id);else try{const j=await this.F(F.identifier,t,!!c.installOnlyNewlyAddedFromExtensionPack,!!c.installPreReleaseVersion,c.profileLocation),O=await this.getInstalled(void 0,c.profileLocation);for(const{gallery:U,manifest:$}of j){N=N||!!$.extensionDependencies?.some(Z=>(0,w.areSameExtensions)({id:Z},F.identifier));const G=o(U),H=this.j.get(G);if(H){if(this.C(F,H.task)){this.v.info("Waiting for already requested installing extension",U.identifier.id,F.identifier.id),H.waitingTasks.push(F);const Z=H.task.identifier;E.push(L.Event.toPromise(L.Event.filter(this.onDidInstallExtensions,z=>z.some(B=>(0,w.areSameExtensions)(B.identifier,Z)))).then(z=>{if(!z.find(Y=>(0,w.areSameExtensions)(Y.identifier,Z))?.local)throw new Error(`Extension ${Z.id} is not installed`)}))}}else if(!O.some(({identifier:Z})=>(0,w.areSameExtensions)(Z,U.identifier))){const Z=this.Q($,U,{...c,donotIncludePackAndDependencies:!0});this.j.set(G,{task:Z,waitingTasks:[F]}),this.l.fire({identifier:Z.identifier,source:U,profileLocation:c.profileLocation}),this.v.info("Installing extension:",Z.identifier.id,F.identifier.id),p.push({task:Z,manifest:$})}}}catch(j){if(S.URI.isUri(F.source))(0,D.isNonEmptyArray)(t.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",F.identifier.id,j.message),(0,D.isNonEmptyArray)(t.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",F.identifier.id,j.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",F.identifier.id),j}const q=p.reduce((j,{task:O,manifest:U})=>(j.set(O.identifier.id.toLowerCase(),{task:O,manifest:U}),j),new Map);for(;q.size;){let j;const O=[...q.values()].filter(({manifest:U})=>!U.extensionDependencies?.some($=>q.has($.toLowerCase())));O.length?j=q.size===1?O:O.filter(({task:U})=>!(U===F&&!N)):(this.v.info("Found extensions with circular dependencies",O.map(({task:U})=>U.identifier.id)),j=[...q.values()]),await this.D(j.map(async({task:U})=>{const $=new Date().getTime();try{const{local:G}=await U.run();if(await this.D(this.s.map(H=>H.postInstall(G,U.source,c,R.CancellationToken.None))),!S.URI.isUri(U.source)){const H=U.operation===3,Z=H?void 0:(new Date().getTime()-U.source.lastUpdated)/1e3;if(f(this.u,H?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,w.getGalleryExtensionTelemetryData)(U.source),wasVerified:U.wasVerified,duration:new Date().getTime()-$,durationSinceUpdate:Z}),I.isWeb&&U.operation!==3)try{await this.t.reportStatistic(G.manifest.publisher,G.manifest.name,G.manifest.version,"install")}catch{}}k.push({local:G,identifier:U.identifier,operation:U.operation,source:U.source,context:c.context,profileLocation:c.profileLocation,applicationScoped:G.isApplicationScoped})}catch(G){throw S.URI.isUri(U.source)||f(this.u,U.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,w.getGalleryExtensionTelemetryData)(U.source),wasVerified:U.wasVerified,duration:new Date().getTime()-$,error:G}),this.v.error("Error while installing the extension:",U.identifier.id),G}finally{q.delete(U.identifier.id.toLowerCase())}}))}return E.length&&await this.D(E),k.forEach(({identifier:j})=>this.v.info("Extension installed successfully:",j.id)),this.m.fire(k),k.filter(({identifier:j})=>(0,w.areSameExtensions)(j,F.identifier))[0].local}catch(q){if(p.forEach(({task:j})=>j.cancel()),k.length)try{const j=await Promise.allSettled(k.map(({local:O})=>this.R(O,{versionOnly:!0,profileLocation:c.profileLocation}).run()));for(let O=0;O<j.length;O++){const U=j[O],{identifier:$}=k[O];U.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",$.id):this.v.warn("Rollback: Error while uninstalling extension",$.id,(0,A.getErrorMessage)(U.reason))}}catch(j){this.v.warn("Error while rolling back extensions",(0,A.getErrorMessage)(j),k.map(({identifier:O})=>O.id))}throw this.m.fire(p.map(({task:j})=>({identifier:j.identifier,operation:2,source:j.source,context:c.context,profileLocation:c.profileLocation}))),q}finally{for(const[q,{task:j,waitingTasks:O}]of this.j.entries()){const U=O.indexOf(F);U!==-1&&O.splice(U,1),O.length===0&&(j===F||U!==-1)&&this.j.delete(q)}}}C(t,a){for(const[,{task:r,waitingTasks:c}]of this.j.entries())if(r===t&&(c.includes(a)||c.some(o=>this.C(o,a)))||r===a&&c[0]&&!this.C(t,c[0]))return!1;return!0}async D(t){const a=[],r=[],c=await Promise.allSettled(t);for(const o of c)o.status==="fulfilled"?a.push(o.value):r.push(o.reason);if(r.length)throw u(r);return a}async F(t,a,r,c,o){if(!this.t.isEnabled())return[];const p=await this.getInstalled(void 0,o),E=[t],k=[],F=async(N,q)=>{const j=q.extensionDependencies||[],O=[...j];if(q.extensionPack){const U=r?p.find($=>(0,w.areSameExtensions)($.identifier,N)):void 0;for(const $ of q.extensionPack)U&&U.manifest.extensionPack&&U.manifest.extensionPack.some(G=>(0,w.areSameExtensions)({id:G},{id:$}))||O.every(G=>!(0,w.areSameExtensions)({id:G},{id:$}))&&O.push($)}if(O.length){const U=[...E,...k.map(G=>G.gallery.identifier)],$=O.filter(G=>U.every(H=>!(0,w.areSameExtensions)(H,{id:G})));if($.length){const G=await this.t.getExtensions($.map(H=>({id:H,preRelease:c})),R.CancellationToken.None);for(const H of G){if(U.find(B=>(0,w.areSameExtensions)(B,H.identifier)))continue;const Z=j.some(B=>(0,w.areSameExtensions)({id:B},H.identifier));let z;try{z=await this.G(H,!1,c)}catch(B){if(B instanceof b.ExtensionManagementError&&B.code===b.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!Z){this.v.info("Skipping the packed extension as it cannot be installed",H.identifier.id);continue}else throw B}k.push({gallery:z.extension,manifest:z.manifest}),await F(z.extension.identifier,z.manifest)}}}};return await F(t,a),k}async G(t,a,r){if((await this.getExtensionsControlManifest()).malicious.some(E=>(0,w.areSameExtensions)(t.identifier,E)))throw new b.ExtensionManagementError(C.localize(1,null,t.identifier.id),b.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(t)){const E=await this.getTargetPlatform();throw new b.ExtensionManagementError(C.localize(2,null,t.identifier.id,this.w.nameLong,(0,b.TargetPlatformToString)(E)),b.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const o=await this.H(t,a,r);if(o){if(r&&!a&&t.hasPreReleaseVersion&&!o.properties.isPreReleaseVersion)throw new b.ExtensionManagementError(C.localize(3,null,t.identifier.id,this.w.nameLong,this.w.version),b.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!r&&t.properties.isPreReleaseVersion&&(await this.t.getExtensions([t.identifier],R.CancellationToken.None))[0]?new b.ExtensionManagementError(C.localize(4,null,t.identifier.id),b.ExtensionManagementErrorCode.ReleaseVersionNotFound):new b.ExtensionManagementError(C.localize(5,null,t.identifier.id,this.w.nameLong,this.w.version),b.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",o.identifier.id);const p=await this.t.getManifest(o,R.CancellationToken.None);if(p===null)throw new b.ExtensionManagementError(`Missing manifest for extension ${t.identifier.id}`,b.ExtensionManagementErrorCode.Invalid);if(p.version!==o.version)throw new b.ExtensionManagementError(`Cannot install '${t.identifier.id}' extension because of version mismatch in Marketplace`,b.ExtensionManagementErrorCode.Invalid);return{extension:o,manifest:p}}async H(t,a,r){const c=await this.getTargetPlatform();let o=null;return!a&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==r&&(o=(await this.t.getExtensions([{...t.identifier,preRelease:r}],{targetPlatform:c,compatible:!0},R.CancellationToken.None))[0]||null),!o&&await this.t.isExtensionCompatible(t,r,c)&&(o=t),o||(a?o=(await this.t.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:c,compatible:!0},R.CancellationToken.None))[0]||null:o=await this.t.getCompatibleExtension(t,r,c)),o}async I(t,a){const r={...a,profileLocation:t.isApplicationScoped?this.y.defaultProfile.extensionsResource:a.profileLocation??this.P()},c=N=>`${N.id.toLowerCase()}${r.versionOnly?`-${t.manifest.version}`:""}${r.profileLocation?`@${r.profileLocation.toString()}`:""}`,o=this.k.get(c(t.identifier));if(o)return this.v.info("Extensions is already requested to uninstall",t.identifier.id),o.waitUntilTaskIsFinished();const p=N=>{const q=this.R(N,r);return this.k.set(c(q.extension.identifier),q),r.profileLocation?this.v.info("Uninstalling extension from the profile:",`${N.identifier.id}@${N.manifest.version}`,r.profileLocation.toString()):this.v.info("Uninstalling extension:",`${N.identifier.id}@${N.manifest.version}`),this.n.fire({identifier:N.identifier,profileLocation:r.profileLocation,applicationScoped:N.isApplicationScoped}),q},E=(N,q)=>{q?r.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${N.identifier.id}@${N.manifest.version}`,r.profileLocation.toString(),q.message):this.v.error("Failed to uninstall extension:",`${N.identifier.id}@${N.manifest.version}`,q.message):r.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${N.identifier.id}@${N.manifest.version}`,r.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${N.identifier.id}@${N.manifest.version}`),f(this.u,"extensionGallery:uninstall",{extensionData:(0,w.getLocalExtensionTelemetryData)(N),error:q}),this.p.fire({identifier:N.identifier,error:q?.code,profileLocation:r.profileLocation,applicationScoped:N.isApplicationScoped})},k=[],F=[];try{k.push(p(t));const N=await this.getInstalled(1,r.profileLocation);if(r.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const q=this.M(t,N);for(const j of q)this.k.has(c(j.identifier))?this.v.info("Extensions is already requested to uninstall",j.identifier.id):k.push(p(j))}r.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.J(k.map(q=>q.extension),N,t),await this.D(k.map(async q=>{try{if(await q.run(),await this.D(this.s.map(j=>j.postUninstall(q.extension,r,R.CancellationToken.None))),q.extension.identifier.uuid)try{await this.t.reportStatistic(q.extension.manifest.publisher,q.extension.manifest.name,q.extension.manifest.version,"uninstall")}catch{}E(q.extension)}catch(j){const O=j instanceof b.ExtensionManagementError?j:new b.ExtensionManagementError((0,A.getErrorMessage)(j),b.ExtensionManagementErrorCode.Internal);throw E(q.extension,O),O}finally{F.push(q)}}))}catch(N){const q=N instanceof b.ExtensionManagementError?N:new b.ExtensionManagementError((0,A.getErrorMessage)(N),b.ExtensionManagementErrorCode.Internal);for(const j of k){try{j.cancel()}catch{}F.includes(j)||E(j.extension,q)}throw q}finally{for(const N of k)this.k.delete(c(N.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",N.extension.identifier.id)}}J(t,a,r){for(const c of t){const o=this.N(c,a);if(o.length){const p=o.filter(E=>!t.some(k=>(0,w.areSameExtensions)(k.identifier,E.identifier)));if(p.length)throw new Error(this.L(c,p,r))}}}L(t,a,r){return r===t?a.length===1?C.localize(6,null,r.manifest.displayName||r.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?C.localize(7,null,r.manifest.displayName||r.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):C.localize(8,null,r.manifest.displayName||r.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):a.length===1?C.localize(9,null,r.manifest.displayName||r.manifest.name,t.manifest.displayName||t.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?C.localize(10,null,r.manifest.displayName||r.manifest.name,t.manifest.displayName||t.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):C.localize(11,null,r.manifest.displayName||r.manifest.name,t.manifest.displayName||t.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name)}M(t,a,r=[]){if(r.indexOf(t)!==-1)return[];r.push(t);const c=t.manifest.extensionPack?t.manifest.extensionPack:[];if(c.length){const o=a.filter(E=>!E.isBuiltin&&c.some(k=>(0,w.areSameExtensions)({id:k},E.identifier))),p=[];for(const E of o)p.push(...this.M(E,a,r));return[...o,...p]}return[]}N(t,a){return a.filter(r=>r.manifest.extensionDependencies&&r.manifest.extensionDependencies.some(c=>(0,w.areSameExtensions)({id:c},t.identifier)))}async O(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const t=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};m=ye([K(0,b.IExtensionGalleryService),K(1,v.ITelemetryService),K(2,d.ILogService),K(3,g.IProductService),K(4,l.IUserDataProfilesService)],m),e.AbstractExtensionManagementService=m;function u(s){const t=Array.isArray(s)?s:[s];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((a,r)=>new Error(`${a.message}${a.message?",":""}${r instanceof Error?r.message:r}`),new Error(""))}e.joinErrors=u;function h(s){if(s instanceof b.ExtensionManagementError)return s;const t=new b.ExtensionManagementError(s.message,b.ExtensionManagementErrorCode.Internal);return t.stack=s.stack,t}function f(s,t,{extensionData:a,wasVerified:r,duration:c,error:o,durationSinceUpdate:p}){let E,k;o&&(o instanceof b.ExtensionManagementError?(E=o.code,o.code===b.ExtensionManagementErrorCode.Signature&&(k=o.message)):E=b.ExtensionManagementErrorCode.Internal),s.publicLog(t,{...a,wasVerified:r,success:!o,duration:c,errorcode:E,errorcodeDetail:k,durationSinceUpdate:p})}e.reportTelemetry=f;class n{constructor(){this.d=new i.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,i.createCancelablePromise)(t=>this.h(t))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,i.createCancelablePromise)(t=>new Promise((a,r)=>{const c=t.onCancellationRequested(()=>{c.dispose(),r(new A.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=n}),define(re[61],ae([0,1,6,17,2,3,37,7,33,42,13,4,8,18,30]),function(_,e,D,i,R,A,L,P,I,S,C,b,w,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,b.createDecorator)("IExtensionsProfileScannerService");let g=class extends R.Disposable{constructor(m,u,h,f){super(),this.h=m,this.i=u,this.j=h,this.k=f,this.a=this.B(new A.Emitter),this.onAddExtensions=this.a.event,this.b=this.B(new A.Emitter),this.onDidAddExtensions=this.b.event,this.c=this.B(new A.Emitter),this.onRemoveExtensions=this.c.event,this.f=this.B(new A.Emitter),this.onDidRemoveExtensions=this.f.event,this.g=new L.ResourceMap}scanProfileExtensions(m){return this.l(m)}async addExtensionsToProfile(m,u){const h=[],f=[];try{return await this.l(u,n=>{const s=[];for(const t of n)m.some(([a])=>(0,I.areSameExtensions)(a.identifier,t.identifier)&&a.manifest.version!==t.version)?h.push(t):s.push(t);for(const[t,a]of m)if(!s.some(r=>(0,I.areSameExtensions)(r.identifier,t.identifier)&&r.version===t.manifest.version)){const r={identifier:t.identifier,version:t.manifest.version,location:t.location,metadata:a};f.push(r),s.push(r)}return f.length&&this.a.fire({extensions:f,profileLocation:u}),h.length&&this.c.fire({extensions:h,profileLocation:u}),s}),f.length&&this.b.fire({extensions:f,profileLocation:u}),h.length&&this.f.fire({extensions:h,profileLocation:u}),f}catch(n){throw f.length&&this.b.fire({extensions:f,error:n,profileLocation:u}),h.length&&this.f.fire({extensions:h,error:n,profileLocation:u}),n}}async removeExtensionFromProfile(m,u){const h=[];this.c.fire({extensions:h,profileLocation:u});try{await this.l(u,f=>{const n=[];for(const s of f)(0,I.areSameExtensions)(s.identifier,m.identifier)?h.push(s):n.push(s);return h.length&&this.c.fire({extensions:h,profileLocation:u}),n}),h.length&&this.f.fire({extensions:h,profileLocation:u})}catch(f){throw h.length&&this.f.fire({extensions:h,error:f,profileLocation:u}),f}}async l(m,u){return this.p(m).queue(async()=>{let h=[],f;try{const n=await this.h.readFile(m);f=JSON.parse(n.value.toString())}catch(n){if((0,C.toFileOperationResult)(n)!==1)throw n;this.j.extUri.isEqual(m,this.i.defaultProfile.extensionsResource)&&(f=await this.n())}if(f)for(const n of f){if(!n.identifier){this.k.info("Ignoring invalid extension while scanning. Identifier does not exist.",n);continue}if(!n.location){this.k.info("Ignoring invalid extension while scanning. Location does not exist.",n);continue}if(!n.version){this.k.info("Ignoring invalid extension while scanning. Version does not exist.",n);continue}h.push({identifier:n.identifier,location:P.URI.revive(n.location),version:n.version,metadata:n.metadata})}if(u){h=u(h);const n=h.map(s=>({identifier:s.identifier,version:s.version,location:s.location.toJSON(),metadata:s.metadata}));await this.h.writeFile(m,i.VSBuffer.fromString(JSON.stringify(n)))}return h})}async n(){return this.m||(this.m=(async()=>{const m=this.j.extUri.joinPath(this.i.defaultProfile.location,"extensions.json");let u;try{u=(await this.h.readFile(m)).value.toString()}catch(f){if((0,C.toFileOperationResult)(f)===1)return;throw f}this.k.info("Migrating extensions from old default profile location",m.toString());let h;try{const f=JSON.parse(u);Array.isArray(f)&&f.every(n=>!!(n&&typeof n=="object"&&(0,S.isIExtensionIdentifier)(n.identifier)&&v(n.location)&&n.version&&typeof n.version=="string"))?h=f:this.k.warn("Skipping migrating from old default profile locaiton: Found invalid data",f)}catch(f){this.k.error(f)}if(h)try{await this.h.createFile(this.i.defaultProfile.extensionsResource,i.VSBuffer.fromString(JSON.stringify(h)),{overwrite:!1}),this.k.info("Migrated extensions from old default profile location to new location",m.toString(),this.i.defaultProfile.extensionsResource.toString())}catch(f){if((0,C.toFileOperationResult)(f)===3)this.k.info("Migration from old default profile location to new location is done by another window",m.toString(),this.i.defaultProfile.extensionsResource.toString());else throw f}try{await this.h.del(m)}catch(f){(0,C.toFileOperationResult)(f)!==1&&this.k.error(f)}return h})()),this.m}p(m){let u=this.g.get(m);return u||(u=new D.Queue,this.g.set(m,u)),u}};g=ye([K(0,C.IFileService),K(1,y.IUserDataProfilesService),K(2,d.IUriIdentityService),K(3,w.ILogService)],g),e.ExtensionsProfileScannerService=g;function v(l){return l?typeof l.path=="string"&&typeof l.scheme=="string":!1}}),define(re[79],ae([0,1,20,6,32,17,9,35,136,2,24,12,5,21,53,88,15,7,157,14,33,42,70,13,4,8,25,3,67,61,18,30,187,188]),function(_,e,D,i,R,A,L,P,I,S,C,b,w,y,d,g,v,l,m,u,h,f,n,s,t,a,r,c,o,p,E,k,F,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var q;(function(Z){function z(B,Y){if(B===Y)return!0;const ee=Object.keys(B),oe=new Set;for(const J of Object.keys(Y))oe.add(J);if(ee.length!==oe.size)return!1;for(const J of ee){if(B[J]!==Y[J])return!1;oe.delete(J)}return oe.size===0}Z.equals=z})(q=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let j=class extends S.Disposable{constructor(z,B,Y,ee,oe,J,Q,T,M,V,W,X){super(),this.systemExtensionsLocation=z,this.userExtensionsLocation=B,this.l=Y,this.m=ee,this.n=oe,this.p=J,this.r=Q,this.s=T,this.t=M,this.u=V,this.v=W,this.w=X,this.g=this.B(new c.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,y.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance($,(0,y.joinPath)(this.m,f.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance($,(0,y.joinPath)(this.m,f.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(U,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,h.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(z,B,Y){const[ee,oe]=await Promise.all([this.scanSystemExtensions(z),this.scanUserExtensions(B)]),J=Y?await this.scanExtensionsUnderDevelopment(z,[...ee,...oe]):[];return this.D(ee,oe,J,await this.getTargetPlatform(),!0)}async scanSystemExtensions(z){const B=[];B.push(this.F(!!z.useCache,z.language)),B.push(this.G(z.language,!!z.checkControlFile));const[Y,ee]=await Promise.all(B);return this.C([...Y,...ee],0,z,!1)}async scanUserExtensions(z){const B=z.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",B);const Y=await this.I(B,!!z.profileLocation,1,!z.includeUninstalled,z.language);let oe=await(z.useCache&&!Y.devMode&&Y.excludeObsolete?this.j:this.k).scanExtensions(Y);return oe=await this.C(oe,1,z,!0),this.s.trace("Scanned user extensions:",oe.length),oe}async scanExtensionsUnderDevelopment(z,B){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const Y=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(ee=>ee.scheme===C.Schemas.file).map(async ee=>{const oe=await this.I(ee,!1,1,!0,z.language,!1);return(await this.k.scanOneOrMultipleExtensions(oe)).map(Q=>(Q.type=B.find(T=>(0,h.areSameExtensions)(T.identifier,Q.identifier))?.type??Q.type,this.k.validate(Q,oe)))}))).flat();return this.C(Y,"development",z,!0)}return[]}async scanExistingExtension(z,B,Y){const ee=await this.I(z,!1,B,!0,Y.language),oe=await this.k.scanExtension(ee);return!oe||!Y.includeInvalid&&!oe.isValid?null:oe}async scanOneOrMultipleExtensions(z,B,Y){const ee=await this.I(z,!1,B,!0,Y.language),oe=await this.k.scanOneOrMultipleExtensions(ee);return this.C(oe,B,Y,!0)}async scanMetadata(z){const B=(0,y.joinPath)(z,"package.json"),Y=(await this.r.readFile(B)).value.toString();return JSON.parse(Y).__metadata}async updateMetadata(z,B){const Y=(0,y.joinPath)(z,"package.json"),ee=(await this.r.readFile(Y)).value.toString(),oe=JSON.parse(ee);B.isMachineScoped=B.isMachineScoped||void 0,B.isBuiltin=B.isBuiltin||void 0,B.installedTimestamp=B.installedTimestamp||void 0,oe.__metadata={...oe.__metadata,...B},await this.r.writeFile((0,y.joinPath)(z,"package.json"),A.VSBuffer.fromString(JSON.stringify(oe,null,"	")))}initializeDefaultProfileExtensions(){return this.z||(this.z=(async()=>{try{const z=this.v.extUri.joinPath(this.userExtensionsLocation,".init-default-profile-extensions");if(await this.r.exists(z))return;if(!await this.r.exists(this.n.defaultProfile.extensionsResource)&&!await this.r.exists(this.v.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"))){this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const B=await this.scanUserExtensions({includeInvalid:!0});await this.p.addExtensionsToProfile(B.map(Y=>[Y,Y.metadata]),this.n.defaultProfile.extensionsResource),this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}try{await this.r.createFile(z,A.VSBuffer.fromString(""))}catch(B){(0,s.toFileOperationResult)(B)!==1&&this.s.warn("Failed to create default profile extensions initialize marker in extensions installation folder.",this.userExtensionsLocation.toString(),(0,L.getErrorMessage)(B))}}catch(z){throw this.s.error(z),z}})()),this.z}async C(z,B,Y,ee){return Y.includeAllVersions||(z=this.D(B===0?z:void 0,B===1?z:void 0,B==="development"?z:void 0,await this.getTargetPlatform(),ee)),Y.includeInvalid||(z=z.filter(oe=>oe.isValid)),z.sort((oe,J)=>{const Q=b.basename(oe.location.fsPath),T=b.basename(J.location.fsPath);return Q<T?-1:Q>T?1:0})}D(z,B,Y,ee,oe){const J=(T,M,V)=>{if(T.isValid&&!M.isValid)return!1;if(T.isValid===M.isValid){if(oe&&d.gt(T.manifest.version,M.manifest.version))return this.s.debug(`Skipping extension ${M.location.path} with lower version ${M.manifest.version} in favour of ${T.location.path} with version ${T.manifest.version}`),!1;if(d.eq(T.manifest.version,M.manifest.version)){if(T.type===0)return this.s.debug(`Skipping extension ${M.location.path} in favour of system extension ${T.location.path} with same version`),!1;if(T.targetPlatform===ee)return this.s.debug(`Skipping extension ${M.location.path} from different target platform ${M.targetPlatform}`),!1}}return V?this.s.warn(`Overwriting user extension ${T.location.path} with ${M.location.path}.`):this.s.debug(`Overwriting user extension ${T.location.path} with ${M.location.path}.`),!0},Q=new Map;return z?.forEach(T=>{const M=f.ExtensionIdentifier.toKey(T.identifier.id),V=Q.get(M);(!V||J(V,T,!1))&&Q.set(M,T)}),B?.forEach(T=>{const M=f.ExtensionIdentifier.toKey(T.identifier.id),V=Q.get(M);if(!V&&z&&T.type===0){this.s.debug(`Skipping obsolete system extension ${T.location.path}.`);return}(!V||J(V,T,!1))&&Q.set(M,T)}),Y?.forEach(T=>{const M=f.ExtensionIdentifier.toKey(T.identifier.id),V=Q.get(M);(!V||J(V,T,!0))&&Q.set(M,T),Q.set(M,T)}),[...Q.values()]}async F(z,B){this.s.trace("Started scanning system extensions");const Y=await this.I(this.systemExtensionsLocation,!1,0,!0,B),oe=await(z&&!Y.devMode?this.i:this.k).scanExtensions(Y);return this.s.trace("Scanned system extensions:",oe.length),oe}async G(z,B){const Y=this.t.isBuilt?[]:this.u.builtInExtensions;if(!Y?.length)return[];this.s.trace("Started scanning dev system extensions");const ee=B?await this.H():{},oe=[],J=l.URI.file(b.normalize(b.join(C.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const T of Y){const M=ee[T.name]||"marketplace";switch(M){case"disabled":break;case"marketplace":oe.push((0,y.joinPath)(J,T.name));break;default:oe.push(l.URI.file(M));break}}const Q=await Promise.all(oe.map(async T=>this.k.scanExtension(await this.I(T,!1,0,!0,z))));return this.s.trace("Scanned dev system extensions:",Q.length),(0,D.coalesce)(Q)}async H(){try{const z=await this.r.readFile(this.l);return JSON.parse(z.value.toString())}catch{return{}}}async I(z,B,Y,ee,oe,J=!0){const Q=await this.f(oe??w.language),T=await this.J(z),M=B&&!this.v.extUri.isEqual(z,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,V=M?await this.J(M):void 0;return new O(z,T,M,V,B,Y,ee,J,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,oe,Q)}async J(z){try{const B=await this.r.stat(z);if(typeof B.mtime=="number")return B.mtime}catch{}}};j=ye([K(4,E.IUserDataProfilesService),K(5,p.IExtensionsProfileScannerService),K(6,s.IFileService),K(7,a.ILogService),K(8,u.IEnvironmentService),K(9,r.IProductService),K(10,k.IUriIdentityService),K(11,t.IInstantiationService)],j),e.AbstractExtensionsScannerService=j;class O{constructor(z,B,Y,ee,oe,J,Q,T,M,V,W,X,se,x){this.location=z,this.mtime=B,this.applicationExtensionslocation=Y,this.applicationExtensionslocationMtime=ee,this.profile=oe,this.type=J,this.excludeObsolete=Q,this.validate=T,this.productVersion=M,this.productDate=V,this.productCommit=W,this.devMode=X,this.language=se,this.translations=x}static createNlsConfiguration(z){return{language:z.language,pseudo:z.language==="pseudo",devMode:z.devMode,translations:z.translations}}static equals(z,B){return(0,y.isEqual)(z.location,B.location)&&z.mtime===B.mtime&&(0,y.isEqual)(z.applicationExtensionslocation,B.applicationExtensionslocation)&&z.applicationExtensionslocationMtime===B.applicationExtensionslocationMtime&&z.profile===B.profile&&z.type===B.type&&z.excludeObsolete===B.excludeObsolete&&z.validate===B.validate&&z.productVersion===B.productVersion&&z.productDate===B.productDate&&z.productCommit===B.productCommit&&z.devMode===B.devMode&&z.language===B.language&&q.equals(z.translations,B.translations)}}let U=class extends S.Disposable{constructor(z,B,Y,ee,oe){super(),this.f=z,this.g=B,this.h=Y,this.i=ee,this.j=oe}async scanExtensions(z){const B=z.profile?await this.l(z):await this.k(z);let Y={};if(z.excludeObsolete&&z.type===1)try{const ee=(await this.i.readFile(this.f)).value.toString();Y=JSON.parse(ee)}catch{}return(0,v.isEmptyObject)(Y)?B:B.filter(ee=>!Y[h.ExtensionKey.create(ee).toString()])}async k(z){const B=await this.i.resolve(z.location);if(!B.children?.length)return[];const Y=await Promise.all(B.children.map(async ee=>{if(!ee.isDirectory||z.type===1&&(0,y.basename)(ee.resource).indexOf(".")===0)return null;const oe=new O(ee.resource,z.mtime,z.applicationExtensionslocation,z.applicationExtensionslocationMtime,z.profile,z.type,z.excludeObsolete,z.validate,z.productVersion,z.productDate,z.productCommit,z.devMode,z.language,z.translations);return this.scanExtension(oe)}));return(0,D.coalesce)(Y).sort((ee,oe)=>ee.location.path<oe.location.path?-1:1)}async l(z){let B=await this.m(z.location,()=>!0,z);if(z.applicationExtensionslocation&&!this.h.extUri.isEqual(z.location,z.applicationExtensionslocation)){B=B.filter(ee=>!ee.metadata?.isApplicationScoped);const Y=await this.m(z.applicationExtensionslocation,ee=>!!ee.metadata?.isApplicationScoped,z);B.push(...Y)}return B}async m(z,B,Y){const ee=await this.g.scanProfileExtensions(z);if(!ee.length)return[];const oe=await Promise.all(ee.map(async J=>{if(B(J)){const Q=new O(J.location,Y.mtime,Y.applicationExtensionslocation,Y.applicationExtensionslocationMtime,Y.profile,Y.type,Y.excludeObsolete,Y.validate,Y.productVersion,Y.productDate,Y.productCommit,Y.devMode,Y.language,Y.translations);return this.scanExtension(Q,J.metadata)}return null}));return(0,D.coalesce)(oe)}async scanOneOrMultipleExtensions(z){try{if(await this.i.exists((0,y.joinPath)(z.location,"package.json"))){const B=await this.scanExtension(z);return B?[B]:[]}else return await this.scanExtensions(z)}catch(B){return this.j.error(`Error scanning extensions at ${z.location.path}:`,(0,L.getErrorMessage)(B)),[]}}async scanExtension(z,B){try{let Y=await this.scanExtensionManifest(z.location);if(Y){Y.publisher||(Y.publisher=f.UNDEFINED_PUBLISHER),B=B??Y.__metadata,delete Y.__metadata;const ee=(0,h.getGalleryExtensionId)(Y.publisher,Y.name),oe=B?.id?{id:ee,uuid:B.id}:{id:ee},J=B?.isSystem?0:z.type,Q=J===0||!!B?.isBuiltin;N.ImplicitActivationEvents.updateManifest(Y),Y=await this.n(z.location,Y,O.createNlsConfiguration(z));const T={type:J,identifier:oe,manifest:Y,location:z.location,isBuiltin:Q,targetPlatform:B?.targetPlatform??"undefined",metadata:B,isValid:!0,validations:[]};return z.validate?this.validate(T,z):T}}catch(Y){z.type!==0&&this.j.error(Y)}return null}validate(z,B){let Y=!0;const ee=(0,n.validateExtensionManifest)(B.productVersion,B.productDate,B.location,z.manifest,z.isBuiltin);for(const[oe,J]of ee)oe===g.default.Error&&(Y=!1,this.j.error(this.t(B.location,J)));return z.isValid=Y,z.validations=ee,z}async scanExtensionManifest(z){const B=(0,y.joinPath)(z,"package.json");let Y;try{Y=(await this.i.readFile(B)).value.toString()}catch(oe){return(0,s.toFileOperationResult)(oe)!==1&&this.j.error(this.t(z,(0,m.localize)(0,null,B.path,oe.message))),null}let ee;try{ee=JSON.parse(Y)}catch{const J=[];(0,P.parse)(Y,J);for(const Q of J)this.j.error(this.t(z,(0,m.localize)(1,null,B.path,Q.offset,Q.length,(0,I.getParseErrorMessage)(Q.error))));return null}return(0,P.getNodeType)(ee)!=="object"?(this.j.error(this.t(z,(0,m.localize)(2,null,B.path))),null):ee}async n(z,B,Y){const ee=await this.p(z,B,Y);if(ee)try{const oe=[],J=await this.r(ee.default,oe);if(oe.length>0)return oe.forEach(T=>{this.j.error(this.t(z,(0,m.localize)(3,null,ee.default?.path,(0,I.getParseErrorMessage)(T.error))))}),B;if((0,P.getNodeType)(ee)!=="object")return this.j.error(this.t(z,(0,m.localize)(4,null,ee.default?.path))),B;const Q=ee.values||Object.create(null);return(0,F.localizeManifest)(B,Q,J)}catch{}return B}async p(z,B,Y){const ee=(0,y.joinPath)(z,"package.nls.json"),oe=(M,V)=>{V.forEach(W=>{this.j.error(this.t(z,(0,m.localize)(5,null,M?.path,(0,I.getParseErrorMessage)(W.error))))})},J=M=>{this.j.error(this.t(z,(0,m.localize)(6,null,M?.path)))},Q=`${B.publisher}.${B.name}`,T=Y.translations[Q];if(T)try{const M=l.URI.file(T),V=(await this.i.readFile(M)).value.toString(),W=[],X=(0,P.parse)(V,W);return W.length>0?(oe(M,W),{values:void 0,default:ee}):(0,P.getNodeType)(X)!=="object"?(J(M),{values:void 0,default:ee}):{values:X.contents?X.contents.package:void 0,default:ee}}catch{return{values:void 0,default:ee}}else{if(!await this.i.exists(ee))return;let V;try{V=await this.s(z,Y)}catch{return}if(!V.localized)return{values:void 0,default:V.original};try{const W=(await this.i.readFile(V.localized)).value.toString(),X=[],se=(0,P.parse)(W,X);return X.length>0?(oe(V.localized,X),{values:void 0,default:V.original}):(0,P.getNodeType)(se)!=="object"?(J(V.localized),{values:void 0,default:V.original}):{values:se,default:V.original}}catch{return{values:void 0,default:V.original}}}}async r(z,B){if(z)try{const Y=(await this.i.readFile(z)).value.toString();return(0,P.parse)(Y,B)}catch{}}s(z,B){return new Promise((Y,ee)=>{const oe=J=>{const Q=(0,y.joinPath)(z,`package.nls.${J}.json`);this.i.exists(Q).then(T=>{T&&Y({localized:Q,original:(0,y.joinPath)(z,"package.nls.json")});const M=J.lastIndexOf("-");M===-1?Y({localized:(0,y.joinPath)(z,"package.nls.json"),original:null}):(J=J.substring(0,M),oe(J))})};if(B.devMode||B.pseudo||!B.language)return Y({localized:(0,y.joinPath)(z,"package.nls.json"),original:null});oe(B.language)})}t(z,B){return`[${z.path}]: ${B}`}};U=ye([K(1,p.IExtensionsProfileScannerService),K(2,k.IUriIdentityService),K(3,s.IFileService),K(4,a.ILogService)],U);let $=class extends U{constructor(z,B,Y,ee,oe,J){super(B,Y,ee,oe,J),this.y=z,this.v=this.B(new i.ThrottledDelayer(3e3)),this.w=this.B(new c.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(z){const B=await this.z();if(this.u=z,B&&B.input&&O.equals(B.input,this.u))return this.v.trigger(()=>this.D()),B.result.map(ee=>(ee.location=l.URI.revive(ee.location),ee));const Y=await super.scanExtensions(z);return await this.C({input:z,result:Y}),Y}async z(){try{const z=await this.i.readFile(this.y),B=JSON.parse(z.value.toString());return{result:B.result,input:(0,o.revive)(B.input)}}catch(z){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,L.getErrorMessage)(z))}return null}async C(z){try{await this.i.writeFile(this.y,A.VSBuffer.fromString(JSON.stringify(z)))}catch(B){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,L.getErrorMessage)(B))}}async D(){if(!this.u)return;const z=await this.z();if(!z)return;const B=z.result,Y=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!R.equals(Y,B))try{await this.i.del(this.y),this.w.fire()}catch(ee){this.j.error(ee)}}};$=ye([K(2,p.IExtensionsProfileScannerService),K(3,k.IUriIdentityService),K(4,s.IFileService),K(5,a.ILogService)],$);function G(Z,z){const B=(0,h.getExtensionId)(Z.manifest.publisher,Z.manifest.name);return{id:B,identifier:new f.ExtensionIdentifier(B),isBuiltin:Z.type===0,isUserBuiltin:Z.type===1&&Z.isBuiltin,isUnderDevelopment:z,extensionLocation:Z.location,uuid:Z.identifier.uuid,targetPlatform:Z.targetPlatform,...Z.manifest}}e.toExtensionDescription=G;class H extends j{constructor(z,B,Y,ee,oe,J,Q,T,M,V,W,X){super(z,B,(0,y.joinPath)(Y,".vscode-oss-dev","extensions","control.json"),(0,y.joinPath)(ee,f.MANIFEST_CACHE_FOLDER),oe,J,Q,T,M,V,W,X),this.L=(async()=>{if(w.translationsConfigFile)try{const se=await this.r.readFile(l.URI.file(w.translationsConfigFile));return JSON.parse(se.value.toString())}catch{}return Object.create(null)})()}f(z){return this.L}}e.NativeExtensionsScannerService=H}),define(re[263],ae([0,1,49,6,38,3,2,24,12,28,8,18]),function(_,e,D,i,R,A,L,P,I,S,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let w=class extends L.Disposable{constructor(d,g){super(),this.b=d,this.f=g,this.a=new i.Limiter(5)}async postUninstall(d){const g=this.g(d,"uninstall");return g&&(this.f.info(d.identifier.id,d.manifest.version,"Running post uninstall script"),await this.a.queue(()=>this.h(g.script,"uninstall",g.args,!0,d).then(()=>this.f.info(d.identifier.id,d.manifest.version,"Finished running post uninstall script"),v=>this.f.error(d.identifier.id,d.manifest.version,`Failed to run post uninstall script: ${v}`)))),S.Promises.rm(this.j(d)).then(void 0,v=>this.f.error("Error while removing extension storage path",v))}g(d,g){const v=`vscode:${g}`;if(d.location.scheme===P.Schemas.file&&d.manifest&&d.manifest.scripts&&typeof d.manifest.scripts[v]=="string"){const l=d.manifest.scripts[v].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.f.warn(d.identifier.id,d.manifest.version,`${v} should be a node script`),null):{script:(0,I.join)(d.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}h(d,g,v,l,m){return new Promise((u,h)=>{const f=this.i(d,g,v,m);let n;const s=t=>{n&&(clearTimeout(n),n=null),t?h(t):u(void 0)};f.on("error",t=>{s((0,R.toErrorMessage)(t)||"Unknown")}),f.on("exit",(t,a)=>{s(t?`post-${g} process exited with code ${t}`:void 0)}),l&&(n=setTimeout(()=>{n=null,f.kill(),h("timed out")},5e3))})}i(d,g,v,l){const m={silent:!0,execArgv:void 0},u=(0,D.fork)(d,[`--type=extension-post-${g}`,...v],m);u.stdout.setEncoding("utf8"),u.stderr.setEncoding("utf8");const h=A.Event.fromNodeEventEmitter(u.stdout,"data"),f=A.Event.fromNodeEventEmitter(u.stderr,"data");h(t=>this.f.info(l.identifier.id,l.manifest.version,`post-${g}`,t)),f(t=>this.f.error(l.identifier.id,l.manifest.version,`post-${g}`,t));const n=A.Event.any(A.Event.map(h,t=>({data:`%c${t}`,format:[""]})),A.Event.map(f,t=>({data:`%c${t}`,format:["color: red"]})));return A.Event.debounce(n,(t,a)=>t?{data:t.data+a.data,format:[...t.format,...a.format]}:{data:a.data,format:a.format},100)(t=>{console.group(l.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),u}j(d){return(0,I.join)(this.b.defaultProfile.globalStorageHome.fsPath,d.identifier.id.toLowerCase())}};w=ye([K(0,b.IUserDataProfilesService),K(1,C.ILogService)],w),e.ExtensionsLifecycle=w}),define(re[264],ae([0,1,7,14,61,79,13,4,8,25,30,18]),function(_,e,D,i,R,A,L,P,I,S,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let w=class extends A.NativeExtensionsScannerService{constructor(d,g,v,l,m,u,h,f){super(D.URI.file(m.builtinExtensionsPath),D.URI.file(m.extensionsPath),m.userHome,D.URI.file(m.userDataPath),d,g,v,l,m,u,h,f)}};w=ye([K(0,b.IUserDataProfilesService),K(1,R.IExtensionsProfileScannerService),K(2,L.IFileService),K(3,I.ILogService),K(4,i.INativeEnvironmentService),K(5,S.IProductService),K(6,C.IUriIdentityService),K(7,P.IInstantiationService)],w),e.ExtensionsScannerService=w}),define(re[19],ae([0,1,6,3,2,206,15,69,4,18]),function(_,e,D,i,R,A,L,P,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,I.createDecorator)("storageService");var C;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(C=e.WillSaveStateReason||(e.WillSaveStateReason={}));var b;(function(m){m[m.APPLICATION=-1]="APPLICATION",m[m.PROFILE=0]="PROFILE",m[m.WORKSPACE=1]="WORKSPACE"})(b=e.StorageScope||(e.StorageScope={}));var w;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(w=e.StorageTarget||(e.StorageTarget={}));function y(m){const u=m.get(e.TARGET_KEY);if(u)try{return JSON.parse(u)}catch{}return Object.create(null)}e.loadKeyTargets=y;class d extends R.Disposable{constructor(u={flushInterval:d.a}){super(),this.j=u,this.b=this.B(new i.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new i.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new i.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new D.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new R.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,D.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,R.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.J()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(u,h){if(h===e.TARGET_KEY){switch(u){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:u})}else this.b.fire({scope:u,key:h,target:this.F(u)[h]})}r(u){this.f.fire({reason:u})}get(u,h,f){return this.L(h)?.get(u,f)}getBoolean(u,h,f){return this.L(h)?.getBoolean(u,f)}getNumber(u,h,f){return this.L(h)?.getNumber(u,f)}store(u,h,f,n){if((0,L.isUndefinedOrNull)(h)){this.remove(u,f);return}this.t(()=>{this.u(u,f,n),this.L(f)?.set(u,h)})}remove(u,h){this.t(()=>{this.u(u,h,void 0),this.L(h)?.delete(u)})}t(u){this.b.pause(),this.c.pause();try{u()}finally{this.b.resume(),this.c.resume()}}keys(u,h){const f=[],n=this.F(u);for(const s of Object.keys(n))n[s]===h&&f.push(s);return f}u(u,h,f){const n=this.F(h);typeof f=="number"?n[u]!==f&&(n[u]=f,this.L(h)?.set(e.TARGET_KEY,JSON.stringify(n))):typeof n[u]=="number"&&(delete n[u],this.L(h)?.set(e.TARGET_KEY,JSON.stringify(n)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(u){switch(u){case-1:return this.D;case 0:return this.z;default:return this.w}}G(u){const h=this.L(u);return h?y(h):Object.create(null)}isNew(u){return this.getBoolean(e.IS_NEW_KEY,u)===!0}async flush(u=C.NONE){this.f.fire({reason:u});const h=this.L(-1),f=this.L(0),n=this.L(1);switch(u){case C.NONE:await D.Promises.settled([h?.whenFlushed()??Promise.resolve(),f?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await D.Promises.settled([h?.flush(0)??Promise.resolve(),f?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const u=this.L(-1)?.items??new Map,h=this.L(0)?.items??new Map,f=this.L(1)?.items??new Map;return l(u,h,f,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(u,h){return this.r(C.NONE),(0,S.isUserDataProfile)(u)?this.N(u,h):this.O(u,h)}H(u,h){return!(u.id===h.id||g(h)&&g(u))}I(u,h,f,n){this.t(()=>{if(n)for(const[s,t]of u)h.set(s,t);else{const s=new Set;for(const[t,a]of u)s.add(t),h.get(t)!==a&&this.n(f,t);for(const[t]of h.items)s.has(t)||this.n(f,t)}})}}e.AbstractStorageService=d,d.a=60*1e3;function g(m){return m.isDefault||!!m.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=g;class v extends d{constructor(){super(),this.p=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(u=>this.n(1,u))),this.B(this.P.onDidChangeStorage(u=>this.n(0,u))),this.B(this.p.onDidChangeStorage(u=>this.n(-1,u)))}L(u){switch(u){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(u){switch(u){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(u){return!1}}e.InMemoryStorageService=v;async function l(m,u,h,f,n,s){const t=N=>{try{return JSON.parse(N)}catch{return N}},a=new Map,r=new Map;m.forEach((N,q)=>{a.set(q,N),r.set(q,t(N))});const c=new Map,o=new Map;u.forEach((N,q)=>{c.set(q,N),o.set(q,t(N))});const p=new Map,E=new Map;h.forEach((N,q)=>{p.set(q,N),E.set(q,t(N))}),console.group(f!==n?`Storage: Application (path: ${f})`:`Storage: Application & Profile (path: ${f}, default profile)`);const k=[];if(a.forEach((N,q)=>{k.push({key:q,value:N})}),console.table(k),console.groupEnd(),console.log(r),f!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const N=[];c.forEach((q,j)=>{N.push({key:j,value:q})}),console.table(N),console.groupEnd(),console.log(o)}console.group(`Storage: Workspace (path: ${s})`);const F=[];p.forEach((N,q)=>{F.push({key:q,value:N})}),console.table(F),console.groupEnd(),console.log(E)}e.logStorage=l}),define(re[116],ae([0,1,3,2,15,29,33,19]),function(_,e,D,i,R,A,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let I=class extends i.Disposable{constructor(b,w){super(),this.a=new D.Emitter,this.onDidChangeEnablement=this.a.event,this.b=this.B(new S(b)),this.B(this.b.onDidChange(y=>this.a.fire({extensions:y,source:"storage"}))),this.B(w.onDidInstallExtensions(y=>y.forEach(({local:d,operation:g})=>{d&&g===4&&this.f(d.identifier)})))}async enableExtension(b,w){return this.f(b)?(this.a.fire({extensions:[b],source:w}),!0):!1}async disableExtension(b,w){return this.c(b)?(this.a.fire({extensions:[b],source:w}),!0):!1}getDisabledExtensions(){return this.h(A.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(b){const w=this.getDisabledExtensions();return w.every(y=>!(0,L.areSameExtensions)(y,b))?(w.push(b),this.g(w),!0):!1}f(b){const w=this.getDisabledExtensions();for(let y=0;y<w.length;y++){const d=w[y];if((0,L.areSameExtensions)(d,b))return w.splice(y,1),this.g(w),!0}return!1}g(b){this.i(A.DISABLED_EXTENSIONS_STORAGE_PATH,b)}h(b){return this.b.get(b,0)}i(b,w){this.b.set(b,w,0)}};I=ye([K(0,P.IStorageService),K(1,A.IExtensionManagementService)],I),e.GlobalExtensionEnablementService=I;class S extends i.Disposable{constructor(b){super(),this.c=b,this.a=Object.create(null),this.b=this.B(new D.Emitter),this.onDidChange=this.b.event,this.B(b.onDidChangeValue(w=>this.f(w)))}get(b,w){let y;return w===0?((0,R.isUndefinedOrNull)(this.a[b])&&(this.a[b]=this.g(b,w)),y=this.a[b]):y=this.g(b,w),JSON.parse(y)}set(b,w,y){const d=JSON.stringify(w.map(({id:v,uuid:l})=>({id:v,uuid:l})));this.g(b,y)!==d&&(y===0&&(w.length?this.a[b]=d:delete this.a[b]),this.h(b,w.length?d:void 0,y))}f(b){if(b.scope===0&&!(0,R.isUndefinedOrNull)(this.a[b.key])&&this.g(b.key,b.scope)!==this.a[b.key]){const y=this.get(b.key,b.scope);delete this.a[b.key];const d=this.get(b.key,b.scope),g=y.filter(l=>!d.some(m=>(0,L.areSameExtensions)(l,m))),v=d.filter(l=>!y.some(m=>(0,L.areSameExtensions)(m,l)));(g.length||v.length)&&this.b.fire([...g,...v])}}g(b,w){return this.c.get(b,w,"[]")}h(b,w,y){w?this.c.store(b,w,y,1):this.c.remove(b,y)}}e.StorageManager=S}),define(re[265],ae([0,1,20,23,9,5,36,15,7,16,14,29,33,70,13,8,25,59,236,19,22]),function(_,e,D,i,R,A,L,P,I,S,C,b,w,y,d,g,v,l,m,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const f=A.isWeb?"web":(0,b.getTargetPlatform)(A.platform,L.arch);var n;(function(T){T[T.None=0]="None",T[T.IncludeVersions=1]="IncludeVersions",T[T.IncludeFiles=2]="IncludeFiles",T[T.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",T[T.IncludeSharedAccounts=8]="IncludeSharedAccounts",T[T.IncludeVersionProperties=16]="IncludeVersionProperties",T[T.ExcludeNonValidated=32]="ExcludeNonValidated",T[T.IncludeInstallationTargets=64]="IncludeInstallationTargets",T[T.IncludeAssetUri=128]="IncludeAssetUri",T[T.IncludeStatistics=256]="IncludeStatistics",T[T.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",T[T.Unpublished=4096]="Unpublished",T[T.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function s(...T){return String(T.reduce((M,V)=>M|V,0))}var t;(function(T){T[T.Tag=1]="Tag",T[T.ExtensionId=4]="ExtensionId",T[T.Category=5]="Category",T[T.ExtensionName=7]="ExtensionName",T[T.Target=8]="Target",T[T.Featured=9]="Featured",T[T.SearchText=10]="SearchText",T[T.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},r={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},o={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class p{constructor(M=o){this.d=M}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(M,V=this.d.pageSize){return new p({...this.d,pageNumber:M,pageSize:V})}withFilter(M,...V){const W=[...this.d.criteria,...V.length?V.map(X=>({filterType:M,value:X})):[{filterType:M}]];return new p({...this.d,criteria:W})}withSortBy(M){return new p({...this.d,sortBy:M})}withSortOrder(M){return new p({...this.d,sortOrder:M})}withFlags(...M){return new p({...this.d,flags:M.reduce((V,W)=>V|W,0)})}withAssetTypes(...M){return new p({...this.d,assetTypes:M})}withSource(M){return new p({...this.d,source:M})}get raw(){const{criteria:M,pageNumber:V,pageSize:W,sortBy:X,sortOrder:se,flags:x,assetTypes:ie}=this.d;return{filters:[{criteria:M,pageNumber:V,pageSize:W,sortBy:X,sortOrder:se}],assetTypes:ie,flags:x}}get searchText(){const M=this.d.criteria.filter(V=>V.filterType===t.SearchText)[0];return M&&M.value?M.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(M=>String(M.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function E(T,M){const V=(T||[]).filter(W=>W.statisticName===M)[0];return V?V.value:0}function k(T){const M="Microsoft.VisualStudio.Code.Translation.";return T.files.filter(W=>W.assetType.indexOf(M)===0).reduce((W,X)=>{const se=q(T,X.assetType);return se&&W.push([X.assetType.substring(M.length),se]),W},[])}function F(T){if(T.properties){const M=T.properties.filter(X=>X.key===a.Repository),V=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),W=M.filter(X=>V.test(X.value))[0];return W?{uri:W.value,fallbackUri:W.value}:null}return q(T,a.Repository)}function N(T){return{uri:`${T.fallbackAssetUri}/${a.VSIX}?redirect=true${T.targetPlatform?`&targetPlatform=${T.targetPlatform}`:""}`,fallbackUri:`${T.fallbackAssetUri}/${a.VSIX}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`}}function q(T,M){return T.files.filter(W=>W.assetType===M)[0]?{uri:`${T.assetUri}/${M}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`,fallbackUri:`${T.fallbackAssetUri}/${M}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`}:null}function j(T,M){const V=T.properties?T.properties.filter(X=>X.key===M):[],W=V.length>0&&V[0].value;return W?W.split(",").map(X=>(0,w.adoptToGalleryExtensionId)(X)):[]}function O(T){const M=T.properties?T.properties.filter(V=>V.key===r.Engine):[];return M.length>0&&M[0].value||""}function U(T){const M=T.properties?T.properties.filter(V=>V.key===r.PreRelease):[];return M.length>0&&M[0].value==="true"}function $(T){const M=T.properties?T.properties.filter(W=>W.key===r.LocalizedLanguages):[],V=M.length>0&&M[0].value||"";return V?V.split(","):[]}function G(T){return T.properties?.find(M=>M.key===r.SponsorLink)?.value}function H(T){return T.indexOf("preview")!==-1}function Z(T){return T.targetPlatform?(0,b.toTargetPlatform)(T.targetPlatform):"undefined"}function z(T){const M=(0,D.distinct)(T.versions.map(Z)),V=!!T.tags?.includes(b.WEB_EXTENSION_TAG),W=M.indexOf("web");return V?W===-1&&M.push("web"):W!==-1&&M.splice(W,1),M}function B(T,M){const V=(0,b.getFallbackTargetPlarforms)(M);for(let W=0;W<T.length;W++){const X=T[W];if(X.version===T[W-1]?.version){let se=W;const x=Z(X);if(x===M)for(;se>0&&T[se-1].version===X.version;)se--;else if(V.includes(x))for(;se>0&&T[se-1].version===X.version&&Z(T[se-1])!==M;)se--;se!==W&&(T.splice(W,1),T.splice(se,0,X))}}return T}e.sortExtensionVersions=B;function Y(T,M,V){T.telemetryData={index:M,querySource:V}}function ee(T,M,V){const W=T.versions[0],X={manifest:q(M,a.Manifest),readme:q(M,a.Details),changelog:q(M,a.Changelog),license:q(M,a.License),repository:F(M),download:N(M),icon:q(M,a.Icon),signature:q(M,a.Signature),coreTranslations:k(M)};return{identifier:{id:(0,w.getGalleryExtensionId)(T.publisher.publisherName,T.extensionName),uuid:T.extensionId},name:T.extensionName,version:M.version,displayName:T.displayName,publisherId:T.publisher.publisherId,publisher:T.publisher.publisherName,publisherDisplayName:T.publisher.displayName,publisherDomain:T.publisher.domain?{link:T.publisher.domain,verified:!!T.publisher.isDomainVerified}:void 0,publisherSponsorLink:G(W),description:T.shortDescription||"",installCount:E(T.statistics,"install"),rating:E(T.statistics,"averagerating"),ratingCount:E(T.statistics,"ratingcount"),categories:T.categories||[],tags:T.tags||[],releaseDate:Date.parse(T.releaseDate),lastUpdated:Date.parse(T.lastUpdated),allTargetPlatforms:V,assets:X,properties:{dependencies:j(M,r.Dependency),extensionPack:j(M,r.ExtensionPack),engine:O(M),localizedLanguages:$(M),targetPlatform:Z(M),isPreReleaseVersion:U(M)},hasPreReleaseVersion:U(W),hasReleaseVersion:!0,preview:H(T.flags),isSigned:!!X.signature}}let oe=class{constructor(M,V,W,X,se,x,ie,ne){this.k=V,this.l=W,this.n=X,this.o=se,this.q=x,this.u=ie,this.w=ne;const le=ie.extensionsGallery,ue=le?.servicePPEUrl&&ne.getValue("_extensionsGallery.enablePPE");this.d=ue?le.servicePPEUrl:le?.serviceUrl,this.g=ue?void 0:le?.searchUrl,this.h=le?.controlUrl,this.j=(0,m.resolveMarketplaceHeaders)(ie.version,ie,this.n,this.w,this.q,M,this.o)}x(M=""){return`${this.d}${M}`}isEnabled(){return!!this.d}async getExtensions(M,V,W){const X=i.CancellationToken.isCancellationToken(V)?{}:V,se=i.CancellationToken.isCancellationToken(V)?V:W,x=[],ie=[],ne=[],le=[];let ue=!0;for(const be of M){be.uuid?ie.push(be.uuid):x.push(be.id);const Ee=!!(be.version||be.preRelease);ne.push({id:be.id,uuid:be.uuid,includePreRelease:Ee}),be.version&&le.push({id:be.id,uuid:be.uuid,version:be.version}),ue=ue&&!!be.hasPreRelease&&!Ee}if(!ie.length&&!x.length)return[];let pe=new p().withPage(1,M.length);ie.length&&(pe=pe.withFilter(t.ExtensionId,...ie)),x.length&&(pe=pe.withFilter(t.ExtensionName,...x)),(X.queryAllVersions||ue)&&(pe=pe.withFlags(pe.flags,n.IncludeVersions)),X.source&&(pe=pe.withSource(X.source));const{extensions:Se}=await this.z(pe,{targetPlatform:X.targetPlatform??f,includePreRelease:ne,versions:le,compatible:!!X.compatible},se);return X.source&&Se.forEach((be,Ee)=>Y(be,Ee,X.source)),Se}async getCompatibleExtension(M,V,W){if((0,b.isNotWebExtensionInWebTargetPlatform)(M.allTargetPlatforms,W))return null;if(await this.isExtensionCompatible(M,V,W))return M;const X=new p().withFlags(n.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,M.identifier.uuid),{extensions:se}=await this.z(X,{targetPlatform:W,compatible:!0,includePreRelease:V},i.CancellationToken.None);return se[0]||null}async isExtensionCompatible(M,V,W){if(!(0,b.isTargetPlatformCompatible)(M.properties.targetPlatform,M.allTargetPlatforms,W)||!V&&M.properties.isPreReleaseVersion)return!1;let X=M.properties.engine;if(!X){const se=await this.getManifest(M,i.CancellationToken.None);if(!se)throw new Error("Manifest was not found");X=se.engines.vscode}return(0,y.isEngineValid)(X,this.u.version,this.u.date)}async y(M,V,W,X,se){if(!(0,b.isTargetPlatformCompatible)(Z(M),X,se)||V!=="any"&&U(M)!==(V==="prerelease"))return!1;if(W)try{const x=await this.E(M);if(!(0,y.isEngineValid)(x,this.u.version,this.u.date))return!1}catch(x){return this.l.error(`Error while getting the engine for the version ${M.version}.`,(0,R.getErrorMessage)(x)),!1}return!0}async query(M,V){let W=M.text||"";const X=M.pageSize??50;let se=new p().withPage(1,X);W?(W=W.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,pe,Se)=>(se=se.withFilter(t.Category,Se||pe),"")),W=W.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,pe,Se)=>(se=se.withFilter(t.Tag,Se||pe),"")),W=W.replace(/\bfeatured(\s+|\b|$)/g,()=>(se=se.withFilter(t.Featured),"")),W=W.trim(),W&&(W=W.length<200?W:W.substring(0,200),se=se.withFilter(t.SearchText,W)),se=se.withSortBy(0)):M.ids?se=se.withFilter(t.ExtensionId,...M.ids):M.names?se=se.withFilter(t.ExtensionName,...M.names):se=se.withSortBy(4),typeof M.sortBy=="number"&&(se=se.withSortBy(M.sortBy)),typeof M.sortOrder=="number"&&(se=se.withSortOrder(M.sortOrder)),M.source&&(se=se.withSource(M.source));const x=async(ue,pe)=>{const{extensions:Se,total:be}=await this.z(ue,{targetPlatform:f,compatible:!1,includePreRelease:!!M.includePreRelease},pe);return Se.forEach((Ee,Ne)=>Y(Ee,(ue.pageNumber-1)*ue.pageSize+Ne,M.source)),{extensions:Se,total:be}},{extensions:ie,total:ne}=await x(se,V),le=async(ue,pe)=>{if(pe.isCancellationRequested)throw new R.CancellationError;const{extensions:Se}=await x(se.withPage(ue+1),pe);return Se};return{firstPage:ie,total:ne,pageSize:se.pageSize,getPage:le}}async z(M,V,W){const X=M.flags;!!(M.flags&n.IncludeLatestVersionOnly)&&!!(M.flags&n.IncludeVersions)&&(M=M.withFlags(M.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(M.flags&n.IncludeLatestVersionOnly)&&!(M.flags&n.IncludeVersions)&&(M=M.withFlags(M.flags,n.IncludeLatestVersionOnly)),V.versions?.length&&(M=M.withFlags(M.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),M=M.withFlags(M.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:se,total:x}=await this.B(M,W);if(!(M.flags&n.IncludeLatestVersionOnly)){const ue=[];for(const pe of se){const Se=await this.A(pe,V);Se&&ue.push(Se)}return{extensions:ue,total:x}}const ne=[],le=new Map;for(let ue=0;ue<se.length;ue++){const pe=se[ue],Se={id:(0,w.getGalleryExtensionId)(pe.publisher.publisherName,pe.extensionName),uuid:pe.extensionId},be=(0,P.isBoolean)(V.includePreRelease)?V.includePreRelease:!!V.includePreRelease.find(Ne=>(0,w.areSameExtensions)(Ne,Se))?.includePreRelease;if(V.compatible&&(0,b.isNotWebExtensionInWebTargetPlatform)(z(pe),V.targetPlatform))continue;const Ee=await this.A(pe,V);!Ee||Ee.properties.isPreReleaseVersion&&(!be||!Ee.hasReleaseVersion)||!Ee.properties.isPreReleaseVersion&&Ee.properties.targetPlatform!==V.targetPlatform&&Ee.hasPreReleaseVersion?le.set(pe.extensionId,ue):ne.push([ue,Ee])}if(le.size){const ue=new Date().getTime(),pe=new p().withFlags(X&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,le.size).withFilter(t.ExtensionId,...le.keys()),{extensions:Se}=await this.z(pe,V,W);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ue,count:le.size});for(const be of Se){const Ee=le.get(be.identifier.uuid);ne.push([Ee,be])}}return{extensions:ne.sort((ue,pe)=>ue[0]-pe[0]).map(([,ue])=>ue),total:x}}async A(M,V){const W={id:(0,w.getGalleryExtensionId)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},X=V.versions?.find(ne=>(0,w.areSameExtensions)(ne,W))?.version,se=(0,P.isBoolean)(V.includePreRelease)?V.includePreRelease:!!V.includePreRelease.find(ne=>(0,w.areSameExtensions)(ne,W))?.includePreRelease,x=z(M),ie=B(M.versions,V.targetPlatform);if(V.compatible&&(0,b.isNotWebExtensionInWebTargetPlatform)(x,V.targetPlatform))return null;for(let ne=0;ne<ie.length;ne++){const le=ie[ne];if(!(X&&le.version!==X)){if(await this.y(le,se?"any":"release",V.compatible,x,V.targetPlatform))return ee(M,le,x);if(X&&le.version===X)return null}}return X||V.compatible?null:ee(M,M.versions[0],x)}async B(M,V){if(!this.isEnabled())throw new Error("No extension gallery service configured.");M=M.withFlags(M.flags,n.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,s(n.Unpublished));const W=await this.j,X=JSON.stringify(M.raw),se={...W,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(X.length)},x=new Date().getTime();let ie,ne,le=0;try{if(ie=await this.k.request({type:"POST",url:this.g&&M.criteria.some(pe=>pe.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:X,headers:se},V),ie.res.statusCode&&ie.res.statusCode>=400&&ie.res.statusCode<500)return{galleryExtensions:[],total:le};const ue=await(0,l.asJson)(ie);if(ue){const pe=ue.results[0],Se=pe.extensions,be=pe.resultMetadata&&pe.resultMetadata.filter(Ee=>Ee.metadataType==="ResultCount")[0];return le=be&&be.metadataItems.filter(Ee=>Ee.name==="TotalCount")[0].count||0,{galleryExtensions:Se,total:le}}return{galleryExtensions:[],total:le}}catch(ue){throw ne=ue,ue}finally{this.o.publicLog2("galleryService:query",{...M.telemetryData,requestBodySize:String(X.length),duration:new Date().getTime()-x,success:!!ie&&(0,l.isSuccess)(ie),responseBodySize:ie?.res.headers["Content-Length"],statusCode:ie?String(ie.res.statusCode):void 0,errorCode:ne?(0,R.isCancellationError)(ne)?"canceled":(0,R.getErrorMessage)(ne).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(le)})}}async reportStatistic(M,V,W,X){if(!this.isEnabled())return;const se=A.isWeb?this.x(`/itemName/${M}.${V}/version/${W}/statType/${X==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${M}/extensions/${V}/${W}/stats?statType=${X}`),x=A.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ne={...await this.j,Accept:x};try{await this.k.request({type:"POST",url:se,headers:ne},i.CancellationToken.None)}catch{}}async download(M,V,W){this.l.trace("ExtensionGalleryService#download",M.identifier.id);const X=(0,w.getGalleryExtensionTelemetryData)(M),se=new Date().getTime(),x=ue=>this.o.publicLog("galleryService:downloadVSIX",{...X,duration:ue}),ie=W===2?"install":W===3?"update":"",ne=ie?{uri:`${M.assets.download.uri}${I.URI.parse(M.assets.download.uri).query?"&":"?"}${ie}=true`,fallbackUri:`${M.assets.download.fallbackUri}${I.URI.parse(M.assets.download.fallbackUri).query?"&":"?"}${ie}=true`}:M.assets.download,le=await this.D(ne);await this.q.writeFile(V,le.stream),x(new Date().getTime()-se)}async downloadSignatureArchive(M,V){if(!M.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",M.identifier.id);const W=await this.D(M.assets.signature);await this.q.writeFile(V,W.stream)}async getReadme(M,V){if(M.assets.readme){const W=await this.D(M.assets.readme,{},V);return await(0,l.asTextOrError)(W)||""}return""}async getManifest(M,V){if(M.assets.manifest){const W=await this.D(M.assets.manifest,{},V),X=await(0,l.asTextOrError)(W);return X?JSON.parse(X):null}return null}async C(M,V){const W=q(M,a.Manifest);if(!W)throw new Error("Manifest was not found");const X={"Accept-Encoding":"gzip"},se=await this.D(W,{headers:X});return await(0,l.asJson)(se)}async getCoreTranslation(M,V){const W=M.assets.coreTranslations.filter(X=>X[0]===V.toUpperCase())[0];if(W){const X=await this.D(W[1]),se=await(0,l.asTextOrError)(X);return se?JSON.parse(se):null}return null}async getChangelog(M,V){if(M.assets.changelog){const W=await this.D(M.assets.changelog,{},V);return await(0,l.asTextOrError)(W)||""}return""}async getAllCompatibleVersions(M,V,W){let X=new p().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);M.identifier.uuid?X=X.withFilter(t.ExtensionId,M.identifier.uuid):X=X.withFilter(t.ExtensionName,M.identifier.id);const{galleryExtensions:se}=await this.B(X,i.CancellationToken.None);if(!se.length)return[];const x=z(se[0]);if((0,b.isNotWebExtensionInWebTargetPlatform)(x,W))return[];const ie=[];await Promise.all(se[0].versions.map(async ue=>{try{await this.y(ue,V?"any":"release",!0,x,W)&&ie.push(ue)}catch{}}));const ne=[],le=new Set;for(const ue of B(ie,W))le.has(ue.version)||(le.add(ue.version),ne.push({version:ue.version,date:ue.lastUpdated,isPreReleaseVersion:U(ue)}));return ne}async D(M,V={},W=i.CancellationToken.None){const X=await this.j,se={type:"GET"},x={...X,...V.headers||{}};V={...V,...se,headers:x};const ie=M.uri,ne=M.fallbackUri,le={...V,url:ie};try{const ue=await this.k.request(le,W);if(ue.res.statusCode===200)return ue;const pe=await(0,l.asTextOrError)(ue);throw new Error(`Expected 200, got back ${ue.res.statusCode} instead.

${pe}`)}catch(ue){if((0,R.isCancellationError)(ue))throw ue;const pe=(0,R.getErrorMessage)(ue);this.o.publicLog2("galleryService:cdnFallback",{url:ie,message:pe});const Se={...V,url:ne};return this.k.request(Se,W)}}async E(M){let V=O(M);if(!V){const W=await this.C(M,i.CancellationToken.None);if(!W)throw new Error("Manifest was not found");V=W.engines.vscode}return V}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const M=await this.k.request({type:"GET",url:this.h},i.CancellationToken.None);if(M.res.statusCode!==200)throw new Error("Could not get extensions report.");const V=await(0,l.asJson)(M),W=[],X={};if(V){for(const se of V.malicious)W.push({id:se});if(V.migrateToPreRelease)for(const[se,x]of Object.entries(V.migrateToPreRelease))(!x.engine||(0,y.isEngineValid)(x.engine,this.u.version,this.u.date))&&(X[se.toLowerCase()]={disallowInstall:!0,extension:{id:x.id,displayName:x.displayName,autoMigrate:{storage:!!x.migrateStorage},preRelease:!0}});if(V.deprecated)for(const[se,x]of Object.entries(V.deprecated))x&&(X[se.toLowerCase()]=(0,P.isBoolean)(x)?{}:x)}return{malicious:W,deprecated:X}}};oe=ye([K(1,l.IRequestService),K(2,g.ILogService),K(3,C.IEnvironmentService),K(4,h.ITelemetryService),K(5,d.IFileService),K(6,v.IProductService),K(7,S.IConfigurationService)],oe);let J=class extends oe{constructor(M,V,W,X,se,x,ie,ne){super(M,V,W,X,se,x,ie,ne)}};J=ye([K(0,u.IStorageService),K(1,l.IRequestService),K(2,g.ILogService),K(3,C.IEnvironmentService),K(4,h.ITelemetryService),K(5,d.IFileService),K(6,v.IProductService),K(7,S.IConfigurationService)],J),e.ExtensionGalleryService=J;let Q=class extends oe{constructor(M,V,W,X,se,x,ie){super(void 0,M,V,W,X,se,x,ie)}};Q=ye([K(0,l.IRequestService),K(1,g.ILogService),K(2,C.IEnvironmentService),K(3,h.ITelemetryService),K(4,d.IFileService),K(5,v.IProductService),K(6,S.IConfigurationService)],Q),e.ExtensionGalleryServiceWithNoStorageService=Q}),define(re[80],ae([0,1,4,3,2,19,33,25,20,8,15]),function(_,e,D,i,R,A,L,P,I,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,D.createDecorator)("IExtensionStorageService");const b=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let w=class Ze extends R.Disposable{static b(d){return`extensionKeys/${(0,L.adoptToGalleryExtensionId)(d.id)}@${d.version}`}static c(d){const g=b.exec(d);if(g&&g[1])return{id:g[1],version:g[2]}}static async removeOutdatedExtensionVersions(d,g){const v=await d.getInstalled(),l=[];for(const[m,u]of Ze.f(g)){const h=v.find(f=>(0,L.areSameExtensions)(f.identifier,{id:m}))?.manifest.version;for(const f of u)h!==f&&l.push(Ze.b({id:m,version:f}))}for(const m of l)g.remove(m,0)}static f(d){const g=new Map,v=d.keys(0,1);for(const l of v){const m=Ze.c(l);if(m){let u=g.get(m.id.toLowerCase());u||g.set(m.id.toLowerCase(),u=[]),u.push(m.version)}}return g}constructor(d,g,v){super(),this.i=d,this.j=g,this.k=v,this.g=this.B(new i.Emitter),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=Ze.f(d),this.B(this.i.onDidChangeValue(l=>this.l(l)))}l(d){if(d.scope!==0)return;if(this.h.has(d.key.toLowerCase())){this.g.fire();return}const g=Ze.c(d.key);if(g){if(this.i.get(d.key,0)===void 0)this.h.delete(g.id.toLowerCase());else{let v=this.h.get(g.id.toLowerCase());v||this.h.set(g.id.toLowerCase(),v=[]),v.push(g.version),this.g.fire()}return}}m(d){if((0,C.isString)(d))return d;const g=d.manifest?d.manifest.publisher:d.publisher,v=d.manifest?d.manifest.name:d.name;return(0,L.getExtensionId)(g,v)}getExtensionState(d,g){const v=this.m(d),l=this.getExtensionStateRaw(d,g);if(l)try{return JSON.parse(l)}catch(m){this.k.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${v}, global: ${g}): ${m}`)}}getExtensionStateRaw(d,g){const v=this.m(d),l=this.i.get(v,g?0:1);return l&&l?.length>Ze.a&&this.k.warn(`[mainThreadStorage] large extension state detected (extensionId: ${v}, global: ${g}): ${l.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),l}setExtensionState(d,g,v){const l=this.m(d);g===void 0?this.i.remove(l,v?0:1):this.i.store(l,JSON.stringify(g),v?0:1,1)}setKeysForSync(d,g){this.i.store(Ze.b(d),JSON.stringify(g),0,1)}getKeysForSync(d){const g=this.j.extensionSyncedKeys?.[d.id.toLowerCase()],v=this.i.get(Ze.b(d),0),l=v?JSON.parse(v):void 0;return l&&g?(0,I.distinct)([...l,...g]):l||g}addToMigrationList(d,g){if(d!==g){const v=this.n.filter(l=>!l.includes(d)&&!l.includes(g));v.push([d,g]),this.n=v}}getSourceExtensionToMigrate(d){const g=this.n.find(([,v])=>d===v);return g?g[0]:void 0}get n(){const d=this.i.get("extensionStorage.migrationList",-1,"[]");try{const g=JSON.parse(d);if(Array.isArray(g))return g}catch{}return[]}set n(d){d.length?this.i.store("extensionStorage.migrationList",JSON.stringify(d),-1,1):this.i.remove("extensionStorage.migrationList",-1)}};w.a=512*1024,w=ye([K(0,A.IStorageService),K(1,P.IProductService),K(2,S.ILogService)],w),e.ExtensionStorageService=w}),define(re[266],ae([0,1,20,6,3,12,5,36,7,158,14,29,33,211,98,13,57,25,19,22]),function(_,e,D,i,R,A,L,P,I,S,C,b,w,y,d,g,v,l,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const h="extensionTips/promptedExecutableTips",f="extensionTips/lastPromptedMediumImpExeTime";let n=class extends y.ExtensionTipsService{constructor(t,a,r,c,o,p,E,k){super(E,k),this.m=t,this.n=a,this.p=r,this.r=c,this.s=o,this.t=p,this.g=new Map,this.h=new Map,this.j=new Map,this.k=new Map,this.l=new Map,k.exeBasedExtensionTips&&Object.entries(k.exeBasedExtensionTips).forEach(([F,N])=>{const q=[],j=[],O=[];Object.entries(N.recommendations).forEach(([U,$])=>{$.important?N.important?q.push({extensionId:U,extensionName:$.name,isExtensionPack:!!$.isExtensionPack}):j.push({extensionId:U,extensionName:$.name,isExtensionPack:!!$.isExtensionPack}):O.push({extensionId:U,extensionName:$.name,isExtensionPack:!!$.isExtensionPack})}),q.length&&this.g.set(F,{exeFriendlyName:N.friendlyName,windowsPath:N.windowsPath,recommendations:q}),j.length&&this.h.set(F,{exeFriendlyName:N.friendlyName,windowsPath:N.windowsPath,recommendations:j}),O.length&&this.j.set(F,{exeFriendlyName:N.friendlyName,windowsPath:N.windowsPath,recommendations:O})}),(0,i.timeout)(3e3).then(async()=>{await this.u(),this.w(),this.y()})}async getImportantExecutableBasedTips(){const t=await this.I(this.g),a=await this.I(this.h);return[...t,...a]}getOtherExecutableBasedTips(){return this.I(this.j)}async u(){const t=await this.I(this.g),a=await this.I(this.h),r=await this.p.getInstalled();this.k=this.v(t,r),this.l=this.v(a,r)}v(t,a){const r=new Map;t.forEach(k=>r.set(k.extensionId.toLowerCase(),k));const{installed:c,uninstalled:o}=this.H([...r.keys()],a);for(const k of c){const F=r.get(k);F&&this.n.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:k,exeName:F.exeName})}for(const k of o){const F=r.get(k);F&&this.n.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:k,exeName:F.exeName})}const p=this.F(),E=new Map;for(const k of o){const F=r.get(k);if(F&&(!p[F.exeName]||!p[F.exeName].includes(F.extensionId))){let N=E.get(F.exeName);N||(N=[],E.set(F.exeName,N)),N.push(F)}}return E}w(){if(this.k.size===0)return;const[t,a]=[...this.k.entries()][0];this.z(a).then(r=>{switch(r){case"reacted":this.G(a[0].exeName,a);break;case"ignored":this.k.delete(t);break;case"incompatibleWindow":{const c=R.Event.once(R.Event.latch(R.Event.any(this.s.onDidOpenWindow,this.s.onDidFocusWindow)));this.B(c(()=>this.w()));break}case"toomany":{const c=this.B((0,i.disposableTimeout)(()=>{c.dispose(),this.w()},36e5));break}}})}y(){if(this.l.size===0)return;const t=this.C(),a=Date.now()-t,r=7*24*60*60*1e3;if(a<r){const p=this.B((0,i.disposableTimeout)(()=>{p.dispose(),this.y()},r-a));return}const[c,o]=[...this.l.entries()][0];this.z(o).then(p=>{switch(p){case"reacted":{this.D(Date.now()),this.l.delete(c),this.G(o[0].exeName,o);const E=this.B((0,i.disposableTimeout)(()=>{E.dispose(),this.y()},r));break}case"ignored":this.l.delete(c),this.y();break;case"incompatibleWindow":{const E=R.Event.once(R.Event.latch(R.Event.any(this.s.onDidOpenWindow,this.s.onDidFocusWindow)));this.B(E(()=>this.y()));break}case"toomany":{const E=this.B((0,i.disposableTimeout)(()=>{E.dispose(),this.y()},36e5));break}}})}async z(t){const a=await this.p.getInstalled(1),r=t.filter(o=>!o.whenNotInstalled||o.whenNotInstalled.every(p=>a.every(E=>!(0,w.areSameExtensions)(E.identifier,{id:p})))).map(({extensionId:o})=>o.toLowerCase()),c=(0,S.localize)(0,null,t[0].exeFriendlyName);return this.t.promptImportantExtensionsInstallNotification(r,c,`@exe:"${t[0].exeName}"`,3)}C(){let t=this.r.getNumber(f,-1);return t||(t=Date.now(),this.D(t)),t}D(t){this.r.store(f,t,-1,1)}F(){return JSON.parse(this.r.get(h,-1,"{}"))}G(t,a){const r=this.F();r[t]=a.map(({extensionId:c})=>c.toLowerCase()),this.r.store(h,JSON.stringify(r),-1,0)}H(t,a){const r=[],c=[],o=a.reduce((p,E)=>(p.add(E.identifier.id.toLowerCase()),p),new Set);return t.forEach(p=>{o.has(p.toLowerCase())?r.push(p):c.push(p)}),{installed:r,uninstalled:c}}async I(t){const a=[],r=new Map;for(const c of t.keys()){const o=t.get(c);if(!o||!(0,D.isNonEmptyArray)(o.recommendations))continue;const p=[];L.isWindows?o.windowsPath&&p.push(o.windowsPath.replace("%USERPROFILE%",P.env.USERPROFILE).replace("%ProgramFiles(x86)%",P.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",P.env.ProgramFiles).replace("%APPDATA%",P.env.APPDATA).replace("%WINDIR%",P.env.WINDIR)):(p.push((0,A.join)("/usr/local/bin",c)),p.push((0,A.join)("/usr/bin",c)),p.push((0,A.join)(this.m.userHome.fsPath,c)));for(const E of p){let k=r.get(E);if(k===void 0&&(k=await this.b.exists(I.URI.file(E)),r.set(E,k)),k)for(const{extensionId:F,extensionName:N,isExtensionPack:q,whenNotInstalled:j}of o.recommendations)a.push({extensionId:F,extensionName:N,isExtensionPack:q,exeName:c,exeFriendlyName:o.exeFriendlyName,windowsPath:o.windowsPath,whenNotInstalled:j})}}return a}};n=ye([K(0,C.INativeEnvironmentService),K(1,u.ITelemetryService),K(2,b.IExtensionManagementService),K(3,m.IStorageService),K(4,v.INativeHostService),K(5,d.IExtensionRecommendationNotificationService),K(6,g.IFileService),K(7,l.IProductService)],n),e.ExtensionTipsService=n}),define(re[267],ae([0,1,6,2,21,69,19,76,18]),function(_,e,D,i,R,A,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class S extends L.AbstractStorageService{constructor(b,w,y,d){super(),this.X=b,this.Y=w,this.Z=y,this.ab=d,this.p=this.Y.defaultProfile,this.s=this.bb(),this.P=this.Y.currentProfile,this.Q=this.B(new i.DisposableStore),this.R=this.cb(this.P),this.S=this.X?.id,this.U=this.B(new i.DisposableStore),this.W=this.db(this.X)}bb(){const b=this.B(new P.ApplicationStorageDatabaseClient(this.Z.getChannel("storage"))),w=this.B(new A.Storage(b));return this.B(w.onDidChangeStorage(y=>this.n(-1,y))),w}cb(b){this.Q.clear(),this.P=b;let w;if((0,L.isProfileUsingDefaultStorage)(b))w=this.s;else{const y=this.Q.add(new P.ProfileStorageDatabaseClient(this.Z.getChannel("storage"),b));w=this.Q.add(new A.Storage(y))}return this.Q.add(w.onDidChangeStorage(y=>this.n(0,y))),w}db(b){this.U.clear(),this.S=b?.id;let w;if(b){const y=this.U.add(new P.WorkspaceStorageDatabaseClient(this.Z.getChannel("storage"),b));w=this.U.add(new A.Storage(y)),this.U.add(w.onDidChangeStorage(d=>this.n(1,d)))}return w}async J(){await D.Promises.settled([this.s.init(),this.R.init(),this.W?.init()??Promise.resolve()])}L(b){switch(b){case-1:return this.s;case 0:return this.R;default:return this.W}}M(b){switch(b){case-1:return this.p.globalStorageHome.fsPath;case 0:return this.P?.globalStorageHome.fsPath;default:return this.S?`${(0,R.joinPath)(this.ab.workspaceStorageHome,this.S,"state.vscdb").fsPath}`:void 0}}async close(){this.m(),this.r(L.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.s.close(),this.R.close(),this.W?.close()??Promise.resolve()])}async N(b,w){if(!this.H(this.P,b))return;const y=this.R,d=y.items;y!==this.s&&await y.close(),this.R=this.cb(b),await this.R.init(),this.I(d,this.R,0,w)}async O(b,w){const y=this.W,d=y?.items??new Map;await y?.close(),this.W=this.db(b),await this.W.init(),this.I(d,this.W,1,w)}hasScope(b){return(0,I.isUserDataProfile)(b)?this.P.id===b.id:this.S===b.id}}e.NativeStorageService=S}),define(re[62],ae([0,1,2,69,4,19]),function(_,e,D,i,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUserDataProfileStorageService=e.IUserDataProfileStorageService=void 0,e.IUserDataProfileStorageService=(0,R.createDecorator)("IUserDataProfileStorageService");let L=class extends D.Disposable{constructor(S){super(),this.a=S}async readStorageData(S){return this.withProfileScopedStorageService(S,async C=>this.b(C))}async updateStorageData(S,C,b){return this.withProfileScopedStorageService(S,async w=>this.c(w,C,b))}async withProfileScopedStorageService(S,C){if(this.a.hasScope(S))return C(this.a);const b=await this.createStorageDatabase(S),w=new P(b);try{await w.initialize();const y=await C(w);return await w.flush(),y}finally{w.dispose(),await this.f(b)}}b(S){const C=new Map,b=w=>{for(const y of S.keys(0,w))C.set(y,{value:S.get(y,0),target:w})};return b(0),b(1),C}c(S,C,b){for(const[w,y]of C)S.store(w,y,0,b)}async f(S){try{await S.close()}finally{(0,D.isDisposable)(S)&&S.dispose()}}};L=ye([K(0,A.IStorageService)],L),e.AbstractUserDataProfileStorageService=L;class P extends A.AbstractStorageService{constructor(S){super({flushInterval:100}),this.p=this.B(new i.Storage(S))}J(){return this.p.init()}L(S){return S===0?this.p:void 0}M(){}async N(){}async O(){}hasScope(){return!1}}}),define(re[268],ae([0,1,3,2,21,14,56,18]),function(_,e,D,i,R,A,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesNativeService=void 0;let I=class extends i.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this.b}constructor(C,b,w){super(),this.b=[],this.c=this.B(new D.Emitter),this.onDidChangeProfiles=this.c.event,this.f=!0,this.a=b.getChannel("userDataProfiles"),this.profilesHome=(0,R.joinPath)(w.userRoamingDataHome,"profiles"),this.b=C.map(y=>(0,P.reviveProfile)(y,this.profilesHome.scheme)),this.B(this.a.listen("onDidChangeProfiles")(y=>{const d=y.added.map(l=>(0,P.reviveProfile)(l,this.profilesHome.scheme)),g=y.removed.map(l=>(0,P.reviveProfile)(l,this.profilesHome.scheme)),v=y.updated.map(l=>(0,P.reviveProfile)(l,this.profilesHome.scheme));this.b=y.all.map(l=>(0,P.reviveProfile)(l,this.profilesHome.scheme)),this.c.fire({added:d,removed:g,updated:v,all:this.profiles})})),this.onDidResetWorkspaces=this.a.listen("onDidResetWorkspaces")}setEnablement(C){this.f=C}isEnabled(){return this.f}async createNamedProfile(C,b,w){const y=await this.a.call("createNamedProfile",[C,b,w]);return(0,P.reviveProfile)(y,this.profilesHome.scheme)}async createProfile(C,b,w,y){const d=await this.a.call("createProfile",[C,b,w,y]);return(0,P.reviveProfile)(d,this.profilesHome.scheme)}async createTransientProfile(C){const b=await this.a.call("createTransientProfile",[C]);return(0,P.reviveProfile)(b,this.profilesHome.scheme)}async setProfileForWorkspace(C,b){await this.a.call("setProfileForWorkspace",[C,b])}removeProfile(C){return this.a.call("removeProfile",[C])}async updateProfile(C,b){const w=await this.a.call("updateProfile",[C,b]);return(0,P.reviveProfile)(w,this.profilesHome.scheme)}resetWorkspaces(){return this.a.call("resetWorkspaces")}cleanUp(){return this.a.call("cleanUp")}cleanUpTransientProfiles(){return this.a.call("cleanUpTransientProfiles")}};I=ye([K(1,L.IMainProcessService),K(2,A.IEnvironmentService)],I),e.UserDataProfilesNativeService=I}),define(re[269],ae([0,1,3,2,56,8,62,19,76,18,71]),function(_,e,D,i,R,A,L,P,I,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfileStorageService=void 0;let b=class extends L.AbstractUserDataProfileStorageService{constructor(y,d,g,v){super(g),this.h=y;const l=y.getChannel("profileStorageListener"),m=this.B(new i.MutableDisposable);this.g=this.B(new D.Emitter({onWillAddFirstListener:()=>{m.value=l.listen("onDidChange")(u=>{v.trace("profile storage changes",u),this.g.fire({targetChanges:u.targetChanges.map(h=>(0,S.reviveProfile)(h,d.profilesHome.scheme)),valueChanges:u.valueChanges.map(h=>({...h,profile:(0,S.reviveProfile)(h.profile,d.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>m.value=void 0})),this.onDidChange=this.g.event}async createStorageDatabase(y){const d=this.h.getChannel("storage");return(0,P.isProfileUsingDefaultStorage)(y)?new I.ApplicationStorageDatabaseClient(d):new I.ProfileStorageDatabaseClient(d,y)}};b=ye([K(0,R.IMainProcessService),K(1,S.IUserDataProfilesService),K(2,P.IStorageService),K(3,A.ILogService)],b),e.UserDataProfileStorageService=b,(0,C.registerSingleton)(L.IUserDataProfileStorageService,b,1)}),define(re[41],ae([0,1,20,6,17,23,3,35,2,27,15,174,16,14,13,8,45,19,22,30,26,18]),function(_,e,D,i,R,A,L,P,I,S,C,b,w,y,d,g,v,l,m,u,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.getSyncResourceLogLabel=e.isSyncData=e.isRemoteUserData=void 0;function n(p){return!!(p&&p.ref!==void 0&&typeof p.ref=="string"&&p.ref!==""&&p.syncData!==void 0&&(p.syncData===null||s(p.syncData)))}e.isRemoteUserData=n;function s(p){return!!(p&&p.version!==void 0&&typeof p.version=="number"&&p.content!==void 0&&typeof p.content=="string"&&(Object.keys(p).length===2||Object.keys(p).length===3&&p.machineId!==void 0&&typeof p.machineId=="string"))}e.isSyncData=s;function t(p,E){return`${(0,S.uppercaseFirstLetter)(p)}${E.isDefault?"":` (${E.name})`}`}e.getSyncResourceLogLabel=t;let a=class extends I.Disposable{get status(){return this.k}get conflicts(){return{...this.syncResource,conflicts:this.m}}constructor(E,k,F,N,q,j,O,U,$,G,H,Z){super(),this.syncResource=E,this.collection=k,this.C=F,this.D=N,this.F=q,this.G=j,this.H=O,this.I=U,this.J=$,this.L=G,this.M=H,this.c=null,this.k="idle",this.l=this.B(new L.Emitter),this.onDidChangeStatus=this.l.event,this.m=[],this.n=this.B(new L.Emitter),this.onDidChangeConflicts=this.n.event,this.s=new i.ThrottledDelayer(50),this.t=this.B(new L.Emitter),this.onDidChangeLocal=this.t.event,this.v=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.w=!1,this.z={},this.resource=this.syncResource.syncResource,this.y=t(E.syncResource,E.profile),this.h=Z.extUri,this.f=this.h.joinPath(N.userDataSyncHome,...(0,h.getPathSegments)(E.profile.isDefault?void 0:E.profile.id,E.syncResource)),this.g=this.h.joinPath(this.f,h.PREVIEW_DIR_NAME),this.u=(0,h.getLastSyncResourceUri)(E.profile.isDefault?void 0:E.profile.id,E.syncResource,N,this.h),this.j=(0,v.getServiceMachineId)(N,F,q)}triggerLocalChange(){this.s.trigger(()=>this.N())}async N(){if(this.status==="hasConflicts"){this.L.info(`${this.y}: In conflicts state and local change detected. Syncing again...`);const E=await this.c;this.c=null;const k=await this.S(E.remoteUserData,E.lastSyncUserData,!0,this.lb());this.O(k)}else{this.L.trace(`${this.y}: Checking for local changes...`);const E=await this.getLastSyncUserData();(E?await this.rb(E):!0)&&this.t.fire()}}O(E){this.k!==E&&(this.k=E,this.l.fire(E))}async sync(E,k={}){await this.P(E,!0,this.lb(),k)}async preview(E,k,F={}){return this.P(E,!1,k,F)}async apply(E,k={}){try{this.z={...k};const F=await this.X(E);return this.O(F),this.c}finally{this.z={}}}async P(E,k,F,N){try{if(this.z={...N},this.status==="hasConflicts")return this.L.info(`${this.y}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.L.info(`${this.y}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.L.trace(`${this.y}: Started synchronizing ${this.resource.toLowerCase()}...`),this.O("syncing");let q="idle";try{const j=await this.getLastSyncUserData(),O=await this.R(E,j);return q=await this.S(O,j,k,F),q==="hasConflicts"?this.L.info(`${this.y}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):q==="idle"&&this.L.trace(`${this.y}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.O(q)}}finally{this.z={}}}async replace(E){const k=this.hb(E);if(!k)return!1;await this.stop();try{this.L.trace(`${this.y}: Started resetting ${this.resource.toLowerCase()}...`),this.O("syncing");const F=await this.getLastSyncUserData(),N=await this.R(null,F),q=await this.Q(N),j=await this.nb({ref:N.ref,syncData:k},F,q,this.lb(),A.CancellationToken.None),O=[];for(const U of j){const $=await this.pb(U,U.remoteResource,void 0,A.CancellationToken.None),{remoteChange:G}=await this.pb(U,U.previewResource,U.remoteContent,A.CancellationToken.None);O.push([U,{...$,remoteChange:G!==0?G:2}])}await this.qb(N,F,O,!1),this.L.info(`${this.y}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.O("idle")}return!0}async Q(E){const k=await this.j;return!!E.syncData?.machineId&&E.syncData.machineId===k}async R(E,k){if(k){const F=E?E[this.resource]:void 0;if(k.ref===F||F===void 0&&k.syncData===null)return k}return this.getRemoteUserData(k)}async S(E,k,F,N){if(E.syncData&&E.syncData.version>this.mb)throw this.J.publicLog2("sync/incompatible",{source:this.resource}),new h.UserDataSyncError((0,b.localize)(0,null,this.resource,this.mb,E.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.U(E,k,F,N)}catch(q){if(q instanceof h.UserDataSyncError)switch(q.code){case"LocalPreconditionFailed":return this.L.info(`${this.y}: Failed to synchronize ${this.y} as there is a new local version available. Synchronizing again...`),this.S(E,k,F,N);case"Conflict":case"PreconditionFailed":return this.L.info(`${this.y}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),E=await this.getRemoteUserData(null),k=await this.getLastSyncUserData(),this.S(E,k,F,N)}throw q}}async U(E,k,F,N){try{const q=await this.Q(E),j=!q&&k===null&&this.db()!==void 0,O=F&&!j;this.c||(this.c=(0,i.createCancelablePromise)($=>this.bb(E,k,q,O,N,$)));let U=await this.c;if(F&&j){this.L.info(`${this.y}: Accepting remote because it was synced before and the last sync data is not available.`);for(const $ of U.resourcePreviews)U=await this.accept($.remoteResource)||U}return this.Z(U.resourcePreviews),U.resourcePreviews.some(({mergeState:$})=>$==="conflict")?"hasConflicts":F?await this.X(!1):"syncing"}catch(q){throw this.c=null,q}}async merge(E){return await this.W(E,async k=>{const F=await this.ob(k,A.CancellationToken.None);await this.C.writeFile(k.previewResource,R.VSBuffer.fromString(F?.content||""));const N=F&&!F.hasConflicts?await this.pb(k,k.previewResource,void 0,A.CancellationToken.None):void 0;return k.acceptResult=N,k.mergeState=F.hasConflicts?"conflict":N?"accepted":"preview",k.localChange=N?N.localChange:F.localChange,k.remoteChange=N?N.remoteChange:F.remoteChange,k}),this.c}async accept(E,k){return await this.W(E,async F=>{const N=await this.pb(F,E,k,A.CancellationToken.None);return F.acceptResult=N,F.mergeState="accepted",F.localChange=N.localChange,F.remoteChange=N.remoteChange,F}),this.c}async discard(E){return await this.W(E,async k=>{const F=await this.ob(k,A.CancellationToken.None);return await this.C.writeFile(k.previewResource,R.VSBuffer.fromString(F.content||"")),k.acceptResult=void 0,k.mergeState="preview",k.localChange=F.localChange,k.remoteChange=F.remoteChange,k}),this.c}async W(E,k){if(!this.c)return;let F=await this.c;const N=F.resourcePreviews.findIndex(({localResource:q,remoteResource:j,previewResource:O})=>this.h.isEqual(q,E)||this.h.isEqual(j,E)||this.h.isEqual(O,E));N!==-1&&(this.c=(0,i.createCancelablePromise)(async q=>{const j=[...F.resourcePreviews];return j[N]=await k(j[N]),{...F,resourcePreviews:j}}),F=await this.c,this.Z(F.resourcePreviews),F.resourcePreviews.some(({mergeState:q})=>q==="conflict")?this.O("hasConflicts"):this.O("syncing"))}async X(E){if(!this.c)return"idle";const k=await this.c;return k.resourcePreviews.some(({mergeState:F})=>F==="conflict")?"hasConflicts":k.resourcePreviews.some(({mergeState:F})=>F!=="accepted")?"syncing":(await this.qb(k.remoteUserData,k.lastSyncUserData,k.resourcePreviews.map(F=>[F,F.acceptResult]),E),this.c=null,await this.Y(),"idle")}async Y(){try{await this.C.del(this.g,{recursive:!0})}catch{}}Z(E){const k=E.filter(({mergeState:F})=>F==="conflict");(0,D.equals)(this.m,k,(F,N)=>this.h.isEqual(F.previewResource,N.previewResource))||(this.m=k,this.n.fire(this.conflicts))}async hasPreviouslySynced(){const E=await this.getLastSyncUserData();return!!E&&E.syncData!==null}async ab(E){const k=this.c?await this.c:null;if(k)for(const F of k.resourcePreviews){if(this.h.isEqual(F.acceptedResource,E))return F.acceptResult?F.acceptResult.content:null;if(this.h.isEqual(F.remoteResource,E))return F.remoteContent;if(this.h.isEqual(F.localResource,E))return F.localContent;if(this.h.isEqual(F.baseResource,E))return F.baseContent}return null}async resetLocal(){this.F.remove(this.v,-1);try{await this.C.del(this.u)}catch(E){this.L.error(E)}}async bb(E,k,F,N,q,j){const O=await this.nb(E,k,F,q,j),U=[];for(const $ of O){const G=$.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"});if($.localChange===0&&$.remoteChange===0)U.push({...$,acceptedResource:G,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const H=N?await this.ob($,j):void 0;if(j.isCancellationRequested)break;await this.C.writeFile($.previewResource,R.VSBuffer.fromString(H?.content||""));const Z=H&&!H.hasConflicts?await this.pb($,$.previewResource,void 0,j):void 0;U.push({...$,acceptResult:Z,mergeState:H?.hasConflicts?"conflict":Z?"accepted":"preview",localChange:Z?Z.localChange:H?H.localChange:$.localChange,remoteChange:Z?Z.remoteChange:H?H.remoteChange:$.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:E,lastSyncUserData:k,resourcePreviews:U,isLastSyncFromCurrentMachine:F}}async getLastSyncUserData(){let E=this.db();if(E||(E=await this.gb()),!E)return this.L.info(`${this.y}: Last sync data state does not exist.`),null;const k=JSON.parse(E),F=this.I.getResourceSyncStateVersion(this.resource);if(this.w=!!k.version&&!!F&&k.version!==F,this.w)return this.L.info(`${this.y}: Reset last sync state because last sync state version ${k.version} is not compatible with current sync state version ${F}.`),await this.resetLocal(),null;let N,q=1;for(;N===void 0&&q++<6;)try{const j=await this.eb();j&&(j.ref===k.ref?N=j.syncData:this.L.info(`${this.y}: Last sync data stored locally is not same as the last sync state.`));break}catch(j){if(j instanceof d.FileOperationError&&j.fileOperationResult===1){this.L.info(`${this.y}: Last sync resource does not exist locally.`);break}else{if(j instanceof h.UserDataSyncError)throw j;this.L.error(j,q)}}if(N===void 0)try{const j=await this.G.resolveResourceContent(this.resource,k.ref,this.collection,this.z);N=j===null?null:this.hb(j),await this.fb({ref:k.ref,syncData:N})}catch(j){if(j instanceof h.UserDataSyncError&&j.code==="NotFound")this.L.info(`${this.y}: Last sync resource does not exist remotely.`);else throw j}return N===void 0?null:{...k,syncData:N}}async cb(E,k={}){if(k.ref||k.version)throw new Error("Cannot have core properties as additional");const F=this.I.getResourceSyncStateVersion(this.resource),N={ref:E.ref,version:F,...k};this.F.store(this.v,JSON.stringify(N),-1,1),await this.fb(E)}db(){return this.F.get(this.v,-1)}async eb(){const E=(await this.C.readFile(this.u)).value.toString();try{const k=E?JSON.parse(E):void 0;if(n(k))return k}catch(k){this.L.error(k)}}async fb(E){await this.C.writeFile(this.u,R.VSBuffer.fromString(JSON.stringify(E)))}async gb(){try{const E=await this.C.readFile(this.u),k=JSON.parse(E.value.toString());await this.C.del(this.u),k.ref&&k.content!==void 0&&(this.F.store(this.v,JSON.stringify({...k,content:void 0}),-1,1),await this.fb({ref:k.ref,syncData:k.content===null?null:JSON.parse(k.content)}))}catch(E){E instanceof d.FileOperationError&&E.fileOperationResult===1?this.L.debug(`${this.y}: Migrating last sync user data. Resource does not exist.`):this.L.error(E)}return this.F.get(this.v,-1)}async getRemoteUserData(E){const{ref:k,content:F}=await this.ib(E);let N=null;return F!==null&&(N=this.hb(F)),{ref:k,syncData:N}}hb(E){try{const k=JSON.parse(E);if(s(k))return k}catch(k){this.L.error(k)}throw new h.UserDataSyncError((0,b.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async ib(E){const k=E?{ref:E.ref,content:E.syncData?JSON.stringify(E.syncData):null}:null;return this.G.readResource(this.resource,k,this.collection,this.z)}async jb(E,k){const F=await this.j,N={version:this.mb,machineId:F,content:E};try{return k=await this.G.writeResource(this.resource,JSON.stringify(N),k,this.collection,this.z),{ref:k,syncData:N}}catch(q){throw q instanceof h.UserDataSyncError&&q.code==="TooLarge"&&(q=new h.UserDataSyncError(q.message,q.code,this.resource)),q}}async kb(E){const k={version:this.mb,content:E};return this.H.backup(this.syncResource.profile,this.resource,JSON.stringify(k))}async stop(){this.status!=="idle"&&(this.L.trace(`${this.y}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.Z([]),await this.Y(),this.O("idle"),this.L.info(`${this.y}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}lb(){return this.M.getValue(h.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};a=ye([K(2,d.IFileService),K(3,y.IEnvironmentService),K(4,l.IStorageService),K(5,h.IUserDataSyncStoreService),K(6,h.IUserDataSyncBackupStoreService),K(7,h.IUserDataSyncEnablementService),K(8,m.ITelemetryService),K(9,h.IUserDataSyncLogService),K(10,w.IConfigurationService),K(11,u.IUriIdentityService)],a),e.AbstractSynchroniser=a;let r=class extends a{constructor(E,k,F,N,q,j,O,U,$,G,H,Z,z){super(k,F,N,q,j,O,U,$,G,H,Z,z),this.i=E,this.B(this.C.watch(this.h.dirname(E))),this.B(this.C.onDidFilesChange(B=>this.tb(B)))}async p(){try{return await this.C.readFile(this.i)}catch{return null}}async r(E,k,F){try{k?await this.C.writeFile(this.i,R.VSBuffer.fromString(E),F?void 0:k):await this.C.createFile(this.i,R.VSBuffer.fromString(E),{overwrite:F})}catch(N){throw N instanceof d.FileOperationError&&N.fileOperationResult===1||N instanceof d.FileOperationError&&N.fileOperationResult===3?new h.UserDataSyncError(N.message,"LocalPreconditionFailed"):N}}async sb(){try{await this.C.del(this.i)}catch(E){if(!(E instanceof d.FileOperationError&&E.fileOperationResult===1))throw E}}tb(E){!E.contains(this.i)||this.triggerLocalChange()}};r=ye([K(3,d.IFileService),K(4,y.IEnvironmentService),K(5,l.IStorageService),K(6,h.IUserDataSyncStoreService),K(7,h.IUserDataSyncBackupStoreService),K(8,h.IUserDataSyncEnablementService),K(9,m.ITelemetryService),K(10,h.IUserDataSyncLogService),K(11,w.IConfigurationService),K(12,u.IUriIdentityService)],r),e.AbstractFileSynchroniser=r;let c=class extends r{constructor(E,k,F,N,q,j,O,U,$,G,H,Z,z,B){super(E,k,F,N,q,j,O,U,$,G,H,z,B),this.ub=Z,this.wb=void 0}vb(E,k){const F=[],N=(0,P.parse)(E,F,{allowEmptyContent:!0,allowTrailingComma:!0});return F.length>0||!(0,C.isUndefined)(N)&&k!==Array.isArray(N)}xb(){return this.wb||(this.wb=this.ub.resolveFormattingOptions(this.i)),this.wb}};c=ye([K(3,d.IFileService),K(4,y.IEnvironmentService),K(5,l.IStorageService),K(6,h.IUserDataSyncStoreService),K(7,h.IUserDataSyncBackupStoreService),K(8,h.IUserDataSyncEnablementService),K(9,m.ITelemetryService),K(10,h.IUserDataSyncLogService),K(11,h.IUserDataSyncUtilService),K(12,w.IConfigurationService),K(13,u.IUriIdentityService)],c),e.AbstractJsonFileSynchroniser=c;let o=class{constructor(E,k,F,N,q,j,O){this.resource=E,this.g=k,this.h=F,this.j=N,this.k=q,this.l=j,this.d=O.extUri,this.f=(0,h.getLastSyncResourceUri)(void 0,this.resource,F,this.d)}async initialize({ref:E,content:k}){if(!k){this.j.info("Remote content does not exist.",this.resource);return}const F=this.m(k);if(!!F)try{await this.doInitialize({ref:E,syncData:F})}catch(N){this.j.error(N)}}m(E){try{const k=JSON.parse(E);if(s(k))return k}catch(k){this.j.error(k)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(E,k={}){if(k.ref||k.version)throw new Error("Cannot have core properties as additional");const F={ref:E.ref,version:void 0,...k};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(F),-1,1),await this.k.writeFile(this.f,R.VSBuffer.fromString(JSON.stringify(E)))}};o=ye([K(1,f.IUserDataProfilesService),K(2,y.IEnvironmentService),K(3,g.ILogService),K(4,d.IFileService),K(5,l.IStorageService),K(6,u.IUriIdentityService)],o),e.AbstractInitializer=o}),define(re[117],ae([0,1,6,23,9,3,43,2,27,16,14,116,29,33,80,13,4,72,8,19,22,30,18,41,252,114,26,62]),function(_,e,D,i,R,A,L,P,I,S,C,b,w,y,d,g,v,l,m,u,h,f,n,s,t,a,r,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.LocalExtensionsProvider=e.ExtensionsSynchroniser=e.stringify=e.parseExtensions=void 0;async function o(q,j){const O=JSON.parse(q.content);if(q.version===1||q.version===2){const U=(await j.getInstalled(0)).filter($=>$.isBuiltin);for(const $ of O)q.version===1&&($.enabled===!1&&($.disabled=!0),delete $.enabled),q.version===2&&U.every(G=>!(0,y.areSameExtensions)(G.identifier,$.identifier))&&($.installed=!0)}return O}function p(q){return JSON.parse(q.content)}e.parseExtensions=p;function E(q,j){return q.sort((O,U)=>!O.identifier.uuid&&U.identifier.uuid?-1:O.identifier.uuid&&!U.identifier.uuid?1:(0,I.compare)(O.identifier.id,U.identifier.id)),j?(0,L.toFormattedString)(q,{}):JSON.stringify(q)}e.stringify=E;let k=class extends s.AbstractSynchroniser{constructor(j,O,U,$,G,H,Z,z,B,Y,ee,oe,J,Q,T,M,V){super({syncResource:"extensions",profile:j},O,$,U,G,H,Z,oe,J,Y,ee,T),this.yb=z,this.zb=B,this.Ab=V,this.mb=5,this.sb=this.h.joinPath(this.g,"extensions.json"),this.tb=this.sb.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"base"}),this.ub=this.sb.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"local"}),this.vb=this.sb.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.wb=this.sb.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.xb=this.Ab.createInstance(F),this.B(A.Event.any(A.Event.filter(this.yb.onDidInstallExtensions,W=>W.some(({local:X})=>!!X)),A.Event.filter(this.yb.onDidUninstallExtension,W=>!W.error),A.Event.filter(M.onDidChange,W=>W.valueChanges.some(({profile:X,changes:se})=>this.syncResource.profile.id===X.id&&se.some(x=>x.key===w.DISABLED_EXTENSIONS_STORAGE_PATH))),Q.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async nb(j,O){const U=j.syncData?await o(j.syncData,this.yb):null,$=O?.skippedExtensions||[],G=O?.builtinExtensions||[],H=O?.syncData?await o(O.syncData,this.yb):null,{localExtensions:Z,ignoredExtensions:z}=await this.xb.getLocalExtensions(this.syncResource.profile);U?this.L.trace(`${this.y}: Merging remote extensions with local extensions...`):this.L.trace(`${this.y}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:B,remote:Y}=(0,t.merge)(Z,U,H,$,z,G),ee={local:B,remote:Y,content:this.Db(Z,B.added,B.updated,B.removed),localChange:B.added.length>0||B.removed.length>0||B.updated.length>0?2:0,remoteChange:Y!==null?2:0},oe=this.Jb(Z,!1);return[{skippedExtensions:$,builtinExtensions:G,baseResource:this.tb,baseContent:H?this.Jb(H,!1):oe,localResource:this.ub,localContent:oe,localExtensions:Z,remoteResource:this.vb,remoteExtensions:U,remoteContent:U?this.Jb(U,!1):null,previewResource:this.sb,previewResult:ee,localChange:ee.localChange,remoteChange:ee.remoteChange,acceptedResource:this.wb}]}async rb(j){const O=j.syncData?await o(j.syncData,this.yb):null,{localExtensions:U,ignoredExtensions:$}=await this.xb.getLocalExtensions(this.syncResource.profile),{remote:G}=(0,t.merge)(U,O,O,j.skippedExtensions||[],$,j.builtinExtensions||[]);return G!==null}Db(j,O,U,$){const G=[...O,...U],H=new Set,Z=z=>{H.add(z.id.toLowerCase()),z.uuid&&H.add(z.uuid)};G.forEach(({identifier:z})=>Z(z)),$.forEach(Z);for(const z of j)H.has(z.identifier.id.toLowerCase())||z.identifier.uuid&&H.has(z.identifier.uuid)||G.push(z);return this.Jb(G,!1)}async ob(j,O){return{...j.previewResult,hasConflicts:!1}}async pb(j,O,U,$){if(this.h.isEqual(O,this.ub))return this.Gb(j);if(this.h.isEqual(O,this.vb))return this.Hb(j);if(this.h.isEqual(O,this.sb))return j.previewResult;throw new Error(`Invalid Resource: ${O.toString()}`)}async Gb(j){const O=await this.yb.getInstalled(void 0,this.syncResource.profile.extensionsResource),U=this.zb.getIgnoredExtensions(O),$=(0,t.merge)(j.localExtensions,null,null,j.skippedExtensions,U,j.builtinExtensions),{local:G,remote:H}=$;return{content:j.localContent,local:G,remote:H,localChange:G.added.length>0||G.removed.length>0||G.updated.length>0?2:0,remoteChange:H!==null?2:0}}async Hb(j){const O=await this.yb.getInstalled(void 0,this.syncResource.profile.extensionsResource),U=this.zb.getIgnoredExtensions(O),$=j.remoteContent?JSON.parse(j.remoteContent):null;if($!==null){const G=(0,t.merge)(j.localExtensions,$,j.localExtensions,[],U,j.builtinExtensions),{local:H,remote:Z}=G;return{content:j.remoteContent,local:H,remote:Z,localChange:H.added.length>0||H.removed.length>0||H.updated.length>0?2:0,remoteChange:Z!==null?2:0}}else return{content:j.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async qb(j,O,U,$){let{skippedExtensions:G,localExtensions:H}=U[0][0];const{local:Z,remote:z,localChange:B,remoteChange:Y}=U[0][1];if(B===0&&Y===0&&this.L.info(`${this.y}: No changes found during synchronizing extensions.`),B!==0&&(await this.kb(JSON.stringify(H)),G=await this.xb.updateLocalExtensions(Z.added,Z.removed,Z.updated,G,this.syncResource.profile)),z){this.L.trace(`${this.y}: Updating remote extensions...`);const ee=JSON.stringify(z.all);j=await this.jb(ee,$?null:j.ref),this.L.info(`${this.y}: Updated remote extensions.${z.added.length?` Added: ${JSON.stringify(z.added.map(oe=>oe.identifier.id))}.`:""}${z.updated.length?` Updated: ${JSON.stringify(z.updated.map(oe=>oe.identifier.id))}.`:""}${z.removed.length?` Removed: ${JSON.stringify(z.removed.map(oe=>oe.identifier.id))}.`:""}`)}if(O?.ref!==j.ref){this.L.trace(`${this.y}: Updating last synchronized extensions...`);const ee=H.filter(oe=>!oe.installed).map(oe=>oe.identifier);await this.cb(j,{skippedExtensions:G,builtinExtensions:ee}),this.L.info(`${this.y}: Updated last synchronized extensions.${G.length?` Skipped: ${JSON.stringify(G.map(oe=>oe.identifier.id))}.`:""}`)}}async resolveContent(j){if(this.h.isEqual(this.vb,j)||this.h.isEqual(this.tb,j)||this.h.isEqual(this.ub,j)||this.h.isEqual(this.wb,j)){const O=await this.ab(j);return O&&this.Jb(JSON.parse(O),!0)}return null}Jb(j,O){return E(j,O)}async hasLocalData(){try{const{localExtensions:j}=await this.xb.getLocalExtensions(this.syncResource.profile);if(j.some(O=>O.installed||O.disabled))return!0}catch{}return!1}};k=ye([K(2,C.IEnvironmentService),K(3,g.IFileService),K(4,u.IStorageService),K(5,r.IUserDataSyncStoreService),K(6,r.IUserDataSyncBackupStoreService),K(7,w.IExtensionManagementService),K(8,a.IIgnoredExtensionsManagementService),K(9,r.IUserDataSyncLogService),K(10,S.IConfigurationService),K(11,r.IUserDataSyncEnablementService),K(12,h.ITelemetryService),K(13,d.IExtensionStorageService),K(14,f.IUriIdentityService),K(15,c.IUserDataProfileStorageService),K(16,v.IInstantiationService)],k),e.ExtensionsSynchroniser=k;let F=class{constructor(j,O,U,$,G,H){this.a=j,this.b=O,this.c=U,this.d=$,this.f=G,this.g=H}async getLocalExtensions(j){const O=await this.a.getInstalled(void 0,j.extensionsResource),U=this.d.getIgnoredExtensions(O);return{localExtensions:await this.j(j,async(G,H)=>{const Z=G.getDisabledExtensions();return O.map(z=>{const{identifier:B,isBuiltin:Y,manifest:ee,preRelease:oe}=z,J={identifier:B,preRelease:oe,version:ee.version};Z.some(Q=>(0,y.areSameExtensions)(Q,B))&&(J.disabled=!0),Y||(J.installed=!0);try{const Q=H.getKeysForSync({id:B.id,version:ee.version});if(Q){const T=H.getExtensionState(z,!0)||{};J.state=Object.keys(T).reduce((M,V)=>(Q.includes(V)&&(M[V]=T[V]),M),{})}}catch(Q){this.g.info(`${(0,s.getSyncResourceLogLabel)("extensions",j)}: Error while parsing extension state`,(0,R.getErrorMessage)(Q))}return J})}),ignoredExtensions:U}}async updateLocalExtensions(j,O,U,$,G){const H=(0,s.getSyncResourceLogLabel)("extensions",G);return this.j(G,async(Z,z)=>{const B=[],Y=[],ee=await this.a.getInstalled(void 0,G.extensionsResource);if(O.length){const J=ee.filter(({identifier:Q,isBuiltin:T})=>!T&&O.some(M=>(0,y.areSameExtensions)(Q,M)));await D.Promises.settled(J.map(async Q=>{this.g.trace(`${H}: Uninstalling local extension...`,Q.identifier.id),await this.a.uninstall(Q,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:G.extensionsResource}),this.g.info(`${H}: Uninstalled local extension.`,Q.identifier.id),B.push(Q.identifier)}))}(j.length||U.length)&&await D.Promises.settled([...j,...U].map(async J=>{const Q=ee.find(M=>(0,y.areSameExtensions)(M.identifier,J.identifier));if(Q&&Q.isBuiltin){J.state&&Q.manifest.version===J.version&&this.h(J.state,Q,Q.manifest.version,z),Z.getDisabledExtensions().some(V=>(0,y.areSameExtensions)(V,J.identifier))!==!!J.disabled&&(J.disabled?(this.g.trace(`${H}: Disabling extension...`,J.identifier.id),await Z.disableExtension(J.identifier),this.g.info(`${H}: Disabled extension`,J.identifier.id)):(this.g.trace(`${H}: Enabling extension...`,J.identifier.id),await Z.enableExtension(J.identifier),this.g.info(`${H}: Enabled extension`,J.identifier.id))),B.push(J.identifier);return}const T=(await this.c.getExtensions([{...J.identifier,preRelease:J.preRelease}],i.CancellationToken.None))[0];if(J.state&&(Q?Q.manifest.version===J.version:!!T)&&this.h(J.state,Q||T,Q?.manifest.version,z),T)try{Z.getDisabledExtensions().some(V=>(0,y.areSameExtensions)(V,J.identifier))!==!!J.disabled&&(J.disabled?(this.g.trace(`${H}: Disabling extension...`,J.identifier.id,T.version),await Z.disableExtension(T.identifier),this.g.info(`${H}: Disabled extension`,J.identifier.id,T.version)):(this.g.trace(`${H}: Enabling extension...`,J.identifier.id,T.version),await Z.enableExtension(T.identifier),this.g.info(`${H}: Enabled extension`,J.identifier.id,T.version))),(!Q||Q.preRelease!==J.preRelease)&&(await this.a.canInstall(T)?(this.g.trace(`${H}: Installing extension...`,J.identifier.id,T.version),await this.a.installFromGallery(T,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:J.preRelease,profileLocation:G.extensionsResource}),this.g.info(`${H}: Installed extension.`,J.identifier.id,T.version),B.push(T.identifier)):(this.g.info(`${H}: Skipped synchronizing extension because it cannot be installed.`,T.displayName||T.identifier.id),Y.push(J)))}catch(M){Y.push(J),M instanceof w.ExtensionManagementError&&[w.ExtensionManagementErrorCode.Incompatible,w.ExtensionManagementErrorCode.IncompatiblePreRelease,w.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(M.code)?this.g.info(`${H}: Skipped synchronizing extension because the compatible extension is not found.`,T.displayName||T.identifier.id):(this.g.error(M),this.g.info(`${H}: Skipped synchronizing extension`,T.displayName||T.identifier.id))}else Y.push(J),this.g.info(`${H}: Skipped synchronizing extension because the extension is not found.`,J.identifier.id)}));const oe=[];for(const J of $)B.some(Q=>(0,y.areSameExtensions)(Q,J.identifier))||oe.push(J);for(const J of Y)oe.some(Q=>(0,y.areSameExtensions)(Q.identifier,J.identifier))||oe.push(J);return oe})}h(j,O,U,$){const G=$.getExtensionState(O,!0)||{},H=U?$.getKeysForSync({id:O.identifier.id,version:U}):void 0;H?H.forEach(Z=>{G[Z]=j[Z]}):Object.keys(j).forEach(Z=>G[Z]=j[Z]),$.setExtensionState(O,G,!0)}async j(j,O){return this.b.withProfileScopedStorageService(j,async U=>{const $=new P.DisposableStore,G=this.f.createChild(new l.ServiceCollection([u.IStorageService,U])),H=$.add(G.createInstance(b.GlobalExtensionEnablementService)),Z=$.add(G.createInstance(d.ExtensionStorageService));try{return await O(H,Z)}finally{$.dispose()}})}};F=ye([K(0,w.IExtensionManagementService),K(1,c.IUserDataProfileStorageService),K(2,w.IExtensionGalleryService),K(3,a.IIgnoredExtensionsManagementService),K(4,v.IInstantiationService),K(5,r.IUserDataSyncLogService)],F),e.LocalExtensionsProvider=F;let N=class extends s.AbstractInitializer{constructor(j,O,U,$,G,H,Z,z){super("extensions",$,G,H,U,Z,z),this.o=j,this.p=O}async q(j){return j.syncData?await o(j.syncData,this.o):null}t(j,O){const U=[],$=[],G=[];for(const H of j){if(this.p.hasToNeverSyncExtension(H.identifier.id))continue;const Z=O.find(z=>(0,y.areSameExtensions)(z.identifier,H.identifier));Z?(U.push(Z),H.disabled&&G.push(H.identifier)):H.installed&&($.push({...H.identifier,preRelease:!!H.preRelease}),H.disabled&&G.push(H.identifier))}return{installedExtensions:U,newExtensions:$,disabledExtensions:G,remoteExtensions:j}}};N=ye([K(0,w.IExtensionManagementService),K(1,a.IIgnoredExtensionsManagementService),K(2,g.IFileService),K(3,n.IUserDataProfilesService),K(4,C.IEnvironmentService),K(5,m.ILogService),K(6,u.IStorageService),K(7,f.IUriIdentityService)],N),e.AbstractExtensionsInitializer=N}),define(re[118],ae([0,1,17,9,3,35,43,5,31,16,14,13,8,45,19,22,30,41,60,256,26,18,62,4]),function(_,e,D,i,R,A,L,P,I,S,C,b,w,y,d,g,v,l,m,u,h,f,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.LocalGlobalStateProvider=e.GlobalStateSynchroniser=e.stringify=void 0;const t="globalState.argv.",a=["locale"];function r(F,N){const q=F.storage?Object.keys(F.storage).sort():[],j={};return q.forEach(O=>j[O]=F.storage[O]),F.storage=j,N?(0,L.toFormattedString)(F,{}):JSON.stringify(F)}e.stringify=r;const c=1;let o=class extends l.AbstractSynchroniser{constructor(N,q,j,O,U,$,G,H,Z,z,B,Y,ee,oe){super({syncResource:"globalState",profile:N},q,O,H,Y,U,$,Z,z,G,B,ee),this.wb=j,this.mb=c,this.p=this.h.joinPath(this.g,"globalState.json"),this.r=this.p.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),this.sb=this.p.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),this.tb=this.p.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.ub=this.p.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.vb=oe.createInstance(p),this.B(O.watch(this.h.dirname(this.D.argvResource))),this.B(R.Event.any(R.Event.filter(O.onDidFilesChange,J=>J.contains(this.D.argvResource)),R.Event.filter(j.onDidChange,J=>!!(J.targetChanges.some(Q=>this.syncResource.profile.id===Q.id)||J.valueChanges.some(({profile:Q,changes:T})=>this.syncResource.profile.id===Q.id&&T.some(M=>M.target===0)))))(()=>this.triggerLocalChange()))}async nb(N,q,j){const O=N.syncData?JSON.parse(N.syncData.content):null;q=q===null&&j?N:q;const U=q&&q.syncData?JSON.parse(q.syncData.content):null,$=await this.vb.getLocalGlobalState(this.syncResource.profile);O?this.L.trace(`${this.y}: Merging remote ui state with local ui state...`):this.L.trace(`${this.y}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const G=await this.Eb(U),{local:H,remote:Z}=(0,u.merge)($.storage,O?O.storage:null,U?U.storage:null,G,this.L),z={content:null,local:H,remote:Z,localChange:Object.keys(H.added).length>0||Object.keys(H.updated).length>0||H.removed.length>0?2:0,remoteChange:Z.all!==null?2:0},B=r($,!1);return[{baseResource:this.r,baseContent:U?r(U,!1):B,localResource:this.sb,localContent:B,localUserData:$,remoteResource:this.tb,remoteContent:O?r(O,!1):null,previewResource:this.p,previewResult:z,localChange:z.localChange,remoteChange:z.remoteChange,acceptedResource:this.ub,storageKeys:G}]}async rb(N){const q=N.syncData?JSON.parse(N.syncData.content):null;if(q===null)return!0;const j=await this.vb.getLocalGlobalState(this.syncResource.profile),O=await this.Eb(q),{remote:U}=(0,u.merge)(j.storage,q.storage,q.storage,O,this.L);return U.all!==null}async ob(N,q){return{...N.previewResult,hasConflicts:!1}}async pb(N,q,j,O){if(this.h.isEqual(q,this.sb))return this.Bb(N);if(this.h.isEqual(q,this.tb))return this.Cb(N);if(this.h.isEqual(q,this.p))return N.previewResult;throw new Error(`Invalid Resource: ${q.toString()}`)}async Bb(N){return{content:N.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(N.localUserData.storage),removed:[],updated:[],all:N.localUserData.storage},localChange:0,remoteChange:2}}async Cb(N){if(N.remoteContent!==null){const q=JSON.parse(N.remoteContent),{local:j,remote:O}=(0,u.merge)(N.localUserData.storage,q.storage,null,N.storageKeys,this.L);return{content:N.remoteContent,local:j,remote:O,localChange:Object.keys(j.added).length>0||Object.keys(j.updated).length>0||j.removed.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:N.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async qb(N,q,j,O){const{localUserData:U}=j[0][0],{local:$,remote:G,localChange:H,remoteChange:Z}=j[0][1];if(H===0&&Z===0&&this.L.info(`${this.y}: No changes found during synchronizing ui state.`),H!==0&&(this.L.trace(`${this.y}: Updating local ui state...`),await this.kb(JSON.stringify(U)),await this.vb.writeLocalGlobalState($,this.syncResource.profile),this.L.info(`${this.y}: Updated local ui state`)),Z!==0){this.L.trace(`${this.y}: Updating remote ui state...`);const z=JSON.stringify({storage:G.all});N=await this.jb(z,O?null:N.ref),this.L.info(`${this.y}: Updated remote ui state.${G.added.length?` Added: ${G.added}.`:""}${G.updated.length?` Updated: ${G.updated}.`:""}${G.removed.length?` Removed: ${G.removed}.`:""}`)}q?.ref!==N.ref&&(this.L.trace(`${this.y}: Updating last synchronized ui state...`),await this.cb(N),this.L.info(`${this.y}: Updated last synchronized ui state`))}async resolveContent(N){if(this.h.isEqual(this.tb,N)||this.h.isEqual(this.r,N)||this.h.isEqual(this.sb,N)||this.h.isEqual(this.ub,N)){const q=await this.ab(N);return q&&r(JSON.parse(q),!0)}return null}async hasLocalData(){try{const{storage:N}=await this.vb.getLocalGlobalState(this.syncResource.profile);if(Object.keys(N).length>1||N[`${t}.locale`]?.value!=="en")return!0}catch{}return!1}async Eb(N){const q=await this.wb.readStorageData(this.syncResource.profile),j=[],O=[];for(const[G,H]of q)H.target===0?j.push(G):H.target===1&&O.push(G);const U=[...j,...O],$=N?.storage?Object.keys(N.storage).filter(G=>!G.startsWith(t)&&!U.includes(G)&&q.get(G)!==void 0):[];if(!P.isWeb){const G=[...h.ALL_SYNC_RESOURCES.map(H=>(0,h.getEnablementKey)(H)),h.SYNC_SERVICE_URL_TYPE];$.push(...G),O.push(...G)}return{user:j,machine:O,unregistered:$}}};o=ye([K(2,n.IUserDataProfileStorageService),K(3,b.IFileService),K(4,h.IUserDataSyncStoreService),K(5,h.IUserDataSyncBackupStoreService),K(6,h.IUserDataSyncLogService),K(7,C.IEnvironmentService),K(8,h.IUserDataSyncEnablementService),K(9,g.ITelemetryService),K(10,S.IConfigurationService),K(11,d.IStorageService),K(12,v.IUriIdentityService),K(13,s.IInstantiationService)],o),e.GlobalStateSynchroniser=o;let p=class{constructor(N,q,j,O){this.a=N,this.b=q,this.c=j,this.d=O}async getLocalGlobalState(N){const q={};if(N.isDefault){const O=await this.f(),U=(0,A.parse)(O);for(const $ of a)U[$]!==void 0&&(q[`${t}${$}`]={version:1,value:U[$]})}const j=await this.c.readStorageData(N);for(const[O,U]of j)U.value&&U.target===0&&(q[O]={version:1,value:U.value});return{storage:q}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const N=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),N.value.toString()}catch(N){this.d.debug((0,i.getErrorMessage)(N))}return"{}"}async writeLocalGlobalState({added:N,removed:q,updated:j},O){const U=(0,l.getSyncResourceLogLabel)("globalState",O),$={},G=new Map,H=await this.c.readStorageData(O),Z=(z,B)=>{for(const Y of z){if(Y.startsWith(t)){$[Y.substring(t.length)]=B?B[Y].value:void 0;continue}if(B){const ee=B[Y];ee.value!==H.get(Y)?.value&&G.set(Y,ee.value)}else H.get(Y)!==void 0&&G.set(Y,void 0)}};if(Z(Object.keys(N),N),Z(Object.keys(j),j),Z(q),Object.keys($).length){this.d.trace(`${U}: Updating locale...`);const z=await this.f();let B=z;for(const Y of Object.keys($))B=(0,m.edit)(B,[Y],$[Y],{});z!==B&&(this.d.trace(`${U}: Updating locale...`),await this.a.writeFile(this.b.argvResource,D.VSBuffer.fromString(B)),this.d.info(`${U}: Updated locale.`)),this.d.info(`${U}: Updated locale`)}G.size&&(this.d.trace(`${U}: Updating global state...`),await this.c.updateStorageData(O,G,0),this.d.info(`${U}: Updated global state`,[...G.keys()]))}};p=ye([K(0,b.IFileService),K(1,C.IEnvironmentService),K(2,n.IUserDataProfileStorageService),K(3,h.IUserDataSyncLogService)],p),e.LocalGlobalStateProvider=p;let E=class extends l.AbstractInitializer{constructor(N,q,j,O,U,$){super("globalState",j,O,U,q,N,$)}async doInitialize(N){const q=N.syncData?JSON.parse(N.syncData.content):null;if(!q){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const j={},O={};for(const U of Object.keys(q.storage))U.startsWith(t)?j[U.substring(t.length)]=q.storage[U].value:this.l.get(U,0)===void 0&&(O[U]=q.storage[U].value);if(Object.keys(j).length){let U="{}";try{U=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const $ of Object.keys(j))U=(0,m.edit)(U,[$],j[$],{});await this.k.writeFile(this.h.argvResource,D.VSBuffer.fromString(U))}if(Object.keys(O).length)for(const U of Object.keys(O))this.l.store(U,O[U],0,0)}};E=ye([K(0,d.IStorageService),K(1,b.IFileService),K(2,f.IUserDataProfilesService),K(3,C.IEnvironmentService),K(4,h.IUserDataSyncLogService),K(5,v.IUriIdentityService)],E),e.GlobalStateInitializer=E;let k=class{constructor(N,q,j,O,U){this.a=N,this.b=q,this.c=j,this.d=O,this.f=U}getSyncStoreType(N){return this.h(N)?.storage[h.SYNC_SERVICE_URL_TYPE]?.value}async sync(N){const q=(0,h.createSyncHeaders)((0,I.generateUuid)());try{return await this.g(N,q)}catch(j){if(j instanceof h.UserDataSyncError)switch(j.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(N,q)}throw j}}async g(N,q){const j=await this.a.readResource("globalState",null,void 0,q),O=this.h(j)||{storage:{}};O.storage[h.SYNC_SERVICE_URL_TYPE]={value:N,version:c};const U=await(0,y.getServiceMachineId)(this.c,this.d,this.b),$={version:c,machineId:U,content:r(O,!1)};await this.a.writeResource("globalState",JSON.stringify($),j.ref,void 0,q)}h({content:N}){if(!N)return null;const q=JSON.parse(N);if((0,l.isSyncData)(q))return q?JSON.parse(q.content):null;throw new Error("Invalid remote data")}};k=ye([K(1,d.IStorageService),K(2,C.IEnvironmentService),K(3,b.IFileService),K(4,w.ILogService)],k),e.UserDataSyncStoreTypeSynchronizer=k}),define(re[119],ae([0,1,20,17,3,35,5,15,175,16,14,13,19,22,30,18,41,253,26]),function(_,e,D,i,R,A,L,P,I,S,C,b,w,y,d,g,v,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function u(n,s,t){try{const a=JSON.parse(n);if(!s)return(0,P.isUndefined)(a.all)?null:a.all;switch(L.OS){case 2:return(0,P.isUndefined)(a.mac)?null:a.mac;case 3:return(0,P.isUndefined)(a.linux)?null:a.linux;case 1:return(0,P.isUndefined)(a.windows)?null:a.windows}}catch(a){return t.error(a),null}}e.getKeybindingsContentFromSyncContent=u;let h=class extends v.AbstractJsonFileSynchroniser{constructor(s,t,a,r,c,o,p,E,k,F,N,q,j){super(s.keybindingsResource,{syncResource:"keybindings",profile:s},t,E,k,F,a,r,p,q,c,N,o,j),this.mb=2,this.zb=this.h.joinPath(this.g,"keybindings.json"),this.Ab=this.zb.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),this.Bb=this.zb.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.Cb=this.zb.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.Db=this.zb.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.B(R.Event.filter(o.onDidChangeConfiguration,O=>O.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async nb(s,t,a,r){const c=s.syncData?u(s.syncData.content,r.keybindingsPerPlatform??this.Lb(),this.L):null;t=t===null&&a?s:t;const o=t?this.Jb(t):null,p=await this.p(),E=await this.xb();let k=null,F=!1,N=!1,q=!1;if(c){let U=p?p.value.toString():"[]";if(U=U||"[]",this.vb(U,!0))throw new m.UserDataSyncError((0,I.localize)(0,null),"LocalInvalidContent",this.resource);if(!o||o!==U||o!==c){this.L.trace(`${this.y}: Merging remote keybindings with local keybindings...`);const $=await(0,l.merge)(U,c,o,E,this.ub);$.hasChanges&&(k=$.mergeContent,q=$.hasConflicts,F=q||$.mergeContent!==U,N=q||$.mergeContent!==c)}}else p&&(this.L.trace(`${this.y}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),k=p.value.toString(),N=!0);const j={content:q?o:k,localChange:F?p?2:1:0,remoteChange:N?2:0,hasConflicts:q},O=p?p.value.toString():null;return[{fileContent:p,baseResource:this.Ab,baseContent:o,localResource:this.Bb,localContent:O,localChange:j.localChange,remoteResource:this.Cb,remoteContent:c,remoteChange:j.remoteChange,previewResource:this.zb,previewResult:j,acceptedResource:this.Db}]}async rb(s){const t=this.Jb(s);if(t===null)return!0;const a=await this.p(),r=a?a.value.toString():"",c=await this.xb(),o=await(0,l.merge)(r||"[]",t,t,c,this.ub);return o.hasConflicts||o.mergeContent!==t}async ob(s,t){return s.previewResult}async pb(s,t,a,r){if(this.h.isEqual(t,this.Bb))return{content:s.fileContent?s.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(t,this.Cb))return{content:s.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(t,this.zb))return a===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:a,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async qb(s,t,a,r){const{fileContent:c}=a[0][0];let{content:o,localChange:p,remoteChange:E}=a[0][1];if(p===0&&E===0&&this.L.info(`${this.y}: No changes found during synchronizing keybindings.`),o!==null&&(o=o.trim(),o=o||"[]",this.vb(o,!0)))throw new m.UserDataSyncError((0,I.localize)(1,null),"LocalInvalidContent",this.resource);if(p!==0&&(this.L.trace(`${this.y}: Updating local keybindings...`),c&&await this.kb(this.Kb(c.value.toString())),await this.r(o||"[]",c,r),this.L.info(`${this.y}: Updated local keybindings`)),E!==0){this.L.trace(`${this.y}: Updating remote keybindings...`);const k=this.Kb(o||"[]",s.syncData?.content);s=await this.jb(k,r?null:s.ref),this.L.info(`${this.y}: Updated remote keybindings`)}try{await this.C.del(this.zb)}catch{}t?.ref!==s.ref&&(this.L.trace(`${this.y}: Updating last synchronized keybindings...`),await this.cb(s,{platformSpecific:this.Lb()}),this.L.info(`${this.y}: Updated last synchronized keybindings`))}async hasLocalData(){try{const s=await this.p();if(s){const t=(0,A.parse)(s.value.toString());if((0,D.isNonEmptyArray)(t))return!0}}catch(s){if(s.fileOperationResult!==1)return!0}return!1}async resolveContent(s){return this.h.isEqual(this.Cb,s)||this.h.isEqual(this.Ab,s)||this.h.isEqual(this.Bb,s)||this.h.isEqual(this.Db,s)?this.ab(s):null}Jb(s){return!s.syncData||s.platformSpecific!==void 0&&s.platformSpecific!==this.Lb()?null:u(s.syncData.content,this.Lb(),this.L)}Kb(s,t){let a={};try{a=JSON.parse(t||"{}")}catch(r){this.L.error(r)}switch(this.Lb()?delete a.all:a.all=s,L.OS){case 2:a.mac=s;break;case 3:a.linux=s;break;case 1:a.windows=s;break}return JSON.stringify(a)}Lb(){return!!this.M.getValue(m.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM)}};h=ye([K(2,m.IUserDataSyncStoreService),K(3,m.IUserDataSyncBackupStoreService),K(4,m.IUserDataSyncLogService),K(5,S.IConfigurationService),K(6,m.IUserDataSyncEnablementService),K(7,b.IFileService),K(8,C.IEnvironmentService),K(9,w.IStorageService),K(10,m.IUserDataSyncUtilService),K(11,y.ITelemetryService),K(12,d.IUriIdentityService)],h),e.KeybindingsSynchroniser=h;let f=class extends v.AbstractInitializer{constructor(s,t,a,r,c,o){super("keybindings",t,a,r,s,c,o)}async doInitialize(s){const t=s.syncData?this.i(s.syncData.content):null;if(!t){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.c()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,i.VSBuffer.fromString(t)),await this.n(s)}async c(){try{const s=await this.k.readFile(this.g.defaultProfile.settingsResource),t=(0,A.parse)(s.value.toString());return!(0,D.isNonEmptyArray)(t)}catch(s){return s.fileOperationResult===1}}i(s){try{return u(s,!0,this.j)}catch(t){return this.j.error(t),null}}};f=ye([K(0,b.IFileService),K(1,g.IUserDataProfilesService),K(2,C.IEnvironmentService),K(3,m.IUserDataSyncLogService),K(4,w.IStorageService),K(5,d.IUriIdentityService)],f),e.KeybindingsInitializer=f}),define(re[120],ae([0,1,17,3,176,16,74,14,29,13,19,22,30,18,41,60,257,26]),function(_,e,D,i,R,A,L,P,I,S,C,b,w,y,d,g,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function m(n){return n&&n.settings&&typeof n.settings=="string"&&Object.keys(n).length===1}function u(n){const s=JSON.parse(n);return m(s)?s:{settings:n}}e.parseSettingsSyncContent=u;let h=class extends d.AbstractJsonFileSynchroniser{constructor(s,t,a,r,c,o,p,E,k,F,N,q,j,O){super(s.settingsResource,{syncResource:"settings",profile:s},t,a,r,c,o,p,N,q,E,k,F,O),this.zb=j,this.mb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.Jb=void 0}async getRemoteUserDataSyncConfiguration(s){const t=await this.getLastSyncUserData(),a=await this.R(s,t),r=this.Gb(a),c=new L.ConfigurationModelParser(l.USER_DATA_SYNC_CONFIGURATION_SCOPE);return r?.settings&&c.parse(r.settings),c.configurationModel.getValue(l.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async nb(s,t,a){const r=await this.p(),c=await this.xb(),o=this.Gb(s);t=t===null&&a?s:t;const p=t?this.Gb(t):null,E=await this.Kb();let k=null,F=!1,N=!1,q=!1;if(o){let $=r?r.value.toString().trim():"{}";$=$||"{}",this.Lb($),this.L.trace(`${this.y}: Merging remote settings with local settings...`);const G=(0,v.merge)($,o.settings,p?p.settings:null,E,[],c);k=G.localContent||G.remoteContent,F=G.localContent!==null,N=G.remoteContent!==null,q=G.hasConflicts}else r&&(this.L.trace(`${this.y}: Remote settings does not exist. Synchronizing settings for the first time.`),k=r.value.toString().trim()||"{}",this.Lb(k),N=!0);const j=r?r.value.toString():null,O=p?.settings??null,U={content:q?O:k,localChange:F?2:0,remoteChange:N?2:0,hasConflicts:q};return[{fileContent:r,baseResource:this.baseResource,baseContent:O,localResource:this.localResource,localContent:j,localChange:U.localChange,remoteResource:this.remoteResource,remoteContent:o?o.settings:null,remoteChange:U.remoteChange,previewResource:this.previewResource,previewResult:U,acceptedResource:this.acceptedResource}]}async rb(s){const t=this.Gb(s);if(t===null)return!0;const a=await this.p(),r=a?a.value.toString().trim():"",c=await this.Kb(),o=await this.xb();return(0,v.merge)(r||"{}",t.settings,t.settings,c,[],o).remoteContent!==null}async ob(s,t){const a=await this.xb(),r=await this.Kb();return{...s.previewResult,content:s.previewResult.content?(0,v.updateIgnoredSettings)(s.previewResult.content,"{}",r,a):null}}async pb(s,t,a,r){const c=await this.xb(),o=await this.Kb();if(this.h.isEqual(t,this.localResource))return{content:s.fileContent?(0,v.updateIgnoredSettings)(s.fileContent.value.toString(),"{}",o,c):null,localChange:0,remoteChange:2};if(this.h.isEqual(t,this.remoteResource))return{content:s.remoteContent!==null?(0,v.updateIgnoredSettings)(s.remoteContent,s.fileContent?s.fileContent.value.toString():"{}",o,c):null,localChange:2,remoteChange:0};if(this.h.isEqual(t,this.previewResource))return a===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:a!==null?(0,v.updateIgnoredSettings)(a,s.fileContent?s.fileContent.value.toString():"{}",o,c):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async qb(s,t,a,r){const{fileContent:c}=a[0][0];let{content:o,localChange:p,remoteChange:E}=a[0][1];if(p===0&&E===0&&this.L.info(`${this.y}: No changes found during synchronizing settings.`),o=o?o.trim():"{}",o=o||"{}",this.Lb(o),p!==0&&(this.L.trace(`${this.y}: Updating local settings...`),c&&await this.kb(JSON.stringify(this.Ib(c.value.toString()))),await this.r(o,c,r),await this.M.reloadConfiguration(3),this.L.info(`${this.y}: Updated local settings`)),E!==0){const k=await this.xb(),F=this.Gb(s),N=await this.Kb(o);o=(0,v.updateIgnoredSettings)(o,F?F.settings:"{}",N,k),this.L.trace(`${this.y}: Updating remote settings...`),s=await this.jb(JSON.stringify(this.Ib(o)),r?null:s.ref),this.L.info(`${this.y}: Updated remote settings`)}try{await this.C.del(this.previewResource)}catch{}t?.ref!==s.ref&&(this.L.trace(`${this.y}: Updating last synchronized settings...`),await this.cb(s),this.L.info(`${this.y}: Updated last synchronized settings`))}async hasLocalData(){try{const s=await this.p();if(s){const t=await this.xb(),a=(0,g.edit)(s.value.toString(),[l.CONFIGURATION_SYNC_STORE_KEY],void 0,t);return!(0,v.isEmpty)(a)}}catch(s){if(s.fileOperationResult!==1)return!0}return!1}async resolveContent(s){return this.h.isEqual(this.remoteResource,s)||this.h.isEqual(this.localResource,s)||this.h.isEqual(this.acceptedResource,s)||this.h.isEqual(this.baseResource,s)?this.ab(s):null}async ab(s){let t=await super.ab(s);if(t){const a=await this.xb(),r=await this.Kb();t=(0,v.updateIgnoredSettings)(t,"{}",r,a)}return t}Gb(s){return s.syncData?this.Hb(s.syncData.content):null}Hb(s){try{return u(s)}catch(t){this.L.error(t)}return null}Ib(s){return{settings:s}}async Kb(s){if(!this.Jb){this.Jb=this.ub.resolveDefaultIgnoredSettings();const a=i.Event.any(i.Event.filter(this.zb.onDidInstallExtensions,r=>r.some(({local:c})=>!!c)),i.Event.filter(this.zb.onDidUninstallExtension,r=>!r.error))(()=>{a.dispose(),this.Jb=void 0})}const t=await this.Jb;return(0,v.getIgnoredSettings)(t,this.M,s)}Lb(s){if(this.vb(s,!1))throw new l.UserDataSyncError((0,R.localize)(0,null),"LocalInvalidContent",this.resource)}};h=ye([K(2,S.IFileService),K(3,P.IEnvironmentService),K(4,C.IStorageService),K(5,l.IUserDataSyncStoreService),K(6,l.IUserDataSyncBackupStoreService),K(7,l.IUserDataSyncLogService),K(8,l.IUserDataSyncUtilService),K(9,A.IConfigurationService),K(10,l.IUserDataSyncEnablementService),K(11,b.ITelemetryService),K(12,I.IExtensionManagementService),K(13,w.IUriIdentityService)],h),e.SettingsSynchroniser=h;let f=class extends d.AbstractInitializer{constructor(s,t,a,r,c,o){super("settings",t,a,r,s,c,o)}async doInitialize(s){const t=s.syncData?this.i(s.syncData.content):null;if(!t){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.c()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,D.VSBuffer.fromString(t.settings)),await this.n(s)}async c(){try{const s=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,v.isEmpty)(s.value.toString().trim())}catch(s){return s.fileOperationResult===1}}i(s){try{return u(s)}catch(t){this.j.error(t)}return null}};f=ye([K(0,S.IFileService),K(1,y.IUserDataProfilesService),K(2,P.IEnvironmentService),K(3,l.IUserDataSyncLogService),K(4,C.IStorageService),K(5,w.IUriIdentityService)],f),e.SettingsInitializer=f}),define(re[121],ae([0,1,17,3,32,16,14,13,19,22,30,18,41,254,26]),function(_,e,D,i,R,A,L,P,I,S,C,b,w,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=e.parseSnippets=void 0;function g(m){return JSON.parse(m.content)}e.parseSnippets=g;let v=class extends w.AbstractSynchroniser{constructor(u,h,f,n,s,t,a,r,c,o,p,E){super({syncResource:"snippets",profile:u},h,n,f,s,t,a,o,p,r,c,E),this.mb=1,this.p=u.snippetsHome,this.B(this.C.watch(f.userRoamingDataHome)),this.B(this.C.watch(this.p)),this.B(i.Event.filter(this.C.onDidFilesChange,k=>k.affects(this.p))(()=>this.triggerLocalChange()))}async nb(u,h,f){const n=await this.Cb(),s=this.Bb(n),t=u.syncData?this.Ab(u.syncData):null;h=h===null&&f?u:h;const a=h&&h.syncData?this.Ab(h.syncData):null;t?this.L.trace(`${this.y}: Merging remote snippets with local snippets...`):this.L.trace(`${this.y}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const r=(0,y.merge)(s,t,a);return this.wb(r,n,t||{},a||{})}async rb(u){const h=u.syncData?this.Ab(u.syncData):null;if(h===null)return!0;const f=await this.Cb(),n=this.Bb(f),s=(0,y.merge)(n,h,h);return Object.keys(s.remote.added).length>0||Object.keys(s.remote.updated).length>0||s.remote.removed.length>0||s.conflicts.length>0}async ob(u,h){return u.previewResult}async pb(u,h,f,n){if(this.h.isEqualOrParent(h,this.g.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:u.fileContent?u.fileContent.value.toString():null,localChange:0,remoteChange:u.fileContent?u.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(h,this.g.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:u.remoteContent,localChange:u.remoteContent!==null?u.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(h,this.g))return f===void 0?{content:u.previewResult.content,localChange:u.previewResult.localChange,remoteChange:u.previewResult.remoteChange}:{content:f,localChange:f===null?u.fileContent!==null?3:0:2,remoteChange:f===null?u.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${h.toString()}`)}async qb(u,h,f,n){const s=f.map(([t,a])=>({...t,acceptResult:a}));s.every(({localChange:t,remoteChange:a})=>t===0&&a===0)&&this.L.info(`${this.y}: No changes found during synchronizing snippets.`),s.some(({localChange:t})=>t!==0)&&(await this.xb(s),await this.yb(s,n)),s.some(({remoteChange:t})=>t!==0)&&(u=await this.zb(s,u,n)),h?.ref!==u.ref&&(this.L.trace(`${this.y}: Updating last synchronized snippets...`),await this.cb(u),this.L.info(`${this.y}: Updated last synchronized snippets`));for(const{previewResource:t}of s)try{await this.C.del(t)}catch{}}wb(u,h,f,n){const s=new Map;for(const t of Object.keys(u.local.added)){const a={content:u.local.added[t],hasConflicts:!1,localChange:1,remoteChange:0};s.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[t],previewResource:this.h.joinPath(this.g,t),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(u.local.updated)){const a={content:u.local.updated[t],hasConflicts:!1,localChange:2,remoteChange:0},r=h[t]?h[t].value.toString():null;s.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:h[t],localContent:r,remoteResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[t],previewResource:this.h.joinPath(this.g,t),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of u.local.removed){const a={content:null,hasConflicts:!1,localChange:3,remoteChange:0},r=h[t]?h[t].value.toString():null;s.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:h[t],localContent:r,remoteResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,t),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(u.remote.added)){const a={content:u.remote.added[t],hasConflicts:!1,localChange:0,remoteChange:1},r=h[t]?h[t].value.toString():null;s.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:h[t],localContent:r,remoteResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,t),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(u.remote.updated)){const a={content:u.remote.updated[t],hasConflicts:!1,localChange:0,remoteChange:2},r=h[t]?h[t].value.toString():null;s.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:h[t],localContent:r,remoteResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[t],previewResource:this.h.joinPath(this.g,t),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of u.remote.removed){const a={content:null,hasConflicts:!1,localChange:0,remoteChange:3};s.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[t],previewResource:this.h.joinPath(this.g,t),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of u.conflicts){const a={content:n[t]??null,hasConflicts:!0,localChange:h[t]?2:1,remoteChange:f[t]?2:1},r=h[t]?h[t].value.toString():null;s.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:h[t]||null,localContent:r,remoteResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[t]||null,previewResource:this.h.joinPath(this.g,t),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(h))if(!s.has(t)){const a={content:h[t]?h[t].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},r=h[t]?h[t].value.toString():null;s.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:h[t]||null,localContent:r,remoteResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[t]||null,previewResource:this.h.joinPath(this.g,t),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...s.values()]}async resolveContent(u){return this.h.isEqualOrParent(u,this.g.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.h.isEqualOrParent(u,this.g.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.h.isEqualOrParent(u,this.g.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.h.isEqualOrParent(u,this.g.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"}))?this.ab(u):null}async hasLocalData(){try{const u=await this.Cb();if(Object.keys(u).length)return!0}catch{}return!1}async xb(u){const h={};for(const f of u)f.fileContent&&(h[this.h.basename(f.localResource)]=f.fileContent);await this.kb(JSON.stringify(this.Bb(h)))}async yb(u,h){for(const{fileContent:f,acceptResult:n,localResource:s,remoteResource:t,localChange:a}of u)if(a!==0){const r=t?this.h.basename(t):this.h.basename(s),c=this.h.joinPath(this.p,r);a===3?(this.L.trace(`${this.y}: Deleting snippet...`,this.h.basename(c)),await this.C.del(c),this.L.info(`${this.y}: Deleted snippet`,this.h.basename(c))):a===1?(this.L.trace(`${this.y}: Creating snippet...`,this.h.basename(c)),await this.C.createFile(c,D.VSBuffer.fromString(n.content),{overwrite:h}),this.L.info(`${this.y}: Created snippet`,this.h.basename(c))):(this.L.trace(`${this.y}: Updating snippet...`,this.h.basename(c)),await this.C.writeFile(c,D.VSBuffer.fromString(n.content),h?void 0:f),this.L.info(`${this.y}: Updated snippet`,this.h.basename(c)))}}async zb(u,h,f){const n=h.syncData?this.Ab(h.syncData):{},s=(0,R.deepClone)(n);for(const{acceptResult:t,localResource:a,remoteResource:r,remoteChange:c}of u)if(c!==0){const o=a?this.h.basename(a):this.h.basename(r);c===3?delete s[o]:s[o]=t.content}return(0,y.areSame)(n,s)||(this.L.trace(`${this.y}: Updating remote snippets...`),h=await this.jb(JSON.stringify(s),f?null:h.ref),this.L.info(`${this.y}: Updated remote snippets`)),h}Ab(u){return g(u)}Bb(u){const h={};for(const f of Object.keys(u))h[f]=u[f].value.toString();return h}async Cb(){const u={};let h;try{h=await this.C.resolve(this.p)}catch(f){if(f instanceof P.FileOperationError&&f.fileOperationResult===1)return u;throw f}for(const f of h.children||[]){const n=f.resource,s=this.h.extname(n);if(s===".json"||s===".code-snippets"){const t=this.h.relativePath(this.p,n),a=await this.C.readFile(n);u[t]=a}}return u}};v=ye([K(2,L.IEnvironmentService),K(3,P.IFileService),K(4,I.IStorageService),K(5,d.IUserDataSyncStoreService),K(6,d.IUserDataSyncBackupStoreService),K(7,d.IUserDataSyncLogService),K(8,A.IConfigurationService),K(9,d.IUserDataSyncEnablementService),K(10,S.ITelemetryService),K(11,C.IUriIdentityService)],v),e.SnippetsSynchroniser=v;let l=class extends w.AbstractInitializer{constructor(u,h,f,n,s,t){super("snippets",h,f,n,u,s,t)}async doInitialize(u){const h=u.syncData?JSON.parse(u.syncData.content):null;if(!h){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.c()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const n of Object.keys(h)){const s=h[n];if(s){const t=this.d.joinPath(this.g.defaultProfile.snippetsHome,n);await this.k.createFile(t,D.VSBuffer.fromString(s)),this.j.info("Created snippet",this.d.basename(t))}}await this.n(u)}async c(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(u){return u.fileOperationResult===1}}};l=ye([K(0,P.IFileService),K(1,b.IUserDataProfilesService),K(2,L.IEnvironmentService),K(3,d.IUserDataSyncLogService),K(4,I.IStorageService),K(5,C.IUriIdentityService)],l),e.SnippetsInitializer=l}),define(re[122],ae([0,1,17,16,14,13,19,22,30,18,41,26]),function(_,e,D,i,R,A,L,P,I,S,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function w(v,l){try{return JSON.parse(v).tasks??null}catch(m){return l.error(m),null}}e.getTasksContentFromSyncContent=w;let y=class extends C.AbstractFileSynchroniser{constructor(l,m,u,h,f,n,s,t,a,r,c,o){super(l.tasksResource,{syncResource:"tasks",profile:l},m,t,a,r,u,h,s,c,f,n,o),this.mb=1,this.vb=this.h.joinPath(this.g,"tasks.json"),this.wb=this.vb.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"base"}),this.xb=this.vb.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"local"}),this.yb=this.vb.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.zb=this.vb.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async nb(l,m,u,h){const f=l.syncData?w(l.syncData.content,this.L):null;m=m===null&&u?l:m;const n=m?.syncData?w(m.syncData.content,this.L):null,s=await this.p();let t=null,a=!1,r=!1,c=!1;if(l.syncData){const E=s?s.value.toString():null;if(!n||n!==E||n!==f){this.L.trace(`${this.y}: Merging remote tasks with local tasks...`);const k=g(E,f,n);t=k.content,c=k.hasConflicts,a=k.hasLocalChanged,r=k.hasRemoteChanged}}else s&&(this.L.trace(`${this.y}: Remote tasks does not exist. Synchronizing tasks for the first time.`),t=s.value.toString(),r=!0);const o={content:c?n:t,localChange:a?s?2:1:0,remoteChange:r?2:0,hasConflicts:c},p=s?s.value.toString():null;return[{fileContent:s,baseResource:this.wb,baseContent:n,localResource:this.xb,localContent:p,localChange:o.localChange,remoteResource:this.yb,remoteContent:f,remoteChange:o.remoteChange,previewResource:this.vb,previewResult:o,acceptedResource:this.zb}]}async rb(l){const m=l?.syncData?w(l.syncData.content,this.L):null;if(m===null)return!0;const u=await this.p(),h=u?u.value.toString():null,f=g(h,m,m);return f.hasLocalChanged||f.hasRemoteChanged}async ob(l,m){return l.previewResult}async pb(l,m,u,h){if(this.h.isEqual(m,this.xb))return{content:l.fileContent?l.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(m,this.yb))return{content:l.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(m,this.vb))return u===void 0?{content:l.previewResult.content,localChange:l.previewResult.localChange,remoteChange:l.previewResult.remoteChange}:{content:u,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${m.toString()}`)}async qb(l,m,u,h){const{fileContent:f}=u[0][0],{content:n,localChange:s,remoteChange:t}=u[0][1];if(s===0&&t===0&&this.L.info(`${this.y}: No changes found during synchronizing tasks.`),s!==0&&(this.L.trace(`${this.y}: Updating local tasks...`),f&&await this.kb(JSON.stringify(this.Fb(f.value.toString()))),n?await this.r(n,f,h):await this.sb(),this.L.info(`${this.y}: Updated local tasks`)),t!==0){this.L.trace(`${this.y}: Updating remote tasks...`);const a=JSON.stringify(this.Fb(n));l=await this.jb(a,h?null:l.ref),this.L.info(`${this.y}: Updated remote tasks`)}try{await this.C.del(this.vb)}catch{}m?.ref!==l.ref&&(this.L.trace(`${this.y}: Updating last synchronized tasks...`),await this.cb(l),this.L.info(`${this.y}: Updated last synchronized tasks`))}async hasLocalData(){return this.C.exists(this.i)}async resolveContent(l){return this.h.isEqual(this.yb,l)||this.h.isEqual(this.wb,l)||this.h.isEqual(this.xb,l)||this.h.isEqual(this.zb,l)?this.ab(l):null}Fb(l){return l?{tasks:l}:{}}};y=ye([K(2,b.IUserDataSyncStoreService),K(3,b.IUserDataSyncBackupStoreService),K(4,b.IUserDataSyncLogService),K(5,i.IConfigurationService),K(6,b.IUserDataSyncEnablementService),K(7,A.IFileService),K(8,R.IEnvironmentService),K(9,L.IStorageService),K(10,P.ITelemetryService),K(11,I.IUriIdentityService)],y),e.TasksSynchroniser=y;let d=class extends C.AbstractInitializer{constructor(l,m,u,h,f,n){super("tasks",m,u,h,l,f,n),this.c=this.g.defaultProfile.tasksResource}async doInitialize(l){const m=l.syncData?w(l.syncData.content,this.j):null;if(!m){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,D.VSBuffer.fromString(m)),await this.n(l)}async i(){return this.k.exists(this.c)}};d=ye([K(0,A.IFileService),K(1,S.IUserDataProfilesService),K(2,R.IEnvironmentService),K(3,b.IUserDataSyncLogService),K(4,L.IStorageService),K(5,I.IUriIdentityService)],d),e.TasksInitializer=d;function g(v,l,m){if(v===null&&l===null&&m===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(v===l)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const u=m!==v,h=m!==l;return!u&&!h?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:u&&!h?{content:v,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:h&&!u?{content:l,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:v,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(re[123],ae([0,1,43,16,14,13,19,22,30,18,41,255,26]),function(_,e,D,i,R,A,L,P,I,S,C,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseUserDataProfilesManifest=e.stringifyLocalProfiles=e.UserDataProfilesManifestSynchroniser=void 0;let y=class extends C.AbstractSynchroniser{constructor(l,m,u,h,f,n,s,t,a,r,c,o,p){super({syncResource:"profiles",profile:l},m,h,f,n,s,t,c,o,a,r,p),this.r=u,this.mb=1,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async getLastSyncedProfiles(){const l=await this.getLastSyncUserData();return l?.syncData?g(l.syncData):null}async getRemoteSyncedProfiles(l){const m=await this.getLastSyncUserData(),u=await this.R(l,m);return u?.syncData?g(u.syncData):null}async nb(l,m,u){if(!this.r.isEnabled())throw new w.UserDataSyncError("Cannot sync profiles because they are disabled","LocalError");const h=l.syncData?g(l.syncData):null,f=m?.syncData?g(m.syncData):null,n=this.zb(),{local:s,remote:t}=(0,b.merge)(n,h,f,[]),a={local:s,remote:t,content:f?this.Ab(f):null,localChange:s.added.length>0||s.removed.length>0||s.updated.length>0?2:0,remoteChange:t!==null?2:0},r=d(n,!1);return[{baseResource:this.baseResource,baseContent:f?this.Ab(f):null,localResource:this.localResource,localContent:r,remoteResource:this.remoteResource,remoteContent:h?this.Ab(h):null,remoteProfiles:h,previewResource:this.previewResource,previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.acceptedResource}]}async rb(l){const m=l?.syncData?g(l.syncData):null,u=this.zb(),{remote:h}=(0,b.merge)(u,m,m,[]);return!!h?.added.length||!!h?.removed.length||!!h?.updated.length}async ob(l,m){return{...l.previewResult,hasConflicts:!1}}async pb(l,m,u,h){if(this.h.isEqual(m,this.localResource))return this.wb(l);if(this.h.isEqual(m,this.remoteResource))return this.xb(l);if(this.h.isEqual(m,this.previewResource))return l.previewResult;throw new Error(`Invalid Resource: ${m.toString()}`)}async wb(l){const m=this.zb(),u=(0,b.merge)(m,null,null,[]),{local:h,remote:f}=u;return{content:l.localContent,local:h,remote:f,localChange:h.added.length>0||h.removed.length>0||h.updated.length>0?2:0,remoteChange:f!==null?2:0}}async xb(l){const m=l.remoteContent?JSON.parse(l.remoteContent):null,u=[],h=[];for(const f of this.zb()){const n=m?.find(s=>s.id===f.id);n&&(u.push({id:f.id,name:f.name,collection:n.collection}),h.push(f))}if(m!==null){const f=(0,b.merge)(h,m,u,[]),{local:n,remote:s}=f;return{content:l.remoteContent,local:n,remote:s,localChange:n.added.length>0||n.removed.length>0||n.updated.length>0?2:0,remoteChange:s!==null?2:0}}else return{content:l.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async qb(l,m,u,h){const{local:f,remote:n,localChange:s,remoteChange:t}=u[0][1];if(s===0&&t===0&&this.L.info(`${this.y}: No changes found during synchronizing profiles.`),s!==0){await this.kb(d(this.zb(),!1));const a=[];for(const r of f.added)a.push((async()=>{this.L.trace(`${this.y}: Creating '${r.name}' profile...`),await this.r.createProfile(r.id,r.name,{shortName:r.shortName}),this.L.info(`${this.y}: Created profile '${r.name}'.`)})());for(const r of f.removed)a.push((async()=>{this.L.trace(`${this.y}: Removing '${r.name}' profile...`),await this.r.removeProfile(r),this.L.info(`${this.y}: Removed profile '${r.name}'.`)})());for(const r of f.updated){const c=this.r.profiles.find(o=>o.id===r.id);c?a.push((async()=>{this.L.trace(`${this.y}: Updating '${r.name}' profile...`),await this.r.updateProfile(c,{name:r.name,shortName:r.shortName}),this.L.info(`${this.y}: Updated profile '${r.name}'.`)})()):this.L.info(`${this.y}: Could not find profile with id '${r.id}' to update.`)}await Promise.all(a)}if(t!==0){const a=u[0][0].remoteProfiles||[];this.L.trace(`${this.y}: Updating remote profiles...`);for(const r of n?.added||[]){const c=await this.G.createCollection(this.z);a.push({id:r.id,name:r.name,collection:c,shortName:r.shortName})}for(const r of n?.removed||[])a.splice(a.findIndex(({id:c})=>r.id===c),1);for(const r of n?.updated||[]){const c=a.find(({id:o})=>r.id===o);c&&a.splice(a.indexOf(c),1,{id:r.id,name:r.name,collection:c.collection,shortName:r.shortName})}l=await this.jb(this.Ab(a),h?null:l.ref),this.L.info(`${this.y}: Updated remote profiles.${n?.added.length?` Added: ${JSON.stringify(n.added.map(r=>r.name))}.`:""}${n?.updated.length?` Updated: ${JSON.stringify(n.updated.map(r=>r.name))}.`:""}${n?.removed.length?` Removed: ${JSON.stringify(n.removed.map(r=>r.name))}.`:""}`);for(const r of n?.removed||[])await this.G.deleteCollection(r.collection,this.z)}m?.ref!==l.ref&&(this.L.trace(`${this.y}: Updating last synchronized profiles...`),await this.cb(l),this.L.info(`${this.y}: Updated last synchronized profiles.`))}async hasLocalData(){return this.zb().length>0}async resolveContent(l){if(this.h.isEqual(this.remoteResource,l)||this.h.isEqual(this.baseResource,l)||this.h.isEqual(this.localResource,l)||this.h.isEqual(this.acceptedResource,l)){const m=await this.ab(l);return m&&(0,D.toFormattedString)(JSON.parse(m),{})}return null}zb(){return this.r.profiles.filter(l=>!l.isDefault&&!l.isTransient)}Ab(l){return JSON.stringify([...l].sort((m,u)=>m.name.localeCompare(u.name)))}};y=ye([K(2,S.IUserDataProfilesService),K(3,A.IFileService),K(4,R.IEnvironmentService),K(5,L.IStorageService),K(6,w.IUserDataSyncStoreService),K(7,w.IUserDataSyncBackupStoreService),K(8,w.IUserDataSyncLogService),K(9,i.IConfigurationService),K(10,w.IUserDataSyncEnablementService),K(11,P.ITelemetryService),K(12,I.IUriIdentityService)],y),e.UserDataProfilesManifestSynchroniser=y;function d(v,l){const m=[...v].sort((u,h)=>u.name.localeCompare(h.name)).map(u=>({id:u.id,name:u.name}));return l?(0,D.toFormattedString)(m,{}):JSON.stringify(m)}e.stringifyLocalProfiles=d;function g(v){return JSON.parse(v.content)}e.parseUserDataProfilesManifest=g}),define(re[270],ae([0,1,6,17,65,2,21,16,14,13,18,26]),function(_,e,D,i,R,A,L,P,I,S,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let w=class extends A.Disposable{constructor(d,g,v,l,m){super(),this.a=d,this.b=g,this.c=v,this.f=l,this.g=m;for(const u of this.g.profiles)for(const h of b.ALL_SYNC_RESOURCES)this.i(this.h(u,h))}async getAllRefs(d,g){const v=this.h(d,g),l=await this.b.resolve(v);return l.children?l.children.filter(u=>u.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(u.name)).sort().reverse().map(u=>({ref:u.name,created:this.j(u)})):[]}async resolveContent(d,g,v){const l=this.h(d,g),m=(0,L.joinPath)(l,v);try{return(await this.b.readFile(m)).value.toString()}catch(u){return this.f.error(u),null}}async backup(d,g,v){const l=this.h(d,g),m=(0,L.joinPath)(l,`${(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(m,i.VSBuffer.fromString(v))}catch(u){this.f.error(u)}try{this.i(l)}catch{}}h(d,g){return(0,L.joinPath)(this.a.userDataSyncHome,...d.isDefault?[g]:[d.id,g])}async i(d){try{try{if(!await this.b.exists(d))return}catch{return}const g=await this.b.resolve(d);if(g.children){const v=g.children.filter(h=>h.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(h.name)).sort(),l=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let m=v.filter(h=>Date.now()-this.j(h)>l);const u=v.length-m.length;u<10&&(m=m.slice(10-u)),await D.Promises.settled(m.map(async h=>{this.f.info("Deleting from backup",h.resource.path),await this.b.del(h.resource)}))}}catch(g){this.f.error(g)}}j(d){return d.ctime||new Date(parseInt(d.name.substring(0,4)),parseInt(d.name.substring(4,6))-1,parseInt(d.name.substring(6,8)),parseInt(d.name.substring(9,11)),parseInt(d.name.substring(11,13)),parseInt(d.name.substring(13,15))).getTime()}};w=ye([K(0,I.IEnvironmentService),K(1,S.IFileService),K(2,P.IConfigurationService),K(3,b.IUserDataSyncLogService),K(4,C.IUserDataProfilesService)],w),e.UserDataSyncBackupStoreService=w}),define(re[271],ae([0,1,3,2,5,14,19,22,26]),function(_,e,D,i,R,A,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const S="sync.enable";let C=class extends i.Disposable{constructor(w,y,d,g){super(),this.c=w,this.f=y,this.g=d,this.h=g,this.a=new D.Emitter,this.onDidChangeEnablement=this.a.event,this.b=new D.Emitter,this.onDidChangeResourceEnablement=this.b.event,this.B(w.onDidChangeValue(v=>this.j(v)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(S,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(w){w&&!this.canToggleEnablement()||(this.f.publicLog2(S,{enabled:w}),this.c.store(S,w,-1,1))}isResourceEnabled(w){return this.c.getBoolean((0,I.getEnablementKey)(w),-1,!0)}setResourceEnablement(w,y){if(this.isResourceEnabled(w)!==y){const d=(0,I.getEnablementKey)(w);this.i(d,y)}}getResourceSyncStateVersion(w){}i(w,y){this.c.store(w,y,-1,R.isWeb?0:1)}j(w){if(w.scope!==-1)return;if(S===w.key){this.a.fire(this.isEnabled());return}const y=I.ALL_SYNC_RESOURCES.filter(d=>(0,I.getEnablementKey)(d)===w.key)[0];if(y){this.b.fire([y,this.isResourceEnabled(y)]);return}}};C=ye([K(0,L.IStorageService),K(1,P.ITelemetryService),K(2,A.IEnvironmentService),K(3,I.IUserDataSyncStoreManagementService)],C),e.UserDataSyncEnablementService=C}),define(re[81],ae([0,1,3,2,5,27,179,14,13,4,25,45,19,26]),function(_,e,D,i,R,A,L,P,I,S,C,b,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,S.createDecorator)("IUserDataSyncMachinesService");const d="sync.currentMachineName",g="Safari",v="Chrome",l="Edge",m="Firefox",u="Android";function h(s){switch(s){case g:case v:case l:case m:case u:case(0,R.PlatformToString)(0):return!0}return!1}e.isWebPlatform=h;function f(){return R.isSafari?g:R.isChrome?v:R.isEdge?l:R.isFirefox?m:R.isAndroid?u:(0,R.PlatformToString)(R.isWeb?0:R.platform)}let n=class rt extends i.Disposable{constructor(t,a,r,c,o,p){super(),this.h=r,this.i=c,this.j=o,this.k=p,this.c=this.B(new D.Emitter),this.onDidChange=this.c.event,this.g=null,this.f=(0,b.getServiceMachineId)(t,a,r)}async getMachines(t){const a=await this.f;return(await this.m(t)).machines.map(c=>({...c,isCurrent:c.id===a}))}async addCurrentMachine(t){const a=await this.f,r=await this.m(t);r.machines.some(({id:c})=>c===a)||(r.machines.push({id:a,name:this.l(r.machines),platform:f()}),await this.n(r))}async removeCurrentMachine(t){const a=await this.f,r=await this.m(t),c=r.machines.filter(({id:o})=>o!==a);c.length!==r.machines.length&&(r.machines=c,await this.n(r))}async renameMachine(t,a,r){const c=await this.m(r),o=c.machines.find(({id:p})=>p===t);if(o){o.name=a,await this.n(c);const p=await this.f;t===p&&this.h.store(d,a,-1,1)}}async setEnablements(t){const a=await this.m();for(const[r,c]of t){const o=a.machines.find(p=>p.id===r);o&&(o.disabled=c?void 0:!0)}await this.n(a)}l(t){const a=this.h.get(d,-1);if(a)return a;const r=`${this.k.embedderIdentifier?`${this.k.embedderIdentifier} - `:""}${f()} (${this.k.nameShort})`,c=new RegExp(`${(0,A.escapeRegExpCharacters)(r)}\\s#(\\d+)`);let o=0;for(const p of t){const E=c.exec(p.name),k=E?parseInt(E[1]):0;o=k>o?k:o}return`${r} #${o+1}`}async m(t){this.g=await this.p(t);const a=this.r(this.g);if(a.version!==rt.a)throw new Error((0,L.localize)(0,null,this.k.nameLong));return a}async n(t){const a=JSON.stringify(t),r=await this.i.writeResource(rt.b,a,this.g?.ref||null);this.g={ref:r,content:a},this.c.fire()}async p(t){if(this.g){const a=t&&t.latest?t.latest[rt.b]:void 0;if(this.g.ref===a)return this.g;if(a===void 0&&this.g.content===null)return this.g}return this.i.readResource(rt.b,this.g)}r(t){if(t.content!==null)try{return JSON.parse(t.content)}catch(a){this.j.error(a)}return{version:rt.a,machines:[]}}};n.a=1,n.b="machines",n=ye([K(0,P.IEnvironmentService),K(1,I.IFileService),K(2,w.IStorageService),K(3,y.IUserDataSyncStoreService),K(4,y.IUserDataSyncLogService),K(5,C.IProductService)],n),e.UserDataSyncMachinesService=n}),define(re[272],ae([0,1,6,65,38,9,3,2,5,21,7,177,25,19,22,26,78,81]),function(_,e,D,i,R,A,L,P,I,S,C,b,w,y,d,g,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const m="sync.disableMachineEventually",u="sync.sessionId",h="sync.storeUrl",f="sync.productQuality";let n=class extends P.Disposable{get j(){const a=this.z.get(h,-1);return a?C.URI.parse(a):void 0}set j(a){a?this.z.store(h,a.toString(),-1,1):this.z.remove(h,-1)}get l(){return this.z.get(f,-1)}set l(a){a?this.z.store(f,a,-1,1):this.z.remove(f,-1)}constructor(a,r,c,o,p,E,k,F,N,q){super(),this.n=r,this.p=c,this.r=o,this.s=p,this.u=E,this.v=k,this.w=F,this.y=N,this.z=q,this.a=this.B(new P.MutableDisposable),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new L.Emitter),this.onError=this.h.event,this.N=[],this.f=this.B(new D.ThrottledDelayer(this.O())),this.i=this.j,this.j=r.userDataSyncStore?.url,this.k=this.l,this.l=a.quality,this.j&&(this.u.info("Using settings sync service",this.j.toString()),this.B(r.onDidChangeUserDataSyncStore(()=>{(0,S.isEqual)(this.j,r.userDataSyncStore?.url)||(this.i=this.j,this.j=r.userDataSyncStore?.url,this.j&&this.u.info("Using settings sync service",this.j.toString()))})),this.r.isEnabled()?this.u.info("Auto Sync is enabled."):this.u.info("Auto Sync is disabled."),this.C(),this.L()&&this.J(),this.B(k.onDidChangeAccount(()=>this.C())),this.B(c.onDidChangeDonotMakeRequestsUntil(()=>this.C())),this.B(p.onDidChangeLocal(j=>this.triggerSync([j],!1,!1))),this.B(L.Event.filter(this.r.onDidChangeResourceEnablement,([,j])=>j)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.n.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}C(){const{enabled:a,message:r}=this.F();a?this.a.value===void 0&&(this.a.value=new s(this.i,1e3*60*5,this.n,this.p,this.s,this.y,this.u,this.z),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(c=>this.I(c))),this.D()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(r&&this.u.info(r),this.a.clear()):r&&this.r.isEnabled()&&this.u.info(r))}D(){return!0}F(){return this.r.isEnabled()?this.v.account?this.p.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,i.toLocalISOString)(this.p.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.M(),this.i=this.j,this.G(!0)}async turnOff(a,r,c){try{this.v.account&&!c&&await this.y.removeCurrentMachine(),this.G(!1),this.z.remove(u,-1),a?(this.w.publicLog2("sync/turnOffEveryWhere"),await this.s.reset()):await this.s.resetLocal()}catch(o){if(this.u.error(o),r)this.G(!1);else throw o}}G(a){this.r.isEnabled()!==a&&(this.r.setEnablement(a),this.C())}H(){return!!this.k&&!!this.l&&this.k!==this.l}async I(a){if(!a){this.b=0;return}const r=g.UserDataSyncError.toUserDataSyncError(a);r instanceof g.UserDataAutoSyncError&&this.w.publicLog2("autosync/error",{code:r.code,service:this.n.userDataSyncStore.url.toString()}),r.code==="SessionExpired"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because current session is expired")):r.code==="TurnedOff"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):r.code==="LocalTooManyRequests"?(this.g=!0,this.u.info("Auto Sync: Suspended sync because of making too many requests to server"),this.C()):r.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.J(),this.u.info("Auto Sync: Turned off sync because of making too many requests to server")):r.code==="UpgradeRequired"||r.code==="Gone"?(await this.turnOff(!1,!0,!0),this.J(),this.u.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):r.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${r.resource} content with newer version than of client. Requires client upgrade.`)):r.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${r.resource} content with older version than of client. Requires server reset.`)):r.code==="ServiceChanged"||r.code==="DefaultServiceChanged"?I.isWeb&&r.code==="DefaultServiceChanged"&&!this.H()?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.u.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.u.error(r),this.b++),this.h.fire(r)}async J(){this.z.store(m,!0,-1,1),await(0,D.timeout)(1e3*60*10),this.L()&&(this.M(),!this.r.isEnabled()&&this.v.account&&await this.y.removeCurrentMachine())}L(){return this.z.getBoolean(m,-1,!1)}M(){this.z.remove(m,-1)}async triggerSync(a,r,c){if(this.a.value===void 0)return this.f.cancel();if(r&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.u.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.N.push(...a),this.f.trigger(async()=>{this.u.trace("activity sources",...this.N);const o=this.v.account?.authenticationProviderId||"";this.w.publicLog2("sync/triggered",{sources:this.N,providerId:o}),this.N=[],this.a.value&&await this.a.value.sync("Activity",c)},this.b?this.O()*1*Math.min(Math.pow(2,this.b),60):this.O())}O(){return 2e3}};n=ye([K(0,w.IProductService),K(1,g.IUserDataSyncStoreManagementService),K(2,g.IUserDataSyncStoreService),K(3,g.IUserDataSyncEnablementService),K(4,g.IUserDataSyncService),K(5,g.IUserDataSyncLogService),K(6,v.IUserDataSyncAccountService),K(7,d.ITelemetryService),K(8,l.IUserDataSyncMachinesService),K(9,y.IStorageService)],n),e.UserDataAutoSyncService=n;class s extends P.Disposable{constructor(a,r,c,o,p,E,k,F){super(),this.j=a,this.k=r,this.l=c,this.m=o,this.n=p,this.p=E,this.r=k,this.s=F,this.b=this.B(new P.MutableDisposable),this.c=this.B(new L.Emitter),this.onDidStartSync=this.c.event,this.f=this.B(new L.Emitter),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.u())),this.B((0,P.toDisposable)(()=>{this.i&&(this.i.cancel(),this.r.info("Auto sync: Cancelled sync that is in progress"),this.i=void 0),this.h?.stop(),this.r.info("Auto Sync: Stopped")})),this.sync(s.a,!1)}u(){this.b.value=(0,D.disposableTimeout)(()=>this.sync(s.a,!1),this.k)}sync(a,r){const c=(0,D.createCancelablePromise)(async o=>{if(this.i)try{this.r.debug("Auto Sync: Waiting until sync is finished."),await this.i}catch(p){if((0,A.isCancellationError)(p))return}return this.y(a,r,o)});return this.i=c,this.i.finally(()=>this.i=void 0),this.i}v(){return this.j!==void 0&&!(0,S.isEqual)(this.j,this.l.userDataSyncStore?.url)}async w(){const a=await this.l.getPreviousUserDataSyncStore(),r=this.l.userDataSyncStore;return!!r&&!!a&&(!(0,S.isEqual)(r.defaultUrl,a.defaultUrl)||!(0,S.isEqual)(r.insidersUrl,a.insidersUrl)||!(0,S.isEqual)(r.stableUrl,a.stableUrl))}async y(a,r,c){this.r.info(`Auto Sync: Triggered by ${a}`),this.c.fire();let o;try{if(this.h=await this.n.createSyncTask(this.g,r),c.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.n.hasPreviouslySynced())throw this.v()?await this.w()?new g.UserDataAutoSyncError((0,b.localize)(0,null),"DefaultServiceChanged"):new g.UserDataAutoSyncError((0,b.localize)(1,null),"ServiceChanged"):new g.UserDataAutoSyncError((0,b.localize)(2,null),"TurnedOff");const p=this.s.get(u,-1);if(p&&this.g&&p!==this.g.session)throw this.v()?await this.w()?new g.UserDataAutoSyncError((0,b.localize)(3,null),"DefaultServiceChanged"):new g.UserDataAutoSyncError((0,b.localize)(4,null),"ServiceChanged"):new g.UserDataAutoSyncError((0,b.localize)(5,null),"SessionExpired");const E=await this.p.getMachines(this.g||void 0);if(c.isCancellationRequested)return;const k=E.find(F=>F.isCurrent);if(k?.disabled)throw new g.UserDataAutoSyncError((0,b.localize)(6,null),"TurnedOff");if(await this.h.run(),this.g===null)try{this.g=await this.m.manifest(null)}catch(F){throw new g.UserDataAutoSyncError((0,R.toErrorMessage)(F),F instanceof g.UserDataSyncError?F.code:"Unknown")}if(this.g&&this.g.session!==p&&this.s.store(u,this.g.session,-1,1),c.isCancellationRequested)return;k||await this.p.addCurrentMachine(this.g||void 0)}catch(p){this.r.error(p),o=p}this.f.fire(o)}register(a){return super.B(a)}}s.a="Interval"}),define(re[273],ae([0,1,7,180,14,13,45,19,30,26,18,41,121,120,119,16,122,117,118,4,123,43]),function(_,e,D,i,R,A,L,P,I,S,C,b,w,y,d,g,v,l,m,u,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceProviderService=void 0;let n=class Ve{constructor(t,a,r,c,o,p,E,k,F,N){this.e=t,this.f=a,this.g=r,this.h=o,this.i=p,this.j=E,this.k=k,this.l=F,this.m=N,this.d=c.extUri}async getRemoteSyncedProfiles(){const t=await this.e.readResource("profiles",null,void 0);if(t.content){const a=this.K(t.content,"profiles");return(0,h.parseUserDataProfilesManifest)(a)}return[]}async getRemoteSyncResourceHandles(t,a){return(await this.e.getAllResourceRefs(t,a?.collection)).map(({created:c,ref:o})=>({created:c,uri:this.I({remote:!0,syncResource:t,profile:a?.id??this.k.defaultProfile.id,collection:a?.collection,ref:o,node:void 0})}))}async getLocalSyncResourceHandles(t,a){return(await this.f.getAllRefs(a,t)).map(({created:c,ref:o})=>({created:c,uri:this.I({remote:!1,syncResource:t,profile:a.id,collection:void 0,ref:o,node:void 0})}))}resolveUserDataSyncResource({uri:t}){const a=this.J(t),r=a?this.k.profiles.find(c=>c.id===a.profile):void 0;return a&&r?{profile:r,syncResource:a?.syncResource}:void 0}async getAssociatedResources({uri:t}){const a=this.J(t);if(!a)return[];const r=this.k.profiles.find(c=>c.id===a.profile);switch(a.syncResource){case"settings":return this.r(t,r);case"keybindings":return this.t(t,r);case"tasks":return this.v(t,r);case"snippets":return this.x(t,r);case"globalState":return this.C(t,r);case"extensions":return this.z(t,r);case"profiles":return this.F(t,r)}}async getMachineId({uri:t}){const a=this.J(t);if(!!a){if(a.remote){if(a.ref){const{content:r}=await this.L(a.syncResource,a.ref,a.collection);if(r)return this.K(r,a.syncResource)?.machineId}return}return(0,L.getServiceMachineId)(this.h,this.j,this.i)}}async resolveContent(t){const a=this.J(t);if(!a||a.node===Ve.a)return null;if(a.ref){const r=await this.n(a.remote,a.syncResource,a.profile,a.collection,a.ref);return a.node&&r?this.o(a.syncResource,r,a.node):r}return!a.remote&&!a.node?this.q(a.syncResource,a.profile):null}async n(t,a,r,c,o){if(t){const{content:E}=await this.L(a,o,c);return E}const p=this.k.profiles.find(E=>E.id===r);return p?this.f.resolveContent(p,a,o):null}o(t,a,r){const c=this.K(a,t);switch(t){case"settings":return this.s(c,r);case"keybindings":return this.u(c,r);case"tasks":return this.w(c,r);case"snippets":return this.y(c,r);case"globalState":return this.D(c,r);case"extensions":return this.A(c,r);case"profiles":return this.G(c,r)}}async q(t,a){const r=this.k.profiles.find(c=>c.id===a);if(!r)return null;switch(t){case"globalState":return this.E(r);case"extensions":return this.B(r);case"profiles":return this.H(r);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null}}r(t,a){const r=this.d.joinPath(t,"settings.json"),c=a?a.settingsResource:this.d.joinPath(t,Ve.a);return[{resource:r,comparableResource:c}]}s(t,a){switch(a){case"settings.json":return(0,y.parseSettingsSyncContent)(t.content).settings}return null}t(t,a){const r=this.d.joinPath(t,"keybindings.json"),c=a?a.keybindingsResource:this.d.joinPath(t,Ve.a);return[{resource:r,comparableResource:c}]}u(t,a){switch(a){case"keybindings.json":return(0,d.getKeybindingsContentFromSyncContent)(t.content,!!this.l.getValue(S.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM),this.g)}return null}v(t,a){const r=this.d.joinPath(t,"tasks.json"),c=a?a.tasksResource:this.d.joinPath(t,Ve.a);return[{resource:r,comparableResource:c}]}w(t,a){switch(a){case"tasks.json":return(0,v.getTasksContentFromSyncContent)(t.content,this.g)}return null}async x(t,a){const r=await this.resolveContent(t);if(r){const c=this.K(r,"snippets");if(c){const o=(0,w.parseSnippets)(c),p=[];for(const E of Object.keys(o)){const k=this.d.joinPath(t,E),F=a?this.d.joinPath(a.snippetsHome,E):this.d.joinPath(t,Ve.a);p.push({resource:k,comparableResource:F})}return p}}return[]}y(t,a){return(0,w.parseSnippets)(t)[a]||null}z(t,a){const r=this.d.joinPath(t,"extensions.json"),c=a?this.I({remote:!1,syncResource:"extensions",profile:a.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,Ve.a);return[{resource:r,comparableResource:c}]}A(t,a){switch(a){case"extensions.json":return(0,l.stringify)((0,l.parseExtensions)(t),!0)}return null}async B(t){const{localExtensions:a}=await this.m.createInstance(l.LocalExtensionsProvider).getLocalExtensions(t);return(0,l.stringify)(a,!0)}C(t,a){const r=this.d.joinPath(t,"globalState.json"),c=a?this.I({remote:!1,syncResource:"globalState",profile:a.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,Ve.a);return[{resource:r,comparableResource:c}]}D(t,a){switch(a){case"globalState.json":return(0,m.stringify)(JSON.parse(t.content),!0)}return null}async E(t){const a=await this.m.createInstance(m.LocalGlobalStateProvider).getLocalGlobalState(t);return(0,m.stringify)(a,!0)}F(t,a){const r=this.d.joinPath(t,"profiles.json"),c=this.I({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,collection:void 0,ref:void 0,node:void 0});return[{resource:r,comparableResource:c}]}G(t,a){switch(a){case"profiles.json":return(0,f.toFormattedString)(JSON.parse(t.content),{})}return null}async H(t){return(0,h.stringifyLocalProfiles)(this.k.profiles.filter(a=>!a.isDefault&&!a.isTransient),!0)}I(t){const a=t.remote?Ve.b:Ve.c,r=[t.syncResource,t.profile];return t.collection&&r.push(`collection:${t.collection}`),t.ref&&r.push(`ref:${t.ref}`),t.node&&r.push(t.node),this.d.joinPath(D.URI.from({scheme:S.USER_DATA_SYNC_SCHEME,authority:a,path:"/"}),...r)}J(t){if(t.scheme!==S.USER_DATA_SYNC_SCHEME||t.authority!==Ve.c&&t.authority!==Ve.b)return;const a=[];for(;t.path!=="/";)a.unshift(this.d.basename(t)),t=this.d.dirname(t);if(a.length<2)return;const r=t.authority===Ve.b,c=a.shift(),o=a.shift();let p,E,k;for(;a.length;){const F=a.shift();F.startsWith("collection:")?p=F.substring(11):F.startsWith("ref:")?E=F.substring(4):k=F}return{remote:r,syncResource:c,profile:o,collection:p,ref:E,node:k}}K(t,a){try{const r=JSON.parse(t);if((0,b.isSyncData)(r))return r}catch(r){this.g.error(r)}throw new S.UserDataSyncError((0,i.localize)(0,null),"IncompatibleRemoteContent",a)}async L(t,a,r){const c=await this.e.resolveResourceContent(t,a,r);return{ref:a,content:c}}};n.a="not-existing-resource",n.b="remote-backup",n.c="local-backup",n=ye([K(0,S.IUserDataSyncStoreService),K(1,S.IUserDataSyncBackupStoreService),K(2,S.IUserDataSyncLogService),K(3,I.IUriIdentityService),K(4,R.IEnvironmentService),K(5,P.IStorageService),K(6,A.IFileService),K(7,C.IUserDataProfilesService),K(8,g.IConfigurationService),K(9,u.IInstantiationService)],n),e.UserDataSyncResourceProviderService=n}),define(re[274],ae([0,1,20,6,23,38,3,2,21,15,31,16,29,4,19,22,18,117,118,119,120,121,122,123,26]),function(_,e,D,i,R,A,L,P,I,S,C,b,w,y,d,g,v,l,m,u,h,f,n,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const a="sync.lastSyncTime";let r=class extends P.Disposable{get status(){return this.c}get conflicts(){return this.h}get lastSyncTime(){return this.l}constructor(k,F,N,q,j,O,U,$,G){super(),this.u=k,this.v=F,this.w=N,this.y=q,this.z=j,this.C=O,this.D=U,this.F=$,this.G=G,this.c="uninitialized",this.f=this.B(new L.Emitter),this.onDidChangeStatus=this.f.event,this.g=this.B(new L.Emitter),this.onDidChangeLocal=this.g.event,this.h=[],this.i=this.B(new L.Emitter),this.onDidChangeConflicts=this.i.event,this.j=[],this.k=this.B(new L.Emitter),this.onSyncErrors=this.k.event,this.l=void 0,this.m=this.B(new L.Emitter),this.onDidChangeLastSyncTime=this.m.event,this.n=this.B(new L.Emitter),this.onDidResetLocal=this.n.event,this.r=this.B(new L.Emitter),this.onDidResetRemote=this.r.event,this.t=new Map,this.c=F.userDataSyncStore?"idle":"uninitialized",this.l=this.C.getNumber(a,-1,void 0),this.B((0,P.toDisposable)(()=>this.U()))}async createSyncTask(k,F){this.W(),this.y.info("Sync started.");const N=new Date().getTime(),q=(0,C.generateUuid)();try{const $=(0,t.createSyncHeaders)(q);F&&($["Cache-Control"]="no-cache"),k=await this.u.manifest(k,$)}catch($){const G=t.UserDataSyncError.toUserDataSyncError($);throw p(G,q,this.v,this.z),G}const j=!1,O=this;let U;return{manifest:k,async run(){if(j)throw new Error("Can run a task only once");U=(0,i.createCancelablePromise)($=>O.H(k,!1,q,$)),await U.finally(()=>U=void 0),O.y.info(`Sync done. Took ${new Date().getTime()-N}ms`),O.R()},stop(){return U?.cancel(),O.M()}}}async createManualSyncTask(){if(this.W(),this.D.isEnabled())throw new t.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");this.y.info("Sync started.");const k=new Date().getTime(),F=(0,C.generateUuid)(),N=(0,t.createSyncHeaders)(F);let q;try{q=await this.u.manifest(null,N)}catch(U){const $=t.UserDataSyncError.toUserDataSyncError(U);throw p($,F,this.v,this.z),$}await this.resetLocal();const j=this,O=new R.CancellationTokenSource;return{id:F,async merge(){return j.H(q,!0,F,O.token)},async apply(){await j.J(q,F,O.token),j.y.info(`Sync done. Took ${new Date().getTime()-k}ms`),j.R()},async stop(){O.cancel(),await j.M(),await j.resetLocal()}}}async H(k,F,N,q){this.j=[];try{this.status!=="hasConflicts"&&this.P("syncing");const j=this.getOrCreateActiveProfileSynchronizer(this.F.defaultProfile,void 0);this.j.push(...await this.L(j,k,F,N,q));const O=j.enabled.find(U=>U.resource==="profiles");if(O){const U=await O.getLastSyncedProfiles()||[];if(q.isCancellationRequested)return;await this.I(U,k,F,N,q)}}finally{this.k.fire(this.j)}}async I(k,F,N,q,j){for(const O of k){if(j.isCancellationRequested)return;const U=this.F.profiles.find(G=>G.id===O.id);if(!U){this.y.error(`Profile with id:${O.id} and name: ${O.name} does not exist locally to sync.`);continue}this.y.info("Syncing profile.",O.name);const $=this.getOrCreateActiveProfileSynchronizer(U,O);this.j.push(...await this.L($,F,N,q,j))}for(const[O,U]of this.t.entries())this.F.profiles.some($=>$.id===U[0].profile.id)||(U[1].dispose(),this.t.delete(O))}async J(k,F,N){const q=this.S();for(const G of q){if(N.isCancellationRequested)return;await G.apply(F,N)}const j=q.find(G=>G.profile.isDefault);if(!j)return;const O=j.enabled.find(G=>G.resource==="profiles");if(!O)return;const $=(await O.getRemoteSyncedProfiles(k?.latest??null)||[]).filter(G=>q.every(H=>H.profile.id!==G.id));$.length&&await this.I($,k,!1,F,N)}async L(k,F,N,q,j){return(await k.sync(F,N,q,j)).map(([U,$])=>({profile:k.profile,syncResource:U,error:$}))}async M(){this.status!=="idle"&&await Promise.allSettled(this.S().map(k=>k.stop()))}async resolveContent(k){const F=await this.G.resolveContent(k);if(F)return F;for(const N of this.S())for(const q of N.enabled){const j=await q.resolveContent(k);if(j)return j}return null}async replace(k){this.W();const F=this.G.resolveUserDataSyncResource(k);if(!F)return;const N=await this.resolveContent(k.uri);!N||await this.N(F.profile,async q=>{if(F.syncResource===q.resource)return await q.replace(N),!0})}async accept(k,F,N,q){this.W(),await this.N(k.profile,async j=>{if(k.syncResource===j.resource)return await j.accept(F,N),q&&await j.apply((0,S.isBoolean)(q)?!1:q.force,(0,t.createSyncHeaders)((0,C.generateUuid)())),!0})}getRemoteProfiles(){return this.G.getRemoteSyncedProfiles()}getRemoteSyncResourceHandles(k,F){return this.G.getRemoteSyncResourceHandles(k,F)}async getLocalSyncResourceHandles(k,F){return this.G.getLocalSyncResourceHandles(k,F??this.F.defaultProfile)}async getAssociatedResources(k){return this.G.getAssociatedResources(k)}async getMachineId(k){return this.G.getMachineId(k)}async hasLocalData(){return!!await this.N(this.F.defaultProfile,async F=>{if(F.resource!=="globalState"&&await F.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.N(this.F.defaultProfile,async F=>{if(await F.hasPreviouslySynced())return!0})}async reset(){this.W(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.W();try{await this.u.clear(),this.y.info("Cleared data on server")}catch(k){this.y.error(k)}this.r.fire()}async resetLocal(){this.W(),this.l=void 0,this.C.remove(a,-1);for(const[k]of this.t.values())try{await k.resetLocal()}catch(F){this.y.error(F)}this.U(),this.n.fire(),this.y.info("Did reset the local sync state.")}async N(k,F){const N=new P.DisposableStore;try{const q=this.t.get(k.id);if(q){const G=await this.O(q[0],F,N);return(0,S.isUndefined)(G)?null:G}if(k.isDefault){const G=N.add(this.w.createInstance(c,k,void 0)),H=await this.O(G,F,N);return(0,S.isUndefined)(H)?null:H}if(this.F.isEnabled())return null;const j=N.add(this.w.createInstance(s.UserDataProfilesManifestSynchroniser,k,void 0)),O=await this.u.manifest(null),$=(await j.getRemoteSyncedProfiles(O?.latest??null)||[]).find(G=>G.id===k.id);if($){const G=N.add(this.w.createInstance(c,k,$.collection)),H=await this.O(G,F,N);return(0,S.isUndefined)(H)?null:H}return null}finally{N.dispose()}}async O(k,F,N){const q=[...k.enabled,...k.disabled.map(j=>N.add(k.createSynchronizer(j)))];for(const j of q){const O=await F(j);if(!(0,S.isUndefined)(O))return O}}P(k){const F=this.c;this.c!==k&&(this.c=k,this.f.fire(k),F==="hasConflicts"&&this.R())}Q(){const k=this.S().map(F=>F.conflicts).flat();(0,D.equals)(this.h,k,(F,N)=>F.profile.id===N.profile.id&&F.syncResource===N.syncResource&&(0,D.equals)(F.conflicts,N.conflicts,(q,j)=>(0,I.isEqual)(q.previewResource,j.previewResource)))||(this.h=k,this.i.fire(k))}R(){this.status==="idle"&&(this.l=new Date().getTime(),this.C.store(a,this.l,-1,1),this.m.fire(this.l))}getOrCreateActiveProfileSynchronizer(k,F){let N=this.t.get(k.id);if(N&&N[0].collection!==F?.collection&&(this.y.error("Profile synchronizer collection does not match with the remote sync profile collection"),N[1].dispose(),N=void 0,this.t.delete(k.id)),!N){const q=new P.DisposableStore,j=q.add(this.w.createInstance(c,k,F?.collection));q.add(j.onDidChangeStatus(O=>this.P(O))),q.add(j.onDidChangeConflicts(O=>this.Q())),q.add(j.onDidChangeLocal(O=>this.g.fire(O))),this.t.set(k.id,N=[j,q])}return N[0]}S(){const k=[];for(const[F]of this.t.values())k.push(F);return k}U(){this.t.forEach(([,k])=>k.dispose()),this.t.clear()}W(){if(!this.v.userDataSyncStore)throw new Error("Not enabled")}};r=ye([K(0,t.IUserDataSyncStoreService),K(1,t.IUserDataSyncStoreManagementService),K(2,y.IInstantiationService),K(3,t.IUserDataSyncLogService),K(4,g.ITelemetryService),K(5,d.IStorageService),K(6,t.IUserDataSyncEnablementService),K(7,v.IUserDataProfilesService),K(8,t.IUserDataSyncResourceProviderService)],r),e.UserDataSyncService=r;let c=class extends P.Disposable{get enabled(){return this.c.sort((k,F)=>k[1]-F[1]).map(([k])=>k)}get disabled(){return t.ALL_SYNC_RESOURCES.filter(k=>!this.k.isResourceEnabled(k))}get status(){return this.f}get conflicts(){return this.i}constructor(k,F,N,q,j,O,U,$,G,H){super(),this.profile=k,this.collection=F,this.k=N,this.l=q,this.m=j,this.n=O,this.r=U,this.t=$,this.u=G,this.v=H,this.c=[],this.f="idle",this.g=this.B(new L.Emitter),this.onDidChangeStatus=this.g.event,this.h=this.B(new L.Emitter),this.onDidChangeLocal=this.h.event,this.i=[],this.j=this.B(new L.Emitter),this.onDidChangeConflicts=this.j.event,this.B(N.onDidChangeResourceEnablement(([Z,z])=>this.w(Z,z))),this.B((0,P.toDisposable)(()=>this.c.splice(0,this.c.length).forEach(([,,Z])=>Z.dispose())));for(const Z of t.ALL_SYNC_RESOURCES)N.isResourceEnabled(Z)&&this.y(Z)}w(k,F){F?this.y(k):this.z(k)}y(k){if(this.c.some(([j])=>j.resource===k))return;if(k==="extensions"&&!this.m.isEnabled()){this.t.info("Skipping extensions sync because gallery is not configured");return}if(k==="profiles"&&(!this.profile.isDefault||!this.u.isEnabled()))return;const F=new P.DisposableStore,N=F.add(this.createSynchronizer(k));F.add(N.onDidChangeStatus(()=>this.F())),F.add(N.onDidChangeConflicts(()=>this.G())),F.add(N.onDidChangeLocal(()=>this.h.fire(k)));const q=this.H(k);this.c.push([N,q,F])}z(k){const F=this.c.findIndex(([N])=>N.resource===k);if(F!==-1){const[[N,,q]]=this.c.splice(F,1);q.dispose(),this.F(),Promise.allSettled([N.stop(),N.resetLocal()]).then(null,j=>this.t.error(j))}}createSynchronizer(k){switch(k){case"settings":return this.l.createInstance(h.SettingsSynchroniser,this.profile,this.collection);case"keybindings":return this.l.createInstance(u.KeybindingsSynchroniser,this.profile,this.collection);case"snippets":return this.l.createInstance(f.SnippetsSynchroniser,this.profile,this.collection);case"tasks":return this.l.createInstance(n.TasksSynchroniser,this.profile,this.collection);case"globalState":return this.l.createInstance(m.GlobalStateSynchroniser,this.profile,this.collection);case"extensions":return this.l.createInstance(l.ExtensionsSynchroniser,this.profile,this.collection);case"profiles":return this.l.createInstance(s.UserDataProfilesManifestSynchroniser,this.profile,this.collection)}}async sync(k,F,N,q){if(q.isCancellationRequested)return[];const j=this.enabled;if(!j.length)return[];try{const O=[],U=(0,t.createSyncHeaders)(N),$=(this.collection?k?.collections?.[this.collection]?.latest:k?.latest)??null,G=F?await this.C($):{};for(const H of j){if(q.isCancellationRequested)return[];if(!this.k.isResourceEnabled(H.resource))return[];try{if(F){const Z=await H.preview($,G,U);if(Z)for(const z of Z.resourcePreviews)(z.localChange!==0||z.remoteChange!==0)&&z.mergeState==="preview"&&await H.merge(z.previewResource)}else await H.sync($,U)}catch(Z){const z=t.UserDataSyncError.toUserDataSyncError(Z);if(p(z,N,this.n,this.r),o(Z))throw z;this.t.error(Z),this.t.error(`${H.resource}: ${(0,A.toErrorMessage)(Z)}`),O.push([H.resource,z])}}return O}finally{this.F()}}async apply(k,F){const N=(0,t.createSyncHeaders)(k);for(const q of this.enabled){if(F.isCancellationRequested)return;try{await q.apply(!1,N)}catch(j){const O=t.UserDataSyncError.toUserDataSyncError(j);if(p(O,k,this.n,this.r),o(j))throw O;this.t.error(j),this.t.error(`${q.resource}: ${(0,A.toErrorMessage)(j)}`)}}}async stop(){for(const k of this.enabled)try{k.status!=="idle"&&await k.stop()}catch(F){this.t.error(F)}}async resetLocal(){for(const k of this.enabled)try{await k.resetLocal()}catch(F){this.t.error(`${k.resource}: ${(0,A.toErrorMessage)(F)}`),this.t.error(F)}}async C(k){if(!this.profile.isDefault)return{};const F=this.v.getValue(t.USER_DATA_SYNC_CONFIGURATION_SCOPE),N=this.enabled.find(q=>q instanceof h.SettingsSynchroniser);if(N){const q=await N.getRemoteUserDataSyncConfiguration(k);return{...F,...q}}return F}D(k){this.f!==k&&(this.f=k,this.g.fire(k))}F(){return this.G(),this.enabled.some(k=>k.status==="hasConflicts")?this.D("hasConflicts"):this.enabled.some(k=>k.status==="syncing")?this.D("syncing"):this.D("idle")}G(){const k=this.enabled.filter(F=>F.status==="hasConflicts").filter(F=>F.conflicts.conflicts.length>0).map(F=>F.conflicts);(0,D.equals)(this.i,k,(F,N)=>F.syncResource===N.syncResource&&(0,D.equals)(F.conflicts,N.conflicts,(q,j)=>(0,I.isEqual)(q.previewResource,j.previewResource)))||(this.i=k,this.j.fire(k))}H(k){switch(k){case"profiles":return 0;case"settings":return 1;case"keybindings":return 2;case"snippets":return 3;case"tasks":return 4;case"globalState":return 5;case"extensions":return 6}}};c=ye([K(2,t.IUserDataSyncEnablementService),K(3,y.IInstantiationService),K(4,w.IExtensionGalleryService),K(5,t.IUserDataSyncStoreManagementService),K(6,g.ITelemetryService),K(7,t.IUserDataSyncLogService),K(8,v.IUserDataProfilesService),K(9,b.IConfigurationService)],c);function o(E){if(E instanceof t.UserDataSyncError)switch(E.code){case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function p(E,k,F,N){N.publicLog2("sync/error",{code:E.code,serverCode:E instanceof t.UserDataSyncStoreError?String(E.serverCode):void 0,url:E instanceof t.UserDataSyncStoreError?E.url:void 0,resource:E.resource,executionId:k,service:F.userDataSyncStore.url.toString()})}}),define(re[275],ae([0,1,3,2,7,18,26]),function(_,e,D,i,R,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;function P(w,y){return{...w,profile:(0,A.reviveProfile)(w.profile,y.profilesHome.scheme)}}function I(w){return{created:w.created,uri:R.URI.revive(w.uri)}}class S{constructor(y,d,g){this.c=y,this.d=d,this.f=g,this.a=new Map,this.b=new D.Emitter}listen(y,d){switch(d){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${d}`)}async call(y,d,g){try{return await this.g(y,d,g)}catch(v){throw this.f.error(v),v}}async g(y,d,g){switch(d){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(R.URI.revive(g[0]));case"accept":return this.c.accept(P(g[0],this.d),R.URI.revive(g[1]),g[2],g[3]);case"getRemoteProfiles":return this.c.getRemoteProfiles();case"getLocalSyncResourceHandles":return this.c.getLocalSyncResourceHandles(g[0],(0,A.reviveProfile)(g[1],this.d.profilesHome.scheme));case"getRemoteSyncResourceHandles":return this.c.getRemoteSyncResourceHandles(g[0],g[1]);case"replace":return this.c.replace(I(g[0]));case"getAssociatedResources":return this.c.getAssociatedResources(I(g[0]));case"getMachineId":return this.c.getMachineId(I(g[0]));case"createManualSyncTask":return this.i()}if(d.startsWith("manualSync/")){const v=d.substring(11),l=g[0],m=this.h(l);switch(g=g.slice(1),v){case"merge":return m.merge();case"apply":return m.apply().finally(()=>this.a.delete(this.j(m.id)));case"stop":return m.stop().finally(()=>this.a.delete(this.j(m.id)))}}throw new Error("Invalid call")}h(y){const d=this.a.get(this.j(y));if(!d)throw new Error(`Manual sync taks not found: ${y}`);return d}async i(){const y=await this.c.createManualSyncTask();return this.a.set(this.j(y.id),y),y.id}j(y){return`manualSyncTask-${y}`}}e.UserDataSyncChannel=S;let C=class extends i.Disposable{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(y,d){super(),this.k=d,this.b="uninitialized",this.c=this.B(new D.Emitter),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new D.Emitter),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.i=this.B(new D.Emitter),this.onDidChangeLastSyncTime=this.i.event,this.j=this.B(new D.Emitter),this.onSyncErrors=this.j.event,this.a={call(g,v,l){return y.call(g,v,l).then(null,m=>{throw L.UserDataSyncError.toUserDataSyncError(m)})},listen(g,v){return y.listen(g,v)}},this.a.call("_getInitialData").then(([g,v,l])=>{this.l(g),this.m(v),l&&this.n(l),this.B(this.a.listen("onDidChangeStatus")(m=>this.l(m))),this.B(this.a.listen("onDidChangeLastSyncTime")(m=>this.n(m)))}),this.B(this.a.listen("onDidChangeConflicts")(g=>this.m(g))),this.B(this.a.listen("onSyncErrors")(g=>this.j.fire(g.map(v=>({...v,error:L.UserDataSyncError.toUserDataSyncError(v.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const y=await this.a.call("createManualSyncTask"),d=this;return new b(y,{async call(v,l,m){return d.a.call(`manualSync/${v}`,[y,...Array.isArray(l)?l:[l]],m)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(y,d,g,v){return this.a.call("accept",[y,d,g,v])}resolveContent(y){return this.a.call("resolveContent",[y])}getRemoteProfiles(){return this.a.call("getRemoteProfiles")}async getLocalSyncResourceHandles(y,d){return(await this.a.call("getLocalSyncResourceHandles",[y,d])).map(({created:v,uri:l})=>({created:v,uri:R.URI.revive(l)}))}async getRemoteSyncResourceHandles(y,d){return(await this.a.call("getRemoteSyncResourceHandles",[y,d])).map(({created:v,uri:l})=>({created:v,uri:R.URI.revive(l)}))}async getAssociatedResources(y){return(await this.a.call("getAssociatedResources",[y])).map(({resource:g,comparableResource:v})=>({resource:R.URI.revive(g),comparableResource:R.URI.revive(v)}))}getMachineId(y){return this.a.call("getMachineId",[y])}replace(y){return this.a.call("replace",[y])}async l(y){this.b=y,this.c.fire(y)}async m(y){this.f=y.map(d=>({syncResource:d.syncResource,profile:(0,A.reviveProfile)(d.profile,this.k.profilesHome.scheme),conflicts:d.conflicts.map(g=>({...g,baseResource:R.URI.revive(g.baseResource),localResource:R.URI.revive(g.localResource),remoteResource:R.URI.revive(g.remoteResource),previewResource:R.URI.revive(g.previewResource)}))})),this.g.fire(this.f)}n(y){this.h!==y&&(this.h=y,this.i.fire(y))}};C=ye([K(1,A.IUserDataProfilesService)],C),e.UserDataSyncChannelClient=C;class b extends i.Disposable{constructor(y,d){super(),this.id=y,this.a=d}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose")}}}),define(re[276],ae([0,1,6,23,9,3,2,138,5,21,15,7,31,16,14,13,25,59,45,19,26]),function(_,e,D,i,R,A,L,P,I,S,C,b,w,y,d,g,v,l,m,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const f="sync.previous.store",n="sync.donot-make-requests-until",s="sync.user-session-id",t="sync.machine-session-id",a=100,r=1e3*60*5;let c=class extends L.Disposable{get userDataSyncStore(){return this.b}get c(){return this.h.get(h.SYNC_SERVICE_URL_TYPE,-1)}set c(N){this.h.store(h.SYNC_SERVICE_URL_TYPE,N,-1,I.isWeb?0:1)}constructor(N,q,j){super(),this.f=N,this.g=q,this.h=j,this.a=this.B(new A.Emitter),this.onDidChangeUserDataSyncStore=this.a.event,this.i(),this.B(A.Event.filter(j.onDidChangeValue,O=>O.key===h.SYNC_SERVICE_URL_TYPE&&O.scope===-1&&this.c!==this.userDataSyncStore?.type)(()=>this.i()))}i(){this.b=this.j(this.f[h.CONFIGURATION_SYNC_STORE_KEY],this.g.getValue(h.CONFIGURATION_SYNC_STORE_KEY)),this.a.fire()}j(N,q){N=I.isWeb&&N?.web?{...N,...N.web}:N;const j={...N||{},...q||{}};if(j&&(0,C.isString)(j.url)&&(0,C.isObject)(j.authenticationProviders)&&Object.keys(j.authenticationProviders).every(O=>Array.isArray(j.authenticationProviders[O].scopes))){const O=j,U=!!O.canSwitch&&!q?.url,$=O.url===O.insidersUrl?"insiders":"stable",G=(U?this.c:void 0)||$,H=q?.url||(G==="insiders"?O.insidersUrl:G==="stable"?O.stableUrl:O.url);return{url:b.URI.parse(H),type:G,defaultType:$,defaultUrl:b.URI.parse(O.url),stableUrl:b.URI.parse(O.stableUrl),insidersUrl:b.URI.parse(O.insidersUrl),canSwitch:U,authenticationProviders:Object.keys(O.authenticationProviders).reduce((Z,z)=>(Z.push({id:z,scopes:O.authenticationProviders[z].scopes}),Z),[])}}}};c=ye([K(0,v.IProductService),K(1,y.IConfigurationService),K(2,u.IStorageService)],c),e.AbstractUserDataSyncStoreManagementService=c;let o=class extends c{constructor(N,q,j){super(N,q,j);const O=this.h.get(f,-1);O&&(this.k=JSON.parse(O));const U=this.f[h.CONFIGURATION_SYNC_STORE_KEY];U?this.h.store(f,JSON.stringify(U),-1,1):this.h.remove(f,-1)}async switch(N){N!==this.c&&(this.c=N,this.i())}async getPreviousUserDataSyncStore(){return this.j(this.k)}};o=ye([K(0,v.IProductService),K(1,y.IConfigurationService),K(2,u.IStorageService)],o),e.UserDataSyncStoreManagementService=o;let p=class extends L.Disposable{get donotMakeRequestsUntil(){return this.i}constructor(N,q,j,O,U,$,G){super(),this.k=j,this.l=O,this.n=G,this.g=this.B(new A.Emitter),this.onTokenFailed=this.g.event,this.h=this.B(new A.Emitter),this.onTokenSucceed=this.h.event,this.i=void 0,this.j=this.B(new A.Emitter),this.onDidChangeDonotMakeRequestsUntil=this.j.event,this.s=void 0,this.p(N),this.c=(0,m.getServiceMachineId)(U,$,G).then(H=>{const Z={"X-Client-Name":`${q.applicationName}${I.isWeb?"-web":""}`,"X-Client-Version":q.version};return q.commit&&(Z["X-Client-Commit"]=q.commit),Z}),this.f=new k(a,r,this.k,this.l),this.r(),this.B((0,L.toDisposable)(()=>{this.s&&(this.s.cancel(),this.s=void 0)}))}setAuthToken(N,q){this.b={token:N,type:q}}p(N){this.a=N?(0,S.joinPath)(N,"v1"):void 0}r(){const N=this.n.getNumber(n,-1);N&&Date.now()<N&&this.t(new Date(N))}t(N){this.i?.getTime()!==N?.getTime()&&(this.i=N,this.s&&(this.s.cancel(),this.s=void 0),this.i?(this.n.store(n,this.i.getTime(),-1,1),this.s=(0,D.createCancelablePromise)(q=>(0,D.timeout)(this.i.getTime()-Date.now(),q).then(()=>this.t(void 0))),this.s.then(null,q=>null)):this.n.remove(n,-1),this.j.fire())}async getAllCollections(N={}){if(!this.a)throw new Error("No settings sync store url configured.");const q=(0,S.joinPath)(this.a,"collection").toString();N={...N},N["Content-Type"]="application/json";const j=await this.w(q,{type:"GET",headers:N},[],i.CancellationToken.None);return await(0,l.asJson)(j)||[]}async createCollection(N={}){if(!this.a)throw new Error("No settings sync store url configured.");const q=(0,S.joinPath)(this.a,"collection").toString();N={...N},N["Content-Type"]=P.Mimes.text;const j=await this.w(q,{type:"POST",headers:N},[],i.CancellationToken.None),O=await(0,l.asTextOrError)(j);if(!O)throw new h.UserDataSyncStoreError("Server did not return the collection id",q,"NoCollection",j.res.statusCode,j.res.headers[h.HEADER_OPERATION_ID]);return O}async deleteCollection(N,q={}){if(!this.a)throw new Error("No settings sync store url configured.");const j=N?(0,S.joinPath)(this.a,"collection",N).toString():(0,S.joinPath)(this.a,"collection").toString();q={...q},await this.w(j,{type:"DELETE",headers:q},[],i.CancellationToken.None)}async getAllResourceRefs(N,q){if(!this.a)throw new Error("No settings sync store url configured.");const j=this.u(this.a,q,N),O={},U=await this.w(j.toString(),{type:"GET",headers:O},[],i.CancellationToken.None);return(await(0,l.asJson)(U)||[]).map(({url:G,created:H})=>({ref:(0,S.relativePath)(j,j.with({path:G})),created:H*1e3}))}async resolveResourceContent(N,q,j,O={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=(0,S.joinPath)(this.u(this.a,j,N),q).toString();O={...O},O["Cache-Control"]="no-cache";const $=await this.w(U,{type:"GET",headers:O},[],i.CancellationToken.None);return await(0,l.asTextOrError)($)}async deleteResource(N,q,j){if(!this.a)throw new Error("No settings sync store url configured.");const O=q!==null?(0,S.joinPath)(this.u(this.a,j,N),q).toString():this.u(this.a,j,N).toString(),U={};await this.w(O,{type:"DELETE",headers:U},[],i.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const N=(0,S.joinPath)(this.a,"resource").toString(),q={"Content-Type":P.Mimes.text};await this.w(N,{type:"DELETE",headers:q},[],i.CancellationToken.None)}async readResource(N,q,j,O={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=(0,S.joinPath)(this.u(this.a,j,N),"latest").toString();O={...O},O["Cache-Control"]="no-cache",q&&(O["If-None-Match"]=q.ref);const $=await this.w(U,{type:"GET",headers:O},[304],i.CancellationToken.None);let G=null;if($.res.statusCode===304&&(G=q),G===null){const H=$.res.headers.etag;if(!H)throw new h.UserDataSyncStoreError("Server did not return the ref",U,"NoRef",$.res.statusCode,$.res.headers[h.HEADER_OPERATION_ID]);const Z=await(0,l.asTextOrError)($);if(!Z&&$.res.statusCode===304)throw new h.UserDataSyncStoreError("Empty response",U,"EmptyResponse",$.res.statusCode,$.res.headers[h.HEADER_OPERATION_ID]);G={ref:H,content:Z}}return G}async writeResource(N,q,j,O,U={}){if(!this.a)throw new Error("No settings sync store url configured.");const $=this.u(this.a,O,N).toString();U={...U},U["Content-Type"]=P.Mimes.text,j&&(U["If-Match"]=j);const G=await this.w($,{type:"POST",data:q,headers:U},[],i.CancellationToken.None),H=G.res.headers.etag;if(!H)throw new h.UserDataSyncStoreError("Server did not return the ref",$,"NoRef",G.res.statusCode,G.res.headers[h.HEADER_OPERATION_ID]);return H}async manifest(N,q={}){if(!this.a)throw new Error("No settings sync store url configured.");const j=(0,S.joinPath)(this.a,"manifest").toString();q={...q},q["Content-Type"]="application/json",N&&(q["If-None-Match"]=N.ref);const O=await this.w(j,{type:"GET",headers:q},[304],i.CancellationToken.None);let U=null;if(O.res.statusCode===304&&(U=N),!U){const G=O.res.headers.etag;if(!G)throw new h.UserDataSyncStoreError("Server did not return the ref",j,"NoRef",O.res.statusCode,O.res.headers[h.HEADER_OPERATION_ID]);const H=await(0,l.asTextOrError)(O);if(!H&&O.res.statusCode===304)throw new h.UserDataSyncStoreError("Empty response",j,"EmptyResponse",O.res.statusCode,O.res.headers[h.HEADER_OPERATION_ID]);H&&(U={...JSON.parse(H),ref:G})}const $=this.n.get(s,-1);return $&&U&&$!==U.session&&this.v(),U===null&&$&&this.v(),U&&this.n.store(s,U.session,-1,1),U}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteResources(),await this.deleteCollection(),this.v()}u(N,q,j){return q?(0,S.joinPath)(N,"collection",q,"resource",j):(0,S.joinPath)(N,"resource",j)}v(){this.n.remove(s,-1),this.n.remove(t,-1)}async w(N,q,j,O){if(!this.b)throw new h.UserDataSyncStoreError("No Auth Token Available",N,"Unauthorized",void 0,void 0);if(this.i&&Date.now()<this.i.getTime())throw new h.UserDataSyncStoreError(`${q.type} request '${N}' failed because of too many requests (429).`,N,"TooManyRequestsAndRetryAfter",void 0,void 0);this.t(void 0);const U=await this.c;q.headers={...q.headers||{},...U,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.y(q.headers),this.l.trace("Sending request to server",{url:N,type:q.type,headers:{...q.headers,authorization:void 0}});let $;try{$=await this.f.request(N,q,O)}catch(z){if(!(z instanceof h.UserDataSyncStoreError)){let B="RequestFailed";const Y=(0,R.getErrorMessage)(z).toLowerCase();Y.includes("xhr timeout")?B="RequestTimeout":Y.includes("protocol")&&Y.includes("not supported")?B="RequestProtocolNotSupported":Y.includes("request path contains unescaped characters")?B="RequestPathNotEscaped":Y.includes("headers must be an object")?B="RequestHeadersNotObject":(0,R.isCancellationError)(z)&&(B="RequestCanceled"),z=new h.UserDataSyncStoreError(`Connection refused for the request '${N}'.`,N,B,void 0,void 0)}throw this.l.info("Request failed",N),z}const G=$.res.headers[h.HEADER_OPERATION_ID],H={url:N,status:$.res.statusCode,"execution-id":q.headers[h.HEADER_EXECUTION_ID],"operation-id":G},Z=(0,l.isSuccess)($)||$.res.statusCode&&j.indexOf($.res.statusCode)!==-1;if(Z?this.l.trace("Request succeeded",H):this.l.info("Request failed",H),$.res.statusCode===401)throw this.b=void 0,this.g.fire(),new h.UserDataSyncStoreError(`Request '${N}' failed because of Unauthorized (401).`,N,"Unauthorized",$.res.statusCode,G);if(this.h.fire(),$.res.statusCode===404)throw new h.UserDataSyncStoreError(`${q.type} request '${N}' failed because the requested resource is not found (404).`,N,"NotFound",$.res.statusCode,G);if($.res.statusCode===409)throw new h.UserDataSyncStoreError(`${q.type} request '${N}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,N,"Conflict",$.res.statusCode,G);if($.res.statusCode===410)throw new h.UserDataSyncStoreError(`${q.type} request '${N}' failed because the requested resource is not longer available (410).`,N,"Gone",$.res.statusCode,G);if($.res.statusCode===412)throw new h.UserDataSyncStoreError(`${q.type} request '${N}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,N,"PreconditionFailed",$.res.statusCode,G);if($.res.statusCode===413)throw new h.UserDataSyncStoreError(`${q.type} request '${N}' failed because of too large payload (413).`,N,"TooLarge",$.res.statusCode,G);if($.res.statusCode===426)throw new h.UserDataSyncStoreError(`${q.type} request '${N}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,N,"UpgradeRequired",$.res.statusCode,G);if($.res.statusCode===429){const z=$.res.headers["retry-after"];throw z?(this.t(new Date(Date.now()+parseInt(z)*1e3)),new h.UserDataSyncStoreError(`${q.type} request '${N}' failed because of too many requests (429).`,N,"TooManyRequestsAndRetryAfter",$.res.statusCode,G)):new h.UserDataSyncStoreError(`${q.type} request '${N}' failed because of too many requests (429).`,N,"RemoteTooManyRequests",$.res.statusCode,G)}if(!Z)throw new h.UserDataSyncStoreError("Server returned "+$.res.statusCode,N,"Unknown",$.res.statusCode,G);return $}y(N){let q=this.n.get(t,-1);q===void 0&&(q=(0,w.generateUuid)(),this.n.store(t,q,-1,1)),N["X-Machine-Session-Id"]=q;const j=this.n.get(s,-1);j!==void 0&&(N["X-User-Session-Id"]=j)}};p=ye([K(1,v.IProductService),K(2,l.IRequestService),K(3,h.IUserDataSyncLogService),K(4,d.IEnvironmentService),K(5,g.IFileService),K(6,u.IStorageService)],p),e.UserDataSyncStoreClient=p;let E=class extends p{constructor(N,q,j,O,U,$,G){super(N.userDataSyncStore?.url,q,j,O,U,$,G),this.B(N.onDidChangeUserDataSyncStore(()=>this.p(N.userDataSyncStore?.url)))}};E=ye([K(0,h.IUserDataSyncStoreManagementService),K(1,v.IProductService),K(2,l.IRequestService),K(3,h.IUserDataSyncLogService),K(4,d.IEnvironmentService),K(5,g.IFileService),K(6,u.IStorageService)],E),e.UserDataSyncStoreService=E;class k{constructor(N,q,j,O){this.c=N,this.d=q,this.f=j,this.g=O,this.a=[],this.b=void 0}request(N,q,j){if(this.h()&&this.i(),q.url=N,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new h.UserDataSyncStoreError(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,N,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(N),this.f.request(q,j)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.RequestsSession=k}),define(re[277],ae([0,1,3,57,25,19,22,272,26,78,81]),function(_,e,D,i,R,A,L,P,I,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let b=class extends P.UserDataAutoSyncService{constructor(y,d,g,v,l,m,u,h,f,n,s){super(y,d,g,v,l,u,h,f,n,s),this.B(D.Event.debounce(D.Event.any(D.Event.map(m.onDidFocusWindow,()=>"windowFocus"),D.Event.map(m.onDidOpenWindow,()=>"windowOpen")),(t,a)=>t?[...t,a]:[a],1e3)(t=>this.triggerSync(t,!0,!1)))}};b=ye([K(0,R.IProductService),K(1,I.IUserDataSyncStoreManagementService),K(2,I.IUserDataSyncStoreService),K(3,I.IUserDataSyncEnablementService),K(4,I.IUserDataSyncService),K(5,i.INativeHostService),K(6,I.IUserDataSyncLogService),K(7,S.IUserDataSyncAccountService),K(8,L.ITelemetryService),K(9,C.IUserDataSyncMachinesService),K(10,A.IStorageService)],b),e.UserDataAutoSyncService=b}),define(re[278],ae([0,1,99,24,5,21]),function(_,e,D,i,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function L(S){function C(){let b=S.scheme===i.Schemas.file?(0,A.originalFSPath)(S):S.toString();return R.isLinux||(b=b.toLowerCase()),(0,D.createHash)("md5").update(b).digest("hex")}return{id:C(),configPath:S}}e.getWorkspaceIdentifier=L;function P(S,C){function b(){if(S.scheme!==i.Schemas.file)return(0,D.createHash)("md5").update(S.toString()).digest("hex");if(!C)return;let y;return R.isLinux?y=C.ino:R.isMacintosh?y=C.birthtime.getTime():R.isWindows&&(typeof C.birthtimeMs=="number"?y=Math.floor(C.birthtimeMs):y=C.birthtime.getTime()),(0,D.createHash)("md5").update(S.fsPath).update(y?String(y):"").digest("hex")}const w=b();if(typeof w=="string")return{id:w,uri:S}}e.getSingleFolderWorkspaceIdentifier=P;function I(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=I}),define(re[279],ae([0,1,6,9,2,12,28,14,56,8,57,76,115,278]),function(_,e,D,i,R,A,L,P,I,S,C,b,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let d=class extends R.Disposable{constructor(v,l,m,u){super(),this.a=v,this.b=l,this.c=m,this.f=u,this.B(new D.RunOnceScheduler(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const v=await L.Promises.readdir(this.a.workspaceStorageHome.fsPath),l=new b.StorageClient(this.f.getChannel("storage"));await Promise.all(v.map(async m=>{const u=(0,A.join)(this.a.workspaceStorageHome.fsPath,m);m.length===y.NON_EMPTY_WORKSPACE_ID_LENGTH||m===w.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.c.getWindows()).some(n=>n.workspace?.id===m)||await l.isUsed(u)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${m} as it seems to be an unused empty workspace.`),await L.Promises.rm(u))}))}catch(v){(0,i.onUnexpectedError)(v)}}};d=ye([K(0,P.INativeEnvironmentService),K(1,S.ILogService),K(2,C.INativeHostService),K(3,I.IMainProcessService)],d),e.UnusedWorkspaceStorageDataCleaner=d}),define(re[124],ae([0,1,52,6,12,15,28,150,288,289]),function(_,e,D,i,R,A,L,P,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class C extends Error{constructor(n,s){let t=s.message;switch(n){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t),this.type=n,this.cause=s}}e.ExtractError=C;function b(f){const n=f.externalFileAttributes>>16||33188;return[448,56,7].map(s=>n&s).reduce((s,t)=>s+t,n&61440)}function w(f){if(f instanceof C)return f;let n;return/end of central directory record signature not found/.test(f.message)&&(n="CorruptZip"),new C(n,f)}function y(f,n,s,t,a,r){const c=R.dirname(n),o=R.join(t,c);if(!o.startsWith(t))return Promise.reject(new Error(P.localize(0,null,n)));const p=R.join(t,n);let E;return r.onCancellationRequested(()=>{E?.destroy()}),Promise.resolve(L.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((k,F)=>{if(!r.isCancellationRequested)try{E=(0,D.createWriteStream)(p,{mode:s}),E.once("close",()=>k()),E.once("error",F),f.once("error",F),f.pipe(E)}catch(N){F(N)}}))}function d(f,n,s,t){let a=(0,i.createCancelablePromise)(()=>Promise.resolve()),r=0;return t.onCancellationRequested(()=>{a.cancel(),f.close()}),new Promise((c,o)=>{const p=new i.Sequencer,E=k=>{k.isCancellationRequested||(r++,f.readEntry())};f.once("error",o),f.once("close",()=>a.then(()=>{t.isCancellationRequested||f.entryCount===r?c():o(new C("Incomplete",new Error(P.localize(1,null,r,f.entryCount))))},o)),f.readEntry(),f.on("entry",k=>{if(t.isCancellationRequested)return;if(!s.sourcePathRegex.test(k.fileName)){E(t);return}const F=k.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(F)){const j=R.join(n,F);a=(0,i.createCancelablePromise)(O=>L.Promises.mkdir(j,{recursive:!0}).then(()=>E(O)).then(void 0,o));return}const N=v(f,k),q=b(k);a=(0,i.createCancelablePromise)(j=>p.queue(()=>N.then(O=>y(O,F,q,n,s,j).then(()=>E(j)))).then(null,o))})})}function g(f,n=!1){return new Promise((s,t)=>{(0,I.open)(f,n?{lazyEntries:!0}:void 0,(a,r)=>{a?t(w(a)):s((0,A.assertIsDefined)(r))})})}function v(f,n){return new Promise((s,t)=>{f.openReadStream(n,(a,r)=>{a?t(w(a)):s((0,A.assertIsDefined)(r))})})}function l(f,n){return new Promise((s,t)=>{const a=new S.ZipFile;n.forEach(c=>{c.contents?a.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&a.addFile(c.localPath,c.path)}),a.end();const r=(0,D.createWriteStream)(f);a.outputStream.pipe(r),a.outputStream.once("error",t),r.once("error",t),r.once("finish",()=>s(f))})}e.zip=l;function m(f,n,s={},t){const a=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let r=g(f,!0);return s.overwrite&&(r=r.then(c=>L.Promises.rm(n).then(()=>c))),r.then(c=>d(c,n,{sourcePathRegex:a},t))}e.extract=m;function u(f,n){return g(f).then(s=>new Promise((t,a)=>{s.on("entry",r=>{r.fileName===n&&v(s,r).then(c=>t(c),c=>a(c))}),s.once("close",()=>a(new Error(P.localize(2,null,n))))}))}function h(f,n){return u(f,n).then(s=>new Promise((t,a)=>{const r=[];s.once("error",a),s.on("data",c=>r.push(c)),s.on("end",()=>t(Buffer.concat(r)))}))}e.buffer=h}),define(re[280],ae([0,1,124,160]),function(_,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function R(A){return(0,D.buffer)(A,"extension/package.json").then(L=>{try{return JSON.parse(L.toString("utf8"))}catch{throw new Error((0,i.localize)(0,null))}})}e.getManifest=R}),define(re[125],ae([0,1,6,23,38,9,3,2,37,24,12,5,21,53,15,7,31,28,124,159,96,14,262,29,33,61,79,218,263,280,219,220,42,70,13,4,8,25,22,30,18]),function(_,e,D,i,R,A,L,P,I,S,C,b,w,y,d,g,v,l,m,u,h,f,n,s,t,a,r,c,o,p,E,k,F,N,q,j,O,U,$,G,H){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,j.refineServiceDecorator)(s.IExtensionManagementService);let Z=class extends n.AbstractExtensionManagementService{constructor(T,M,V,W,X,se,x,ie,ne,le,ue,pe){super(T,M,V,le,pe),this.Y=X,this.Z=se,this.ab=x,this.bb=ne,this.cb=ue,this.X=new Map,this.kb=new I.ResourceSet;const Se=this.B(ie.createInstance(o.ExtensionsLifecycle));this.S=this.B(ie.createInstance(z,Ee=>Se.postUninstall(Ee))),this.U=this.B(new E.ExtensionsManifestCache(W,this)),this.W=this.B(ie.createInstance(c.ExtensionsDownloader,this.getTargetPlatform()));const be=this.B(new k.ExtensionsWatcher(this,this.Y,pe,se,ue,ne,V));this.B(be.onDidChangeExtensionsByAnotherSource(Ee=>this.jb(Ee))),this.lb()}getTargetPlatform(){return this.db||(this.db=(0,t.computeTargetPlatform)(this.bb,this.v)),this.db}async zip(T){this.v.trace("ExtensionManagementService#zip",T.identifier.id);const M=await this.ib(T),V=await(0,m.zip)((0,w.joinPath)(this.W.extensionsDownloadDir,(0,v.generateUuid)()).fsPath,M);return g.URI.file(V)}async unzip(T){return this.v.trace("ExtensionManagementService#unzip",T.toString()),(await this.install(T)).identifier}async getManifest(T){const{location:M,cleanup:V}=await this.eb(T),W=C.resolve(M.fsPath);try{return await(0,p.getManifest)(W)}finally{await V()}}getInstalled(T,M){return this.S.scanExtensions(T??null,M)}getAllUserInstalled(){return this.S.scanAllUserExtensions(!1)}async install(T,M={}){this.v.trace("ExtensionManagementService#install",T.toString());const{location:V,cleanup:W}=await this.eb(T);try{const X=await(0,p.getManifest)(C.resolve(V.fsPath));if(X.engines&&X.engines.vscode&&!(0,N.isEngineValid)(X.engines.vscode,this.w.version,this.w.date))throw new Error(u.localize(0,null,(0,t.getGalleryExtensionId)(X.publisher,X.name),this.w.version));return await this.z(X,V,M)}finally{await W()}}async installFromLocation(T,M){this.v.trace("ExtensionManagementService#installFromLocation",T.toString());const V=await this.S.scanUserExtensionAtLocation(T);if(!V)throw new Error(`Cannot find a valid extension from the location ${T.toString()}`);return await this.nb([V],M),this.v.info("Successfully installed extension",V.identifier.id,M.toString()),V}getMetadata(T){return this.Y.scanMetadata(T.location)}async updateMetadata(T,M){this.v.trace("ExtensionManagementService#updateMetadata",T.identifier.id);const V={...M};return M.isPreReleaseVersion&&(V.preRelease=!0),T=await this.S.updateMetadata(T,V),this.U.invalidate(),T}async updateExtensionScope(T,M){return this.v.trace("ExtensionManagementService#updateExtensionScope",T.identifier.id),T=await this.S.updateMetadata(T,{isMachineScoped:M}),this.U.invalidate(),T}async reinstallFromGallery(T){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",T.identifier.id),!this.t.isEnabled())throw new Error(u.localize(1,null));const M=await this.getTargetPlatform(),[V]=await this.t.getExtensions([{...T.identifier,preRelease:T.preRelease}],{targetPlatform:M,compatible:!0},i.CancellationToken.None);if(!V)throw new Error(u.localize(2,null));await this.S.setUninstalled(T);try{await this.S.removeUninstalledExtension(T)}catch(W){throw new Error(u.localize(3,null,(0,R.toErrorMessage)(W)))}await this.installFromGallery(V)}markAsUninstalled(...T){return this.S.setUninstalled(...T)}removeUninstalledExtensions(){return this.S.cleanUp()}async download(T,M){const{location:V}=await this.W.download(T,M);return V}async eb(T){if(T.scheme===S.Schemas.file)return{location:T,async cleanup(){}};this.v.trace("Downloading extension from",T.toString());const M=(0,w.joinPath)(this.W.extensionsDownloadDir,(0,v.generateUuid)());return await this.ab.download(T,M),this.v.info("Downloaded extension to",M.toString()),{location:M,cleanup:async()=>{try{await this.bb.del(M)}catch(W){this.v.error(W)}}}}P(){return this.y.defaultProfile.extensionsResource}Q(T,M,V){let W;if(g.URI.isUri(M))W=new ee(T,M,V,this.t,this.S,this.v);else{const X=t.ExtensionKey.create(M).toString();W=this.X.get(X),W||(this.X.set(X,W=new Y(T,M,V,this.W,this.S,this.v)),W.waitUntilTaskIsFinished().then(()=>this.X.delete(X)))}return new oe(W,V.profileLocation,this.Z)}R(T,M){return new J(T,M.profileLocation,this.Z)}async ib(T){const M=async W=>{let X=await l.Promises.readdir(W);X=X.map(ie=>C.join(W,ie));const se=await Promise.all(X.map(ie=>l.Promises.stat(ie)));let x=Promise.resolve([]);return se.forEach((ie,ne)=>{const le=X[ne];ie.isFile()&&(x=x.then(ue=>[...ue,le])),ie.isDirectory()&&(x=x.then(ue=>M(le).then(pe=>[...ue,...pe])))}),x};return(await M(T.location.fsPath)).map(W=>({path:`extension/${C.relative(T.location.fsPath,W)}`,localPath:W}))}async jb({added:T,removed:M}){if(M)for(const V of M.extensions)this.v.info("Extensions removed from another source",V.id,M.profileLocation.toString()),this.p.fire({identifier:V,profileLocation:M.profileLocation});if(T){const W=(await this.S.scanExtensions(1,T.profileLocation)).filter(X=>T.extensions.some(se=>(0,t.areSameExtensions)(se,X.identifier)));this.m.fire(W.map(X=>(this.v.info("Extensions added from another source",X.identifier.id,T.profileLocation.toString()),{identifier:X.identifier,local:X,profileLocation:T.profileLocation,operation:1})))}}async lb(){this.B(this.S.onExtract(M=>this.kb.add(M)));const T=await this.bb.resolve(this.Y.userExtensionsLocation);for(const M of T.children??[])M.isDirectory&&this.kb.add(M.resource);this.B(this.bb.watch(this.Y.userExtensionsLocation)),this.B(this.bb.onDidFilesChange(M=>this.mb(M)))}async mb(T){const M=[];for(const V of T.rawAdded){if(this.kb.has(V)||!this.cb.extUri.isEqual(this.cb.extUri.dirname(V),this.Y.userExtensionsLocation)||this.cb.extUri.isEqual(V,this.cb.extUri.joinPath(this.Y.userExtensionsLocation,".obsolete"))||this.cb.extUri.basename(V).startsWith(".")||!(await this.bb.stat(V)).isDirectory)continue;const W=await this.S.scanUserExtensionAtLocation(V);W&&W.installedTimestamp===void 0&&(this.kb.add(V),M.push(W))}M.length&&(await this.nb(M,this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",M.map(V=>V.identifier.id)))}async nb(T,M){await this.Z.addExtensionsToProfile(T.map(V=>[V,void 0]),M),this.m.fire(T.map(V=>({local:V,identifier:V.identifier,operation:1,profileLocation:M})))}};Z=ye([K(0,s.IExtensionGalleryService),K(1,$.ITelemetryService),K(2,O.ILogService),K(3,f.INativeEnvironmentService),K(4,r.IExtensionsScannerService),K(5,a.IExtensionsProfileScannerService),K(6,h.IDownloadService),K(7,j.IInstantiationService),K(8,q.IFileService),K(9,U.IProductService),K(10,G.IUriIdentityService),K(11,H.IUserDataProfilesService)],Z),e.ExtensionManagementService=Z;let z=class extends P.Disposable{constructor(T,M,V,W){super(),this.j=T,this.k=M,this.l=V,this.m=W,this.h=this.B(new L.Emitter),this.onExtract=this.h.event,this.c=(0,w.joinPath)(this.l.userExtensionsLocation,".obsolete").fsPath,this.g=new D.Queue}async cleanUp(){await this.v()}async scanExtensions(T,M){await this.l.initializeDefaultProfileExtensions();const V={includeInvalid:!0,profileLocation:M};let W=[];return T===null||T===0?W.push(...await this.l.scanAllExtensions({includeInvalid:!0},V,!1)):T===1&&W.push(...await this.l.scanUserExtensions(V)),W=T!==null?W.filter(X=>X.type===T):W,Promise.all(W.map(X=>this.u(X)))}async scanAllUserExtensions(T){const M=await this.l.scanUserExtensions({includeAllVersions:!T,includeInvalid:!0});return Promise.all(M.map(V=>this.u(V)))}async scanUserExtensionAtLocation(T){try{const M=await this.l.scanExistingExtension(T,1,{includeInvalid:!0});if(M)return await this.u(M)}catch(M){this.m.error(M)}return null}async extractUserExtension(T,M,V,W){await this.l.initializeDefaultProfileExtensions();const X=T.toString(),se=C.join(this.l.userExtensionsLocation.fsPath,`.${(0,v.generateUuid)()}`),x=C.join(this.l.userExtensionsLocation.fsPath,X);try{await l.Promises.rm(x)}catch{throw new s.ExtensionManagementError(u.localize(4,null,x,T.id),s.ExtensionManagementErrorCode.Delete)}await this.p(T,M,se,W),await this.l.updateMetadata(g.URI.file(se),V);try{this.h.fire(g.URI.file(x)),await this.s(T,se,x,Date.now()+2*60*1e3),this.m.info("Renamed to",x)}catch(ie){try{await l.Promises.rm(se)}catch{}if(ie.code==="ENOTEMPTY")this.m.info("Rename failed because extension was installed by another source. So ignoring renaming.",T.id);else throw this.m.info(`Rename failed because of ${(0,A.getErrorMessage)(ie)}. Deleted from extracted location`,se),ie}return this.t(g.URI.file(x),1)}async updateMetadata(T,M){return await this.l.updateMetadata(T.location,M),this.t(T.location,T.type)}getUninstalledExtensions(){return this.n()}async setUninstalled(...T){const M=T.map(V=>t.ExtensionKey.create(V));await this.n(V=>M.forEach(W=>{V[W.toString()]=!0,this.m.info("Marked extension as uninstalled",W.toString())}))}async setInstalled(T){await this.n(W=>delete W[T.toString()]);const V=(await this.scanAllUserExtensions(!0)).find(W=>t.ExtensionKey.create(W).equals(T))||null;return V?this.updateMetadata(V,{installedTimestamp:Date.now()}):null}async removeExtension(T,M){this.m.trace(`Deleting ${M} extension from disk`,T.identifier.id,T.location.fsPath),await l.Promises.rm(T.location.fsPath),this.m.info("Deleted from disk",T.identifier.id,T.location.fsPath)}async removeUninstalledExtension(T){await this.removeExtension(T,"uninstalled"),await this.n(M=>delete M[t.ExtensionKey.create(T).toString()])}async n(T){return this.g.queue(async()=>{let M;try{M=await l.Promises.readFile(this.c,"utf8")}catch(W){if(W.code!=="ENOENT")throw W}let V={};if(M)try{V=JSON.parse(M)}catch{}return T&&(T(V),Object.keys(V).length?await l.Promises.writeFile(this.c,JSON.stringify(V)):await l.Promises.rm(this.c)),V})}async p(T,M,V,W){this.m.trace(`Started extracting the extension from ${M} to ${V}`);try{await l.Promises.rm(V)}catch(X){throw new s.ExtensionManagementError(this.w(X).message,s.ExtensionManagementErrorCode.Delete)}try{await(0,m.extract)(M,V,{sourcePath:"extension",overwrite:!0},W),this.m.info(`Extracted extension to ${V}:`,T.id)}catch(X){try{await l.Promises.rm(V)}catch{}let se=s.ExtensionManagementErrorCode.Extract;throw X instanceof m.ExtractError&&(X.type==="CorruptZip"?se=s.ExtensionManagementErrorCode.CorruptZip:X.type==="Incomplete"&&(se=s.ExtensionManagementErrorCode.IncompleteZip)),new s.ExtensionManagementError(X.message,se)}}async s(T,M,V,W){try{await l.Promises.rename(M,V)}catch(X){if(b.isWindows&&X&&X.code==="EPERM"&&Date.now()<W)return this.m.info(`Failed renaming ${M} to ${V} with 'EPERM' error. Trying again...`,T.id),this.s(T,M,V,W);throw new s.ExtensionManagementError(X.message||u.localize(5,null,M,V),X.code||s.ExtensionManagementErrorCode.Rename)}}async t(T,M){const V=await this.l.scanExistingExtension(T,M,{includeInvalid:!0});if(V)return this.u(V);throw new Error(u.localize(6,null,T.path))}async u(T){const M=await this.k.resolve(T.location);let V,W;return M.children&&(V=M.children.find(({name:X})=>/^readme(\.txt|\.md|)$/i.test(X))?.resource,W=M.children.find(({name:X})=>/^changelog(\.txt|\.md|)$/i.test(X))?.resource),{identifier:T.identifier,type:T.type,isBuiltin:T.isBuiltin||!!T.metadata?.isBuiltin,location:T.location,manifest:T.manifest,targetPlatform:T.targetPlatform,validations:T.validations,isValid:T.isValid,readmeUrl:V,changelogUrl:W,publisherDisplayName:T.metadata?.publisherDisplayName||null,publisherId:T.metadata?.publisherId||null,isApplicationScoped:!!T.metadata?.isApplicationScoped,isMachineScoped:!!T.metadata?.isMachineScoped,isPreReleaseVersion:!!T.metadata?.isPreReleaseVersion,preRelease:!!T.metadata?.preRelease,installedTimestamp:T.metadata?.installedTimestamp,updated:!!T.metadata?.updated}}async v(){const T=await this.getUninstalledExtensions(),M=await this.l.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),V=new Set;for(const se of M)T[t.ExtensionKey.create(se).toString()]||V.add(se.identifier.id.toLowerCase());const W=(0,t.groupByExtension)(M,se=>se.identifier);await D.Promises.settled(W.map(async se=>{const x=se.sort((ie,ne)=>y.rcompare(ie.manifest.version,ne.manifest.version))[0];V.has(x.identifier.id.toLowerCase())||await this.j(await this.u(x))}));const X=M.filter(se=>se.metadata&&T[t.ExtensionKey.create(se).toString()]);await D.Promises.settled(X.map(se=>this.removeUninstalledExtension(se)))}w(T){const M=Array.isArray(T)?T:[T];return M.length===1?M[0]instanceof Error?M[0]:new Error(M[0]):M.reduce((V,W)=>new Error(`${V.message}${V.message?",":""}${W instanceof Error?W.message:W}`),new Error(""))}};z=ye([K(1,q.IFileService),K(2,r.IExtensionsScannerService),K(3,O.ILogService)],z),e.ExtensionsScanner=z;class B extends n.AbstractExtensionTask{get operation(){return(0,d.isUndefined)(this.k.operation)?this.j:this.k.operation}constructor(T,M,V,W,X){super(),this.identifier=T,this.source=M,this.k=V,this.l=W,this.m=X,this.wasVerified=!1,this.j=2}async n(T,M){try{const V=await this.o(T.key);if(V)return this.l.updateMetadata(V,T.metadata)}catch{throw b.isMacintosh?new s.ExtensionManagementError(u.localize(7,null),s.ExtensionManagementErrorCode.Internal):new s.ExtensionManagementError(u.localize(8,null),s.ExtensionManagementErrorCode.Internal)}return this.q(T,M)}async o(T){if(!await this.p(T))return null;this.m.trace("Removing the extension from uninstalled list:",T.id);const V=await this.l.setInstalled(T);return this.m.info("Removed the extension from uninstalled list:",T.id),V}async p(T){return!!(await this.l.getUninstalledExtensions())[T.toString()]}async q({zipPath:T,key:M,metadata:V},W){const X=await this.l.extractUserExtension(M,T,V,W);return this.m.info("Extracting completed.",M.id),X}}class Y extends B{constructor(T,M,V,W,X,se){super(M.identifier,M,V,X,se),this.s=T,this.t=M,this.u=W}async h(T){const V=(await this.l.scanExtensions(null,void 0)).find(x=>(0,t.areSameExtensions)(x.identifier,this.t.identifier));V&&(this.j=3);const W={id:this.t.identifier.uuid,publisherId:this.t.publisherId,publisherDisplayName:this.t.publisherDisplayName,targetPlatform:this.t.properties.targetPlatform,isApplicationScoped:(0,F.isApplicationScopedExtension)(this.s),isMachineScoped:this.k.isMachineScoped||V?.isMachineScoped,isBuiltin:this.k.isBuiltin||V?.isBuiltin,isSystem:V?.type===0?!0:void 0,updated:!!V,isPreReleaseVersion:this.t.properties.isPreReleaseVersion,installedTimestamp:Date.now(),preRelease:this.t.properties.isPreReleaseVersion||((0,d.isBoolean)(this.k.installPreReleaseVersion)?this.k.installPreReleaseVersion:V?.preRelease)};if(V?.manifest.version===this.t.version)return{local:await this.l.updateMetadata(V,W),metadata:W};const{location:X,verified:se}=await this.u.download(this.t,this.j);try{return this.wasVerified=!!se,this.w(X.fsPath),{local:await this.n({zipPath:X.fsPath,key:t.ExtensionKey.create(this.t),metadata:W},T),metadata:W}}catch(x){try{await this.u.delete(X)}catch(ie){this.m.warn("Error while deleting the downloaded file",X.toString(),(0,A.getErrorMessage)(ie))}throw x}}async w(T){try{await(0,p.getManifest)(T)}catch(M){throw new s.ExtensionManagementError((0,n.joinErrors)(M).message,s.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=Y;class ee extends B{constructor(T,M,V,W,X,se){super({id:(0,t.getGalleryExtensionId)(T.publisher,T.name)},M,V,X,se),this.s=T,this.t=M,this.u=W}async h(T){const M=new t.ExtensionKey(this.identifier,this.s.version),W=(await this.l.scanExtensions(1,void 0)).find(x=>(0,t.areSameExtensions)(this.identifier,x.identifier)),X=await this.w(this.identifier.id,this.s.version,T);if(X.isApplicationScoped=(0,F.isApplicationScopedExtension)(this.s),X.isMachineScoped=this.k.isMachineScoped||W?.isMachineScoped,X.isBuiltin=this.k.isBuiltin||W?.isBuiltin,X.installedTimestamp=Date.now(),W)if(this.j=3,M.equals(new t.ExtensionKey(W.identifier,W.manifest.version)))try{await this.l.removeExtension(W,"existing")}catch{throw new Error(u.localize(9,null,this.s.displayName||this.s.name))}else!this.k.profileLocation&&y.gt(W.manifest.version,this.s.version)&&await this.l.setUninstalled(W);else{const x=await this.o(M);if(x)try{await this.l.removeExtension(x,"existing")}catch{throw new Error(u.localize(10,null,this.s.displayName||this.s.name))}}return{local:await this.n({zipPath:C.resolve(this.t.fsPath),key:M,metadata:X},T),metadata:X}}async w(T,M,V){try{let[W]=await this.u.getExtensions([{id:T,version:M}],V);if(W||([W]=await this.u.getExtensions([{id:T}],V)),W)return{id:W.identifier.uuid,publisherDisplayName:W.publisherDisplayName,publisherId:W.publisherId,isPreReleaseVersion:W.properties.isPreReleaseVersion,preRelease:W.properties.isPreReleaseVersion||this.k.installPreReleaseVersion}}catch{}return{}}}class oe{constructor(T,M,V){this.d=T,this.g=M,this.h=V,this.identifier=this.d.identifier,this.source=this.d.source,this.operation=this.d.operation,this.c=this.j()}async j(){const T=await this.d.waitUntilTaskIsFinished();return await this.h.addExtensionsToProfile([[T.local,T.metadata]],this.g),T}async run(){return await this.d.run(),this.c}waitUntilTaskIsFinished(){return this.c}cancel(){return this.d.cancel()}}class J extends n.AbstractExtensionTask{constructor(T,M,V){super(),this.extension=T,this.j=M,this.k=V}async h(T){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(re[281],ae([0,1,2,29,80,217,125,8,19]),function(_,e,D,i,R,A,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsContributions=void 0;let S=class extends D.Disposable{constructor(b,w,y,d,g,v){super(),b.removeUninstalledExtensions(),(0,A.migrateUnsupportedExtensions)(b,w,y,d,v),R.ExtensionStorageService.removeOutdatedExtensionVersions(b,g)}};S=ye([K(0,L.INativeServerExtensionManagementService),K(1,i.IExtensionGalleryService),K(2,R.IExtensionStorageService),K(3,i.IGlobalExtensionEnablementService),K(4,I.IStorageService),K(5,P.ILogService)],S),e.ExtensionsContributions=S}),define(re[290],ae([0,1,93,34,38,9,2,24,21,7,39,148,209,210,202,203,279,191,194,16,215,95,234,96,226,14,231,116,265,29,97,193,266,125,98,189,13,205,207,54,4,200,72,201,56,73,221,8,102,57,103,25,59,19,267,108,22,109,110,111,50,239,112,241,247,80,114,26,78,270,258,259,81,271,274,275,276,277,269,62,260,107,233,77,249,223,248,106,230,30,250,5,251,195,213,212,79,264,18,61,208,58,268,228,238,261,235,105,101,273,281]),function(_,e,D,i,R,A,L,P,I,S,C,b,w,y,d,g,v,l,m,u,h,f,n,s,t,a,r,c,o,p,E,k,F,N,q,j,O,U,$,G,H,Z,z,B,Y,ee,oe,J,Q,T,M,V,W,X,se,x,ie,ne,le,ue,pe,Se,be,Ee,Ne,Fe,Ye,ze,ce,de,ge,Ce,Pe,Ae,De,je,Oe,Ue,Be,ke,Te,te,he,fe,me,we,Ie,Re,He,$e,Le,qe,Ge,et,at,wt,At,Lt,vt,St,Ot,bt,Tt,Nt,Mt,Ut,Ft,Et,Ct,jt,$t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class zt extends L.Disposable{constructor(ve){super(),this.f=ve,this.a=this.B(new b.Server),this.b=void 0,this.c=void 0,this.g()}g(){const ve=async()=>{this.c&&(await this.c.fireOnWillShutdown(),this.c.dispose(),this.c=void 0),this.dispose()};process.once("exit",ve),D.ipcRenderer.once("vscode:electron-main->shared-process=exit",ve);const Me="vscode:electron-main->shared-process=disposeWorker",We=(Je,tt)=>{this.h(tt)};D.ipcRenderer.on(Me,We),this.B((0,L.toDisposable)(()=>D.ipcRenderer.removeListener(Me,We)))}h(ve){this.b?.disposeWorker(ve)}async open(){const ve=await this.i();(0,ze.registerConfiguration)(),ve.invokeFunction(Me=>{const We=Me.get(J.ILogService);We.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(Me),this.k(We)}),this.B((0,L.combinedDisposable)(ve.createInstance(w.CodeCacheCleaner,this.f.codeCachePath),ve.createInstance(y.LanguagePackCachedDataCleaner),ve.createInstance(v.UnusedWorkspaceStorageDataCleaner),ve.createInstance(g.LogsDataCleaner),ve.createInstance(d.LocalizationsUpdater),ve.createInstance($t.ExtensionsContributions),ve.createInstance(Ut.UserDataProfilesCleaner)))}async i(){const ve=new z.ServiceCollection,Me={_serviceBrand:void 0,...M.default};ve.set(V.IProductService,Me);const We=new C.StaticRouter(Qe=>Qe==="main"),Je=new B.MessagePortMainProcessService(this.a,We);ve.set(Y.IMainProcessService,Je);const tt=this.f.policiesData?new Ot.PolicyChannelClient(this.f.policiesData,Je.getChannel("policy")):new bt.NullPolicyService;ve.set(bt.IPolicyService,tt);const Ke=new r.SharedProcessEnvironmentService(this.f.args,Me);ve.set(a.INativeEnvironmentService,Ke);const lt=new Q.LogLevelChannelClient(this.a.getChannel("logLevel",We)),it=new Q.LoggerChannelClient(this.f.logLevel,lt.onDidChangeLogLevel,Je.getChannel("logger"));ve.set(J.ILoggerService,it);const ht=this.B(new J.MultiplexLogService([this.B(new J.ConsoleLogger(this.f.logLevel)),this.B(it.createLogger((0,I.joinPath)(S.URI.file(Ke.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),xe=this.B(new Q.FollowerLogService(lt,ht));ve.set(J.ILogService,xe),this.c=new Ct.SharedProcessLifecycleService(xe),ve.set(Ct.ISharedProcessLifecycleService,this.c),this.b=new He.SharedProcessWorkerService(xe),ve.set(Re.ISharedProcessWorkerService,this.b);const _e=this.B(new U.FileService(xe));ve.set(O.IFileService,_e);const ft=this.B(new $.DiskFileSystemProvider(xe));_e.registerProvider(P.Schemas.file,ft);const dt=this.B(new Ge.FileUserDataProvider(P.Schemas.file,this.B(new et.DiskFileSystemProviderClient(Je.getChannel(et.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:qe.isLinux})),P.Schemas.vscodeUserData,xe));_e.registerProvider(P.Schemas.vscodeUserData,dt);const nt=this.B(new Tt.UserDataProfilesNativeService(this.f.profiles,Je,Ke));ve.set(vt.IUserDataProfilesService,nt);const Xe=this.B(new h.ConfigurationService(nt.defaultProfile.settingsResource,_e,tt,xe));ve.set(u.IConfigurationService,Xe);const ot=new se.NativeStorageService(void 0,{defaultProfile:nt.defaultProfile,currentProfile:nt.defaultProfile},Je,Ke);ve.set(X.IStorageService,ot),this.B((0,L.toDisposable)(()=>ot.flush())),await Promise.all([Xe.initialize(),ot.initialize()]),ve.set($e.IUriIdentityService,new Le.UriIdentityService(_e)),ve.set(W.IRequestService,new Nt.SharedProcessRequestService(Je,Xe,Me,xe)),ve.set(l.IChecksumService,new G.SyncDescriptor(m.ChecksumService,void 0,!1)),ve.set(wt.IV8InspectProfilingService,new G.SyncDescriptor(at.InspectProfilingService,void 0,!1));const ut=C.ProxyChannel.toService(Je.getChannel("nativeHost"),{context:this.f.windowId});ve.set(T.INativeHostService,ut),ve.set(s.IDownloadService,new G.SyncDescriptor(t.DownloadService,void 0,!0));const gt=this.B(new Te.ActiveWindowManager(ut)),mt=new C.StaticRouter(Qe=>gt.getActiveClientId().then(yt=>Qe===yt));ve.set(q.IExtensionRecommendationNotificationService,new j.ExtensionRecommendationNotificationServiceChannelClient(this.a.getChannel("extensionRecommendationNotification",mt)));let st;const ct=[],Pt=(0,pe.isInternalTelemetry)(Me,Xe);if((0,pe.supportsTelemetry)(Me,Ke)){const Qe=new le.TelemetryLogAppender(it,Ke);ct.push(Qe);const{installSourcePath:yt}=Ke;if(Me.aiConfig?.ariaKey){const Dt=new Mt.OneDataSystemAppender(Pt,"monacoworkbench",null,Me.aiConfig.ariaKey);this.B((0,L.toDisposable)(()=>Dt.flush())),ct.push(Dt)}st=new ue.TelemetryService({appenders:ct,commonProperties:(0,x.resolveCommonProperties)(_e,(0,i.release)(),(0,i.hostname)(),process.arch,Me.commit,Me.version,this.f.machineId,Pt,yt),sendErrorTelemetry:!0,piiPaths:(0,pe.getPiiPathsFromEnvironment)(Ke)},Xe,Me)}else{st=pe.NullTelemetryService;const Qe=pe.NullAppender;ct.push(Qe)}this.a.registerChannel("telemetryAppender",new ne.TelemetryAppenderChannel(ct)),ve.set(ie.ITelemetryService,st);const qt=new Se.CustomEndpointTelemetryService(Xe,st,it,Ke,Me);ve.set(ie.ICustomEndpointTelemetryService,qt),ve.set(St.IExtensionsProfileScannerService,new G.SyncDescriptor(St.ExtensionsProfileScannerService,void 0,!0)),ve.set(At.IExtensionsScannerService,new G.SyncDescriptor(Lt.ExtensionsScannerService,void 0,!0)),ve.set(E.IExtensionSignatureVerificationService,new G.SyncDescriptor(E.ExtensionSignatureVerificationService,void 0,!0)),ve.set(N.INativeServerExtensionManagementService,new G.SyncDescriptor(N.ExtensionManagementService,void 0,!0)),ve.set(p.IExtensionGalleryService,new G.SyncDescriptor(o.ExtensionGalleryService,void 0,!0)),ve.set(p.IExtensionTipsService,new G.SyncDescriptor(F.ExtensionTipsService,void 0,!1)),ve.set(ee.ILanguagePackService,new G.SyncDescriptor(oe.NativeLanguagePackService,void 0,!1)),ve.set(f.IDiagnosticsService,new G.SyncDescriptor(n.DiagnosticsService,void 0,!1)),ve.set(ce.IUserDataSyncAccountService,new G.SyncDescriptor(ce.UserDataSyncAccountService,void 0,!0)),ve.set(ze.IUserDataSyncLogService,new G.SyncDescriptor(Ce.UserDataSyncLogService,void 0,!0)),ve.set(ze.IUserDataSyncUtilService,new ge.UserDataSyncUtilServiceClient(this.a.getChannel("userDataSyncUtil",Qe=>Qe.ctx!=="main"))),ve.set(p.IGlobalExtensionEnablementService,new G.SyncDescriptor(c.GlobalExtensionEnablementService,void 0,!1)),ve.set(Ye.IIgnoredExtensionsManagementService,new G.SyncDescriptor(Ye.IgnoredExtensionsManagementService,void 0,!0)),ve.set(Fe.IExtensionStorageService,new G.SyncDescriptor(Fe.ExtensionStorageService)),ve.set(ze.IUserDataSyncStoreManagementService,new G.SyncDescriptor(Oe.UserDataSyncStoreManagementService,void 0,!0)),ve.set(ze.IUserDataSyncStoreService,new G.SyncDescriptor(Oe.UserDataSyncStoreService,void 0,!0)),ve.set(Pe.IUserDataSyncMachinesService,new G.SyncDescriptor(Pe.UserDataSyncMachinesService,void 0,!0)),ve.set(ze.IUserDataSyncBackupStoreService,new G.SyncDescriptor(de.UserDataSyncBackupStoreService,void 0,!1)),ve.set(ze.IUserDataSyncEnablementService,new G.SyncDescriptor(Ae.UserDataSyncEnablementService,void 0,!0)),ve.set(ze.IUserDataSyncService,new G.SyncDescriptor(De.UserDataSyncService,void 0,!1)),ve.set(ke.IUserDataProfileStorageService,new G.SyncDescriptor(Be.UserDataProfileStorageService,void 0,!0)),ve.set(ze.IUserDataSyncResourceProviderService,new G.SyncDescriptor(jt.UserDataSyncResourceProviderService,void 0,!0));const Rt=new Ne.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Xe.getValue("terminal.integrated.persistentSessionScrollback")??100},Xe,Ke,xe);return Rt.initialize(),ve.set(Ee.ILocalPtyService,this.B(Rt)),ve.set(te.ISignService,new G.SyncDescriptor(he.SignService,void 0,!1)),ve.set(fe.ISharedTunnelsService,new G.SyncDescriptor(me.SharedTunnelsService)),ve.set(we.ISharedProcessTunnelService,new G.SyncDescriptor(Ie.SharedProcessTunnelService)),ve.set(Et.IRemoteTunnelService,new G.SyncDescriptor(Ft.RemoteTunnelService)),new Z.InstantiationService(ve)}j(ve){const Me=new Q.LogLevelChannel(ve.get(J.ILogService),ve.get(J.ILoggerService));this.a.registerChannel("logLevel",Me);const We=new k.ExtensionManagementChannel(ve.get(p.IExtensionManagementService),()=>null);this.a.registerChannel("extensions",We);const Je=C.ProxyChannel.fromService(ve.get(ee.ILanguagePackService));this.a.registerChannel("languagePacks",Je);const tt=C.ProxyChannel.fromService(ve.get(f.IDiagnosticsService));this.a.registerChannel("diagnostics",tt);const Ke=new k.ExtensionTipsChannel(ve.get(p.IExtensionTipsService));this.a.registerChannel("extensionTipsService",Ke);const lt=C.ProxyChannel.fromService(ve.get(l.IChecksumService));this.a.registerChannel("checksum",lt);const it=C.ProxyChannel.fromService(ve.get(wt.IV8InspectProfilingService));this.a.registerChannel("v8InspectProfiling",it);const ht=new ge.UserDataSyncMachinesServiceChannel(ve.get(Pe.IUserDataSyncMachinesService));this.a.registerChannel("userDataSyncMachines",ht);const xe=C.ProxyChannel.fromService(ve.get(ie.ICustomEndpointTelemetryService));this.a.registerChannel("customEndpointTelemetry",xe);const _e=new ge.UserDataSyncAccountServiceChannel(ve.get(ce.IUserDataSyncAccountService));this.a.registerChannel("userDataSyncAccount",_e);const ft=new ge.UserDataSyncStoreManagementServiceChannel(ve.get(ze.IUserDataSyncStoreManagementService));this.a.registerChannel("userDataSyncStoreManagement",ft);const dt=new je.UserDataSyncChannel(ve.get(ze.IUserDataSyncService),ve.get(vt.IUserDataProfilesService),ve.get(J.ILogService));this.a.registerChannel("userDataSync",dt);const nt=this.B(ve.get(H.IInstantiationService).createInstance(Ue.UserDataAutoSyncService)),Xe=new ge.UserDataAutoSyncChannel(nt);this.a.registerChannel("userDataAutoSync",Xe);const ot=ve.get(Ee.ILocalPtyService),ut=C.ProxyChannel.fromService(ot);this.a.registerChannel(be.TerminalIpcChannels.LocalPty,ut);const gt=C.ProxyChannel.fromService(ve.get(we.ISharedProcessTunnelService));this.a.registerChannel(we.ipcSharedProcessTunnelChannelName,gt);const mt=C.ProxyChannel.fromService(ve.get(Re.ISharedProcessWorkerService));this.a.registerChannel(Re.ipcSharedProcessWorkerChannelName,mt);const st=C.ProxyChannel.fromService(ve.get(Et.IRemoteTunnelService));this.a.registerChannel("remoteTunnel",st)}k(ve){window.addEventListener("unhandledrejection",Me=>{(0,A.onUnexpectedError)(Me.reason),Me.preventDefault()}),(0,A.setUnexpectedErrorHandler)(Me=>{const We=(0,R.toErrorMessage)(Me,!0);!We||ve.error(`[uncaught exception in sharedProcess]: ${We}`)})}}async function Bt(It){const ve=new zt(It);D.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ve.open(),D.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Bt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8b9891739b703b50547f506a7e2bc9565e52beff/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
