/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Y=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/base/common/event","vs/base/common/types","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/path","vs/base/common/buffer","vs/base/common/network","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/userDataProfile/common/userDataProfile","vs/platform/product/common/productService","vs/platform/extensions/common/extensions","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/objects","vs/base/common/uuid","vs/base/common/strings","vs/platform/telemetry/common/telemetry","os","vs/base/common/errorMessage","vs/base/common/process","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/policy/common/policy","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/stream","vs/base/common/marshalling","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/json","vs/base/common/processes","vs/base/common/hash","vs/base/common/severity","vs/base/common/ternarySearchTree","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/state","vs/platform/telemetry/common/commonProperties","vs/base/node/zip","vs/base/common/assert","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/node/spdlogLog","vs/platform/policy/common/filePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/stateService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","crypto","vs/platform/environment/node/argvHelper","https","vscode-policy-watcher","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Z=function($){for(var e=[],T=0,D=$.length;T<D;T++)e[T]=Y[$[T]];return e};define(Y[49],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function T(N){return(P,d,c)=>{let m=null,y=null;if(typeof c.value=="function"?(m="value",y=c.value):typeof c.get=="function"&&(m="get",y=c.get),!y)throw new Error("not supported");c[m]=N(y,d)}}function D(N,P,d){let c=null,m=null;if(typeof d.value=="function"?(c="value",m=d.value,m.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(c="get",m=d.get),!m)throw new Error("not supported");const y=`$memoize$${P}`;d[c]=function(...p){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:m.apply(this,p)}),this[y]}}e.memoize=D;function k(N,P,d){return T((c,m)=>{const y=`$debounce$${m}`,p=`$debounce$result$${m}`;return function(...I){this[p]||(this[p]=d?d():void 0),clearTimeout(this[y]),P&&(this[p]=P(this[p],...I),I=[this[p]]),this[y]=setTimeout(()=>{c.apply(this,I),this[p]=d?d():void 0},N)}})}e.debounce=k;function L(N,P,d){return T((c,m)=>{const y=`$throttle$timer$${m}`,p=`$throttle$result$${m}`,I=`$throttle$lastRun$${m}`,w=`$throttle$pending$${m}`;return function(...S){if(this[p]||(this[p]=d?d():void 0),(this[I]===null||this[I]===void 0)&&(this[I]=-Number.MAX_VALUE),P&&(this[p]=P(this[p],...S)),this[w])return;const E=this[I]+N;E<=Date.now()?(this[I]=Date.now(),c.apply(this,[this[p]]),this[p]=d?d():void 0):(this[w]=!0,this[y]=setTimeout(()=>{this[w]=!1,this[I]=Date.now(),c.apply(this,[this[p]]),this[p]=d?d():void 0},E-Date.now()))}})}e.throttle=L}),define(Y[70],Z([0,1,10]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function D(d,c){if(!d)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}e.ok=D;function k(d,c="Unreachable"){throw new Error(c)}e.assertNever=k;function L(d){if(!d)throw new T.BugIndicatingError("Assertion Failed")}e.assert=L;function N(d){if(!d()){debugger;d(),(0,T.onUnexpectedError)(new T.BugIndicatingError("Assertion Failed"))}}e.assertFn=N;function P(d,c){let m=0;for(;m<d.length-1;){const y=d[m],p=d[m+1];if(!c(y,p))return!1;m++}return!0}e.checkAdjacentItems=P}),define(Y[50],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var T;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(T=e.ScanError||(e.ScanError={}));var D;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(D=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var L;(function(i){i.DEFAULT={allowTrailingComma:!0}})(L=e.ParseOptions||(e.ParseOptions={}));function N(i,n=!1){let t=0;const r=i.length;let o="",u=0,a=16,h=0;function O(Q){let ge=0,ce=0;for(;ge<Q;){const re=i.charCodeAt(t);if(re>=48&&re<=57)ce=ce*16+re-48;else if(re>=65&&re<=70)ce=ce*16+re-65+10;else if(re>=97&&re<=102)ce=ce*16+re-97+10;else break;t++,ge++}return ge<Q&&(ce=-1),ce}function j(Q){t=Q,o="",u=0,a=16,h=0}function x(){const Q=t;if(i.charCodeAt(t)===48)t++;else for(t++;t<i.length&&c(i.charCodeAt(t));)t++;if(t<i.length&&i.charCodeAt(t)===46)if(t++,t<i.length&&c(i.charCodeAt(t)))for(t++;t<i.length&&c(i.charCodeAt(t));)t++;else return h=3,i.substring(Q,t);let ge=t;if(t<i.length&&(i.charCodeAt(t)===69||i.charCodeAt(t)===101))if(t++,(t<i.length&&i.charCodeAt(t)===43||i.charCodeAt(t)===45)&&t++,t<i.length&&c(i.charCodeAt(t))){for(t++;t<i.length&&c(i.charCodeAt(t));)t++;ge=t}else h=3;return i.substring(Q,ge)}function K(){let Q="",ge=t;for(;;){if(t>=r){Q+=i.substring(ge,t),h=2;break}const ce=i.charCodeAt(t);if(ce===34){Q+=i.substring(ge,t),t++;break}if(ce===92){if(Q+=i.substring(ge,t),t++,t>=r){h=2;break}switch(i.charCodeAt(t++)){case 34:Q+='"';break;case 92:Q+="\\";break;case 47:Q+="/";break;case 98:Q+="\b";break;case 102:Q+="\f";break;case 110:Q+=`
`;break;case 114:Q+="\r";break;case 116:Q+="	";break;case 117:{const me=O(4);me>=0?Q+=String.fromCharCode(me):h=4;break}default:h=5}ge=t;continue}if(ce>=0&&ce<=31)if(d(ce)){Q+=i.substring(ge,t),h=2;break}else h=6;t++}return Q}function X(){if(o="",h=0,u=t,t>=r)return u=r,a=17;let Q=i.charCodeAt(t);if(P(Q)){do t++,o+=String.fromCharCode(Q),Q=i.charCodeAt(t);while(P(Q));return a=15}if(d(Q))return t++,o+=String.fromCharCode(Q),Q===13&&i.charCodeAt(t)===10&&(t++,o+=`
`),a=14;switch(Q){case 123:return t++,a=1;case 125:return t++,a=2;case 91:return t++,a=3;case 93:return t++,a=4;case 58:return t++,a=6;case 44:return t++,a=5;case 34:return t++,o=K(),a=10;case 47:{const ge=t-1;if(i.charCodeAt(t+1)===47){for(t+=2;t<r&&!d(i.charCodeAt(t));)t++;return o=i.substring(ge,t),a=12}if(i.charCodeAt(t+1)===42){t+=2;const ce=r-1;let re=!1;for(;t<ce;){if(i.charCodeAt(t)===42&&i.charCodeAt(t+1)===47){t+=2,re=!0;break}t++}return re||(t++,h=1),o=i.substring(ge,t),a=13}return o+=String.fromCharCode(Q),t++,a=16}case 45:if(o+=String.fromCharCode(Q),t++,t===r||!c(i.charCodeAt(t)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=x(),a=11;default:for(;t<r&&ie(Q);)t++,Q=i.charCodeAt(t);if(u!==t){switch(o=i.substring(u,t),o){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return o+=String.fromCharCode(Q),t++,a=16}}function ie(Q){if(P(Q)||d(Q))return!1;switch(Q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ne(){let Q;do Q=X();while(Q>=12&&Q<=15);return Q}return{setPosition:j,getPosition:()=>t,scan:n?ne:X,getToken:()=>a,getTokenValue:()=>o,getTokenOffset:()=>u,getTokenLength:()=>t-u,getTokenError:()=>h}}e.createScanner=N;function P(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function d(i){return i===10||i===13||i===8232||i===8233}function c(i){return i>=48&&i<=57}var m;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(m||(m={}));function y(i,n){const t=[],r=new Object;let o;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function h(O,j,x,K){u.value=O,u.offset=j,u.length=x,u.type=K,u.colonOffset=void 0,o=u}try{v(i,{onObjectBegin:(O,j)=>{if(n<=O)throw r;o=void 0,a=n>O,t.push("")},onObjectProperty:(O,j,x)=>{if(n<j||(h(O,j,x,"property"),t[t.length-1]=O,n<=j+x))throw r},onObjectEnd:(O,j)=>{if(n<=O)throw r;o=void 0,t.pop()},onArrayBegin:(O,j)=>{if(n<=O)throw r;o=void 0,t.push(0)},onArrayEnd:(O,j)=>{if(n<=O)throw r;o=void 0,t.pop()},onLiteralValue:(O,j,x)=>{if(n<j||(h(O,j,x,s(O)),n<=j+x))throw r},onSeparator:(O,j,x)=>{if(n<=j)throw r;if(O===":"&&o&&o.type==="property")o.colonOffset=j,a=!1,o=void 0;else if(O===","){const K=t[t.length-1];typeof K=="number"?t[t.length-1]=K+1:(a=!0,t[t.length-1]=""),o=void 0}}})}catch(O){if(O!==r)throw O}return{path:t,previousNode:o,isAtPropertyKey:a,matches:O=>{let j=0;for(let x=0;j<O.length&&x<t.length;x++)if(O[j]===t[x]||O[j]==="*")j++;else if(O[j]!=="**")return!1;return j===O.length}}}e.getLocation=y;function p(i,n=[],t=L.DEFAULT){let r=null,o=[];const u=[];function a(O){Array.isArray(o)?o.push(O):r!==null&&(o[r]=O)}return v(i,{onObjectBegin:()=>{const O={};a(O),u.push(o),o=O,r=null},onObjectProperty:O=>{r=O},onObjectEnd:()=>{o=u.pop()},onArrayBegin:()=>{const O=[];a(O),u.push(o),o=O,r=null},onArrayEnd:()=>{o=u.pop()},onLiteralValue:a,onError:(O,j,x)=>{n.push({error:O,offset:j,length:x})}},t),o[0]}e.parse=p;function I(i,n=[],t=L.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(O){r.type==="property"&&(r.length=O-r.offset,r=r.parent)}function u(O){return r.children.push(O),O}v(i,{onObjectBegin:O=>{r=u({type:"object",offset:O,length:-1,parent:r,children:[]})},onObjectProperty:(O,j,x)=>{r=u({type:"property",offset:j,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:O,offset:j,length:x,parent:r})},onObjectEnd:(O,j)=>{r.length=O+j-r.offset,r=r.parent,o(O+j)},onArrayBegin:(O,j)=>{r=u({type:"array",offset:O,length:-1,parent:r,children:[]})},onArrayEnd:(O,j)=>{r.length=O+j-r.offset,r=r.parent,o(O+j)},onLiteralValue:(O,j,x)=>{u({type:s(O),offset:j,length:x,parent:r,value:O}),o(j+x)},onSeparator:(O,j,x)=>{r.type==="property"&&(O===":"?r.colonOffset=j:O===","&&o(j))},onError:(O,j,x)=>{n.push({error:O,offset:j,length:x})}},t);const h=r.children[0];return h&&delete h.parent,h}e.parseTree=I;function w(i,n){if(!i)return;let t=i;for(const r of n)if(typeof r=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let o=!1;for(const u of t.children)if(Array.isArray(u.children)&&u.children[0].value===r){t=u.children[1],o=!0;break}if(!o)return}else{const o=r;if(t.type!=="array"||o<0||!Array.isArray(t.children)||o>=t.children.length)return;t=t.children[o]}return t}e.findNodeAtLocation=w;function S(i){if(!i.parent||!i.parent.children)return[];const n=S(i.parent);if(i.parent.type==="property"){const t=i.parent.children[0].value;n.push(t)}else if(i.parent.type==="array"){const t=i.parent.children.indexOf(i);t!==-1&&n.push(t)}return n}e.getNodePath=S;function E(i){switch(i.type){case"array":return i.children.map(E);case"object":{const n=Object.create(null);for(const t of i.children){const r=t.children[1];r&&(n[t.children[0].value]=E(r))}return n}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=E;function l(i,n,t=!1){return n>=i.offset&&n<i.offset+i.length||t&&n===i.offset+i.length}e.contains=l;function g(i,n,t=!1){if(l(i,n,t)){const r=i.children;if(Array.isArray(r))for(let o=0;o<r.length&&r[o].offset<=n;o++){const u=g(r[o],n,t);if(u)return u}return i}}e.findNodeAtOffset=g;function v(i,n,t=L.DEFAULT){const r=N(i,!1);function o(q){return q?()=>q(r.getTokenOffset(),r.getTokenLength()):()=>!0}function u(q){return q?ee=>q(ee,r.getTokenOffset(),r.getTokenLength()):()=>!0}const a=o(n.onObjectBegin),h=u(n.onObjectProperty),O=o(n.onObjectEnd),j=o(n.onArrayBegin),x=o(n.onArrayEnd),K=u(n.onLiteralValue),X=u(n.onSeparator),ie=o(n.onComment),ne=u(n.onError),Q=t&&t.disallowComments,ge=t&&t.allowTrailingComma;function ce(){for(;;){const q=r.scan();switch(r.getTokenError()){case 4:re(14);break;case 5:re(15);break;case 3:re(13);break;case 1:Q||re(11);break;case 2:re(12);break;case 6:re(16);break}switch(q){case 12:case 13:Q?re(10):ie();break;case 16:re(1);break;case 15:case 14:break;default:return q}}}function re(q,ee=[],b=[]){if(ne(q),ee.length+b.length>0){let R=r.getToken();for(;R!==17;){if(ee.indexOf(R)!==-1){ce();break}else if(b.indexOf(R)!==-1)break;R=ce()}}}function me(q){const ee=r.getTokenValue();return q?K(ee):h(ee),ce(),!0}function M(){switch(r.getToken()){case 11:{let q=0;try{q=JSON.parse(r.getTokenValue()),typeof q!="number"&&(re(2),q=0)}catch{re(2)}K(q);break}case 7:K(null);break;case 8:K(!0);break;case 9:K(!1);break;default:return!1}return ce(),!0}function A(){return r.getToken()!==10?(re(3,[],[2,5]),!1):(me(!1),r.getToken()===6?(X(":"),ce(),G()||re(4,[],[2,5])):re(5,[],[2,5]),!0)}function U(){a(),ce();let q=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(q||re(4,[],[]),X(","),ce(),r.getToken()===2&&ge)break}else q&&re(6,[],[]);A()||re(4,[],[2,5]),q=!0}return O(),r.getToken()!==2?re(7,[2],[]):ce(),!0}function V(){j(),ce();let q=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(q||re(4,[],[]),X(","),ce(),r.getToken()===4&&ge)break}else q&&re(6,[],[]);G()||re(4,[],[4,5]),q=!0}return x(),r.getToken()!==4?re(8,[4],[]):ce(),!0}function G(){switch(r.getToken()){case 3:return V();case 1:return U();case 10:return me(!0);default:return M()}}return ce(),r.getToken()===17?t.allowEmptyContent?!0:(re(4,[],[]),!1):G()?(r.getToken()!==17&&re(9,[],[]),!0):(re(4,[],[]),!1)}e.visit=v;function f(i,n){const t=N(i),r=[];let o,u=0,a;do switch(a=t.getPosition(),o=t.scan(),o){case 12:case 13:case 17:u!==a&&r.push(i.substring(u,a)),n!==void 0&&r.push(t.getTokenValue().replace(/[^\r\n]/g,n)),u=t.getPosition();break}while(o!==17);return r.join("")}e.stripComments=f;function s(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=s}),function(){function $(k){const L=[];typeof k=="number"&&L.push("code/timeOrigin",k);function N(d){L.push(d,Date.now())}function P(){const d=[];for(let c=0;c<L.length;c+=2)d.push({name:L[c],startTime:L[c+1]});return d}return{mark:N,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?$():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const N of performance.getEntriesByType("mark"))L.push({name:N.name,startTime:Math.round(k+N.startTime)});return L}};if(typeof process=="object"){const k=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return $(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),$()}function T(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return T(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=T(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=T(D))}(),function($,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var T=e();for(var D in T)(typeof exports=="object"?exports:$)[D]=T[D]}}(typeof self<"u"?self:this,function(){return function($){var e={};function T(D){if(e[D])return e[D].exports;var k=e[D]={i:D,l:!1,exports:{}};return $[D].call(k.exports,k,k.exports,T),k.l=!0,k.exports}return T.m=$,T.c=e,T.d=function(D,k,L){T.o(D,k)||Object.defineProperty(D,k,{enumerable:!0,get:L})},T.r=function(D){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},T.t=function(D,k){if(1&k&&(D=T(D)),8&k||4&k&&typeof D=="object"&&D&&D.__esModule)return D;var L=Object.create(null);if(T.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:D}),2&k&&typeof D!="string")for(var N in D)T.d(L,N,function(P){return D[P]}.bind(null,N));return L},T.n=function(D){var k=D&&D.__esModule?function(){return D.default}:function(){return D};return T.d(k,"a",k),k},T.o=function(D,k){return Object.prototype.hasOwnProperty.call(D,k)},T.p="",T(T.s=0)}([function($,e,T){(function(D){var k;e=$.exports=b,k=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var z=Array.prototype.slice.call(arguments,0);z.unshift("SEMVER"),console.log.apply(console,z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,N=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],d=e.src=[],c=0,m=c++;d[m]="0|[1-9]\\d*";var y=c++;d[y]="[0-9]+";var p=c++;d[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var I=c++;d[I]="("+d[m]+")\\.("+d[m]+")\\.("+d[m]+")";var w=c++;d[w]="("+d[y]+")\\.("+d[y]+")\\.("+d[y]+")";var S=c++;d[S]="(?:"+d[m]+"|"+d[p]+")";var E=c++;d[E]="(?:"+d[y]+"|"+d[p]+")";var l=c++;d[l]="(?:-("+d[S]+"(?:\\."+d[S]+")*))";var g=c++;d[g]="(?:-?("+d[E]+"(?:\\."+d[E]+")*))";var v=c++;d[v]="[0-9A-Za-z-]+";var f=c++;d[f]="(?:\\+("+d[v]+"(?:\\."+d[v]+")*))";var s=c++,i="v?"+d[I]+d[l]+"?"+d[f]+"?";d[s]="^"+i+"$";var n="[v=\\s]*"+d[w]+d[g]+"?"+d[f]+"?",t=c++;d[t]="^"+n+"$";var r=c++;d[r]="((?:<|>)?=?)";var o=c++;d[o]=d[y]+"|x|X|\\*";var u=c++;d[u]=d[m]+"|x|X|\\*";var a=c++;d[a]="[v=\\s]*("+d[u]+")(?:\\.("+d[u]+")(?:\\.("+d[u]+")(?:"+d[l]+")?"+d[f]+"?)?)?";var h=c++;d[h]="[v=\\s]*("+d[o]+")(?:\\.("+d[o]+")(?:\\.("+d[o]+")(?:"+d[g]+")?"+d[f]+"?)?)?";var O=c++;d[O]="^"+d[r]+"\\s*"+d[a]+"$";var j=c++;d[j]="^"+d[r]+"\\s*"+d[h]+"$";var x=c++;d[x]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var K=c++;d[K]="(?:~>?)";var X=c++;d[X]="(\\s*)"+d[K]+"\\s+",P[X]=new RegExp(d[X],"g");var ie=c++;d[ie]="^"+d[K]+d[a]+"$";var ne=c++;d[ne]="^"+d[K]+d[h]+"$";var Q=c++;d[Q]="(?:\\^)";var ge=c++;d[ge]="(\\s*)"+d[Q]+"\\s+",P[ge]=new RegExp(d[ge],"g");var ce=c++;d[ce]="^"+d[Q]+d[a]+"$";var re=c++;d[re]="^"+d[Q]+d[h]+"$";var me=c++;d[me]="^"+d[r]+"\\s*("+n+")$|^$";var M=c++;d[M]="^"+d[r]+"\\s*("+i+")$|^$";var A=c++;d[A]="(\\s*)"+d[r]+"\\s*("+n+"|"+d[a]+")",P[A]=new RegExp(d[A],"g");var U=c++;d[U]="^\\s*("+d[a]+")\\s+-\\s+("+d[a]+")\\s*$";var V=c++;d[V]="^\\s*("+d[h]+")\\s+-\\s+("+d[h]+")\\s*$";var G=c++;d[G]="(<|>)?=?\\s*\\*";for(var q=0;q<35;q++)k(q,d[q]),P[q]||(P[q]=new RegExp(d[q]));function ee(z,H){if(z instanceof b)return z;if(typeof z!="string"||z.length>L||!(H?P[t]:P[s]).test(z))return null;try{return new b(z,H)}catch{return null}}function b(z,H){if(z instanceof b){if(z.loose===H)return z;z=z.version}else if(typeof z!="string")throw new TypeError("Invalid Version: "+z);if(z.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof b))return new b(z,H);k("SemVer",z,H),this.loose=H;var J=z.trim().match(H?P[t]:P[s]);if(!J)throw new TypeError("Invalid Version: "+z);if(this.raw=z,this.major=+J[1],this.minor=+J[2],this.patch=+J[3],this.major>N||this.major<0)throw new TypeError("Invalid major version");if(this.minor>N||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>N||this.patch<0)throw new TypeError("Invalid patch version");J[4]?this.prerelease=J[4].split(".").map(function(he){if(/^[0-9]+$/.test(he)){var ve=+he;if(ve>=0&&ve<N)return ve}return he}):this.prerelease=[],this.build=J[5]?J[5].split("."):[],this.format()}e.parse=ee,e.valid=function(z,H){var J=ee(z,H);return J?J.version:null},e.clean=function(z,H){var J=ee(z.trim().replace(/^[=v]+/,""),H);return J?J.version:null},e.SemVer=b,b.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},b.prototype.toString=function(){return this.version},b.prototype.compare=function(z){return k("SemVer.compare",this.version,this.loose,z),z instanceof b||(z=new b(z,this.loose)),this.compareMain(z)||this.comparePre(z)},b.prototype.compareMain=function(z){return z instanceof b||(z=new b(z,this.loose)),C(this.major,z.major)||C(this.minor,z.minor)||C(this.patch,z.patch)},b.prototype.comparePre=function(z){if(z instanceof b||(z=new b(z,this.loose)),this.prerelease.length&&!z.prerelease.length)return-1;if(!this.prerelease.length&&z.prerelease.length)return 1;if(!this.prerelease.length&&!z.prerelease.length)return 0;var H=0;do{var J=this.prerelease[H],he=z.prerelease[H];if(k("prerelease compare",H,J,he),J===void 0&&he===void 0)return 0;if(he===void 0)return 1;if(J===void 0)return-1;if(J!==he)return C(J,he)}while(++H)},b.prototype.inc=function(z,H){switch(z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var J=this.prerelease.length;--J>=0;)typeof this.prerelease[J]=="number"&&(this.prerelease[J]++,J=-2);J===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+z)}return this.format(),this.raw=this.version,this},e.inc=function(z,H,J,he){typeof J=="string"&&(he=J,J=void 0);try{return new b(z,J).inc(H,he).version}catch{return null}},e.diff=function(z,H){if(te(z,H))return null;var J=ee(z),he=ee(H);if(J.prerelease.length||he.prerelease.length){for(var ve in J)if((ve==="major"||ve==="minor"||ve==="patch")&&J[ve]!==he[ve])return"pre"+ve;return"prerelease"}for(var ve in J)if((ve==="major"||ve==="minor"||ve==="patch")&&J[ve]!==he[ve])return ve},e.compareIdentifiers=C;var R=/^[0-9]+$/;function C(z,H){var J=R.test(z),he=R.test(H);return J&&he&&(z=+z,H=+H),J&&!he?-1:he&&!J?1:z<H?-1:z>H?1:0}function F(z,H,J){return new b(z,J).compare(new b(H,J))}function B(z,H,J){return F(z,H,J)>0}function W(z,H,J){return F(z,H,J)<0}function te(z,H,J){return F(z,H,J)===0}function se(z,H,J){return F(z,H,J)!==0}function pe(z,H,J){return F(z,H,J)>=0}function ye(z,H,J){return F(z,H,J)<=0}function ae(z,H,J,he){var ve;switch(H){case"===":typeof z=="object"&&(z=z.version),typeof J=="object"&&(J=J.version),ve=z===J;break;case"!==":typeof z=="object"&&(z=z.version),typeof J=="object"&&(J=J.version),ve=z!==J;break;case"":case"=":case"==":ve=te(z,J,he);break;case"!=":ve=se(z,J,he);break;case">":ve=B(z,J,he);break;case">=":ve=pe(z,J,he);break;case"<":ve=W(z,J,he);break;case"<=":ve=ye(z,J,he);break;default:throw new TypeError("Invalid operator: "+H)}return ve}function ue(z,H){if(z instanceof ue){if(z.loose===H)return z;z=z.value}if(!(this instanceof ue))return new ue(z,H);k("comparator",z,H),this.loose=H,this.parse(z),this.semver===le?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(z,H){return C(H,z)},e.major=function(z,H){return new b(z,H).major},e.minor=function(z,H){return new b(z,H).minor},e.patch=function(z,H){return new b(z,H).patch},e.compare=F,e.compareLoose=function(z,H){return F(z,H,!0)},e.rcompare=function(z,H,J){return F(H,z,J)},e.sort=function(z,H){return z.sort(function(J,he){return e.compare(J,he,H)})},e.rsort=function(z,H){return z.sort(function(J,he){return e.rcompare(J,he,H)})},e.gt=B,e.lt=W,e.eq=te,e.neq=se,e.gte=pe,e.lte=ye,e.cmp=ae,e.Comparator=ue;var le={};function oe(z,H){if(z instanceof oe)return z.loose===H?z:new oe(z.raw,H);if(z instanceof ue)return new oe(z.value,H);if(!(this instanceof oe))return new oe(z,H);if(this.loose=H,this.raw=z,this.set=z.split(/\s*\|\|\s*/).map(function(J){return this.parseRange(J.trim())},this).filter(function(J){return J.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+z);this.format()}function fe(z){return!z||z.toLowerCase()==="x"||z==="*"}function Te(z,H,J,he,ve,Re,Se,Le,Pe,Oe,je,Ie,Ne){return((H=fe(J)?"":fe(he)?">="+J+".0.0":fe(ve)?">="+J+"."+he+".0":">="+H)+" "+(Le=fe(Pe)?"":fe(Oe)?"<"+(+Pe+1)+".0.0":fe(je)?"<"+Pe+"."+(+Oe+1)+".0":Ie?"<="+Pe+"."+Oe+"."+je+"-"+Ie:"<="+Le)).trim()}function Fe(z,H){for(var J=0;J<z.length;J++)if(!z[J].test(H))return!1;if(H.prerelease.length){for(J=0;J<z.length;J++)if(k(z[J].semver),z[J].semver!==le&&z[J].semver.prerelease.length>0){var he=z[J].semver;if(he.major===H.major&&he.minor===H.minor&&he.patch===H.patch)return!0}return!1}return!0}function De(z,H,J){try{H=new oe(H,J)}catch{return!1}return H.test(z)}function Me(z,H,J,he){var ve,Re,Se,Le,Pe;switch(z=new b(z,he),H=new oe(H,he),J){case">":ve=B,Re=ye,Se=W,Le=">",Pe=">=";break;case"<":ve=W,Re=pe,Se=B,Le="<",Pe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(De(z,H,he))return!1;for(var Oe=0;Oe<H.set.length;++Oe){var je=H.set[Oe],Ie=null,Ne=null;if(je.forEach(function(Ce){Ce.semver===le&&(Ce=new ue(">=0.0.0")),Ie=Ie||Ce,Ne=Ne||Ce,ve(Ce.semver,Ie.semver,he)?Ie=Ce:Se(Ce.semver,Ne.semver,he)&&(Ne=Ce)}),Ie.operator===Le||Ie.operator===Pe||(!Ne.operator||Ne.operator===Le)&&Re(z,Ne.semver)||Ne.operator===Pe&&Se(z,Ne.semver))return!1}return!0}ue.prototype.parse=function(z){var H=this.loose?P[me]:P[M],J=z.match(H);if(!J)throw new TypeError("Invalid comparator: "+z);this.operator=J[1],this.operator==="="&&(this.operator=""),J[2]?this.semver=new b(J[2],this.loose):this.semver=le},ue.prototype.toString=function(){return this.value},ue.prototype.test=function(z){return k("Comparator.test",z,this.loose),this.semver===le||(typeof z=="string"&&(z=new b(z,this.loose)),ae(z,this.operator,this.semver,this.loose))},ue.prototype.intersects=function(z,H){if(!(z instanceof ue))throw new TypeError("a Comparator is required");var J;if(this.operator==="")return J=new oe(z.value,H),De(this.value,J,H);if(z.operator==="")return J=new oe(this.value,H),De(z.semver,J,H);var he=!(this.operator!==">="&&this.operator!==">"||z.operator!==">="&&z.operator!==">"),ve=!(this.operator!=="<="&&this.operator!=="<"||z.operator!=="<="&&z.operator!=="<"),Re=this.semver.version===z.semver.version,Se=!(this.operator!==">="&&this.operator!=="<="||z.operator!==">="&&z.operator!=="<="),Le=ae(this.semver,"<",z.semver,H)&&(this.operator===">="||this.operator===">")&&(z.operator==="<="||z.operator==="<"),Pe=ae(this.semver,">",z.semver,H)&&(this.operator==="<="||this.operator==="<")&&(z.operator===">="||z.operator===">");return he||ve||Re&&Se||Le||Pe},e.Range=oe,oe.prototype.format=function(){return this.range=this.set.map(function(z){return z.join(" ").trim()}).join("||").trim(),this.range},oe.prototype.toString=function(){return this.range},oe.prototype.parseRange=function(z){var H=this.loose;z=z.trim(),k("range",z,H);var J=H?P[V]:P[U];z=z.replace(J,Te),k("hyphen replace",z),z=z.replace(P[A],"$1$2$3"),k("comparator trim",z,P[A]),z=(z=(z=z.replace(P[X],"$1~")).replace(P[ge],"$1^")).split(/\s+/).join(" ");var he=H?P[me]:P[M],ve=z.split(" ").map(function(Re){return function(Se,Le){return k("comp",Se),Se=function(Pe,Oe){return Pe.trim().split(/\s+/).map(function(je){return function(Ie,Ne){k("caret",Ie,Ne);var Ce=Ne?P[re]:P[ce];return Ie.replace(Ce,function(Ue,we,Ee,be,ke){var Ae;return k("caret",Ie,Ue,we,Ee,be,ke),fe(we)?Ae="":fe(Ee)?Ae=">="+we+".0.0 <"+(+we+1)+".0.0":fe(be)?Ae=we==="0"?">="+we+"."+Ee+".0 <"+we+"."+(+Ee+1)+".0":">="+we+"."+Ee+".0 <"+(+we+1)+".0.0":ke?(k("replaceCaret pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Ae=we==="0"?Ee==="0"?">="+we+"."+Ee+"."+be+ke+" <"+we+"."+Ee+"."+(+be+1):">="+we+"."+Ee+"."+be+ke+" <"+we+"."+(+Ee+1)+".0":">="+we+"."+Ee+"."+be+ke+" <"+(+we+1)+".0.0"):(k("no pr"),Ae=we==="0"?Ee==="0"?">="+we+"."+Ee+"."+be+" <"+we+"."+Ee+"."+(+be+1):">="+we+"."+Ee+"."+be+" <"+we+"."+(+Ee+1)+".0":">="+we+"."+Ee+"."+be+" <"+(+we+1)+".0.0"),k("caret return",Ae),Ae})}(je,Oe)}).join(" ")}(Se,Le),k("caret",Se),Se=function(Pe,Oe){return Pe.trim().split(/\s+/).map(function(je){return function(Ie,Ne){var Ce=Ne?P[ne]:P[ie];return Ie.replace(Ce,function(Ue,we,Ee,be,ke){var Ae;return k("tilde",Ie,Ue,we,Ee,be,ke),fe(we)?Ae="":fe(Ee)?Ae=">="+we+".0.0 <"+(+we+1)+".0.0":fe(be)?Ae=">="+we+"."+Ee+".0 <"+we+"."+(+Ee+1)+".0":ke?(k("replaceTilde pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Ae=">="+we+"."+Ee+"."+be+ke+" <"+we+"."+(+Ee+1)+".0"):Ae=">="+we+"."+Ee+"."+be+" <"+we+"."+(+Ee+1)+".0",k("tilde return",Ae),Ae})}(je,Oe)}).join(" ")}(Se,Le),k("tildes",Se),Se=function(Pe,Oe){return k("replaceXRanges",Pe,Oe),Pe.split(/\s+/).map(function(je){return function(Ie,Ne){Ie=Ie.trim();var Ce=Ne?P[j]:P[O];return Ie.replace(Ce,function(Ue,we,Ee,be,ke,Ae){k("xRange",Ie,Ue,we,Ee,be,ke,Ae);var We=fe(Ee),ze=We||fe(be),Be=ze||fe(ke);return we==="="&&Be&&(we=""),We?Ue=we===">"||we==="<"?"<0.0.0":"*":we&&Be?(ze&&(be=0),Be&&(ke=0),we===">"?(we=">=",ze?(Ee=+Ee+1,be=0,ke=0):Be&&(be=+be+1,ke=0)):we==="<="&&(we="<",ze?Ee=+Ee+1:be=+be+1),Ue=we+Ee+"."+be+"."+ke):ze?Ue=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Be&&(Ue=">="+Ee+"."+be+".0 <"+Ee+"."+(+be+1)+".0"),k("xRange return",Ue),Ue})}(je,Oe)}).join(" ")}(Se,Le),k("xrange",Se),Se=function(Pe,Oe){return k("replaceStars",Pe,Oe),Pe.trim().replace(P[G],"")}(Se,Le),k("stars",Se),Se}(Re,H)}).join(" ").split(/\s+/);return this.loose&&(ve=ve.filter(function(Re){return!!Re.match(he)})),ve=ve.map(function(Re){return new ue(Re,H)})},oe.prototype.intersects=function(z,H){if(!(z instanceof oe))throw new TypeError("a Range is required");return this.set.some(function(J){return J.every(function(he){return z.set.some(function(ve){return ve.every(function(Re){return he.intersects(Re,H)})})})})},e.toComparators=function(z,H){return new oe(z,H).set.map(function(J){return J.map(function(he){return he.value}).join(" ").trim().split(" ")})},oe.prototype.test=function(z){if(!z)return!1;typeof z=="string"&&(z=new b(z,this.loose));for(var H=0;H<this.set.length;H++)if(Fe(this.set[H],z))return!0;return!1},e.satisfies=De,e.maxSatisfying=function(z,H,J){var he=null,ve=null;try{var Re=new oe(H,J)}catch{return null}return z.forEach(function(Se){Re.test(Se)&&(he&&ve.compare(Se)!==-1||(ve=new b(he=Se,J)))}),he},e.minSatisfying=function(z,H,J){var he=null,ve=null;try{var Re=new oe(H,J)}catch{return null}return z.forEach(function(Se){Re.test(Se)&&(he&&ve.compare(Se)!==1||(ve=new b(he=Se,J)))}),he},e.validRange=function(z,H){try{return new oe(z,H).range||"*"}catch{return null}},e.ltr=function(z,H,J){return Me(z,H,"<",J)},e.gtr=function(z,H,J){return Me(z,H,">",J)},e.outside=Me,e.prerelease=function(z,H){var J=ee(z,H);return J&&J.prerelease.length?J.prerelease:null},e.intersects=function(z,H,J){return z=new oe(z,J),H=new oe(H,J),z.intersects(H)},e.coerce=function(z){if(z instanceof b)return z;if(typeof z!="string")return null;var H=z.match(P[x]);return H==null?null:ee((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,T(1))},function($,e){var T,D,k=$.exports={};function L(){throw new Error("setTimeout has not been defined")}function N(){throw new Error("clearTimeout has not been defined")}function P(E){if(T===setTimeout)return setTimeout(E,0);if((T===L||!T)&&setTimeout)return T=setTimeout,setTimeout(E,0);try{return T(E,0)}catch{try{return T.call(null,E,0)}catch{return T.call(this,E,0)}}}(function(){try{T=typeof setTimeout=="function"?setTimeout:L}catch{T=L}try{D=typeof clearTimeout=="function"?clearTimeout:N}catch{D=N}})();var d,c=[],m=!1,y=-1;function p(){m&&d&&(m=!1,d.length?c=d.concat(c):y=-1,c.length&&I())}function I(){if(!m){var E=P(p);m=!0;for(var l=c.length;l;){for(d=c,c=[];++y<l;)d&&d[y].run();y=-1,l=c.length}d=null,m=!1,function(g){if(D===clearTimeout)return clearTimeout(g);if((D===N||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(g);try{D(g)}catch{try{return D.call(null,g)}catch{return D.call(this,g)}}}(E)}}function w(E,l){this.fun=E,this.array=l}function S(){}k.nextTick=function(E){var l=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)l[g-1]=arguments[g];c.push(new w(E,l)),c.length!==1||m||P(I)},w.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=S,k.addListener=S,k.once=S,k.off=S,k.removeListener=S,k.removeAllListeners=S,k.emit=S,k.prependListener=S,k.prependOnceListener=S,k.listeners=function(E){return[]},k.binding=function(E){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(E){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(Y[71],Z([0,1]),function($,e){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class D{constructor(P,d,c){this.level=P,this.key=d,this.value=c,this.forward=[]}}const k=void 0;class L{constructor(P,d=2**16){this.comparator=P,this[T]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(d)|0),this.e=new D(this.c,k,k)}get size(){return this.f}clear(){this.e=new D(this.c,k,k)}has(P){return Boolean(L.g(this,P,this.comparator))}get(P){return L.g(this,P,this.comparator)?.value}set(P,d){return L.h(this,P,d,this.comparator)&&(this.f+=1),this}delete(P){const d=L.k(this,P,this.comparator);return d&&(this.f-=1),d}forEach(P,d){let c=this.e.forward[0];for(;c;)P.call(d,c.value,c.key,this),c=c.forward[0]}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",d=this.e.forward[0];for(;d;)P+=`node(${d.key}, ${d.value}, lvl:${d.level})`,d=d.forward[0];return P}static g(P,d,c){let m=P.e;for(let y=P.d-1;y>=0;y--)for(;m.forward[y]&&c(m.forward[y].key,d)<0;)m=m.forward[y];if(m=m.forward[0],m&&c(m.key,d)===0)return m}static h(P,d,c,m){const y=[];let p=P.e;for(let I=P.d-1;I>=0;I--){for(;p.forward[I]&&m(p.forward[I].key,d)<0;)p=p.forward[I];y[I]=p}if(p=p.forward[0],p&&m(p.key,d)===0)return p.value=c,!1;{const I=L.j(P);if(I>P.d){for(let w=P.d;w<I;w++)y[w]=P.e;P.d=I}p=new D(I,d,c);for(let w=0;w<I;w++)p.forward[w]=y[w].forward[w],y[w].forward[w]=p;return!0}}static j(P,d=.5){let c=1;for(;Math.random()<d&&c<P.c;)c+=1;return c}static k(P,d,c){const m=[];let y=P.e;for(let p=P.d-1;p>=0;p--){for(;y.forward[p]&&c(y.forward[p].key,d)<0;)y=y.forward[p];m[p]=y}if(y=y.forward[0],!y||c(y.key,d)!==0)return!1;for(let p=0;p<P.d&&m[p].forward[p]===y;p++)m[p].forward[p]=y.forward[p];for(;P.d>0&&P.e.forward[P.d-1]===k;)P.d-=1;return!0}}e.SkipList=L}),define(Y[43],Z([0,1,10,2]),function($,e,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(f){const s=f;return s?typeof s.read=="function":!1}e.isReadable=k;function L(f){const s=f;return s?[s.on,s.pause,s.resume,s.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=L;function N(f){const s=f;return s?L(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}e.isReadableBufferedStream=N;function P(f,s){return new d(f,s)}e.newWriteableStream=P;class d{constructor(s,i){this.e=s,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(s){if(!this.a.destroyed){if(this.a.flowing)this.g(s);else if(this.b.data.push(s),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(s){this.a.destroyed||(this.a.flowing?this.h(s):this.b.error.push(s))}end(s){this.a.destroyed||(typeof s<"u"&&this.write(s),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(s){this.c.data.slice(0).forEach(i=>i(s))}h(s){this.c.error.length===0?(0,T.onUnexpectedError)(s):this.c.error.slice(0).forEach(i=>i(s))}i(){this.c.end.slice(0).forEach(s=>s())}on(s,i){if(!this.a.destroyed)switch(s){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(s,i){if(this.a.destroyed)return;let n;switch(s){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const t=n.indexOf(i);t>=0&&n.splice(t,1)}}j(){if(this.b.data.length>0){const s=this.e(this.b.data);this.g(s),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const s of this.b.error)this.h(s);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(f,s){const i=[];let n;for(;(n=f.read())!==null;)i.push(n);return s(i)}e.consumeReadable=c;function m(f,s,i){const n=[];let t;for(;(t=f.read())!==null&&n.length<i;)n.push(t);return t===null&&n.length>0?s(n):{read:()=>{if(n.length>0)return n.shift();if(typeof t<"u"){const r=t;return t=void 0,r}return f.read()}}}e.peekReadable=m;function y(f,s){return new Promise((i,n)=>{const t=[];p(f,{onData:r=>{s&&t.push(r)},onError:r=>{s?n(r):i(void 0)},onEnd:()=>{i(s?s(t):void 0)}})})}e.consumeStream=y;function p(f,s){let i=!1;return f.on("error",n=>{i||s.onError(n)}),f.on("end",()=>{i||s.onEnd()}),f.on("data",n=>{i||s.onData(n)}),(0,D.toDisposable)(()=>i=!0)}e.listenStream=p;function I(f,s){return new Promise((i,n)=>{const t=new D.DisposableStore,r=[],o=h=>{if(r.push(h),r.length>s)return t.dispose(),f.pause(),i({stream:f,buffer:r,ended:!1})},u=h=>n(h),a=()=>i({stream:f,buffer:r,ended:!0});t.add((0,D.toDisposable)(()=>f.removeListener("error",u))),f.on("error",u),t.add((0,D.toDisposable)(()=>f.removeListener("end",a))),f.on("end",a),t.add((0,D.toDisposable)(()=>f.removeListener("data",o))),f.on("data",o)})}e.peekStream=I;function w(f,s){const i=P(s);return i.end(f),i}e.toStream=w;function S(){const f=P(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=S;function E(f){let s=!1;return{read:()=>s?null:(s=!0,f)}}e.toReadable=E;function l(f,s,i){const n=P(i);return p(f,{onData:t=>n.write(s.data(t)),onError:t=>n.error(s.error?s.error(t):t),onEnd:()=>n.end()}),n}e.transform=l;function g(f,s,i){let n=!1;return{read:()=>{const t=s.read();return n?t:(n=!0,t!==null?i([f,t]):f)}}}e.prefixedReadable=g;function v(f,s,i){let n=!1;const t=P(i);return p(s,{onData:r=>n?t.write(r):(n=!0,t.write(i([f,r]))),onError:r=>t.error(r),onEnd:()=>{n||(n=!0,t.write(f)),t.end()}}),t}e.prefixedStream=v}),define(Y[15],Z([0,1,43]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const D=typeof Buffer<"u";let k,L;class N{static alloc(h){return D?new N(Buffer.allocUnsafe(h)):new N(new Uint8Array(h))}static wrap(h){return D&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new N(h)}static fromString(h,O){return!(O?.dontUseNodeBuffer||!1)&&D?new N(Buffer.from(h)):(k||(k=new TextEncoder),new N(k.encode(h)))}static fromByteArray(h){const O=N.alloc(h.length);for(let j=0,x=h.length;j<x;j++)O.buffer[j]=h[j];return O}static concat(h,O){if(typeof O>"u"){O=0;for(let K=0,X=h.length;K<X;K++)O+=h[K].byteLength}const j=N.alloc(O);let x=0;for(let K=0,X=h.length;K<X;K++){const ie=h[K];j.set(ie,x),x+=ie.byteLength}return j}constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}clone(){const h=N.alloc(this.byteLength);return h.set(this),h}toString(){return D?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(h,O){return new N(this.buffer.subarray(h,O))}set(h,O){if(h instanceof N)this.buffer.set(h.buffer,O);else if(h instanceof Uint8Array)this.buffer.set(h,O);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),O);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),O);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return c(this.buffer,h)}writeUInt32BE(h,O){m(this.buffer,h,O)}readUInt32LE(h){return y(this.buffer,h)}writeUInt32LE(h,O){p(this.buffer,h,O)}readUInt8(h){return I(this.buffer,h)}writeUInt8(h,O){w(this.buffer,h,O)}}e.VSBuffer=N;function P(a,h){return a[h+0]<<0>>>0|a[h+1]<<8>>>0}e.readUInt16LE=P;function d(a,h,O){a[O+0]=h&255,h=h>>>8,a[O+1]=h&255}e.writeUInt16LE=d;function c(a,h){return a[h]*2**24+a[h+1]*2**16+a[h+2]*2**8+a[h+3]}e.readUInt32BE=c;function m(a,h,O){a[O+3]=h,h=h>>>8,a[O+2]=h,h=h>>>8,a[O+1]=h,h=h>>>8,a[O]=h}e.writeUInt32BE=m;function y(a,h){return a[h+0]<<0>>>0|a[h+1]<<8>>>0|a[h+2]<<16>>>0|a[h+3]<<24>>>0}e.readUInt32LE=y;function p(a,h,O){a[O+0]=h&255,h=h>>>8,a[O+1]=h&255,h=h>>>8,a[O+2]=h&255,h=h>>>8,a[O+3]=h&255}e.writeUInt32LE=p;function I(a,h){return a[h]}e.readUInt8=I;function w(a,h,O){a[O]=h}e.writeUInt8=w;function S(a){return T.consumeReadable(a,h=>N.concat(h))}e.readableToBuffer=S;function E(a){return T.toReadable(a)}e.bufferToReadable=E;function l(a){return T.consumeStream(a,h=>N.concat(h))}e.streamToBuffer=l;async function g(a){return a.ended?N.concat(a.buffer):N.concat([...a.buffer,await l(a.stream)])}e.bufferedStreamToBuffer=g;function v(a){return T.toStream(a,h=>N.concat(h))}e.bufferToStream=v;function f(a){return T.transform(a,{data:h=>typeof h=="string"?N.fromString(h):N.wrap(h)},h=>N.concat(h))}e.streamToBufferReadableStream=f;function s(a){return T.newWriteableStream(h=>N.concat(h),a)}e.newWriteableBufferStream=s;function i(a,h){return T.prefixedReadable(a,h,O=>N.concat(O))}e.prefixedBufferReadable=i;function n(a,h){return T.prefixedStream(a,h,O=>N.concat(O))}e.prefixedBufferStream=n;function t(a){let h=0,O=0,j=0;const x=new Uint8Array(Math.floor(a.length/4*3)),K=ie=>{switch(O){case 3:x[j++]=h|ie,O=0;break;case 2:x[j++]=h|ie>>>2,h=ie<<6,O=3;break;case 1:x[j++]=h|ie>>>4,h=ie<<4,O=2;break;default:h=ie<<2,O=1}};for(let ie=0;ie<a.length;ie++){const ne=a.charCodeAt(ie);if(ne>=65&&ne<=90)K(ne-65);else if(ne>=97&&ne<=122)K(ne-97+26);else if(ne>=48&&ne<=57)K(ne-48+52);else if(ne===43||ne===45)K(62);else if(ne===47||ne===95)K(63);else{if(ne===61)break;throw new SyntaxError(`Unexpected base64 character ${a[ie]}`)}}const X=j;for(;O>0;)K(0);return N.wrap(x).slice(0,X)}e.decodeBase64=t;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:a},h=!0,O=!1){const j=O?o:r;let x="";const K=a.byteLength%3;let X=0;for(;X<a.byteLength-K;X+=3){const ie=a[X+0],ne=a[X+1],Q=a[X+2];x+=j[ie>>>2],x+=j[(ie<<4|ne>>>4)&63],x+=j[(ne<<2|Q>>>6)&63],x+=j[Q&63]}if(K===1){const ie=a[X+0];x+=j[ie>>>2],x+=j[ie<<4&63],h&&(x+="==")}else if(K===2){const ie=a[X+0],ne=a[X+1];x+=j[ie>>>2],x+=j[(ie<<4|ne>>>4)&63],x+=j[ne<<2&63],h&&(x+="=")}return x}e.encodeBase64=u}),define(Y[29],Z([0,1,5]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function D(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const g=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([v,f])=>{g[v]=f&&typeof f=="object"?D(f):f}),g}e.deepClone=D;function k(l){if(!l||typeof l!="object")return l;const g=[l];for(;g.length>0;){const v=g.shift();Object.freeze(v);for(const f in v)if(L.call(v,f)){const s=v[f];typeof s=="object"&&!Object.isFrozen(s)&&!(0,T.isTypedArray)(s)&&g.push(s)}}return l}e.deepFreeze=k;const L=Object.prototype.hasOwnProperty;function N(l,g){return P(l,g,new Set)}e.cloneAndChange=N;function P(l,g,v){if((0,T.isUndefinedOrNull)(l))return l;const f=g(l);if(typeof f<"u")return f;if(Array.isArray(l)){const s=[];for(const i of l)s.push(P(i,g,v));return s}if((0,T.isObject)(l)){if(v.has(l))throw new Error("Cannot clone recursive data-structure");v.add(l);const s={};for(const i in l)L.call(l,i)&&(s[i]=P(l[i],g,v));return v.delete(l),s}return l}function d(l,g,v=!0){return(0,T.isObject)(l)?((0,T.isObject)(g)&&Object.keys(g).forEach(f=>{f in l?v&&((0,T.isObject)(l[f])&&(0,T.isObject)(g[f])?d(l[f],g[f],v):l[f]=g[f]):l[f]=g[f]}),l):g}e.mixin=d;function c(l,g){if(l===g)return!0;if(l==null||g===null||g===void 0||typeof l!=typeof g||typeof l!="object"||Array.isArray(l)!==Array.isArray(g))return!1;let v,f;if(Array.isArray(l)){if(l.length!==g.length)return!1;for(v=0;v<l.length;v++)if(!c(l[v],g[v]))return!1}else{const s=[];for(f in l)s.push(f);s.sort();const i=[];for(f in g)i.push(f);if(i.sort(),!c(s,i))return!1;for(v=0;v<s.length;v++)if(!c(l[s[v]],g[s[v]]))return!1}return!0}e.equals=c;function m(l){const g=new Set;return JSON.stringify(l,(v,f)=>{if((0,T.isObject)(f)||Array.isArray(f)){if(g.has(f))return"[Circular]";g.add(f)}return f})}e.safeStringify=m;function y(l,g){const v=Object.create(null);return!l||!g||Object.keys(g).forEach(s=>{const i=l[s],n=g[s];c(i,n)||(v[s]=n)}),v}e.distinct=y;function p(l,g){const v=g.toLowerCase(),f=Object.keys(l).find(s=>s.toLowerCase()===v);return f?l[f]:l[g]}e.getCaseInsensitive=p;function I(l,g){const v=Object.create(null);for(const[f,s]of Object.entries(l))g(f,s)&&(v[f]=s);return v}e.filter=I;function w(l){let g=[],v=Object.getPrototypeOf(l);for(;Object.prototype!==v;)g=g.concat(Object.getOwnPropertyNames(v)),v=Object.getPrototypeOf(v);return g}e.getAllPropertyNames=w;function S(l){const g=[];for(const v of w(l))typeof l[v]=="function"&&g.push(v);return g}e.getAllMethodNames=S;function E(l,g){const v=s=>function(){const i=Array.prototype.slice.call(arguments,0);return g(s,i)},f={};for(const s of l)f[s]=v(s);return f}e.createProxyObject=E}),define(Y[30],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const T=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(k){return T.test(k)}e.isUUID=D,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(P){for(let d=0;d<P.length;d++)P[d]=Math.floor(Math.random()*256);return P};const L=new Uint8Array(16),N=[];for(let P=0;P<256;P++)N.push(P.toString(16).padStart(2,"0"));return function(){k(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let d=0,c="";return c+=N[L[d++]],c+=N[L[d++]],c+=N[L[d++]],c+=N[L[d++]],c+="-",c+=N[L[d++]],c+=N[L[d++]],c+="-",c+=N[L[d++]],c+=N[L[d++]],c+="-",c+=N[L[d++]],c+=N[L[d++]],c+="-",c+=N[L[d++]],c+=N[L[d++]],c+=N[L[d++]],c+=N[L[d++]],c+=N[L[d++]],c+=N[L[d++]],c}}()}),define(Y[72],Z([0,1,33]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const D=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(N){const P=N.replace(/\-/g,":").toLowerCase();return!D.has(P)}function L(){const N=(0,T.networkInterfaces)();for(const P in N){const d=N[P];if(d){for(const{mac:c}of d)if(k(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=L}),define(Y[73],Z([6,7]),function($,e){return $.create("vs/base/common/date",e)}),define(Y[74],Z([0,1,73]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const D=60,k=D*60,L=k*24,N=L*7,P=L*30,d=L*365;function c(y,p,I){typeof y!="number"&&(y=y.getTime());const w=Math.round((new Date().getTime()-y)/1e3);if(w<-30)return(0,T.localize)(0,null,c(new Date().getTime()+w*1e3,!1));if(w<30)return(0,T.localize)(1,null);let S;return w<D?(S=w,p?S===1?I?(0,T.localize)(2,null,S):(0,T.localize)(3,null,S):I?(0,T.localize)(4,null,S):(0,T.localize)(5,null,S):S===1?I?(0,T.localize)(6,null,S):(0,T.localize)(7,null,S):I?(0,T.localize)(8,null,S):(0,T.localize)(9,null,S)):w<k?(S=Math.floor(w/D),p?S===1?I?(0,T.localize)(10,null,S):(0,T.localize)(11,null,S):I?(0,T.localize)(12,null,S):(0,T.localize)(13,null,S):S===1?I?(0,T.localize)(14,null,S):(0,T.localize)(15,null,S):I?(0,T.localize)(16,null,S):(0,T.localize)(17,null,S)):w<L?(S=Math.floor(w/k),p?S===1?I?(0,T.localize)(18,null,S):(0,T.localize)(19,null,S):I?(0,T.localize)(20,null,S):(0,T.localize)(21,null,S):S===1?I?(0,T.localize)(22,null,S):(0,T.localize)(23,null,S):I?(0,T.localize)(24,null,S):(0,T.localize)(25,null,S)):w<N?(S=Math.floor(w/L),p?S===1?(0,T.localize)(26,null,S):(0,T.localize)(27,null,S):S===1?(0,T.localize)(28,null,S):(0,T.localize)(29,null,S)):w<P?(S=Math.floor(w/N),p?S===1?I?(0,T.localize)(30,null,S):(0,T.localize)(31,null,S):I?(0,T.localize)(32,null,S):(0,T.localize)(33,null,S):S===1?I?(0,T.localize)(34,null,S):(0,T.localize)(35,null,S):I?(0,T.localize)(36,null,S):(0,T.localize)(37,null,S)):w<d?(S=Math.floor(w/P),p?S===1?I?(0,T.localize)(38,null,S):(0,T.localize)(39,null,S):I?(0,T.localize)(40,null,S):(0,T.localize)(41,null,S):S===1?I?(0,T.localize)(42,null,S):(0,T.localize)(43,null,S):I?(0,T.localize)(44,null,S):(0,T.localize)(45,null,S)):(S=Math.floor(w/d),p?S===1?I?(0,T.localize)(46,null,S):(0,T.localize)(47,null,S):I?(0,T.localize)(48,null,S):(0,T.localize)(49,null,S):S===1?I?(0,T.localize)(50,null,S):(0,T.localize)(51,null,S):I?(0,T.localize)(52,null,S):(0,T.localize)(53,null,S))}e.fromNow=c;function m(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=m}),define(Y[75],Z([6,7]),function($,e){return $.create("vs/base/common/errorMessage",e)}),define(Y[34],Z([0,1,19,5,75]),function($,e,T,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function L(y,p){return p&&(y.stack||y.stacktrace)?k.localize(0,null,P(y),N(y.stack)||N(y.stacktrace)):P(y)}function N(y){return Array.isArray(y)?y.join(`
`):y}function P(y){return typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?k.localize(1,null,y.message):y.message||k.localize(2,null)}function d(y=null,p=!1){if(!y)return k.localize(3,null);if(Array.isArray(y)){const I=T.coalesce(y),w=d(I[0],p);return I.length>1?k.localize(4,null,w,I.length):w}if(D.isString(y))return y;if(y.detail){const I=y.detail;if(I.error)return L(I.error,p);if(I.exception)return L(I.exception,p)}return y.stack?L(y,p):y.message?y.message:k.localize(5,null)}e.toErrorMessage=d;function c(y){const p=y;return p instanceof Error&&Array.isArray(p.actions)}e.isErrorWithActions=c;function m(y,p){let I;return typeof y=="string"?I=new Error(y):I=y,I.actions=p,I}e.createErrorWithActions=m}),define(Y[76],Z([6,7]),function($,e){return $.create("vs/base/common/jsonErrorMessages",e)}),define(Y[77],Z([0,1,76]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function D(k){switch(k){case 1:return(0,T.localize)(0,null);case 2:return(0,T.localize)(1,null);case 3:return(0,T.localize)(2,null);case 4:return(0,T.localize)(3,null);case 5:return(0,T.localize)(4,null);case 6:return(0,T.localize)(5,null);case 7:return(0,T.localize)(6,null);case 8:return(0,T.localize)(7,null);case 9:return(0,T.localize)(8,null);default:return""}}e.getParseErrorMessage=D}),define(Y[51],Z([0,1,12]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var D;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(D=e.Source||(e.Source={}));var k;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function L(P,...d){const c=d.reduce((p,I)=>(p[I]=!0,p),{}),m=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(p=>!c[p]).forEach(p=>{for(let I=0;I<m.length;I++)if(p.search(m[I])!==-1){delete P[p];break}})}e.sanitizeProcessEnvironment=L;function N(P){!P||(delete P.DEBUG,T.isMacintosh&&delete P.DYLD_LIBRARY_PATH,T.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=N}),define(Y[52],Z([0,1,31]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function D(l){return k(l,0)}e.hash=D;function k(l,g){switch(typeof l){case"object":return l===null?L(349,g):Array.isArray(l)?d(l,g):c(l,g);case"string":return P(l,g);case"boolean":return N(l,g);case"number":return L(l,g);case"undefined":return L(937,g);default:return L(617,g)}}e.doHash=k;function L(l,g){return(g<<5)-g+l|0}e.numberHash=L;function N(l,g){return L(l?433:863,g)}function P(l,g){g=L(149417,g);for(let v=0,f=l.length;v<f;v++)g=L(l.charCodeAt(v),g);return g}e.stringHash=P;function d(l,g){return g=L(104579,g),l.reduce((v,f)=>k(f,v),g)}function c(l,g){return g=L(181387,g),Object.keys(l).sort().reduce((v,f)=>(v=P(f,v),k(l[f],v)),g)}class m{constructor(){this.g=0}get value(){return this.g}hash(g){return this.g=k(g,this.g),this.g}}e.Hasher=m;var y;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function p(l,g,v=32){const f=v-g,s=~((1<<f)-1);return(l<<g|(s&l)>>>f)>>>0}function I(l,g=0,v=l.byteLength,f=0){for(let s=0;s<v;s++)l[g+s]=f}function w(l,g,v="0"){for(;l.length<g;)l=v+l;return l}function S(l,g=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(v=>v.toString(16).padStart(2,"0")).join(""):w((l>>>0).toString(16),g/4)}e.toHexString=S;class E{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(g){const v=g.length;if(v===0)return;const f=this.p;let s=this.r,i=this.u,n,t;for(i!==0?(n=i,t=-1,i=0):(n=g.charCodeAt(0),t=0);;){let r=n;if(T.isHighSurrogate(n))if(t+1<v){const o=g.charCodeAt(t+1);T.isLowSurrogate(o)?(t++,r=T.computeCodePoint(n,o)):r=65533}else{i=n;break}else T.isLowSurrogate(n)&&(r=65533);if(s=this.w(f,s,r),t++,t<v)n=g.charCodeAt(t);else break}this.r=s,this.u=i}w(g,v,f){return f<128?g[v++]=f:f<2048?(g[v++]=192|(f&1984)>>>6,g[v++]=128|(f&63)>>>0):f<65536?(g[v++]=224|(f&61440)>>>12,g[v++]=128|(f&4032)>>>6,g[v++]=128|(f&63)>>>0):(g[v++]=240|(f&1835008)>>>18,g[v++]=128|(f&258048)>>>12,g[v++]=128|(f&4032)>>>6,g[v++]=128|(f&63)>>>0),v>=64&&(this.y(),v-=64,this.t+=64,g[0]=g[64+0],g[1]=g[64+1],g[2]=g[64+2]),v}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),S(this.h)+S(this.l)+S(this.m)+S(this.n)+S(this.o)}x(){this.p[this.r++]=128,I(this.p,this.r),this.r>56&&(this.y(),I(this.p));const g=8*this.t;this.q.setUint32(56,Math.floor(g/4294967296),!1),this.q.setUint32(60,g%4294967296,!1),this.y()}y(){const g=E.g,v=this.q;for(let a=0;a<64;a+=4)g.setUint32(a,v.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)g.setUint32(a,p(g.getUint32(a-12,!1)^g.getUint32(a-32,!1)^g.getUint32(a-56,!1)^g.getUint32(a-64,!1),1),!1);let f=this.h,s=this.l,i=this.m,n=this.n,t=this.o,r,o,u;for(let a=0;a<80;a++)a<20?(r=s&i|~s&n,o=1518500249):a<40?(r=s^i^n,o=1859775393):a<60?(r=s&i|s&n|i&n,o=2400959708):(r=s^i^n,o=3395469782),u=p(f,5)+r+t+o+g.getUint32(a*4,!1)&4294967295,t=n,n=i,i=p(s,30),s=f,f=u;this.h=this.h+f&4294967295,this.l=this.l+s&4294967295,this.m=this.m+i&4294967295,this.n=this.n+n&4294967295,this.o=this.o+t&4294967295}}e.StringSHA1=E,E.g=new DataView(new ArrayBuffer(320))}),define(Y[53],Z([0,1,31]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var D;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(D||(D={})),function(k){const L="error",N="warning",P="warn",d="info",c="ignore";function m(p){return p?T.equalsIgnoreCase(L,p)?k.Error:T.equalsIgnoreCase(N,p)||T.equalsIgnoreCase(P,p)?k.Warning:T.equalsIgnoreCase(d,p)?k.Info:k.Ignore:k.Ignore}k.fromValue=m;function y(p){switch(p){case k.Error:return L;case k.Warning:return N;case k.Info:return d;default:return c}}k.toString=y}(D||(D={})),e.default=D}),define(Y[78],Z([0,1,11]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function D(c){const m=c;return m&&typeof m.type=="string"&&typeof m.severity=="string"}e.isRemoteConsoleLog=D;function k(c){const m=[];let y;try{const p=JSON.parse(c.arguments),I=p[p.length-1];I&&I.__$stack&&(p.pop(),y=I.__$stack),m.push(...p)}catch{m.push("Unable to log remote console arguments",c.arguments)}return{args:m,stack:y}}e.parse=k;function L(c){if(typeof c!="string")return L(k(c).stack);const m=c;if(m){const y=N(m),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(p&&p.length===4)return{uri:T.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.getFirstFrame=L;function N(c){if(!c)return c;const m=c.indexOf(`
`);return m===-1?c:c.substring(0,m)}function P(c,m){const{args:y,stack:p}=k(c),I=typeof y[0]=="string"&&y.length===1;let w=N(p);w&&(w=`(${w.trim()})`);let S=[];if(typeof y[0]=="string"?w&&I?S=[`%c[${m}] %c${y[0]} %c${w}`,d("blue"),d(""),d("grey")]:S=[`%c[${m}] %c${y[0]}`,d("blue"),d(""),...y.slice(1)]:S=[`%c[${m}]%`,d("blue"),...y],w&&!I&&S.push(w),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,S)}e.log=P;function d(c){return`color: ${c}`}}),define(Y[44],Z([0,1,15,31,11]),function($,e,T,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(c){return JSON.stringify(c,P)}e.stringify=L;function N(c){let m=JSON.parse(c);return m=d(m),m}e.parse=N;function P(c,m){return m instanceof RegExp?{$mid:2,source:m.source,flags:(0,D.regExpFlags)(m)}:m}function d(c,m=0){if(!c||m>200)return c;if(typeof c=="object"){switch(c.$mid){case 1:return k.URI.revive(c);case 2:return new RegExp(c.source,c.flags);case 16:return new Date(c.source)}if(c instanceof T.VSBuffer||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let y=0;y<c.length;++y)c[y]=d(c[y],m+1);else for(const y in c)Object.hasOwnProperty.call(c,y)&&(c[y]=d(c[y],m+1))}return c}e.revive=d}),define(Y[79],Z([0,1,33,10,54,30,72]),function($,e,T,D,k,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(m){return this.a||(this.a=k.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(m)}value(){if(this.b===void 0){let m=0,y=0;const p=(0,T.networkInterfaces)();for(const I in p){const w=p[I];if(w)for(const{mac:S,internal:E}of w)E||(y+=1,this.c(S.toUpperCase())&&(m+=1))}this.b=y>0?m/y:0}return this.b}};let P;async function d(){return P||(P=(async()=>await c()||L.generateUuid())()),P}e.getMachineId=d;async function c(){try{const m=await new Promise((p,I)=>{$(["crypto"],p,I)}),y=(0,N.getMac)();return m.createHash("sha256").update(y,"utf8").digest("hex")}catch(m){D.onUnexpectedError(m);return}}}),define(Y[80],Z([0,1,33,14,20]),function($,e,T,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const L=/^\d+$/,N=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var d;(function(f){f[f.x64=0]="x64",f[f.x86=1]="x86",f[f.ARM=2]="ARM"})(d||(d={}));let c;switch(process.arch){case"ia32":case"x32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let m;process.env.PROCESSOR_ARCHITEW6432?m=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?m=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?m=1:m=0;class y{constructor(s,i,n){this.exePath=s,this.displayName=i,this.a=n}async exists(){return this.a===void 0&&(this.a=await k.SymlinkSupport.existsFile(this.exePath)),this.a}}function p({useAlternateBitness:f=!1}={}){return f?c===0?process.env["ProgramFiles(x86)"]||null:m===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function I({useAlternateBitness:f=!1,findPreview:s=!1}={}){const i=p({useAlternateBitness:f});if(!i)return null;const n=D.join(i,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(n))return null;let t=-1,r=null;for(const a of await k.Promises.readdir(n)){let h=-1;if(s){const j=a.indexOf("-");if(j<0)continue;const x=a.substring(0,j);if(!L.test(x)||a.substring(j+1)!=="preview")continue;h=parseInt(x,10)}else{if(!L.test(a))continue;h=parseInt(a,10)}if(h<=t)continue;const O=D.join(n,a,"pwsh.exe");!await k.SymlinkSupport.existsFile(O)||(r=O,t=h)}if(!r)return null;const o=i.includes("x86")?" (x86)":"",u=s?" Preview":"";return new y(r,`PowerShell${u}${o}`,!0)}async function w({findPreview:f}={}){if(!process.env.LOCALAPPDATA)return null;const s=D.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:i,pwshMsixName:n}=f?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:N,pwshMsixName:"PowerShell (Store)"};for(const t of await k.Promises.readdir(s))if(i.test(t)){const r=D.join(s,t,"pwsh.exe");return new y(r,n)}return null}function S(){const f=D.join(T.homedir(),".dotnet","tools","pwsh.exe");return new y(f,".NET Core PowerShell Global Tool")}function E(){const f=D.join(process.env.windir,c===1&&m!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new y(f,"Windows PowerShell",!0)}async function*l(){let f=await I();f&&(yield f),f=await I({useAlternateBitness:!0}),f&&(yield f),f=await w(),f&&(yield f),f=S(),f&&(yield f),f=await I({findPreview:!0}),f&&(yield f),f=await w({findPreview:!0}),f&&(yield f),f=await I({useAlternateBitness:!0,findPreview:!0}),f&&(yield f),f=E(),f&&(yield f)}async function*g(){for await(const f of l())await f.exists()&&(yield f)}e.enumeratePowerShellInstallations=g;async function v(){for await(const f of g())return f;return null}e.getFirstAvailablePowerShellInstallation=v}),define(Y[55],Z([0,1,14,12,35,51,5,20]),function($,e,T,D,k,L,N,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function d(y=k.env){return y.comspec||"cmd.exe"}e.getWindowsShell=d;function c(y){let p=[],I=!1;const w=function(S){if(I){p.push(S);return}(!y.send(S,l=>{if(l&&console.error(l),I=!1,p.length>0){const g=p.slice(0);p=[],g.forEach(v=>w(v))}})||D.isWindows)&&(I=!0)};return{send:w}}e.createQueuedSender=c;var m;(function(y){async function p(I,w,S){if(T.isAbsolute(I))return I;if(w===void 0&&(w=k.cwd()),T.dirname(I)!=="."||(S===void 0&&N.isString(k.env.PATH)&&(S=k.env.PATH.split(T.delimiter)),S===void 0||S.length===0))return T.join(w,I);async function l(g){if(await P.Promises.exists(g)){let v;try{v=await P.Promises.stat(g)}catch(f){f.message.startsWith("EACCES")&&(v=await P.Promises.lstat(g))}return v?!v.isDirectory():!1}return!1}for(const g of S){let v;if(T.isAbsolute(g)?v=T.join(g,I):v=T.join(w,g,I),await l(v))return v;let f=v+".com";if(await l(f)||(f=v+".exe",await l(f)))return f}return T.join(w,I)}y.findExecutable=p})(m=e.win32||(e.win32={}))}),define(Y[81],Z([0,1,33,12,80,55]),function($,e,T,D,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function N(I,w){return I===1?D.isWindows?y():L.getWindowsShell(w):c(I,w)}e.getSystemShell=N;function P(I,w){return I===1?D.isWindows?p(w):L.getWindowsShell(w):c(I,w)}e.getSystemShellSync=P;let d=null;function c(I,w){if(D.isLinux&&I===2||D.isMacintosh&&I===3)return"/bin/bash";if(!d){let S;if(D.isWindows)S="/bin/bash";else{if(S=w.SHELL,!S)try{S=(0,T.userInfo)().shell}catch{}S||(S="sh"),S==="/bin/false"&&(S="/bin/bash")}d=S}return d}let m=null;async function y(){return m||(m=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),m}function p(I){if(m)return m;const w=D.isWindows&&parseFloat((0,T.release)())>=10,S=I.hasOwnProperty("PROCESSOR_ARCHITEW6432"),E=`${I.windir}\\${S?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return w?E:L.getWindowsShell(I)}});var de=this&&this.__decorate||function($,e,T,D){var k=arguments.length,L=k<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,T):D,N;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate($,e,T,D);else for(var P=$.length-1;P>=0;P--)(N=$[P])&&(L=(k<3?N(L):k>3?N(e,T,L):N(e,T))||L);return k>3&&L&&Object.defineProperty(e,T,L),L};define(Y[56],Z([0,1,19,3,15,22,49,10,4,2,44,31,5]),function($,e,T,D,k,L,N,P,d,c,m,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=void 0;var I;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(I||(I={}));function w(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var S;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(S||(S={}));function E(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(l||(l={}));class g{constructor(A){this.b=A,this.a=0}read(A){const U=this.b.slice(this.a,this.a+A);return this.a+=U.byteLength,U}}class v{constructor(){this.a=[]}get buffer(){return k.VSBuffer.concat(this.a)}write(A){this.a.push(A)}}var f;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object"})(f||(f={}));function s(M){const A=k.VSBuffer.alloc(4);return A.writeUInt32BE(M,0),A}function i(M){return M.read(4).readUInt32BE(0)}function n(M){const A=k.VSBuffer.alloc(1);return A.writeUInt8(M,0),A}const t={Undefined:n(f.Undefined),String:n(f.String),Buffer:n(f.Buffer),VSBuffer:n(f.VSBuffer),Array:n(f.Array),Object:n(f.Object)},r=typeof Buffer<"u";function o(M,A){if(typeof A>"u")M.write(t.Undefined);else if(typeof A=="string"){const U=k.VSBuffer.fromString(A);M.write(t.String),M.write(s(U.byteLength)),M.write(U)}else if(r&&Buffer.isBuffer(A)){const U=k.VSBuffer.wrap(A);M.write(t.Buffer),M.write(s(U.byteLength)),M.write(U)}else if(A instanceof k.VSBuffer)M.write(t.VSBuffer),M.write(s(A.byteLength)),M.write(A);else if(Array.isArray(A)){M.write(t.Array),M.write(s(A.length));for(const U of A)o(M,U)}else{const U=k.VSBuffer.fromString(JSON.stringify(A));M.write(t.Object),M.write(s(U.byteLength)),M.write(U)}}function u(M){switch(M.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return M.read(i(M)).toString();case f.Buffer:return M.read(i(M)).buffer;case f.VSBuffer:return M.read(i(M));case f.Array:{const U=i(M),V=[];for(let G=0;G<U;G++)V.push(u(M));return V}case f.Object:return JSON.parse(M.read(i(M)).toString())}}class a{constructor(A,U,V=null,G=1e3){this.h=A,this.j=U,this.k=V,this.l=G,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(q=>this.p(q)),this.m({type:200})}registerChannel(A,U){this.b.set(A,U),setTimeout(()=>this.v(A),0)}m(A){switch(A.type){case 200:{const U=this.n([A.type]);this.k?.logOutgoing(U,0,1,E(A.type));return}case 201:case 202:case 204:case 203:{const U=this.n([A.type,A.id],A.data);this.k?.logOutgoing(U,A.id,1,E(A.type),A.data);return}}}n(A,U=void 0){const V=new v;return o(V,A),o(V,U),this.o(V.buffer)}o(A){try{return this.h.send(A),A.byteLength}catch{return 0}}p(A){const U=new g(A),V=u(U),G=u(U),q=V[0];switch(q){case 100:return this.k?.logIncoming(A.byteLength,V[1],1,`${w(q)}: ${V[2]}.${V[3]}`,G),this.q({type:q,id:V[1],channelName:V[2],name:V[3],arg:G});case 102:return this.k?.logIncoming(A.byteLength,V[1],1,`${w(q)}: ${V[2]}.${V[3]}`,G),this.s({type:q,id:V[1],channelName:V[2],name:V[3],arg:G});case 101:return this.k?.logIncoming(A.byteLength,V[1],1,`${w(q)}`),this.t({type:q,id:V[1]});case 103:return this.k?.logIncoming(A.byteLength,V[1],1,`${w(q)}`),this.t({type:q,id:V[1]})}}q(A){const U=this.b.get(A.channelName);if(!U){this.u(A);return}const V=new L.CancellationTokenSource;let G;try{G=U.call(this.j,A.name,A.arg,V.token)}catch(b){G=Promise.reject(b)}const q=A.id;G.then(b=>{this.m({id:q,data:b,type:201}),this.d.delete(A.id)},b=>{b instanceof Error?this.m({id:q,data:{message:b.message,name:b.name,stack:b.stack?b.stack.split?b.stack.split(`
`):b.stack:void 0},type:202}):this.m({id:q,data:b,type:203}),this.d.delete(A.id)});const ee=(0,c.toDisposable)(()=>V.cancel());this.d.set(A.id,ee)}s(A){const U=this.b.get(A.channelName);if(!U){this.u(A);return}const V=A.id,q=U.listen(this.j,A.name,A.arg)(ee=>this.m({id:V,data:ee,type:204}));this.d.set(A.id,q)}t(A){const U=this.d.get(A.id);U&&(U.dispose(),this.d.delete(A.id))}u(A){let U=this.g.get(A.channelName);U||(U=[],this.g.set(A.channelName,U));const V=setTimeout(()=>{console.error(`Unknown channel: ${A.channelName}`),A.type===100&&this.m({id:A.id,data:{name:"Unknown channel",message:`Channel name '${A.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);U.push({request:A,timeoutTimer:V})}v(A){const U=this.g.get(A);if(U){for(const V of U)switch(clearTimeout(V.timeoutTimer),V.request.type){case 100:this.q(V.request);break;case 102:this.s(V.request);break}this.g.delete(A)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=a;var h;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));class O{constructor(A,U=null){this.l=A,this.a=!1,this.b=l.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new d.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(V=>this.r(V)),this.j=U}getChannel(A){const U=this;return{call(V,G,q){return U.a?Promise.reject(new P.CancellationError):U.m(A,V,G,q)},listen(V,G){return U.a?d.Event.None:U.n(A,V,G)}}}m(A,U,V,G=L.CancellationToken.None){const q=this.g++,b={id:q,type:100,channelName:A,name:U,arg:V};if(G.isCancellationRequested)return Promise.reject(new P.CancellationError);let R;return new Promise((F,B)=>{if(G.isCancellationRequested)return B(new P.CancellationError);const W=()=>{const ye=ae=>{switch(ae.type){case 201:this.f.delete(q),F(ae.data);break;case 202:{this.f.delete(q);const ue=new Error(ae.data.message);ue.stack=Array.isArray(ae.data.stack)?ae.data.stack.join(`
`):ae.data.stack,ue.name=ae.data.name,B(ue);break}case 203:this.f.delete(q),B(ae.data);break}};this.f.set(q,ye),this.o(b)};let te=null;this.b===l.Idle?W():(te=(0,D.createCancelablePromise)(ye=>this.t()),te.then(()=>{te=null,W()}));const se=()=>{te?(te.cancel(),te=null):this.o({id:q,type:101}),B(new P.CancellationError)},pe=G.onCancellationRequested(se);R=(0,c.combinedDisposable)((0,c.toDisposable)(se),pe),this.d.add(R)}).finally(()=>{this.d.delete(R)})}n(A,U,V){const G=this.g++,ee={id:G,type:102,channelName:A,name:U,arg:V};let b=null;const R=new d.Emitter({onWillAddFirstListener:()=>{b=(0,D.createCancelablePromise)(F=>this.t()),b.then(()=>{b=null,this.d.add(R),this.o(ee)})},onDidRemoveLastListener:()=>{b?(b.cancel(),b=null):(this.d.delete(R),this.o({id:G,type:103}))}}),C=F=>R.fire(F.data);return this.f.set(G,C),R.event}o(A){switch(A.type){case 100:case 102:{const U=this.p([A.type,A.id,A.channelName,A.name],A.arg);this.j?.logOutgoing(U,A.id,0,`${w(A.type)}: ${A.channelName}.${A.name}`,A.arg);return}case 101:case 103:{const U=this.p([A.type,A.id]);this.j?.logOutgoing(U,A.id,0,w(A.type));return}}}p(A,U=void 0){const V=new v;return o(V,A),o(V,U),this.q(V.buffer)}q(A){try{return this.l.send(A),A.byteLength}catch{return 0}}r(A){const U=new g(A),V=u(U),G=u(U),q=V[0];switch(q){case 200:return this.j?.logIncoming(A.byteLength,0,0,E(q)),this.s({type:V[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(A.byteLength,V[1],0,E(q),G),this.s({type:V[0],id:V[1],data:G})}}s(A){if(A.type===200){this.b=l.Idle,this.k.fire();return}this.f.get(A.id)?.(A)}get onDidInitializePromise(){return d.Event.toPromise(this.onDidInitialize)}t(){return this.b===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.dispose)(this.d.values()),this.d.clear()}}de([N.memoize],O.prototype,"onDidInitializePromise",null),e.ChannelClient=O;class j{get connections(){const A=[];return this.f.forEach(U=>A.push(U)),A}constructor(A){this.a=new Map,this.f=new Set,this.g=new d.Emitter,this.onDidAddConnection=this.g.event,this.h=new d.Emitter,this.onDidRemoveConnection=this.h.event,A(({protocol:U,onDidClientDisconnect:V})=>{d.Event.once(U.onMessage)(q=>{const ee=new g(q),b=u(ee),R=new a(U,b),C=new O(U);this.a.forEach((B,W)=>R.registerChannel(W,B));const F={channelServer:R,channelClient:C,ctx:b};this.f.add(F),this.g.fire(F),V(()=>{R.dispose(),C.dispose(),this.f.delete(F),this.h.fire(F)})})})}getChannel(A,U){const V=this;return{call(G,q,ee){let b;if((0,p.isFunction)(U)){const C=(0,T.getRandomElement)(V.connections.filter(U));b=C?Promise.resolve(C):d.Event.toPromise(d.Event.filter(V.onDidAddConnection,U))}else b=U.routeCall(V,G,q);const R=b.then(C=>C.channelClient.getChannel(A));return K(R).call(G,q,ee)},listen(G,q){if((0,p.isFunction)(U))return V.j(A,U,G,q);const ee=U.routeEvent(V,G,q).then(b=>b.channelClient.getChannel(A));return K(ee).listen(G,q)}}}j(A,U,V,G){const q=this;let ee=new c.DisposableStore;const b=new d.Emitter({onWillAddFirstListener:()=>{ee=new c.DisposableStore;const R=new d.EventMultiplexer,C=new Map,F=W=>{const se=W.channelClient.getChannel(A).listen(V,G),pe=R.add(se);C.set(W,pe)},B=W=>{const te=C.get(W);!te||(te.dispose(),C.delete(W))};q.connections.filter(U).forEach(F),d.Event.filter(q.onDidAddConnection,U)(F,void 0,ee),q.onDidRemoveConnection(B,void 0,ee),R.event(b.fire,b,ee),ee.add(R)},onDidRemoveLastListener:()=>{ee.dispose()}});return b.event}registerChannel(A,U){this.a.set(A,U),this.f.forEach(V=>{V.channelServer.registerChannel(A,U)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=j;class x{constructor(A,U,V=null){const G=new v;o(G,U),A.send(G.buffer),this.a=new O(A,V),this.d=new a(A,U,V)}getChannel(A){return this.a.getChannel(A)}registerChannel(A,U){this.d.registerChannel(A,U)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=x;function K(M){return{call(A,U,V){return M.then(G=>G.call(A,U,V))},listen(A,U){const V=new d.Relay;return M.then(G=>V.input=G.listen(A,U)),V.event}}}e.getDelayedChannel=K;function X(M){let A=!1;return{call(U,V,G){return A?M.call(U,V,G):(0,D.timeout)(0).then(()=>A=!0).then(()=>M.call(U,V,G))},listen(U,V){if(A)return M.listen(U,V);const G=new d.Relay;return(0,D.timeout)(0).then(()=>A=!0).then(()=>G.input=M.listen(U,V)),G.event}}}e.getNextTickChannel=X;class ie{constructor(A){this.a=A}routeCall(A){return this.b(A)}routeEvent(A){return this.b(A)}async b(A){for(const U of A.connections)if(await Promise.resolve(this.a(U.ctx)))return Promise.resolve(U);return await d.Event.toPromise(A.onDidAddConnection),await this.b(A)}}e.StaticRouter=ie;var ne;(function(M){function A(q,ee){const b=q,R=ee&&ee.disableMarshalling,C=new Map;for(const F in b)V(F)&&C.set(F,d.Event.buffer(b[F],!0));return new class{listen(F,B,W){const te=C.get(B);if(te)return te;if(G(B)){const se=b[B];if(typeof se=="function")return se.call(b,W)}throw new Error(`Event not found: ${B}`)}call(F,B,W){const te=b[B];if(typeof te=="function"){if(!R&&Array.isArray(W))for(let se=0;se<W.length;se++)W[se]=(0,m.revive)(W[se]);return te.apply(b,W)}throw new Error(`Method not found: ${B}`)}}}M.fromService=A;function U(q,ee){const b=ee&&ee.disableMarshalling;return new Proxy({},{get(R,C){if(typeof C=="string")return ee?.properties?.has(C)?ee.properties.get(C):G(C)?function(F){return q.listen(C,F)}:V(C)?q.listen(C):async function(...F){let B;ee&&!(0,p.isUndefinedOrNull)(ee.context)?B=[ee.context,...F]:B=F;const W=await q.call(C,B);return b?W:(0,m.revive)(W)};throw new Error(`Property not found: ${String(C)}`)}})}M.toService=U;function V(q){return q[0]==="o"&&q[1]==="n"&&y.isUpperAsciiLetter(q.charCodeAt(2))}function G(q){return/^onDynamic/.test(q)&&y.isUpperAsciiLetter(q.charCodeAt(9))}})(ne=e.ProxyChannel||(e.ProxyChannel={}));const Q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ge(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){const A=M.toString();if(A!=="[object Object]")return A}return M}function ce(M){return Array.isArray(M)?M.map(ge):ge(M)}function re(M,A,U,V,G,q,ee){ee=ce(ee);const b=Q[G],R=b[V%b.length];let C=[`%c[${M}]%c[${String(A).padStart(7," ")}]%c[len: ${String(U).padStart(5," ")}]%c${String(V).padStart(5," ")} - ${q}`,"color: darkgreen","color: grey","color: grey",`color: ${R}`];/\($/.test(q)?(C=C.concat(ee),C.push(")")):C.push(ee),console.log.apply(console,C)}class me{constructor(A,U){this.d=A,this.f=U,this.a=0,this.b=0}logOutgoing(A,U,V,G,q){this.b+=A,re(this.d,this.b,A,U,V,G,q)}logIncoming(A,U,V,G,q){this.a+=A,re(this.f,this.a,A,U,V,G,q)}}e.IPCLogger=me}),define(Y[82],Z([0,1,57,3,15,22,78,10,4,2,29,55,51,56]),function($,e,T,D,k,L,N,P,d,c,m,y,p,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class w extends I.ChannelServer{constructor(l){super({send:g=>{try{process.send?.(g.buffer.toString("base64"))}catch{}},onMessage:d.Event.fromNodeEventEmitter(process,"message",g=>k.VSBuffer.wrap(Buffer.from(g,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.Server=w;class S{constructor(l,g){this.i=l,this.j=g,this.c=new Set,this.g=new Map,this.h=new d.Emitter,this.onDidProcessExit=this.h.event;const v=g&&g.timeout?g.timeout:6e4;this.b=new D.Delayer(v),this.d=null,this.f=null}getChannel(l){const g=this;return{call(v,f,s){return g.k(l,v,f,s)},listen(v,f){return g.l(l,v,f)}}}k(l,g,v,f=L.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(P.canceled());this.b.cancel();const s=this.n(l),i=(0,D.createCancelablePromise)(r=>s.call(g,v,r)),n=f.onCancellationRequested(()=>i.cancel()),t=(0,c.toDisposable)(()=>i.cancel());return this.c.add(t),i.finally(()=>{n.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(l,g,v){if(!this.b)return d.Event.None;this.b.cancel();let f;const s=new d.Emitter({onWillAddFirstListener:()=>{f=this.n(l).listen(g,v)(s.fire,s),this.c.add(f)},onDidRemoveLastListener:()=>{this.c.delete(f),f.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return s.event}get m(){if(!this.f){const l=this.j&&this.j.args?this.j.args:[],g=Object.create(null);g.env={...(0,m.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(g.env={...g.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(g.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,p.removeDangerousEnvVariables)(g.env),this.d=(0,T.fork)(this.i,l,g);const v=new d.Emitter;d.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,N.isRemoteConsoleLog)(o)){(0,N.log)(o,`IPC Library: ${this.j.serverName}`);return}v.fire(k.VSBuffer.wrap(Buffer.from(o,"base64")))});const s=this.j.useQueue?(0,y.createQueuedSender)(this.d):this.d,i=o=>this.d&&this.d.connected&&s.send(o.buffer.toString("base64")),n=v.event,t={send:i,onMessage:n};this.f=new I.ChannelClient(t);const r=()=>this.o();process.once("exit",r),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,u)=>{process.removeListener("exit",r),this.c.forEach(a=>(0,c.dispose)(a)),this.c.clear(),o!==0&&u!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+u),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:u})})}return this.f}n(l){let g=this.g.get(l);return g||(g=this.m.getChannel(l),this.g.set(l,g)),g}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=S}),define(Y[83],Z([0,1,3,4,2,5]),function($,e,T,D,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var N;(function(y){y[y.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",y[y.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(N=e.StorageHint||(e.StorageHint={}));function P(y){const p=y;return p?.changed instanceof Map||p?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var d;(function(y){y[y.None=0]="None",y[y.Initialized=1]="Initialized",y[y.Closed=2]="Closed"})(d=e.StorageState||(e.StorageState={}));class c extends k.Disposable{constructor(p,I=Object.create(null)){super(),this.m=p,this.n=I,this.b=this.B(new D.Emitter),this.onDidChangeStorage=this.b.event,this.c=d.None,this.f=new Map,this.g=new T.ThrottledDelayer(c.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(p=>this.r(p)))}r(p){p.changed?.forEach((I,w)=>this.s(w,I)),p.deleted?.forEach(I=>this.s(I,void 0))}s(p,I){if(this.c===d.Closed)return;let w=!1;(0,L.isUndefinedOrNull)(I)?w=this.f.delete(p):this.f.get(p)!==I&&(this.f.set(p,I),w=!0),w&&this.b.fire(p)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===d.None&&(this.c=d.Initialized,this.n.hint!==N.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(p,I){const w=this.f.get(p);return(0,L.isUndefinedOrNull)(w)?I:w}getBoolean(p,I){const w=this.get(p);return(0,L.isUndefinedOrNull)(w)?I:w==="true"}getNumber(p,I){const w=this.get(p);return(0,L.isUndefinedOrNull)(w)?I:parseInt(w,10)}async set(p,I){if(this.c===d.Closed)return;if((0,L.isUndefinedOrNull)(I))return this.delete(p);const w=String(I);if(this.f.get(p)!==w)return this.f.set(p,w),this.j.set(p,w),this.h.delete(p),this.b.fire(p),this.w()}async delete(p){if(!(this.c===d.Closed||!this.f.delete(p)))return this.h.has(p)||this.h.add(p),this.j.delete(p),this.b.fire(p),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=d.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const p={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(p).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(p){if(!!this.u)return this.w(p)}async w(p){return this.g.trigger(()=>this.v(),p)}async whenFlushed(){if(!!this.u)return new Promise(p=>this.l.push(p))}isInMemory(){return this.n.hint===N.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.Storage=c,c.a=100;class m{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(p){p.insert?.forEach((I,w)=>this.a.set(w,I)),p.delete?.forEach(I=>this.a.delete(I))}async close(){}}e.InMemoryStorageDatabase=m}),define(Y[84],Z([6,7]),function($,e){return $.create("vs/base/node/zip",e)}),define(Y[85],Z([6,7]),function($,e){return $.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Y[86],Z([6,7]),function($,e){return $.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(Y[87],Z([6,7]),function($,e){return $.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Y[88],Z([6,7]),function($,e){return $.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(Y[89],Z([6,7]),function($,e){return $.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(Y[90],Z([6,7]),function($,e){return $.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(Y[91],Z([6,7]),function($,e){return $.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Y[92],Z([6,7]),function($,e){return $.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Y[93],Z([6,7]),function($,e){return $.create("vs/platform/extensions/common/extensionValidator",e)}),define(Y[94],Z([6,7]),function($,e){return $.create("vs/platform/files/common/fileService",e)}),define(Y[95],Z([6,7]),function($,e){return $.create("vs/platform/files/common/io",e)}),define(Y[96],Z([6,7]),function($,e){return $.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Y[97],Z([6,7]),function($,e){return $.create("vs/platform/languagePacks/common/languagePacks",e)}),define(Y[98],Z([6,7]),function($,e){return $.create("vs/platform/request/common/request",e)}),define(Y[99],Z([6,7]),function($,e){return $.create("vs/platform/shell/node/shellEnv",e)}),define(Y[100],Z([6,7]),function($,e){return $.create("vs/platform/telemetry/common/telemetryService",e)}),define(Y[101],Z([6,7]),function($,e){return $.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Y[102],Z([6,7]),function($,e){return $.create("vs/platform/workspace/common/workspace",e)}),define(Y[103],Z([0,1,74,49,16,14,35,17,11]),function($,e,T,D,k,L,N,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class c{get appRoot(){return(0,L.dirname)(k.FileAccess.asFileUri("").fsPath)}get userHome(){return d.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return d.URI.file((0,L.join)(this.userDataPath,"User"))}get tmpDir(){return d.URI.file(this.b.tmpDir)}get cacheHome(){return d.URI.file(this.userDataPath)}get stateResource(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const S=(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.join)(this.userDataPath,"logs",S)}return this.args.logsPath}get userDataSyncLogResource(){return d.URI.file((0,L.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return d.URI.file((0,L.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(d.URI.file((0,L.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const S=N.env.VSCODE_PORTABLE;return S?d.URI.file((0,L.join)(S,"argv.json")):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return d.URI.file((0,L.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,L.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const S=this.args["builtin-extensions-dir"];return S?(0,L.resolve)(S):(0,L.normalize)((0,L.join)(k.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const S=this.args["extensions-download-dir"];return S?d.URI.file((0,L.resolve)(S)):d.URI.file((0,L.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const S=this.args["extensions-dir"];if(S)return(0,L.resolve)(S);const E=N.env.VSCODE_EXTENSIONS;if(E)return E;const l=N.env.VSCODE_PORTABLE;return l?(0,L.join)(l,"extensions"):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const S=this.args.extensionDevelopmentPath;if(Array.isArray(S))return S.map(E=>/^[^:/?#]+?:\/\//.test(E)?d.URI.parse(E):d.URI.file((0,L.normalize)(E)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(S=>S==="ui"||S==="workspace"||S==="web"?S:"workspace")}get extensionTestsLocationURI(){const S=this.args.extensionTestsPath;if(S)return/^[^:/?#]+?:\/\//.test(S)?d.URI.parse(S):d.URI.file((0,L.normalize)(S))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const S=this.args["disable-extension"];if(S){if(typeof S=="string")return[S];if(Array.isArray(S)&&S.length>0)return S}return!1}get debugExtensionHost(){return m(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!N.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(S=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(S))}get extensionLogLevel(){const S=[];for(const E of this.args.log||[]){const l=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(E);l&&l[1]&&l[2]&&S.push([l[1],l[2]])}return S.length?S:void 0}get serviceMachineIdResource(){return(0,P.joinPath)(d.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return d.URI.file((0,L.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const S=N.env.VSCODE_PORTABLE;return S?d.URI.file((0,L.join)(S,"policy.json")):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(S){this.args.continueOn=S}get args(){return this.a}constructor(S,E,l){this.a=S,this.b=E,this.c=l,this.editSessionId=this.args.editSessionId}}de([D.memoize],c.prototype,"appRoot",null),de([D.memoize],c.prototype,"userHome",null),de([D.memoize],c.prototype,"userDataPath",null),de([D.memoize],c.prototype,"appSettingsHome",null),de([D.memoize],c.prototype,"tmpDir",null),de([D.memoize],c.prototype,"cacheHome",null),de([D.memoize],c.prototype,"stateResource",null),de([D.memoize],c.prototype,"userRoamingDataHome",null),de([D.memoize],c.prototype,"userDataSyncHome",null),de([D.memoize],c.prototype,"userDataSyncLogResource",null),de([D.memoize],c.prototype,"editSessionsLogResource",null),de([D.memoize],c.prototype,"sync",null),de([D.memoize],c.prototype,"machineSettingsResource",null),de([D.memoize],c.prototype,"workspaceStorageHome",null),de([D.memoize],c.prototype,"localHistoryHome",null),de([D.memoize],c.prototype,"keyboardLayoutResource",null),de([D.memoize],c.prototype,"argvResource",null),de([D.memoize],c.prototype,"isExtensionDevelopment",null),de([D.memoize],c.prototype,"untitledWorkspacesHome",null),de([D.memoize],c.prototype,"installSourcePath",null),de([D.memoize],c.prototype,"builtinExtensionsPath",null),de([D.memoize],c.prototype,"extensionsPath",null),de([D.memoize],c.prototype,"extensionDevelopmentLocationURI",null),de([D.memoize],c.prototype,"extensionDevelopmentKind",null),de([D.memoize],c.prototype,"extensionTestsLocationURI",null),de([D.memoize],c.prototype,"debugExtensionHost",null),de([D.memoize],c.prototype,"logLevel",null),de([D.memoize],c.prototype,"extensionLogLevel",null),de([D.memoize],c.prototype,"serviceMachineIdResource",null),de([D.memoize],c.prototype,"telemetryLogResource",null),de([D.memoize],c.prototype,"disableWorkspaceTrust",null),de([D.memoize],c.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=c;function m(w,S){return I(w["inspect-extensions"],w["inspect-brk-extensions"],5870,S,w.debugId,w.extensionEnvironment)}e.parseExtensionHostPort=m;function y(w,S){return I(w["inspect-search"],w["inspect-brk-search"],5876,S,w.extensionEnvironment)}e.parseSearchPort=y;function p(w,S){return I(w["inspect-ptyhost"],w["inspect-brk-ptyhost"],5877,S,w.extensionEnvironment)}e.parsePtyHostPort=p;function I(w,S,E,l,g,v){const s=Number(S||w)||(l?null:E),i=s?Boolean(!!S):!1;let n;if(v)try{n=JSON.parse(v)}catch{}return{port:s,break:i,debugId:g,env:n}}}),function(){"use strict";function $(e,T,D){function k(N,P){const d=L(N,P),c=[d];return e.isAbsolute(d)||c.unshift(D),e.resolve(...c)}function L(N,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const d=process.env.VSCODE_PORTABLE;if(d)return e.join(d,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,P);const m=N["user-data-dir"];if(m)return m;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(y,"AppData","Roaming")}break;case"darwin":c=e.join(T.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(T.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,P)}return{getUserDataPath:k}}if(typeof define=="function")define(Y[104],Z([154,33,35]),function(e,T,D){return $(e,T,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),T=require("os");module.exports=$(e,T,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Y[105],Z([0,1,33,103,104]),function($,e,T,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class L extends D.AbstractNativeEnvironmentService{constructor(P,d){super(P,{homeDir:(0,T.homedir)(),tmpDir:(0,T.tmpdir)(),userDataDir:(0,k.getUserDataPath)(P,d.nameShort)},d)}}e.NativeEnvironmentService=L}),define(Y[106],Z([0,1,5,89]),function($,e,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function k(N,P,d){try{L(N,P,d)}catch(c){console.error(c?.message??c)}return N}e.localizeManifest=k;function L(N,P,d){const c=(m,y,p)=>{const I=m[y];if((0,T.isString)(I)){const w=I,S=w.length;if(S>1&&w[0]==="%"&&w[S-1]==="%"){const E=w.substr(1,S-2);let l=P[E];l===void 0&&d&&(l=d[E]);const g=typeof l=="string"?l:l?.message,v=d?.[E],f=typeof v=="string"?v:v?.message;if(!g){f||console.warn(`[${N.name}]: ${(0,D.localize)(0,null,E)}`);return}if(p&&(y==="title"||y==="category")&&f&&f!==g){const s={value:g,original:f};m[y]=s}else m[y]=g}}else if((0,T.isObject)(I))for(const w in I)I.hasOwnProperty(w)&&(w==="commands"?c(I,w,!0):c(I,w,p));else if(Array.isArray(I))for(let w=0;w<I.length;w++)c(I,w,p)};for(const m in N)N.hasOwnProperty(m)&&c(N,m)}}),define(Y[107],Z([0,1,10]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class D{constructor(){this.a=new Map}register(L,N){this.a.set(L,N)}updateManifest(L){if(!(!Array.isArray(L.activationEvents)||!L.contributes)&&!(typeof L.main>"u"&&typeof L.browser>"u"))for(const N in L.contributes){const P=this.a.get(N);if(!P)continue;const d=L.contributes[N],c=Array.isArray(d)?d:[d];try{P(c,L.activationEvents)}catch(m){(0,T.onUnexpectedError)(m)}}}}e.ImplicitActivationEventsImpl=D,e.ImplicitActivationEvents=new D}),define(Y[45],Z([0,1,17,53,93,39]),function($,e,T,D,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const N=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function d(l){return l=l.trim(),l==="*"||N.test(l)}e.isValidVersionStr=d;function c(l){if(!d(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=l.match(N);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=c;function m(l){if(!l)return null;const g=l.majorBase,v=l.majorMustEqual,f=l.minorBase;let s=l.minorMustEqual;const i=l.patchBase;let n=l.patchMustEqual;l.hasCaret&&(g===0||(s=!1),n=!1);let t=0;if(l.preRelease){const r=P.exec(l.preRelease);if(r){const[,o,u,a]=r;t=Date.UTC(Number(o),Number(u)-1,Number(a))}}return{majorBase:g,majorMustEqual:v,minorBase:f,minorMustEqual:s,patchBase:i,patchMustEqual:n,isMinimum:l.hasGreaterEquals,notBefore:t}}e.normalizeVersion=m;function y(l,g,v){let f;typeof l=="string"?f=m(c(l)):f=l;let s;g instanceof Date?s=g.getTime():typeof g=="string"&&(s=new Date(g).getTime());let i;if(typeof v=="string"?i=m(c(v)):i=v,!f||!i)return!1;const n=f.majorBase,t=f.minorBase,r=f.patchBase;let o=i.majorBase,u=i.minorBase,a=i.patchBase;const h=i.notBefore;let O=i.majorMustEqual,j=i.minorMustEqual,x=i.patchMustEqual;return i.isMinimum?n>o?!0:n<o?!1:t>u?!0:t<u||s&&s<h?!1:r>=a:(n===1&&o===0&&(!O||!j||!x)&&(o=1,u=0,a=0,O=!0,j=!1,x=!1),n<o?!1:n>o?!O:t<u?!1:t>u?!j:r<a?!1:r>a?!x:!(s&&s<h))}e.isValidVersion=y;function p(l,g,v,f,s){const i=[];if(typeof f.publisher<"u"&&typeof f.publisher!="string")return i.push([D.default.Error,k.localize(0,null)]),i;if(typeof f.name!="string")return i.push([D.default.Error,k.localize(1,null,"name")]),i;if(typeof f.version!="string")return i.push([D.default.Error,k.localize(2,null,"version")]),i;if(!f.engines)return i.push([D.default.Error,k.localize(3,null,"engines")]),i;if(typeof f.engines.vscode!="string")return i.push([D.default.Error,k.localize(4,null,"engines.vscode")]),i;if(typeof f.extensionDependencies<"u"&&!E(f.extensionDependencies))return i.push([D.default.Error,k.localize(5,null,"extensionDependencies")]),i;if(typeof f.activationEvents<"u"){if(!E(f.activationEvents))return i.push([D.default.Error,k.localize(6,null,"activationEvents")]),i;if(typeof f.main>"u"&&typeof f.browser>"u")return i.push([D.default.Error,k.localize(7,null,"activationEvents","main")]),i}if(typeof f.extensionKind<"u"&&typeof f.main>"u"&&i.push([D.default.Warning,k.localize(8,null,"extensionKind")]),typeof f.main<"u"){if(typeof f.main!="string")return i.push([D.default.Error,k.localize(9,null,"main")]),i;{const r=(0,T.joinPath)(v,f.main);(0,T.isEqualOrParent)(r,v)||i.push([D.default.Warning,k.localize(10,null,r.path,v.path)])}if(typeof f.activationEvents>"u")return i.push([D.default.Error,k.localize(11,null,"activationEvents","main")]),i}if(typeof f.browser<"u"){if(typeof f.browser!="string")return i.push([D.default.Error,k.localize(12,null,"browser")]),i;{const r=(0,T.joinPath)(v,f.browser);(0,T.isEqualOrParent)(r,v)||i.push([D.default.Warning,k.localize(13,null,r.path,v.path)])}if(typeof f.activationEvents>"u")return i.push([D.default.Error,k.localize(14,null,"activationEvents","browser")]),i}if(!L.valid(f.version))return i.push([D.default.Error,k.localize(15,null)]),i;const n=[];if(!I(l,g,f,s,n))for(const r of n)i.push([D.default.Error,r]);return i}e.validateExtensionManifest=p;function I(l,g,v,f,s){return f||typeof v.main>"u"&&typeof v.browser>"u"?!0:S(l,g,v.engines.vscode,s)}e.isValidExtensionVersion=I;function w(l,g,v){return l==="*"||S(g,v,l)}e.isEngineValid=w;function S(l,g,v,f=[]){const s=m(c(v));if(!s)return f.push(k.localize(16,null,v)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return f.push(k.localize(17,null,v)),!1}else if(!s.majorMustEqual)return f.push(k.localize(18,null,v)),!1;return y(l,g,s)?!0:(f.push(k.localize(19,null,l,v)),!1)}function E(l){if(!Array.isArray(l))return!1;for(let g=0,v=l.length;g<v;g++)if(typeof l[g]!="string")return!1;return!0}}),define(Y[108],Z([0,1,15,30]),function($,e,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(L,N,P){let d=P&&P.get("storage.serviceMachineId",-1)||null;if(d)return d;try{const m=(await N.readFile(L.serviceMachineIdResource)).value.toString();d=(0,D.isUUID)(m)?m:null}catch{d=null}if(!d){d=(0,D.generateUuid)();try{await N.writeFile(L.serviceMachineIdResource,T.VSBuffer.fromString(d))}catch{}}return P?.store("storage.serviceMachineId",d,-1,1),d}e.getServiceMachineId=k}),define(Y[46],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class T{constructor(k,L=[],N=!1){this.ctor=k,this.staticArguments=L,this.supportsDelayedInstantiation=N}}e.SyncDescriptor=T}),define(Y[109],Z([0,1,46]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const D=[];var k;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(k=e.InstantiationType||(e.InstantiationType={}));function L(P,d,c){d instanceof T.SyncDescriptor||(d=new T.SyncDescriptor(d,[],Boolean(c))),D.push([P,d])}e.registerSingleton=L;function N(){return D}e.getSingletonServiceDescriptors=N}),define(Y[110],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class T{constructor(L,N){this.key=L,this.data=N,this.incoming=new Map,this.outgoing=new Map}}e.Node=T;class D{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const N of this.a.values())N.outgoing.size===0&&L.push(N);return L}insertEdge(L,N){const P=this.lookupOrInsertNode(L),d=this.lookupOrInsertNode(N);P.outgoing.set(d.key,d),d.incoming.set(P.key,P)}removeNode(L){const N=this.b(L);this.a.delete(N);for(const P of this.a.values())P.outgoing.delete(N),P.incoming.delete(N)}lookupOrInsertNode(L){const N=this.b(L);let P=this.a.get(N);return P||(P=new T(N,L),this.a.set(N,P)),P}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[N,P]of this.a)L.push(`${N}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,N]of this.a){const P=new Set([L]),d=this.c(N,P);if(d)return d}}c(L,N){for(const[P,d]of L.outgoing){if(N.has(P))return[...N,P].join(" -> ");N.add(P);const c=this.c(d,N);if(c)return c;N.delete(P)}}}e.Graph=D}),define(Y[21],Z([0,1,5,11,8]),function($,e,T,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function L(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof D.URI)}e.isConfigurationOverrides=L;function N(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof D.URI)}e.isConfigurationUpdateOverrides=N;var P;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function d(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=d;function c(l,g){const v=Object.create(null);for(const f in l)m(v,f,l[f],g);return v}e.toValuesTree=c;function m(l,g,v,f){const s=g.split("."),i=s.pop();let n=l;for(let t=0;t<s.length;t++){const r=s[t];let o=n[r];switch(typeof o){case"undefined":o=n[r]=Object.create(null);break;case"object":break;default:f(`Ignoring ${g} as ${s.slice(0,t+1).join(".")} is ${JSON.stringify(o)}`);return}n=o}if(typeof n=="object"&&n!==null)try{n[i]=v}catch{f(`Ignoring ${g} as ${s.join(".")} is ${JSON.stringify(n)}`)}else f(`Ignoring ${g} as ${s.join(".")} is ${JSON.stringify(n)}`)}e.addToValueTree=m;function y(l,g){const v=g.split(".");p(l,v)}e.removeFromValueTree=y;function p(l,g){const v=g.shift();if(g.length===0){delete l[v];return}if(Object.keys(l).indexOf(v)!==-1){const f=l[v];typeof f=="object"&&!Array.isArray(f)&&(p(f,g),Object.keys(f).length===0&&delete l[v])}}function I(l,g,v){function f(n,t){let r=n;for(const o of t){if(typeof r!="object"||r===null)return;r=r[o]}return r}const s=g.split("."),i=f(l,s);return typeof i>"u"?v:i}e.getConfigurationValue=I;function w(l,g,v){Object.keys(g).forEach(f=>{f!=="__proto__"&&(f in l?T.isObject(l[f])&&T.isObject(g[f])?w(l[f],g[f],v):v&&(l[f]=g[f]):l[f]=g[f])})}e.merge=w;function S(l,g,v){const f=l.inspect(g),s=l.inspect(v);return typeof f.userValue<"u"||typeof f.workspaceValue<"u"||typeof f.workspaceFolderValue<"u"?f.value:typeof s.userValue<"u"||typeof s.workspaceValue<"u"||typeof s.workspaceFolderValue<"u"?s.value:f.defaultValue}e.getMigratedSettingValue=S;function E(l){return l.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=E}),define(Y[58],Z([0,1,8]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,T.createDecorator)("downloadService")}),define(Y[18],Z([0,1,8]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,T.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,T.refineServiceDecorator)(e.IEnvironmentService)}),define(Y[23],Z([0,1,87,8]),function($,e,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function L(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=L;function N(l,g){switch(l){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=N;function P(l,g){return g==="web"&&!l.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function d(l,g,v){return P(g,v)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===v?!0:c(v).includes(l)}e.isTargetPlatformCompatible=d;function c(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=c;function m(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=m;var y;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(y=e.SortBy||(e.SortBy={}));var p;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(p=e.SortOrder||(e.SortOrder={}));var I;(function(l){l.Install="install",l.Uninstall="uninstall"})(I=e.StatisticType||(e.StatisticType={}));var w;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(w=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService");var S;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatiblePreRelease="IncompatiblePreRelease",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Internal="Internal",l.Signature="Signature"})(S=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class E extends Error{constructor(g,v){super(g),this.code=v,this.name=v}}e.ExtensionManagementError=E,e.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,T.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,T.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Y[59],Z([0,1,8]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,T.createDecorator)("IExtensionSignatureVerificationService");class D{b(){return this.a||(this.a=new Promise((L,N)=>$(["node-vsce-sign"],async P=>L(P),N))),this.a}async verify(L,N){let P;try{P=await this.b()}catch{return!1}return P.verify(L,N)}}e.ExtensionSignatureVerificationService=D}),define(Y[60],Z([0,1,15,10,95,13]),function($,e,T,D,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function N(m,y,p,I,w,S){let E;try{await P(m,y,p,I,w,S)}catch(l){E=l}finally{E&&w.errorTransformer&&(E=w.errorTransformer(E)),typeof E<"u"&&p.error(E),p.end()}}e.readFileIntoStream=N;async function P(m,y,p,I,w,S){d(S);const E=await m.open(y,{create:!1});try{d(S);let l=0,g=0,v=w&&typeof w.length=="number"?w.length:void 0,f=T.VSBuffer.alloc(Math.min(w.bufferSize,typeof v=="number"?v:w.bufferSize)),s=w&&typeof w.position=="number"?w.position:0,i=0;do g=await m.read(E,s,f.buffer,i,f.byteLength-i),s+=g,i+=g,l+=g,typeof v=="number"&&(v-=g),i===f.byteLength&&(await p.write(I(f)),f=T.VSBuffer.alloc(Math.min(w.bufferSize,typeof v=="number"?v:w.bufferSize)),i=0);while(g>0&&(typeof v!="number"||v>0)&&d(S)&&c(l,w));if(i>0){let n=i;typeof v=="number"&&(n=Math.min(i,v)),p.write(I(f.slice(0,n)))}}catch(l){throw(0,L.ensureFileSystemProviderError)(l)}finally{await m.close(E)}}function d(m){if(m.isCancellationRequested)throw(0,D.canceled)();return!0}function c(m,y){if(y?.limits){if(typeof y.limits.memory=="number"&&m>y.limits.memory)throw(0,L.createFileSystemProviderError)((0,k.localize)(0,null),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof y.limits.size=="number"&&m>y.limits.size)throw(0,L.createFileSystemProviderError)((0,k.localize)(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Y[111],Z([0,1,4,155,2,12,156]),function($,e,T,D,k,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class P extends k.Disposable{constructor(){super(...arguments),this.a=this.B(new T.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new T.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=T.Event.None,this.c=new Map,this.f=!1}async watch(c){const m=this.i(c),y=m.filter(I=>{const w=this.c.get(I.path);return w?!(0,D.patternsEquals)(w.request.excludes,I.excludes)||!(0,D.patternsEquals)(w.request.includes,I.includes):!0}),p=Array.from(this.c.values()).filter(({request:I})=>!m.find(w=>w.path===I.path&&(0,D.patternsEquals)(w.excludes,I.excludes)&&(0,D.patternsEquals)(w.includes,I.includes))).map(({request:I})=>I.path);y.length&&this.j(`Request to start watching: ${y.map(I=>`${I.path} (excludes: ${I.excludes.length>0?I.excludes:"<none>"}, includes: ${I.includes&&I.includes.length>0?JSON.stringify(I.includes):"<all>"})`).join(",")}`),p.length&&this.j(`Request to stop watching: ${p.join(",")}`);for(const I of p)this.h(I);for(const I of y)this.g(I)}g(c){const m=new N.NodeJSFileWatcherLibrary(c,p=>this.a.fire(p),p=>this.b.fire(p),this.f),y={request:c,instance:m};this.c.set(c.path,y)}async stop(){for(const[c]of this.c)this.h(c);this.c.clear()}h(c){const m=this.c.get(c);m&&(this.c.delete(c),m.instance.dispose())}i(c){const m=new Map;for(const y of c){const p=L.isLinux?y.path:y.path.toLowerCase();m.set(p,y)}return Array.from(m.values())}async setVerboseLogging(c){this.f=c;for(const[,m]of this.c)m.instance.setVerboseLogging(c)}j(c){this.f&&this.b.fire({type:"trace",message:this.k(c)})}k(c,m){return m?`[File Watcher (node.js)] ${c} (path: ${m.request.path})`:`[File Watcher (node.js)] ${c}`}}e.NodeJSWatcher=P}),define(Y[112],Z([0,1,61,111]),function($,e,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends T.AbstractNonRecursiveWatcherClient{constructor(N,P,d){super(N,P,d),this.m()}l(){return new D.NodeJSWatcher}}e.NodeJSWatcherClient=k}),define(Y[113],Z([0,1,16,56,82,61]),function($,e,T,D,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class N extends L.AbstractUniversalWatcherClient{constructor(d,c,m){super(d,c,m),this.m()}l(d){const c=d.add(new k.Client(T.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return d.add(c.onDidProcessExit(({code:m,signal:y})=>this.n(`terminated by itself with code ${m}, signal: ${y}`))),D.ProxyChannel.toService((0,D.getNextTickChannel)(c.getChannel("watcher")))}}e.UniversalWatcherClient=N}),define(Y[62],Z([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class T{constructor(...k){this.a=new Map;for(const[L,N]of k)this.set(L,N)}set(k,L){const N=this.a.get(k);return this.a.set(k,L),N}has(k){return this.a.has(k)}get(k){return this.a.get(k)}}e.ServiceCollection=T}),define(Y[114],Z([0,1,3,10,2,46,110,8,62,157]),function($,e,T,D,k,L,N,P,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const m=!1;class y extends Error{constructor(E){super("cyclic dependency between services"),this.message=E.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${E.toString()}`}}class p{constructor(E=new d.ServiceCollection,l=!1,g,v=m){this.f=E,this.g=l,this.h=g,this.i=v,this.o=new Set,this.f.set(P.IInstantiationService,this),this._globalGraph=v?g?._globalGraph??new N.Graph(f=>f):void 0}createChild(E){return new p(E,this.g,this,this.i)}invokeFunction(E,...l){const g=w.traceInvocation(this.i,E);let v=!1;try{return E({get:s=>{if(v)throw(0,D.illegalState)("service accessor is only valid during the invocation of its target method");const i=this.m(s,g);if(!i)throw new Error(`[invokeFunction] unknown service '${s}'`);return i}},...l)}finally{v=!0,g.stop()}}createInstance(E,...l){let g,v;return E instanceof L.SyncDescriptor?(g=w.traceCreation(this.i,E.ctor),v=this.j(E.ctor,E.staticArguments.concat(l),g)):(g=w.traceCreation(this.i,E),v=this.j(E,l,g)),g.stop(),v}j(E,l=[],g){const v=P._util.getServiceDependencies(E).sort((i,n)=>i.index-n.index),f=[];for(const i of v){const n=this.m(i.id,g);n||this.u(`[createInstance] ${E.name} depends on UNKNOWN service ${i.id}.`,!1),f.push(n)}const s=v.length>0?v[0].index:l.length;if(l.length!==s){console.trace(`[createInstance] First service dependency of ${E.name} at position ${s+1} conflicts with ${l.length} static arguments`);const i=s-l.length;i>0?l=l.concat(new Array(i)):l=l.slice(0,s)}return Reflect.construct(E,l.concat(f))}k(E,l){if(this.f.get(E)instanceof L.SyncDescriptor)this.f.set(E,l);else if(this.h)this.h.k(E,l);else throw new Error("illegalState - setting UNKNOWN service instance")}l(E){const l=this.f.get(E);return!l&&this.h?this.h.l(E):l}m(E,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(E));const g=this.l(E);return g instanceof L.SyncDescriptor?this.q(E,g,l.branch(E,!0)):(l.branch(E,!1),g)}q(E,l,g){if(this.o.has(E))throw new Error(`illegal state - RECURSIVELY instantiating service '${E}'`);this.o.add(E);try{return this.r(E,l,g)}finally{this.o.delete(E)}}r(E,l,g){const v=new N.Graph(i=>i.id.toString());let f=0;const s=[{id:E,desc:l,_trace:g}];for(;s.length;){const i=s.pop();if(v.lookupOrInsertNode(i),f++>1e3)throw new y(v);for(const n of P._util.getServiceDependencies(i.desc.ctor)){const t=this.l(n.id);if(t||this.u(`[createInstance] ${E} depends on ${n.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(n.id)),t instanceof L.SyncDescriptor){const r={id:n.id,desc:t,_trace:i._trace.branch(n.id,!0)};v.insertEdge(i,r),s.push(r)}}}for(;;){const i=v.roots();if(i.length===0){if(!v.isEmpty())throw new y(v);break}for(const{data:n}of i){if(this.l(n.id)instanceof L.SyncDescriptor){const r=this.s(n.id,n.desc.ctor,n.desc.staticArguments,n.desc.supportsDelayedInstantiation,n._trace);this.k(n.id,r)}v.removeNode(n)}}return this.l(E)}s(E,l,g=[],v,f){if(this.f.get(E)instanceof L.SyncDescriptor)return this.t(E,l,g,v,f);if(this.h)return this.h.s(E,l,g,v,f);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}t(E,l,g=[],v,f){if(v){const s=new p(void 0,this.g,this,this.i);s.c=String(E);const i=new Map,n=new T.IdleValue(()=>{const t=s.j(l,g,f);for(const[r,o]of i){const u=t[r];if(typeof u=="function")for(const a of o)u.apply(t,a)}return i.clear(),t});return new Proxy(Object.create(null),{get(t,r){if(!n.isInitialized&&typeof r=="string"&&(r.startsWith("onDid")||r.startsWith("onWill"))){let a=i.get(r);return a||(a=new c.LinkedList,i.set(r,a)),(O,j,x)=>{const K=a.push([O,j,x]);return(0,k.toDisposable)(K)}}if(r in t)return t[r];const o=n.value;let u=o[r];return typeof u!="function"||(u=u.bind(o),t[r]=u),u},set(t,r,o){return n.value[r]=o,!0},getPrototypeOf(t){return l.prototype}})}else return this.j(l,g,f)}u(E,l){if(l&&console.warn(E),this.g)throw new Error(E)}}e.InstantiationService=p;var I;(function(S){S[S.Creation=0]="Creation",S[S.Invocation=1]="Invocation",S[S.Branch=2]="Branch"})(I||(I={}));class w{static traceInvocation(E,l){return E?new w(1,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):w.c}static traceCreation(E,l){return E?new w(0,l.name):w.c}constructor(E,l){this.type=E,this.name=l,this.g=Date.now(),this.h=[]}branch(E,l){const g=new w(2,E.toString());return this.h.push([E,l,g]),g}stop(){const E=Date.now()-this.g;w.f+=E;let l=!1;function g(f,s){const i=[],n=new Array(f+1).join("	");for(const[t,r,o]of s.h)if(r&&o){l=!0,i.push(`${n}CREATES -> ${t}`);const u=g(f+1,o);u&&i.push(u)}else i.push(`${n}uses -> ${t}`);return i.join(`
`)}const v=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${E.toFixed(2)}ms (grand total ${w.f.toFixed(2)}ms)`];(E>2||l)&&w.all.add(v.join(`
`))}}e.Trace=w,w.all=new Set,w.c=new class extends w{constructor(){super(-1,null)}stop(){}branch(){return this}},w.f=0});var _=this&&this.__param||function($,e){return function(T,D){e(T,D,$)}};define(Y[63],Z([0,1,22,2,12,97,23,8]),function($,e,T,D,k,L,N,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function d(m){return m.tags.find(y=>y.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=d,e.ILanguagePackService=(0,P.createDecorator)("languagePackService");let c=class extends D.Disposable{constructor(y){super(),this.c=y}async getAvailableLanguages(){const y=new T.CancellationTokenSource;setTimeout(()=>y.cancel(),1e3);let p;try{p=await this.c.query({text:'category:"language packs"',pageSize:20},y.token)}catch{return[]}const w=p.firstPage.filter(S=>S.properties.localizedLanguages?.length&&S.tags.some(E=>E.startsWith("lp-"))).map(S=>{const E=S.properties.localizedLanguages?.[0],l=d(S);return{...this.f(l,E,S),extensionId:S.identifier.id,galleryExtension:S}});return w.push({...this.f("en","English"),extensionId:"default"}),w}f(y,p,I){const w=p??y;let S;if(w!==y&&(S=`(${y})`),y.toLowerCase()===k.language.toLowerCase()&&(S??="",S+=(0,L.localize)(0,null)),I?.installCount){S??="";const E=I.installCount;let l;E>1e6?l=`${Math.floor(E/1e5)/10}M`:E>1e3?l=`${Math.floor(E/1e3)}K`:l=String(E),S+=` $(cloud-download) ${l}`}return{id:y,label:w,description:S}}};c=de([_(0,N.IExtensionGalleryService)],c),e.LanguagePackBaseService=c}),define(Y[9],Z([0,1,34,4,2,36,12,11,8]),function($,e,T,D,k,L,N,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,d.createDecorator)("logService"),e.ILoggerService=(0,d.createDecorator)("loggerService");function c(){return new Date().toISOString()}var m;(function(u){u[u.Off=0]="Off",u[u.Trace=1]="Trace",u[u.Debug=2]="Debug",u[u.Info=3]="Info",u[u.Warning=4]="Warning",u[u.Error=5]="Error"})(m=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=m.Info;function y(u,a,h){switch(a){case m.Trace:u.trace(h);break;case m.Debug:u.debug(h);break;case m.Info:u.info(h);break;case m.Warning:u.warn(h);break;case m.Error:u.error(h);break;case m.Off:break;default:throw new Error(`Invalid log level ${a}`)}}e.log=y;function p(u){let a="";for(let h=0;h<u.length;h++){let O=u[h];if(typeof O=="object")try{O=JSON.stringify(O)}catch{}a+=(h>0?" ":"")+O}return a}e.format=p;class I extends k.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new D.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(a){this.b!==a&&(this.b=a,this.c.fire(this.b))}getLevel(){return this.b}f(a){return this.b!==m.Off&&this.b<=a}}e.AbstractLogger=I;class w extends I{constructor(a){super(),this.h=a}f(a){return this.h||super.f(a)}trace(a,...h){this.f(m.Trace)&&this.g(m.Trace,p([a,...h]))}debug(a,...h){this.f(m.Debug)&&this.g(m.Debug,p([a,...h]))}info(a,...h){this.f(m.Info)&&this.g(m.Info,p([a,...h]))}warn(a,...h){this.f(m.Warning)&&this.g(m.Warning,p([a,...h]))}error(a,...h){if(this.f(m.Error))if(a instanceof Error){const O=Array.prototype.slice.call(arguments);O[0]=a.stack,this.g(m.Error,p(O))}else this.g(m.Error,p([a,...h]))}flush(){}}e.AbstractMessageLogger=w;class S extends I{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a),this.g=!N.isWindows}trace(a,...h){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,a,...h):console.log(`[main ${c()}]`,a,...h))}debug(a,...h){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,a,...h):console.log(`[main ${c()}]`,a,...h))}info(a,...h){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,a,...h):console.log(`[main ${c()}]`,a,...h))}warn(a,...h){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${c()}]\x1B[0m`,a,...h):console.warn(`[main ${c()}]`,a,...h))}error(a,...h){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${c()}]\x1B[0m`,a,...h):console.error(`[main ${c()}]`,a,...h))}dispose(){}flush(){}}e.ConsoleMainLogger=S;class E extends I{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a)}trace(a,...h){this.f(m.Trace)&&console.log("%cTRACE","color: #888",a,...h)}debug(a,...h){this.f(m.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",a,...h)}info(a,...h){this.f(m.Info)&&console.log("%c INFO","color: #33f",a,...h)}warn(a,...h){this.f(m.Warning)&&console.log("%c WARN","color: #993",a,...h)}error(a,...h){this.f(m.Error)&&console.log("%c  ERR","color: #f33",a,...h)}dispose(){}flush(){}}e.ConsoleLogger=E;class l extends I{constructor(a,h=e.DEFAULT_LOG_LEVEL){super(),this.g=a,this.setLevel(h)}trace(a,...h){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(a),...h])}debug(a,...h){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(a),...h])}info(a,...h){this.f(m.Info)&&this.g.log(m.Info,[this.h(a),...h])}warn(a,...h){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(a),...h])}error(a,...h){this.f(m.Error)&&this.g.log(m.Error,[this.h(a),...h])}h(a){return typeof a=="string"?a:(0,T.toErrorMessage)(a,this.f(m.Trace))}dispose(){}flush(){}}e.AdapterLogger=l;class g extends I{constructor(a){super(),this.g=a,a.length&&this.setLevel(a[0].getLevel())}setLevel(a){for(const h of this.g)h.setLevel(a);super.setLevel(a)}trace(a,...h){for(const O of this.g)O.trace(a,...h)}debug(a,...h){for(const O of this.g)O.debug(a,...h)}info(a,...h){for(const O of this.g)O.info(a,...h)}warn(a,...h){for(const O of this.g)O.warn(a,...h)}error(a,...h){for(const O of this.g)O.error(a,...h)}flush(){for(const a of this.g)a.flush()}dispose(){for(const a of this.g)a.dispose()}}e.MultiplexLogService=g;class v extends k.Disposable{constructor(a){super(),this.b=a,this.B(a)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(a){this.b.setLevel(a)}getLevel(){return this.b.getLevel()}trace(a,...h){this.b.trace(a,...h)}debug(a,...h){this.b.debug(a,...h)}info(a,...h){this.b.info(a,...h)}warn(a,...h){this.b.warn(a,...h)}error(a,...h){this.b.error(a,...h)}flush(){this.b.flush()}}e.LogService=v;class f extends k.Disposable{constructor(a,h){super(),this.c=a,this.b=new L.ResourceMap,this.B(h(O=>this.setLevel(O)))}getLoggers(){return[...this.b.values()].map(({logger:a})=>a)}getLogger(a){return this.b.get(a)?.logger}createLogger(a,h,O){let j=this.b.get(a)?.logger;return j||(O=h?.always?m.Trace:O,j=this.f(a,O??this.c,h),this.b.set(a,{logger:j,logLevel:O})),j}setLevel(a,h){const O=P.URI.isUri(a)?a:void 0,j=O?h:a;if(O){const x=this.b.get(O);x&&x.logLevel!==j&&(x.logLevel=j,x.logger.setLevel(j))}else this.c=j,this.b.forEach(({logLevel:x,logger:K})=>{x===void 0&&K.setLevel(this.c)})}getLogLevel(a){return this.b.get(a)?.logLevel}dispose(){this.b.forEach(({logger:a})=>a.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=f;class s{constructor(){this.onDidChangeLogLevel=new D.Emitter().event}setLevel(a){}getLevel(){return m.Info}trace(a,...h){}debug(a,...h){}info(a,...h){}warn(a,...h){}error(a,...h){}critical(a,...h){}dispose(){}flush(){}}e.NullLogger=s;class i extends s{}e.NullLogService=i;class n extends f{constructor(){super(m.Info,D.Event.None)}f(a,h,O){return new s}}e.NullLoggerService=n;function t(u){if(u.verbose)return m.Trace;if(typeof u.logLevel=="string"){const a=o(u.logLevel.toLowerCase());if(a!==void 0)return a}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=t;function r(u){switch(u){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}e.LogLevelToString=r;function o(u){switch(u){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.parseLogLevel=o}),define(Y[115],Z([0,1,19,3,10,4,2,14,61,9]),function($,e,T,D,k,L,N,P,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class m extends N.Disposable{constructor(p,I){super(),this.a=p,this.b=I,this.c=this.B(new L.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new L.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new D.ThrottledDelayer(0)),this.s=[],this.t=this.B(new D.ThrottledDelayer(0))}watch(p,I){return I.recursive||this.b?.watcher?.forceUniversal?this.l(p,I):this.u(p,I)}l(p,I){const w={path:this.C(p),excludes:I.excludes,includes:I.includes,recursive:I.recursive},S=(0,T.insert)(this.j,w);return this.m(),(0,N.toDisposable)(()=>{S(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(p=>(0,k.onUnexpectedError)(p))}n(){this.h||(this.h=this.B(this.p(I=>this.c.fire((0,d.toFileChanges)(I)),I=>this.z(I),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)})));const p=this.b?.watcher?.recursive?.usePolling;if(p===!0)for(const I of this.j)(0,d.isRecursiveWatchRequest)(I)&&(I.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const I of this.j)(0,d.isRecursiveWatchRequest)(I)&&p.includes(I.path)&&(I.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(p,I){const w={path:this.C(p),excludes:I.excludes,includes:I.includes,recursive:!1},S=(0,T.insert)(this.s,w);return this.v(),(0,N.toDisposable)(()=>{S(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(p=>(0,k.onUnexpectedError)(p))}w(){return this.r||(this.r=this.B(this.y(p=>this.c.fire((0,d.toFileChanges)(p)),p=>this.z(p),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)}))),this.r.watch(this.s)}z(p){p.type==="error"&&this.g.fire(p.message),this.a[p.type](p.message)}C(p){return(0,P.normalize)(p.fsPath)}}e.AbstractDiskFileSystemProvider=m}),define(Y[116],Z([0,1,19,3,15,22,4,52,64,2,54,16,117,17,43,94,13,60,9]),function($,e,T,D,k,L,N,P,d,c,m,y,p,I,w,S,E,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let v=class extends c.Disposable{constructor(s){super(),this.b=s,this.a=256*1024,this.c=this.B(new N.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new N.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new N.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new N.Emitter),this.onDidRunOperation=this.m.event,this.Q=this.B(new N.Emitter),this.onDidFilesChange=this.Q.event,this.R=this.B(new N.Emitter),this.onDidWatchError=this.R.event,this.S=new Map,this.W=this.B(new D.ResourceQueue)}registerProvider(s,i){if(this.h.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,p.mark)(`code/registerFilesystem/${s}`);const n=new c.DisposableStore;return this.h.set(s,i),this.c.fire({added:!0,scheme:s,provider:i}),n.add(i.onDidChangeFile(t=>this.Q.fire(new E.FileChangesEvent(t,!this.N(i))))),typeof i.onDidWatchError=="function"&&n.add(i.onDidWatchError(t=>this.R.fire(new Error(t)))),n.add(i.onDidChangeCapabilities(()=>this.g.fire({provider:i,scheme:s}))),(0,c.toDisposable)(()=>{this.c.fire({added:!1,scheme:s,provider:i}),this.h.delete(s),(0,c.dispose)(n)})}getProvider(s){return this.h.get(s)}async activateProvider(s){const i=[];this.f.fire({scheme:s,join(n){i.push(n)}}),!this.h.has(s)&&await D.Promises.settled(i)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.h.has(s.scheme)}hasCapability(s,i){const n=this.h.get(s.scheme);return!!(n&&n.capabilities&i)}listCapabilities(){return d.Iterable.map(this.h,([s,i])=>({scheme:s,capabilities:i.capabilities}))}async j(s){if(!(0,I.isAbsolutePath)(s))throw new E.FileOperationError((0,S.localize)(0,null,this.mb(s)),8);await this.activateProvider(s.scheme);const i=this.h.get(s.scheme);if(!i){const n=new Error;throw n.name="ENOPRO",n.message=(0,S.localize)(1,null,s.toString()),n}return i}async k(s){const i=await this.j(s);if((0,E.hasOpenReadWriteCloseCapability)(i)||(0,E.hasReadWriteCapability)(i)||(0,E.hasFileReadStreamCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(s){const i=await this.j(s);if((0,E.hasOpenReadWriteCloseCapability)(i)||(0,E.hasReadWriteCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,i){try{return await this.n(s,i)}catch(n){throw(0,E.toFileSystemProviderErrorCode)(n)===E.FileSystemProviderErrorCode.FileNotFound?new E.FileOperationError((0,S.localize)(2,null,this.mb(s)),1):(0,E.ensureFileSystemProviderError)(n)}}async n(s,i){const n=await this.j(s),t=this.N(n),r=i?.resolveTo,o=i?.resolveSingleChildDescendants,u=i?.resolveMetadata,a=await n.stat(s);let h;return this.p(n,s,a,void 0,!!u,(O,j)=>(h||(h=m.TernarySearchTree.forUris(()=>!t),h.set(s,!0),r&&h.fill(!0,r)),h.get(O.resource)||h.findSuperstr(O.resource.with({query:null,fragment:null}))?!0:O.isDirectory&&o?j===1:!1))}async p(s,i,n,t,r,o){const{providerExtUri:u}=this.M(s),a={resource:i,name:u.basename(i),isFile:(n.type&E.FileType.File)!==0,isDirectory:(n.type&E.FileType.Directory)!==0,isSymbolicLink:(n.type&E.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&E.FilePermission.Readonly)||Boolean(s.capabilities&2048),etag:(0,E.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(a.isDirectory&&o(a,t)){try{const h=await s.readdir(i),O=await D.Promises.settled(h.map(async([j,x])=>{try{const K=u.joinPath(i,j),X=r?await s.stat(K):{type:x};return await this.p(s,K,X,h.length,r,o)}catch(K){return this.b.trace(K),null}}));a.children=(0,T.coalesce)(O)}catch(h){this.b.trace(h),a.children=[]}return a}return a}async resolveAll(s){return D.Promises.settled(s.map(async i=>{try{return{stat:await this.n(i.resource,i.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(s){const i=await this.j(s),n=await i.stat(s);return this.p(i,s,n,void 0,!0,()=>!1)}async exists(s){const i=await this.j(s);try{return!!await i.stat(s)}catch{return!1}}async canCreateFile(s,i){try{await this.r(s,i)}catch(n){return n}return!0}async r(s,i){if(!i?.overwrite&&await this.exists(s))throw new E.FileOperationError((0,S.localize)(3,null,this.mb(s)),3,i)}async createFile(s,i=k.VSBuffer.fromString(""),n){await this.r(s,n);const t=await this.writeFile(s,i);return this.m.fire(new E.FileOperationEvent(s,0,t)),t}async writeFile(s,i,n){const t=this.kb(await this.l(s),s),{providerExtUri:r}=this.M(t);try{await this.s(t,s,n)||await this.O(t,r.dirname(s));let u;if((0,E.hasReadWriteCapability)(t)&&!(i instanceof k.VSBuffer))if((0,w.isReadableStream)(i)){const a=await(0,w.peekStream)(i,3);a.ended?u=k.VSBuffer.concat(a.buffer):u=a}else u=(0,w.peekReadable)(i,a=>k.VSBuffer.concat(a),3);else u=i;!(0,E.hasOpenReadWriteCloseCapability)(t)||(0,E.hasReadWriteCapability)(t)&&u instanceof k.VSBuffer?await this.bb(t,s,n,u):await this.X(t,s,n,u instanceof k.VSBuffer?(0,k.bufferToReadable)(u):u),this.m.fire(new E.FileOperationEvent(s,4))}catch(o){throw new E.FileOperationError((0,S.localize)(4,null,this.mb(s),(0,E.ensureFileSystemProviderError)(o).toString()),(0,E.toFileOperationResult)(o),n)}return this.resolve(s,{resolveMetadata:!0})}async s(s,i,n){if(!!n?.unlock&&!(s.capabilities&8192))throw new Error((0,S.localize)(5,null,this.mb(i)));let r;try{r=await s.stat(i)}catch{return}if((r.type&E.FileType.Directory)!==0)throw new E.FileOperationError((0,S.localize)(6,null,this.mb(i)),0,n);if(this.lb(i,r),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==E.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&n.mtime<r.mtime&&n.etag!==(0,E.etag)({mtime:n.mtime,size:r.size}))throw new E.FileOperationError((0,S.localize)(7,null),3,n);return r}async readFile(s,i,n){const t=await this.k(s);return i?.atomic?this.t(t,s,i,n):this.u(t,s,i,n)}async t(s,i,n,t){return new Promise((r,o)=>{this.W.queueFor(i,this.M(s).providerExtUri).queue(async()=>{try{const u=await this.u(s,i,n,t);r(u)}catch(u){o(u)}})})}async u(s,i,n,t){const r=await this.v(s,i,{...n,preferUnbuffered:!0},t);return{...r,value:await(0,k.streamToBuffer)(r.value)}}async readFileStream(s,i,n){const t=await this.k(s);return this.v(t,s,i,n)}async v(s,i,n,t){const r=new L.CancellationTokenSource(t),o=this.D(i,n).then(a=>a,a=>{throw r.cancel(),a});let u;try{return typeof n?.etag=="string"&&n.etag!==E.ETAG_DISABLED&&await o,n?.atomic&&(0,E.hasFileAtomicReadCapability)(s)||!((0,E.hasOpenReadWriteCloseCapability)(s)||(0,E.hasFileReadStreamCapability)(s))||(0,E.hasReadWriteCapability)(s)&&n?.preferUnbuffered?u=this.C(s,i,n):(0,E.hasFileReadStreamCapability)(s)?u=this.w(s,i,r.token,n):u=this.z(s,i,r.token,n),{...await o,value:u}}catch(a){u&&await(0,w.consumeStream)(u);const h=(0,S.localize)(8,null,this.mb(i),(0,E.ensureFileSystemProviderError)(a).toString());throw a instanceof E.NotModifiedSinceFileOperationError?new E.NotModifiedSinceFileOperationError(h,a.stat,n):new E.FileOperationError(h,(0,E.toFileOperationResult)(a),n)}}w(s,i,n,t=Object.create(null)){const r=s.readFileStream(i,t,n);return(0,w.transform)(r,{data:o=>o instanceof k.VSBuffer?o:k.VSBuffer.wrap(o),error:o=>new E.FileOperationError((0,S.localize)(9,null,this.mb(i),(0,E.ensureFileSystemProviderError)(o).toString()),(0,E.toFileOperationResult)(o),t)},o=>k.VSBuffer.concat(o))}z(s,i,n,t=Object.create(null)){const r=(0,k.newWriteableBufferStream)();return(0,l.readFileIntoStream)(s,i,r,o=>o,{...t,bufferSize:this.a,errorTransformer:o=>new E.FileOperationError((0,S.localize)(10,null,this.mb(i),(0,E.ensureFileSystemProviderError)(o).toString()),(0,E.toFileOperationResult)(o),t)},n),r}C(s,i,n){const t=(0,w.newWriteableStream)(r=>k.VSBuffer.concat(r));return(async()=>{try{let r;n?.atomic&&(0,E.hasFileAtomicReadCapability)(s)?r=await s.readFile(i,{atomic:!0}):r=await s.readFile(i),typeof n?.position=="number"&&(r=r.slice(n.position)),typeof n?.length=="number"&&(r=r.slice(0,n.length)),this.F(i,r.byteLength,n),t.end(k.VSBuffer.wrap(r))}catch(r){t.error(r),t.end()}})(),t}async D(s,i){const n=await this.resolve(s,{resolveMetadata:!0});if(n.isDirectory)throw new E.FileOperationError((0,S.localize)(11,null,this.mb(s)),0,i);if(typeof i?.etag=="string"&&i.etag!==E.ETAG_DISABLED&&i.etag===n.etag)throw new E.NotModifiedSinceFileOperationError((0,S.localize)(12,null),n,i);return this.F(s,n.size,i),n}F(s,i,n){if(n?.limits){let t;if(typeof n.limits.memory=="number"&&i>n.limits.memory&&(t=9),typeof n.limits.size=="number"&&i>n.limits.size&&(t=7),typeof t=="number")throw new E.FileOperationError((0,S.localize)(13,null,this.mb(s)),t)}}async canMove(s,i,n){return this.G(s,i,"move",n)}async canCopy(s,i,n){return this.G(s,i,"copy",n)}async G(s,i,n,t){if(s.toString()!==i.toString())try{const r=n==="move"?this.kb(await this.l(s),s):await this.k(s),o=this.kb(await this.l(i),i);await this.L(r,s,o,i,n,t)}catch(r){return r}return!0}async move(s,i,n){const t=this.kb(await this.l(s),s),r=this.kb(await this.l(i),i),o=await this.H(t,s,r,i,"move",!!n),u=await this.resolve(i,{resolveMetadata:!0});return this.m.fire(new E.FileOperationEvent(s,o==="move"?2:3,u)),u}async copy(s,i,n){const t=await this.k(s),r=this.kb(await this.l(i),i),o=await this.H(t,s,r,i,"copy",!!n),u=await this.resolve(i,{resolveMetadata:!0});return this.m.fire(new E.FileOperationEvent(s,o==="copy"?3:2,u)),u}async H(s,i,n,t,r,o){if(i.toString()===t.toString())return r;const{exists:u,isSameResourceWithDifferentPathCase:a}=await this.L(s,i,n,t,r,o);if(u&&!a&&o&&await this.del(t,{recursive:!0}),await this.O(n,this.M(n).providerExtUri.dirname(t)),r==="copy"){if(s===n&&(0,E.hasFileFolderCopyCapability)(s))await s.copy(i,t,{overwrite:o});else{const h=await this.resolve(i);h.isDirectory?await this.J(s,h,n,t):await this.I(s,i,n,t)}return r}else return s===n?(await s.rename(i,t,{overwrite:o}),r):(await this.H(s,i,n,t,"copy",o),await this.del(i,{recursive:!0}),"copy")}async I(s,i,n,t){if((0,E.hasOpenReadWriteCloseCapability)(s)&&(0,E.hasOpenReadWriteCloseCapability)(n))return this.db(s,i,n,t);if((0,E.hasOpenReadWriteCloseCapability)(s)&&(0,E.hasReadWriteCapability)(n))return this.jb(s,i,n,t);if((0,E.hasReadWriteCapability)(s)&&(0,E.hasOpenReadWriteCloseCapability)(n))return this.hb(s,i,n,t);if((0,E.hasReadWriteCapability)(s)&&(0,E.hasReadWriteCapability)(n))return this.fb(s,i,n,t)}async J(s,i,n,t){await n.mkdir(t),Array.isArray(i.children)&&await D.Promises.settled(i.children.map(async r=>{const o=this.M(n).providerExtUri.joinPath(t,r.name);return r.isDirectory?this.J(s,await this.resolve(r.resource),n,o):this.I(s,r.resource,n,o)}))}async L(s,i,n,t,r,o){let u=!1;if(s===n){const{providerExtUri:h,isPathCaseSensitive:O}=this.M(s);if(O||(u=h.isEqual(i,t)),u&&r==="copy")throw new Error((0,S.localize)(14,null,this.mb(i),this.mb(t)));if(!u&&h.isEqualOrParent(t,i))throw new Error((0,S.localize)(15,null,this.mb(i),this.mb(t)))}const a=await this.exists(t);if(a&&!u){if(!o)throw new E.FileOperationError((0,S.localize)(16,null,this.mb(i),this.mb(t)),4);if(s===n){const{providerExtUri:h}=this.M(s);if(h.isEqualOrParent(i,t))throw new Error((0,S.localize)(17,null,this.mb(i),this.mb(t)))}}return{exists:a,isSameResourceWithDifferentPathCase:u}}M(s){const i=this.N(s);return{providerExtUri:i?I.extUri:I.extUriIgnorePathCase,isPathCaseSensitive:i}}N(s){return!!(s.capabilities&1024)}async createFolder(s){const i=this.kb(await this.j(s),s);await this.O(i,s);const n=await this.resolve(s,{resolveMetadata:!0});return this.m.fire(new E.FileOperationEvent(s,0,n)),n}async O(s,i){const n=[],{providerExtUri:t}=this.M(s);for(;!t.isEqual(i,t.dirname(i));)try{if(((await s.stat(i)).type&E.FileType.Directory)===0)throw new Error((0,S.localize)(18,null,this.mb(i)));break}catch(r){if((0,E.toFileSystemProviderErrorCode)(r)!==E.FileSystemProviderErrorCode.FileNotFound)throw r;n.push(t.basename(i)),i=t.dirname(i)}for(let r=n.length-1;r>=0;r--){i=t.joinPath(i,n[r]);try{await s.mkdir(i)}catch(o){if((0,E.toFileSystemProviderErrorCode)(o)!==E.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(s,i){try{await this.P(s,i)}catch(n){return n}return!0}async P(s,i){const n=this.kb(await this.j(s),s);if(!!i?.useTrash&&!(n.capabilities&4096))throw new Error((0,S.localize)(19,null,this.mb(s)));let r;try{r=await n.stat(s)}catch{}if(r)this.lb(s,r);else throw new E.FileOperationError((0,S.localize)(20,null,this.mb(s)),1);if(!!!i?.recursive){const u=await this.resolve(s);if(u.isDirectory&&Array.isArray(u.children)&&u.children.length>0)throw new Error((0,S.localize)(21,null,this.mb(s)))}return n}async del(s,i){const n=await this.P(s,i),t=!!i?.useTrash,r=!!i?.recursive;await n.delete(s,{recursive:r,useTrash:t}),this.m.fire(new E.FileOperationEvent(s,1))}async cloneFile(s,i){const n=await this.j(s),t=this.kb(await this.l(i),i);if(n===t&&this.M(n).providerExtUri.isEqual(s,i))return;if(n===t&&(0,E.hasFileCloneCapability)(n))return n.cloneFile(s,i);await this.O(t,this.M(t).providerExtUri.dirname(i));const r=this.W.queueFor(s,this.M(n).providerExtUri);return n===t&&(0,E.hasFileFolderCopyCapability)(n)?r.queue(()=>n.copy(s,i,{overwrite:!0})):r.queue(()=>this.I(n,s,t,i))}watch(s,i={recursive:!1,excludes:[]}){const n=new c.DisposableStore;let t=!1,r=()=>{t=!0};return n.add((0,c.toDisposable)(()=>r())),(async()=>{try{const o=await this.U(s,i);t?(0,c.dispose)(o):r=()=>(0,c.dispose)(o)}catch(o){this.b.error(o)}})(),n}async U(s,i){const n=await this.j(s),t=(0,P.hash)([this.M(n).providerExtUri.getComparisonKey(s),i]);let r=this.S.get(t);return r||(r={count:0,disposable:n.watch(s,i)},this.S.set(t,r)),r.count+=1,(0,c.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,c.dispose)(r.disposable),this.S.delete(t)))})}dispose(){super.dispose();for(const[,s]of this.S)(0,c.dispose)(s.disposable);this.S.clear()}async X(s,i,n,t){return this.W.queueFor(i,this.M(s).providerExtUri).queue(async()=>{const r=await s.open(i,{create:!0,unlock:n?.unlock??!1});try{(0,w.isReadableStream)(t)||(0,w.isReadableBufferedStream)(t)?await this.Y(s,r,t):await this.Z(s,r,t)}catch(o){throw(0,E.ensureFileSystemProviderError)(o)}finally{await s.close(r)}})}async Y(s,i,n){let t=0,r;if((0,w.isReadableBufferedStream)(n)){if(n.buffer.length>0){const o=k.VSBuffer.concat(n.buffer);await this.ab(s,i,o,o.byteLength,t,0),t+=o.byteLength}if(n.ended)return;r=n.stream}else r=n;return new Promise((o,u)=>{(0,w.listenStream)(r,{onData:async a=>{r.pause();try{await this.ab(s,i,a,a.byteLength,t,0)}catch(h){return u(h)}t+=a.byteLength,setTimeout(()=>r.resume())},onError:a=>u(a),onEnd:()=>o()})})}async Z(s,i,n){let t=0,r;for(;(r=n.read())!==null;)await this.ab(s,i,r,r.byteLength,t,0),t+=r.byteLength}async ab(s,i,n,t,r,o){let u=0;for(;u<t;)u+=await s.write(i,r+u,n.buffer,o+u,t-u)}async bb(s,i,n,t){return this.W.queueFor(i,this.M(s).providerExtUri).queue(()=>this.cb(s,i,n,t))}async cb(s,i,n,t){let r;t instanceof k.VSBuffer?r=t:(0,w.isReadableStream)(t)?r=await(0,k.streamToBuffer)(t):(0,w.isReadableBufferedStream)(t)?r=await(0,k.bufferedStreamToBuffer)(t):r=(0,k.readableToBuffer)(t),await s.writeFile(i,r.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async db(s,i,n,t){return this.W.queueFor(t,this.M(n).providerExtUri).queue(()=>this.eb(s,i,n,t))}async eb(s,i,n,t){let r,o;try{r=await s.open(i,{create:!1}),o=await n.open(t,{create:!0,unlock:!1});const u=k.VSBuffer.alloc(this.a);let a=0,h=0,O=0;do O=await s.read(r,a,u.buffer,h,u.byteLength-h),await this.ab(n,o,u,O,a,h),a+=O,h+=O,h===u.byteLength&&(h=0);while(O>0)}catch(u){throw(0,E.ensureFileSystemProviderError)(u)}finally{await D.Promises.settled([typeof r=="number"?s.close(r):Promise.resolve(),typeof o=="number"?n.close(o):Promise.resolve()])}}async fb(s,i,n,t){return this.W.queueFor(t,this.M(n).providerExtUri).queue(()=>this.gb(s,i,n,t))}async gb(s,i,n,t){return n.writeFile(t,await s.readFile(i),{create:!0,overwrite:!0,unlock:!1})}async hb(s,i,n,t){return this.W.queueFor(t,this.M(n).providerExtUri).queue(()=>this.ib(s,i,n,t))}async ib(s,i,n,t){const r=await n.open(t,{create:!0,unlock:!1});try{const o=await s.readFile(i);await this.ab(n,r,k.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,E.ensureFileSystemProviderError)(o)}finally{await n.close(r)}}async jb(s,i,n,t){const r=await(0,k.streamToBuffer)(this.z(s,i,L.CancellationToken.None));await this.bb(n,t,void 0,r)}kb(s,i){if(s.capabilities&2048)throw new E.FileOperationError((0,S.localize)(22,null,this.mb(i)),6);return s}lb(s,i){if((i.permissions??0)&E.FilePermission.Readonly)throw new E.FileOperationError((0,S.localize)(23,null,this.mb(s)),6)}mb(s){return s.scheme===y.Schemas.file?s.fsPath:s.toString(!0)}};v=de([_(0,g.ILogService)],v),e.FileService=v}),define(Y[118],Z([0,1,119,158,3,36,15,4,159,2,14,12,17,43,20,96,13,60,115,34,113,112]),function($,e,T,D,k,L,N,P,d,c,m,y,p,I,w,S,E,l,g,v,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,D.gracefulify)(T)}catch(n){console.error(`Error enabling graceful-fs: ${(0,v.toErrorMessage)(n)}`)}})();class i extends g.AbstractDiskFileSystemProvider{constructor(t,r){super(t,r),this.onDidChangeCapabilities=P.Event.None,this.H=new L.ResourceMap(o=>p.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,y.isLinux&&(this.F|=1024)),this.F}async stat(t){try{const{stat:r,symbolicLink:o}=await w.SymlinkSupport.stat(this.C(t));return{type:this.G(r,o),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.Y(r)}}async readdir(t){try{const r=await w.Promises.readdir(this.C(t),{withFileTypes:!0}),o=[];return await Promise.all(r.map(async u=>{try{let a;u.isSymbolicLink()?a=(await this.stat((0,p.joinPath)(t,u.name))).type:a=this.G(u),o.push([u.name,a])}catch(a){this.a.trace(a)}})),o}catch(r){throw this.Y(r)}}G(t,r){let o;return r?.dangling?o=E.FileType.Unknown:t.isFile()?o=E.FileType.File:t.isDirectory()?o=E.FileType.Directory:o=E.FileType.Unknown,r&&(o|=E.FileType.SymbolicLink),o}async I(t){const r=this.C(t);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let o;for(;o=this.H.get(t);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await o.wait();const u=new k.Barrier;return this.H.set(t,u),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,c.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.H.get(t)===u&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.H.delete(t)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),u.open()})}async readFile(t,r){let o;try{r?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(t)})`),o=await this.I(t));const u=this.C(t);return await w.Promises.readFile(u)}catch(u){throw this.Y(u)}finally{o?.dispose()}}J(t){i.D&&this.a.trace(t)}readFileStream(t,r,o){const u=(0,I.newWriteableStream)(a=>N.VSBuffer.concat(a.map(h=>N.VSBuffer.wrap(h))).buffer);return(0,l.readFileIntoStream)(this,t,u,a=>a.buffer,{...r,bufferSize:256*1024},o),u}async writeFile(t,r,o){let u;try{const a=this.C(t);if(!o.create||!o.overwrite){if(await w.Promises.exists(a)){if(!o.overwrite)throw(0,E.createFileSystemProviderError)((0,S.localize)(0,null),E.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,E.createFileSystemProviderError)((0,S.localize)(1,null),E.FileSystemProviderErrorCode.FileNotFound)}u=await this.open(t,{create:!0,unlock:o.unlock}),await this.write(u,0,r,0,r.byteLength)}catch(a){throw await this.Z(t,a)}finally{typeof u=="number"&&await this.close(u)}}static configureFlushOnWrite(t){i.O=t}async open(t,r){const o=this.C(t);let u;(0,E.isFileOpenForWriteOptions)(r)&&(u=await this.I(t));let a;try{if((0,E.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:O}=await w.SymlinkSupport.stat(o);O.mode&128||await w.Promises.chmod(o,O.mode|128)}catch(O){this.a.trace(O)}let h;if((0,E.isFileOpenForWriteOptions)(r)){if(y.isWindows)try{await w.Promises.truncate(o,0),h="r+"}catch(O){O.code!=="ENOENT"&&this.a.trace(O)}h||(h="w")}else h="r";a=await w.Promises.open(o,h)}catch(h){throw u?.dispose(),(0,E.isFileOpenForWriteOptions)(r)?await this.Z(t,h):this.Y(h)}if(this.L.set(a,0),(0,E.isFileOpenForWriteOptions)(r)&&this.N.set(a,t),u){const h=this.M.get(a);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${o})`),this.M.set(a,u),h&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${o})`),h.dispose())}return a}async close(t){const r=this.M.get(t);try{if(this.L.delete(t),this.N.delete(t)&&i.O)try{await w.Promises.fdatasync(t)}catch(o){i.configureFlushOnWrite(!1),this.a.error(o)}return await w.Promises.close(t)}catch(o){throw this.Y(o)}finally{r&&(this.M.get(t)===r&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.M.delete(t)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),r.dispose())}}async read(t,r,o,u,a){const h=this.P(t,r);let O=null;try{O=(await w.Promises.read(t,o,u,a,h)).bytesRead}catch(j){throw this.Y(j)}finally{this.Q(t,h,O)}return O}P(t,r){return r===this.L.get(t)?null:r}Q(t,r,o){const u=this.L.get(t);typeof u=="number"&&(typeof r=="number"||(typeof o=="number"?this.L.set(t,u+o):this.L.delete(t)))}async write(t,r,o,u,a){return(0,k.retry)(()=>this.R(t,r,o,u,a),100,3)}async R(t,r,o,u,a){const h=this.P(t,r);let O=null;try{O=(await w.Promises.write(t,o,u,a,h)).bytesWritten}catch(j){throw await this.Z(this.N.get(t),j)}finally{this.Q(t,h,O)}return O}async mkdir(t){try{await w.Promises.mkdir(this.C(t))}catch(r){throw this.Y(r)}}async delete(t,r){try{const o=this.C(t);r.recursive?await w.Promises.rm(o,w.RimRafMode.MOVE):await w.Promises.unlink(o)}catch(o){throw this.Y(o)}}async rename(t,r,o){const u=this.C(t),a=this.C(r);if(u!==a)try{await this.S(t,r,"move",o.overwrite),await w.Promises.move(u,a)}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,S.localize)(2,null,(0,m.basename)(u),(0,m.basename)((0,m.dirname)(a)),h.toString()))),this.Y(h)}}async copy(t,r,o){const u=this.C(t),a=this.C(r);if(u!==a)try{await this.S(t,r,"copy",o.overwrite),await w.Promises.copy(u,a,{preserveSymlinks:!0})}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,S.localize)(3,null,(0,m.basename)(u),(0,m.basename)((0,m.dirname)(a)),h.toString()))),this.Y(h)}}async S(t,r,o,u){const a=this.C(t),h=this.C(r);let O=!1;if(!!(this.capabilities&1024)||(O=(0,d.isEqual)(a,h,!0)),O&&o==="copy")throw(0,E.createFileSystemProviderError)((0,S.localize)(4,null),E.FileSystemProviderErrorCode.FileExists);if(!O&&await w.Promises.exists(h)){if(!u)throw(0,E.createFileSystemProviderError)((0,S.localize)(5,null),E.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}async cloneFile(t,r){return this.U(t,r,!1)}async U(t,r,o){const u=this.C(t),a=this.C(r),h=!!(this.capabilities&1024);if((0,d.isEqual)(u,a,!h))return;const O=new c.DisposableStore;try{const[j,x]=await Promise.all([this.I(t),this.I(r)]);O.add(j),O.add(x),o&&await w.Promises.mkdir((0,m.dirname)(a),{recursive:!0}),await w.Promises.copyFile(u,a)}catch(j){if(j.code==="ENOENT"&&!o)return this.U(t,r,!0);throw this.Y(j)}finally{O.dispose()}}p(t,r,o){return new f.UniversalWatcherClient(u=>t(u),u=>r(u),o)}y(t,r,o){return new s.NodeJSWatcherClient(u=>t(u),u=>r(u),o)}Y(t){if(t instanceof E.FileSystemProviderError)return t;let r;switch(t.code){case"ENOENT":r=E.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=E.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=E.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=E.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=E.FileSystemProviderErrorCode.NoPermissions;break;default:r=E.FileSystemProviderErrorCode.Unknown}return(0,E.createFileSystemProviderError)(t,r)}async Z(t,r){let o=this.Y(r);if(t&&o.code===E.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await w.SymlinkSupport.stat(this.C(t));u.mode&128||(o=(0,E.createFileSystemProviderError)(r,E.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.a.trace(u)}return o}}e.DiskFileSystemProvider=i,i.D=!1,i.O=!0}),define(Y[120],Z([0,1,13,9]),function($,e,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var k;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(k||(k={}));async function L(c,m,y,p,I){try{const w=await new Promise((E,l)=>{$(["spdlog"],E,l)});w.setFlushOn(k.Trace);const S=await w.createAsyncRotatingLogger(c,m,y,p);return I?S.clearFormatters():S.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),S}catch(w){console.error(w)}return null}function N(c,m,y){switch(m){case D.LogLevel.Trace:c.trace(y);break;case D.LogLevel.Debug:c.debug(y);break;case D.LogLevel.Info:c.info(y);break;case D.LogLevel.Warning:c.warn(y);break;case D.LogLevel.Error:c.error(y);break;case D.LogLevel.Off:break;default:throw new Error(`Invalid log level ${m}`)}}function P(c,m){switch(m){case D.LogLevel.Trace:c.setLevel(k.Trace);break;case D.LogLevel.Debug:c.setLevel(k.Debug);break;case D.LogLevel.Info:c.setLevel(k.Info);break;case D.LogLevel.Warning:c.setLevel(k.Warning);break;case D.LogLevel.Error:c.setLevel(k.Error);break;case D.LogLevel.Off:c.setLevel(k.Off);break;default:throw new Error(`Invalid log level ${m}`)}}class d extends D.AbstractMessageLogger{constructor(m,y,p,I,w){super(),this.k=[],this.setLevel(w),this.l=this.n(m,y,p,I),this.B(this.onDidChangeLogLevel(S=>{this.m&&P(this.m,S)}))}async n(m,y,p,I){const w=p?6:1,S=30/w*T.ByteSize.MB,E=await L(m,y,S,w,I);if(E){this.m=E,P(this.m,this.getLevel());for(const{level:l,message:g}of this.k)N(this.m,l,g);this.k=[]}}g(m,y){this.m?N(this.m,m,y):this.getLevel()<=m&&this.k.push({level:m,message:y})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=d}),define(Y[38],Z([0,1,4,64,2,8]),function($,e,T,D,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,L.createDecorator)("policy");class N extends k.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new T.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const m=Object.keys(this.f).length;return this.f={...c,...this.f},m!==Object.keys(this.f).length&&await this.i(c),D.Iterable.reduce(this.g.entries(),(y,[p,I])=>({...y,[p]:I}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return D.Iterable.reduce(Object.entries(this.f),(c,[m,y])=>({...c,[m]:{definition:y,value:this.g.get(m)}}),{})}}e.AbstractPolicyService=N;class P{constructor(){this.onDidChange=T.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=P}),define(Y[121],Z([0,1,3,4,64,5,13,9,38]),function($,e,T,D,k,L,N,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function c(y,p){const I=[];for(const w of k.Iterable.concat(y.keys(),p.keys()))y.get(w)!==p.get(w)&&I.push(w);return I}let m=class extends d.AbstractPolicyService{constructor(p,I,w){super(),this.j=p,this.k=I,this.l=w,this.c=this.B(new T.ThrottledDelayer(500));const S=D.Event.filter(I.onDidFilesChange,E=>E.affects(p));this.B(I.watch(p)),this.B(S(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const p=new Map;try{const I=await this.k.readFile(this.j),w=JSON.parse(I.value.toString());if(!(0,L.isObject)(w))throw new Error("Policy file isn't a JSON object");for(const S of Object.keys(w))this.f[S]&&p.set(S,w[S])}catch(I){I.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",I)}return p}async p(){const p=await this.n(),I=c(this.g,p);this.g=p,I.length>0&&this.h.fire(I)}};m=de([_(1,N.IFileService),_(2,P.ILogService)],m),e.FilePolicyService=m}),define(Y[26],Z([0,1,8]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,T.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(Y[37],Z([0,1,70,5]),function($,e,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.a=new Map}add(N,P){T.ok(D.isString(N)),T.ok(D.isObject(P)),T.ok(!this.a.has(N),"There is already an extension with this id"),this.a.set(N,P)}knows(N){return this.a.has(N)}as(N){return this.a.get(N)||null}}e.Registry=new k}),define(Y[122],Z([0,1,4,37]),function($,e,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class L{constructor(){this.b=new T.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(d,c){this.a[k(d)]=c,this.b.fire(d)}notifySchemaChanged(d){this.b.fire(d)}getSchemaContributions(){return{schemas:this.a}}}const N=new L;D.Registry.add(e.Extensions.JSONContribution,N)}),define(Y[40],Z([0,1,19,4,5,85,21,122,37]),function($,e,T,D,k,L,N,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var c;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(c=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var m;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(m=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const y=d.Registry.as(P.Extensions.JSONContribution);class p{constructor(){this.h=new Set,this.i=new D.Emitter,this.onDidSchemaChange=this.i.event,this.j=new D.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.r()}registerConfiguration(i,n=!0){this.registerConfigurations([i],n)}registerConfigurations(i,n=!0){const t=this.k(i,n);y.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(i){const n=this.l(i);y.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:n})}updateConfigurations({add:i,remove:n}){const t=[];t.push(...this.l(n)),t.push(...this.k(i,!1)),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:(0,T.distinct)(t)})}registerDefaultConfigurations(i){const n=[],t=[];for(const{overrides:r,source:o}of i)for(const u in r)if(n.push(u),e.OVERRIDE_PROPERTY_REGEX.test(u)){const a=this.a.get(u),h=a?.valuesSources??new Map;if(o)for(const K of Object.keys(r[u]))h.set(K,o);const O={...a?.value||{},...r[u]};this.a.set(u,{source:o,value:O,valuesSources:h});const j=(0,N.getLanguageTagSettingPlainKey)(u),x={type:"object",default:O,description:L.localize(1,null,j),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:O,source:k.isString(o)?void 0:o,defaultValueSource:o};t.push(...S(u)),this.d[u]=x,this.b.properties[u]=x}else{this.a.set(u,{value:r[u],source:o});const a=this.d[u];a&&(this.s(u,a),this.o(u,a))}this.registerOverrideIdentifiers(t),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}deregisterDefaultConfigurations(i){const n=[];for(const{overrides:t,source:r}of i)for(const o in t){const u=this.a.get(o),a=k.isString(r)?r:r?.id,h=k.isString(u?.source)?u?.source:u?.source?.id;if(a===h)if(n.push(o),this.a.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.d[o],delete this.b.properties[o];else{const O=this.d[o];O&&(this.s(o,O),this.o(o,O))}}this.q(),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){for(const n of i)this.h.add(n);this.q()}k(i,n){const t=[];return i.forEach(r=>{t.push(...this.m(r,n,r.extensionInfo,r.restrictedProperties)),this.c.push(r),this.n(r)}),t}l(i){const n=[],t=r=>{if(r.properties)for(const o in r.properties){n.push(o);const u=this.d[o];u?.policy?.name&&this.e.delete(u.policy.name),delete this.d[o],this.p(o,r.properties[o])}r.allOf?.forEach(o=>t(o))};for(const r of i){t(r);const o=this.c.indexOf(r);o!==-1&&this.c.splice(o,1)}return n}m(i,n=!0,t,r,o=3){o=k.isUndefinedOrNull(i.scope)?o:i.scope;const u=[],a=i.properties;if(a)for(const O in a){const j=a[O];if(n&&v(O,j)){delete a[O];continue}if(j.source=t,j.defaultDefaultValue=a[O].default,this.s(O,j),e.OVERRIDE_PROPERTY_REGEX.test(O)?j.scope=void 0:(j.scope=k.isUndefinedOrNull(j.scope)?o:j.scope,j.restricted=k.isUndefinedOrNull(j.restricted)?!!r?.includes(O):j.restricted),a[O].hasOwnProperty("included")&&!a[O].included){this.f[O]=a[O],delete a[O];continue}else this.d[O]=a[O],a[O].policy?.name&&this.e.set(a[O].policy.name,O);!a[O].deprecationMessage&&a[O].markdownDeprecationMessage&&(a[O].deprecationMessage=a[O].markdownDeprecationMessage),u.push(O)}const h=i.allOf;if(h)for(const O of h)u.push(...this.m(O,n,t,r,o));return u}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}n(i){const n=t=>{const r=t.properties;if(r)for(const u in r)this.o(u,r[u]);t.allOf?.forEach(n)};n(i)}o(i,n){switch(e.allSettings.properties[i]=n,n.scope){case 1:e.applicationSettings.properties[i]=n;break;case 2:e.machineSettings.properties[i]=n;break;case 6:e.machineOverridableSettings.properties[i]=n;break;case 3:e.windowSettings.properties[i]=n;break;case 4:e.resourceSettings.properties[i]=n;break;case 5:e.resourceSettings.properties[i]=n,this.g.properties[i]=n;break}}p(i,n){switch(delete e.allSettings.properties[i],n.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.g.properties[i];break}}q(){for(const i of this.h.values()){const n=`[${i}]`,t={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.s(n,t),e.allSettings.properties[n]=t,e.applicationSettings.properties[n]=t,e.machineSettings.properties[n]=t,e.machineOverridableSettings.properties[n]=t,e.windowSettings.properties[n]=t,e.resourceSettings.properties[n]=t}this.i.fire()}r(){const i={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this.i.fire()}s(i,n){const t=this.a.get(i);let r=t?.value,o=t?.source;k.isUndefined(r)&&(r=n.defaultDefaultValue,o=void 0),k.isUndefined(r)&&(r=l(n.type)),n.default=r,n.defaultValueSource=o}}const I="\\[([^\\]]+)\\]",w=new RegExp(I,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${I})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function S(s){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(s)){let n=w.exec(s);for(;n?.length;){const t=n[1].trim();t&&i.push(t),n=w.exec(s)}}return(0,T.distinct)(i)}e.overrideIdentifiersFromKey=S;function E(s){return s.reduce((i,n)=>`${i}[${n}]`,"")}e.keyFromOverrideIdentifiers=E;function l(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const g=new p;d.Registry.add(e.Extensions.Configuration,g);function v(s,i){return s.trim()?e.OVERRIDE_PROPERTY_REGEX.test(s)?L.localize(7,null,s):g.getConfigurationProperties()[s]!==void 0?L.localize(8,null,s):i.policy?.name&&g.getPolicyConfigurations().get(i.policy?.name)!==void 0?L.localize(9,null,s,i.policy?.name,g.getPolicyConfigurations().get(i.policy?.name)):null:L.localize(6,null)}e.validateProperty=v;function f(){const s=[],i=g.getConfigurationProperties();for(const n of Object.keys(i))s.push([n,i[n].scope]);return s.push(["launch",4]),s.push(["task",4]),s}e.getScopes=f}),define(Y[65],Z([0,1,19,4,50,2,36,29,5,11,21,40,37]),function($,e,T,D,k,L,N,P,d,c,m,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class I{constructor(n={},t=[],r=[],o){this.c=n,this.d=t,this.f=r,this.raw=o,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const n=this.raw.map(t=>{if(t instanceof I)return t;const r=new w("");return r.parseRaw(t),r.configurationModel});this.g=n.reduce((t,r)=>r===t?r:t.merge(r),n[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(n){return n?(0,m.getConfigurationValue)(this.contents,n):this.contents}inspect(n,t){const r=this.rawConfiguration.getValue(n),o=t?this.rawConfiguration.getOverrideValue(n,t):void 0,u=t?this.rawConfiguration.override(t).getValue(n):r;return{value:r,override:o,merged:u}}getOverrideValue(n,t){const r=this.l(t);return r?n?(0,m.getConfigurationValue)(r,n):r:void 0}getKeysForOverrideIdentifier(n){const t=[];for(const r of this.overrides)r.identifiers.includes(n)&&t.push(...r.keys);return T.distinct(t)}getAllOverrideIdentifiers(){const n=[];for(const t of this.overrides)n.push(...t.identifiers);return T.distinct(n)}override(n){let t=this.b.get(n);return t||(t=this.h(n),this.b.set(n,t)),t}merge(...n){const t=P.deepClone(this.contents),r=P.deepClone(this.overrides),o=[...this.keys],u=this.raw?.length?[...this.raw]:[this];for(const a of n)if(u.push(...a.raw?.length?a.raw:[a]),!a.isEmpty()){this.j(t,a.contents);for(const h of a.overrides){const[O]=r.filter(j=>T.equals(j.identifiers,h.identifiers));O?(this.j(O.contents,h.contents),O.keys.push(...h.keys),O.keys=T.distinct(O.keys)):r.push(P.deepClone(h))}for(const h of a.keys)o.indexOf(h)===-1&&o.push(h)}return new I(t,o,r,u.every(a=>a instanceof I)?void 0:u)}freeze(){return this.a=!0,this}clone(){return new I(P.deepClone(this.contents),[...this.keys],P.deepClone(this.overrides))}h(n){const t=this.l(n);if(!t||typeof t!="object"||!Object.keys(t).length)return this;const r={};for(const o of T.distinct([...Object.keys(this.contents),...Object.keys(t)])){let u=this.contents[o];const a=t[o];a&&(typeof u=="object"&&typeof a=="object"?(u=P.deepClone(u),this.j(u,a)):u=a),r[o]=u}return new I(r,this.keys,this.overrides)}j(n,t){for(const r of Object.keys(t)){if(r in n&&d.isObject(n[r])&&d.isObject(t[r])){this.j(n[r],t[r]);continue}n[r]=P.deepClone(t[r])}}k(n){return this.a&&!Object.isFrozen(n)?P.deepFreeze(n):n}l(n){let t=null,r=null;const o=u=>{u&&(r?this.j(r,u):r=P.deepClone(u))};for(const u of this.overrides)T.equals(u.identifiers,[n])?t=u.contents:u.identifiers.includes(n)&&o(u.contents);return o(t),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,t){this.m(n),(0,m.addToValueTree)(this.contents,n,t,r=>{throw new Error(r)})}removeValue(n){this.n(n)&&(0,m.removeFromValueTree)(this.contents,n)}m(n){let t=this.keys.length;for(let r=0;r<t;r++)n.indexOf(this.keys[r])===0&&(t=r);this.keys.splice(t,1,n)}n(n){const t=this.keys.indexOf(n);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=I;class w{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new I}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,t){if(!d.isUndefinedOrNull(n)){const r=this.g(n);this.parseRaw(r,t)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,t){this.a=n;const{contents:r,keys:o,overrides:u,restricted:a,hasExcludedProperties:h}=this.h(n,t);this.b=new I(r,o,u,h?[n]:void 0),this.c=a||[]}g(n){let t={},r=null,o=[];const u=[],a=[];function h(j){Array.isArray(o)?o.push(j):r!==null&&(o[r]=j)}const O={onObjectBegin:()=>{const j={};h(j),u.push(o),o=j,r=null},onObjectProperty:j=>{r=j},onObjectEnd:()=>{o=u.pop()},onArrayBegin:()=>{const j=[];h(j),u.push(o),o=j,r=null},onArrayEnd:()=>{o=u.pop()},onLiteralValue:h,onError:(j,x,K)=>{a.push({error:j,offset:x,length:K})}};if(n)try{k.visit(n,O),t=o[0]||{}}catch(j){console.error(`Error while parsing settings file ${this.f}: ${j}`),this.d=[j]}return t}h(n,t){const r=p.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),o=this.j(n,r,!0,t);n=o.raw;const u=(0,m.toValuesTree)(n,O=>console.error(`Conflict in settings file ${this.f}: ${O}`)),a=Object.keys(n),h=this.l(n,O=>console.error(`Conflict in settings file ${this.f}: ${O}`));return{contents:u,keys:a,overrides:h,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}j(n,t,r,o){let u=!1;if(!o?.scopes&&!o?.skipRestricted)return{raw:n,restricted:[],hasExcludedProperties:u};const a={},h=[];for(const O in n)if(y.OVERRIDE_PROPERTY_REGEX.test(O)&&r){const j=this.j(n[O],t,!1,o);a[O]=j.raw,u=u||j.hasExcludedProperties,h.push(...j.restricted)}else{const j=t[O],x=j?typeof j.scope<"u"?j.scope:3:void 0;j?.restricted&&h.push(O),(x===void 0||o.scopes===void 0||o.scopes.includes(x))&&!(o.skipRestricted&&j?.restricted)?a[O]=n[O]:u=!0}return{raw:a,restricted:h,hasExcludedProperties:u}}l(n,t){const r=[];for(const o of Object.keys(n))if(y.OVERRIDE_PROPERTY_REGEX.test(o)){const u={};for(const a in n[o])u[a]=n[o][a];r.push({identifiers:(0,y.overrideIdentifiersFromKey)(o),keys:Object.keys(u),contents:(0,m.toValuesTree)(u,t)})}return r}}e.ConfigurationModelParser=w;class S extends L.Disposable{constructor(n,t,r,o){super(),this.f=n,this.g=t,this.h=o,this.c=this.B(new D.Emitter),this.onDidChange=this.c.event,this.a=new w(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(r.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(D.Event.any(D.Event.filter(this.h.onDidFilesChange,u=>u.contains(this.f)),D.Event.filter(this.h.onDidRunOperation,u=>(u.isOperation(0)||u.isOperation(3)||u.isOperation(1)||u.isOperation(4))&&r.isEqual(u.resource,n)))(()=>this.c.fire()))}async loadConfiguration(){try{const n=await this.h.readFile(this.f);return this.a.parse(n.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new I}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=S;class E{constructor(n,t,r,o,u,a,h,O,j,x,K,X,ie){this.a=n,this.b=t,this.value=r,this.overrideIdentifiers=o,this.c=u,this.d=a,this.f=h,this.g=O,this.h=j,this.j=x,this.k=K,this.l=X,this.m=ie}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get z(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.z.merged}get userRemote(){return this.z.value!==void 0||this.z.override!==void 0?{value:this.z.value,override:this.z.override}:void 0}get B(){return this.A===void 0&&(this.A=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.A}get workspaceValue(){return this.B?.merged}get workspace(){return this.B?.value!==void 0||this.B?.override!==void 0?{value:this.B.value,override:this.B.override}:void 0}get E(){return this.D===void 0&&(this.D=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.D}get workspaceFolderValue(){return this.E?.merged}get workspaceFolder(){return this.E?.value!==void 0||this.E?.override!==void 0?{value:this.E.value,override:this.E.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class l{constructor(n,t,r,o,u=new I,a=new I,h=new N.ResourceMap,O=new I,j=new N.ResourceMap,x=!0){this.c=n,this.d=t,this.f=r,this.g=o,this.h=u,this.j=a,this.l=h,this.m=O,this.n=j,this.p=x,this.a=null,this.b=new N.ResourceMap,this.q=null}getValue(n,t,r){return this.s(n,t,r).getValue(n)}updateValue(n,t,r={}){let o;r.resource?(o=this.n.get(r.resource),o||(o=new I,this.n.set(r.resource,o))):o=this.m,t===void 0?o.removeValue(n):o.setValue(n,t),r.resource||(this.a=null)}inspect(n,t,r){const o=this.s(n,t,r),u=T.distinct(o.overrides.map(O=>O.identifiers).flat()).filter(O=>o.getOverrideValue(n,O)!==void 0),a=this.w(t.resource,r),h=t.resource?this.n.get(t.resource)||this.m:this.m;return new E(n,t,o.getValue(n),u.length?u:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),r?this.j.freeze():void 0,a?a.freeze():void 0,h.inspect(n,t.overrideIdentifier))}keys(n){const t=this.w(void 0,n);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.j=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,t){this.l.set(n,t),this.b.delete(n)}deleteFolderConfiguration(n){this.r.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,t){const r=[];if(!t){const{added:o,updated:u,removed:a}=f(this.c,n);t=[...o,...u,...a]}for(const o of t)for(const u of(0,y.overrideIdentifiersFromKey)(o)){const a=this.c.getKeysForOverrideIdentifier(u),h=n.getKeysForOverrideIdentifier(u),O=[...h.filter(j=>a.indexOf(j)===-1),...a.filter(j=>h.indexOf(j)===-1),...a.filter(j=>!P.equals(this.c.override(u).getValue(j),n.override(u).getValue(j)))];r.push([u,O])}return this.updateDefaultConfiguration(n),{keys:t,overrides:r}}compareAndUpdatePolicyConfiguration(n){const{added:t,updated:r,removed:o}=f(this.d,n),u=[...t,...r,...o];return u.length&&this.updatePolicyConfiguration(n),{keys:u,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:t,updated:r,removed:o,overrides:u}=f(this.applicationConfiguration,n),a=[...t,...r,...o];return a.length&&this.updateApplicationConfiguration(n),{keys:a,overrides:u}}compareAndUpdateLocalUserConfiguration(n){const{added:t,updated:r,removed:o,overrides:u}=f(this.localUserConfiguration,n),a=[...t,...r,...o];return a.length&&this.updateLocalUserConfiguration(n),{keys:a,overrides:u}}compareAndUpdateRemoteUserConfiguration(n){const{added:t,updated:r,removed:o,overrides:u}=f(this.remoteUserConfiguration,n),a=[...t,...r,...o];return a.length&&this.updateRemoteUserConfiguration(n),{keys:a,overrides:u}}compareAndUpdateWorkspaceConfiguration(n){const{added:t,updated:r,removed:o,overrides:u}=f(this.workspaceConfiguration,n),a=[...t,...r,...o];return a.length&&this.updateWorkspaceConfiguration(n),{keys:a,overrides:u}}compareAndUpdateFolderConfiguration(n,t){const r=this.r.get(n),{added:o,updated:u,removed:a,overrides:h}=f(r,t),O=[...o,...u,...a];return(O.length||!r)&&this.updateFolderConfiguration(n,t),{keys:O,overrides:h}}compareAndDeleteFolderConfiguration(n){const t=this.r.get(n);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:r,updated:o,removed:u,overrides:a}=f(t,void 0);return{keys:[...r,...o,...u],overrides:a}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(n,t,r){let o=this.t(t,r);return t.overrideIdentifier&&(o=o.override(t.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(o=o.merge(this.d)),o}t({resource:n},t){let r=this.u();if(t&&n){const o=t.getFolder(n);o&&(r=this.v(o.uri)||r);const u=this.n.get(n);u&&(r=r.merge(u))}return r}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(n){let t=this.b.get(n);if(!t){const r=this.u(),o=this.l.get(n);o?(t=r.merge(o),this.p&&(t=t.freeze()),this.b.set(n,t)):t=r}return t}w(n,t){if(t&&n){const r=t.getFolder(n);if(r)return this.l.get(r.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((n,t)=>{const{contents:r,overrides:o,keys:u}=this.l.get(t);return n.push([t,{contents:r,overrides:o,keys:u}]),n},[])}}allKeys(){const n=new Set;return this.c.freeze().keys.forEach(t=>n.add(t)),this.userConfiguration.freeze().keys.forEach(t=>n.add(t)),this.j.freeze().keys.forEach(t=>n.add(t)),this.l.forEach(t=>t.freeze().keys.forEach(r=>n.add(r))),[...n.values()]}x(){const n=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this.j.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this.l.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(r=>n.add(r))),[...n.values()]}y(n){const t=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(r=>t.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>t.add(r)),this.j.getKeysForOverrideIdentifier(n).forEach(r=>t.add(r)),this.l.forEach(r=>r.getKeysForOverrideIdentifier(n).forEach(o=>t.add(o))),[...t.values()]}static parse(n){const t=this.z(n.defaults),r=this.z(n.policy),o=this.z(n.application),u=this.z(n.user),a=this.z(n.workspace),h=n.folders.reduce((O,j)=>(O.set(c.URI.revive(j[0]),this.z(j[1])),O),new N.ResourceMap);return new l(t,r,o,u,new I,a,h,new I,new N.ResourceMap,!1)}static z(n){return new I(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=l;function g(...i){if(i.length===0)return{keys:[],overrides:[]};if(i.length===1)return i[0];const n=new Set,t=new Map;for(const o of i)o.keys.forEach(u=>n.add(u)),o.overrides.forEach(([u,a])=>{const h=(0,N.getOrSet)(t,u,new Set);a.forEach(O=>h.add(O))});const r=[];return t.forEach((o,u)=>r.push([u,[...o.values()]])),{keys:[...n.values()],overrides:r}}e.mergeChanges=g;class v{constructor(n,t,r,o){this.change=n,this.b=t,this.c=r,this.d=o,this.f=void 0;const u=new Set;n.keys.forEach(h=>u.add(h)),n.overrides.forEach(([,h])=>h.forEach(O=>u.add(O))),this.affectedKeys=[...u.values()];const a=new I;this.affectedKeys.forEach(h=>a.setValue(h,{})),this.a=a.contents}get previousConfiguration(){return!this.f&&this.b&&(this.f=l.parse(this.b.data)),this.f}affectsConfiguration(n,t){if(this.g(this.a,n)){if(t){const r=this.previousConfiguration?this.previousConfiguration.getValue(n,t,this.b?.workspace):void 0,o=this.c.getValue(n,t,this.d);return!P.equals(r,o)}return!0}return!1}g(n,t){let r=(0,m.toValuesTree)({[t]:!0},()=>{}),o;for(;typeof r=="object"&&(o=Object.keys(r)[0]);){if(n=n[o],!n)return!1;r=r[o]}return!0}}e.ConfigurationChangeEvent=v;function f(i,n){const{added:t,removed:r,updated:o}=s(n?.rawConfiguration,i?.rawConfiguration),u=[],a=i?.getAllOverrideIdentifiers()||[],h=n?.getAllOverrideIdentifiers()||[];if(n){const O=h.filter(j=>!a.includes(j));for(const j of O)u.push([j,n.getKeysForOverrideIdentifier(j)])}if(i){const O=a.filter(j=>!h.includes(j));for(const j of O)u.push([j,i.getKeysForOverrideIdentifier(j)])}if(n&&i){for(const O of a)if(h.includes(O)){const j=s({contents:i.getOverrideValue(void 0,O)||{},keys:i.getKeysForOverrideIdentifier(O)},{contents:n.getOverrideValue(void 0,O)||{},keys:n.getKeysForOverrideIdentifier(O)});u.push([O,[...j.added,...j.removed,...j.updated]])}}return{added:t,removed:r,updated:o,overrides:u}}function s(i,n){const t=i?n?i.keys.filter(u=>n.keys.indexOf(u)===-1):[...i.keys]:[],r=n?i?n.keys.filter(u=>i.keys.indexOf(u)===-1):[...n.keys]:[],o=[];if(i&&n){for(const u of n.keys)if(i.keys.indexOf(u)!==-1){const a=(0,m.getConfigurationValue)(n.contents,u),h=(0,m.getConfigurationValue)(i.contents,u);P.equals(a,h)||o.push(u)}}return{added:t,removed:r,updated:o}}}),define(Y[123],Z([0,1,19,4,2,29,5,21,65,40,9,38,37]),function($,e,T,D,k,L,N,P,d,c,m,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class I extends k.Disposable{constructor(){super(...arguments),this.a=this.B(new D.Emitter),this.onDidChangeConfiguration=this.a.event}get configurationModel(){return this.b||(this.b=new w(this.f())),this.b}async initialize(){return this.b=void 0,this.B(p.Registry.as(c.Extensions.Configuration).onDidUpdateConfiguration(({properties:g,defaultsOverrides:v})=>this.c(g,v))),this.configurationModel}reload(){return this.b=void 0,this.configurationModel}c(g,v){this.b=void 0,this.a.fire({defaults:this.configurationModel,properties:g})}f(){return{}}}e.DefaultConfiguration=I;class w extends d.ConfigurationModel{constructor(g={}){const v=p.Registry.as(c.Extensions.Configuration).getConfigurationProperties(),f=Object.keys(v),s=Object.create(null),i=[];for(const n in v){const t=g[n],r=t!==void 0?t:v[n].default;(0,P.addToValueTree)(s,n,r,o=>console.error(`Conflict in default settings: ${o}`))}for(const n of Object.keys(s))c.OVERRIDE_PROPERTY_REGEX.test(n)&&i.push({identifiers:(0,c.overrideIdentifiersFromKey)(n),keys:Object.keys(s[n]),contents:(0,P.toValuesTree)(s[n],t=>console.error(`Conflict in default settings file: ${t}`))});super(s,f,i)}}e.DefaultConfigurationModel=w;class S{constructor(){this.onDidChangeConfiguration=D.Event.None,this.configurationModel=new d.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=S;let E=class extends k.Disposable{get configurationModel(){return this.b}constructor(g,v,f){super(),this.c=g,this.f=v,this.g=f,this.a=this.B(new D.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new d.ConfigurationModel}async initialize(){return this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(g=>this.i(g))),this.B(this.c.onDidChangeConfiguration(async({properties:g})=>this.j(await this.h(g),!0))),this.b}async h(g){const v={},f=[],s=p.Registry.as(c.Extensions.Configuration).getConfigurationProperties();for(const i of g){const n=s[i];if(!n){f.push(i);continue}if(n.policy){if(n.type!=="string"&&n.type!=="number"){this.g.warn(`Policy ${n.policy.name} has unsupported type ${n.type}`);continue}f.push(i),v[n.policy.name]={type:n.type}}}return(0,N.isEmptyObject)(v)||await this.f.updatePolicyDefinitions(v),f}i(g){const v=p.Registry.as(c.Extensions.Configuration).getPolicyConfigurations(),f=(0,T.coalesce)(g.map(s=>v.get(s)));this.j(f,!0)}j(g,v){const f=p.Registry.as(c.Extensions.Configuration).getConfigurationProperties(),s=[],i=this.b.isEmpty();for(const n of g){const t=f[n]?.policy?.name;if(t){const r=this.f.getPolicyValue(t);(i?r!==void 0:!(0,L.equals)(this.b.getValue(n),r))&&s.push([n,r])}else this.b.getValue(n)!==void 0&&s.push([n,void 0])}if(s.length){const n=this.b;this.b=new d.ConfigurationModel;for(const t of n.keys)this.b.setValue(t,n.getValue(t));for(const[t,r]of s)r===void 0?this.b.removeValue(t):this.b.setValue(t,r);v&&this.a.fire(this.b)}}};E=de([_(1,y.IPolicyService),_(2,m.ILogService)],E),e.PolicyConfiguration=E}),define(Y[124],Z([0,1,3,4,2,17,21,65,123,38]),function($,e,T,D,k,L,N,P,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class m extends k.Disposable{constructor(p,I,w,S){super(),this.i=p,this.h=this.B(new D.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new d.DefaultConfiguration),this.c=w instanceof c.NullPolicyService?new d.NullPolicyConfiguration:this.B(new d.PolicyConfiguration(this.b,w,S)),this.f=this.B(new P.UserSettings(this.i,void 0,L.extUriBiasedIgnorePathCase,I)),this.a=new P.Configuration(this.b.configurationModel,this.c.configurationModel,new P.ConfigurationModel,new P.ConfigurationModel),this.g=this.B(new T.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:E,properties:l})=>this.k(E,l))),this.B(this.c.onDidChangeConfiguration(E=>this.l(E))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[p,I,w]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new P.Configuration(p,I,new P.ConfigurationModel,w)}getConfigurationData(){return this.a.toData()}getValue(p,I){const w=typeof p=="string"?p:void 0,S=(0,N.isConfigurationOverrides)(p)?p:(0,N.isConfigurationOverrides)(I)?I:{};return this.a.getValue(w,S,void 0)}updateValue(p,I,w,S){return Promise.reject(new Error("not supported"))}inspect(p){return this.a.inspect(p,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const p=await this.f.loadConfiguration();this.j(p)}j(p){const I=this.a.toData(),w=this.a.compareAndUpdateLocalUserConfiguration(p);this.m(w,I,2)}k(p,I){const w=this.a.toData(),S=this.a.compareAndUpdateDefaultConfiguration(p,I);this.m(S,w,7)}l(p){const I=this.a.toData(),w=this.a.compareAndUpdatePolicyConfiguration(p);this.m(w,I,7)}m(p,I,w){const S=new P.ConfigurationChangeEvent(p,{data:I},this.a);S.source=w,S.sourceConfig=this.n(w),this.h.fire(S)}n(p){switch(p){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=m}),define(Y[66],Z([0,1,16]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function D(c){return c.scheme===T.Schemas.vscodeRemote?c.authority:void 0}e.getRemoteAuthority=D;function k(c){if(!c)return;const m=c.indexOf("+");return m<0?c:c.substr(0,m)}e.getRemoteName=k;function L(c){return`/${c.quality??"oss"}-${c.commit??"dev"}`}e.getRemoteServerRootPath=L;function N(c){const{host:m,port:y}=d(c);if(typeof y>"u")throw new Error("Remote authority doesn't contain a port!");return{host:m,port:y}}e.parseAuthorityWithPort=N;function P(c,m){let{host:y,port:p}=d(c);return typeof p>"u"&&(p=m),{host:y,port:p}}e.parseAuthorityWithOptionalPort=P;function d(c){const m=c.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(m)return{host:m[1],port:parseInt(m[2],10)};const y=c.match(/^(\[[0-9a-z:]+\])$/);if(y)return{host:y[1],port:void 0};const p=c.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:c,port:void 0}}}),define(Y[27],Z([0,1,31,8,66]),function($,e,T,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.getWorkspaceSupportTypeMessage=L;function N(w){return w&&typeof w=="object"&&typeof w.id=="string"&&(!w.uuid||typeof w.uuid=="string")}e.isIExtensionIdentifier=N,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));var d;(function(w){w.WIN32_X64="win32-x64",w.WIN32_IA32="win32-ia32",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(d=e.TargetPlatform||(e.TargetPlatform={}));class c{constructor(S){this.value=S,this.c=S.toLowerCase()}static equals(S,E){if(typeof S>"u"||S===null)return typeof E>"u"||E===null;if(typeof E>"u"||E===null)return!1;if(typeof S=="string"||typeof E=="string"){const l=typeof S=="string"?S:S.value,g=typeof E=="string"?E:E.value;return T.equalsIgnoreCase(l,g)}return S.c===E.c}static toKey(S){return typeof S=="string"?S.toLowerCase():S.c}}e.ExtensionIdentifier=c;function m(w){return y(w)}e.isApplicationScopedExtension=m;function y(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.isLanguagePackExtension=y;function p(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=p;function I(w,S){if(S){const E=`onResolveRemoteAuthority:${(0,k.getRemoteName)(S)}`;return w.activationEvents?.indexOf(E)!==-1}return!1}e.isResolverExtension=I,e.IBuiltinExtensionsScannerService=(0,D.createDecorator)("IBuiltinExtensionsScannerService")}),define(Y[24],Z([0,1,31,23,27,12,11,10,35]),function($,e,T,D,k,L,N,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function c(n,t){return n.uuid&&t.uuid?n.uuid===t.uuid:n.id===t.id?!0:(0,T.compareIgnoreCase)(n.id,t.id)===0}e.areSameExtensions=c;const m=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class y{static create(t){const r=t.manifest?t.manifest.version:t.version,o=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new y(t.identifier,r,o)}static parse(t){const r=m.exec(t);return r&&r[1]&&r[2]?new y({id:r[1]},r[2],r[4]||void 0):null}constructor(t,r,o="undefined"){this.version=r,this.targetPlatform=o,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof y?c(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.ExtensionKey=y;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function I(n){const t=p.exec(n);return t&&t[1]?[S(t[1]),t[2]]:[S(n),void 0]}e.getIdAndVersion=I;function w(n,t){return`${n}.${t}`}e.getExtensionId=w;function S(n){return n.toLocaleLowerCase()}e.adoptToGalleryExtensionId=S;function E(n,t){return S(w(n,t))}e.getGalleryExtensionId=E;function l(n,t){const r=[],o=u=>{for(const a of r)if(a.some(h=>c(t(h),t(u))))return a;return null};for(const u of n){const a=o(u);a?a.push(u):r.push([u])}return r}e.groupByExtension=l;function g(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=g;function v(n){return{id:n.identifier.id,name:n.name,galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.getGalleryExtensionTelemetryData=v,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function f(n,t){const r=[],o=t.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const u=o.shift();if(u&&r.every(a=>!c(a.identifier,{id:u}))){const a=n.filter(h=>c(h.identifier,{id:u}));a.length===1&&(r.push(a[0]),o.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=f;async function s(n,t){if(!L.isLinux)return!1;let r;try{r=(await n.readFile(N.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await n.readFile(N.URI.file("/usr/lib/os-release"))).value.toString()}catch(u){t.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(u))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=s;async function i(n,t){const r=await s(n,t),o=(0,D.getTargetPlatform)(r?"alpine":L.platform,d.arch);return t.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=i}),define(Y[125],Z([0,1,22,10,16,17,39,11,88,23,24,27]),function($,e,T,D,k,L,N,P,d,c,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const p=E=>(0,d.localize)(0,null,E),I=(0,d.localize)(1,null,"ms-dotnettools.csharp");function w(E,l){return l?`${E.publisher}.${E.name}@${E.version}`:`${E.publisher}.${E.name}`}let S=class{constructor(l,g){this.a=l,this.b=g}get d(){}async listExtensions(l,g,v,f=console){let s=await this.a.getInstalled(1,v);const i=y.EXTENSION_CATEGORIES.map(t=>t.toLowerCase());if(g&&g!==""){if(i.indexOf(g.toLowerCase())<0){f.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}s=s.filter(t=>t.manifest.categories?t.manifest.categories.map(o=>o.toLowerCase()).indexOf(g.toLowerCase())>-1:!1)}else if(g===""){f.log("Possible Categories: "),i.forEach(t=>{f.log(t)});return}this.d&&f.log((0,d.localize)(2,null,this.d)),s=s.sort((t,r)=>t.identifier.id.localeCompare(r.identifier.id));let n;for(const t of s)n!==t.identifier.id&&(n=t.identifier.id,f.log(w(t.manifest,l)))}async installExtensions(l,g,v,f,s=console){const i=[],n=[];l.length&&s.log(this.d?(0,d.localize)(3,null,this.d):(0,d.localize)(4,null));const t=await this.a.getInstalled(1,v.profileLocation),r=(h,O)=>{const j=t.find(x=>(0,m.areSameExtensions)(x.identifier,{id:h}));if(j){if(!f&&(!O||O==="prerelease"&&j.preRelease))return s.log((0,d.localize)(5,null,h,j.manifest.version,h)),!1;if(O&&j.manifest.version===O)return s.log((0,d.localize)(6,null,`${h}@${O}`)),!1}return!0},o=(h,O,j)=>{a.push({id:h,version:O!=="prerelease"?O:void 0,installOptions:{...v,isBuiltin:j,installPreReleaseVersion:O==="prerelease"||v.installPreReleaseVersion}})},u=[],a=[];for(const h of l)if(h instanceof P.URI)u.push(h);else{const[O,j]=(0,m.getIdAndVersion)(h);r(O,j)&&o(O,j,!1)}for(const h of g){const[O,j]=(0,m.getIdAndVersion)(h);r(O,j)&&o(O,j,!0)}if(u.length&&await Promise.all(u.map(async h=>{try{const O=await this.f(h,{...v,isBuiltin:!1},f,s);O&&n.push(O)}catch(O){s.error(O.message||O.stack||O),i.push(h.toString())}})),a.length){const h=await this.g(a);await Promise.all(a.map(async O=>{const j=h.get(O.id.toLowerCase());if(j)try{const x=await this.h(O,j,t,f,s);x&&n.push(x)}catch(x){s.error(x.message||x.stack||x),i.push(O.id)}else s.error(`${p(O.version?`${O.id}@${O.version}`:O.id)}
${I}`),i.push(O.id)}))}if(i.length)throw new Error((0,d.localize)(7,null,i.join(", ")))}async f(l,g,v,f){const s=await this.a.getManifest(l);if(!s)throw new Error("Invalid vsix");if(await this.k(s,v,g.profileLocation,f))try{return await this.a.install(l,g),f.log((0,d.localize)(8,null,(0,L.basename)(l))),s}catch(n){if((0,D.isCancellationError)(n))return f.log((0,d.localize)(9,null,(0,L.basename)(l))),null;throw n}return null}async g(l){const g=new Map,v=l.some(s=>s.installOptions.installPreReleaseVersion),f=await this.b.getExtensions(l.map(s=>({...s,preRelease:v})),T.CancellationToken.None);for(const s of f)g.set(s.identifier.id.toLowerCase(),s);return g}async h({id:l,version:g,installOptions:v},f,s,i,n){const t=await this.b.getManifest(f,T.CancellationToken.None);if(t&&!this.j(t,n))return null;const r=s.find(o=>(0,m.areSameExtensions)(o.identifier,f.identifier));if(r){if(f.version===r.manifest.version)return n.log((0,d.localize)(10,null,g?`${l}@${g}`:l)),null;n.log((0,d.localize)(11,null,l,f.version))}try{v.isBuiltin?n.log(g?(0,d.localize)(12,null,l,g):(0,d.localize)(13,null,l)):n.log(g?(0,d.localize)(14,null,l,g):(0,d.localize)(15,null,l));const o=await this.a.installFromGallery(f,{...v,installGivenVersion:!!g});return n.log((0,d.localize)(16,null,l,o.manifest.version)),t}catch(o){if((0,D.isCancellationError)(o))return n.log((0,d.localize)(17,null,l)),null;throw o}}j(l,g){return!0}async k(l,g,v,f){const s={id:(0,m.getGalleryExtensionId)(l.publisher,l.name)},n=(await this.a.getInstalled(1,v)).find(t=>(0,m.areSameExtensions)(s,t.identifier)&&(0,N.gt)(t.manifest.version,l.version));return n&&!g?(f.log((0,d.localize)(18,null,n.identifier.id,n.manifest.version,l.version)),!1):this.j(l,f)}async uninstallExtensions(l,g,v,f=console){const s=async n=>{if(n instanceof P.URI){const t=await this.a.getManifest(n);return w(t)}return n},i=[];for(const n of l){const t=await s(n),o=(await this.a.getInstalled(void 0,v)).filter(u=>(0,m.areSameExtensions)(u.identifier,{id:t}));if(!o.length)throw new Error(`${this.l(t)}
${I}`);if(o.some(u=>u.type===0)){f.log((0,d.localize)(19,null,t));return}if(!g&&o.some(u=>u.isBuiltin)){f.log((0,d.localize)(20,null,t));return}f.log((0,d.localize)(21,null,t));for(const u of o)await this.a.uninstall(u,{profileLocation:v}),i.push(u);this.d?f.log((0,d.localize)(22,null,t,this.d)):f.log((0,d.localize)(23,null,t))}}async locateExtension(l,g=console){const v=await this.a.getInstalled();l.forEach(f=>{v.forEach(s=>{if(s.identifier.id===f&&s.location.scheme===k.Schemas.file){g.log(s.location.fsPath);return}})})}l(l){return this.d?(0,d.localize)(24,null,l,this.d):(0,d.localize)(25,null,l)}};S=de([_(0,c.IExtensionManagementService),_(1,c.IExtensionGalleryService)],S),e.ExtensionManagementCLI=S}),define(Y[126],Z([0,1,3,10,2,16,12,17,39,5,30,20,21,18,23,24,59,13,9,26]),function($,e,T,D,k,L,N,P,d,c,m,y,p,I,w,S,E,l,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let f=class Ve extends k.Disposable{constructor(i,n,t,r,o,u,a,h){super(),this.h=i,this.i=t,this.j=r,this.k=o,this.l=u,this.m=a,this.n=h,this.extensionsDownloadDir=n.extensionsDownloadLocation,this.f=20,this.g=this.w()}async download(i,n){await this.g;const t=(0,P.joinPath)(this.extensionsDownloadDir,this.y(i));try{await this.u(i,t,o=>this.j.download(i,o,n))}catch(o){throw new w.ExtensionManagementError(o.message,w.ExtensionManagementErrorCode.Download)}let r=!1;if(await this.r(i)){const o=await this.t(i);try{r=await this.m.verify(t.fsPath,o.fsPath),this.n.info(`Verified extension: ${i.identifier.id}`,r)}catch(u){throw await this.delete(o),await this.delete(t),new w.ExtensionManagementError(u.code,w.ExtensionManagementErrorCode.Signature)}}return{location:t,verified:r}}async r(i){if(!i.isSigned||await this.h==="linux-armhf")return!1;const t=this.k.getValue("extensions.verifySignature");return(0,c.isBoolean)(t)?t:this.l.quality!=="stable"}async t(i){await this.g;const n=(0,P.joinPath)(this.extensionsDownloadDir,`${this.y(i)}${Ve.c}`);return await this.u(i,n,t=>this.j.downloadSignatureArchive(i,t)),n}async u(i,n,t){if(await this.i.exists(n))return;if(n.scheme!==L.Schemas.file){await t(n);return}const r=(0,P.joinPath)(this.extensionsDownloadDir,`.${(0,m.generateUuid)()}`);await this.i.exists(r)||await t(r);try{await this.v(r,n,Date.now()+2*60*1e3)}catch(o){try{await this.i.del(r)}catch{}if(o.code==="ENOTEMPTY")this.n.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,n.path);else throw this.n.info(`Rename failed because of ${(0,D.getErrorMessage)(o)}. Deleted the file from downloaded location`,r.path),o}}async delete(i){await this.g,await this.i.del(i)}async v(i,n,t){try{await y.Promises.rename(i.fsPath,n.fsPath)}catch(r){if(N.isWindows&&r&&r.code==="EPERM"&&Date.now()<t)return this.n.info(`Failed renaming ${i} to ${n} with 'EPERM' error. Trying again...`),this.v(i,n,t);throw r}}async w(){try{if(!await this.i.exists(this.extensionsDownloadDir)){this.n.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.i.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const n=[],t=[],r=[];for(const a of i.children)if(a.name.endsWith(Ve.c))r.push(a.resource);else{const h=S.ExtensionKey.parse(a.name);h&&t.push([h,a])}const o=(0,S.groupByExtension)(t,([a])=>a),u=[];for(const a of o)a.sort((h,O)=>d.rcompare(h[0].version,O[0].version)),n.push(...a.slice(1).map(h=>h[1].resource)),u.push(a[0][1]);u.sort((a,h)=>a.mtime-h.mtime),n.push(...u.slice(0,Math.max(0,u.length-this.f)).map(a=>a.resource)),n.push(...r),await T.Promises.settled(n.map(a=>(this.n.trace("Deleting from cache",a.path),this.i.del(a))))}}catch(i){this.n.error(i)}}y(i){return this.f?S.ExtensionKey.create(i).toString().toLowerCase():(0,m.generateUuid)()}};f.c=".sigzip",f=de([_(1,I.INativeEnvironmentService),_(2,l.IFileService),_(3,w.IExtensionGalleryService),_(4,p.IConfigurationService),_(5,v.IProductService),_(6,E.IExtensionSignatureVerificationService),_(7,g.ILogService)],f),e.ExtensionsDownloader=f}),define(Y[127],Z([0,1,2,14,20,27]),function($,e,T,D,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class N extends T.Disposable{constructor(d,c){super(),this.b=d,this.a=(0,D.join)(this.b.userDataPath,L.MANIFEST_CACHE_FOLDER,L.USER_MANIFEST_CACHE_FILE),this.B(c.onDidInstallExtensions(m=>this.c(m))),this.B(c.onDidUninstallExtension(m=>this.f(m)))}c(d){d.some(c=>!!c.local)&&this.invalidate()}f(d){d.error||this.invalidate()}invalidate(){k.Promises.rm(this.a,k.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=N}),define(Y[128],Z([0,1,4,2,36,24,27]),function($,e,T,D,k,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class P extends D.Disposable{constructor(c,m,y,p,I,w,S){super(),this.f=c,this.g=m,this.h=y,this.i=p,this.j=I,this.k=w,this.l=S,this.a=this.B(new T.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new D.DisposableMap),this.m().then(null,E=>S.error(E))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.C()}n(){this.B(this.h.onDidChangeProfiles(c=>this.p(c.added,c.removed))),this.B(this.i.onAddExtensions(c=>this.r(c))),this.B(this.i.onDidAddExtensions(c=>this.s(c))),this.B(this.i.onRemoveExtensions(c=>this.t(c))),this.B(this.i.onDidRemoveExtensions(c=>this.u(c))),this.B(this.k.onDidFilesChange(c=>this.v(c)))}async p(c,m){try{await Promise.all(m.map(y=>(this.c.deleteAndDispose(y.id),this.z(y.extensionsResource))))}catch(y){this.l.error(y)}try{c.length&&await Promise.all(c.map(y=>(this.c.set(y.id,(0,D.combinedDisposable)(this.k.watch(this.j.extUri.dirname(y.extensionsResource)),this.k.watch(y.extensionsResource))),this.y(y.extensionsResource))))}catch(y){this.l.error(y)}}async r(c){for(const m of c.extensions)this.D(this.G(m.identifier,m.version),c.profileLocation)}async s(c){for(const m of c.extensions){const y=this.G(m.identifier,m.version);c.error?this.F(y,c.profileLocation):this.D(y,c.profileLocation)}}async t(c){for(const m of c.extensions)this.F(this.G(m.identifier,m.version),c.profileLocation)}async u(c){let m=!1;for(const y of c.extensions){const p=this.G(y.identifier,y.version);c.error?this.D(p,c.profileLocation):(this.F(p,c.profileLocation),m=m||!this.b.has(p))}m&&await this.C()}v(c){for(const m of this.h.profiles)c.contains(m.extensionsResource,0,1)&&this.w(m.extensionsResource)}async w(c){const m=[],y=[],p=await this.i.scanProfileExtensions(c),I=new Set,w=new Set;for(const[S,E]of this.b)E.has(c)&&w.add(S);for(const S of p){const E=this.G(S.identifier,S.version);I.add(E),w.has(E)||(m.push(S.identifier),this.D(E,c))}for(const S of w)if(!I.has(S)){const E=this.H(S);E&&(y.push(E.identifier),this.F(S,c))}(m.length||y.length)&&this.a.fire({added:m.length?{extensions:m,profileLocation:c}:void 0,removed:y.length?{extensions:y,profileLocation:c}:void 0})}async y(c){const m=await this.i.scanProfileExtensions(c);for(const y of m)this.D(this.G(y.identifier,y.version),c)}async z(c){for(const m of[...this.b.keys()])this.F(m,c);await this.C()}async C(){const m=(await this.f.getAllUserInstalled()).filter(y=>y.installedTimestamp&&!this.b.has(this.G(y.identifier,y.manifest.version)));m.length&&await this.f.markAsUninstalled(...m)}D(c,m){let y=this.b.get(c);y||this.b.set(c,y=new k.ResourceSet(p=>this.j.extUri.getComparisonKey(p))),y.add(m)}F(c,m){const y=this.b.get(c);y&&y.delete(m),y?.size||this.b.delete(c)}G(c,m){return`${N.ExtensionIdentifier.toKey(c.id)}@${m}`}H(c){const[m,y]=(0,L.getIdAndVersion)(c);return y?{identifier:{id:m},version:y}:void 0}}e.ExtensionsWatcher=P}),define(Y[129],Z([0,1,160,19,3,2,16,14,20,18,23,24,9,63,12,11]),function($,e,T,D,k,L,N,P,d,c,m,y,p,I,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let E=class extends I.LanguagePackBaseService{constructor(f,s,i,n){super(i),this.h=f,this.i=n,this.g=this.B(new l(s,n)),this.h.registerParticipant({postInstall:async t=>this.j(t),postUninstall:async t=>this.k(t)})}async getBuiltInExtensionTranslationsUri(f){const i=(await this.g.getLanguagePacks())[w.Language.value()];if(!i){this.i.warn(`No language pack found for ${w.Language.value()}`);return}const n=i.translations[f];return n?S.URI.file(n):void 0}async getInstalledLanguages(){const f=await this.g.getLanguagePacks(),s=Object.keys(f).map(i=>{const n=f[i];return{...this.f(i,n.label),extensionId:n.extensions[0].extensionIdentifier.id}});return s.push({...this.f("en","English"),extensionId:"default"}),s.sort((i,n)=>i.label.localeCompare(n.label)),s}async j(f){f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",f.identifier.id),await this.update())}async k(f){const s=await this.g.getLanguagePacks();Object.keys(s).some(i=>s[i]&&s[i].extensions.some(n=>(0,y.areSameExtensions)(n.extensionIdentifier,f.identifier)))&&(this.i.info("Removing language packs from the extension",f.identifier.id),await this.update())}async update(){const[f,s]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),i=await this.g.update(s);return!(0,D.equals)(Object.keys(f),Object.keys(i))}};E=de([_(0,m.IExtensionManagementService),_(1,c.INativeEnvironmentService),_(2,m.IExtensionGalleryService),_(3,p.ILogService)],E),e.NativeLanguagePackService=E;let l=class extends L.Disposable{constructor(f,s){super(),this.i=s,this.c={},this.f=(0,P.join)(f.userDataPath,"languagepacks.json"),this.g=new k.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(f){return this.m(s=>{Object.keys(s).forEach(i=>delete s[i]),this.j(s,...f)}).then(()=>this.c)}j(f,...s){for(const i of s)i&&i.manifest&&i.manifest.contributes&&i.manifest.contributes.localizations&&i.manifest.contributes.localizations.length&&this.k(f,i);Object.keys(f).forEach(i=>this.l(f[i]))}k(f,s){const i=s.identifier,n=s.manifest.contributes&&s.manifest.contributes.localizations?s.manifest.contributes.localizations:[];for(const t of n)if(s.location.scheme===N.Schemas.file&&g(t)){let r=f[t.languageId];r||(r={hash:"",extensions:[],translations:{},label:t.localizedLanguageName??t.languageName},f[t.languageId]=r);const o=r.extensions.filter(u=>(0,y.areSameExtensions)(u.extensionIdentifier,i))[0];o?o.version=s.manifest.version:r.extensions.push({extensionIdentifier:i,version:s.manifest.version});for(const u of t.translations)r.translations[u.id]=(0,P.join)(s.location.fsPath,u.path)}}l(f){if(f){const s=(0,T.createHash)("md5");for(const i of f.extensions)s.update(i.extensionIdentifier.uuid||i.extensionIdentifier.id).update(i.version);f.hash=s.digest("hex")}}m(f=()=>null){return this.g.queue(()=>{let s=null;return d.Promises.readFile(this.f,"utf8").then(void 0,i=>i.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(i)).then(i=>{try{return JSON.parse(i)}catch{return{}}}).then(i=>(s=f(i),i)).then(i=>{for(const t of Object.keys(i))i[t]||delete i[t];this.c=i,this.h=!0;const n=JSON.stringify(this.c);return this.i.debug("Writing language packs",n),d.Promises.writeFile(this.f,n)}).then(()=>s,i=>this.i.error(i))})}};l=de([_(0,c.INativeEnvironmentService),_(1,p.ILogService)],l);function g(v){if(typeof v.languageId!="string"||!Array.isArray(v.translations)||v.translations.length===0)return!1;for(const f of v.translations)if(typeof f.id!="string"||typeof f.path!="string")return!1;return!(v.languageName&&typeof v.languageName!="string"||v.localizedLanguageName&&typeof v.localizedLanguageName!="string")}}),define(Y[47],Z([0,1,15,98,40,8,37]),function($,e,T,D,k,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,L.createDecorator)("requestService");function P(S){return S.res.statusCode&&S.res.statusCode>=200&&S.res.statusCode<300||S.res.statusCode===1223}e.isSuccess=P;function d(S){return S.res.statusCode===204}async function c(S){return d(S)?null:(await(0,T.streamToBuffer)(S.stream)).toString()}e.asText=c;async function m(S){if(!P(S))throw new Error("Server returned "+S.res.statusCode);return c(S)}e.asTextOrError=m;async function y(S){if(!P(S))throw new Error("Server returned "+S.res.statusCode);if(d(S))return null;const l=(await(0,T.streamToBuffer)(S.stream)).toString();try{return JSON.parse(l)}catch(g){throw g.message+=`:
`+l,g}}e.asJson=y;function p(S){w(S)}e.updateProxyConfigurationsScope=p;let I;function w(S){const E=N.Registry.as(k.Extensions.Configuration),l=I;I={id:"http",order:15,title:(0,D.localize)(0,null),type:"object",scope:S,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,D.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,D.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,D.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,D.localize)(4,null),(0,D.localize)(5,null),(0,D.localize)(6,null),(0,D.localize)(7,null)],default:"override",description:(0,D.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,D.localize)(9,null),restricted:!0}}},E.updateConfigurations({add:[I],remove:l?[l]:[]})}w(2)}),define(Y[130],Z([0,1,22,16,13,47]),function($,e,T,D,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let N=class{constructor(d,c){this.a=d,this.b=c}async download(d,c,m=T.CancellationToken.None){if(d.scheme===D.Schemas.file||d.scheme===D.Schemas.vscodeRemote){await this.b.copy(d,c);return}const y={type:"GET",url:d.toString(!0)},p=await this.a.request(y,m);if(p.res.statusCode===200)await this.b.writeFile(c,p.stream);else{const I=await(0,L.asTextOrError)(p);throw new Error(`Expected 200, got back ${p.res.statusCode} instead.

${I}`)}}};N=de([_(0,L.IRequestService),_(1,k.IFileService)],N),e.DownloadService=N}),define(Y[131],Z([0,1,132,5]),function($,e,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(N,P){return N.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:N.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function L(N,P,d={}){const c=(0,T.parse)(N),m=d.proxyUrl||k(c,P);if(!m)return null;const y=(0,T.parse)(m);if(!/^https?:$/.test(y.protocol||""))return null;const p={host:y.hostname||"",port:y.port||(y.protocol==="https"?"443":"80"),auth:y.auth,rejectUnauthorized:(0,D.isBoolean)(d.strictSSL)?d.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((I,w)=>{$(["http-proxy-agent"],I,w)}))(p):new(await new Promise((I,w)=>{$(["https-proxy-agent"],I,w)}))(p)}e.getProxyAgent=L}),define(Y[133],Z([0,1,57,14,99,22,34,10,12,30,81,161,3]),function($,e,T,D,k,L,N,P,d,c,m,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const I=1e4;let w;async function S(l,g,v){return g["force-disable-user-env"]?(l.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):d.isWindows?(l.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,y.isLaunchedFromCli)(v)&&!g["force-user-env"]?(l.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,y.isLaunchedFromCli)(v)?l.trace("resolveShellEnv(): running (--force-user-env)"):l.trace("resolveShellEnv(): running (macOS/Linux)"),w||(w=p.Promises.withAsyncBody(async(f,s)=>{const i=new L.CancellationTokenSource,n=setTimeout(()=>{i.dispose(!0),s(new Error((0,k.localize)(0,null)))},I);try{f(await E(l,i.token))}catch(t){!(0,P.isCancellationError)(t)&&!i.token.isCancellationRequested?s(new Error((0,k.localize)(1,null,(0,N.toErrorMessage)(t)))):f({})}finally{clearTimeout(n),i.dispose()}})),w)}e.getResolvedShellEnv=S;async function E(l,g){const v=process.env.ELECTRON_RUN_AS_NODE;l.trace("getUnixShellEnvironment#runAsNode",v);const f=process.env.ELECTRON_NO_ATTACH_CONSOLE;l.trace("getUnixShellEnvironment#noAttach",f);const s=(0,c.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(s+"(.*)"+s),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};l.trace("getUnixShellEnvironment#env",n);const t=await(0,m.getSystemShell)(d.OS,n);return l.trace("getUnixShellEnvironment#shell",t),new Promise((r,o)=>{if(g.isCancellationRequested)return o((0,P.canceled)());const u=(0,D.basename)(t);let a,h;const O=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(u)?(a=`& '${process.execPath}' ${O} -p '''${s}'' + JSON.stringify(process.env) + ''${s}'''`,h=["-Login","-Command"]):(a=`'${process.execPath}' ${O} -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,u==="tcsh"?h=["-ic"]:h=["-ilc"]),l.trace("getUnixShellEnvironment#spawn",JSON.stringify(h),a);const j=(0,T.spawn)(t,[...h,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});g.onCancellationRequested(()=>(j.kill(),o((0,P.canceled)()))),j.on("error",X=>{l.error("getUnixShellEnvironment#errorChildProcess",(0,N.toErrorMessage)(X)),o(X)});const x=[];j.stdout.on("data",X=>x.push(X));const K=[];j.stderr.on("data",X=>K.push(X)),j.on("close",(X,ie)=>{const ne=Buffer.concat(x).toString("utf8");l.trace("getUnixShellEnvironment#raw",ne);const Q=Buffer.concat(K).toString("utf8");if(Q.trim()&&l.trace("getUnixShellEnvironment#stderr",Q),X||ie)return o(new Error((0,k.localize)(2,null,X,ie)));const ge=i.exec(ne),ce=ge?ge[1]:"{}";try{const re=JSON.parse(ce);v?re.ELECTRON_RUN_AS_NODE=v:delete re.ELECTRON_RUN_AS_NODE,f?re.ELECTRON_NO_ATTACH_CONSOLE=f:delete re.ELECTRON_NO_ATTACH_CONSOLE,delete re.XDG_RUNTIME_DIR,l.trace("getUnixShellEnvironment#result",re),r(re)}catch(re){l.error("getUnixShellEnvironment#errorCaught",(0,N.toErrorMessage)(re)),o(re)}})})}}),define(Y[67],Z([0,1,8]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,T.createDecorator)("stateService")}),define(Y[134],Z([0,1,3,15,5,18,13,9]),function($,e,T,D,k,L,N,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class d{constructor(y,p,I){this.f=y,this.g=p,this.h=I,this.a=Object.create(null),this.b="",this.c=new T.ThrottledDelayer(100),this.d=void 0,this.e=void 0}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(y){y.fileOperationResult!==1&&this.g.error(y)}}getItem(y,p){const I=this.a[y];return(0,k.isUndefinedOrNull)(I)?p:I}setItem(y,p){this.setItems([{key:y,data:p}])}setItems(y){let p=!1;for(const{key:I,data:w}of y)this.a[I]!==w&&((0,k.isUndefinedOrNull)(w)?(0,k.isUndefined)(this.a[I])||(this.a[I]=void 0,p=!0):(this.a[I]=w,p=!0));p&&this.j()}removeItem(y){(0,k.isUndefined)(this.a[y])||(this.a[y]=void 0,this.j())}async j(){if(!this.e)return this.c.trigger(()=>this.k())}async k(){if(!this.d)return;await this.d;const y=JSON.stringify(this.a,null,4);if(y!==this.b)try{await this.h.writeFile(this.f,D.VSBuffer.fromString(y)),this.b=y}catch(p){this.g.error(p)}}async close(){return this.e||(this.e=this.c.trigger(()=>this.k(),0)),this.e}}e.FileStorage=d;let c=class{constructor(y,p,I){this.a=new d(y.stateResource,p,I)}async init(){await this.a.init()}getItem(y,p){return this.a.getItem(y,p)}};c=de([_(0,L.IEnvironmentService),_(1,P.ILogService),_(2,N.IFileService)],c),e.StateService=c}),define(Y[68],Z([0,1,12,35,11,30]),function($,e,T,D,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function N(c){if(T.platform===2&&/^penguin(\.|$)/i.test(c))return"chromebook"}async function P(c,m,y,p,I,w,S,E,l,g){const v=Object.create(null);v["common.machineId"]=S,v.sessionID=(0,L.generateUuid)()+Date.now(),v.commitHash=I,v.version=w,v["common.platformVersion"]=(m||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),v["common.platform"]=(0,T.PlatformToString)(T.platform),v["common.nodePlatform"]=D.platform,v["common.nodeArch"]=p,v["common.product"]=g||"desktop",E&&(v["common.msftInternal"]=E);let f=0;const s=Date.now();Object.defineProperties(v,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),T.isLinuxSnap&&(v["common.snap"]="true");const i=N(y);i&&(v["common.platformDetail"]=i);try{const n=await c.readFile(k.URI.file(l));v["common.source"]=n.value.toString().slice(0,30)}catch{}return v}e.resolveCommonProperties=P;function d(c){const m=D.env.USERDNSDOMAIN;if(!m)return!1;const y=m.toLowerCase();return c.some(p=>y===p)}e.verifyMicrosoftInternalDomain=d}),define(Y[32],Z([0,1,8]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,T.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,T.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var D;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(D=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Y[41],Z([0,1,29,5,21,66,68,32]),function($,e,T,D,k,L,N,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TrustedTelemetryValue=void 0;class d{constructor(u){this.value=u}}e.TrustedTelemetryValue=d;class c{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(u,a){return Promise.resolve(void 0)}publicLog2(u,a){return this.publicLog(u,a)}publicLogError(u,a){return Promise.resolve(void 0)}publicLogError2(u,a){return this.publicLogError(u,a)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=c,e.NullTelemetryService=new c;class m{async publicLog(u,a,h){}async publicLogError(u,a,h){}}e.NullEndpointTelemetryService=m,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function y(o,u){return u.onDidChangeConfiguration(a=>{a.source!==7&&o.publicLog2("updateConfiguration",{configurationSource:(0,k.ConfigurationTargetToString)(a.source),configurationKeys:v(a.sourceConfig)})})}e.configurationTelemetry=y;function p(o,u){return!u.isBuilt&&!u.disableTelemetry?!0:!(u.disableTelemetry||!o.enableTelemetry||u.extensionTestsLocationURI)}e.supportsTelemetry=p;function I(o,u){return!(u.isBuilt||u.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}e.isLoggingOnly=I;function w(o){const u=o.getValue(P.TELEMETRY_SETTING_ID),a=o.getValue("telemetry.enableCrashReporter");if(o.getValue(P.TELEMETRY_OLD_SETTING_ID)===!1||a===!1)return 0;switch(u??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=w;function S(o){const u={},a={},h={};g(o,h);for(let O in h){O=O.length>150?O.substr(O.length-149):O;const j=h[O];typeof j=="number"?a[O]=j:typeof j=="boolean"?a[O]=j?1:0:typeof j=="string"?(j.length>8192&&console.warn(`Telemetry property: ${O} has been trimmed to 8192, the original length is ${j.length}`),u[O]=j.substring(0,8191)):typeof j<"u"&&j!==null&&(u[O]=j)}return{properties:u,measurements:a}}e.validateTelemetryData=S;const E=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function l(o){if(!o)return"none";const u=(0,L.getRemoteName)(o);return E.has(u)?u:"other"}e.cleanRemoteAuthority=l;function g(o,u,a=0,h){if(!!o)for(const O of Object.getOwnPropertyNames(o)){const j=o[O],x=h?h+O:O;Array.isArray(j)?u[x]=(0,T.safeStringify)(j):j instanceof Date?u[x]=j.toISOString():(0,D.isObject)(j)?a<2?g(j,u,a+1,x+"."):u[x]=(0,T.safeStringify)(j):u[x]=j}}function v(o){if(!o)return[];const u=[];return f(u,"",o),u}function f(o,u,a){a&&typeof a=="object"&&!Array.isArray(a)?Object.keys(a).forEach(h=>f(o,u?`${u}.${h}`:h,a[h])):o.push(u)}function s(o,u){const a=o.msftInternalDomains||[],h=u.getValue("telemetry.internalTesting");return(0,N.verifyMicrosoftInternalDomain)(a)||h}e.isInternalTelemetry=s;function i(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}e.getPiiPathsFromEnvironment=i;function n(o,u){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let a=o;const h=[];for(const K of u)for(;;){const X=K.exec(o);if(!X)break;h.push([X.index,K.lastIndex])}const O=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,j=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let x=0;for(a="";;){const K=j.exec(o);if(!K)break;const X=h.some(([ie,ne])=>K.index<ne&&ie<j.lastIndex);!O.test(K[0])&&!X&&(a+=o.substring(x,K.index)+"<REDACTED: user-file-path>",x=j.lastIndex)}return x<o.length&&(a+=o.substr(x)),a}function t(o){if(!o)return o;const u=o.toLowerCase(),a=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const h of a)if(h.regex.test(u))return`<REDACTED: ${h.label}>`;return o}function r(o,u){return(0,T.cloneAndChange)(o,a=>{if(a instanceof d)return a.value;if(typeof a=="string"){let h=a.replaceAll("%20"," ");h=n(h,u);for(const O of u)h=h.replace(O,"");return h=t(h),h}})}e.cleanData=r}),define(Y[135],Z([0,1,108,41]),function($,e,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function k(L,N,P,d,c,m,y){const p={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${N.nameShort})`};if((0,D.supportsTelemetry)(N,P)&&(0,D.getTelemetryLevel)(d)===3){const I=await(0,T.getServiceMachineId)(P,c,m),{machineId:w}=await y.getTelemetryInfo();p["X-Market-User-Id"]=I,p["VSCode-SessionId"]=w||I}return p}e.resolveMarketplaceHeaders=k}),define(Y[136],Z([0,1,10,29,41]),function($,e,T,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const L="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function N(d,c,m){const y=await new Promise((E,l)=>{$(["@microsoft/1ds-core-js"],E,l)}),p=await new Promise((E,l)=>{$(["@microsoft/1ds-post-js"],E,l)}),I=new y.AppInsightsCore,w=new p.PostChannel,S={instrumentationKey:d,endpointUrl:L,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[w]]};if(m){S.extensionConfig={};const E={alwaysUseXhrOverride:!0,httpXHROverride:m};S.extensionConfig[w.identifier]=E}return I.initialize(S,[]),I.addTelemetryInitializer(E=>{c&&(E.ext=E.ext??{},E.ext.utc=E.ext.utc??{},E.ext.utc.flags=8462029)}),I}class P{constructor(c,m,y,p,I){this.d=c,this.e=m,this.f=y,this.g=I,this.c=L,this.f||(this.f={}),typeof p=="function"?this.a=p():this.a=p,this.b=null}h(c){if(!!this.a){if(typeof this.a!="string"){c(this.a);return}this.b||(this.b=N(this.a,this.d,this.g)),this.b.then(m=>{c(m)},m=>{(0,T.onUnexpectedError)(m),console.error(m)})}}log(c,m){if(!this.a)return;m=(0,D.mixin)(m,this.f),m=(0,k.validateTelemetryData)(m);const y=this.e+"/"+c;try{this.h(p=>{p.pluginVersionString=m?.properties.version??"Unknown",p.track({name:y,baseData:{name:y,properties:m?.properties,measurements:m?.measurements}})})}catch{}}flush(){return this.a?new Promise(c=>{this.h(m=>{m.unload(!0,()=>{this.a=void 0,c(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=P}),define(Y[137],Z([0,1,2,29,12,31,100,21,40,138,26,37,32,41]),function($,e,T,D,k,L,N,P,d,c,m,y,p,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let w=class{constructor(l,g,v){this.k=g,this.l=v,this.d={},this.i=new T.DisposableStore,this.j=[],this.b=l.appenders,this.c=l.commonProperties||Promise.resolve({}),this.f=l.piiPaths||[],this.g=3,this.h=!!l.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const f of this.f)this.j.push(new RegExp((0,L.escapeRegExpCharacters)(f),"gi")),f.indexOf("\\")>=0&&this.j.push(new RegExp((0,L.escapeRegExpCharacters)(f.replace(/\\/g,"/")),"gi"));this.m(),this.k.onDidChangeConfiguration(this.m,this,this.i)}setExperimentProperty(l,g){this.d[l]=g}m(){let l=(0,I.getTelemetryLevel)(this.k);const g=this.l.enabledTelemetryLevels;if(g){this.h=this.sendErrorTelemetry?g.error:!1;const v=g.usage?3:g.error?2:0;l=Math.min(l,v)}this.g=l}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const l=await this.c,g=l.sessionID,v=l["common.machineId"],f=l["common.firstSessionDate"],s=l["common.msftInternal"];return{sessionId:g,machineId:v,firstSessionDate:f,msftInternal:s}}dispose(){this.i.dispose()}n(l,g,v){return this.g<g?Promise.resolve(void 0):this.c.then(f=>{v=(0,D.mixin)(v,this.d),v=(0,I.cleanData)(v,this.j),v=(0,D.mixin)(v,f),this.b.forEach(s=>s.log(l,v))},f=>{console.error(f)})}publicLog(l,g){return this.n(l,3,g)}publicLog2(l,g){return this.publicLog(l,g)}publicLogError(l,g){return this.h?this.n(l,2,g):Promise.resolve(void 0)}publicLogError2(l,g){return this.publicLogError(l,g)}};w.IDLE_START_EVENT_NAME="UserIdleStart",w.IDLE_STOP_EVENT_NAME="UserIdleStop",w=de([_(1,P.IConfigurationService),_(2,m.IProductService)],w),e.TelemetryService=w;function S(){const E=(0,N.localize)(0,null,c.default.nameLong),l=c.default.privacyStatementUrl?(0,N.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,N.localize)(1,null,"https://aka.ms/vscode-telemetry"),g=k.isWeb?"":(0,N.localize)(3,null),v=(0,N.localize)(4,null),f=(0,N.localize)(5,null),s=(0,N.localize)(6,null),i=(0,N.localize)(7,null),n=`
|       | ${v} | ${f} | ${s} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,N.localize)(8,null);return`
${E} ${l} ${g}

&nbsp;

${i}
${n}

&nbsp;

${t}
`}y.Registry.as(d.Extensions.Configuration).registerConfiguration({id:p.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,N.localize)(9,null),properties:{[p.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,N.localize)(10,null),(0,N.localize)(11,null),(0,N.localize)(12,null),(0,N.localize)(13,null)],markdownDescription:S(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),y.Registry.as(d.Extensions.Configuration).registerConfiguration({id:p.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,N.localize)(14,null),properties:{[p.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,N.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,N.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,N.localize)(17,null,`\`#${p.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Y[139],Z([0,1,162,136]),function($,e,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class k extends D.AbstractOneDataSystemAppender{constructor(N,P,d,c){const m={sendPOST:(y,p)=>{const I={method:"POST",headers:{...y.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(y.data)}};try{const w=T.request(y.urlString,I,S=>{S.on("data",function(E){p(S.statusCode??200,S.headers,E.toString())}),S.on("error",function(E){p(0,{})})});w.write(y.data),w.end()}catch{p(0,{})}}};super(N,P,d,c,m)}}e.OneDataSystemAppender=k}),define(Y[140],Z([0,1,14,20]),function($,e,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildTelemetryMessage=void 0;async function k(L,N){const P=Object.create(null),d=(m,y)=>{const p=JSON.parse(m);P[y]=p};if(N){const m=[],y=await D.Promises.readdir(N);for(const I of y)try{(await D.Promises.stat((0,T.join)(N,I))).isDirectory()&&m.push(I)}catch{}const p=[];for(const I of m)(await D.Promises.readdir((0,T.join)(N,I))).filter(S=>S==="telemetry.json").length===1&&p.push(I);for(const I of p){const w=(await D.Promises.readFile((0,T.join)(N,I,"telemetry.json"))).toString();d(w,I)}}let c=(await D.Promises.readFile((0,T.join)(L,"telemetry-core.json"))).toString();return d(c,"vscode-core"),c=(await D.Promises.readFile((0,T.join)(L,"telemetry-extensions.json"))).toString(),d(c,"vscode-extensions"),JSON.stringify(P,null,4)}e.buildTelemetryMessage=k}),define(Y[141],Z([0,1,12,79,32]),function($,e,T,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function L(N){let P=N.getItem(k.machineIdKey);return(!P||T.isMacintosh&&P==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(P=await(0,D.getMachineId)()),P}e.resolveMachineId=L}),define(Y[28],Z([0,1,8]),function($,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,T.createDecorator)("IUriIdentityService")}),define(Y[142],Z([0,1,28,109,13,17,71,4,2]),function($,e,T,D,k,L,N,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class c{constructor(p){this.uri=p,this.time=c._clock++}touch(){return this.time=c._clock++,this}}c._clock=0;let m=class{constructor(p){this.g=p,this.c=new d.DisposableStore,this.f=2**16;const I=new Map,w=S=>{let E=I.get(S.scheme);return E===void 0&&(E=p.hasProvider(S)&&!this.g.hasCapability(S,1024),I.set(S.scheme,E)),E};this.c.add(P.Event.any(p.onDidChangeFileSystemProviderRegistrations,p.onDidChangeFileSystemProviderCapabilities)(S=>{I.delete(S.scheme)})),this.extUri=new L.ExtUri(w),this.d=new N.SkipList((S,E)=>this.extUri.compare(S,E,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(p){this.g.hasProvider(p)&&(p=(0,L.normalizePath)(p));const I=this.d.get(p);return I?I.touch().uri.with({fragment:p.fragment}):(this.d.set(p,new c(p)),this.h(),p)}h(){if(this.d.size<this.f)return;const p=[...this.d.entries()].sort((w,S)=>w[1].touch<S[1].touch?1:w[1].touch>S[1].touch?-1:0);c._clock=0,this.d.clear();const I=this.f*.5;for(let w=0;w<I;w++)this.d.set(p[w][0],p[w][1].touch())}};m=de([_(0,k.IFileService)],m),e.UriIdentityService=m,(0,D.registerSingleton)(T.IUriIdentityService,m,1)}),define(Y[143],Z([0,1,102,14,54,17,11,8,16]),function($,e,T,D,k,L,N,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function c(n){const t=n;return typeof t?.id=="string"&&N.URI.isUri(t.uri)}e.isSingleFolderWorkspaceIdentifier=c,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function m(n,t){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,D.basename)(n)}:t?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const r=n;if(r.configuration)return{id:r.id,configPath:r.configuration};if(r.folders.length===1)return{id:r.id,uri:r.folders[0].uri}}e.toWorkspaceIdentifier=m;function y(n){const t=n;return typeof t?.id=="string"&&N.URI.isUri(t.configPath)}e.isWorkspaceIdentifier=y;function p(n){const t=n;if(t?.uri)return{id:t.id,uri:N.URI.revive(t.uri)};const r=n;if(r?.configPath)return{id:r.id,configPath:N.URI.revive(r.configPath)};if(n?.id)return{id:n.id}}e.reviveIdentifier=p;var I;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(I=e.WorkbenchState||(e.WorkbenchState={}));function w(n){const t=n;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.isWorkspace=w;function S(n){const t=n;return!!(t&&typeof t=="object"&&N.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.isWorkspaceFolder=S;class E{constructor(t,r,o,u,a){this.h=t,this.j=o,this.k=u,this.l=a,this.c=k.TernarySearchTree.forUris(this.l,()=>!0),this.folders=r}update(t){this.h=t.id,this.k=t.configuration,this.j=t.transient,this.l=t.l,this.folders=t.folders}get folders(){return this.g}set folders(t){this.g=t,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(t){this.k=t}getFolder(t){return t&&this.c.findSubstr(t)||null}n(){this.c=k.TernarySearchTree.forUris(this.l,()=>!0);for(const t of this.folders)this.c.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=E;class l{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,L.joinPath)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=l;function g(n){return new l({uri:n,index:0,name:(0,L.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=g,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,T.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function v(n,t){return L.extUriBiasedIgnorePathCase.isEqualOrParent(n,t.untitledWorkspacesHome)}e.isUntitledWorkspace=v;function f(n){let t;return N.URI.isUri(n)?t=n:t=n.configuration,t?.scheme===d.Schemas.tmp}e.isTemporaryWorkspace=f;function s(n,t){return!v(n,t)&&!f(n)}e.isSavedWorkspace=s;function i(n){return(typeof n=="string"?(0,D.extname)(n):(0,L.extname)(n))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=i}),define(Y[25],Z([0,1,52,4,2,17,11,101,18,13,8,9,143,36,28,3,30,31]),function($,e,T,D,k,L,N,P,d,c,m,y,p,I,w,S,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function g(n){const t=n;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&N.URI.isUri(t.location)&&N.URI.isUri(t.globalStorageHome)&&N.URI.isUri(t.settingsResource)&&N.URI.isUri(t.keybindingsResource)&&N.URI.isUri(t.tasksResource)&&N.URI.isUri(t.snippetsHome)&&N.URI.isUri(t.extensionsResource))}e.isUserDataProfile=g,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,m.createDecorator)("IUserDataProfilesService");function v(n,t){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,location:N.URI.revive(n.location).with({scheme:t}),globalStorageHome:N.URI.revive(n.globalStorageHome).with({scheme:t}),settingsResource:N.URI.revive(n.settingsResource).with({scheme:t}),keybindingsResource:N.URI.revive(n.keybindingsResource).with({scheme:t}),tasksResource:N.URI.revive(n.tasksResource).with({scheme:t}),snippetsHome:N.URI.revive(n.snippetsHome).with({scheme:t}),extensionsResource:N.URI.revive(n.extensionsResource)?.with({scheme:t}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.reviveProfile=v;function f(n,t,r,o){return{id:n,name:t,location:r,isDefault:!1,shortName:o?.shortName,globalStorageHome:(0,L.joinPath)(r,"globalStorage"),settingsResource:(0,L.joinPath)(r,"settings.json"),keybindingsResource:(0,L.joinPath)(r,"keybindings.json"),tasksResource:(0,L.joinPath)(r,"tasks.json"),snippetsHome:(0,L.joinPath)(r,"snippets"),extensionsResource:(0,L.joinPath)(r,"extensions.json"),useDefaultFlags:o?.useDefaultFlags,isTransient:o?.transient}}e.toUserDataProfile=f;let s=class extends k.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(t,r,o,u){super(),this.m=t,this.n=r,this.r=o,this.s=u,this.f=!1,this.g=this.B(new D.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new D.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new D.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new D.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new I.ResourceMap},this.profilesHome=(0,L.joinPath)(this.m.userRoamingDataHome,"profiles")}setEnablement(t){this.f!==t&&(this.t=void 0,this.f=t)}isEnabled(){return this.f}get u(){if(!this.t){const t=this.f?this.H().map(a=>f((0,L.basename)(a.location),a.name,a.location,{shortName:a.shortName,useDefaultFlags:a.useDefaultFlags})):[];let r;const o=new I.ResourceMap,u=f((0,T.hash)(this.m.userRoamingDataHome.path).toString(16),(0,P.localize)(0,null),this.m.userRoamingDataHome);if(t.unshift({...u,extensionsResource:this.M()??u.extensionsResource,isDefault:!0}),t.length){const a=this.J();if(a.workspaces)for(const[h,O]of Object.entries(a.workspaces)){const j=N.URI.parse(h),x=N.URI.parse(O),K=t.find(X=>this.r.extUri.isEqual(X.location,x));K&&o.set(j,K)}if(a.emptyWindow){const h=N.URI.parse(a.emptyWindow);r=t.find(O=>this.r.extUri.isEqual(O.location,h))}}this.t={profiles:t,workspaces:o,emptyWindow:r}}return this.t}async createTransientProfile(t){const r="Temp",o=new RegExp(`${(0,l.escapeRegExpCharacters)(r)}\\s(\\d+)`);let u=0;for(const h of this.profiles){const O=o.exec(h.name),j=O?parseInt(O[1]):0;u=j>u?j:u}const a=`${r} ${u+1}`;return this.createProfile((0,T.hash)((0,E.generateUuid)()).toString(16),a,{transient:!0},t)}async createNamedProfile(t,r,o){return this.createProfile((0,T.hash)((0,E.generateUuid)()).toString(16),t,r,o)}async createProfile(t,r,o,u){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const a=await this.v(t,r,o);return u&&await this.setProfileForWorkspace(u,a),a}async v(t,r,o){let u=this.k.get(r);return u||(u=(async()=>{try{const a=this.profiles.find(j=>j.name===r||j.id===t);if(a)return a;const h=f(t,r,(0,L.joinPath)(this.profilesHome,t),o);await this.n.createFolder(h.location);const O=[];return this.h.fire({profile:h,join(j){O.push(j)}}),await S.Promises.settled(O),this.C([h],[],[]),h}finally{this.k.delete(r)}})(),this.k.set(r,u)),u}async updateProfile(t,r){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let o=this.profiles.find(u=>u.id===t.id);if(!o)throw new Error(`Profile '${t.name}' does not exist`);return o=f(o.id,r.name??o.name,o.location,{shortName:r.shortName??o.shortName,transient:r.transient??o.isTransient,useDefaultFlags:r.useDefaultFlags??o.useDefaultFlags}),this.C([],[],[o]),o}async removeProfile(t){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(t.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(u=>u.id===t.id);if(!r)throw new Error(`Profile '${t.name}' does not exist`);const o=[];this.i.fire({profile:r,join(u){o.push(u)}});try{await Promise.allSettled(o)}catch(u){this.s.error(u)}r.id===this.u.emptyWindow?.id&&(this.u.emptyWindow=void 0);for(const u of[...this.u.workspaces.keys()])r.id===this.u.workspaces.get(u)?.id&&this.u.workspaces.delete(u);this.G(),this.C([],[r],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(r.location,{recursive:!0})}catch(u){this.s.error(u)}}getOrSetProfileForWorkspace(t,r=this.defaultProfile){if(!this.f)return this.defaultProfile;let o=this.w(t);return o||(o=r,this.profiles.length>1&&this.setProfileForWorkspaceSync(t,o)),o}async setProfileForWorkspace(t,r){this.setProfileForWorkspaceSync(t,r)}setProfileForWorkspaceSync(t,r){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const o=this.profiles.find(u=>u.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);this.F(t,o)}unsetWorkspace(t,r){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.F(t,void 0,r)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindow=void 0,this.u.workspaces.clear(),this.u.emptyWindow=void 0,this.G(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const t=await this.n.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(r=>r.isDirectory&&this.profiles.every(o=>!this.r.extUri.isEqual(o.location,r.resource))).map(r=>this.n.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const t=this.l.profiles.filter(r=>!this.z(r));await Promise.allSettled(t.map(r=>this.removeProfile(r)))}w(t){const r=this.y(t);return N.URI.isUri(r)?this.l.workspaces.get(r)??this.u.workspaces.get(r):this.l.emptyWindow??this.u.emptyWindow}y(t){return(0,p.isSingleFolderWorkspaceIdentifier)(t)?t.uri:(0,p.isWorkspaceIdentifier)(t)?t.configPath:"empty-window"}z(t){return!!(this.r.extUri.isEqual(this.l.emptyWindow?.location,t.location)||[...this.l.workspaces.values()].some(r=>this.r.extUri.isEqual(r.location,t.location))||this.r.extUri.isEqual(this.u.emptyWindow?.location,t.location)||[...this.u.workspaces.values()].some(r=>this.r.extUri.isEqual(r.location,t.location)))}C(t,r,o){const u=[...this.profiles,...t],a=[];this.l.profiles=[];for(let h of u)h.isDefault||r.some(O=>h.id===O.id)||(h=o.find(O=>h.id===O.id)??h,h.isTransient?this.l.profiles.push(h):a.push({location:h.location,name:h.name,shortName:h.shortName,useDefaultFlags:h.useDefaultFlags}));this.I(a),this.t=void 0,this.D(t,r,o)}D(t,r,o){this.g.fire({added:t,removed:r,updated:o,all:this.profiles})}F(t,r,o){o=r?.isTransient?!0:o,o||this.F(t,void 0,!0);const u=this.y(t),a=o?this.l:this.u;N.URI.isUri(u)?(a.workspaces.delete(u),r&&a.workspaces.set(u,r)):a.emptyWindow=r,o||this.G()}G(){const t={};for(const[o,u]of this.u.workspaces.entries())t[o.toString()]=u.location.toString();const r=this.u.emptyWindow?.location.toString();this.L({workspaces:t,emptyWindow:r}),this.t=void 0}H(){return[]}I(t){throw new Error("not implemented")}J(){return{}}L(t){throw new Error("not implemented")}M(){}};s.b="userDataProfiles",s.c="profileAssociations",s=de([_(0,d.IEnvironmentService),_(1,c.IFileService),_(2,w.IUriIdentityService),_(3,y.ILogService)],s),e.UserDataProfilesService=s;class i extends s{constructor(){super(...arguments),this.a=[],this.P={}}H(){return this.a}I(t){this.a=t}J(){return this.P}L(t){this.P=t}}e.InMemoryUserDataProfilesService=i}),define(Y[144],Z([0,1,19,3,22,10,4,2,12,11,86,23,24,27,9,26,32,25]),function($,e,T,D,k,L,N,P,d,c,m,y,p,I,w,S,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let g=class extends P.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(t,r,o,u,a){super(),this.t=t,this.u=r,this.v=o,this.w=u,this.y=a,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new N.Emitter),this.m=this.B(new N.Emitter),this.n=this.B(new N.Emitter),this.p=this.B(new N.Emitter),this.s=[],this.B((0,P.toDisposable)(()=>{this.j.forEach(({task:h})=>h.cancel()),this.k.forEach(h=>h.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(o=>(0,y.isTargetPlatformCompatible)(o,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{if(!this.t.isEnabled())throw new y.ExtensionManagementError(m.localize(0,null),y.ExtensionManagementErrorCode.Internal);const o=await this.G(t,!!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.z(o.manifest,o.extension,r)}catch(o){throw s(this.u,"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(t),error:o}),this.v.error("Failed to install extension.",t.identifier.id),this.v.error(o),f(o)}}async uninstall(t,r={}){return this.v.trace("ExtensionManagementService#uninstall",t.identifier.id),this.I(t,r)}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.g||t-this.h>1e3*60*5)&&(this.g=this.O(),this.h=t),this.g}registerParticipant(t){this.s.push(t)}async z(t,r,o){const u={...o,installOnlyNewlyAddedFromExtensionPack:c.URI.isUri(r)?o.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,I.isApplicationScopedExtension)(t)?this.y.defaultProfile.extensionsResource:o.profileLocation??this.P()},a=X=>`${p.ExtensionKey.create(X).toString()}${u.profileLocation?`-${u.profileLocation.toString()}`:""}`;if(!c.URI.isUri(r)){const X=this.j.get(a(r));if(X){this.v.info("Extensions is already requested to install",r.identifier.id);const{local:ie}=await X.task.waitUntilTaskIsFinished();return ie}}const h=[],O=[],j=[],x=this.Q(t,r,u);c.URI.isUri(r)||this.j.set(a(r),{task:x,waitingTasks:[]}),this.l.fire({identifier:x.identifier,source:r,profileLocation:u.profileLocation}),this.v.info("Installing extension:",x.identifier.id),h.push({task:x,manifest:t});let K=!1;try{if(u.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",x.identifier.id);else try{const ie=await this.F(x.identifier,t,!!u.installOnlyNewlyAddedFromExtensionPack,!!u.installPreReleaseVersion,u.profileLocation),ne=await this.getInstalled(void 0,u.profileLocation);for(const{gallery:Q,manifest:ge}of ie){K=K||!!ge.extensionDependencies?.some(me=>(0,p.areSameExtensions)({id:me},x.identifier));const ce=a(Q),re=this.j.get(ce);if(re){if(this.C(x,re.task)){this.v.info("Waiting for already requested installing extension",Q.identifier.id,x.identifier.id),re.waitingTasks.push(x);const me=re.task.identifier;O.push(N.Event.toPromise(N.Event.filter(this.onDidInstallExtensions,M=>M.some(A=>(0,p.areSameExtensions)(A.identifier,me)))).then(M=>{if(!M.find(U=>(0,p.areSameExtensions)(U.identifier,me))?.local)throw new Error(`Extension ${me.id} is not installed`)}))}}else if(!ne.some(({identifier:me})=>(0,p.areSameExtensions)(me,Q.identifier))){const me=this.Q(ge,Q,{...u,donotIncludePackAndDependencies:!0});this.j.set(ce,{task:me,waitingTasks:[x]}),this.l.fire({identifier:me.identifier,source:Q,profileLocation:u.profileLocation}),this.v.info("Installing extension:",me.identifier.id,x.identifier.id),h.push({task:me,manifest:ge})}}}catch(ie){if(c.URI.isUri(x.source))(0,T.isNonEmptyArray)(t.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",x.identifier.id,ie.message),(0,T.isNonEmptyArray)(t.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",x.identifier.id,ie.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",x.identifier.id),ie}const X=h.reduce((ie,{task:ne,manifest:Q})=>(ie.set(ne.identifier.id.toLowerCase(),{task:ne,manifest:Q}),ie),new Map);for(;X.size;){let ie;const ne=[...X.values()].filter(({manifest:Q})=>!Q.extensionDependencies?.some(ge=>X.has(ge.toLowerCase())));ne.length?ie=X.size===1?ne:ne.filter(({task:Q})=>!(Q===x&&!K)):(this.v.info("Found extensions with circular dependencies",ne.map(({task:Q})=>Q.identifier.id)),ie=[...X.values()]),await this.D(ie.map(async({task:Q})=>{const ge=new Date().getTime();try{const{local:ce}=await Q.run();if(await this.D(this.s.map(re=>re.postInstall(ce,Q.source,u,k.CancellationToken.None))),!c.URI.isUri(Q.source)){const re=Q.operation===3,me=re?void 0:(new Date().getTime()-Q.source.lastUpdated)/1e3;if(s(this.u,re?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(Q.source),wasVerified:Q.wasVerified,duration:new Date().getTime()-ge,durationSinceUpdate:me}),d.isWeb&&Q.operation!==3)try{await this.t.reportStatistic(ce.manifest.publisher,ce.manifest.name,ce.manifest.version,"install")}catch{}}j.push({local:ce,identifier:Q.identifier,operation:Q.operation,source:Q.source,context:u.context,profileLocation:u.profileLocation,applicationScoped:ce.isApplicationScoped})}catch(ce){throw c.URI.isUri(Q.source)||s(this.u,Q.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(Q.source),wasVerified:Q.wasVerified,duration:new Date().getTime()-ge,error:ce}),this.v.error("Error while installing the extension:",Q.identifier.id),ce}finally{X.delete(Q.identifier.id.toLowerCase())}}))}return O.length&&await this.D(O),j.forEach(({identifier:ie})=>this.v.info("Extension installed successfully:",ie.id)),this.m.fire(j),j.filter(({identifier:ie})=>(0,p.areSameExtensions)(ie,x.identifier))[0].local}catch(X){if(h.forEach(({task:ie})=>ie.cancel()),j.length)try{const ie=await Promise.allSettled(j.map(({local:ne})=>this.R(ne,{versionOnly:!0,profileLocation:u.profileLocation}).run()));for(let ne=0;ne<ie.length;ne++){const Q=ie[ne],{identifier:ge}=j[ne];Q.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",ge.id):this.v.warn("Rollback: Error while uninstalling extension",ge.id,(0,L.getErrorMessage)(Q.reason))}}catch(ie){this.v.warn("Error while rolling back extensions",(0,L.getErrorMessage)(ie),j.map(({identifier:ne})=>ne.id))}throw this.m.fire(h.map(({task:ie})=>({identifier:ie.identifier,operation:2,source:ie.source,context:u.context,profileLocation:u.profileLocation}))),X}finally{for(const[X,{task:ie,waitingTasks:ne}]of this.j.entries()){const Q=ne.indexOf(x);Q!==-1&&ne.splice(Q,1),ne.length===0&&(ie===x||Q!==-1)&&this.j.delete(X)}}}C(t,r){for(const[,{task:o,waitingTasks:u}]of this.j.entries())if(o===t&&(u.includes(r)||u.some(a=>this.C(a,r)))||o===r&&u[0]&&!this.C(t,u[0]))return!1;return!0}async D(t){const r=[],o=[],u=await Promise.allSettled(t);for(const a of u)a.status==="fulfilled"?r.push(a.value):o.push(a.reason);if(o.length)throw v(o);return r}async F(t,r,o,u,a){if(!this.t.isEnabled())return[];const h=await this.getInstalled(void 0,a),O=[t],j=[],x=async(K,X)=>{const ie=X.extensionDependencies||[],ne=[...ie];if(X.extensionPack){const Q=o?h.find(ge=>(0,p.areSameExtensions)(ge.identifier,K)):void 0;for(const ge of X.extensionPack)Q&&Q.manifest.extensionPack&&Q.manifest.extensionPack.some(ce=>(0,p.areSameExtensions)({id:ce},{id:ge}))||ne.every(ce=>!(0,p.areSameExtensions)({id:ce},{id:ge}))&&ne.push(ge)}if(ne.length){const Q=[...O,...j.map(ce=>ce.gallery.identifier)],ge=ne.filter(ce=>Q.every(re=>!(0,p.areSameExtensions)(re,{id:ce})));if(ge.length){const ce=await this.t.getExtensions(ge.map(re=>({id:re,preRelease:u})),k.CancellationToken.None);for(const re of ce){if(Q.find(A=>(0,p.areSameExtensions)(A,re.identifier)))continue;const me=ie.some(A=>(0,p.areSameExtensions)({id:A},re.identifier));let M;try{M=await this.G(re,!1,u)}catch(A){if(A instanceof y.ExtensionManagementError&&A.code===y.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!me){this.v.info("Skipping the packed extension as it cannot be installed",re.identifier.id);continue}else throw A}j.push({gallery:M.extension,manifest:M.manifest}),await x(M.extension.identifier,M.manifest)}}}};return await x(t,r),j}async G(t,r,o){if((await this.getExtensionsControlManifest()).malicious.some(O=>(0,p.areSameExtensions)(t.identifier,O)))throw new y.ExtensionManagementError(m.localize(1,null,t.identifier.id),y.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(t)){const O=await this.getTargetPlatform();throw new y.ExtensionManagementError(m.localize(2,null,t.identifier.id,this.w.nameLong,(0,y.TargetPlatformToString)(O)),y.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const a=await this.H(t,r,o);if(a){if(o&&!r&&t.hasPreReleaseVersion&&!a.properties.isPreReleaseVersion)throw new y.ExtensionManagementError(m.localize(3,null,t.identifier.id,this.w.nameLong,this.w.version),y.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&t.properties.isPreReleaseVersion&&(await this.t.getExtensions([t.identifier],k.CancellationToken.None))[0]?new y.ExtensionManagementError(m.localize(4,null,t.identifier.id),y.ExtensionManagementErrorCode.ReleaseVersionNotFound):new y.ExtensionManagementError(m.localize(5,null,t.identifier.id,this.w.nameLong,this.w.version),y.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",a.identifier.id);const h=await this.t.getManifest(a,k.CancellationToken.None);if(h===null)throw new y.ExtensionManagementError(`Missing manifest for extension ${t.identifier.id}`,y.ExtensionManagementErrorCode.Invalid);if(h.version!==a.version)throw new y.ExtensionManagementError(`Cannot install '${t.identifier.id}' extension because of version mismatch in Marketplace`,y.ExtensionManagementErrorCode.Invalid);return{extension:a,manifest:h}}async H(t,r,o){const u=await this.getTargetPlatform();let a=null;return!r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==o&&(a=(await this.t.getExtensions([{...t.identifier,preRelease:o}],{targetPlatform:u,compatible:!0},k.CancellationToken.None))[0]||null),!a&&await this.t.isExtensionCompatible(t,o,u)&&(a=t),a||(r?a=(await this.t.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:u,compatible:!0},k.CancellationToken.None))[0]||null:a=await this.t.getCompatibleExtension(t,o,u)),a}async I(t,r){const o={...r,profileLocation:t.isApplicationScoped?this.y.defaultProfile.extensionsResource:r.profileLocation??this.P()},u=K=>`${K.id.toLowerCase()}${o.versionOnly?`-${t.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,a=this.k.get(u(t.identifier));if(a)return this.v.info("Extensions is already requested to uninstall",t.identifier.id),a.waitUntilTaskIsFinished();const h=K=>{const X=this.R(K,o);return this.k.set(u(X.extension.identifier),X),o.profileLocation?this.v.info("Uninstalling extension from the profile:",`${K.identifier.id}@${K.manifest.version}`,o.profileLocation.toString()):this.v.info("Uninstalling extension:",`${K.identifier.id}@${K.manifest.version}`),this.n.fire({identifier:K.identifier,profileLocation:o.profileLocation,applicationScoped:K.isApplicationScoped}),X},O=(K,X)=>{X?o.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${K.identifier.id}@${K.manifest.version}`,o.profileLocation.toString(),X.message):this.v.error("Failed to uninstall extension:",`${K.identifier.id}@${K.manifest.version}`,X.message):o.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${K.identifier.id}@${K.manifest.version}`,o.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${K.identifier.id}@${K.manifest.version}`),s(this.u,"extensionGallery:uninstall",{extensionData:(0,p.getLocalExtensionTelemetryData)(K),error:X}),this.p.fire({identifier:K.identifier,error:X?.code,profileLocation:o.profileLocation,applicationScoped:K.isApplicationScoped})},j=[],x=[];try{j.push(h(t));const K=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const X=this.M(t,K);for(const ie of X)this.k.has(u(ie.identifier))?this.v.info("Extensions is already requested to uninstall",ie.identifier.id):j.push(h(ie))}o.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.J(j.map(X=>X.extension),K,t),await this.D(j.map(async X=>{try{if(await X.run(),await this.D(this.s.map(ie=>ie.postUninstall(X.extension,o,k.CancellationToken.None))),X.extension.identifier.uuid)try{await this.t.reportStatistic(X.extension.manifest.publisher,X.extension.manifest.name,X.extension.manifest.version,"uninstall")}catch{}O(X.extension)}catch(ie){const ne=ie instanceof y.ExtensionManagementError?ie:new y.ExtensionManagementError((0,L.getErrorMessage)(ie),y.ExtensionManagementErrorCode.Internal);throw O(X.extension,ne),ne}finally{x.push(X)}}))}catch(K){const X=K instanceof y.ExtensionManagementError?K:new y.ExtensionManagementError((0,L.getErrorMessage)(K),y.ExtensionManagementErrorCode.Internal);for(const ie of j){try{ie.cancel()}catch{}x.includes(ie)||O(ie.extension,X)}throw X}finally{for(const K of j)this.k.delete(u(K.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",K.extension.identifier.id)}}J(t,r,o){for(const u of t){const a=this.N(u,r);if(a.length){const h=a.filter(O=>!t.some(j=>(0,p.areSameExtensions)(j.identifier,O.identifier)));if(h.length)throw new Error(this.L(u,h,o))}}}L(t,r,o){return o===t?r.length===1?m.localize(6,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?m.localize(7,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):m.localize(8,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?m.localize(9,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?m.localize(10,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):m.localize(11,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}M(t,r,o=[]){if(o.indexOf(t)!==-1)return[];o.push(t);const u=t.manifest.extensionPack?t.manifest.extensionPack:[];if(u.length){const a=r.filter(O=>!O.isBuiltin&&u.some(j=>(0,p.areSameExtensions)({id:j},O.identifier))),h=[];for(const O of a)h.push(...this.M(O,r,o));return[...a,...h]}return[]}N(t,r){return r.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(u=>(0,p.areSameExtensions)({id:u},t.identifier)))}async O(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const t=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};g=de([_(0,y.IExtensionGalleryService),_(1,E.ITelemetryService),_(2,w.ILogService),_(3,S.IProductService),_(4,l.IUserDataProfilesService)],g),e.AbstractExtensionManagementService=g;function v(n){const t=Array.isArray(n)?n:[n];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,o)=>new Error(`${r.message}${r.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.joinErrors=v;function f(n){if(n instanceof y.ExtensionManagementError)return n;const t=new y.ExtensionManagementError(n.message,y.ExtensionManagementErrorCode.Internal);return t.stack=n.stack,t}function s(n,t,{extensionData:r,wasVerified:o,duration:u,error:a,durationSinceUpdate:h}){let O,j;a&&(a instanceof y.ExtensionManagementError?(O=a.code,a.code===y.ExtensionManagementErrorCode.Signature&&(j=a.message)):O=y.ExtensionManagementErrorCode.Internal),n.publicLog(t,{...r,wasVerified:o,success:!a,duration:u,errorcode:O,errorcodeDetail:j,durationSinceUpdate:h})}e.reportTelemetry=s;class i{constructor(){this.d=new D.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,D.createCancelablePromise)(t=>this.h(t))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,D.createCancelablePromise)(t=>new Promise((r,o)=>{const u=t.onCancellationRequested(()=>{u.dispose(),o(new L.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=i}),define(Y[42],Z([0,1,3,15,2,4,36,11,24,27,13,8,9,25,28]),function($,e,T,D,k,L,N,P,d,c,m,y,p,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,y.createDecorator)("IExtensionsProfileScannerService");let S=class extends k.Disposable{constructor(g,v,f,s){super(),this.h=g,this.i=v,this.j=f,this.k=s,this.a=this.B(new L.Emitter),this.onAddExtensions=this.a.event,this.b=this.B(new L.Emitter),this.onDidAddExtensions=this.b.event,this.c=this.B(new L.Emitter),this.onRemoveExtensions=this.c.event,this.f=this.B(new L.Emitter),this.onDidRemoveExtensions=this.f.event,this.g=new N.ResourceMap}scanProfileExtensions(g){return this.l(g)}async addExtensionsToProfile(g,v){const f=[],s=[];try{return await this.l(v,i=>{const n=[];for(const t of i)g.some(([r])=>(0,d.areSameExtensions)(r.identifier,t.identifier)&&r.manifest.version!==t.version)?f.push(t):n.push(t);for(const[t,r]of g)if(!n.some(o=>(0,d.areSameExtensions)(o.identifier,t.identifier)&&o.version===t.manifest.version)){const o={identifier:t.identifier,version:t.manifest.version,location:t.location,metadata:r};s.push(o),n.push(o)}return s.length&&this.a.fire({extensions:s,profileLocation:v}),f.length&&this.c.fire({extensions:f,profileLocation:v}),n}),s.length&&this.b.fire({extensions:s,profileLocation:v}),f.length&&this.f.fire({extensions:f,profileLocation:v}),s}catch(i){throw s.length&&this.b.fire({extensions:s,error:i,profileLocation:v}),f.length&&this.f.fire({extensions:f,error:i,profileLocation:v}),i}}async removeExtensionFromProfile(g,v){const f=[];this.c.fire({extensions:f,profileLocation:v});try{await this.l(v,s=>{const i=[];for(const n of s)(0,d.areSameExtensions)(n.identifier,g.identifier)?f.push(n):i.push(n);return f.length&&this.c.fire({extensions:f,profileLocation:v}),i}),f.length&&this.f.fire({extensions:f,profileLocation:v})}catch(s){throw f.length&&this.f.fire({extensions:f,error:s,profileLocation:v}),s}}async l(g,v){return this.p(g).queue(async()=>{let f=[],s;try{const i=await this.h.readFile(g);s=JSON.parse(i.value.toString())}catch(i){if((0,m.toFileOperationResult)(i)!==1)throw i;this.j.extUri.isEqual(g,this.i.defaultProfile.extensionsResource)&&(s=await this.n())}if(s)for(const i of s){if(!i.identifier){this.k.info("Ignoring invalid extension while scanning. Identifier does not exist.",i);continue}if(!i.location){this.k.info("Ignoring invalid extension while scanning. Location does not exist.",i);continue}if(!i.version){this.k.info("Ignoring invalid extension while scanning. Version does not exist.",i);continue}f.push({identifier:i.identifier,location:P.URI.revive(i.location),version:i.version,metadata:i.metadata})}if(v){f=v(f);const i=f.map(n=>({identifier:n.identifier,version:n.version,location:n.location.toJSON(),metadata:n.metadata}));await this.h.writeFile(g,D.VSBuffer.fromString(JSON.stringify(i)))}return f})}async n(){return this.m||(this.m=(async()=>{const g=this.j.extUri.joinPath(this.i.defaultProfile.location,"extensions.json");let v;try{v=(await this.h.readFile(g)).value.toString()}catch(s){if((0,m.toFileOperationResult)(s)===1)return;throw s}this.k.info("Migrating extensions from old default profile location",g.toString());let f;try{const s=JSON.parse(v);Array.isArray(s)&&s.every(i=>!!(i&&typeof i=="object"&&(0,c.isIExtensionIdentifier)(i.identifier)&&E(i.location)&&i.version&&typeof i.version=="string"))?f=s:this.k.warn("Skipping migrating from old default profile locaiton: Found invalid data",s)}catch(s){this.k.error(s)}if(f)try{await this.h.createFile(this.i.defaultProfile.extensionsResource,D.VSBuffer.fromString(JSON.stringify(f)),{overwrite:!1}),this.k.info("Migrated extensions from old default profile location to new location",g.toString(),this.i.defaultProfile.extensionsResource.toString())}catch(s){if((0,m.toFileOperationResult)(s)===3)this.k.info("Migration from old default profile location to new location is done by another window",g.toString(),this.i.defaultProfile.extensionsResource.toString());else throw s}try{await this.h.del(g)}catch(s){(0,m.toFileOperationResult)(s)!==1&&this.k.error(s)}return f})()),this.m}p(g){let v=this.g.get(g);return v||(v=new T.Queue,this.g.set(g,v)),v}};S=de([_(0,m.IFileService),_(1,I.IUserDataProfilesService),_(2,w.IUriIdentityService),_(3,p.ILogService)],S),e.ExtensionsProfileScannerService=S;function E(l){return l?typeof l.path=="string"&&typeof l.scheme=="string":!1}}),define(Y[48],Z([0,1,19,3,29,15,10,50,77,2,16,14,12,17,39,53,5,11,90,18,24,27,45,13,8,9,26,4,44,42,25,28,106,107]),function($,e,T,D,k,L,N,P,d,c,m,y,p,I,w,S,E,l,g,v,f,s,i,n,t,r,o,u,a,h,O,j,x,K){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var X;(function(me){function M(A,U){if(A===U)return!0;const V=Object.keys(A),G=new Set;for(const q of Object.keys(U))G.add(q);if(V.length!==G.size)return!1;for(const q of V){if(A[q]!==U[q])return!1;G.delete(q)}return G.size===0}me.equals=M})(X=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let ie=class extends c.Disposable{constructor(M,A,U,V,G,q,ee,b,R,C,F,B){super(),this.systemExtensionsLocation=M,this.userExtensionsLocation=A,this.l=U,this.m=V,this.n=G,this.p=q,this.r=ee,this.s=b,this.t=R,this.u=C,this.v=F,this.w=B,this.g=this.B(new u.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,I.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(ge,(0,I.joinPath)(this.m,s.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(ge,(0,I.joinPath)(this.m,s.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(Q,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,f.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(M,A,U){const[V,G]=await Promise.all([this.scanSystemExtensions(M),this.scanUserExtensions(A)]),q=U?await this.scanExtensionsUnderDevelopment(M,[...V,...G]):[];return this.D(V,G,q,await this.getTargetPlatform(),!0)}async scanSystemExtensions(M){const A=[];A.push(this.F(!!M.useCache,M.language)),A.push(this.G(M.language,!!M.checkControlFile));const[U,V]=await Promise.all(A);return this.C([...U,...V],0,M,!1)}async scanUserExtensions(M){const A=M.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",A);const U=await this.I(A,!!M.profileLocation,1,!M.includeUninstalled,M.language);let G=await(M.useCache&&!U.devMode&&U.excludeObsolete?this.j:this.k).scanExtensions(U);return G=await this.C(G,1,M,!0),this.s.trace("Scanned user extensions:",G.length),G}async scanExtensionsUnderDevelopment(M,A){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const U=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(V=>V.scheme===m.Schemas.file).map(async V=>{const G=await this.I(V,!1,1,!0,M.language,!1);return(await this.k.scanOneOrMultipleExtensions(G)).map(ee=>(ee.type=A.find(b=>(0,f.areSameExtensions)(b.identifier,ee.identifier))?.type??ee.type,this.k.validate(ee,G)))}))).flat();return this.C(U,"development",M,!0)}return[]}async scanExistingExtension(M,A,U){const V=await this.I(M,!1,A,!0,U.language),G=await this.k.scanExtension(V);return!G||!U.includeInvalid&&!G.isValid?null:G}async scanOneOrMultipleExtensions(M,A,U){const V=await this.I(M,!1,A,!0,U.language),G=await this.k.scanOneOrMultipleExtensions(V);return this.C(G,A,U,!0)}async scanMetadata(M){const A=(0,I.joinPath)(M,"package.json"),U=(await this.r.readFile(A)).value.toString();return JSON.parse(U).__metadata}async updateMetadata(M,A){const U=(0,I.joinPath)(M,"package.json"),V=(await this.r.readFile(U)).value.toString(),G=JSON.parse(V);A.isMachineScoped=A.isMachineScoped||void 0,A.isBuiltin=A.isBuiltin||void 0,A.installedTimestamp=A.installedTimestamp||void 0,G.__metadata={...G.__metadata,...A},await this.r.writeFile((0,I.joinPath)(M,"package.json"),L.VSBuffer.fromString(JSON.stringify(G,null,"	")))}initializeDefaultProfileExtensions(){return this.z||(this.z=(async()=>{try{const M=this.v.extUri.joinPath(this.userExtensionsLocation,".init-default-profile-extensions");if(await this.r.exists(M))return;if(!await this.r.exists(this.n.defaultProfile.extensionsResource)&&!await this.r.exists(this.v.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"))){this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const A=await this.scanUserExtensions({includeInvalid:!0});await this.p.addExtensionsToProfile(A.map(U=>[U,U.metadata]),this.n.defaultProfile.extensionsResource),this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}try{await this.r.createFile(M,L.VSBuffer.fromString(""))}catch(A){(0,n.toFileOperationResult)(A)!==1&&this.s.warn("Failed to create default profile extensions initialize marker in extensions installation folder.",this.userExtensionsLocation.toString(),(0,N.getErrorMessage)(A))}}catch(M){throw this.s.error(M),M}})()),this.z}async C(M,A,U,V){return U.includeAllVersions||(M=this.D(A===0?M:void 0,A===1?M:void 0,A==="development"?M:void 0,await this.getTargetPlatform(),V)),U.includeInvalid||(M=M.filter(G=>G.isValid)),M.sort((G,q)=>{const ee=y.basename(G.location.fsPath),b=y.basename(q.location.fsPath);return ee<b?-1:ee>b?1:0})}D(M,A,U,V,G){const q=(b,R,C)=>{if(b.isValid&&!R.isValid)return!1;if(b.isValid===R.isValid){if(G&&w.gt(b.manifest.version,R.manifest.version))return this.s.debug(`Skipping extension ${R.location.path} with lower version ${R.manifest.version} in favour of ${b.location.path} with version ${b.manifest.version}`),!1;if(w.eq(b.manifest.version,R.manifest.version)){if(b.type===0)return this.s.debug(`Skipping extension ${R.location.path} in favour of system extension ${b.location.path} with same version`),!1;if(b.targetPlatform===V)return this.s.debug(`Skipping extension ${R.location.path} from different target platform ${R.targetPlatform}`),!1}}return C?this.s.warn(`Overwriting user extension ${b.location.path} with ${R.location.path}.`):this.s.debug(`Overwriting user extension ${b.location.path} with ${R.location.path}.`),!0},ee=new Map;return M?.forEach(b=>{const R=s.ExtensionIdentifier.toKey(b.identifier.id),C=ee.get(R);(!C||q(C,b,!1))&&ee.set(R,b)}),A?.forEach(b=>{const R=s.ExtensionIdentifier.toKey(b.identifier.id),C=ee.get(R);if(!C&&M&&b.type===0){this.s.debug(`Skipping obsolete system extension ${b.location.path}.`);return}(!C||q(C,b,!1))&&ee.set(R,b)}),U?.forEach(b=>{const R=s.ExtensionIdentifier.toKey(b.identifier.id),C=ee.get(R);(!C||q(C,b,!0))&&ee.set(R,b),ee.set(R,b)}),[...ee.values()]}async F(M,A){this.s.trace("Started scanning system extensions");const U=await this.I(this.systemExtensionsLocation,!1,0,!0,A),G=await(M&&!U.devMode?this.i:this.k).scanExtensions(U);return this.s.trace("Scanned system extensions:",G.length),G}async G(M,A){const U=this.t.isBuilt?[]:this.u.builtInExtensions;if(!U?.length)return[];this.s.trace("Started scanning dev system extensions");const V=A?await this.H():{},G=[],q=l.URI.file(y.normalize(y.join(m.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const b of U){const R=V[b.name]||"marketplace";switch(R){case"disabled":break;case"marketplace":G.push((0,I.joinPath)(q,b.name));break;default:G.push(l.URI.file(R));break}}const ee=await Promise.all(G.map(async b=>this.k.scanExtension(await this.I(b,!1,0,!0,M))));return this.s.trace("Scanned dev system extensions:",ee.length),(0,T.coalesce)(ee)}async H(){try{const M=await this.r.readFile(this.l);return JSON.parse(M.value.toString())}catch{return{}}}async I(M,A,U,V,G,q=!0){const ee=await this.f(G??p.language),b=await this.J(M),R=A&&!this.v.extUri.isEqual(M,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,C=R?await this.J(R):void 0;return new ne(M,b,R,C,A,U,V,q,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,G,ee)}async J(M){try{const A=await this.r.stat(M);if(typeof A.mtime=="number")return A.mtime}catch{}}};ie=de([_(4,O.IUserDataProfilesService),_(5,h.IExtensionsProfileScannerService),_(6,n.IFileService),_(7,r.ILogService),_(8,v.IEnvironmentService),_(9,o.IProductService),_(10,j.IUriIdentityService),_(11,t.IInstantiationService)],ie),e.AbstractExtensionsScannerService=ie;class ne{constructor(M,A,U,V,G,q,ee,b,R,C,F,B,W,te){this.location=M,this.mtime=A,this.applicationExtensionslocation=U,this.applicationExtensionslocationMtime=V,this.profile=G,this.type=q,this.excludeObsolete=ee,this.validate=b,this.productVersion=R,this.productDate=C,this.productCommit=F,this.devMode=B,this.language=W,this.translations=te}static createNlsConfiguration(M){return{language:M.language,pseudo:M.language==="pseudo",devMode:M.devMode,translations:M.translations}}static equals(M,A){return(0,I.isEqual)(M.location,A.location)&&M.mtime===A.mtime&&(0,I.isEqual)(M.applicationExtensionslocation,A.applicationExtensionslocation)&&M.applicationExtensionslocationMtime===A.applicationExtensionslocationMtime&&M.profile===A.profile&&M.type===A.type&&M.excludeObsolete===A.excludeObsolete&&M.validate===A.validate&&M.productVersion===A.productVersion&&M.productDate===A.productDate&&M.productCommit===A.productCommit&&M.devMode===A.devMode&&M.language===A.language&&X.equals(M.translations,A.translations)}}let Q=class extends c.Disposable{constructor(M,A,U,V,G){super(),this.f=M,this.g=A,this.h=U,this.i=V,this.j=G}async scanExtensions(M){const A=M.profile?await this.l(M):await this.k(M);let U={};if(M.excludeObsolete&&M.type===1)try{const V=(await this.i.readFile(this.f)).value.toString();U=JSON.parse(V)}catch{}return(0,E.isEmptyObject)(U)?A:A.filter(V=>!U[f.ExtensionKey.create(V).toString()])}async k(M){const A=await this.i.resolve(M.location);if(!A.children?.length)return[];const U=await Promise.all(A.children.map(async V=>{if(!V.isDirectory||M.type===1&&(0,I.basename)(V.resource).indexOf(".")===0)return null;const G=new ne(V.resource,M.mtime,M.applicationExtensionslocation,M.applicationExtensionslocationMtime,M.profile,M.type,M.excludeObsolete,M.validate,M.productVersion,M.productDate,M.productCommit,M.devMode,M.language,M.translations);return this.scanExtension(G)}));return(0,T.coalesce)(U).sort((V,G)=>V.location.path<G.location.path?-1:1)}async l(M){let A=await this.m(M.location,()=>!0,M);if(M.applicationExtensionslocation&&!this.h.extUri.isEqual(M.location,M.applicationExtensionslocation)){A=A.filter(V=>!V.metadata?.isApplicationScoped);const U=await this.m(M.applicationExtensionslocation,V=>!!V.metadata?.isApplicationScoped,M);A.push(...U)}return A}async m(M,A,U){const V=await this.g.scanProfileExtensions(M);if(!V.length)return[];const G=await Promise.all(V.map(async q=>{if(A(q)){const ee=new ne(q.location,U.mtime,U.applicationExtensionslocation,U.applicationExtensionslocationMtime,U.profile,U.type,U.excludeObsolete,U.validate,U.productVersion,U.productDate,U.productCommit,U.devMode,U.language,U.translations);return this.scanExtension(ee,q.metadata)}return null}));return(0,T.coalesce)(G)}async scanOneOrMultipleExtensions(M){try{if(await this.i.exists((0,I.joinPath)(M.location,"package.json"))){const A=await this.scanExtension(M);return A?[A]:[]}else return await this.scanExtensions(M)}catch(A){return this.j.error(`Error scanning extensions at ${M.location.path}:`,(0,N.getErrorMessage)(A)),[]}}async scanExtension(M,A){try{let U=await this.scanExtensionManifest(M.location);if(U){U.publisher||(U.publisher=s.UNDEFINED_PUBLISHER),A=A??U.__metadata,delete U.__metadata;const V=(0,f.getGalleryExtensionId)(U.publisher,U.name),G=A?.id?{id:V,uuid:A.id}:{id:V},q=A?.isSystem?0:M.type,ee=q===0||!!A?.isBuiltin;K.ImplicitActivationEvents.updateManifest(U),U=await this.n(M.location,U,ne.createNlsConfiguration(M));const b={type:q,identifier:G,manifest:U,location:M.location,isBuiltin:ee,targetPlatform:A?.targetPlatform??"undefined",metadata:A,isValid:!0,validations:[]};return M.validate?this.validate(b,M):b}}catch(U){M.type!==0&&this.j.error(U)}return null}validate(M,A){let U=!0;const V=(0,i.validateExtensionManifest)(A.productVersion,A.productDate,A.location,M.manifest,M.isBuiltin);for(const[G,q]of V)G===S.default.Error&&(U=!1,this.j.error(this.t(A.location,q)));return M.isValid=U,M.validations=V,M}async scanExtensionManifest(M){const A=(0,I.joinPath)(M,"package.json");let U;try{U=(await this.i.readFile(A)).value.toString()}catch(G){return(0,n.toFileOperationResult)(G)!==1&&this.j.error(this.t(M,(0,g.localize)(0,null,A.path,G.message))),null}let V;try{V=JSON.parse(U)}catch{const q=[];(0,P.parse)(U,q);for(const ee of q)this.j.error(this.t(M,(0,g.localize)(1,null,A.path,ee.offset,ee.length,(0,d.getParseErrorMessage)(ee.error))));return null}return(0,P.getNodeType)(V)!=="object"?(this.j.error(this.t(M,(0,g.localize)(2,null,A.path))),null):V}async n(M,A,U){const V=await this.p(M,A,U);if(V)try{const G=[],q=await this.r(V.default,G);if(G.length>0)return G.forEach(b=>{this.j.error(this.t(M,(0,g.localize)(3,null,V.default?.path,(0,d.getParseErrorMessage)(b.error))))}),A;if((0,P.getNodeType)(V)!=="object")return this.j.error(this.t(M,(0,g.localize)(4,null,V.default?.path))),A;const ee=V.values||Object.create(null);return(0,x.localizeManifest)(A,ee,q)}catch{}return A}async p(M,A,U){const V=(0,I.joinPath)(M,"package.nls.json"),G=(R,C)=>{C.forEach(F=>{this.j.error(this.t(M,(0,g.localize)(5,null,R?.path,(0,d.getParseErrorMessage)(F.error))))})},q=R=>{this.j.error(this.t(M,(0,g.localize)(6,null,R?.path)))},ee=`${A.publisher}.${A.name}`,b=U.translations[ee];if(b)try{const R=l.URI.file(b),C=(await this.i.readFile(R)).value.toString(),F=[],B=(0,P.parse)(C,F);return F.length>0?(G(R,F),{values:void 0,default:V}):(0,P.getNodeType)(B)!=="object"?(q(R),{values:void 0,default:V}):{values:B.contents?B.contents.package:void 0,default:V}}catch{return{values:void 0,default:V}}else{if(!await this.i.exists(V))return;let C;try{C=await this.s(M,U)}catch{return}if(!C.localized)return{values:void 0,default:C.original};try{const F=(await this.i.readFile(C.localized)).value.toString(),B=[],W=(0,P.parse)(F,B);return B.length>0?(G(C.localized,B),{values:void 0,default:C.original}):(0,P.getNodeType)(W)!=="object"?(q(C.localized),{values:void 0,default:C.original}):{values:W,default:C.original}}catch{return{values:void 0,default:C.original}}}}async r(M,A){if(M)try{const U=(await this.i.readFile(M)).value.toString();return(0,P.parse)(U,A)}catch{}}s(M,A){return new Promise((U,V)=>{const G=q=>{const ee=(0,I.joinPath)(M,`package.nls.${q}.json`);this.i.exists(ee).then(b=>{b&&U({localized:ee,original:(0,I.joinPath)(M,"package.nls.json")});const R=q.lastIndexOf("-");R===-1?U({localized:(0,I.joinPath)(M,"package.nls.json"),original:null}):(q=q.substring(0,R),G(q))})};if(A.devMode||A.pseudo||!A.language)return U({localized:(0,I.joinPath)(M,"package.nls.json"),original:null});G(A.language)})}t(M,A){return`[${M.path}]: ${A}`}};Q=de([_(1,h.IExtensionsProfileScannerService),_(2,j.IUriIdentityService),_(3,n.IFileService),_(4,r.ILogService)],Q);let ge=class extends Q{constructor(M,A,U,V,G,q){super(A,U,V,G,q),this.y=M,this.v=this.B(new D.ThrottledDelayer(3e3)),this.w=this.B(new u.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(M){const A=await this.z();if(this.u=M,A&&A.input&&ne.equals(A.input,this.u))return this.v.trigger(()=>this.D()),A.result.map(V=>(V.location=l.URI.revive(V.location),V));const U=await super.scanExtensions(M);return await this.C({input:M,result:U}),U}async z(){try{const M=await this.i.readFile(this.y),A=JSON.parse(M.value.toString());return{result:A.result,input:(0,a.revive)(A.input)}}catch(M){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,N.getErrorMessage)(M))}return null}async C(M){try{await this.i.writeFile(this.y,L.VSBuffer.fromString(JSON.stringify(M)))}catch(A){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,N.getErrorMessage)(A))}}async D(){if(!this.u)return;const M=await this.z();if(!M)return;const A=M.result,U=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!k.equals(U,A))try{await this.i.del(this.y),this.w.fire()}catch(V){this.j.error(V)}}};ge=de([_(2,h.IExtensionsProfileScannerService),_(3,j.IUriIdentityService),_(4,n.IFileService),_(5,r.ILogService)],ge);function ce(me,M){const A=(0,f.getExtensionId)(me.manifest.publisher,me.manifest.name);return{id:A,identifier:new s.ExtensionIdentifier(A),isBuiltin:me.type===0,isUserBuiltin:me.type===1&&me.isBuiltin,isUnderDevelopment:M,extensionLocation:me.location,uuid:me.identifier.uuid,targetPlatform:me.targetPlatform,...me.manifest}}e.toExtensionDescription=ce;class re extends ie{constructor(M,A,U,V,G,q,ee,b,R,C,F,B){super(M,A,(0,I.joinPath)(U,".vscode-oss-dev","extensions","control.json"),(0,I.joinPath)(V,s.MANIFEST_CACHE_FOLDER),G,q,ee,b,R,C,F,B),this.L=(async()=>{if(p.translationsConfigFile)try{const W=await this.r.readFile(l.URI.file(p.translationsConfigFile));return JSON.parse(W.value.toString())}catch{}return Object.create(null)})()}f(M){return this.L}}e.NativeExtensionsScannerService=re}),define(Y[145],Z([0,1,57,3,34,4,2,16,14,20,9,25]),function($,e,T,D,k,L,N,P,d,c,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let p=class extends N.Disposable{constructor(w,S){super(),this.b=w,this.f=S,this.a=new D.Limiter(5)}async postUninstall(w){const S=this.g(w,"uninstall");return S&&(this.f.info(w.identifier.id,w.manifest.version,"Running post uninstall script"),await this.a.queue(()=>this.h(S.script,"uninstall",S.args,!0,w).then(()=>this.f.info(w.identifier.id,w.manifest.version,"Finished running post uninstall script"),E=>this.f.error(w.identifier.id,w.manifest.version,`Failed to run post uninstall script: ${E}`)))),c.Promises.rm(this.j(w)).then(void 0,E=>this.f.error("Error while removing extension storage path",E))}g(w,S){const E=`vscode:${S}`;if(w.location.scheme===P.Schemas.file&&w.manifest&&w.manifest.scripts&&typeof w.manifest.scripts[E]=="string"){const l=w.manifest.scripts[E].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.f.warn(w.identifier.id,w.manifest.version,`${E} should be a node script`),null):{script:(0,d.join)(w.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}h(w,S,E,l,g){return new Promise((v,f)=>{const s=this.i(w,S,E,g);let i;const n=t=>{i&&(clearTimeout(i),i=null),t?f(t):v(void 0)};s.on("error",t=>{n((0,k.toErrorMessage)(t)||"Unknown")}),s.on("exit",(t,r)=>{n(t?`post-${S} process exited with code ${t}`:void 0)}),l&&(i=setTimeout(()=>{i=null,s.kill(),f("timed out")},5e3))})}i(w,S,E,l){const g={silent:!0,execArgv:void 0},v=(0,T.fork)(w,[`--type=extension-post-${S}`,...E],g);v.stdout.setEncoding("utf8"),v.stderr.setEncoding("utf8");const f=L.Event.fromNodeEventEmitter(v.stdout,"data"),s=L.Event.fromNodeEventEmitter(v.stderr,"data");f(t=>this.f.info(l.identifier.id,l.manifest.version,`post-${S}`,t)),s(t=>this.f.error(l.identifier.id,l.manifest.version,`post-${S}`,t));const i=L.Event.any(L.Event.map(f,t=>({data:`%c${t}`,format:[""]})),L.Event.map(s,t=>({data:`%c${t}`,format:["color: red"]})));return L.Event.debounce(i,(t,r)=>t?{data:t.data+r.data,format:[...t.format,...r.format]}:{data:r.data,format:r.format},100)(t=>{console.group(l.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),v}j(w){return(0,d.join)(this.b.defaultProfile.globalStorageHome.fsPath,w.identifier.id.toLowerCase())}};p=de([_(0,y.IUserDataProfilesService),_(1,m.ILogService)],p),e.ExtensionsLifecycle=p}),define(Y[146],Z([0,1,11,18,42,48,13,8,9,26,28,25]),function($,e,T,D,k,L,N,P,d,c,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let p=class extends L.NativeExtensionsScannerService{constructor(w,S,E,l,g,v,f,s){super(T.URI.file(g.builtinExtensionsPath),T.URI.file(g.extensionsPath),g.userHome,T.URI.file(g.userDataPath),w,S,E,l,g,v,f,s)}};p=de([_(0,y.IUserDataProfilesService),_(1,k.IExtensionsProfileScannerService),_(2,N.IFileService),_(3,d.ILogService),_(4,D.INativeEnvironmentService),_(5,c.IProductService),_(6,m.IUriIdentityService),_(7,P.IInstantiationService)],p),e.ExtensionsScannerService=p}),define(Y[147],Z([0,1,3,4,2,117,5,83,8,25]),function($,e,T,D,k,L,N,P,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,d.createDecorator)("storageService");var m;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(m=e.WillSaveStateReason||(e.WillSaveStateReason={}));var y;(function(g){g[g.APPLICATION=-1]="APPLICATION",g[g.PROFILE=0]="PROFILE",g[g.WORKSPACE=1]="WORKSPACE"})(y=e.StorageScope||(e.StorageScope={}));var p;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(p=e.StorageTarget||(e.StorageTarget={}));function I(g){const v=g.get(e.TARGET_KEY);if(v)try{return JSON.parse(v)}catch{}return Object.create(null)}e.loadKeyTargets=I;class w extends k.Disposable{constructor(v={flushInterval:w.a}){super(),this.j=v,this.b=this.B(new D.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new D.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new D.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new T.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new k.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,T.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,k.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.J()}finally{(0,L.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(v,f){if(f===e.TARGET_KEY){switch(v){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:v})}else this.b.fire({scope:v,key:f,target:this.F(v)[f]})}r(v){this.f.fire({reason:v})}get(v,f,s){return this.L(f)?.get(v,s)}getBoolean(v,f,s){return this.L(f)?.getBoolean(v,s)}getNumber(v,f,s){return this.L(f)?.getNumber(v,s)}store(v,f,s,i){if((0,N.isUndefinedOrNull)(f)){this.remove(v,s);return}this.t(()=>{this.u(v,s,i),this.L(s)?.set(v,f)})}remove(v,f){this.t(()=>{this.u(v,f,void 0),this.L(f)?.delete(v)})}t(v){this.b.pause(),this.c.pause();try{v()}finally{this.b.resume(),this.c.resume()}}keys(v,f){const s=[],i=this.F(v);for(const n of Object.keys(i))i[n]===f&&s.push(n);return s}u(v,f,s){const i=this.F(f);typeof s=="number"?i[v]!==s&&(i[v]=s,this.L(f)?.set(e.TARGET_KEY,JSON.stringify(i))):typeof i[v]=="number"&&(delete i[v],this.L(f)?.set(e.TARGET_KEY,JSON.stringify(i)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(v){switch(v){case-1:return this.D;case 0:return this.z;default:return this.w}}G(v){const f=this.L(v);return f?I(f):Object.create(null)}isNew(v){return this.getBoolean(e.IS_NEW_KEY,v)===!0}async flush(v=m.NONE){this.f.fire({reason:v});const f=this.L(-1),s=this.L(0),i=this.L(1);switch(v){case m.NONE:await T.Promises.settled([f?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case m.SHUTDOWN:await T.Promises.settled([f?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const v=this.L(-1)?.items??new Map,f=this.L(0)?.items??new Map,s=this.L(1)?.items??new Map;return l(v,f,s,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(v,f){return this.r(m.NONE),(0,c.isUserDataProfile)(v)?this.N(v,f):this.O(v,f)}H(v,f){return!(v.id===f.id||S(f)&&S(v))}I(v,f,s,i){this.t(()=>{if(i)for(const[n,t]of v)f.set(n,t);else{const n=new Set;for(const[t,r]of v)n.add(t),f.get(t)!==r&&this.n(s,t);for(const[t]of f.items)n.has(t)||this.n(s,t)}})}}e.AbstractStorageService=w,w.a=60*1e3;function S(g){return g.isDefault||!!g.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=S;class E extends w{constructor(){super(),this.p=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(v=>this.n(1,v))),this.B(this.P.onDidChangeStorage(v=>this.n(0,v))),this.B(this.p.onDidChangeStorage(v=>this.n(-1,v)))}L(v){switch(v){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(v){switch(v){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(v){return!1}}e.InMemoryStorageService=E;async function l(g,v,f,s,i,n){const t=K=>{try{return JSON.parse(K)}catch{return K}},r=new Map,o=new Map;g.forEach((K,X)=>{r.set(X,K),o.set(X,t(K))});const u=new Map,a=new Map;v.forEach((K,X)=>{u.set(X,K),a.set(X,t(K))});const h=new Map,O=new Map;f.forEach((K,X)=>{h.set(X,K),O.set(X,t(K))}),console.group(s!==i?`Storage: Application (path: ${s})`:`Storage: Application & Profile (path: ${s}, default profile)`);const j=[];if(r.forEach((K,X)=>{j.push({key:X,value:K})}),console.table(j),console.groupEnd(),console.log(o),s!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const K=[];u.forEach((X,ie)=>{K.push({key:ie,value:X})}),console.table(K),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${n})`);const x=[];h.forEach((K,X)=>{x.push({key:X,value:K})}),console.table(x),console.groupEnd(),console.log(O)}e.logStorage=l}),define(Y[148],Z([0,1,19,22,10,12,35,5,11,21,18,23,24,45,13,9,26,47,135,147,32]),function($,e,T,D,k,L,N,P,d,c,m,y,p,I,w,S,E,l,g,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const s=L.isWeb?"web":(0,y.getTargetPlatform)(L.platform,N.arch);var i;(function(b){b[b.None=0]="None",b[b.IncludeVersions=1]="IncludeVersions",b[b.IncludeFiles=2]="IncludeFiles",b[b.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",b[b.IncludeSharedAccounts=8]="IncludeSharedAccounts",b[b.IncludeVersionProperties=16]="IncludeVersionProperties",b[b.ExcludeNonValidated=32]="ExcludeNonValidated",b[b.IncludeInstallationTargets=64]="IncludeInstallationTargets",b[b.IncludeAssetUri=128]="IncludeAssetUri",b[b.IncludeStatistics=256]="IncludeStatistics",b[b.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",b[b.Unpublished=4096]="Unpublished",b[b.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function n(...b){return String(b.reduce((R,C)=>R|C,0))}var t;(function(b){b[b.Tag=1]="Tag",b[b.ExtensionId=4]="ExtensionId",b[b.Category=5]="Category",b[b.ExtensionName=7]="ExtensionName",b[b.Target=8]="Target",b[b.Featured=9]="Featured",b[b.SearchText=10]="SearchText",b[b.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class h{constructor(R=a){this.d=R}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(R,C=this.d.pageSize){return new h({...this.d,pageNumber:R,pageSize:C})}withFilter(R,...C){const F=[...this.d.criteria,...C.length?C.map(B=>({filterType:R,value:B})):[{filterType:R}]];return new h({...this.d,criteria:F})}withSortBy(R){return new h({...this.d,sortBy:R})}withSortOrder(R){return new h({...this.d,sortOrder:R})}withFlags(...R){return new h({...this.d,flags:R.reduce((C,F)=>C|F,0)})}withAssetTypes(...R){return new h({...this.d,assetTypes:R})}withSource(R){return new h({...this.d,source:R})}get raw(){const{criteria:R,pageNumber:C,pageSize:F,sortBy:B,sortOrder:W,flags:te,assetTypes:se}=this.d;return{filters:[{criteria:R,pageNumber:C,pageSize:F,sortBy:B,sortOrder:W}],assetTypes:se,flags:te}}get searchText(){const R=this.d.criteria.filter(C=>C.filterType===t.SearchText)[0];return R&&R.value?R.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(R=>String(R.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function O(b,R){const C=(b||[]).filter(F=>F.statisticName===R)[0];return C?C.value:0}function j(b){const R="Microsoft.VisualStudio.Code.Translation.";return b.files.filter(F=>F.assetType.indexOf(R)===0).reduce((F,B)=>{const W=X(b,B.assetType);return W&&F.push([B.assetType.substring(R.length),W]),F},[])}function x(b){if(b.properties){const R=b.properties.filter(B=>B.key===r.Repository),C=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),F=R.filter(B=>C.test(B.value))[0];return F?{uri:F.value,fallbackUri:F.value}:null}return X(b,r.Repository)}function K(b){return{uri:`${b.fallbackAssetUri}/${r.VSIX}?redirect=true${b.targetPlatform?`&targetPlatform=${b.targetPlatform}`:""}`,fallbackUri:`${b.fallbackAssetUri}/${r.VSIX}${b.targetPlatform?`?targetPlatform=${b.targetPlatform}`:""}`}}function X(b,R){return b.files.filter(F=>F.assetType===R)[0]?{uri:`${b.assetUri}/${R}${b.targetPlatform?`?targetPlatform=${b.targetPlatform}`:""}`,fallbackUri:`${b.fallbackAssetUri}/${R}${b.targetPlatform?`?targetPlatform=${b.targetPlatform}`:""}`}:null}function ie(b,R){const C=b.properties?b.properties.filter(B=>B.key===R):[],F=C.length>0&&C[0].value;return F?F.split(",").map(B=>(0,p.adoptToGalleryExtensionId)(B)):[]}function ne(b){const R=b.properties?b.properties.filter(C=>C.key===o.Engine):[];return R.length>0&&R[0].value||""}function Q(b){const R=b.properties?b.properties.filter(C=>C.key===o.PreRelease):[];return R.length>0&&R[0].value==="true"}function ge(b){const R=b.properties?b.properties.filter(F=>F.key===o.LocalizedLanguages):[],C=R.length>0&&R[0].value||"";return C?C.split(","):[]}function ce(b){return b.properties?.find(R=>R.key===o.SponsorLink)?.value}function re(b){return b.indexOf("preview")!==-1}function me(b){return b.targetPlatform?(0,y.toTargetPlatform)(b.targetPlatform):"undefined"}function M(b){const R=(0,T.distinct)(b.versions.map(me)),C=!!b.tags?.includes(y.WEB_EXTENSION_TAG),F=R.indexOf("web");return C?F===-1&&R.push("web"):F!==-1&&R.splice(F,1),R}function A(b,R){const C=(0,y.getFallbackTargetPlarforms)(R);for(let F=0;F<b.length;F++){const B=b[F];if(B.version===b[F-1]?.version){let W=F;const te=me(B);if(te===R)for(;W>0&&b[W-1].version===B.version;)W--;else if(C.includes(te))for(;W>0&&b[W-1].version===B.version&&me(b[W-1])!==R;)W--;W!==F&&(b.splice(F,1),b.splice(W,0,B))}}return b}e.sortExtensionVersions=A;function U(b,R,C){b.telemetryData={index:R,querySource:C}}function V(b,R,C){const F=b.versions[0],B={manifest:X(R,r.Manifest),readme:X(R,r.Details),changelog:X(R,r.Changelog),license:X(R,r.License),repository:x(R),download:K(R),icon:X(R,r.Icon),signature:X(R,r.Signature),coreTranslations:j(R)};return{identifier:{id:(0,p.getGalleryExtensionId)(b.publisher.publisherName,b.extensionName),uuid:b.extensionId},name:b.extensionName,version:R.version,displayName:b.displayName,publisherId:b.publisher.publisherId,publisher:b.publisher.publisherName,publisherDisplayName:b.publisher.displayName,publisherDomain:b.publisher.domain?{link:b.publisher.domain,verified:!!b.publisher.isDomainVerified}:void 0,publisherSponsorLink:ce(F),description:b.shortDescription||"",installCount:O(b.statistics,"install"),rating:O(b.statistics,"averagerating"),ratingCount:O(b.statistics,"ratingcount"),categories:b.categories||[],tags:b.tags||[],releaseDate:Date.parse(b.releaseDate),lastUpdated:Date.parse(b.lastUpdated),allTargetPlatforms:C,assets:B,properties:{dependencies:ie(R,o.Dependency),extensionPack:ie(R,o.ExtensionPack),engine:ne(R),localizedLanguages:ge(R),targetPlatform:me(R),isPreReleaseVersion:Q(R)},hasPreReleaseVersion:Q(F),hasReleaseVersion:!0,preview:re(b.flags),isSigned:!!B.signature}}let G=class{constructor(R,C,F,B,W,te,se,pe){this.k=C,this.l=F,this.n=B,this.o=W,this.q=te,this.u=se,this.w=pe;const ye=se.extensionsGallery,ae=ye?.servicePPEUrl&&pe.getValue("_extensionsGallery.enablePPE");this.d=ae?ye.servicePPEUrl:ye?.serviceUrl,this.g=ae?void 0:ye?.searchUrl,this.h=ye?.controlUrl,this.j=(0,g.resolveMarketplaceHeaders)(se.version,se,this.n,this.w,this.q,R,this.o)}x(R=""){return`${this.d}${R}`}isEnabled(){return!!this.d}async getExtensions(R,C,F){const B=D.CancellationToken.isCancellationToken(C)?{}:C,W=D.CancellationToken.isCancellationToken(C)?C:F,te=[],se=[],pe=[],ye=[];let ae=!0;for(const oe of R){oe.uuid?se.push(oe.uuid):te.push(oe.id);const fe=!!(oe.version||oe.preRelease);pe.push({id:oe.id,uuid:oe.uuid,includePreRelease:fe}),oe.version&&ye.push({id:oe.id,uuid:oe.uuid,version:oe.version}),ae=ae&&!!oe.hasPreRelease&&!fe}if(!se.length&&!te.length)return[];let ue=new h().withPage(1,R.length);se.length&&(ue=ue.withFilter(t.ExtensionId,...se)),te.length&&(ue=ue.withFilter(t.ExtensionName,...te)),(B.queryAllVersions||ae)&&(ue=ue.withFlags(ue.flags,i.IncludeVersions)),B.source&&(ue=ue.withSource(B.source));const{extensions:le}=await this.z(ue,{targetPlatform:B.targetPlatform??s,includePreRelease:pe,versions:ye,compatible:!!B.compatible},W);return B.source&&le.forEach((oe,fe)=>U(oe,fe,B.source)),le}async getCompatibleExtension(R,C,F){if((0,y.isNotWebExtensionInWebTargetPlatform)(R.allTargetPlatforms,F))return null;if(await this.isExtensionCompatible(R,C,F))return R;const B=new h().withFlags(i.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,R.identifier.uuid),{extensions:W}=await this.z(B,{targetPlatform:F,compatible:!0,includePreRelease:C},D.CancellationToken.None);return W[0]||null}async isExtensionCompatible(R,C,F){if(!(0,y.isTargetPlatformCompatible)(R.properties.targetPlatform,R.allTargetPlatforms,F)||!C&&R.properties.isPreReleaseVersion)return!1;let B=R.properties.engine;if(!B){const W=await this.getManifest(R,D.CancellationToken.None);if(!W)throw new Error("Manifest was not found");B=W.engines.vscode}return(0,I.isEngineValid)(B,this.u.version,this.u.date)}async y(R,C,F,B,W){if(!(0,y.isTargetPlatformCompatible)(me(R),B,W)||C!=="any"&&Q(R)!==(C==="prerelease"))return!1;if(F)try{const te=await this.E(R);if(!(0,I.isEngineValid)(te,this.u.version,this.u.date))return!1}catch(te){return this.l.error(`Error while getting the engine for the version ${R.version}.`,(0,k.getErrorMessage)(te)),!1}return!0}async query(R,C){let F=R.text||"";const B=R.pageSize??50;let W=new h().withPage(1,B);F?(F=F.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ae,ue,le)=>(W=W.withFilter(t.Category,le||ue),"")),F=F.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ae,ue,le)=>(W=W.withFilter(t.Tag,le||ue),"")),F=F.replace(/\bfeatured(\s+|\b|$)/g,()=>(W=W.withFilter(t.Featured),"")),F=F.trim(),F&&(F=F.length<200?F:F.substring(0,200),W=W.withFilter(t.SearchText,F)),W=W.withSortBy(0)):R.ids?W=W.withFilter(t.ExtensionId,...R.ids):R.names?W=W.withFilter(t.ExtensionName,...R.names):W=W.withSortBy(4),typeof R.sortBy=="number"&&(W=W.withSortBy(R.sortBy)),typeof R.sortOrder=="number"&&(W=W.withSortOrder(R.sortOrder)),R.source&&(W=W.withSource(R.source));const te=async(ae,ue)=>{const{extensions:le,total:oe}=await this.z(ae,{targetPlatform:s,compatible:!1,includePreRelease:!!R.includePreRelease},ue);return le.forEach((fe,Te)=>U(fe,(ae.pageNumber-1)*ae.pageSize+Te,R.source)),{extensions:le,total:oe}},{extensions:se,total:pe}=await te(W,C),ye=async(ae,ue)=>{if(ue.isCancellationRequested)throw new k.CancellationError;const{extensions:le}=await te(W.withPage(ae+1),ue);return le};return{firstPage:se,total:pe,pageSize:W.pageSize,getPage:ye}}async z(R,C,F){const B=R.flags;!!(R.flags&i.IncludeLatestVersionOnly)&&!!(R.flags&i.IncludeVersions)&&(R=R.withFlags(R.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(R.flags&i.IncludeLatestVersionOnly)&&!(R.flags&i.IncludeVersions)&&(R=R.withFlags(R.flags,i.IncludeLatestVersionOnly)),C.versions?.length&&(R=R.withFlags(R.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),R=R.withFlags(R.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:W,total:te}=await this.B(R,F);if(!(R.flags&i.IncludeLatestVersionOnly)){const ae=[];for(const ue of W){const le=await this.A(ue,C);le&&ae.push(le)}return{extensions:ae,total:te}}const pe=[],ye=new Map;for(let ae=0;ae<W.length;ae++){const ue=W[ae],le={id:(0,p.getGalleryExtensionId)(ue.publisher.publisherName,ue.extensionName),uuid:ue.extensionId},oe=(0,P.isBoolean)(C.includePreRelease)?C.includePreRelease:!!C.includePreRelease.find(Te=>(0,p.areSameExtensions)(Te,le))?.includePreRelease;if(C.compatible&&(0,y.isNotWebExtensionInWebTargetPlatform)(M(ue),C.targetPlatform))continue;const fe=await this.A(ue,C);!fe||fe.properties.isPreReleaseVersion&&(!oe||!fe.hasReleaseVersion)||!fe.properties.isPreReleaseVersion&&fe.properties.targetPlatform!==C.targetPlatform&&fe.hasPreReleaseVersion?ye.set(ue.extensionId,ae):pe.push([ae,fe])}if(ye.size){const ae=new Date().getTime(),ue=new h().withFlags(B&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,ye.size).withFilter(t.ExtensionId,...ye.keys()),{extensions:le}=await this.z(ue,C,F);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ae,count:ye.size});for(const oe of le){const fe=ye.get(oe.identifier.uuid);pe.push([fe,oe])}}return{extensions:pe.sort((ae,ue)=>ae[0]-ue[0]).map(([,ae])=>ae),total:te}}async A(R,C){const F={id:(0,p.getGalleryExtensionId)(R.publisher.publisherName,R.extensionName),uuid:R.extensionId},B=C.versions?.find(pe=>(0,p.areSameExtensions)(pe,F))?.version,W=(0,P.isBoolean)(C.includePreRelease)?C.includePreRelease:!!C.includePreRelease.find(pe=>(0,p.areSameExtensions)(pe,F))?.includePreRelease,te=M(R),se=A(R.versions,C.targetPlatform);if(C.compatible&&(0,y.isNotWebExtensionInWebTargetPlatform)(te,C.targetPlatform))return null;for(let pe=0;pe<se.length;pe++){const ye=se[pe];if(!(B&&ye.version!==B)){if(await this.y(ye,W?"any":"release",C.compatible,te,C.targetPlatform))return V(R,ye,te);if(B&&ye.version===B)return null}}return B||C.compatible?null:V(R,R.versions[0],te)}async B(R,C){if(!this.isEnabled())throw new Error("No extension gallery service configured.");R=R.withFlags(R.flags,i.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,n(i.Unpublished));const F=await this.j,B=JSON.stringify(R.raw),W={...F,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(B.length)},te=new Date().getTime();let se,pe,ye=0;try{if(se=await this.k.request({type:"POST",url:this.g&&R.criteria.some(ue=>ue.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:B,headers:W},C),se.res.statusCode&&se.res.statusCode>=400&&se.res.statusCode<500)return{galleryExtensions:[],total:ye};const ae=await(0,l.asJson)(se);if(ae){const ue=ae.results[0],le=ue.extensions,oe=ue.resultMetadata&&ue.resultMetadata.filter(fe=>fe.metadataType==="ResultCount")[0];return ye=oe&&oe.metadataItems.filter(fe=>fe.name==="TotalCount")[0].count||0,{galleryExtensions:le,total:ye}}return{galleryExtensions:[],total:ye}}catch(ae){throw pe=ae,ae}finally{this.o.publicLog2("galleryService:query",{...R.telemetryData,requestBodySize:String(B.length),duration:new Date().getTime()-te,success:!!se&&(0,l.isSuccess)(se),responseBodySize:se?.res.headers["Content-Length"],statusCode:se?String(se.res.statusCode):void 0,errorCode:pe?(0,k.isCancellationError)(pe)?"canceled":(0,k.getErrorMessage)(pe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ye)})}}async reportStatistic(R,C,F,B){if(!this.isEnabled())return;const W=L.isWeb?this.x(`/itemName/${R}.${C}/version/${F}/statType/${B==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${R}/extensions/${C}/${F}/stats?statType=${B}`),te=L.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.j,Accept:te};try{await this.k.request({type:"POST",url:W,headers:pe},D.CancellationToken.None)}catch{}}async download(R,C,F){this.l.trace("ExtensionGalleryService#download",R.identifier.id);const B=(0,p.getGalleryExtensionTelemetryData)(R),W=new Date().getTime(),te=ae=>this.o.publicLog("galleryService:downloadVSIX",{...B,duration:ae}),se=F===2?"install":F===3?"update":"",pe=se?{uri:`${R.assets.download.uri}${d.URI.parse(R.assets.download.uri).query?"&":"?"}${se}=true`,fallbackUri:`${R.assets.download.fallbackUri}${d.URI.parse(R.assets.download.fallbackUri).query?"&":"?"}${se}=true`}:R.assets.download,ye=await this.D(pe);await this.q.writeFile(C,ye.stream),te(new Date().getTime()-W)}async downloadSignatureArchive(R,C){if(!R.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",R.identifier.id);const F=await this.D(R.assets.signature);await this.q.writeFile(C,F.stream)}async getReadme(R,C){if(R.assets.readme){const F=await this.D(R.assets.readme,{},C);return await(0,l.asTextOrError)(F)||""}return""}async getManifest(R,C){if(R.assets.manifest){const F=await this.D(R.assets.manifest,{},C),B=await(0,l.asTextOrError)(F);return B?JSON.parse(B):null}return null}async C(R,C){const F=X(R,r.Manifest);if(!F)throw new Error("Manifest was not found");const B={"Accept-Encoding":"gzip"},W=await this.D(F,{headers:B});return await(0,l.asJson)(W)}async getCoreTranslation(R,C){const F=R.assets.coreTranslations.filter(B=>B[0]===C.toUpperCase())[0];if(F){const B=await this.D(F[1]),W=await(0,l.asTextOrError)(B);return W?JSON.parse(W):null}return null}async getChangelog(R,C){if(R.assets.changelog){const F=await this.D(R.assets.changelog,{},C);return await(0,l.asTextOrError)(F)||""}return""}async getAllCompatibleVersions(R,C,F){let B=new h().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);R.identifier.uuid?B=B.withFilter(t.ExtensionId,R.identifier.uuid):B=B.withFilter(t.ExtensionName,R.identifier.id);const{galleryExtensions:W}=await this.B(B,D.CancellationToken.None);if(!W.length)return[];const te=M(W[0]);if((0,y.isNotWebExtensionInWebTargetPlatform)(te,F))return[];const se=[];await Promise.all(W[0].versions.map(async ae=>{try{await this.y(ae,C?"any":"release",!0,te,F)&&se.push(ae)}catch{}}));const pe=[],ye=new Set;for(const ae of A(se,F))ye.has(ae.version)||(ye.add(ae.version),pe.push({version:ae.version,date:ae.lastUpdated,isPreReleaseVersion:Q(ae)}));return pe}async D(R,C={},F=D.CancellationToken.None){const B=await this.j,W={type:"GET"},te={...B,...C.headers||{}};C={...C,...W,headers:te};const se=R.uri,pe=R.fallbackUri,ye={...C,url:se};try{const ae=await this.k.request(ye,F);if(ae.res.statusCode===200)return ae;const ue=await(0,l.asTextOrError)(ae);throw new Error(`Expected 200, got back ${ae.res.statusCode} instead.

${ue}`)}catch(ae){if((0,k.isCancellationError)(ae))throw ae;const ue=(0,k.getErrorMessage)(ae);this.o.publicLog2("galleryService:cdnFallback",{url:se,message:ue});const le={...C,url:pe};return this.k.request(le,F)}}async E(R){let C=ne(R);if(!C){const F=await this.C(R,D.CancellationToken.None);if(!F)throw new Error("Manifest was not found");C=F.engines.vscode}return C}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const R=await this.k.request({type:"GET",url:this.h},D.CancellationToken.None);if(R.res.statusCode!==200)throw new Error("Could not get extensions report.");const C=await(0,l.asJson)(R),F=[],B={};if(C){for(const W of C.malicious)F.push({id:W});if(C.migrateToPreRelease)for(const[W,te]of Object.entries(C.migrateToPreRelease))(!te.engine||(0,I.isEngineValid)(te.engine,this.u.version,this.u.date))&&(B[W.toLowerCase()]={disallowInstall:!0,extension:{id:te.id,displayName:te.displayName,autoMigrate:{storage:!!te.migrateStorage},preRelease:!0}});if(C.deprecated)for(const[W,te]of Object.entries(C.deprecated))te&&(B[W.toLowerCase()]=(0,P.isBoolean)(te)?{}:te)}return{malicious:F,deprecated:B}}};G=de([_(1,l.IRequestService),_(2,S.ILogService),_(3,m.IEnvironmentService),_(4,f.ITelemetryService),_(5,w.IFileService),_(6,E.IProductService),_(7,c.IConfigurationService)],G);let q=class extends G{constructor(R,C,F,B,W,te,se,pe){super(R,C,F,B,W,te,se,pe)}};q=de([_(0,v.IStorageService),_(1,l.IRequestService),_(2,S.ILogService),_(3,m.IEnvironmentService),_(4,f.ITelemetryService),_(5,w.IFileService),_(6,E.IProductService),_(7,c.IConfigurationService)],q),e.ExtensionGalleryService=q;let ee=class extends G{constructor(R,C,F,B,W,te,se){super(void 0,R,C,F,B,W,te,se)}};ee=de([_(0,l.IRequestService),_(1,S.ILogService),_(2,m.IEnvironmentService),_(3,f.ITelemetryService),_(4,w.IFileService),_(5,E.IProductService),_(6,c.IConfigurationService)],ee),e.ExtensionGalleryServiceWithNoStorageService=ee}),define(Y[149],Z([0,1,44,11,18,13,9,67,28,25]),function($,e,T,D,k,L,N,P,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=void 0;let m=class $e extends c.UserDataProfilesService{constructor(p,I,w,S,E){super(w,S,I,E),this.a=p,this.N=w}H(){return(0,T.revive)(this.a.getItem($e.b,[]))}J(){return(0,T.revive)(this.a.getItem($e.c,{}))}M(){return this.r.extUri.joinPath(D.URI.file(this.N.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};m=de([_(0,P.IStateService),_(1,d.IUriIdentityService),_(2,k.INativeEnvironmentService),_(3,L.IFileService),_(4,N.ILogService)],m),e.UserDataProfilesService=m}),define(Y[150],Z([0,1,38,3,163,2,9]),function($,e,T,D,k,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let P=class extends T.AbstractPolicyService{constructor(c,m){super(),this.j=c,this.k=m,this.a=new D.Throttler,this.b=this.B(new L.MutableDisposable)}async i(c){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(c).length} policy definitions`),await this.a.queue(()=>new Promise((m,y)=>{try{this.b.value=(0,k.createWatcher)(this.k,c,p=>{this.m(p),m()})}catch(p){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",p),y(p)}}))}m(c){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(c)}`);for(const m in c){const y=c[m];y===void 0?this.g.delete(m):this.g.set(m,y)}this.h.fire(Object.keys(c))}};P=de([_(0,N.ILogService)],P),e.NativePolicyService=P}),define(Y[69],Z([0,1,119,3,14,5,20,84,164,165]),function($,e,T,D,k,L,N,P,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class m extends Error{constructor(i,n){let t=n.message;switch(i){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t),this.type=i,this.cause=n}}e.ExtractError=m;function y(s){const i=s.externalFileAttributes>>16||33188;return[448,56,7].map(n=>i&n).reduce((n,t)=>n+t,i&61440)}function p(s){if(s instanceof m)return s;let i;return/end of central directory record signature not found/.test(s.message)&&(i="CorruptZip"),new m(i,s)}function I(s,i,n,t,r,o){const u=k.dirname(i),a=k.join(t,u);if(!a.startsWith(t))return Promise.reject(new Error(P.localize(0,null,i)));const h=k.join(t,i);let O;return o.onCancellationRequested(()=>{O?.destroy()}),Promise.resolve(N.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((j,x)=>{if(!o.isCancellationRequested)try{O=(0,T.createWriteStream)(h,{mode:n}),O.once("close",()=>j()),O.once("error",x),s.once("error",x),s.pipe(O)}catch(K){x(K)}}))}function w(s,i,n,t){let r=(0,D.createCancelablePromise)(()=>Promise.resolve()),o=0;return t.onCancellationRequested(()=>{r.cancel(),s.close()}),new Promise((u,a)=>{const h=new D.Sequencer,O=j=>{j.isCancellationRequested||(o++,s.readEntry())};s.once("error",a),s.once("close",()=>r.then(()=>{t.isCancellationRequested||s.entryCount===o?u():a(new m("Incomplete",new Error(P.localize(1,null,o,s.entryCount))))},a)),s.readEntry(),s.on("entry",j=>{if(t.isCancellationRequested)return;if(!n.sourcePathRegex.test(j.fileName)){O(t);return}const x=j.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(x)){const ie=k.join(i,x);r=(0,D.createCancelablePromise)(ne=>N.Promises.mkdir(ie,{recursive:!0}).then(()=>O(ne)).then(void 0,a));return}const K=E(s,j),X=y(j);r=(0,D.createCancelablePromise)(ie=>h.queue(()=>K.then(ne=>I(ne,x,X,i,n,ie).then(()=>O(ie)))).then(null,a))})})}function S(s,i=!1){return new Promise((n,t)=>{(0,d.open)(s,i?{lazyEntries:!0}:void 0,(r,o)=>{r?t(p(r)):n((0,L.assertIsDefined)(o))})})}function E(s,i){return new Promise((n,t)=>{s.openReadStream(i,(r,o)=>{r?t(p(r)):n((0,L.assertIsDefined)(o))})})}function l(s,i){return new Promise((n,t)=>{const r=new c.ZipFile;i.forEach(u=>{u.contents?r.addBuffer(typeof u.contents=="string"?Buffer.from(u.contents,"utf8"):u.contents,u.path):u.localPath&&r.addFile(u.localPath,u.path)}),r.end();const o=(0,T.createWriteStream)(s);r.outputStream.pipe(o),r.outputStream.once("error",t),o.once("error",t),o.once("finish",()=>n(s))})}e.zip=l;function g(s,i,n={},t){const r=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let o=S(s,!0);return n.overwrite&&(o=o.then(u=>N.Promises.rm(i).then(()=>u))),o.then(u=>w(u,i,{sourcePathRegex:r},t))}e.extract=g;function v(s,i){return S(s).then(n=>new Promise((t,r)=>{n.on("entry",o=>{o.fileName===i&&E(n,o).then(u=>t(u),u=>r(u))}),n.once("close",()=>r(new Error(P.localize(2,null,i))))}))}function f(s,i){return v(s,i).then(n=>new Promise((t,r)=>{const o=[];n.once("error",r),n.on("data",u=>o.push(u)),n.on("end",()=>t(Buffer.concat(o)))}))}e.buffer=f}),define(Y[151],Z([0,1,69,92]),function($,e,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function k(L){return(0,T.buffer)(L,"extension/package.json").then(N=>{try{return JSON.parse(N.toString("utf8"))}catch{throw new Error((0,D.localize)(0,null))}})}e.getManifest=k}),define(Y[152],Z([0,1,3,22,34,10,4,2,36,16,14,12,17,39,5,11,30,20,69,91,58,18,144,23,24,42,48,126,145,151,127,128,27,45,13,8,9,26,32,28,25]),function($,e,T,D,k,L,N,P,d,c,m,y,p,I,w,S,E,l,g,v,f,s,i,n,t,r,o,u,a,h,O,j,x,K,X,ie,ne,Q,ge,ce,re){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,ie.refineServiceDecorator)(n.IExtensionManagementService);let me=class extends i.AbstractExtensionManagementService{constructor(b,R,C,F,B,W,te,se,pe,ye,ae,ue){super(b,R,C,ye,ue),this.Y=B,this.Z=W,this.ab=te,this.bb=pe,this.cb=ae,this.X=new Map,this.kb=new d.ResourceSet;const le=this.B(se.createInstance(a.ExtensionsLifecycle));this.S=this.B(se.createInstance(M,fe=>le.postUninstall(fe))),this.U=this.B(new O.ExtensionsManifestCache(F,this)),this.W=this.B(se.createInstance(u.ExtensionsDownloader,this.getTargetPlatform()));const oe=this.B(new j.ExtensionsWatcher(this,this.Y,ue,W,ae,pe,C));this.B(oe.onDidChangeExtensionsByAnotherSource(fe=>this.jb(fe))),this.lb()}getTargetPlatform(){return this.db||(this.db=(0,t.computeTargetPlatform)(this.bb,this.v)),this.db}async zip(b){this.v.trace("ExtensionManagementService#zip",b.identifier.id);const R=await this.ib(b),C=await(0,g.zip)((0,p.joinPath)(this.W.extensionsDownloadDir,(0,E.generateUuid)()).fsPath,R);return S.URI.file(C)}async unzip(b){return this.v.trace("ExtensionManagementService#unzip",b.toString()),(await this.install(b)).identifier}async getManifest(b){const{location:R,cleanup:C}=await this.eb(b),F=m.resolve(R.fsPath);try{return await(0,h.getManifest)(F)}finally{await C()}}getInstalled(b,R){return this.S.scanExtensions(b??null,R)}getAllUserInstalled(){return this.S.scanAllUserExtensions(!1)}async install(b,R={}){this.v.trace("ExtensionManagementService#install",b.toString());const{location:C,cleanup:F}=await this.eb(b);try{const B=await(0,h.getManifest)(m.resolve(C.fsPath));if(B.engines&&B.engines.vscode&&!(0,K.isEngineValid)(B.engines.vscode,this.w.version,this.w.date))throw new Error(v.localize(0,null,(0,t.getGalleryExtensionId)(B.publisher,B.name),this.w.version));return await this.z(B,C,R)}finally{await F()}}async installFromLocation(b,R){this.v.trace("ExtensionManagementService#installFromLocation",b.toString());const C=await this.S.scanUserExtensionAtLocation(b);if(!C)throw new Error(`Cannot find a valid extension from the location ${b.toString()}`);return await this.nb([C],R),this.v.info("Successfully installed extension",C.identifier.id,R.toString()),C}getMetadata(b){return this.Y.scanMetadata(b.location)}async updateMetadata(b,R){this.v.trace("ExtensionManagementService#updateMetadata",b.identifier.id);const C={...R};return R.isPreReleaseVersion&&(C.preRelease=!0),b=await this.S.updateMetadata(b,C),this.U.invalidate(),b}async updateExtensionScope(b,R){return this.v.trace("ExtensionManagementService#updateExtensionScope",b.identifier.id),b=await this.S.updateMetadata(b,{isMachineScoped:R}),this.U.invalidate(),b}async reinstallFromGallery(b){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",b.identifier.id),!this.t.isEnabled())throw new Error(v.localize(1,null));const R=await this.getTargetPlatform(),[C]=await this.t.getExtensions([{...b.identifier,preRelease:b.preRelease}],{targetPlatform:R,compatible:!0},D.CancellationToken.None);if(!C)throw new Error(v.localize(2,null));await this.S.setUninstalled(b);try{await this.S.removeUninstalledExtension(b)}catch(F){throw new Error(v.localize(3,null,(0,k.toErrorMessage)(F)))}await this.installFromGallery(C)}markAsUninstalled(...b){return this.S.setUninstalled(...b)}removeUninstalledExtensions(){return this.S.cleanUp()}async download(b,R){const{location:C}=await this.W.download(b,R);return C}async eb(b){if(b.scheme===c.Schemas.file)return{location:b,async cleanup(){}};this.v.trace("Downloading extension from",b.toString());const R=(0,p.joinPath)(this.W.extensionsDownloadDir,(0,E.generateUuid)());return await this.ab.download(b,R),this.v.info("Downloaded extension to",R.toString()),{location:R,cleanup:async()=>{try{await this.bb.del(R)}catch(F){this.v.error(F)}}}}P(){return this.y.defaultProfile.extensionsResource}Q(b,R,C){let F;if(S.URI.isUri(R))F=new V(b,R,C,this.t,this.S,this.v);else{const B=t.ExtensionKey.create(R).toString();F=this.X.get(B),F||(this.X.set(B,F=new U(b,R,C,this.W,this.S,this.v)),F.waitUntilTaskIsFinished().then(()=>this.X.delete(B)))}return new G(F,C.profileLocation,this.Z)}R(b,R){return new q(b,R.profileLocation,this.Z)}async ib(b){const R=async F=>{let B=await l.Promises.readdir(F);B=B.map(se=>m.join(F,se));const W=await Promise.all(B.map(se=>l.Promises.stat(se)));let te=Promise.resolve([]);return W.forEach((se,pe)=>{const ye=B[pe];se.isFile()&&(te=te.then(ae=>[...ae,ye])),se.isDirectory()&&(te=te.then(ae=>R(ye).then(ue=>[...ae,...ue])))}),te};return(await R(b.location.fsPath)).map(F=>({path:`extension/${m.relative(b.location.fsPath,F)}`,localPath:F}))}async jb({added:b,removed:R}){if(R)for(const C of R.extensions)this.v.info("Extensions removed from another source",C.id,R.profileLocation.toString()),this.p.fire({identifier:C,profileLocation:R.profileLocation});if(b){const F=(await this.S.scanExtensions(1,b.profileLocation)).filter(B=>b.extensions.some(W=>(0,t.areSameExtensions)(W,B.identifier)));this.m.fire(F.map(B=>(this.v.info("Extensions added from another source",B.identifier.id,b.profileLocation.toString()),{identifier:B.identifier,local:B,profileLocation:b.profileLocation,operation:1})))}}async lb(){this.B(this.S.onExtract(R=>this.kb.add(R)));const b=await this.bb.resolve(this.Y.userExtensionsLocation);for(const R of b.children??[])R.isDirectory&&this.kb.add(R.resource);this.B(this.bb.watch(this.Y.userExtensionsLocation)),this.B(this.bb.onDidFilesChange(R=>this.mb(R)))}async mb(b){const R=[];for(const C of b.rawAdded){if(this.kb.has(C)||!this.cb.extUri.isEqual(this.cb.extUri.dirname(C),this.Y.userExtensionsLocation)||this.cb.extUri.isEqual(C,this.cb.extUri.joinPath(this.Y.userExtensionsLocation,".obsolete"))||this.cb.extUri.basename(C).startsWith(".")||!(await this.bb.stat(C)).isDirectory)continue;const F=await this.S.scanUserExtensionAtLocation(C);F&&F.installedTimestamp===void 0&&(this.kb.add(C),R.push(F))}R.length&&(await this.nb(R,this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",R.map(C=>C.identifier.id)))}async nb(b,R){await this.Z.addExtensionsToProfile(b.map(C=>[C,void 0]),R),this.m.fire(b.map(C=>({local:C,identifier:C.identifier,operation:1,profileLocation:R})))}};me=de([_(0,n.IExtensionGalleryService),_(1,ge.ITelemetryService),_(2,ne.ILogService),_(3,s.INativeEnvironmentService),_(4,o.IExtensionsScannerService),_(5,r.IExtensionsProfileScannerService),_(6,f.IDownloadService),_(7,ie.IInstantiationService),_(8,X.IFileService),_(9,Q.IProductService),_(10,ce.IUriIdentityService),_(11,re.IUserDataProfilesService)],me),e.ExtensionManagementService=me;let M=class extends P.Disposable{constructor(b,R,C,F){super(),this.j=b,this.k=R,this.l=C,this.m=F,this.h=this.B(new N.Emitter),this.onExtract=this.h.event,this.c=(0,p.joinPath)(this.l.userExtensionsLocation,".obsolete").fsPath,this.g=new T.Queue}async cleanUp(){await this.v()}async scanExtensions(b,R){await this.l.initializeDefaultProfileExtensions();const C={includeInvalid:!0,profileLocation:R};let F=[];return b===null||b===0?F.push(...await this.l.scanAllExtensions({includeInvalid:!0},C,!1)):b===1&&F.push(...await this.l.scanUserExtensions(C)),F=b!==null?F.filter(B=>B.type===b):F,Promise.all(F.map(B=>this.u(B)))}async scanAllUserExtensions(b){const R=await this.l.scanUserExtensions({includeAllVersions:!b,includeInvalid:!0});return Promise.all(R.map(C=>this.u(C)))}async scanUserExtensionAtLocation(b){try{const R=await this.l.scanExistingExtension(b,1,{includeInvalid:!0});if(R)return await this.u(R)}catch(R){this.m.error(R)}return null}async extractUserExtension(b,R,C,F){await this.l.initializeDefaultProfileExtensions();const B=b.toString(),W=m.join(this.l.userExtensionsLocation.fsPath,`.${(0,E.generateUuid)()}`),te=m.join(this.l.userExtensionsLocation.fsPath,B);try{await l.Promises.rm(te)}catch{throw new n.ExtensionManagementError(v.localize(4,null,te,b.id),n.ExtensionManagementErrorCode.Delete)}await this.p(b,R,W,F),await this.l.updateMetadata(S.URI.file(W),C);try{this.h.fire(S.URI.file(te)),await this.s(b,W,te,Date.now()+2*60*1e3),this.m.info("Renamed to",te)}catch(se){try{await l.Promises.rm(W)}catch{}if(se.code==="ENOTEMPTY")this.m.info("Rename failed because extension was installed by another source. So ignoring renaming.",b.id);else throw this.m.info(`Rename failed because of ${(0,L.getErrorMessage)(se)}. Deleted from extracted location`,W),se}return this.t(S.URI.file(te),1)}async updateMetadata(b,R){return await this.l.updateMetadata(b.location,R),this.t(b.location,b.type)}getUninstalledExtensions(){return this.n()}async setUninstalled(...b){const R=b.map(C=>t.ExtensionKey.create(C));await this.n(C=>R.forEach(F=>{C[F.toString()]=!0,this.m.info("Marked extension as uninstalled",F.toString())}))}async setInstalled(b){await this.n(F=>delete F[b.toString()]);const C=(await this.scanAllUserExtensions(!0)).find(F=>t.ExtensionKey.create(F).equals(b))||null;return C?this.updateMetadata(C,{installedTimestamp:Date.now()}):null}async removeExtension(b,R){this.m.trace(`Deleting ${R} extension from disk`,b.identifier.id,b.location.fsPath),await l.Promises.rm(b.location.fsPath),this.m.info("Deleted from disk",b.identifier.id,b.location.fsPath)}async removeUninstalledExtension(b){await this.removeExtension(b,"uninstalled"),await this.n(R=>delete R[t.ExtensionKey.create(b).toString()])}async n(b){return this.g.queue(async()=>{let R;try{R=await l.Promises.readFile(this.c,"utf8")}catch(F){if(F.code!=="ENOENT")throw F}let C={};if(R)try{C=JSON.parse(R)}catch{}return b&&(b(C),Object.keys(C).length?await l.Promises.writeFile(this.c,JSON.stringify(C)):await l.Promises.rm(this.c)),C})}async p(b,R,C,F){this.m.trace(`Started extracting the extension from ${R} to ${C}`);try{await l.Promises.rm(C)}catch(B){throw new n.ExtensionManagementError(this.w(B).message,n.ExtensionManagementErrorCode.Delete)}try{await(0,g.extract)(R,C,{sourcePath:"extension",overwrite:!0},F),this.m.info(`Extracted extension to ${C}:`,b.id)}catch(B){try{await l.Promises.rm(C)}catch{}let W=n.ExtensionManagementErrorCode.Extract;throw B instanceof g.ExtractError&&(B.type==="CorruptZip"?W=n.ExtensionManagementErrorCode.CorruptZip:B.type==="Incomplete"&&(W=n.ExtensionManagementErrorCode.IncompleteZip)),new n.ExtensionManagementError(B.message,W)}}async s(b,R,C,F){try{await l.Promises.rename(R,C)}catch(B){if(y.isWindows&&B&&B.code==="EPERM"&&Date.now()<F)return this.m.info(`Failed renaming ${R} to ${C} with 'EPERM' error. Trying again...`,b.id),this.s(b,R,C,F);throw new n.ExtensionManagementError(B.message||v.localize(5,null,R,C),B.code||n.ExtensionManagementErrorCode.Rename)}}async t(b,R){const C=await this.l.scanExistingExtension(b,R,{includeInvalid:!0});if(C)return this.u(C);throw new Error(v.localize(6,null,b.path))}async u(b){const R=await this.k.resolve(b.location);let C,F;return R.children&&(C=R.children.find(({name:B})=>/^readme(\.txt|\.md|)$/i.test(B))?.resource,F=R.children.find(({name:B})=>/^changelog(\.txt|\.md|)$/i.test(B))?.resource),{identifier:b.identifier,type:b.type,isBuiltin:b.isBuiltin||!!b.metadata?.isBuiltin,location:b.location,manifest:b.manifest,targetPlatform:b.targetPlatform,validations:b.validations,isValid:b.isValid,readmeUrl:C,changelogUrl:F,publisherDisplayName:b.metadata?.publisherDisplayName||null,publisherId:b.metadata?.publisherId||null,isApplicationScoped:!!b.metadata?.isApplicationScoped,isMachineScoped:!!b.metadata?.isMachineScoped,isPreReleaseVersion:!!b.metadata?.isPreReleaseVersion,preRelease:!!b.metadata?.preRelease,installedTimestamp:b.metadata?.installedTimestamp,updated:!!b.metadata?.updated}}async v(){const b=await this.getUninstalledExtensions(),R=await this.l.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),C=new Set;for(const W of R)b[t.ExtensionKey.create(W).toString()]||C.add(W.identifier.id.toLowerCase());const F=(0,t.groupByExtension)(R,W=>W.identifier);await T.Promises.settled(F.map(async W=>{const te=W.sort((se,pe)=>I.rcompare(se.manifest.version,pe.manifest.version))[0];C.has(te.identifier.id.toLowerCase())||await this.j(await this.u(te))}));const B=R.filter(W=>W.metadata&&b[t.ExtensionKey.create(W).toString()]);await T.Promises.settled(B.map(W=>this.removeUninstalledExtension(W)))}w(b){const R=Array.isArray(b)?b:[b];return R.length===1?R[0]instanceof Error?R[0]:new Error(R[0]):R.reduce((C,F)=>new Error(`${C.message}${C.message?",":""}${F instanceof Error?F.message:F}`),new Error(""))}};M=de([_(1,X.IFileService),_(2,o.IExtensionsScannerService),_(3,ne.ILogService)],M),e.ExtensionsScanner=M;class A extends i.AbstractExtensionTask{get operation(){return(0,w.isUndefined)(this.k.operation)?this.j:this.k.operation}constructor(b,R,C,F,B){super(),this.identifier=b,this.source=R,this.k=C,this.l=F,this.m=B,this.wasVerified=!1,this.j=2}async n(b,R){try{const C=await this.o(b.key);if(C)return this.l.updateMetadata(C,b.metadata)}catch{throw y.isMacintosh?new n.ExtensionManagementError(v.localize(7,null),n.ExtensionManagementErrorCode.Internal):new n.ExtensionManagementError(v.localize(8,null),n.ExtensionManagementErrorCode.Internal)}return this.q(b,R)}async o(b){if(!await this.p(b))return null;this.m.trace("Removing the extension from uninstalled list:",b.id);const C=await this.l.setInstalled(b);return this.m.info("Removed the extension from uninstalled list:",b.id),C}async p(b){return!!(await this.l.getUninstalledExtensions())[b.toString()]}async q({zipPath:b,key:R,metadata:C},F){const B=await this.l.extractUserExtension(R,b,C,F);return this.m.info("Extracting completed.",R.id),B}}class U extends A{constructor(b,R,C,F,B,W){super(R.identifier,R,C,B,W),this.s=b,this.t=R,this.u=F}async h(b){const C=(await this.l.scanExtensions(null,void 0)).find(te=>(0,t.areSameExtensions)(te.identifier,this.t.identifier));C&&(this.j=3);const F={id:this.t.identifier.uuid,publisherId:this.t.publisherId,publisherDisplayName:this.t.publisherDisplayName,targetPlatform:this.t.properties.targetPlatform,isApplicationScoped:(0,x.isApplicationScopedExtension)(this.s),isMachineScoped:this.k.isMachineScoped||C?.isMachineScoped,isBuiltin:this.k.isBuiltin||C?.isBuiltin,isSystem:C?.type===0?!0:void 0,updated:!!C,isPreReleaseVersion:this.t.properties.isPreReleaseVersion,installedTimestamp:Date.now(),preRelease:this.t.properties.isPreReleaseVersion||((0,w.isBoolean)(this.k.installPreReleaseVersion)?this.k.installPreReleaseVersion:C?.preRelease)};if(C?.manifest.version===this.t.version)return{local:await this.l.updateMetadata(C,F),metadata:F};const{location:B,verified:W}=await this.u.download(this.t,this.j);try{return this.wasVerified=!!W,this.w(B.fsPath),{local:await this.n({zipPath:B.fsPath,key:t.ExtensionKey.create(this.t),metadata:F},b),metadata:F}}catch(te){try{await this.u.delete(B)}catch(se){this.m.warn("Error while deleting the downloaded file",B.toString(),(0,L.getErrorMessage)(se))}throw te}}async w(b){try{await(0,h.getManifest)(b)}catch(R){throw new n.ExtensionManagementError((0,i.joinErrors)(R).message,n.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=U;class V extends A{constructor(b,R,C,F,B,W){super({id:(0,t.getGalleryExtensionId)(b.publisher,b.name)},R,C,B,W),this.s=b,this.t=R,this.u=F}async h(b){const R=new t.ExtensionKey(this.identifier,this.s.version),F=(await this.l.scanExtensions(1,void 0)).find(te=>(0,t.areSameExtensions)(this.identifier,te.identifier)),B=await this.w(this.identifier.id,this.s.version,b);if(B.isApplicationScoped=(0,x.isApplicationScopedExtension)(this.s),B.isMachineScoped=this.k.isMachineScoped||F?.isMachineScoped,B.isBuiltin=this.k.isBuiltin||F?.isBuiltin,B.installedTimestamp=Date.now(),F)if(this.j=3,R.equals(new t.ExtensionKey(F.identifier,F.manifest.version)))try{await this.l.removeExtension(F,"existing")}catch{throw new Error(v.localize(9,null,this.s.displayName||this.s.name))}else!this.k.profileLocation&&I.gt(F.manifest.version,this.s.version)&&await this.l.setUninstalled(F);else{const te=await this.o(R);if(te)try{await this.l.removeExtension(te,"existing")}catch{throw new Error(v.localize(10,null,this.s.displayName||this.s.name))}}return{local:await this.n({zipPath:m.resolve(this.t.fsPath),key:R,metadata:B},b),metadata:B}}async w(b,R,C){try{let[F]=await this.u.getExtensions([{id:b,version:R}],C);if(F||([F]=await this.u.getExtensions([{id:b}],C)),F)return{id:F.identifier.uuid,publisherDisplayName:F.publisherDisplayName,publisherId:F.publisherId,isPreReleaseVersion:F.properties.isPreReleaseVersion,preRelease:F.properties.isPreReleaseVersion||this.k.installPreReleaseVersion}}catch{}return{}}}class G{constructor(b,R,C){this.d=b,this.g=R,this.h=C,this.identifier=this.d.identifier,this.source=this.d.source,this.operation=this.d.operation,this.c=this.j()}async j(){const b=await this.d.waitUntilTaskIsFinished();return await this.h.addExtensionsToProfile([[b.local,b.metadata]],this.g),b}async run(){return await this.d.run(),this.c}waitUntilTaskIsFinished(){return this.c}cancel(){return this.d.cancel()}}class q extends i.AbstractExtensionTask{constructor(b,R,C){super(),this.extension=b,this.j=R,this.k=C}async h(b){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(Y[153],Z([0,1,132,3,15,10,2,5,21,18,133,9,131,166]),function($,e,T,D,k,L,N,P,d,c,m,y,p,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let w=class extends N.Disposable{constructor(E,l,g){super(),this.h=l,this.i=g,this.j(E.getValue()),this.B(E.onDidChangeConfiguration(()=>this.j(E.getValue()),this))}j(E){this.a=E.http&&E.http.proxy,this.b=!!(E.http&&E.http.proxyStrictSSL),this.f=E.http&&E.http.proxyAuthorization}async request(E,l){this.i.trace("RequestService#request (node) - begin",E.url);const{a:g,b:v}=this;let f;try{f=await(0,m.getResolvedShellEnv)(this.i,this.h.args,process.env)}catch(n){this.g||(this.g=!0,this.i.error("RequestService#request (node) resolving shell environment failed",n))}const s={...process.env,...f},i=E.agent?E.agent:await(0,p.getProxyAgent)(E.url||"",s,{proxyUrl:g,strictSSL:v});E.agent=i,E.strictSSL=v,this.f&&(E.headers={...E.headers||{},"Proxy-Authorization":this.f});try{const n=await this.l(E,l);return this.i.trace("RequestService#request (node) - success",E.url),n}catch(n){throw this.i.trace("RequestService#request (node) - error",E.url,n),n}}async k(E){return((0,T.parse)(E.url).protocol==="https:"?await new Promise((v,f)=>{$(["https"],v,f)}):await new Promise((v,f)=>{$(["http"],v,f)})).request}l(E,l){return D.Promises.withAsyncBody(async(g,v)=>{const f=(0,T.parse)(E.url),s=E.getRawRequest?E.getRawRequest(E):await this.k(E),i={hostname:f.hostname,port:f.port?parseInt(f.port):f.protocol==="https:"?443:80,protocol:f.protocol,path:f.path,method:E.type||"GET",headers:E.headers,agent:E.agent,rejectUnauthorized:(0,P.isBoolean)(E.strictSSL)?E.strictSSL:!0};E.user&&E.password&&(i.auth=E.user+":"+E.password);const n=s(i,t=>{const r=(0,P.isNumber)(E.followRedirects)?E.followRedirects:3;if(t.statusCode&&t.statusCode>=300&&t.statusCode<400&&r>0&&t.headers.location)this.l({...E,url:t.headers.location,followRedirects:r-1},l).then(g,v);else{let o=t;!E.isChromiumNetwork&&t.headers["content-encoding"]==="gzip"&&(o=t.pipe((0,I.createGunzip)())),g({res:t,stream:(0,k.streamToBufferReadableStream)(o)})}});n.on("error",v),E.timeout&&n.setTimeout(E.timeout),E.isChromiumNetwork&&n.removeHeader("Content-Length"),E.data&&typeof E.data=="string"&&n.write(E.data),n.end(),l.onCancellationRequested(()=>{n.abort(),v(new L.CancellationError)})})}async resolveProxy(E){}};w=de([_(0,d.IConfigurationService),_(1,c.INativeEnvironmentService),_(2,y.ILogService)],w),e.RequestService=w}),define(Y[167],Z([0,1,33,3,15,34,10,2,16,14,12,35,11,20,21,124,58,130,18,105,148,23,59,125,42,48,152,146,13,116,118,46,114,62,63,129,9,120,121,38,150,138,26,47,153,67,134,68,32,137,41,139,140,28,142,25,149,141]),function($,e,T,D,k,L,N,P,d,c,m,y,p,I,w,S,E,l,g,v,f,s,i,n,t,r,o,u,a,h,O,j,x,K,X,ie,ne,Q,ge,ce,re,me,M,A,U,V,G,q,ee,b,R,C,F,B,W,te,se,pe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class ye extends P.Disposable{constructor(le){super(),this.b=le,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[le,oe]=await this.f();return le.invokeFunction(async fe=>{const Te=fe.get(ne.ILogService),Fe=fe.get(a.IFileService),De=fe.get(g.INativeEnvironmentService),Me=fe.get(te.IUserDataProfilesService);Te.info("CLI main",this.b),this.g(Te),await this.h(De,Fe,Me,le),await Promise.all(oe.map(z=>{(0,D.raceTimeout)(z.flush(),1e3)}))})}async f(){const le=new K.ServiceCollection,oe={_serviceBrand:void 0,...me.default};le.set(M.IProductService,oe);const fe=new v.NativeEnvironmentService(this.b,oe);le.set(g.INativeEnvironmentService,fe),await Promise.all([fe.appSettingsHome.fsPath,fe.extensionsPath].map(Pe=>Pe?I.Promises.mkdir(Pe,{recursive:!0}):void 0));const Te=(0,ne.getLogLevel)(fe),Fe=[];Fe.push(new Q.SpdLogLogger("cli",(0,c.join)(fe.logsPath,"cli.log"),!0,!1,Te)),Te===ne.LogLevel.Trace&&Fe.push(new ne.ConsoleLogger(Te));const De=this.B(new ne.MultiplexLogService(Fe));le.set(ne.ILogService,De);const Me=this.B(new h.FileService(De));le.set(a.IFileService,Me);const z=this.B(new O.DiskFileSystemProvider(De));Me.registerProvider(d.Schemas.file,z);const H=new G.StateService(fe,De,Me);le.set(V.IStateService,H);const J=new W.UriIdentityService(Me);le.set(B.IUriIdentityService,J);const he=new se.UserDataProfilesService(H,J,fe,Me,De);le.set(te.IUserDataProfilesService,he);const ve=m.isWindows&&oe.win32RegValueName?this.B(new re.NativePolicyService(De,oe.win32RegValueName)):fe.policyFile?this.B(new ge.FilePolicyService(fe.policyFile,Me,De)):new ce.NullPolicyService;le.set(ce.IPolicyService,ve);const Re=this.B(new S.ConfigurationService(he.defaultProfile.settingsResource,Me,ve,De));le.set(w.IConfigurationService,Re),await Promise.all([H.init(),Re.initialize()]),he.setEnablement(oe.quality!=="stable"||Re.getValue(te.PROFILES_ENABLEMENT_CONFIG)),le.set(B.IUriIdentityService,new W.UriIdentityService(Me)),le.set(A.IRequestService,new j.SyncDescriptor(U.RequestService,void 0,!0)),le.set(E.IDownloadService,new j.SyncDescriptor(l.DownloadService,void 0,!0)),le.set(t.IExtensionsProfileScannerService,new j.SyncDescriptor(t.ExtensionsProfileScannerService,void 0,!0)),le.set(r.IExtensionsScannerService,new j.SyncDescriptor(u.ExtensionsScannerService,void 0,!0)),le.set(i.IExtensionSignatureVerificationService,new j.SyncDescriptor(i.ExtensionSignatureVerificationService,void 0,!0)),le.set(o.INativeServerExtensionManagementService,new j.SyncDescriptor(o.ExtensionManagementService,void 0,!0)),le.set(s.IExtensionGalleryService,new j.SyncDescriptor(f.ExtensionGalleryServiceWithNoStorageService,void 0,!0)),le.set(X.ILanguagePackService,new j.SyncDescriptor(ie.NativeLanguagePackService,void 0,!1));const Se=[],Le=(0,R.isInternalTelemetry)(oe,Re);if((0,R.supportsTelemetry)(oe,fe)){oe.aiConfig&&oe.aiConfig.ariaKey&&Se.push(new C.OneDataSystemAppender(Le,"monacoworkbench",null,oe.aiConfig.ariaKey));const{installSourcePath:Pe}=fe,Oe={appenders:Se,sendErrorTelemetry:!1,commonProperties:(async()=>{let je;try{je=await(0,pe.resolveMachineId)(H)}catch(Ie){Ie.code!=="ENOENT"&&De.error(Ie)}return(0,q.resolveCommonProperties)(Me,(0,T.release)(),(0,T.hostname)(),process.arch,oe.commit,oe.version,je,Le,Pe)})(),piiPaths:(0,R.getPiiPathsFromEnvironment)(fe)};le.set(ee.ITelemetryService,new j.SyncDescriptor(b.TelemetryService,[Oe],!1))}else le.set(ee.ITelemetryService,R.NullTelemetryService);return[new x.InstantiationService(le),Se]}g(le){(0,N.setUnexpectedErrorHandler)(oe=>{const fe=(0,L.toErrorMessage)(oe,!0);!fe||le.error(`[uncaught exception in CLI]: ${fe}`)}),process.on("uncaughtException",oe=>(0,N.onUnexpectedError)(oe)),process.on("unhandledRejection",oe=>(0,N.onUnexpectedError)(oe))}async h(le,oe,fe,Te){const Fe=(le.args.profile?fe.profiles.find(De=>De.name===le.args.profile)??fe.defaultProfile:fe.defaultProfile).extensionsResource;if(this.b["install-source"])return this.j(le,oe,this.b["install-source"]);if(this.b["list-extensions"])return Te.createInstance(n.ExtensionManagementCLI).listExtensions(!!this.b["show-versions"],this.b.category,Fe);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const De={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:Fe};return Te.createInstance(n.ExtensionManagementCLI).installExtensions(this.i(this.b["install-extension"]||[]),this.b["install-builtin-extension"]||[],De,!!this.b.force)}else{if(this.b["uninstall-extension"])return Te.createInstance(n.ExtensionManagementCLI).uninstallExtensions(this.i(this.b["uninstall-extension"]),!!this.b.force,Fe);if(this.b["locate-extension"])return Te.createInstance(n.ExtensionManagementCLI).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,F.buildTelemetryMessage)(le.appRoot,le.extensionsPath))}}i(le){return le.map(oe=>/\.vsix$/i.test(oe)?p.URI.file((0,c.isAbsolute)(oe)?oe:(0,c.join)((0,y.cwd)(),oe)):oe)}async j(le,oe,fe){await oe.writeFile(p.URI.file(le.installSourcePath),k.VSBuffer.fromString(fe.slice(0,30)))}}async function ae(ue){const le=new ye(ue);try{await le.run()}finally{le.dispose()}}e.main=ae})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8b9891739b703b50547f506a7e2bc9565e52beff/core/vs/code/node/cliProcessMain.js.map
